window.Physics = function (t) {
    "use strict";
    void 0 === Number.EPSILON && (Number.EPSILON = Math.pow(2, -52)),
    void 0 === Math.sign && (Math.sign = function (t) {
        return t < 0 ? -1 : t > 0 ? 1 : +t
    }),
    void 0 === Function.prototype.name && Object.defineProperty(Function.prototype, "name", {
        get: function () {
            return this.toString().match(/^\s*function\s*([^\(\s]*)/)[1]
        }
    }),
    void 0 === Object.assign && (Object.assign = function (t) {
        if (null == t)
            throw new TypeError("Cannot convert undefined or null to object");
        for (var e = Object(t), n = 1; n < arguments.length; n++) {
            var a = arguments[n];
            if (null != a)
                for (var u in a)
                    Object.prototype.hasOwnProperty.call(a, u) && (e[u] = a[u])
        }
        return e
    });
    var e,
    n,
    a,
    u,
    g = {
        sqrt: Math.sqrt,
        abs: Math.abs,
        floor: Math.floor,
        cos: Math.cos,
        sin: Math.sin,
        acos: Math.acos,
        asin: Math.asin,
        atan2: Math.atan2,
        round: Math.round,
        pow: Math.pow,
        max: Math.max,
        min: Math.min,
        random: Math.random,
        degtorad: .017453292519943295,
        radtodeg: 57.29577951308232,
        PI: 3.141592653589793,
        TwoPI: 6.283185307179586,
        PI90: 1.570796326794896,
        PI270: 4.712388980384689,
        INF: 1 / 0,
        EPZ: 1e-6,
        EPZ2: 1e-6,
        isZero: function (t) {
            return Math.abs(t) < g.EPZ
        },
        lerp: function (t, e, n) {
            return (1 - n) * t + n * e
        },
        randInt: function (t, e) {
            return t + g.floor(g.random() * (e - t + 1))
        },
        rand: function (t, e) {
            return t + g.random() * (e - t)
        },
        generateUUID: (n = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(""), a = new Array(36), u = 0, function () {
            for (var t = 0; t < 36; t++)
                8 === t || 13 === t || 18 === t || 23 === t ? a[t] = "-" : 14 === t ? a[t] = "4" : (u <= 2 && (u = 33554432 + 16777216 * Math.random() | 0), e = 15 & u, u >>= 4, a[t] = n[19 === t ? 3 & e | 8 : e]);
            return a.join("")
        }),
        int: function (t) {
            return g.floor(t)
        },
        fix: function (t, e) {
            return t.toFixed(e || 3, 10)
        },
        clamp: function (t, e, n) {
            return g.max(e, g.min(n, t))
        },
        distance: function (t, e) {
            var n = e[0] - t[0],
            a = e[1] - t[1],
            u = e[2] - t[2];
            return g.sqrt(n * n + a * a + u * u)
        },
        acosClamp: function (t) {
            return t > 1 ? 0 : t < -1 ? g.PI : g.acos(t)
        },
        distanceVector: function (t, e) {
            var n = t.x - e.x,
            a = t.y - e.y,
            u = t.z - e.z;
            return n * n + a * a + u * u
        },
        dotVectors: function (t, e) {
            return t.x * e.x + t.y * e.y + t.z * e.z
        }
    };
    function printError(t, e) {
        console.error("[OIMO] " + t + ": " + e)
    }
    function InfoDisplay(t) {
        this.parent = t,
        this.infos = new Float32Array(13),
        this.f = [0, 0, 0],
        this.times = [0, 0, 0, 0],
        this.broadPhase = this.parent.broadPhaseType,
        this.version = "1.0.9",
        this.fps = 0,
        this.tt = 0,
        this.broadPhaseTime = 0,
        this.narrowPhaseTime = 0,
        this.solvingTime = 0,
        this.totalTime = 0,
        this.updateTime = 0,
        this.MaxBroadPhaseTime = 0,
        this.MaxNarrowPhaseTime = 0,
        this.MaxSolvingTime = 0,
        this.MaxTotalTime = 0,
        this.MaxUpdateTime = 0
    }
    function Vec3(t, e, n) {
        this.x = t || 0,
        this.y = e || 0,
        this.z = n || 0
    }
    function Quat(t, e, n, a) {
        this.x = t || 0,
        this.y = e || 0,
        this.z = n || 0,
        this.w = void 0 !== a ? a : 1
    }
    function Mat33(t, e, n, a, u, g, p, f, m) {
        this.elements = [1, 0, 0, 0, 1, 0, 0, 0, 1],
        arguments.length > 0 && console.error("OIMO.Mat33: the constructor no longer reads arguments. use .set() instead.")
    }
    function AABB(t, e, n, a, u, g) {
        this.elements = new Float32Array(6);
        var p = this.elements;
        p[0] = t || 0,
        p[1] = n || 0,
        p[2] = u || 0,
        p[3] = e || 0,
        p[4] = a || 0,
        p[5] = g || 0
    }
    Object.assign(InfoDisplay.prototype, {
        setTime: function (t) {
            this.times[t || 0] = performance.now()
        },
        resetMax: function () {
            this.MaxBroadPhaseTime = 0,
            this.MaxNarrowPhaseTime = 0,
            this.MaxSolvingTime = 0,
            this.MaxTotalTime = 0,
            this.MaxUpdateTime = 0
        },
        calcBroadPhase: function () {
            this.setTime(2),
            this.broadPhaseTime = this.times[2] - this.times[1]
        },
        calcNarrowPhase: function () {
            this.setTime(3),
            this.narrowPhaseTime = this.times[3] - this.times[2]
        },
        calcEnd: function () {
            this.setTime(2),
            this.solvingTime = this.times[2] - this.times[1],
            this.totalTime = this.times[2] - this.times[0],
            this.updateTime = this.totalTime - (this.broadPhaseTime + this.narrowPhaseTime + this.solvingTime),
            100 === this.tt && this.resetMax(),
            this.tt > 100 && (this.broadPhaseTime > this.MaxBroadPhaseTime && (this.MaxBroadPhaseTime = this.broadPhaseTime), this.narrowPhaseTime > this.MaxNarrowPhaseTime && (this.MaxNarrowPhaseTime = this.narrowPhaseTime), this.solvingTime > this.MaxSolvingTime && (this.MaxSolvingTime = this.solvingTime), this.totalTime > this.MaxTotalTime && (this.MaxTotalTime = this.totalTime), this.updateTime > this.MaxUpdateTime && (this.MaxUpdateTime = this.updateTime)),
            this.upfps(),
            this.tt++,
            this.tt > 500 && (this.tt = 0)
        },
        upfps: function () {
            this.f[1] = Date.now(),
            this.f[1] - 1e3 > this.f[0] && (this.f[0] = this.f[1], this.fps = this.f[2], this.f[2] = 0),
            this.f[2]++
        },
        show: function () {
            return ["Oimo.js " + this.version + "<br>", this.broadPhase + "<br><br>", "FPS: " + this.fps + " fps<br><br>", "rigidbody " + this.parent.numRigidBodies + "<br>", "contact &nbsp;&nbsp;" + this.parent.numContacts + "<br>", "ct-point &nbsp;" + this.parent.numContactPoints + "<br>", "paircheck " + this.parent.broadPhase.numPairChecks + "<br>", "island &nbsp;&nbsp;&nbsp;" + this.parent.numIslands + "<br><br>", "Time in milliseconds<br><br>", "broadphase &nbsp;" + g.fix(this.broadPhaseTime) + " | " + g.fix(this.MaxBroadPhaseTime) + "<br>", "narrowphase " + g.fix(this.narrowPhaseTime) + " | " + g.fix(this.MaxNarrowPhaseTime) + "<br>", "solving &nbsp;&nbsp;&nbsp;&nbsp;" + g.fix(this.solvingTime) + " | " + g.fix(this.MaxSolvingTime) + "<br>", "total &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + g.fix(this.totalTime) + " | " + g.fix(this.MaxTotalTime) + "<br>", "updating &nbsp;&nbsp;&nbsp;" + g.fix(this.updateTime) + " | " + g.fix(this.MaxUpdateTime) + "<br>"].join("\n")
        },
        toArray: function () {
            return this.infos[0] = this.parent.broadPhase.types,
            this.infos[1] = this.parent.numRigidBodies,
            this.infos[2] = this.parent.numContacts,
            this.infos[3] = this.parent.broadPhase.numPairChecks,
            this.infos[4] = this.parent.numContactPoints,
            this.infos[5] = this.parent.numIslands,
            this.infos[6] = this.broadPhaseTime,
            this.infos[7] = this.narrowPhaseTime,
            this.infos[8] = this.solvingTime,
            this.infos[9] = this.updateTime,
            this.infos[10] = this.totalTime,
            this.infos[11] = this.fps,
            this.infos
        }
    }),
    Object.assign(Vec3.prototype, {
        Vec3: !0,
        set: function (t, e, n) {
            return this.x = t,
            this.y = e,
            this.z = n,
            this
        },
        add: function (t, e) {
            return void 0 !== e ? this.addVectors(t, e) : (this.x += t.x, this.y += t.y, this.z += t.z, this)
        },
        addVectors: function (t, e) {
            return this.x = t.x + e.x,
            this.y = t.y + e.y,
            this.z = t.z + e.z,
            this
        },
        addEqual: function (t) {
            return this.x += t.x,
            this.y += t.y,
            this.z += t.z,
            this
        },
        sub: function (t, e) {
            return void 0 !== e ? this.subVectors(t, e) : (this.x -= t.x, this.y -= t.y, this.z -= t.z, this)
        },
        subVectors: function (t, e) {
            return this.x = t.x - e.x,
            this.y = t.y - e.y,
            this.z = t.z - e.z,
            this
        },
        subEqual: function (t) {
            return this.x -= t.x,
            this.y -= t.y,
            this.z -= t.z,
            this
        },
        scale: function (t, e) {
            return this.x = t.x * e,
            this.y = t.y * e,
            this.z = t.z * e,
            this
        },
        scaleEqual: function (t) {
            return this.x *= t,
            this.y *= t,
            this.z *= t,
            this
        },
        multiply: function (t) {
            return this.x *= t.x,
            this.y *= t.y,
            this.z *= t.z,
            this
        },
        addScaledVector: function (t, e) {
            return this.x += t.x * e,
            this.y += t.y * e,
            this.z += t.z * e,
            this
        },
        subScaledVector: function (t, e) {
            return this.x -= t.x * e,
            this.y -= t.y * e,
            this.z -= t.z * e,
            this
        },
        cross: function (t, e) {
            if (void 0 !== e)
                return this.crossVectors(t, e);
            var n = this.x,
            a = this.y,
            u = this.z;
            return this.x = a * t.z - u * t.y,
            this.y = u * t.x - n * t.z,
            this.z = n * t.y - a * t.x,
            this
        },
        crossVectors: function (t, e) {
            var n = t.x,
            a = t.y,
            u = t.z,
            g = e.x,
            p = e.y,
            f = e.z;
            return this.x = a * f - u * p,
            this.y = u * g - n * f,
            this.z = n * p - a * g,
            this
        },
        tangent: function (t) {
            var e = t.x,
            n = t.y,
            a = t.z;
            return this.x = n * e - a * a,
            this.y = -a * n - e * e,
            this.z = e * a + n * n,
            this
        },
        invert: function (t) {
            return this.x = -t.x,
            this.y = -t.y,
            this.z = -t.z,
            this
        },
        negate: function () {
            return this.x = -this.x,
            this.y = -this.y,
            this.z = -this.z,
            this
        },
        dot: function (t) {
            return this.x * t.x + this.y * t.y + this.z * t.z
        },
        addition: function () {
            return this.x + this.y + this.z
        },
        lengthSq: function () {
            return this.x * this.x + this.y * this.y + this.z * this.z
        },
        length: function () {
            return g.sqrt(this.x * this.x + this.y * this.y + this.z * this.z)
        },
        copy: function (t) {
            return this.x = t.x,
            this.y = t.y,
            this.z = t.z,
            this
        },
        applyMatrix3: function (t, e) {
            var n = this.x,
            a = this.y,
            u = this.z,
            g = t.elements;
            return e ? (this.x = g[0] * n + g[1] * a + g[2] * u, this.y = g[3] * n + g[4] * a + g[5] * u, this.z = g[6] * n + g[7] * a + g[8] * u) : (this.x = g[0] * n + g[3] * a + g[6] * u, this.y = g[1] * n + g[4] * a + g[7] * u, this.z = g[2] * n + g[5] * a + g[8] * u),
            this
        },
        applyQuaternion: function (t) {
            var e = this.x,
            n = this.y,
            a = this.z,
            u = t.x,
            g = t.y,
            p = t.z,
            f = t.w,
            m = f * e + g * a - p * n,
            y = f * n + p * e - u * a,
            S = f * a + u * n - g * e,
            _ = -u * e - g * n - p * a;
            return this.x = m * f + _ * -u + y * -p - S * -g,
            this.y = y * f + _ * -g + S * -u - m * -p,
            this.z = S * f + _ * -p + m * -g - y * -u,
            this
        },
        testZero: function () {
            return 0 !== this.x || 0 !== this.y || 0 !== this.z
        },
        testDiff: function (t) {
            return !this.equals(t)
        },
        equals: function (t) {
            return t.x === this.x && t.y === this.y && t.z === this.z
        },
        clone: function () {
            return new this.constructor(this.x, this.y, this.z)
        },
        toString: function () {
            return "Vec3[" + this.x.toFixed(4) + ", " + this.y.toFixed(4) + ", " + this.z.toFixed(4) + "]"
        },
        multiplyScalar: function (t) {
            return Number.isFinite(t) ? (this.x *= t, this.y *= t, this.z *= t) : (this.x = 0, this.y = 0, this.z = 0),
            this
        },
        divideScalar: function (t) {
            return this.multiplyScalar(1 / t)
        },
        normalize: function (t) {
            return isNaN(t) ? this.divideScalar(this.length()) : this.multiplyScalar(t / this.length())
        },
        toArray: function (t, e) {
            void 0 === e && (e = 0),
            t[e] = this.x,
            t[e + 1] = this.y,
            t[e + 2] = this.z
        },
        fromArray: function (t, e) {
            return void 0 === e && (e = 0),
            this.x = t[e],
            this.y = t[e + 1],
            this.z = t[e + 2],
            this
        },
        lerp: function (t, e) {
            var n = this.x,
            a = this.y,
            u = this.z;
            return this.x = n + e * (t.x - n),
            this.y = a + e * (t.y - a),
            this.z = u + e * (t.z - u),
            this
        },
        distanceTo: function (t) {
            var e = this.x,
            n = this.y,
            a = this.z,
            u = t.x,
            g = t.y,
            p = t.z;
            return Math.sqrt((u - e) * (u - e) + (g - n) * (g - n) + (p - a) * (p - a))
        }
    }),
    Object.assign(Quat.prototype, {
        Quat: !0,
        set: function (t, e, n, a) {
            return this.x = t,
            this.y = e,
            this.z = n,
            this.w = a,
            this
        },
        addTime: function (t, e) {
            var n = t.x,
            a = t.y,
            u = t.z,
            g = this.w,
            p = this.x,
            f = this.y,
            m = this.z;
            return e *= .5,
            this.x += e * (n * g + a * m - u * f),
            this.y += e * (a * g + u * p - n * m),
            this.z += e * (u * g + n * f - a * p),
            this.w += e * (-n * p - a * f - u * m),
            this.normalize(),
            this
        },
        multiply: function (t, e) {
            return void 0 !== e ? this.multiplyQuaternions(t, e) : this.multiplyQuaternions(this, t)
        },
        multiplyQuaternions: function (t, e) {
            var n = t.x,
            a = t.y,
            u = t.z,
            g = t.w,
            p = e.x,
            f = e.y,
            m = e.z,
            y = e.w;
            return this.x = n * y + g * p + a * m - u * f,
            this.y = a * y + g * f + u * p - n * m,
            this.z = u * y + g * m + n * f - a * p,
            this.w = g * y - n * p - a * f - u * m,
            this
        },
        setFromUnitVectors: function (t, e) {
            var n = new Vec3,
            a = t.dot(e) + 1;
            return a < g.EPS2 ? (a = 0, g.abs(t.x) > g.abs(t.z) ? n.set(-t.y, t.x, 0) : n.set(0, -t.z, t.y)) : n.crossVectors(t, e),
            this._x = n.x,
            this._y = n.y,
            this._z = n.z,
            this._w = a,
            this.normalize()
        },
        arc: function (t, e) {
            var n = t.x,
            a = t.y,
            u = t.z,
            p = e.x,
            f = e.y,
            m = e.z,
            y = n * p + a * f + u * m;
            if (-1 == y)
                return p = a * n - u * u, f = -u * a - n * n, m = n * u + a * a, y = 1 / g.sqrt(p * p + f * f + m * m), this.w = 0, this.x = p * y, this.y = f * y, this.z = m * y, this;
            var S = a * m - u * f,
            _ = u * p - n * m,
            A = n * f - a * p;
            return this.w = g.sqrt(.5 * (1 + y)),
            y = .5 / this.w,
            this.x = S * y,
            this.y = _ * y,
            this.z = A * y,
            this
        },
        normalize: function () {
            var t = this.length();
            return 0 === t ? this.set(0, 0, 0, 1) : (t = 1 / t, this.x = this.x * t, this.y = this.y * t, this.z = this.z * t, this.w = this.w * t),
            this
        },
        inverse: function () {
            return this.conjugate().normalize()
        },
        invert: function (t) {
            return this.x = t.x,
            this.y = t.y,
            this.z = t.z,
            this.w = t.w,
            this.conjugate().normalize(),
            this
        },
        conjugate: function () {
            return this.x *= -1,
            this.y *= -1,
            this.z *= -1,
            this
        },
        length: function () {
            return g.sqrt(this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w)
        },
        lengthSq: function () {
            return this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w
        },
        copy: function (t) {
            return this.x = t.x,
            this.y = t.y,
            this.z = t.z,
            this.w = t.w,
            this
        },
        clone: function (t) {
            return new Quat(this.x, this.y, this.z, this.w)
        },
        testDiff: function (t) {
            return !this.equals(t)
        },
        equals: function (t) {
            return this.x === t.x && this.y === t.y && this.z === t.z && this.w === t.w
        },
        toString: function () {
            return "Quat[" + this.x.toFixed(4) + ", (" + this.y.toFixed(4) + ", " + this.z.toFixed(4) + ", " + this.w.toFixed(4) + ")]"
        },
        setFromAxis: function (t, e) {
            t.normalize(),
            e *= .5;
            var n = g.sin(e);
            return this.x = n * t.x,
            this.y = n * t.y,
            this.z = n * t.z,
            this.w = g.cos(e),
            this
        },
        setFromMat33: function (t) {
            var e,
            n = (t = t.elements)[0] + t[4] + t[8];
            if (n > 0)
                e = g.sqrt(n + 1), this.w = .5 / e, e = .5 / e, this.x = (t[5] - t[7]) * e, this.y = (t[6] - t[2]) * e, this.z = (t[1] - t[3]) * e;
            else {
                var a = [],
                u = 0;
                t[4] > t[0] && (u = 1),
                t[8] > t[3 * u + u] && (u = 2);
                var p = (u + 1) % 3,
                f = (u + 2) % 3;
                e = g.sqrt(t[3 * u + u] - t[3 * p + p] - t[3 * f + f] + 1),
                a[u] = .5 * fRoot,
                e = .5 / fRoot,
                this.w = (t[3 * p + f] - t[3 * f + p]) * e,
                a[p] = (t[3 * p + u] + t[3 * u + p]) * e,
                a[f] = (t[3 * f + u] + t[3 * u + f]) * e,
                this.x = a[1],
                this.y = a[2],
                this.z = a[3]
            }
            return this
        },
        toArray: function (t, e) {
            t[e = e || 0] = this.x,
            t[e + 1] = this.y,
            t[e + 2] = this.z,
            t[e + 3] = this.w
        },
        fromArray: function (t, e) {
            return e = e || 0,
            this.set(t[e], t[e + 1], t[e + 2], t[e + 3]),
            this
        },
        toAxisAngle: function (t) {
            var e = g.clamp(this.w, 0, .9999),
            n = 2 * g.acos(e);
            return t.x = this.x / g.sqrt(1 - e * e),
            t.y = this.y / g.sqrt(1 - e * e),
            t.z = this.z / g.sqrt(1 - e * e),
            n
        }
    }),
    Object.assign(Mat33.prototype, {
        Mat33: !0,
        set: function (t, e, n, a, u, g, p, f, m) {
            var y = this.elements;
            return y[0] = t,
            y[1] = e,
            y[2] = n,
            y[3] = a,
            y[4] = u,
            y[5] = g,
            y[6] = p,
            y[7] = f,
            y[8] = m,
            this
        },
        add: function (t, e) {
            if (void 0 !== e)
                return this.addMatrixs(t, e);
            var n = this.elements,
            a = t.elements;
            return n[0] += a[0],
            n[1] += a[1],
            n[2] += a[2],
            n[3] += a[3],
            n[4] += a[4],
            n[5] += a[5],
            n[6] += a[6],
            n[7] += a[7],
            n[8] += a[8],
            this
        },
        addMatrixs: function (t, e) {
            var n = this.elements,
            a = t.elements,
            u = e.elements;
            return n[0] = a[0] + u[0],
            n[1] = a[1] + u[1],
            n[2] = a[2] + u[2],
            n[3] = a[3] + u[3],
            n[4] = a[4] + u[4],
            n[5] = a[5] + u[5],
            n[6] = a[6] + u[6],
            n[7] = a[7] + u[7],
            n[8] = a[8] + u[8],
            this
        },
        addEqual: function (t) {
            var e = this.elements,
            n = t.elements;
            return e[0] += n[0],
            e[1] += n[1],
            e[2] += n[2],
            e[3] += n[3],
            e[4] += n[4],
            e[5] += n[5],
            e[6] += n[6],
            e[7] += n[7],
            e[8] += n[8],
            this
        },
        sub: function (t, e) {
            if (void 0 !== e)
                return this.subMatrixs(t, e);
            var n = this.elements,
            a = t.elements;
            return n[0] -= a[0],
            n[1] -= a[1],
            n[2] -= a[2],
            n[3] -= a[3],
            n[4] -= a[4],
            n[5] -= a[5],
            n[6] -= a[6],
            n[7] -= a[7],
            n[8] -= a[8],
            this
        },
        subMatrixs: function (t, e) {
            var n = this.elements,
            a = t.elements,
            u = e.elements;
            return n[0] = a[0] - u[0],
            n[1] = a[1] - u[1],
            n[2] = a[2] - u[2],
            n[3] = a[3] - u[3],
            n[4] = a[4] - u[4],
            n[5] = a[5] - u[5],
            n[6] = a[6] - u[6],
            n[7] = a[7] - u[7],
            n[8] = a[8] - u[8],
            this
        },
        subEqual: function (t) {
            var e = this.elements,
            n = t.elements;
            return e[0] -= n[0],
            e[1] -= n[1],
            e[2] -= n[2],
            e[3] -= n[3],
            e[4] -= n[4],
            e[5] -= n[5],
            e[6] -= n[6],
            e[7] -= n[7],
            e[8] -= n[8],
            this
        },
        scale: function (t, e) {
            var n = this.elements,
            a = t.elements;
            return n[0] = a[0] * e,
            n[1] = a[1] * e,
            n[2] = a[2] * e,
            n[3] = a[3] * e,
            n[4] = a[4] * e,
            n[5] = a[5] * e,
            n[6] = a[6] * e,
            n[7] = a[7] * e,
            n[8] = a[8] * e,
            this
        },
        scaleEqual: function (t) {
            var e = this.elements;
            return e[0] *= t,
            e[1] *= t,
            e[2] *= t,
            e[3] *= t,
            e[4] *= t,
            e[5] *= t,
            e[6] *= t,
            e[7] *= t,
            e[8] *= t,
            this
        },
        multiplyMatrices: function (t, e, n) {
            n && (e = e.clone().transpose());
            var a = this.elements,
            u = t.elements,
            g = e.elements,
            p = u[0],
            f = u[3],
            m = u[6],
            y = u[1],
            S = u[4],
            _ = u[7],
            A = u[2],
            v = u[5],
            w = u[8],
            E = g[0],
            x = g[3],
            C = g[6],
            b = g[1],
            R = g[4],
            k = g[7],
            B = g[2],
            V = g[5],
            z = g[8];
            return a[0] = p * E + y * x + A * C,
            a[1] = p * b + y * R + A * k,
            a[2] = p * B + y * V + A * z,
            a[3] = f * E + S * x + v * C,
            a[4] = f * b + S * R + v * k,
            a[5] = f * B + S * V + v * z,
            a[6] = m * E + _ * x + w * C,
            a[7] = m * b + _ * R + w * k,
            a[8] = m * B + _ * V + w * z,
            this
        },
        transpose: function (t) {
            if (void 0 !== t) {
                var e = t.elements;
                return this.set(e[0], e[3], e[6], e[1], e[4], e[7], e[2], e[5], e[8]),
                this
            }
            var n = this.elements,
            a = n[1],
            u = n[2],
            g = n[5];
            return n[1] = n[3],
            n[2] = n[6],
            n[3] = a,
            n[5] = n[7],
            n[6] = u,
            n[7] = g,
            this
        },
        setQuat: function (t) {
            var e = this.elements,
            n = t.x,
            a = t.y,
            u = t.z,
            g = t.w,
            p = n + n,
            f = a + a,
            m = u + u,
            y = n * p,
            S = n * f,
            _ = n * m,
            A = a * f,
            v = a * m,
            w = u * m,
            E = g * p,
            x = g * f,
            C = g * m;
            return e[0] = 1 - (A + w),
            e[1] = S - C,
            e[2] = _ + x,
            e[3] = S + C,
            e[4] = 1 - (y + w),
            e[5] = v - E,
            e[6] = _ - x,
            e[7] = v + E,
            e[8] = 1 - (y + A),
            this
        },
        invert: function (t) {
            var e = this.elements,
            n = t.elements,
            a = n[0],
            u = n[3],
            g = n[6],
            p = n[1],
            f = n[4],
            m = n[7],
            y = n[2],
            S = n[5],
            _ = n[8],
            A = _ * f - S * m,
            v = -_ * u + S * g,
            w = m * u - f * g,
            E = a * A + p * v + y * w;
            return 0 === E ? (console.log("can't invert matrix, determinant is 0"), this.identity()) : (E = 1 / E, e[0] = A * E, e[1] = (-_ * p + y * m) * E, e[2] = (S * p - y * f) * E, e[3] = v * E, e[4] = (_ * a - y * g) * E, e[5] = (-S * a + y * u) * E, e[6] = w * E, e[7] = (-m * a + p * g) * E, e[8] = (f * a - p * u) * E, this)
        },
        addOffset: function (t, e) {
            var n = e.x,
            a = e.y,
            u = e.z,
            g = this.elements;
            g[0] += t * (a * a + u * u),
            g[4] += t * (n * n + u * u),
            g[8] += t * (n * n + a * a);
            var p = t * n * a,
            f = t * a * u,
            m = t * u * n;
            return g[1] -= p,
            g[3] -= p,
            g[2] -= f,
            g[6] -= f,
            g[5] -= m,
            g[7] -= m,
            this
        },
        subOffset: function (t, e) {
            var n = e.x,
            a = e.y,
            u = e.z,
            g = this.elements;
            g[0] -= t * (a * a + u * u),
            g[4] -= t * (n * n + u * u),
            g[8] -= t * (n * n + a * a);
            var p = t * n * a,
            f = t * a * u,
            m = t * u * n;
            return g[1] += p,
            g[3] += p,
            g[2] += f,
            g[6] += f,
            g[5] += m,
            g[7] += m,
            this
        },
        multiplyScalar: function (t) {
            var e = this.elements;
            return e[0] *= t,
            e[3] *= t,
            e[6] *= t,
            e[1] *= t,
            e[4] *= t,
            e[7] *= t,
            e[2] *= t,
            e[5] *= t,
            e[8] *= t,
            this
        },
        identity: function () {
            return this.set(1, 0, 0, 0, 1, 0, 0, 0, 1),
            this
        },
        clone: function () {
            return (new Mat33).fromArray(this.elements)
        },
        copy: function (t) {
            for (var e = 0; e < 9; e++)
                this.elements[e] = t.elements[e];
            return this
        },
        determinant: function () {
            var t = this.elements,
            e = t[0],
            n = t[1],
            a = t[2],
            u = t[3],
            g = t[4],
            p = t[5],
            f = t[6],
            m = t[7],
            y = t[8];
            return e * g * y - e * p * m - n * u * y + n * p * f + a * u * m - a * g * f
        },
        fromArray: function (t, e) {
            void 0 === e && (e = 0);
            for (var n = 0; n < 9; n++)
                this.elements[n] = t[n + e];
            return this
        },
        toArray: function (t, e) {
            void 0 === t && (t = []),
            void 0 === e && (e = 0);
            var n = this.elements;
            return t[e] = n[0],
            t[e + 1] = n[1],
            t[e + 2] = n[2],
            t[e + 3] = n[3],
            t[e + 4] = n[4],
            t[e + 5] = n[5],
            t[e + 6] = n[6],
            t[e + 7] = n[7],
            t[e + 8] = n[8],
            t
        }
    }),
    Object.assign(AABB.prototype, {
        AABB: !0,
        set: function (t, e, n, a, u, g) {
            var p = this.elements;
            return p[0] = t,
            p[3] = e,
            p[1] = n,
            p[4] = a,
            p[2] = u,
            p[5] = g,
            this
        },
        intersectTest: function (t) {
            var e = this.elements,
            n = t.elements;
            return e[0] > n[3] || e[1] > n[4] || e[2] > n[5] || e[3] < n[0] || e[4] < n[1] || e[5] < n[2]
        },
        intersectTestTwo: function (t) {
            var e = this.elements,
            n = t.elements;
            return e[0] < n[0] || e[1] < n[1] || e[2] < n[2] || e[3] > n[3] || e[4] > n[4] || e[5] > n[5]
        },
        clone: function () {
            return (new this.constructor).fromArray(this.elements)
        },
        copy: function (t, e) {
            var n = e || 0,
            a = t.elements;
            return this.set(a[0] - n, a[3] + n, a[1] - n, a[4] + n, a[2] - n, a[5] + n),
            this
        },
        fromArray: function (t) {
            return this.elements.set(t),
            this
        },
        combine: function (t, e) {
            var n = t.elements,
            a = e.elements,
            u = this.elements;
            return u[0] = n[0] < a[0] ? n[0] : a[0],
            u[1] = n[1] < a[1] ? n[1] : a[1],
            u[2] = n[2] < a[2] ? n[2] : a[2],
            u[3] = n[3] > a[3] ? n[3] : a[3],
            u[4] = n[4] > a[4] ? n[4] : a[4],
            u[5] = n[5] > a[5] ? n[5] : a[5],
            this
        },
        surfaceArea: function () {
            var t = this.elements,
            e = t[3] - t[0],
            n = t[4] - t[1],
            a = t[5] - t[2];
            return 2 * (e * (n + a) + n * a)
        },
        intersectsWithPoint: function (t, e, n) {
            var a = this.elements;
            return t >= a[0] && t <= a[3] && e >= a[1] && e <= a[4] && n >= a[2] && n <= a[5]
        },
        setFromPoints: function (t) {
            this.makeEmpty();
            for (var e = 0; e < t.length; e++)
                this.expandByPoint(t[e])
        },
        makeEmpty: function () {
            this.set(-1 / 0, -1 / 0, -1 / 0, 1 / 0, 1 / 0, 1 / 0)
        },
        expandByPoint: function (t) {
            var e = this.elements;
            this.set(g.min(e[0], t.x), g.min(e[1], t.y), g.min(e[2], t.z), g.max(e[3], t.x), g.max(e[4], t.y), g.max(e[5], t.z))
        },
        expandByScalar: function (t) {
            var e = this.elements;
            e[0] += -t,
            e[1] += -t,
            e[2] += -t,
            e[3] += t,
            e[4] += t,
            e[5] += t
        },
        getCenter: function () {
            var t = this.elements,
            e = t[3] - t[0],
            n = t[4] - t[1],
            a = t[5] - t[2];
            return new Vec3(t[0] + .5 * e, t[1] + .5 * n, t[2] + .5 * a)
        }
    });
    var p = 0;
    function ShapeIdCount() {
        return p++
    }
    function Shape(t) {
        this.type = 0,
        this.id = ShapeIdCount(),
        this.prev = null,
        this.next = null,
        this.proxy = null,
        this.parent = null,
        this.contactLink = null,
        this.numContacts = 0,
        this.position = new Vec3,
        this.rotation = new Mat33,
        this.relativePosition = (new Vec3).copy(t.relativePosition),
        this.relativeRotation = (new Mat33).copy(t.relativeRotation),
        this.aabb = new AABB,
        this.lastAABB = new AABB,
        this.tempAABB = new AABB,
        this.density = t.density,
        this.friction = t.friction,
        this.restitution = t.restitution,
        this.belongsTo = t.belongsTo,
        this.collidesWith = t.collidesWith,
        this.localRotation = t.localRotation,
        this.mass = null
    }
    function Box(t, e, n, a) {
        Shape.call(this, t),
        this.type = 2,
        this.width = e,
        this.height = n,
        this.depth = a,
        this.halfWidth = .5 * e,
        this.halfHeight = .5 * n,
        this.halfDepth = .5 * a,
        this.dimentions = new Float32Array(18),
        this.elements = new Float32Array(24)
    }
    function Sphere(t, e) {
        Shape.call(this, t),
        this.type = 1,
        this.radius = e
    }
    function Cylinder(t, e, n) {
        Shape.call(this, t),
        this.type = 3,
        this.radius = e,
        this.height = n,
        this.halfHeight = .5 * n,
        this.normalDirection = new Vec3,
        this.halfDirection = new Vec3
    }
    function Plane(t, e) {
        Shape.call(this, t),
        this.type = 4,
        this.normal = new Vec3(0, 1, 0)
    }
    function Particle(t, e) {
        Shape.call(this, t),
        this.type = 5
    }
    function ShapeConfig() {
        this.relativePosition = new Vec3,
        this.relativeRotation = new Mat33,
        this.friction = .2,
        this.restitution = .2,
        this.density = 1,
        this.belongsTo = 1,
        this.collidesWith = 4294967295
    }
    function LimitMotor(t, e) {
        e = e || !1,
        this.axis = t,
        this.angle = 0,
        this.lowerLimit = e ? 0 : 1,
        this.upperLimit = 0,
        this.motorSpeed = 0,
        this.maxMotorForce = 0,
        this.frequency = 0,
        this.dampingRatio = 0
    }
    function Constraint() {
        this.parent = null,
        this.body1 = null,
        this.body2 = null,
        this.addedToIsland = !1
    }
    function JointLink(t) {
        this.prev = null,
        this.next = null,
        this.body = null,
        this.joint = t
    }
    function Joint(t) {
        Constraint.call(this),
        this.scale = 1,
        this.invScale = 1,
        this.name = "",
        this.id = NaN,
        this.type = 0,
        this.prev = null,
        this.next = null,
        this.body1 = t.body1,
        this.body2 = t.body2,
        this.localAnchorPoint1 = (new Vec3).copy(t.localAnchorPoint1),
        this.localAnchorPoint2 = (new Vec3).copy(t.localAnchorPoint2),
        this.relativeAnchorPoint1 = new Vec3,
        this.relativeAnchorPoint2 = new Vec3,
        this.anchorPoint1 = new Vec3,
        this.anchorPoint2 = new Vec3,
        this.allowCollision = t.allowCollision,
        this.b1Link = new JointLink(this),
        this.b2Link = new JointLink(this)
    }
    function LinearConstraint(t) {
        this.m1 = NaN,
        this.m2 = NaN,
        this.ii1 = null,
        this.ii2 = null,
        this.dd = null,
        this.r1x = NaN,
        this.r1y = NaN,
        this.r1z = NaN,
        this.r2x = NaN,
        this.r2y = NaN,
        this.r2z = NaN,
        this.ax1x = NaN,
        this.ax1y = NaN,
        this.ax1z = NaN,
        this.ay1x = NaN,
        this.ay1y = NaN,
        this.ay1z = NaN,
        this.az1x = NaN,
        this.az1y = NaN,
        this.az1z = NaN,
        this.ax2x = NaN,
        this.ax2y = NaN,
        this.ax2z = NaN,
        this.ay2x = NaN,
        this.ay2y = NaN,
        this.ay2z = NaN,
        this.az2x = NaN,
        this.az2y = NaN,
        this.az2z = NaN,
        this.vel = NaN,
        this.velx = NaN,
        this.vely = NaN,
        this.velz = NaN,
        this.joint = t,
        this.r1 = t.relativeAnchorPoint1,
        this.r2 = t.relativeAnchorPoint2,
        this.p1 = t.anchorPoint1,
        this.p2 = t.anchorPoint2,
        this.b1 = t.body1,
        this.b2 = t.body2,
        this.l1 = this.b1.linearVelocity,
        this.l2 = this.b2.linearVelocity,
        this.a1 = this.b1.angularVelocity,
        this.a2 = this.b2.angularVelocity,
        this.i1 = this.b1.inverseInertia,
        this.i2 = this.b2.inverseInertia,
        this.impx = 0,
        this.impy = 0,
        this.impz = 0
    }
    function Rotational3Constraint(t, e, n, a) {
        this.cfm1 = NaN,
        this.cfm2 = NaN,
        this.cfm3 = NaN,
        this.i1e00 = NaN,
        this.i1e01 = NaN,
        this.i1e02 = NaN,
        this.i1e10 = NaN,
        this.i1e11 = NaN,
        this.i1e12 = NaN,
        this.i1e20 = NaN,
        this.i1e21 = NaN,
        this.i1e22 = NaN,
        this.i2e00 = NaN,
        this.i2e01 = NaN,
        this.i2e02 = NaN,
        this.i2e10 = NaN,
        this.i2e11 = NaN,
        this.i2e12 = NaN,
        this.i2e20 = NaN,
        this.i2e21 = NaN,
        this.i2e22 = NaN,
        this.ax1 = NaN,
        this.ay1 = NaN,
        this.az1 = NaN,
        this.ax2 = NaN,
        this.ay2 = NaN,
        this.az2 = NaN,
        this.ax3 = NaN,
        this.ay3 = NaN,
        this.az3 = NaN,
        this.a1x1 = NaN,
        this.a1y1 = NaN,
        this.a1z1 = NaN,
        this.a2x1 = NaN,
        this.a2y1 = NaN,
        this.a2z1 = NaN,
        this.a1x2 = NaN,
        this.a1y2 = NaN,
        this.a1z2 = NaN,
        this.a2x2 = NaN,
        this.a2y2 = NaN,
        this.a2z2 = NaN,
        this.a1x3 = NaN,
        this.a1y3 = NaN,
        this.a1z3 = NaN,
        this.a2x3 = NaN,
        this.a2y3 = NaN,
        this.a2z3 = NaN,
        this.lowerLimit1 = NaN,
        this.upperLimit1 = NaN,
        this.limitVelocity1 = NaN,
        this.limitState1 = 0,
        this.enableMotor1 = !1,
        this.motorSpeed1 = NaN,
        this.maxMotorForce1 = NaN,
        this.maxMotorImpulse1 = NaN,
        this.lowerLimit2 = NaN,
        this.upperLimit2 = NaN,
        this.limitVelocity2 = NaN,
        this.limitState2 = 0,
        this.enableMotor2 = !1,
        this.motorSpeed2 = NaN,
        this.maxMotorForce2 = NaN,
        this.maxMotorImpulse2 = NaN,
        this.lowerLimit3 = NaN,
        this.upperLimit3 = NaN,
        this.limitVelocity3 = NaN,
        this.limitState3 = 0,
        this.enableMotor3 = !1,
        this.motorSpeed3 = NaN,
        this.maxMotorForce3 = NaN,
        this.maxMotorImpulse3 = NaN,
        this.k00 = NaN,
        this.k01 = NaN,
        this.k02 = NaN,
        this.k10 = NaN,
        this.k11 = NaN,
        this.k12 = NaN,
        this.k20 = NaN,
        this.k21 = NaN,
        this.k22 = NaN,
        this.kv00 = NaN,
        this.kv11 = NaN,
        this.kv22 = NaN,
        this.dv00 = NaN,
        this.dv11 = NaN,
        this.dv22 = NaN,
        this.d00 = NaN,
        this.d01 = NaN,
        this.d02 = NaN,
        this.d10 = NaN,
        this.d11 = NaN,
        this.d12 = NaN,
        this.d20 = NaN,
        this.d21 = NaN,
        this.d22 = NaN,
        this.limitMotor1 = e,
        this.limitMotor2 = n,
        this.limitMotor3 = a,
        this.b1 = t.body1,
        this.b2 = t.body2,
        this.a1 = this.b1.angularVelocity,
        this.a2 = this.b2.angularVelocity,
        this.i1 = this.b1.inverseInertia,
        this.i2 = this.b2.inverseInertia,
        this.limitImpulse1 = 0,
        this.motorImpulse1 = 0,
        this.limitImpulse2 = 0,
        this.motorImpulse2 = 0,
        this.limitImpulse3 = 0,
        this.motorImpulse3 = 0
    }
    function HingeJoint(t, e, n) {
        Joint.call(this, t),
        this.type = 3,
        this.localAxis1 = t.localAxis1.clone().normalize(),
        this.localAxis2 = t.localAxis2.clone().normalize();
        var a = (new Mat33).setQuat((new Quat).setFromUnitVectors(this.localAxis1, this.localAxis2));
        this.localAngle1 = (new Vec3).tangent(this.localAxis1).normalize(),
        this.localAngle2 = this.localAngle1.clone().applyMatrix3(a, !0),
        this.ax1 = new Vec3,
        this.ax2 = new Vec3,
        this.an1 = new Vec3,
        this.an2 = new Vec3,
        this.tmp = new Vec3,
        this.nor = new Vec3,
        this.tan = new Vec3,
        this.bin = new Vec3,
        this.limitMotor = new LimitMotor(this.nor, !1),
        this.limitMotor.lowerLimit = e,
        this.limitMotor.upperLimit = n,
        this.lc = new LinearConstraint(this),
        this.r3 = new Rotational3Constraint(this, this.limitMotor, new LimitMotor(this.tan, !0), new LimitMotor(this.bin, !0))
    }
    function BallAndSocketJoint(t) {
        Joint.call(this, t),
        this.type = 2,
        this.lc = new LinearConstraint(this)
    }
    function TranslationalConstraint(t, e) {
        this.cfm = NaN,
        this.m1 = NaN,
        this.m2 = NaN,
        this.i1e00 = NaN,
        this.i1e01 = NaN,
        this.i1e02 = NaN,
        this.i1e10 = NaN,
        this.i1e11 = NaN,
        this.i1e12 = NaN,
        this.i1e20 = NaN,
        this.i1e21 = NaN,
        this.i1e22 = NaN,
        this.i2e00 = NaN,
        this.i2e01 = NaN,
        this.i2e02 = NaN,
        this.i2e10 = NaN,
        this.i2e11 = NaN,
        this.i2e12 = NaN,
        this.i2e20 = NaN,
        this.i2e21 = NaN,
        this.i2e22 = NaN,
        this.motorDenom = NaN,
        this.invMotorDenom = NaN,
        this.invDenom = NaN,
        this.ax = NaN,
        this.ay = NaN,
        this.az = NaN,
        this.r1x = NaN,
        this.r1y = NaN,
        this.r1z = NaN,
        this.r2x = NaN,
        this.r2y = NaN,
        this.r2z = NaN,
        this.t1x = NaN,
        this.t1y = NaN,
        this.t1z = NaN,
        this.t2x = NaN,
        this.t2y = NaN,
        this.t2z = NaN,
        this.l1x = NaN,
        this.l1y = NaN,
        this.l1z = NaN,
        this.l2x = NaN,
        this.l2y = NaN,
        this.l2z = NaN,
        this.a1x = NaN,
        this.a1y = NaN,
        this.a1z = NaN,
        this.a2x = NaN,
        this.a2y = NaN,
        this.a2z = NaN,
        this.lowerLimit = NaN,
        this.upperLimit = NaN,
        this.limitVelocity = NaN,
        this.limitState = 0,
        this.enableMotor = !1,
        this.motorSpeed = NaN,
        this.maxMotorForce = NaN,
        this.maxMotorImpulse = NaN,
        this.limitMotor = e,
        this.b1 = t.body1,
        this.b2 = t.body2,
        this.p1 = t.anchorPoint1,
        this.p2 = t.anchorPoint2,
        this.r1 = t.relativeAnchorPoint1,
        this.r2 = t.relativeAnchorPoint2,
        this.l1 = this.b1.linearVelocity,
        this.l2 = this.b2.linearVelocity,
        this.a1 = this.b1.angularVelocity,
        this.a2 = this.b2.angularVelocity,
        this.i1 = this.b1.inverseInertia,
        this.i2 = this.b2.inverseInertia,
        this.limitImpulse = 0,
        this.motorImpulse = 0
    }
    function DistanceJoint(t, e, n) {
        Joint.call(this, t),
        this.type = 1,
        this.nor = new Vec3,
        this.limitMotor = new LimitMotor(this.nor, !0),
        this.limitMotor.lowerLimit = e,
        this.limitMotor.upperLimit = n,
        this.t = new TranslationalConstraint(this, this.limitMotor)
    }
    function AngularConstraint(t, e) {
        this.joint = t,
        this.targetOrientation = (new Quat).invert(e),
        this.relativeOrientation = new Quat,
        this.ii1 = null,
        this.ii2 = null,
        this.dd = null,
        this.vel = new Vec3,
        this.imp = new Vec3,
        this.rn0 = new Vec3,
        this.rn1 = new Vec3,
        this.rn2 = new Vec3,
        this.b1 = t.body1,
        this.b2 = t.body2,
        this.a1 = this.b1.angularVelocity,
        this.a2 = this.b2.angularVelocity,
        this.i1 = this.b1.inverseInertia,
        this.i2 = this.b2.inverseInertia
    }
    function Translational3Constraint(t, e, n, a) {
        this.m1 = NaN,
        this.m2 = NaN,
        this.i1e00 = NaN,
        this.i1e01 = NaN,
        this.i1e02 = NaN,
        this.i1e10 = NaN,
        this.i1e11 = NaN,
        this.i1e12 = NaN,
        this.i1e20 = NaN,
        this.i1e21 = NaN,
        this.i1e22 = NaN,
        this.i2e00 = NaN,
        this.i2e01 = NaN,
        this.i2e02 = NaN,
        this.i2e10 = NaN,
        this.i2e11 = NaN,
        this.i2e12 = NaN,
        this.i2e20 = NaN,
        this.i2e21 = NaN,
        this.i2e22 = NaN,
        this.ax1 = NaN,
        this.ay1 = NaN,
        this.az1 = NaN,
        this.ax2 = NaN,
        this.ay2 = NaN,
        this.az2 = NaN,
        this.ax3 = NaN,
        this.ay3 = NaN,
        this.az3 = NaN,
        this.r1x = NaN,
        this.r1y = NaN,
        this.r1z = NaN,
        this.r2x = NaN,
        this.r2y = NaN,
        this.r2z = NaN,
        this.t1x1 = NaN,
        this.t1y1 = NaN,
        this.t1z1 = NaN,
        this.t2x1 = NaN,
        this.t2y1 = NaN,
        this.t2z1 = NaN,
        this.l1x1 = NaN,
        this.l1y1 = NaN,
        this.l1z1 = NaN,
        this.l2x1 = NaN,
        this.l2y1 = NaN,
        this.l2z1 = NaN,
        this.a1x1 = NaN,
        this.a1y1 = NaN,
        this.a1z1 = NaN,
        this.a2x1 = NaN,
        this.a2y1 = NaN,
        this.a2z1 = NaN,
        this.t1x2 = NaN,
        this.t1y2 = NaN,
        this.t1z2 = NaN,
        this.t2x2 = NaN,
        this.t2y2 = NaN,
        this.t2z2 = NaN,
        this.l1x2 = NaN,
        this.l1y2 = NaN,
        this.l1z2 = NaN,
        this.l2x2 = NaN,
        this.l2y2 = NaN,
        this.l2z2 = NaN,
        this.a1x2 = NaN,
        this.a1y2 = NaN,
        this.a1z2 = NaN,
        this.a2x2 = NaN,
        this.a2y2 = NaN,
        this.a2z2 = NaN,
        this.t1x3 = NaN,
        this.t1y3 = NaN,
        this.t1z3 = NaN,
        this.t2x3 = NaN,
        this.t2y3 = NaN,
        this.t2z3 = NaN,
        this.l1x3 = NaN,
        this.l1y3 = NaN,
        this.l1z3 = NaN,
        this.l2x3 = NaN,
        this.l2y3 = NaN,
        this.l2z3 = NaN,
        this.a1x3 = NaN,
        this.a1y3 = NaN,
        this.a1z3 = NaN,
        this.a2x3 = NaN,
        this.a2y3 = NaN,
        this.a2z3 = NaN,
        this.lowerLimit1 = NaN,
        this.upperLimit1 = NaN,
        this.limitVelocity1 = NaN,
        this.limitState1 = 0,
        this.enableMotor1 = !1,
        this.motorSpeed1 = NaN,
        this.maxMotorForce1 = NaN,
        this.maxMotorImpulse1 = NaN,
        this.lowerLimit2 = NaN,
        this.upperLimit2 = NaN,
        this.limitVelocity2 = NaN,
        this.limitState2 = 0,
        this.enableMotor2 = !1,
        this.motorSpeed2 = NaN,
        this.maxMotorForce2 = NaN,
        this.maxMotorImpulse2 = NaN,
        this.lowerLimit3 = NaN,
        this.upperLimit3 = NaN,
        this.limitVelocity3 = NaN,
        this.limitState3 = 0,
        this.enableMotor3 = !1,
        this.motorSpeed3 = NaN,
        this.maxMotorForce3 = NaN,
        this.maxMotorImpulse3 = NaN,
        this.k00 = NaN,
        this.k01 = NaN,
        this.k02 = NaN,
        this.k10 = NaN,
        this.k11 = NaN,
        this.k12 = NaN,
        this.k20 = NaN,
        this.k21 = NaN,
        this.k22 = NaN,
        this.kv00 = NaN,
        this.kv11 = NaN,
        this.kv22 = NaN,
        this.dv00 = NaN,
        this.dv11 = NaN,
        this.dv22 = NaN,
        this.d00 = NaN,
        this.d01 = NaN,
        this.d02 = NaN,
        this.d10 = NaN,
        this.d11 = NaN,
        this.d12 = NaN,
        this.d20 = NaN,
        this.d21 = NaN,
        this.d22 = NaN,
        this.limitMotor1 = e,
        this.limitMotor2 = n,
        this.limitMotor3 = a,
        this.b1 = t.body1,
        this.b2 = t.body2,
        this.p1 = t.anchorPoint1,
        this.p2 = t.anchorPoint2,
        this.r1 = t.relativeAnchorPoint1,
        this.r2 = t.relativeAnchorPoint2,
        this.l1 = this.b1.linearVelocity,
        this.l2 = this.b2.linearVelocity,
        this.a1 = this.b1.angularVelocity,
        this.a2 = this.b2.angularVelocity,
        this.i1 = this.b1.inverseInertia,
        this.i2 = this.b2.inverseInertia,
        this.limitImpulse1 = 0,
        this.motorImpulse1 = 0,
        this.limitImpulse2 = 0,
        this.motorImpulse2 = 0,
        this.limitImpulse3 = 0,
        this.motorImpulse3 = 0,
        this.cfm1 = 0,
        this.cfm2 = 0,
        this.cfm3 = 0,
        this.weight = -1
    }
    function PrismaticJoint(t, e, n) {
        Joint.call(this, t),
        this.type = 6,
        this.localAxis1 = t.localAxis1.clone().normalize(),
        this.localAxis2 = t.localAxis2.clone().normalize(),
        this.ax1 = new Vec3,
        this.ax2 = new Vec3,
        this.nor = new Vec3,
        this.tan = new Vec3,
        this.bin = new Vec3,
        this.ac = new AngularConstraint(this, (new Quat).setFromUnitVectors(this.localAxis1, this.localAxis2)),
        this.limitMotor = new LimitMotor(this.nor, !0),
        this.limitMotor.lowerLimit = e,
        this.limitMotor.upperLimit = n,
        this.t3 = new Translational3Constraint(this, this.limitMotor, new LimitMotor(this.tan, !0), new LimitMotor(this.bin, !0))
    }
    function SliderJoint(t, e, n) {
        Joint.call(this, t),
        this.type = 5,
        this.localAxis1 = t.localAxis1.clone().normalize(),
        this.localAxis2 = t.localAxis2.clone().normalize();
        var a = (new Mat33).setQuat((new Quat).setFromUnitVectors(this.localAxis1, this.localAxis2));
        this.localAngle1 = (new Vec3).tangent(this.localAxis1).normalize(),
        this.localAngle2 = this.localAngle1.clone().applyMatrix3(a, !0),
        this.ax1 = new Vec3,
        this.ax2 = new Vec3,
        this.an1 = new Vec3,
        this.an2 = new Vec3,
        this.tmp = new Vec3,
        this.nor = new Vec3,
        this.tan = new Vec3,
        this.bin = new Vec3,
        this.rotationalLimitMotor = new LimitMotor(this.nor, !1),
        this.r3 = new Rotational3Constraint(this, this.rotationalLimitMotor, new LimitMotor(this.tan, !0), new LimitMotor(this.bin, !0)),
        this.translationalLimitMotor = new LimitMotor(this.nor, !0),
        this.translationalLimitMotor.lowerLimit = e,
        this.translationalLimitMotor.upperLimit = n,
        this.t3 = new Translational3Constraint(this, this.translationalLimitMotor, new LimitMotor(this.tan, !0), new LimitMotor(this.bin, !0))
    }
    function WheelJoint(t) {
        Joint.call(this, t),
        this.type = 4,
        this.localAxis1 = t.localAxis1.clone().normalize(),
        this.localAxis2 = t.localAxis2.clone().normalize(),
        this.localAngle1 = new Vec3,
        this.localAngle2 = new Vec3;
        var e = g.dotVectors(this.localAxis1, this.localAxis2);
        if (e > -1 && e < 1)
            this.localAngle1.set(this.localAxis2.x - e * this.localAxis1.x, this.localAxis2.y - e * this.localAxis1.y, this.localAxis2.z - e * this.localAxis1.z).normalize(), this.localAngle2.set(this.localAxis1.x - e * this.localAxis2.x, this.localAxis1.y - e * this.localAxis2.y, this.localAxis1.z - e * this.localAxis2.z).normalize();
        else {
            var n = (new Mat33).setQuat((new Quat).setFromUnitVectors(this.localAxis1, this.localAxis2));
            this.localAngle1.tangent(this.localAxis1).normalize(),
            this.localAngle2 = this.localAngle1.clone().applyMatrix3(n, !0)
        }
        this.ax1 = new Vec3,
        this.ax2 = new Vec3,
        this.an1 = new Vec3,
        this.an2 = new Vec3,
        this.tmp = new Vec3,
        this.nor = new Vec3,
        this.tan = new Vec3,
        this.bin = new Vec3,
        this.translationalLimitMotor = new LimitMotor(this.tan, !0),
        this.translationalLimitMotor.frequency = 8,
        this.translationalLimitMotor.dampingRatio = 1,
        this.rotationalLimitMotor1 = new LimitMotor(this.tan, !1),
        this.rotationalLimitMotor2 = new LimitMotor(this.bin, !1),
        this.t3 = new Translational3Constraint(this, new LimitMotor(this.nor, !0), this.translationalLimitMotor, new LimitMotor(this.bin, !0)),
        this.t3.weight = 1,
        this.r3 = new Rotational3Constraint(this, new LimitMotor(this.nor, !0), this.rotationalLimitMotor1, this.rotationalLimitMotor2)
    }
    function JointConfig() {
        this.scale = 1,
        this.invScale = 1,
        this.body1 = null,
        this.body2 = null,
        this.localAnchorPoint1 = new Vec3,
        this.localAnchorPoint2 = new Vec3,
        this.localAxis1 = new Vec3,
        this.localAxis2 = new Vec3,
        this.allowCollision = !1
    }
    function MassInfo() {
        this.mass = 0,
        this.inertia = new Mat33
    }
    function ContactLink(t) {
        this.prev = null,
        this.next = null,
        this.shape = null,
        this.body = null,
        this.contact = t
    }
    function ImpulseDataBuffer() {
        this.lp1X = NaN,
        this.lp1Y = NaN,
        this.lp1Z = NaN,
        this.lp2X = NaN,
        this.lp2Y = NaN,
        this.lp2Z = NaN,
        this.impulse = NaN
    }
    function ManifoldPoint() {
        this.warmStarted = !1,
        this.position = new Vec3,
        this.localPoint1 = new Vec3,
        this.localPoint2 = new Vec3,
        this.normal = new Vec3,
        this.tangent = new Vec3,
        this.binormal = new Vec3,
        this.normalImpulse = 0,
        this.tangentImpulse = 0,
        this.binormalImpulse = 0,
        this.normalDenominator = 0,
        this.tangentDenominator = 0,
        this.binormalDenominator = 0,
        this.penetration = 0
    }
    function ContactManifold() {
        this.body1 = null,
        this.body2 = null,
        this.numPoints = 0,
        this.points = [new ManifoldPoint, new ManifoldPoint, new ManifoldPoint, new ManifoldPoint]
    }
    function ContactPointDataBuffer() {
        this.nor = new Vec3,
        this.tan = new Vec3,
        this.bin = new Vec3,
        this.norU1 = new Vec3,
        this.tanU1 = new Vec3,
        this.binU1 = new Vec3,
        this.norU2 = new Vec3,
        this.tanU2 = new Vec3,
        this.binU2 = new Vec3,
        this.norT1 = new Vec3,
        this.tanT1 = new Vec3,
        this.binT1 = new Vec3,
        this.norT2 = new Vec3,
        this.tanT2 = new Vec3,
        this.binT2 = new Vec3,
        this.norTU1 = new Vec3,
        this.tanTU1 = new Vec3,
        this.binTU1 = new Vec3,
        this.norTU2 = new Vec3,
        this.tanTU2 = new Vec3,
        this.binTU2 = new Vec3,
        this.norImp = 0,
        this.tanImp = 0,
        this.binImp = 0,
        this.norDen = 0,
        this.tanDen = 0,
        this.binDen = 0,
        this.norTar = 0,
        this.next = null,
        this.last = !1
    }
    function ContactConstraint(t) {
        Constraint.call(this),
        this.manifold = t,
        this.restitution = NaN,
        this.friction = NaN,
        this.p1 = null,
        this.p2 = null,
        this.lv1 = null,
        this.lv2 = null,
        this.av1 = null,
        this.av2 = null,
        this.i1 = null,
        this.i2 = null,
        this.tmp = new Vec3,
        this.tmpC1 = new Vec3,
        this.tmpC2 = new Vec3,
        this.tmpP1 = new Vec3,
        this.tmpP2 = new Vec3,
        this.tmplv1 = new Vec3,
        this.tmplv2 = new Vec3,
        this.tmpav1 = new Vec3,
        this.tmpav2 = new Vec3,
        this.m1 = NaN,
        this.m2 = NaN,
        this.num = 0,
        this.ps = t.points,
        this.cs = new ContactPointDataBuffer,
        this.cs.next = new ContactPointDataBuffer,
        this.cs.next.next = new ContactPointDataBuffer,
        this.cs.next.next.next = new ContactPointDataBuffer
    }
    function Contact() {
        this.shape1 = null,
        this.shape2 = null,
        this.body1 = null,
        this.body2 = null,
        this.prev = null,
        this.next = null,
        this.persisting = !1,
        this.sleeping = !1,
        this.detector = null,
        this.constraint = null,
        this.touching = !1,
        this.close = !1,
        this.dist = g.INF,
        this.b1Link = new ContactLink(this),
        this.b2Link = new ContactLink(this),
        this.s1Link = new ContactLink(this),
        this.s2Link = new ContactLink(this),
        this.manifold = new ContactManifold,
        this.buffer = [new ImpulseDataBuffer, new ImpulseDataBuffer, new ImpulseDataBuffer, new ImpulseDataBuffer],
        this.points = this.manifold.points,
        this.constraint = new ContactConstraint(this.manifold)
    }
    function RigidBody(t, e) {
        this.position = t || new Vec3,
        this.orientation = e || new Quat,
        this.scale = 1,
        this.invScale = 1,
        this.mesh = null,
        this.id = NaN,
        this.name = "",
        this.prev = null,
        this.next = null,
        this.type = 0,
        this.massInfo = new MassInfo,
        this.newPosition = new Vec3,
        this.controlPos = !1,
        this.newOrientation = new Quat,
        this.newRotation = new Vec3,
        this.currentRotation = new Vec3,
        this.controlRot = !1,
        this.controlRotInTime = !1,
        this.quaternion = new Quat,
        this.pos = new Vec3,
        this.linearVelocity = new Vec3,
        this.linearSpeed = new Vec3,
        this.linearVelocityConstraint = "",
        this.angularVelocityConstraint = "",
        this.linearVelocityMax = null,
        this.angularVelocityMax = null,
        this.positionConstraint = null,
        this.angularConstraint = null,
        this.angularVelocity = new Vec3,
        this.parent = null,
        this.contactLink = null,
        this.numContacts = 0,
        this.shapes = null,
        this.numShapes = 0,
        this.jointLink = null,
        this.numJoints = 0,
        this.sleepPosition = new Vec3,
        this.sleepOrientation = new Quat,
        this.isStatic = !1,
        this.isDynamic = !1,
        this.isKinematic = !1,
        this.rotation = new Mat33,
        this.mass = 0,
        this.inverseMass = 0,
        this.inverseInertia = new Mat33,
        this.localInertia = new Mat33,
        this.inverseLocalInertia = new Mat33,
        this.tmpInertia = new Mat33,
        this.addedToIsland = !1,
        this.allowSleep = !0,
        this.sleepTime = 0,
        this.sleeping = !1
    }
    function Pair(t, e) {
        this.shape1 = t || null,
        this.shape2 = e || null
    }
    function BroadPhase() {
        this.types = 0,
        this.numPairChecks = 0,
        this.numPairs = 0,
        this.pairs = []
    }
    Object.assign(Shape.prototype, {
        Shape: !0,
        calculateMassInfo: function (t) {
            printError("Shape", "Inheritance error.")
        },
        updateProxy: function () {
            printError("Shape", "Inheritance error.")
        },
        intersectRay: function () {
            printError("Shape", "intersectRay error.")
        }
    }),
    Box.prototype = Object.assign(Object.create(Shape.prototype), {
        constructor: Box,
        calculateMassInfo: function (t) {
            var e = this.width * this.height * this.depth * this.density;
            this.mass && (e = this.mass),
            this.mass = e;
            t.mass = e,
            t.inertia.set(e * (this.height * this.height + this.depth * this.depth) * (1 / 12), 0, 0, 0, e * (this.width * this.width + this.depth * this.depth) * (1 / 12), 0, 0, 0, e * (this.width * this.width + this.height * this.height) * (1 / 12))
        },
        updateProxy: function () {
            var t = this.rotation.elements,
            e = this.dimentions;
            e[0] = t[0],
            e[1] = t[3],
            e[2] = t[6],
            e[3] = t[1],
            e[4] = t[4],
            e[5] = t[7],
            e[6] = t[2],
            e[7] = t[5],
            e[8] = t[8],
            e[9] = t[0] * this.halfWidth,
            e[10] = t[3] * this.halfWidth,
            e[11] = t[6] * this.halfWidth,
            e[12] = t[1] * this.halfHeight,
            e[13] = t[4] * this.halfHeight,
            e[14] = t[7] * this.halfHeight,
            e[15] = t[2] * this.halfDepth,
            e[16] = t[5] * this.halfDepth,
            e[17] = t[8] * this.halfDepth;
            var n = e[9],
            a = e[10],
            u = e[11],
            g = e[12],
            p = e[13],
            f = e[14],
            m = e[15],
            y = e[16],
            S = e[17],
            _ = this.position.x,
            A = this.position.y,
            v = this.position.z,
            w = this.elements;
            w[0] = _ + n + g + m,
            w[1] = A + a + p + y,
            w[2] = v + u + f + S,
            w[3] = _ + n + g - m,
            w[4] = A + a + p - y,
            w[5] = v + u + f - S,
            w[6] = _ + n - g + m,
            w[7] = A + a - p + y,
            w[8] = v + u - f + S,
            w[9] = _ + n - g - m,
            w[10] = A + a - p - y,
            w[11] = v + u - f - S,
            w[12] = _ - n + g + m,
            w[13] = A - a + p + y,
            w[14] = v - u + f + S,
            w[15] = _ - n + g - m,
            w[16] = A - a + p - y,
            w[17] = v - u + f - S,
            w[18] = _ - n - g + m,
            w[19] = A - a - p + y,
            w[20] = v - u - f + S,
            w[21] = _ - n - g - m,
            w[22] = A - a - p - y,
            w[23] = v - u - f - S;
            var E = e[9] < 0 ? -e[9] : e[9],
            x = e[10] < 0 ? -e[10] : e[10],
            C = e[11] < 0 ? -e[11] : e[11];
            E = e[12] < 0 ? E - e[12] : E + e[12],
            x = e[13] < 0 ? x - e[13] : x + e[13],
            C = e[14] < 0 ? C - e[14] : C + e[14],
            E = e[15] < 0 ? E - e[15] : E + e[15],
            x = e[16] < 0 ? x - e[16] : x + e[16],
            C = e[17] < 0 ? C - e[17] : C + e[17];
            var b = .005;
            this.lastAABB.copy(this.aabb),
            this.aabb.set(this.position.x - E - b, this.position.x + E + b, this.position.y - x - b, this.position.y + x + b, this.position.z - C - b, this.position.z + C + b),
            null != this.proxy && this.proxy.update()
        },
        intersectRay: function (t, e, n, a) {
            var u = [],
            g = [this.halfWidth + 0, this.halfHeight + 0, this.halfDepth + 0],
            p = [-g[0], -g[1], -g[2]],
            f = [-1, -1, -1],
            m = !0,
            y = [t.x, t.y, t.z],
            S = [e.x, e.y, e.z];
            for (let t = 0; t < 3; t++)
                y[t] < p[t] ? (u[t] = p[t], m = !1, 0 != S[t] && (f[t] = (p[t] - y[t]) / S[t])) : y[t] > g[t] && (u[t] = g[t], m = !1, 0 != S[t] && (f[t] = (g[t] - y[t]) / S[t]));
            if (m)
                return a.hasHit = !0, a.distance = 0, a.intersectionPoint = new Vec3(y[0], y[1], y[2]), a.normal = new Vec3(-S[0], -S[1], -S[2]), !0;
            var _ = 0;
            if (f[1] > f[_] && (_ = 1), f[2] > f[_] && (_ = 2), f[_] > n)
                return !1;
            for (let t = 0; t < 3; t++)
                if (t != _ && (u[t] = y[t] + f[_] * S[t], u[t] < p[t] || u[t] > g[t]))
                    return !1;
            a.hasHit = !0,
            a.distance = f[_],
            a.intersectionPoint = new Vec3(u[0], u[1], u[2]);
            var A = S;
            return A[0] = A[1] = A[2] = 0,
            A[_] = u[_] > 0 ? 1 : -1,
            a.normal = new Vec3(A[0], A[1], A[2]),
            !0
        }
    }),
    Sphere.prototype = Object.assign(Object.create(Shape.prototype), {
        constructor: Sphere,
        volume: function () {
            return g.PI * this.radius * 1.333333
        },
        calculateMassInfo: function (t) {
            var e = this.volume() * this.radius * this.radius * this.density;
            this.mass && (e = this.mass),
            this.mass = e,
            t.mass = e;
            var n = e * this.radius * this.radius * .4;
            t.inertia.set(n, 0, 0, 0, n, 0, 0, 0, n)
        },
        updateProxy: function () {
            var t = .005;
            this.lastAABB.copy(this.aabb),
            this.aabb.set(this.position.x - this.radius - t, this.position.x + this.radius + t, this.position.y - this.radius - t, this.position.y + this.radius + t, this.position.z - this.radius - t, this.position.z + this.radius + t),
            null != this.proxy && this.proxy.update()
        },
        intersectRay: function (t, e, n, a) {
            var u = this.radius,
            g = a.temp,
            p = this.position;
            g.copy(t).subEqual(p);
            var f = g.dot(e),
            m = g.dot(g) - u * u;
            if (!(m > 0 && f > 0)) {
                var y = f * f - m;
                if (!(y < 0)) {
                    var S = -f - Math.sqrt(y);
                    S < 0 && (S = 0),
                    a.hasHit = !0,
                    a.distance = S;
                    var _ = new Vec3;
                    _.copy(e).scaleEqual(S).addEqual(t),
                    a.intersectionPoint = _
                }
            }
        }
    }),
    Cylinder.prototype = Object.assign(Object.create(Shape.prototype), {
        constructor: Cylinder,
        calculateMassInfo: function (t) {
            var e = this.radius * this.radius,
            n = g.PI * e * this.height * this.density;
            this.mass && (n = this.mass),
            this.mass = n;
            var a = (.25 * e + .0833 * this.height * this.height) * n,
            u = .5 * e;
            t.mass = n,
            t.inertia.set(a, 0, 0, 0, u, 0, 0, 0, a)
        },
        updateProxy: function () {
            var t,
            e,
            n,
            a,
            u,
            p,
            f,
            m,
            y,
            S,
            _,
            A = this.rotation.elements;
            u = A[1] * A[1],
            p = A[4] * A[4],
            f = A[7] * A[7],
            this.normalDirection.set(A[1], A[4], A[7]),
            this.halfDirection.scale(this.normalDirection, this.halfHeight),
            e = 1 - u,
            (t = g.sqrt(e * e + u * p + u * f)) > 0 && (t = this.radius / t),
            e *= t,
            n = 1 - p,
            (t = g.sqrt(p * u + n * n + p * f)) > 0 && (t = this.radius / t),
            n *= t,
            a = 1 - f,
            (t = g.sqrt(f * u + f * p + a * a)) > 0 && (t = this.radius / t),
            a *= t,
            m = this.halfDirection.x < 0 ? -this.halfDirection.x : this.halfDirection.x,
            y = this.halfDirection.y < 0 ? -this.halfDirection.y : this.halfDirection.y,
            S = this.halfDirection.z < 0 ? -this.halfDirection.z : this.halfDirection.z,
            m = e < 0 ? m - e : m + e,
            y = n < 0 ? y - n : y + n,
            S = a < 0 ? S - a : S + a,
            _ = .005,
            this.lastAABB.copy(this.aabb),
            this.aabb.set(this.position.x - m - _, this.position.x + m + _, this.position.y - y - _, this.position.y + y + _, this.position.z - S - _, this.position.z + S + _),
            null != this.proxy && this.proxy.update()
        },
        intersectRay: function (t, e, n, a) {
            var u = [],
            g = [this.halfWidth + 0, this.halfHeight + 0, this.halfDepth + 0],
            p = [-g[0], -g[1], -g[2]],
            f = [-1, -1, -1],
            m = !0,
            y = [t.x, t.y, t.z],
            S = [e.x, e.y, e.z];
            for (let t = 0; t < 3; t++)
                y[t] < p[t] ? (u[t] = p[t], m = !1, 0 != S[t] && (f[t] = (p[t] - y[t]) / S[t])) : y[t] > g[t] && (u[t] = g[t], m = !1, 0 != S[t] && (f[t] = (g[t] - y[t]) / S[t]));
            if (m)
                return a.hasHit = !0, a.distance = 0, a.intersectionPoint = new Vec3(y[0], y[1], y[2]), a.normal = new Vec3(-S[0], -S[1], -S[2]), !0;
            var _ = 0;
            if (f[1] > f[_] && (_ = 1), f[2] > f[_] && (_ = 2), f[_] > n)
                return !1;
            for (let t = 0; t < 3; t++)
                if (t != _ && (u[t] = y[t] + f[_] * S[t], u[t] < p[t] || u[t] > g[t]))
                    return !1;
            a.hasHit = !0,
            a.distance = f[_],
            a.intersectionPoint = new Vec3(u[0], u[1], u[2]);
            var A = S;
            return A[0] = A[1] = A[2] = 0,
            A[_] = u[_] > 0 ? 1 : -1,
            a.normal = new Vec3(A[0], A[1], A[2]),
            !0
        }
    }),
    Plane.prototype = Object.assign(Object.create(Shape.prototype), {
        constructor: Plane,
        volume: function () {
            return Number.MAX_VALUE
        },
        calculateMassInfo: function (t) {
            t.mass = this.density;
            t.inertia.set(1, 0, 0, 0, 1, 0, 0, 0, 1)
        },
        updateProxy: function () {
            var t = .005,
            e = -g.INF,
            n = g.INF,
            a = this.normal;
            this.lastAABB.copy(this.aabb),
            this.aabb.set(-1 === a.x ? this.position.x - t : e, 1 === a.x ? this.position.x + t : n, -1 === a.y ? this.position.y - t : e, 1 === a.y ? this.position.y + t : n, -1 === a.z ? this.position.z - t : e, 1 === a.z ? this.position.z + t : n),
            null != this.proxy && this.proxy.update()
        }
    }),
    Particle.prototype = Object.assign(Object.create(Shape.prototype), {
        constructor: Particle,
        volume: function () {
            return Number.MAX_VALUE
        },
        calculateMassInfo: function (t) {
            t.inertia.set(0, 0, 0, 0, 0, 0, 0, 0, 0)
        },
        updateProxy: function () {
            this.lastAABB.copy(this.aabb),
            this.aabb.set(this.position.x - 0, this.position.x + 0, this.position.y - 0, this.position.y + 0, this.position.z - 0, this.position.z + 0),
            null != this.proxy && this.proxy.update()
        }
    }),
    Object.assign(LimitMotor.prototype, {
        LimitMotor: !0,
        setLimit: function (t, e) {
            this.lowerLimit = t,
            this.upperLimit = e
        },
        setMotor: function (t, e) {
            this.motorSpeed = t,
            this.maxMotorForce = e
        },
        setSpring: function (t, e) {
            this.frequency = t,
            this.dampingRatio = e
        }
    }),
    Object.assign(Constraint.prototype, {
        Constraint: !0,
        preSolve: function (t, e) {
            printError("Constraint", "Inheritance error.")
        },
        solve: function () {
            printError("Constraint", "Inheritance error.")
        },
        postSolve: function () {
            printError("Constraint", "Inheritance error.")
        }
    }),
    Joint.prototype = Object.assign(Object.create(Constraint.prototype), {
        constructor: Joint,
        setId: function (t) {
            this.id = i
        },
        setParent: function (t) {
            this.parent = t,
            this.scale = this.parent.scale,
            this.invScale = this.parent.invScale,
            this.id = this.parent.numJoints,
            this.name || (this.name = "J" + this.id)
        },
        updateAnchorPoints: function () {
            this.relativeAnchorPoint1.copy(this.localAnchorPoint1).applyMatrix3(this.body1.rotation, !0),
            this.relativeAnchorPoint2.copy(this.localAnchorPoint2).applyMatrix3(this.body2.rotation, !0),
            this.anchorPoint1.add(this.relativeAnchorPoint1, this.body1.position),
            this.anchorPoint2.add(this.relativeAnchorPoint2, this.body2.position)
        },
        attach: function (t) {
            this.b1Link.body = this.body2,
            this.b2Link.body = this.body1,
            t ? (this.body1.jointLink.push(this.b1Link), this.body2.jointLink.push(this.b2Link)) : (null != this.body1.jointLink ? (this.b1Link.next = this.body1.jointLink).prev = this.b1Link : this.b1Link.next = null, this.body1.jointLink = this.b1Link, this.body1.numJoints++, null != this.body2.jointLink ? (this.b2Link.next = this.body2.jointLink).prev = this.b2Link : this.b2Link.next = null, this.body2.jointLink = this.b2Link, this.body2.numJoints++)
        },
        detach: function (t) {
            if (t)
                this.body1.jointLink.splice(this.body1.jointLink.indexOf(this.b1Link), 1), this.body2.jointLink.splice(this.body2.jointLink.indexOf(this.b2Link), 1);
            else {
                var e = this.b1Link.prev,
                n = this.b1Link.next;
                null != e && (e.next = n),
                null != n && (n.prev = e),
                this.body1.jointLink == this.b1Link && (this.body1.jointLink = n),
                this.b1Link.prev = null,
                this.b1Link.next = null,
                this.b1Link.body = null,
                this.body1.numJoints--,
                e = this.b2Link.prev,
                n = this.b2Link.next,
                null != e && (e.next = n),
                null != n && (n.prev = e),
                this.body2.jointLink == this.b2Link && (this.body2.jointLink = n),
                this.b2Link.prev = null,
                this.b2Link.next = null,
                this.b2Link.body = null,
                this.body2.numJoints--
            }
            this.b1Link.body = null,
            this.b2Link.body = null
        },
        awake: function () {
            this.body1.awake(),
            this.body2.awake()
        },
        preSolve: function (t, e) {},
        solve: function () {},
        postSolve: function () {},
        remove: function () {
            this.dispose()
        },
        dispose: function () {
            this.parent.removeJoint(this)
        },
        getPosition: function () {
            return [(new Vec3).scale(this.anchorPoint1, this.scale), (new Vec3).scale(this.anchorPoint2, this.scale)]
        }
    }),
    Object.assign(LinearConstraint.prototype, {
        LinearConstraint: !0,
        preSolve: function (t, e) {
            this.r1x = this.r1.x,
            this.r1y = this.r1.y,
            this.r1z = this.r1.z,
            this.r2x = this.r2.x,
            this.r2y = this.r2.y,
            this.r2z = this.r2.z,
            this.m1 = this.b1.inverseMass,
            this.m2 = this.b2.inverseMass,
            this.ii1 = this.i1.clone(),
            this.ii2 = this.i2.clone();
            var n = this.ii1.elements,
            a = this.ii2.elements;
            this.ax1x = this.r1z * n[1] + -this.r1y * n[2],
            this.ax1y = this.r1z * n[4] + -this.r1y * n[5],
            this.ax1z = this.r1z * n[7] + -this.r1y * n[8],
            this.ay1x = -this.r1z * n[0] + this.r1x * n[2],
            this.ay1y = -this.r1z * n[3] + this.r1x * n[5],
            this.ay1z = -this.r1z * n[6] + this.r1x * n[8],
            this.az1x = this.r1y * n[0] + -this.r1x * n[1],
            this.az1y = this.r1y * n[3] + -this.r1x * n[4],
            this.az1z = this.r1y * n[6] + -this.r1x * n[7],
            this.ax2x = this.r2z * a[1] + -this.r2y * a[2],
            this.ax2y = this.r2z * a[4] + -this.r2y * a[5],
            this.ax2z = this.r2z * a[7] + -this.r2y * a[8],
            this.ay2x = -this.r2z * a[0] + this.r2x * a[2],
            this.ay2y = -this.r2z * a[3] + this.r2x * a[5],
            this.ay2z = -this.r2z * a[6] + this.r2x * a[8],
            this.az2x = this.r2y * a[0] + -this.r2x * a[1],
            this.az2y = this.r2y * a[3] + -this.r2x * a[4],
            this.az2z = this.r2y * a[6] + -this.r2x * a[7];
            var u = this.m1 + this.m2,
            p = (new Mat33).set(u, 0, 0, 0, u, 0, 0, 0, u).elements;
            p[0] += n[4] * this.r1z * this.r1z - (n[7] + n[5]) * this.r1y * this.r1z + n[8] * this.r1y * this.r1y,
            p[1] += (n[6] * this.r1y + n[5] * this.r1x) * this.r1z - n[3] * this.r1z * this.r1z - n[8] * this.r1x * this.r1y,
            p[2] += (n[3] * this.r1y - n[4] * this.r1x) * this.r1z - n[6] * this.r1y * this.r1y + n[7] * this.r1x * this.r1y,
            p[3] += (n[2] * this.r1y + n[7] * this.r1x) * this.r1z - n[1] * this.r1z * this.r1z - n[8] * this.r1x * this.r1y,
            p[4] += n[0] * this.r1z * this.r1z - (n[6] + n[2]) * this.r1x * this.r1z + n[8] * this.r1x * this.r1x,
            p[5] += (n[1] * this.r1x - n[0] * this.r1y) * this.r1z - n[7] * this.r1x * this.r1x + n[6] * this.r1x * this.r1y,
            p[6] += (n[1] * this.r1y - n[4] * this.r1x) * this.r1z - n[2] * this.r1y * this.r1y + n[5] * this.r1x * this.r1y,
            p[7] += (n[3] * this.r1x - n[0] * this.r1y) * this.r1z - n[5] * this.r1x * this.r1x + n[2] * this.r1x * this.r1y,
            p[8] += n[0] * this.r1y * this.r1y - (n[3] + n[1]) * this.r1x * this.r1y + n[4] * this.r1x * this.r1x,
            p[0] += a[4] * this.r2z * this.r2z - (a[7] + a[5]) * this.r2y * this.r2z + a[8] * this.r2y * this.r2y,
            p[1] += (a[6] * this.r2y + a[5] * this.r2x) * this.r2z - a[3] * this.r2z * this.r2z - a[8] * this.r2x * this.r2y,
            p[2] += (a[3] * this.r2y - a[4] * this.r2x) * this.r2z - a[6] * this.r2y * this.r2y + a[7] * this.r2x * this.r2y,
            p[3] += (a[2] * this.r2y + a[7] * this.r2x) * this.r2z - a[1] * this.r2z * this.r2z - a[8] * this.r2x * this.r2y,
            p[4] += a[0] * this.r2z * this.r2z - (a[6] + a[2]) * this.r2x * this.r2z + a[8] * this.r2x * this.r2x,
            p[5] += (a[1] * this.r2x - a[0] * this.r2y) * this.r2z - a[7] * this.r2x * this.r2x + a[6] * this.r2x * this.r2y,
            p[6] += (a[1] * this.r2y - a[4] * this.r2x) * this.r2z - a[2] * this.r2y * this.r2y + a[5] * this.r2x * this.r2y,
            p[7] += (a[3] * this.r2x - a[0] * this.r2y) * this.r2z - a[5] * this.r2x * this.r2x + a[2] * this.r2x * this.r2y,
            p[8] += a[0] * this.r2y * this.r2y - (a[3] + a[1]) * this.r2x * this.r2y + a[4] * this.r2x * this.r2x;
            var f = 1 / (p[0] * (p[4] * p[8] - p[7] * p[5]) + p[3] * (p[7] * p[2] - p[1] * p[8]) + p[6] * (p[1] * p[5] - p[4] * p[2]));
            this.dd = (new Mat33).set(p[4] * p[8] - p[5] * p[7], p[2] * p[7] - p[1] * p[8], p[1] * p[5] - p[2] * p[4], p[5] * p[6] - p[3] * p[8], p[0] * p[8] - p[2] * p[6], p[2] * p[3] - p[0] * p[5], p[3] * p[7] - p[4] * p[6], p[1] * p[6] - p[0] * p[7], p[0] * p[4] - p[1] * p[3]).scaleEqual(f),
            this.velx = this.p2.x - this.p1.x,
            this.vely = this.p2.y - this.p1.y,
            this.velz = this.p2.z - this.p1.z;
            var m = g.sqrt(this.velx * this.velx + this.vely * this.vely + this.velz * this.velz);
            m > .005 ? (m = (.005 - m) / m * e * .05, this.velx *= m, this.vely *= m, this.velz *= m) : (this.velx = 0, this.vely = 0, this.velz = 0),
            this.impx *= .95,
            this.impy *= .95,
            this.impz *= .95,
            this.l1.x += this.impx * this.m1,
            this.l1.y += this.impy * this.m1,
            this.l1.z += this.impz * this.m1,
            this.a1.x += this.impx * this.ax1x + this.impy * this.ay1x + this.impz * this.az1x,
            this.a1.y += this.impx * this.ax1y + this.impy * this.ay1y + this.impz * this.az1y,
            this.a1.z += this.impx * this.ax1z + this.impy * this.ay1z + this.impz * this.az1z,
            this.l2.x -= this.impx * this.m2,
            this.l2.y -= this.impy * this.m2,
            this.l2.z -= this.impz * this.m2,
            this.a2.x -= this.impx * this.ax2x + this.impy * this.ay2x + this.impz * this.az2x,
            this.a2.y -= this.impx * this.ax2y + this.impy * this.ay2y + this.impz * this.az2y,
            this.a2.z -= this.impx * this.ax2z + this.impy * this.ay2z + this.impz * this.az2z
        },
        solve: function () {
            var t = this.dd.elements,
            e = this.l2.x - this.l1.x + this.a2.y * this.r2z - this.a2.z * this.r2y - this.a1.y * this.r1z + this.a1.z * this.r1y - this.velx,
            n = this.l2.y - this.l1.y + this.a2.z * this.r2x - this.a2.x * this.r2z - this.a1.z * this.r1x + this.a1.x * this.r1z - this.vely,
            a = this.l2.z - this.l1.z + this.a2.x * this.r2y - this.a2.y * this.r2x - this.a1.x * this.r1y + this.a1.y * this.r1x - this.velz,
            u = e * t[0] + n * t[1] + a * t[2],
            g = e * t[3] + n * t[4] + a * t[5],
            p = e * t[6] + n * t[7] + a * t[8];
            this.impx += u,
            this.impy += g,
            this.impz += p,
            this.l1.x += u * this.m1,
            this.l1.y += g * this.m1,
            this.l1.z += p * this.m1,
            this.a1.x += u * this.ax1x + g * this.ay1x + p * this.az1x,
            this.a1.y += u * this.ax1y + g * this.ay1y + p * this.az1y,
            this.a1.z += u * this.ax1z + g * this.ay1z + p * this.az1z,
            this.l2.x -= u * this.m2,
            this.l2.y -= g * this.m2,
            this.l2.z -= p * this.m2,
            this.a2.x -= u * this.ax2x + g * this.ay2x + p * this.az2x,
            this.a2.y -= u * this.ax2y + g * this.ay2y + p * this.az2y,
            this.a2.z -= u * this.ax2z + g * this.ay2z + p * this.az2z
        }
    }),
    Object.assign(Rotational3Constraint.prototype, {
        Rotational3Constraint: !0,
        preSolve: function (t, e) {
            this.ax1 = this.limitMotor1.axis.x,
            this.ay1 = this.limitMotor1.axis.y,
            this.az1 = this.limitMotor1.axis.z,
            this.ax2 = this.limitMotor2.axis.x,
            this.ay2 = this.limitMotor2.axis.y,
            this.az2 = this.limitMotor2.axis.z,
            this.ax3 = this.limitMotor3.axis.x,
            this.ay3 = this.limitMotor3.axis.y,
            this.az3 = this.limitMotor3.axis.z,
            this.lowerLimit1 = this.limitMotor1.lowerLimit,
            this.upperLimit1 = this.limitMotor1.upperLimit,
            this.motorSpeed1 = this.limitMotor1.motorSpeed,
            this.maxMotorForce1 = this.limitMotor1.maxMotorForce,
            this.enableMotor1 = this.maxMotorForce1 > 0,
            this.lowerLimit2 = this.limitMotor2.lowerLimit,
            this.upperLimit2 = this.limitMotor2.upperLimit,
            this.motorSpeed2 = this.limitMotor2.motorSpeed,
            this.maxMotorForce2 = this.limitMotor2.maxMotorForce,
            this.enableMotor2 = this.maxMotorForce2 > 0,
            this.lowerLimit3 = this.limitMotor3.lowerLimit,
            this.upperLimit3 = this.limitMotor3.upperLimit,
            this.motorSpeed3 = this.limitMotor3.motorSpeed,
            this.maxMotorForce3 = this.limitMotor3.maxMotorForce,
            this.enableMotor3 = this.maxMotorForce3 > 0;
            var n = this.i1.elements,
            a = this.i2.elements;
            this.i1e00 = n[0],
            this.i1e01 = n[1],
            this.i1e02 = n[2],
            this.i1e10 = n[3],
            this.i1e11 = n[4],
            this.i1e12 = n[5],
            this.i1e20 = n[6],
            this.i1e21 = n[7],
            this.i1e22 = n[8],
            this.i2e00 = a[0],
            this.i2e01 = a[1],
            this.i2e02 = a[2],
            this.i2e10 = a[3],
            this.i2e11 = a[4],
            this.i2e12 = a[5],
            this.i2e20 = a[6],
            this.i2e21 = a[7],
            this.i2e22 = a[8];
            var u = this.limitMotor1.frequency,
            g = this.limitMotor2.frequency,
            p = this.limitMotor3.frequency,
            f = u > 0,
            m = g > 0,
            y = p > 0,
            S = this.lowerLimit1 <= this.upperLimit1,
            _ = this.lowerLimit2 <= this.upperLimit2,
            A = this.lowerLimit3 <= this.upperLimit3,
            v = this.limitMotor1.angle;
            S ? (this.lowerLimit1 == this.upperLimit1 ? (0 != this.limitState1 && (this.limitState1 = 0, this.limitImpulse1 = 0), this.limitVelocity1 = this.lowerLimit1 - v) : v < this.lowerLimit1 ? (-1 != this.limitState1 && (this.limitState1 = -1, this.limitImpulse1 = 0), this.limitVelocity1 = this.lowerLimit1 - v) : v > this.upperLimit1 ? (1 != this.limitState1 && (this.limitState1 = 1, this.limitImpulse1 = 0), this.limitVelocity1 = this.upperLimit1 - v) : (this.limitState1 = 2, this.limitImpulse1 = 0, this.limitVelocity1 = 0), f || (this.limitVelocity1 > .02 ? this.limitVelocity1 -= .02 : this.limitVelocity1 <  - .02 ? this.limitVelocity1 += .02 : this.limitVelocity1 = 0)) : (this.limitState1 = 2, this.limitImpulse1 = 0);
            var w = this.limitMotor2.angle;
            _ ? (this.lowerLimit2 == this.upperLimit2 ? (0 != this.limitState2 && (this.limitState2 = 0, this.limitImpulse2 = 0), this.limitVelocity2 = this.lowerLimit2 - w) : w < this.lowerLimit2 ? (-1 != this.limitState2 && (this.limitState2 = -1, this.limitImpulse2 = 0), this.limitVelocity2 = this.lowerLimit2 - w) : w > this.upperLimit2 ? (1 != this.limitState2 && (this.limitState2 = 1, this.limitImpulse2 = 0), this.limitVelocity2 = this.upperLimit2 - w) : (this.limitState2 = 2, this.limitImpulse2 = 0, this.limitVelocity2 = 0), m || (this.limitVelocity2 > .02 ? this.limitVelocity2 -= .02 : this.limitVelocity2 <  - .02 ? this.limitVelocity2 += .02 : this.limitVelocity2 = 0)) : (this.limitState2 = 2, this.limitImpulse2 = 0);
            var E = this.limitMotor3.angle;
            if (A ? (this.lowerLimit3 == this.upperLimit3 ? (0 != this.limitState3 && (this.limitState3 = 0, this.limitImpulse3 = 0), this.limitVelocity3 = this.lowerLimit3 - E) : E < this.lowerLimit3 ? (-1 != this.limitState3 && (this.limitState3 = -1, this.limitImpulse3 = 0), this.limitVelocity3 = this.lowerLimit3 - E) : E > this.upperLimit3 ? (1 != this.limitState3 && (this.limitState3 = 1, this.limitImpulse3 = 0), this.limitVelocity3 = this.upperLimit3 - E) : (this.limitState3 = 2, this.limitImpulse3 = 0, this.limitVelocity3 = 0), y || (this.limitVelocity3 > .02 ? this.limitVelocity3 -= .02 : this.limitVelocity3 <  - .02 ? this.limitVelocity3 += .02 : this.limitVelocity3 = 0)) : (this.limitState3 = 2, this.limitImpulse3 = 0), this.enableMotor1 && (0 != this.limitState1 || f) ? this.maxMotorImpulse1 = this.maxMotorForce1 * t : (this.motorImpulse1 = 0, this.maxMotorImpulse1 = 0), this.enableMotor2 && (0 != this.limitState2 || m) ? this.maxMotorImpulse2 = this.maxMotorForce2 * t : (this.motorImpulse2 = 0, this.maxMotorImpulse2 = 0), this.enableMotor3 && (0 != this.limitState3 || y) ? this.maxMotorImpulse3 = this.maxMotorForce3 * t : (this.motorImpulse3 = 0, this.maxMotorImpulse3 = 0), this.a1x1 = this.ax1 * this.i1e00 + this.ay1 * this.i1e01 + this.az1 * this.i1e02, this.a1y1 = this.ax1 * this.i1e10 + this.ay1 * this.i1e11 + this.az1 * this.i1e12, this.a1z1 = this.ax1 * this.i1e20 + this.ay1 * this.i1e21 + this.az1 * this.i1e22, this.a2x1 = this.ax1 * this.i2e00 + this.ay1 * this.i2e01 + this.az1 * this.i2e02, this.a2y1 = this.ax1 * this.i2e10 + this.ay1 * this.i2e11 + this.az1 * this.i2e12, this.a2z1 = this.ax1 * this.i2e20 + this.ay1 * this.i2e21 + this.az1 * this.i2e22, this.a1x2 = this.ax2 * this.i1e00 + this.ay2 * this.i1e01 + this.az2 * this.i1e02, this.a1y2 = this.ax2 * this.i1e10 + this.ay2 * this.i1e11 + this.az2 * this.i1e12, this.a1z2 = this.ax2 * this.i1e20 + this.ay2 * this.i1e21 + this.az2 * this.i1e22, this.a2x2 = this.ax2 * this.i2e00 + this.ay2 * this.i2e01 + this.az2 * this.i2e02, this.a2y2 = this.ax2 * this.i2e10 + this.ay2 * this.i2e11 + this.az2 * this.i2e12, this.a2z2 = this.ax2 * this.i2e20 + this.ay2 * this.i2e21 + this.az2 * this.i2e22, this.a1x3 = this.ax3 * this.i1e00 + this.ay3 * this.i1e01 + this.az3 * this.i1e02, this.a1y3 = this.ax3 * this.i1e10 + this.ay3 * this.i1e11 + this.az3 * this.i1e12, this.a1z3 = this.ax3 * this.i1e20 + this.ay3 * this.i1e21 + this.az3 * this.i1e22, this.a2x3 = this.ax3 * this.i2e00 + this.ay3 * this.i2e01 + this.az3 * this.i2e02, this.a2y3 = this.ax3 * this.i2e10 + this.ay3 * this.i2e11 + this.az3 * this.i2e12, this.a2z3 = this.ax3 * this.i2e20 + this.ay3 * this.i2e21 + this.az3 * this.i2e22, this.k00 = this.ax1 * (this.a1x1 + this.a2x1) + this.ay1 * (this.a1y1 + this.a2y1) + this.az1 * (this.a1z1 + this.a2z1), this.k01 = this.ax1 * (this.a1x2 + this.a2x2) + this.ay1 * (this.a1y2 + this.a2y2) + this.az1 * (this.a1z2 + this.a2z2), this.k02 = this.ax1 * (this.a1x3 + this.a2x3) + this.ay1 * (this.a1y3 + this.a2y3) + this.az1 * (this.a1z3 + this.a2z3), this.k10 = this.ax2 * (this.a1x1 + this.a2x1) + this.ay2 * (this.a1y1 + this.a2y1) + this.az2 * (this.a1z1 + this.a2z1), this.k11 = this.ax2 * (this.a1x2 + this.a2x2) + this.ay2 * (this.a1y2 + this.a2y2) + this.az2 * (this.a1z2 + this.a2z2), this.k12 = this.ax2 * (this.a1x3 + this.a2x3) + this.ay2 * (this.a1y3 + this.a2y3) + this.az2 * (this.a1z3 + this.a2z3), this.k20 = this.ax3 * (this.a1x1 + this.a2x1) + this.ay3 * (this.a1y1 + this.a2y1) + this.az3 * (this.a1z1 + this.a2z1), this.k21 = this.ax3 * (this.a1x2 + this.a2x2) + this.ay3 * (this.a1y2 + this.a2y2) + this.az3 * (this.a1z2 + this.a2z2), this.k22 = this.ax3 * (this.a1x3 + this.a2x3) + this.ay3 * (this.a1y3 + this.a2y3) + this.az3 * (this.a1z3 + this.a2z3), this.kv00 = this.k00, this.kv11 = this.k11, this.kv22 = this.k22, this.dv00 = 1 / this.kv00, this.dv11 = 1 / this.kv11, this.dv22 = 1 / this.kv22, f && 2 != this.limitState1) {
                var x = 6.2831853 * u,
                C = x * x * t,
                b = e / (C + 2 * this.limitMotor1.dampingRatio * x);
                this.cfm1 = this.kv00 * b,
                this.limitVelocity1 *= C * b
            } else
                this.cfm1 = 0, this.limitVelocity1 *= .05 * e;
            m && 2 != this.limitState2 ? (b = e / ((C = (x = 6.2831853 * g) * x * t) + 2 * this.limitMotor2.dampingRatio * x), this.cfm2 = this.kv11 * b, this.limitVelocity2 *= C * b) : (this.cfm2 = 0, this.limitVelocity2 *= .05 * e),
            y && 2 != this.limitState3 ? (b = e / ((C = (x = 6.2831853 * p) * x * t) + 2 * this.limitMotor3.dampingRatio * x), this.cfm3 = this.kv22 * b, this.limitVelocity3 *= C * b) : (this.cfm3 = 0, this.limitVelocity3 *= .05 * e),
            this.k00 += this.cfm1,
            this.k11 += this.cfm2,
            this.k22 += this.cfm3;
            var R = 1 / (this.k00 * (this.k11 * this.k22 - this.k21 * this.k12) + this.k10 * (this.k21 * this.k02 - this.k01 * this.k22) + this.k20 * (this.k01 * this.k12 - this.k11 * this.k02));
            this.d00 = (this.k11 * this.k22 - this.k12 * this.k21) * R,
            this.d01 = (this.k02 * this.k21 - this.k01 * this.k22) * R,
            this.d02 = (this.k01 * this.k12 - this.k02 * this.k11) * R,
            this.d10 = (this.k12 * this.k20 - this.k10 * this.k22) * R,
            this.d11 = (this.k00 * this.k22 - this.k02 * this.k20) * R,
            this.d12 = (this.k02 * this.k10 - this.k00 * this.k12) * R,
            this.d20 = (this.k10 * this.k21 - this.k11 * this.k20) * R,
            this.d21 = (this.k01 * this.k20 - this.k00 * this.k21) * R,
            this.d22 = (this.k00 * this.k11 - this.k01 * this.k10) * R,
            this.limitImpulse1 *= .95,
            this.motorImpulse1 *= .95,
            this.limitImpulse2 *= .95,
            this.motorImpulse2 *= .95,
            this.limitImpulse3 *= .95,
            this.motorImpulse3 *= .95;
            var k = this.limitImpulse1 + this.motorImpulse1,
            B = this.limitImpulse2 + this.motorImpulse2,
            V = this.limitImpulse3 + this.motorImpulse3;
            this.a1.x += k * this.a1x1 + B * this.a1x2 + V * this.a1x3,
            this.a1.y += k * this.a1y1 + B * this.a1y2 + V * this.a1y3,
            this.a1.z += k * this.a1z1 + B * this.a1z2 + V * this.a1z3,
            this.a2.x -= k * this.a2x1 + B * this.a2x2 + V * this.a2x3,
            this.a2.y -= k * this.a2y1 + B * this.a2y2 + V * this.a2y3,
            this.a2.z -= k * this.a2z1 + B * this.a2z2 + V * this.a2z3
        },
        solve_: function () {
            var t = this.a2.x - this.a1.x,
            e = this.a2.y - this.a1.y,
            n = this.a2.z - this.a1.z;
            this.limitVelocity3 = 30;
            var a = t * this.ax1 + e * this.ay1 + n * this.az1 - this.limitVelocity1,
            u = t * this.ax2 + e * this.ay2 + n * this.az2 - this.limitVelocity2,
            g = t * this.ax3 + e * this.ay3 + n * this.az3 - this.limitVelocity3,
            p = a * this.d00 + u * this.d01 + g * this.d02,
            f = a * this.d10 + u * this.d11 + g * this.d12,
            m = a * this.d20 + u * this.d21 + g * this.d22;
            this.limitImpulse1 += p,
            this.limitImpulse2 += f,
            this.limitImpulse3 += m,
            this.a1.x += p * this.a1x1 + f * this.a1x2 + m * this.a1x3,
            this.a1.y += p * this.a1y1 + f * this.a1y2 + m * this.a1y3,
            this.a1.z += p * this.a1z1 + f * this.a1z2 + m * this.a1z3,
            this.a2.x -= p * this.a2x1 + f * this.a2x2 + m * this.a2x3,
            this.a2.y -= p * this.a2y1 + f * this.a2y2 + m * this.a2y3,
            this.a2.z -= p * this.a2z1 + f * this.a2z2 + m * this.a2z3
        },
        solve: function () {
            var t = this.a2.x - this.a1.x,
            e = this.a2.y - this.a1.y,
            n = this.a2.z - this.a1.z,
            a = t * this.ax1 + e * this.ay1 + n * this.az1,
            u = t * this.ax2 + e * this.ay2 + n * this.az2,
            g = t * this.ax3 + e * this.ay3 + n * this.az3,
            p = this.motorImpulse1,
            f = this.motorImpulse2,
            m = this.motorImpulse3,
            y = 0,
            S = 0,
            _ = 0;
            this.enableMotor1 && (y = (a - this.motorSpeed1) * this.dv00, this.motorImpulse1 += y, this.motorImpulse1 > this.maxMotorImpulse1 ? this.motorImpulse1 = this.maxMotorImpulse1 : this.motorImpulse1 < -this.maxMotorImpulse1 && (this.motorImpulse1 = -this.maxMotorImpulse1), y = this.motorImpulse1 - p),
            this.enableMotor2 && (S = (u - this.motorSpeed2) * this.dv11, this.motorImpulse2 += S, this.motorImpulse2 > this.maxMotorImpulse2 ? this.motorImpulse2 = this.maxMotorImpulse2 : this.motorImpulse2 < -this.maxMotorImpulse2 && (this.motorImpulse2 = -this.maxMotorImpulse2), S = this.motorImpulse2 - f),
            this.enableMotor3 && (_ = (g - this.motorSpeed3) * this.dv22, this.motorImpulse3 += _, this.motorImpulse3 > this.maxMotorImpulse3 ? this.motorImpulse3 = this.maxMotorImpulse3 : this.motorImpulse3 < -this.maxMotorImpulse3 && (this.motorImpulse3 = -this.maxMotorImpulse3), _ = this.motorImpulse3 - m),
            a += y * this.kv00 + S * this.k01 + _ * this.k02,
            u += y * this.k10 + S * this.kv11 + _ * this.k12,
            g += y * this.k20 + S * this.k21 + _ * this.kv22,
            a -= this.limitVelocity1 + this.limitImpulse1 * this.cfm1,
            u -= this.limitVelocity2 + this.limitImpulse2 * this.cfm2,
            g -= this.limitVelocity3 + this.limitImpulse3 * this.cfm3;
            var A = this.limitImpulse1,
            v = this.limitImpulse2,
            w = this.limitImpulse3,
            E = a * this.d00 + u * this.d01 + g * this.d02,
            x = a * this.d10 + u * this.d11 + g * this.d12,
            C = a * this.d20 + u * this.d21 + g * this.d22;
            this.limitImpulse1 += E,
            this.limitImpulse2 += x,
            this.limitImpulse3 += C;
            var b,
            R = 0;
            switch ((2 == this.limitState1 || this.limitImpulse1 * this.limitState1 < 0) && (u += (E = -A) * this.k10, g += E * this.k20, R |= 1), (2 == this.limitState2 || this.limitImpulse2 * this.limitState2 < 0) && (a += (x = -v) * this.k01, g += x * this.k21, R |= 2), (2 == this.limitState3 || this.limitImpulse3 * this.limitState3 < 0) && (a += (C = -w) * this.k02, u += C * this.k12, R |= 4), R) {
            case 1:
                b = 1 / (this.k11 * this.k22 - this.k12 * this.k21),
                x = (this.k22 * u + -this.k12 * g) * b,
                C = (-this.k21 * u + this.k11 * g) * b;
                break;
            case 2:
                b = 1 / (this.k00 * this.k22 - this.k02 * this.k20),
                E = (this.k22 * a + -this.k02 * g) * b,
                C = (-this.k20 * a + this.k00 * g) * b;
                break;
            case 3:
                C = g / this.k22;
                break;
            case 4:
                b = 1 / (this.k00 * this.k11 - this.k01 * this.k10),
                E = (this.k11 * a + -this.k01 * u) * b,
                x = (-this.k10 * a + this.k00 * u) * b;
                break;
            case 5:
                x = u / this.k11;
                break;
            case 6:
                E = a / this.k00
            }
            this.limitImpulse1 = E + A,
            this.limitImpulse2 = x + v,
            this.limitImpulse3 = C + w;
            var k = y + E,
            B = S + x,
            V = _ + C;
            this.a1.x += k * this.a1x1 + B * this.a1x2 + V * this.a1x3,
            this.a1.y += k * this.a1y1 + B * this.a1y2 + V * this.a1y3,
            this.a1.z += k * this.a1z1 + B * this.a1z2 + V * this.a1z3,
            this.a2.x -= k * this.a2x1 + B * this.a2x2 + V * this.a2x3,
            this.a2.y -= k * this.a2y1 + B * this.a2y2 + V * this.a2y3,
            this.a2.z -= k * this.a2z1 + B * this.a2z2 + V * this.a2z3,
            t = this.a2.x - this.a1.x,
            e = this.a2.y - this.a1.y,
            n = this.a2.z - this.a1.z,
            u = t * this.ax2 + e * this.ay2 + n * this.az2
        }
    }),
    HingeJoint.prototype = Object.assign(Object.create(Joint.prototype), {
        constructor: HingeJoint,
        preSolve: function (t, e) {
            this.updateAnchorPoints(),
            this.ax1.copy(this.localAxis1).applyMatrix3(this.body1.rotation, !0),
            this.ax2.copy(this.localAxis2).applyMatrix3(this.body2.rotation, !0),
            this.an1.copy(this.localAngle1).applyMatrix3(this.body1.rotation, !0),
            this.an2.copy(this.localAngle2).applyMatrix3(this.body2.rotation, !0),
            this.nor.set(this.ax1.x * this.body2.inverseMass + this.ax2.x * this.body1.inverseMass, this.ax1.y * this.body2.inverseMass + this.ax2.y * this.body1.inverseMass, this.ax1.z * this.body2.inverseMass + this.ax2.z * this.body1.inverseMass).normalize(),
            this.tan.tangent(this.nor).normalize(),
            this.bin.crossVectors(this.nor, this.tan);
            var n = g.acosClamp(g.dotVectors(this.an1, this.an2));
            this.tmp.crossVectors(this.an1, this.an2),
            g.dotVectors(this.nor, this.tmp) < 0 ? this.limitMotor.angle = -n : this.limitMotor.angle = n,
            this.tmp.crossVectors(this.ax1, this.ax2),
            this.r3.limitMotor2.angle = g.dotVectors(this.tan, this.tmp),
            this.r3.limitMotor3.angle = g.dotVectors(this.bin, this.tmp),
            this.r3.preSolve(t, e),
            this.lc.preSolve(t, e)
        },
        solve: function () {
            this.r3.solve(),
            this.lc.solve()
        },
        postSolve: function () {}
    }),
    BallAndSocketJoint.prototype = Object.assign(Object.create(Joint.prototype), {
        constructor: BallAndSocketJoint,
        preSolve: function (t, e) {
            this.updateAnchorPoints(),
            this.lc.preSolve(t, e)
        },
        solve: function () {
            this.lc.solve()
        },
        postSolve: function () {}
    }),
    Object.assign(TranslationalConstraint.prototype, {
        TranslationalConstraint: !0,
        preSolve: function (t, e) {
            this.ax = this.limitMotor.axis.x,
            this.ay = this.limitMotor.axis.y,
            this.az = this.limitMotor.axis.z,
            this.lowerLimit = this.limitMotor.lowerLimit,
            this.upperLimit = this.limitMotor.upperLimit,
            this.motorSpeed = this.limitMotor.motorSpeed,
            this.maxMotorForce = this.limitMotor.maxMotorForce,
            this.enableMotor = this.maxMotorForce > 0,
            this.m1 = this.b1.inverseMass,
            this.m2 = this.b2.inverseMass;
            var n = this.i1.elements,
            a = this.i2.elements;
            this.i1e00 = n[0],
            this.i1e01 = n[1],
            this.i1e02 = n[2],
            this.i1e10 = n[3],
            this.i1e11 = n[4],
            this.i1e12 = n[5],
            this.i1e20 = n[6],
            this.i1e21 = n[7],
            this.i1e22 = n[8],
            this.i2e00 = a[0],
            this.i2e01 = a[1],
            this.i2e02 = a[2],
            this.i2e10 = a[3],
            this.i2e11 = a[4],
            this.i2e12 = a[5],
            this.i2e20 = a[6],
            this.i2e21 = a[7],
            this.i2e22 = a[8];
            var u = this.p2.x - this.p1.x,
            g = this.p2.y - this.p1.y,
            p = this.p2.z - this.p1.z,
            f = u * this.ax + g * this.ay + p * this.az,
            m = this.limitMotor.frequency,
            y = m > 0;
            (y && f > 20 || f < -20) && (y = !1),
            this.lowerLimit <= this.upperLimit ? (this.lowerLimit == this.upperLimit ? (0 != this.limitState && (this.limitState = 0, this.limitImpulse = 0), this.limitVelocity = this.lowerLimit - f, y || (f = this.lowerLimit)) : f < this.lowerLimit ? (-1 != this.limitState && (this.limitState = -1, this.limitImpulse = 0), this.limitVelocity = this.lowerLimit - f, y || (f = this.lowerLimit)) : f > this.upperLimit ? (1 != this.limitState && (this.limitState = 1, this.limitImpulse = 0), this.limitVelocity = this.upperLimit - f, y || (f = this.upperLimit)) : (this.limitState = 2, this.limitImpulse = 0, this.limitVelocity = 0), y || (this.limitVelocity > .005 ? this.limitVelocity -= .005 : this.limitVelocity <  - .005 ? this.limitVelocity += .005 : this.limitVelocity = 0)) : (this.limitState = 2, this.limitImpulse = 0),
            this.enableMotor && (0 != this.limitState || y) ? this.maxMotorImpulse = this.maxMotorForce * t : (this.motorImpulse = 0, this.maxMotorImpulse = 0);
            var S = f * this.ax,
            _ = f * this.ay,
            A = f * this.az,
            v = this.m1 / (this.m1 + this.m2),
            w = 1 - v;
            if (this.r1x = this.r1.x + S * v, this.r1y = this.r1.y + _ * v, this.r1z = this.r1.z + A * v, this.r2x = this.r2.x - S * w, this.r2y = this.r2.y - _ * w, this.r2z = this.r2.z - A * w, this.t1x = this.r1y * this.az - this.r1z * this.ay, this.t1y = this.r1z * this.ax - this.r1x * this.az, this.t1z = this.r1x * this.ay - this.r1y * this.ax, this.t2x = this.r2y * this.az - this.r2z * this.ay, this.t2y = this.r2z * this.ax - this.r2x * this.az, this.t2z = this.r2x * this.ay - this.r2y * this.ax, this.l1x = this.ax * this.m1, this.l1y = this.ay * this.m1, this.l1z = this.az * this.m1, this.l2x = this.ax * this.m2, this.l2y = this.ay * this.m2, this.l2z = this.az * this.m2, this.a1x = this.t1x * this.i1e00 + this.t1y * this.i1e01 + this.t1z * this.i1e02, this.a1y = this.t1x * this.i1e10 + this.t1y * this.i1e11 + this.t1z * this.i1e12, this.a1z = this.t1x * this.i1e20 + this.t1y * this.i1e21 + this.t1z * this.i1e22, this.a2x = this.t2x * this.i2e00 + this.t2y * this.i2e01 + this.t2z * this.i2e02, this.a2y = this.t2x * this.i2e10 + this.t2y * this.i2e11 + this.t2z * this.i2e12, this.a2z = this.t2x * this.i2e20 + this.t2y * this.i2e21 + this.t2z * this.i2e22, this.motorDenom = this.m1 + this.m2 + this.ax * (this.a1y * this.r1z - this.a1z * this.r1y + this.a2y * this.r2z - this.a2z * this.r2y) + this.ay * (this.a1z * this.r1x - this.a1x * this.r1z + this.a2z * this.r2x - this.a2x * this.r2z) + this.az * (this.a1x * this.r1y - this.a1y * this.r1x + this.a2x * this.r2y - this.a2y * this.r2x), this.invMotorDenom = 1 / this.motorDenom, y && 2 != this.limitState) {
                var E = 6.2831853 * m,
                x = E * E * t,
                C = e / (x + 2 * this.limitMotor.dampingRatio * E);
                this.cfm = this.motorDenom * C,
                this.limitVelocity *= x * C
            } else
                this.cfm = 0, this.limitVelocity *= .05 * e;
            this.invDenom = 1 / (this.motorDenom + this.cfm);
            var b = this.limitImpulse + this.motorImpulse;
            this.l1.x += b * this.l1x,
            this.l1.y += b * this.l1y,
            this.l1.z += b * this.l1z,
            this.a1.x += b * this.a1x,
            this.a1.y += b * this.a1y,
            this.a1.z += b * this.a1z,
            this.l2.x -= b * this.l2x,
            this.l2.y -= b * this.l2y,
            this.l2.z -= b * this.l2z,
            this.a2.x -= b * this.a2x,
            this.a2.y -= b * this.a2y,
            this.a2.z -= b * this.a2z
        },
        solve: function () {
            var t,
            e,
            n = this.ax * (this.l2.x - this.l1.x) + this.ay * (this.l2.y - this.l1.y) + this.az * (this.l2.z - this.l1.z) + this.t2x * this.a2.x - this.t1x * this.a1.x + this.t2y * this.a2.y - this.t1y * this.a1.y + this.t2z * this.a2.z - this.t1z * this.a1.z;
            if (this.enableMotor) {
                t = (n - this.motorSpeed) * this.invMotorDenom;
                var a = this.motorImpulse;
                this.motorImpulse += t,
                this.motorImpulse > this.maxMotorImpulse ? this.motorImpulse = this.maxMotorImpulse : this.motorImpulse < -this.maxMotorImpulse && (this.motorImpulse = -this.maxMotorImpulse),
                n -= (t = this.motorImpulse - a) * this.motorDenom
            } else
                t = 0;
            if (2 != this.limitState) {
                e = (n - this.limitVelocity - this.limitImpulse * this.cfm) * this.invDenom;
                var u = this.limitImpulse;
                this.limitImpulse += e,
                this.limitImpulse * this.limitState < 0 && (this.limitImpulse = 0),
                e = this.limitImpulse - u
            } else
                e = 0;
            var g = e + t;
            this.l1.x += g * this.l1x,
            this.l1.y += g * this.l1y,
            this.l1.z += g * this.l1z,
            this.a1.x += g * this.a1x,
            this.a1.y += g * this.a1y,
            this.a1.z += g * this.a1z,
            this.l2.x -= g * this.l2x,
            this.l2.y -= g * this.l2y,
            this.l2.z -= g * this.l2z,
            this.a2.x -= g * this.a2x,
            this.a2.y -= g * this.a2y,
            this.a2.z -= g * this.a2z
        }
    }),
    DistanceJoint.prototype = Object.assign(Object.create(Joint.prototype), {
        constructor: DistanceJoint,
        preSolve: function (t, e) {
            this.updateAnchorPoints(),
            this.nor.sub(this.anchorPoint2, this.anchorPoint1).normalize(),
            this.t.preSolve(t, e)
        },
        solve: function () {
            this.t.solve()
        },
        postSolve: function () {}
    }),
    Object.assign(AngularConstraint.prototype, {
        AngularConstraint: !0,
        preSolve: function (t, e) {
            var n,
            a,
            u;
            this.ii1 = this.i1.clone(),
            this.ii2 = this.i2.clone(),
            n = 1 / ((u = (new Mat33).add(this.ii1, this.ii2).elements)[0] * (u[4] * u[8] - u[7] * u[5]) + u[3] * (u[7] * u[2] - u[1] * u[8]) + u[6] * (u[1] * u[5] - u[4] * u[2])),
            this.dd = (new Mat33).set(u[4] * u[8] - u[5] * u[7], u[2] * u[7] - u[1] * u[8], u[1] * u[5] - u[2] * u[4], u[5] * u[6] - u[3] * u[8], u[0] * u[8] - u[2] * u[6], u[2] * u[3] - u[0] * u[5], u[3] * u[7] - u[4] * u[6], u[1] * u[6] - u[0] * u[7], u[0] * u[4] - u[1] * u[3]).multiplyScalar(n),
            this.relativeOrientation.invert(this.b1.orientation).multiply(this.targetOrientation).multiply(this.b2.orientation),
            n = 2 * this.relativeOrientation.w,
            this.vel.copy(this.relativeOrientation).multiplyScalar(n),
            (a = this.vel.length()) > .02 ? (a = (.02 - a) / a * e * .05, this.vel.multiplyScalar(a)) : this.vel.set(0, 0, 0),
            this.rn1.copy(this.imp).applyMatrix3(this.ii1, !0),
            this.rn2.copy(this.imp).applyMatrix3(this.ii2, !0),
            this.a1.add(this.rn1),
            this.a2.sub(this.rn2)
        },
        solve: function () {
            var t = this.a2.clone().sub(this.a1).sub(this.vel);
            this.rn0.copy(t).applyMatrix3(this.dd, !0),
            this.rn1.copy(this.rn0).applyMatrix3(this.ii1, !0),
            this.rn2.copy(this.rn0).applyMatrix3(this.ii2, !0),
            this.imp.add(this.rn0),
            this.a1.add(this.rn1),
            this.a2.sub(this.rn2)
        }
    }),
    Object.assign(Translational3Constraint.prototype, {
        Translational3Constraint: !0,
        preSolve: function (t, e) {
            this.ax1 = this.limitMotor1.axis.x,
            this.ay1 = this.limitMotor1.axis.y,
            this.az1 = this.limitMotor1.axis.z,
            this.ax2 = this.limitMotor2.axis.x,
            this.ay2 = this.limitMotor2.axis.y,
            this.az2 = this.limitMotor2.axis.z,
            this.ax3 = this.limitMotor3.axis.x,
            this.ay3 = this.limitMotor3.axis.y,
            this.az3 = this.limitMotor3.axis.z,
            this.lowerLimit1 = this.limitMotor1.lowerLimit,
            this.upperLimit1 = this.limitMotor1.upperLimit,
            this.motorSpeed1 = this.limitMotor1.motorSpeed,
            this.maxMotorForce1 = this.limitMotor1.maxMotorForce,
            this.enableMotor1 = this.maxMotorForce1 > 0,
            this.lowerLimit2 = this.limitMotor2.lowerLimit,
            this.upperLimit2 = this.limitMotor2.upperLimit,
            this.motorSpeed2 = this.limitMotor2.motorSpeed,
            this.maxMotorForce2 = this.limitMotor2.maxMotorForce,
            this.enableMotor2 = this.maxMotorForce2 > 0,
            this.lowerLimit3 = this.limitMotor3.lowerLimit,
            this.upperLimit3 = this.limitMotor3.upperLimit,
            this.motorSpeed3 = this.limitMotor3.motorSpeed,
            this.maxMotorForce3 = this.limitMotor3.maxMotorForce,
            this.enableMotor3 = this.maxMotorForce3 > 0,
            this.m1 = this.b1.inverseMass,
            this.m2 = this.b2.inverseMass;
            var n = this.i1.elements,
            a = this.i2.elements;
            this.i1e00 = n[0],
            this.i1e01 = n[1],
            this.i1e02 = n[2],
            this.i1e10 = n[3],
            this.i1e11 = n[4],
            this.i1e12 = n[5],
            this.i1e20 = n[6],
            this.i1e21 = n[7],
            this.i1e22 = n[8],
            this.i2e00 = a[0],
            this.i2e01 = a[1],
            this.i2e02 = a[2],
            this.i2e10 = a[3],
            this.i2e11 = a[4],
            this.i2e12 = a[5],
            this.i2e20 = a[6],
            this.i2e21 = a[7],
            this.i2e22 = a[8];
            var u = this.p2.x - this.p1.x,
            g = this.p2.y - this.p1.y,
            p = this.p2.z - this.p1.z,
            f = u * this.ax1 + g * this.ay1 + p * this.az1,
            m = u * this.ax2 + g * this.ay2 + p * this.az2,
            y = u * this.ax3 + g * this.ay3 + p * this.az3,
            S = this.limitMotor1.frequency,
            _ = this.limitMotor2.frequency,
            A = this.limitMotor3.frequency,
            v = S > 0,
            w = _ > 0,
            E = A > 0,
            x = this.lowerLimit1 <= this.upperLimit1,
            C = this.lowerLimit2 <= this.upperLimit2,
            b = this.lowerLimit3 <= this.upperLimit3;
            (v && f > 20 || f < -20) && (v = !1),
            (w && m > 20 || m < -20) && (w = !1),
            (E && y > 20 || y < -20) && (E = !1),
            x ? (this.lowerLimit1 == this.upperLimit1 ? (0 != this.limitState1 && (this.limitState1 = 0, this.limitImpulse1 = 0), this.limitVelocity1 = this.lowerLimit1 - f, v || (f = this.lowerLimit1)) : f < this.lowerLimit1 ? (-1 != this.limitState1 && (this.limitState1 = -1, this.limitImpulse1 = 0), this.limitVelocity1 = this.lowerLimit1 - f, v || (f = this.lowerLimit1)) : f > this.upperLimit1 ? (1 != this.limitState1 && (this.limitState1 = 1, this.limitImpulse1 = 0), this.limitVelocity1 = this.upperLimit1 - f, v || (f = this.upperLimit1)) : (this.limitState1 = 2, this.limitImpulse1 = 0, this.limitVelocity1 = 0), v || (this.limitVelocity1 > .005 ? this.limitVelocity1 -= .005 : this.limitVelocity1 <  - .005 ? this.limitVelocity1 += .005 : this.limitVelocity1 = 0)) : (this.limitState1 = 2, this.limitImpulse1 = 0),
            C ? (this.lowerLimit2 == this.upperLimit2 ? (0 != this.limitState2 && (this.limitState2 = 0, this.limitImpulse2 = 0), this.limitVelocity2 = this.lowerLimit2 - m, w || (m = this.lowerLimit2)) : m < this.lowerLimit2 ? (-1 != this.limitState2 && (this.limitState2 = -1, this.limitImpulse2 = 0), this.limitVelocity2 = this.lowerLimit2 - m, w || (m = this.lowerLimit2)) : m > this.upperLimit2 ? (1 != this.limitState2 && (this.limitState2 = 1, this.limitImpulse2 = 0), this.limitVelocity2 = this.upperLimit2 - m, w || (m = this.upperLimit2)) : (this.limitState2 = 2, this.limitImpulse2 = 0, this.limitVelocity2 = 0), w || (this.limitVelocity2 > .005 ? this.limitVelocity2 -= .005 : this.limitVelocity2 <  - .005 ? this.limitVelocity2 += .005 : this.limitVelocity2 = 0)) : (this.limitState2 = 2, this.limitImpulse2 = 0),
            b ? (this.lowerLimit3 == this.upperLimit3 ? (0 != this.limitState3 && (this.limitState3 = 0, this.limitImpulse3 = 0), this.limitVelocity3 = this.lowerLimit3 - y, E || (y = this.lowerLimit3)) : y < this.lowerLimit3 ? (-1 != this.limitState3 && (this.limitState3 = -1, this.limitImpulse3 = 0), this.limitVelocity3 = this.lowerLimit3 - y, E || (y = this.lowerLimit3)) : y > this.upperLimit3 ? (1 != this.limitState3 && (this.limitState3 = 1, this.limitImpulse3 = 0), this.limitVelocity3 = this.upperLimit3 - y, E || (y = this.upperLimit3)) : (this.limitState3 = 2, this.limitImpulse3 = 0, this.limitVelocity3 = 0), E || (this.limitVelocity3 > .005 ? this.limitVelocity3 -= .005 : this.limitVelocity3 <  - .005 ? this.limitVelocity3 += .005 : this.limitVelocity3 = 0)) : (this.limitState3 = 2, this.limitImpulse3 = 0),
            this.enableMotor1 && (0 != this.limitState1 || v) ? this.maxMotorImpulse1 = this.maxMotorForce1 * t : (this.motorImpulse1 = 0, this.maxMotorImpulse1 = 0),
            this.enableMotor2 && (0 != this.limitState2 || w) ? this.maxMotorImpulse2 = this.maxMotorForce2 * t : (this.motorImpulse2 = 0, this.maxMotorImpulse2 = 0),
            this.enableMotor3 && (0 != this.limitState3 || E) ? this.maxMotorImpulse3 = this.maxMotorForce3 * t : (this.motorImpulse3 = 0, this.maxMotorImpulse3 = 0);
            var R = f * this.ax1 + m * this.ax2 + y * this.ax2,
            k = f * this.ay1 + m * this.ay2 + y * this.ay2,
            B = f * this.az1 + m * this.az2 + y * this.az2,
            V = this.m2 / (this.m1 + this.m2);
            this.weight >= 0 && (V = this.weight);
            var z = 1 - V;
            this.r1x = this.r1.x + R * V,
            this.r1y = this.r1.y + k * V,
            this.r1z = this.r1.z + B * V,
            this.r2x = this.r2.x - R * z,
            this.r2y = this.r2.y - k * z,
            this.r2z = this.r2.z - B * z,
            this.t1x1 = this.r1y * this.az1 - this.r1z * this.ay1,
            this.t1y1 = this.r1z * this.ax1 - this.r1x * this.az1,
            this.t1z1 = this.r1x * this.ay1 - this.r1y * this.ax1,
            this.t2x1 = this.r2y * this.az1 - this.r2z * this.ay1,
            this.t2y1 = this.r2z * this.ax1 - this.r2x * this.az1,
            this.t2z1 = this.r2x * this.ay1 - this.r2y * this.ax1,
            this.l1x1 = this.ax1 * this.m1,
            this.l1y1 = this.ay1 * this.m1,
            this.l1z1 = this.az1 * this.m1,
            this.l2x1 = this.ax1 * this.m2,
            this.l2y1 = this.ay1 * this.m2,
            this.l2z1 = this.az1 * this.m2,
            this.a1x1 = this.t1x1 * this.i1e00 + this.t1y1 * this.i1e01 + this.t1z1 * this.i1e02,
            this.a1y1 = this.t1x1 * this.i1e10 + this.t1y1 * this.i1e11 + this.t1z1 * this.i1e12,
            this.a1z1 = this.t1x1 * this.i1e20 + this.t1y1 * this.i1e21 + this.t1z1 * this.i1e22,
            this.a2x1 = this.t2x1 * this.i2e00 + this.t2y1 * this.i2e01 + this.t2z1 * this.i2e02,
            this.a2y1 = this.t2x1 * this.i2e10 + this.t2y1 * this.i2e11 + this.t2z1 * this.i2e12,
            this.a2z1 = this.t2x1 * this.i2e20 + this.t2y1 * this.i2e21 + this.t2z1 * this.i2e22,
            this.t1x2 = this.r1y * this.az2 - this.r1z * this.ay2,
            this.t1y2 = this.r1z * this.ax2 - this.r1x * this.az2,
            this.t1z2 = this.r1x * this.ay2 - this.r1y * this.ax2,
            this.t2x2 = this.r2y * this.az2 - this.r2z * this.ay2,
            this.t2y2 = this.r2z * this.ax2 - this.r2x * this.az2,
            this.t2z2 = this.r2x * this.ay2 - this.r2y * this.ax2,
            this.l1x2 = this.ax2 * this.m1,
            this.l1y2 = this.ay2 * this.m1,
            this.l1z2 = this.az2 * this.m1,
            this.l2x2 = this.ax2 * this.m2,
            this.l2y2 = this.ay2 * this.m2,
            this.l2z2 = this.az2 * this.m2,
            this.a1x2 = this.t1x2 * this.i1e00 + this.t1y2 * this.i1e01 + this.t1z2 * this.i1e02,
            this.a1y2 = this.t1x2 * this.i1e10 + this.t1y2 * this.i1e11 + this.t1z2 * this.i1e12,
            this.a1z2 = this.t1x2 * this.i1e20 + this.t1y2 * this.i1e21 + this.t1z2 * this.i1e22,
            this.a2x2 = this.t2x2 * this.i2e00 + this.t2y2 * this.i2e01 + this.t2z2 * this.i2e02,
            this.a2y2 = this.t2x2 * this.i2e10 + this.t2y2 * this.i2e11 + this.t2z2 * this.i2e12,
            this.a2z2 = this.t2x2 * this.i2e20 + this.t2y2 * this.i2e21 + this.t2z2 * this.i2e22,
            this.t1x3 = this.r1y * this.az3 - this.r1z * this.ay3,
            this.t1y3 = this.r1z * this.ax3 - this.r1x * this.az3,
            this.t1z3 = this.r1x * this.ay3 - this.r1y * this.ax3,
            this.t2x3 = this.r2y * this.az3 - this.r2z * this.ay3,
            this.t2y3 = this.r2z * this.ax3 - this.r2x * this.az3,
            this.t2z3 = this.r2x * this.ay3 - this.r2y * this.ax3,
            this.l1x3 = this.ax3 * this.m1,
            this.l1y3 = this.ay3 * this.m1,
            this.l1z3 = this.az3 * this.m1,
            this.l2x3 = this.ax3 * this.m2,
            this.l2y3 = this.ay3 * this.m2,
            this.l2z3 = this.az3 * this.m2,
            this.a1x3 = this.t1x3 * this.i1e00 + this.t1y3 * this.i1e01 + this.t1z3 * this.i1e02,
            this.a1y3 = this.t1x3 * this.i1e10 + this.t1y3 * this.i1e11 + this.t1z3 * this.i1e12,
            this.a1z3 = this.t1x3 * this.i1e20 + this.t1y3 * this.i1e21 + this.t1z3 * this.i1e22,
            this.a2x3 = this.t2x3 * this.i2e00 + this.t2y3 * this.i2e01 + this.t2z3 * this.i2e02,
            this.a2y3 = this.t2x3 * this.i2e10 + this.t2y3 * this.i2e11 + this.t2z3 * this.i2e12,
            this.a2z3 = this.t2x3 * this.i2e20 + this.t2y3 * this.i2e21 + this.t2z3 * this.i2e22;
            var J = this.m1 + this.m2;
            if (this.k00 = (this.ax1 * this.ax1 + this.ay1 * this.ay1 + this.az1 * this.az1) * J, this.k01 = (this.ax1 * this.ax2 + this.ay1 * this.ay2 + this.az1 * this.az2) * J, this.k02 = (this.ax1 * this.ax3 + this.ay1 * this.ay3 + this.az1 * this.az3) * J, this.k10 = (this.ax2 * this.ax1 + this.ay2 * this.ay1 + this.az2 * this.az1) * J, this.k11 = (this.ax2 * this.ax2 + this.ay2 * this.ay2 + this.az2 * this.az2) * J, this.k12 = (this.ax2 * this.ax3 + this.ay2 * this.ay3 + this.az2 * this.az3) * J, this.k20 = (this.ax3 * this.ax1 + this.ay3 * this.ay1 + this.az3 * this.az1) * J, this.k21 = (this.ax3 * this.ax2 + this.ay3 * this.ay2 + this.az3 * this.az2) * J, this.k22 = (this.ax3 * this.ax3 + this.ay3 * this.ay3 + this.az3 * this.az3) * J, this.k00 += this.t1x1 * this.a1x1 + this.t1y1 * this.a1y1 + this.t1z1 * this.a1z1, this.k01 += this.t1x1 * this.a1x2 + this.t1y1 * this.a1y2 + this.t1z1 * this.a1z2, this.k02 += this.t1x1 * this.a1x3 + this.t1y1 * this.a1y3 + this.t1z1 * this.a1z3, this.k10 += this.t1x2 * this.a1x1 + this.t1y2 * this.a1y1 + this.t1z2 * this.a1z1, this.k11 += this.t1x2 * this.a1x2 + this.t1y2 * this.a1y2 + this.t1z2 * this.a1z2, this.k12 += this.t1x2 * this.a1x3 + this.t1y2 * this.a1y3 + this.t1z2 * this.a1z3, this.k20 += this.t1x3 * this.a1x1 + this.t1y3 * this.a1y1 + this.t1z3 * this.a1z1, this.k21 += this.t1x3 * this.a1x2 + this.t1y3 * this.a1y2 + this.t1z3 * this.a1z2, this.k22 += this.t1x3 * this.a1x3 + this.t1y3 * this.a1y3 + this.t1z3 * this.a1z3, this.k00 += this.t2x1 * this.a2x1 + this.t2y1 * this.a2y1 + this.t2z1 * this.a2z1, this.k01 += this.t2x1 * this.a2x2 + this.t2y1 * this.a2y2 + this.t2z1 * this.a2z2, this.k02 += this.t2x1 * this.a2x3 + this.t2y1 * this.a2y3 + this.t2z1 * this.a2z3, this.k10 += this.t2x2 * this.a2x1 + this.t2y2 * this.a2y1 + this.t2z2 * this.a2z1, this.k11 += this.t2x2 * this.a2x2 + this.t2y2 * this.a2y2 + this.t2z2 * this.a2z2, this.k12 += this.t2x2 * this.a2x3 + this.t2y2 * this.a2y3 + this.t2z2 * this.a2z3, this.k20 += this.t2x3 * this.a2x1 + this.t2y3 * this.a2y1 + this.t2z3 * this.a2z1, this.k21 += this.t2x3 * this.a2x2 + this.t2y3 * this.a2y2 + this.t2z3 * this.a2z2, this.k22 += this.t2x3 * this.a2x3 + this.t2y3 * this.a2y3 + this.t2z3 * this.a2z3, this.kv00 = this.k00, this.kv11 = this.k11, this.kv22 = this.k22, this.dv00 = 1 / this.kv00, this.dv11 = 1 / this.kv11, this.dv22 = 1 / this.kv22, v && 2 != this.limitState1) {
                var $ = 6.2831853 * S,
                Z = $ * $ * t,
                tt = e / (Z + 2 * this.limitMotor1.dampingRatio * $);
                this.cfm1 = this.kv00 * tt,
                this.limitVelocity1 *= Z * tt
            } else
                this.cfm1 = 0, this.limitVelocity1 *= .05 * e;
            w && 2 != this.limitState2 ? (tt = e / ((Z = ($ = 6.2831853 * _) * $ * t) + 2 * this.limitMotor2.dampingRatio * $), this.cfm2 = this.kv11 * tt, this.limitVelocity2 *= Z * tt) : (this.cfm2 = 0, this.limitVelocity2 *= .05 * e),
            E && 2 != this.limitState3 ? (tt = e / ((Z = ($ = 6.2831853 * A) * $ * t) + 2 * this.limitMotor3.dampingRatio * $), this.cfm3 = this.kv22 * tt, this.limitVelocity3 *= Z * tt) : (this.cfm3 = 0, this.limitVelocity3 *= .05 * e),
            this.k00 += this.cfm1,
            this.k11 += this.cfm2,
            this.k22 += this.cfm3;
            var et = 1 / (this.k00 * (this.k11 * this.k22 - this.k21 * this.k12) + this.k10 * (this.k21 * this.k02 - this.k01 * this.k22) + this.k20 * (this.k01 * this.k12 - this.k11 * this.k02));
            this.d00 = (this.k11 * this.k22 - this.k12 * this.k21) * et,
            this.d01 = (this.k02 * this.k21 - this.k01 * this.k22) * et,
            this.d02 = (this.k01 * this.k12 - this.k02 * this.k11) * et,
            this.d10 = (this.k12 * this.k20 - this.k10 * this.k22) * et,
            this.d11 = (this.k00 * this.k22 - this.k02 * this.k20) * et,
            this.d12 = (this.k02 * this.k10 - this.k00 * this.k12) * et,
            this.d20 = (this.k10 * this.k21 - this.k11 * this.k20) * et,
            this.d21 = (this.k01 * this.k20 - this.k00 * this.k21) * et,
            this.d22 = (this.k00 * this.k11 - this.k01 * this.k10) * et;
            var it = this.limitImpulse1 + this.motorImpulse1,
            st = this.limitImpulse2 + this.motorImpulse2,
            nt = this.limitImpulse3 + this.motorImpulse3;
            this.l1.x += it * this.l1x1 + st * this.l1x2 + nt * this.l1x3,
            this.l1.y += it * this.l1y1 + st * this.l1y2 + nt * this.l1y3,
            this.l1.z += it * this.l1z1 + st * this.l1z2 + nt * this.l1z3,
            this.a1.x += it * this.a1x1 + st * this.a1x2 + nt * this.a1x3,
            this.a1.y += it * this.a1y1 + st * this.a1y2 + nt * this.a1y3,
            this.a1.z += it * this.a1z1 + st * this.a1z2 + nt * this.a1z3,
            this.l2.x -= it * this.l2x1 + st * this.l2x2 + nt * this.l2x3,
            this.l2.y -= it * this.l2y1 + st * this.l2y2 + nt * this.l2y3,
            this.l2.z -= it * this.l2z1 + st * this.l2z2 + nt * this.l2z3,
            this.a2.x -= it * this.a2x1 + st * this.a2x2 + nt * this.a2x3,
            this.a2.y -= it * this.a2y1 + st * this.a2y2 + nt * this.a2y3,
            this.a2.z -= it * this.a2z1 + st * this.a2z2 + nt * this.a2z3
        },
        solve: function () {
            var t = this.l2.x - this.l1.x + this.a2.y * this.r2z - this.a2.z * this.r2y - this.a1.y * this.r1z + this.a1.z * this.r1y,
            e = this.l2.y - this.l1.y + this.a2.z * this.r2x - this.a2.x * this.r2z - this.a1.z * this.r1x + this.a1.x * this.r1z,
            n = this.l2.z - this.l1.z + this.a2.x * this.r2y - this.a2.y * this.r2x - this.a1.x * this.r1y + this.a1.y * this.r1x,
            a = t * this.ax1 + e * this.ay1 + n * this.az1,
            u = t * this.ax2 + e * this.ay2 + n * this.az2,
            g = t * this.ax3 + e * this.ay3 + n * this.az3,
            p = this.motorImpulse1,
            f = this.motorImpulse2,
            m = this.motorImpulse3,
            y = 0,
            S = 0,
            _ = 0;
            this.enableMotor1 && (y = (a - this.motorSpeed1) * this.dv00, this.motorImpulse1 += y, this.motorImpulse1 > this.maxMotorImpulse1 ? this.motorImpulse1 = this.maxMotorImpulse1 : this.motorImpulse1 < -this.maxMotorImpulse1 && (this.motorImpulse1 = -this.maxMotorImpulse1), y = this.motorImpulse1 - p),
            this.enableMotor2 && (S = (u - this.motorSpeed2) * this.dv11, this.motorImpulse2 += S, this.motorImpulse2 > this.maxMotorImpulse2 ? this.motorImpulse2 = this.maxMotorImpulse2 : this.motorImpulse2 < -this.maxMotorImpulse2 && (this.motorImpulse2 = -this.maxMotorImpulse2), S = this.motorImpulse2 - f),
            this.enableMotor3 && (_ = (g - this.motorSpeed3) * this.dv22, this.motorImpulse3 += _, this.motorImpulse3 > this.maxMotorImpulse3 ? this.motorImpulse3 = this.maxMotorImpulse3 : this.motorImpulse3 < -this.maxMotorImpulse3 && (this.motorImpulse3 = -this.maxMotorImpulse3), _ = this.motorImpulse3 - m),
            a += y * this.kv00 + S * this.k01 + _ * this.k02,
            u += y * this.k10 + S * this.kv11 + _ * this.k12,
            g += y * this.k20 + S * this.k21 + _ * this.kv22,
            a -= this.limitVelocity1 + this.limitImpulse1 * this.cfm1,
            u -= this.limitVelocity2 + this.limitImpulse2 * this.cfm2,
            g -= this.limitVelocity3 + this.limitImpulse3 * this.cfm3;
            var A = this.limitImpulse1,
            v = this.limitImpulse2,
            w = this.limitImpulse3,
            E = a * this.d00 + u * this.d01 + g * this.d02,
            x = a * this.d10 + u * this.d11 + g * this.d12,
            C = a * this.d20 + u * this.d21 + g * this.d22;
            this.limitImpulse1 += E,
            this.limitImpulse2 += x,
            this.limitImpulse3 += C;
            var b,
            R = 0;
            switch ((2 == this.limitState1 || this.limitImpulse1 * this.limitState1 < 0) && (u += (E = -A) * this.k10, g += E * this.k20, R |= 1), (2 == this.limitState2 || this.limitImpulse2 * this.limitState2 < 0) && (a += (x = -v) * this.k01, g += x * this.k21, R |= 2), (2 == this.limitState3 || this.limitImpulse3 * this.limitState3 < 0) && (a += (C = -w) * this.k02, u += C * this.k12, R |= 4), R) {
            case 1:
                b = 1 / (this.k11 * this.k22 - this.k12 * this.k21),
                x = (this.k22 * u + -this.k12 * g) * b,
                C = (-this.k21 * u + this.k11 * g) * b;
                break;
            case 2:
                b = 1 / (this.k00 * this.k22 - this.k02 * this.k20),
                E = (this.k22 * a + -this.k02 * g) * b,
                C = (-this.k20 * a + this.k00 * g) * b;
                break;
            case 3:
                C = g / this.k22;
                break;
            case 4:
                b = 1 / (this.k00 * this.k11 - this.k01 * this.k10),
                E = (this.k11 * a + -this.k01 * u) * b,
                x = (-this.k10 * a + this.k00 * u) * b;
                break;
            case 5:
                x = u / this.k11;
                break;
            case 6:
                E = a / this.k00
            }
            this.limitImpulse1 = A + E,
            this.limitImpulse2 = v + x,
            this.limitImpulse3 = w + C;
            var k = y + E,
            B = S + x,
            V = _ + C;
            this.l1.x += k * this.l1x1 + B * this.l1x2 + V * this.l1x3,
            this.l1.y += k * this.l1y1 + B * this.l1y2 + V * this.l1y3,
            this.l1.z += k * this.l1z1 + B * this.l1z2 + V * this.l1z3,
            this.a1.x += k * this.a1x1 + B * this.a1x2 + V * this.a1x3,
            this.a1.y += k * this.a1y1 + B * this.a1y2 + V * this.a1y3,
            this.a1.z += k * this.a1z1 + B * this.a1z2 + V * this.a1z3,
            this.l2.x -= k * this.l2x1 + B * this.l2x2 + V * this.l2x3,
            this.l2.y -= k * this.l2y1 + B * this.l2y2 + V * this.l2y3,
            this.l2.z -= k * this.l2z1 + B * this.l2z2 + V * this.l2z3,
            this.a2.x -= k * this.a2x1 + B * this.a2x2 + V * this.a2x3,
            this.a2.y -= k * this.a2y1 + B * this.a2y2 + V * this.a2y3,
            this.a2.z -= k * this.a2z1 + B * this.a2z2 + V * this.a2z3
        }
    }),
    PrismaticJoint.prototype = Object.assign(Object.create(Joint.prototype), {
        constructor: PrismaticJoint,
        preSolve: function (t, e) {
            this.updateAnchorPoints(),
            this.ax1.copy(this.localAxis1).applyMatrix3(this.body1.rotation, !0),
            this.ax2.copy(this.localAxis2).applyMatrix3(this.body2.rotation, !0),
            this.nor.set(this.ax1.x * this.body2.inverseMass + this.ax2.x * this.body1.inverseMass, this.ax1.y * this.body2.inverseMass + this.ax2.y * this.body1.inverseMass, this.ax1.z * this.body2.inverseMass + this.ax2.z * this.body1.inverseMass).normalize(),
            this.tan.tangent(this.nor).normalize(),
            this.bin.crossVectors(this.nor, this.tan),
            this.ac.preSolve(t, e),
            this.t3.preSolve(t, e)
        },
        solve: function () {
            this.ac.solve(),
            this.t3.solve()
        },
        postSolve: function () {}
    }),
    SliderJoint.prototype = Object.assign(Object.create(Joint.prototype), {
        constructor: SliderJoint,
        preSolve: function (t, e) {
            this.updateAnchorPoints(),
            this.ax1.copy(this.localAxis1).applyMatrix3(this.body1.rotation, !0),
            this.an1.copy(this.localAngle1).applyMatrix3(this.body1.rotation, !0),
            this.ax2.copy(this.localAxis2).applyMatrix3(this.body2.rotation, !0),
            this.an2.copy(this.localAngle2).applyMatrix3(this.body2.rotation, !0),
            this.nor.set(this.ax1.x * this.body2.inverseMass + this.ax2.x * this.body1.inverseMass, this.ax1.y * this.body2.inverseMass + this.ax2.y * this.body1.inverseMass, this.ax1.z * this.body2.inverseMass + this.ax2.z * this.body1.inverseMass).normalize(),
            this.tan.tangent(this.nor).normalize(),
            this.bin.crossVectors(this.nor, this.tan),
            this.tmp.crossVectors(this.an1, this.an2);
            var n = g.acosClamp(g.dotVectors(this.an1, this.an2));
            g.dotVectors(this.nor, this.tmp) < 0 ? this.rotationalLimitMotor.angle = -n : this.rotationalLimitMotor.angle = n,
            this.tmp.crossVectors(this.ax1, this.ax2),
            this.r3.limitMotor2.angle = g.dotVectors(this.tan, this.tmp),
            this.r3.limitMotor3.angle = g.dotVectors(this.bin, this.tmp),
            this.r3.preSolve(t, e),
            this.t3.preSolve(t, e)
        },
        solve: function () {
            this.r3.solve(),
            this.t3.solve()
        },
        postSolve: function () {}
    }),
    WheelJoint.prototype = Object.assign(Object.create(Joint.prototype), {
        constructor: WheelJoint,
        preSolve: function (t, e) {
            this.updateAnchorPoints(),
            this.ax1.copy(this.localAxis1).applyMatrix3(this.body1.rotation, !0),
            this.an1.copy(this.localAngle1).applyMatrix3(this.body1.rotation, !0),
            this.ax2.copy(this.localAxis2).applyMatrix3(this.body2.rotation, !0),
            this.an2.copy(this.localAngle2).applyMatrix3(this.body2.rotation, !0),
            this.r3.limitMotor1.angle = g.dotVectors(this.ax1, this.ax2);
            var n = g.dotVectors(this.an1, this.ax2);
            g.dotVectors(this.ax1, this.tmp.crossVectors(this.an1, this.ax2)) < 0 ? this.rotationalLimitMotor1.angle = -n : this.rotationalLimitMotor1.angle = n,
            n = g.dotVectors(this.an2, this.ax1),
            g.dotVectors(this.ax2, this.tmp.crossVectors(this.an2, this.ax1)) < 0 ? this.rotationalLimitMotor2.angle = -n : this.rotationalLimitMotor2.angle = n,
            this.nor.crossVectors(this.ax1, this.ax2).normalize(),
            this.tan.crossVectors(this.nor, this.ax2).normalize(),
            this.bin.crossVectors(this.nor, this.ax1).normalize(),
            this.r3.preSolve(t, e),
            this.t3.preSolve(t, e)
        },
        solve: function () {
            this.r3.solve(),
            this.t3.solve()
        },
        postSolve: function () {}
    }),
    ContactManifold.prototype = {
        constructor: ContactManifold,
        reset: function (t, e) {
            this.body1 = t.parent,
            this.body2 = e.parent,
            this.numPoints = 0
        },
        addPointVec: function (t, e, n, a) {
            var u = this.points[this.numPoints++];
            u.position.copy(t),
            u.localPoint1.sub(t, this.body1.position).applyMatrix3(this.body1.rotation),
            u.localPoint2.sub(t, this.body2.position).applyMatrix3(this.body2.rotation),
            u.normal.copy(e),
            a && u.normal.negate(),
            u.normalImpulse = 0,
            u.penetration = n,
            u.warmStarted = !1
        },
        addPoint: function (t, e, n, a, u, g, p, f) {
            var m = this.points[this.numPoints++];
            m.position.set(t, e, n),
            m.localPoint1.sub(m.position, this.body1.position).applyMatrix3(this.body1.rotation),
            m.localPoint2.sub(m.position, this.body2.position).applyMatrix3(this.body2.rotation),
            m.normalImpulse = 0,
            m.normal.set(a, u, g),
            f && m.normal.negate(),
            m.penetration = p,
            m.warmStarted = !1
        }
    },
    ContactConstraint.prototype = Object.assign(Object.create(Constraint.prototype), {
        constructor: ContactConstraint,
        attach: function () {
            this.p1 = this.body1.position,
            this.p2 = this.body2.position,
            this.lv1 = this.body1.linearVelocity,
            this.av1 = this.body1.angularVelocity,
            this.lv2 = this.body2.linearVelocity,
            this.av2 = this.body2.angularVelocity,
            this.i1 = this.body1.inverseInertia,
            this.i2 = this.body2.inverseInertia
        },
        detach: function () {
            this.p1 = null,
            this.p2 = null,
            this.lv1 = null,
            this.lv2 = null,
            this.av1 = null,
            this.av2 = null,
            this.i1 = null,
            this.i2 = null
        },
        preSolve: function (t, e) {
            this.m1 = this.body1.inverseMass,
            this.m2 = this.body2.inverseMass;
            var n = this.m1 + this.m2;
            this.num = this.manifold.numPoints;
            for (var a, u, p, f, m, y, S, _ = this.cs, A = 0; A < this.num; A++)
                a = this.ps[A], this.tmpP1.sub(a.position, this.p1), this.tmpP2.sub(a.position, this.p2), this.tmpC1.crossVectors(this.av1, this.tmpP1), this.tmpC2.crossVectors(this.av2, this.tmpP2), _.norImp = a.normalImpulse, _.tanImp = a.tangentImpulse, _.binImp = a.binormalImpulse, _.nor.copy(a.normal), this.tmp.set(this.lv2.x + this.tmpC2.x - (this.lv1.x + this.tmpC1.x), this.lv2.y + this.tmpC2.y - (this.lv1.y + this.tmpC1.y), this.lv2.z + this.tmpC2.z - (this.lv1.z + this.tmpC1.z)), u = g.dotVectors(_.nor, this.tmp), _.tan.set(this.tmp.x - u * _.nor.x, this.tmp.y - u * _.nor.y, this.tmp.z - u * _.nor.z), g.dotVectors(_.tan, _.tan) <= .04 && _.tan.tangent(_.nor), _.tan.normalize(), _.bin.crossVectors(_.nor, _.tan), _.norU1.scale(_.nor, this.m1), _.norU2.scale(_.nor, this.m2), _.tanU1.scale(_.tan, this.m1), _.tanU2.scale(_.tan, this.m2), _.binU1.scale(_.bin, this.m1), _.binU2.scale(_.bin, this.m2), _.norT1.crossVectors(this.tmpP1, _.nor), _.tanT1.crossVectors(this.tmpP1, _.tan), _.binT1.crossVectors(this.tmpP1, _.bin), _.norT2.crossVectors(this.tmpP2, _.nor), _.tanT2.crossVectors(this.tmpP2, _.tan), _.binT2.crossVectors(this.tmpP2, _.bin), y = this.i1, S = this.i2, _.norTU1.copy(_.norT1).applyMatrix3(y, !0), _.tanTU1.copy(_.tanT1).applyMatrix3(y, !0), _.binTU1.copy(_.binT1).applyMatrix3(y, !0), _.norTU2.copy(_.norT2).applyMatrix3(S, !0), _.tanTU2.copy(_.tanT2).applyMatrix3(S, !0), _.binTU2.copy(_.binT2).applyMatrix3(S, !0), this.tmpC1.crossVectors(_.norTU1, this.tmpP1), this.tmpC2.crossVectors(_.norTU2, this.tmpP2), this.tmp.add(this.tmpC1, this.tmpC2), _.norDen = 1 / (n + g.dotVectors(_.nor, this.tmp)), this.tmpC1.crossVectors(_.tanTU1, this.tmpP1), this.tmpC2.crossVectors(_.tanTU2, this.tmpP2), this.tmp.add(this.tmpC1, this.tmpC2), _.tanDen = 1 / (n + g.dotVectors(_.tan, this.tmp)), this.tmpC1.crossVectors(_.binTU1, this.tmpP1), this.tmpC2.crossVectors(_.binTU2, this.tmpP2), this.tmp.add(this.tmpC1, this.tmpC2), _.binDen = 1 / (n + g.dotVectors(_.bin, this.tmp)), a.warmStarted ? (p = a.normalImpulse, this.lv1.addScaledVector(_.norU1, p), this.av1.addScaledVector(_.norTU1, p), this.lv2.subScaledVector(_.norU2, p), this.av2.subScaledVector(_.norTU2, p), _.norImp = p, _.tanImp = 0, _.binImp = 0, u = 0) : (_.norImp = 0, _.tanImp = 0, _.binImp = 0), u > -1 && (u = 0), (f = this.restitution * -u) < (m =  - (a.penetration + .005) * e * .05) && (f = m), _.norTar = f, _.last = A == this.num - 1, _ = _.next
        },
        solve: function () {
            var t,
            e,
            n,
            a,
            u,
            p,
            f,
            m,
            y;
            this.tmplv1.copy(this.lv1),
            this.tmplv2.copy(this.lv2),
            this.tmpav1.copy(this.av1),
            this.tmpav2.copy(this.av2);
            for (var S = this.cs; u = S.norImp, p = S.tanImp, f = S.binImp, m = -u * this.friction, this.tmp.sub(this.tmplv2, this.tmplv1), t = p, n = f, (y = (p += e = (g.dotVectors(this.tmp, S.tan) + g.dotVectors(this.tmpav2, S.tanT2) - g.dotVectors(this.tmpav1, S.tanT1)) * S.tanDen) * p + (f += a = (g.dotVectors(this.tmp, S.bin) + g.dotVectors(this.tmpav2, S.binT2) - g.dotVectors(this.tmpav1, S.binT1)) * S.binDen) * f) > m * m && (p *= y = m / g.sqrt(y), f *= y), e = p - t, a = f - n, this.tmp.set(S.tanU1.x * e + S.binU1.x * a, S.tanU1.y * e + S.binU1.y * a, S.tanU1.z * e + S.binU1.z * a), this.tmplv1.addEqual(this.tmp), this.tmp.set(S.tanTU1.x * e + S.binTU1.x * a, S.tanTU1.y * e + S.binTU1.y * a, S.tanTU1.z * e + S.binTU1.z * a), this.tmpav1.addEqual(this.tmp), this.tmp.set(S.tanU2.x * e + S.binU2.x * a, S.tanU2.y * e + S.binU2.y * a, S.tanU2.z * e + S.binU2.z * a), this.tmplv2.subEqual(this.tmp), this.tmp.set(S.tanTU2.x * e + S.binTU2.x * a, S.tanTU2.y * e + S.binTU2.y * a, S.tanTU2.z * e + S.binTU2.z * a), this.tmpav2.subEqual(this.tmp), this.tmp.sub(this.tmplv2, this.tmplv1), t = u, (u += e = (g.dotVectors(this.tmp, S.nor) + g.dotVectors(this.tmpav2, S.norT2) - g.dotVectors(this.tmpav1, S.norT1) - S.norTar) * S.norDen) > 0 && (u = 0), e = u - t, this.tmplv1.addScaledVector(S.norU1, e), this.tmpav1.addScaledVector(S.norTU1, e), this.tmplv2.subScaledVector(S.norU2, e), this.tmpav2.subScaledVector(S.norTU2, e), S.norImp = u, S.tanImp = p, S.binImp = f, !S.last; )
                S = S.next;
            this.lv1.copy(this.tmplv1),
            this.lv2.copy(this.tmplv2),
            this.av1.copy(this.tmpav1),
            this.av2.copy(this.tmpav2)
        },
        postSolve: function () {
            for (var t, e = this.cs, n = this.num; n--; )
                (t = this.ps[n]).normal.copy(e.nor), t.tangent.copy(e.tan), t.binormal.copy(e.bin), t.normalImpulse = e.norImp, t.tangentImpulse = e.tanImp, t.binormalImpulse = e.binImp, t.normalDenominator = e.norDen, t.tangentDenominator = e.tanDen, t.binormalDenominator = e.binDen, e = e.next
        }
    }),
    Object.assign(Contact.prototype, {
        Contact: !0,
        mixRestitution: function (t, e) {
            return g.sqrt(t * e)
        },
        mixFriction: function (t, e) {
            return g.sqrt(t * e)
        },
        fixPenetration: function (t, e) {
            var n = t.parent,
            a = e.parent,
            u = this.world.detectors[2][2];
            if (this.manifold.numPoints = 0, t.fixed || e.fixed) {
                var g = t;
                if (2 != g.type) {
                    var p = g.tempAABB.elements;
                    (g = new Box({
                            collidesWith: g.collidesWith,
                            belongsTo: g.belongsTo,
                            restitution: g.restitution,
                            friction: g.friction,
                            density: g.density,
                            relativeRotation: g.relativeRotation,
                            relativePosition: g.relativePosition
                        }, p[3] - p[0], p[4] - p[1], p[5] - p[2])).position.copy(t.position),
                    g.rotation.copy(t.rotation),
                    g.updateProxy()
                }
                var f = e;
                if (2 != f.type) {
                    p = f.tempAABB.elements;
                    (f = new Box({
                            collidesWith: f.collidesWith,
                            belongsTo: f.belongsTo,
                            restitution: f.restitution,
                            friction: f.friction,
                            density: f.density,
                            relativeRotation: f.relativeRotation,
                            relativePosition: f.relativePosition
                        }, p[3] - p[0], p[4] - p[1], p[5] - p[2])).position.copy(e.position),
                    f.rotation.copy(e.rotation),
                    f.updateProxy()
                }
                u.detectCollision(g, f, this.manifold)
            }
            var m = this.manifold.numPoints;
            if (m > 0) {
                var y = new Vec3;
                y.copy(this.points[0].position);
                for (var S = 1; S < m; )
                    y.add(this.points[S].position), S++;
                y.scaleEqual(1 / m);
                var _ = this.points[0].position;
                t.fixed && (_.copy(n.position).sub(y).normalize(.01), n.position.copy(y).add(_), n.syncShapes(), t.fixed = !1),
                e.fixed && (_.copy(a.position).sub(y).normalize(.01), a.position.copy(y).add(_), a.syncShapes(), e.fixed = !1)
            }
        },
        updateManifold: function () {
            this.constraint.restitution = this.mixRestitution(this.shape1.restitution, this.shape2.restitution),
            this.constraint.friction = this.mixFriction(this.shape1.friction, this.shape2.friction);
            for (var t = this.manifold.numPoints, e = t; e--; ) {
                var n = this.buffer[e],
                a = this.points[e];
                n.lp1X = a.localPoint1.x,
                n.lp1Y = a.localPoint1.y,
                n.lp1Z = a.localPoint1.z,
                n.lp2X = a.localPoint2.x,
                n.lp2Y = a.localPoint2.y,
                n.lp2Z = a.localPoint2.z,
                n.impulse = a.normalImpulse
            }
            this.fixPenetration(this.shape1, this.shape2),
            this.manifold.numPoints = 0,
            this.detector.detectCollision(this.shape1, this.shape2, this.manifold);
            var u = this.manifold.numPoints;
            if (0 == u)
                return this.touching = !1, this.close = !1, void(this.dist = g.INF);
            for ((this.touching || this.dist < .001) && (this.close = !0), this.touching = !0, e = u; e--; ) {
                for (var p = (a = this.points[e]).localPoint1.x, f = a.localPoint1.y, m = a.localPoint1.z, y = a.localPoint2.x, S = a.localPoint2.y, _ = a.localPoint2.z, A = -1, v = 4e-4, w = t; w--; ) {
                    var E = (n = this.buffer[w]).lp1X - p,
                    x = n.lp1Y - f,
                    C = n.lp1Z - m,
                    b = E * E + x * x + C * C,
                    R = (E = n.lp2X - y) * E + (x = n.lp2Y - S) * x + (C = n.lp2Z - _) * C;
                    b < R ? b < v && (v = b, A = w) : R < v && (v = R, A = w),
                    v < this.dist && (this.dist = v)
                }
                if (-1 != A) {
                    var k = this.buffer[A];
                    this.buffer[A] = this.buffer[--t],
                    this.buffer[t] = k,
                    a.normalImpulse = k.impulse,
                    a.warmStarted = !0
                } else
                    a.normalImpulse = 0, a.warmStarted = !1
            }
            var B = this.shape1.parent,
            V = this.shape2.parent;
            B.event_cb && B.event_cb(V, this.shape2, this, this.shape1),
            V.event_cb && V.event_cb(B, this.shape1, this, this.shape2)
        },
        attach: function (t, e) {
            this.shape1 = t,
            this.shape2 = e,
            this.body1 = t.parent,
            this.body2 = e.parent,
            this.manifold.body1 = this.body1,
            this.manifold.body2 = this.body2,
            this.constraint.body1 = this.body1,
            this.constraint.body2 = this.body2,
            this.constraint.attach(),
            this.s1Link.shape = e,
            this.s1Link.body = this.body2,
            this.s2Link.shape = t,
            this.s2Link.body = this.body1,
            null != t.contactLink ? (this.s1Link.next = t.contactLink).prev = this.s1Link : this.s1Link.next = null,
            t.contactLink = this.s1Link,
            t.numContacts++,
            null != e.contactLink ? (this.s2Link.next = e.contactLink).prev = this.s2Link : this.s2Link.next = null,
            e.contactLink = this.s2Link,
            e.numContacts++,
            this.b1Link.shape = e,
            this.b1Link.body = this.body2,
            this.b2Link.shape = t,
            this.b2Link.body = this.body1,
            null != this.body1.contactLink ? (this.b1Link.next = this.body1.contactLink).prev = this.b1Link : this.b1Link.next = null,
            this.body1.contactLink = this.b1Link,
            this.body1.numContacts++,
            null != this.body2.contactLink ? (this.b2Link.next = this.body2.contactLink).prev = this.b2Link : this.b2Link.next = null,
            this.body2.contactLink = this.b2Link,
            this.body2.numContacts++,
            this.prev = null,
            this.next = null,
            this.persisting = !0,
            this.sleeping = this.body1.sleeping && this.body2.sleeping,
            this.manifold.numPoints = 0
        },
        detach: function () {
            var t = this.s1Link.prev,
            e = this.s1Link.next;
            null !== t && (t.next = e),
            null !== e && (e.prev = t),
            this.shape1.contactLink == this.s1Link && (this.shape1.contactLink = e),
            this.s1Link.prev = null,
            this.s1Link.next = null,
            this.s1Link.shape = null,
            this.s1Link.body = null,
            this.shape1.numContacts--,
            t = this.s2Link.prev,
            e = this.s2Link.next,
            null !== t && (t.next = e),
            null !== e && (e.prev = t),
            this.shape2.contactLink == this.s2Link && (this.shape2.contactLink = e),
            this.s2Link.prev = null,
            this.s2Link.next = null,
            this.s2Link.shape = null,
            this.s2Link.body = null,
            this.shape2.numContacts--,
            t = this.b1Link.prev,
            e = this.b1Link.next,
            null !== t && (t.next = e),
            null !== e && (e.prev = t),
            this.body1.contactLink == this.b1Link && (this.body1.contactLink = e),
            this.b1Link.prev = null,
            this.b1Link.next = null,
            this.b1Link.shape = null,
            this.b1Link.body = null,
            this.body1.numContacts--,
            t = this.b2Link.prev,
            e = this.b2Link.next,
            null !== t && (t.next = e),
            null !== e && (e.prev = t),
            this.body2.contactLink == this.b2Link && (this.body2.contactLink = e),
            this.b2Link.prev = null,
            this.b2Link.next = null,
            this.b2Link.shape = null,
            this.b2Link.body = null,
            this.body2.numContacts--,
            this.manifold.body1 = null,
            this.manifold.body2 = null,
            this.constraint.body1 = null,
            this.constraint.body2 = null,
            this.constraint.detach(),
            this.shape1 = null,
            this.shape2 = null,
            this.body1 = null,
            this.body2 = null
        }
    }),
    Object.assign(RigidBody.prototype, {
        setParent: function (t) {
            this.parent = t,
            this.scale = this.parent.scale,
            this.invScale = this.parent.invScale,
            this.id = ShapeIdCount(),
            this.name || (this.name = this.id),
            this.updateMesh()
        },
        addShape: function (t) {
            t.parent && printError("RigidBody", "It is not possible that you add a shape which already has an associated body."),
            null != this.shapes && ((this.shapes.prev = t).next = this.shapes),
            this.shapes = t,
            t.parent = this,
            this.parent && this.parent.addShape(t),
            this.numShapes++
        },
        removeShape: function (t) {
            var e = t;
            if (e.parent == this) {
                var n = e.prev,
                a = e.next;
                null != n && (n.next = a),
                null != a && (a.prev = n),
                this.shapes == e && (this.shapes = a),
                e.prev = null,
                e.next = null,
                e.parent = null,
                this.parent && this.parent.removeShape(e),
                this.numShapes--
            }
        },
        remove: function () {
            this.dispose()
        },
        dispose: function () {
            this.parent.removeRigidBody(this)
        },
        checkContact: function (t) {
            this.parent.checkContact(this.name, t)
        },
        setupMass: function (t, e) {
            var n = void 0 === e || e;
            this.type = t || 2,
            this.isDynamic = 1 === this.type,
            this.isStatic = 2 === this.type,
            this.mass = 0,
            this.localInertia.set(0, 0, 0, 0, 0, 0, 0, 0, 0);
            for (var a = new Mat33, u = new Vec3, g = this.shapes; null !== g; g = g.next) {
                g.calculateMassInfo(this.massInfo);
                var p = this.massInfo.mass;
                u.addScaledVector(g.relativePosition, p),
                this.mass += p,
                this.rotateInertia(g.relativeRotation, this.massInfo.inertia, a),
                this.localInertia.add(a),
                this.localInertia.addOffset(p, g.relativePosition)
            }
            if (this.inverseMass = 1 / this.mass, u.scaleEqual(this.inverseMass), n) {
                var f = this.position.clone();
                for (this.position.copy(u).applyQuaternion(this.orientation).add(f), g = this.shapes; null !== g; g = g.next)
                    g.relativePosition.subEqual(u);
                this.localInertia.subOffset(this.mass, u)
            }
            this.inverseLocalInertia.invert(this.localInertia),
            2 === this.type && (this.inverseMass = 0, this.inverseLocalInertia.set(0, 0, 0, 0, 0, 0, 0, 0, 0)),
            this.syncShapes(),
            this.awake()
        },
        setMass: function (t) {
            if (!isNaN(t)) {
                for (var e = this.shapes; null !== e; e = e.next)
                    e.mass = e.mass / this.mass * t;
                this.mass = t,
                this.inverseMass = 0 === t ? 1 : 1 / t
            }
        },
        awake: function () {
            if (this.allowSleep && this.sleeping) {
                this.sleeping = !1,
                this.sleepTime = 0;
                for (var t = this.contactLink; null != t; )
                    t.body.sleepTime = 0, t.body.sleeping = !1, t = t.next;
                for (var e = this.jointLink; null != e; )
                    e.body.sleepTime = 0, e.body.sleeping = !1, e = e.next;
                for (var n = this.shapes; null != n; n = n.next)
                    n.updateProxy()
            }
        },
        sleep: function () {
            if (this.allowSleep && !this.sleeping) {
                this.linearVelocity.set(0, 0, 0),
                this.angularVelocity.set(0, 0, 0),
                this.sleepPosition.copy(this.position),
                this.sleepOrientation.copy(this.orientation),
                this.sleepTime = 0,
                this.sleeping = !0;
                for (var t = this.shapes; null != t; t = t.next)
                    t.updateProxy()
            }
        },
        testWakeUp: function () {
            (this.linearVelocity.testZero() || this.angularVelocity.testZero() || this.position.testDiff(this.sleepPosition) || this.orientation.testDiff(this.sleepOrientation)) && this.awake()
        },
        isLonely: function () {
            return 0 == this.numJoints && 0 == this.numContacts
        },
        updatePosition: function (t) {
            switch (this.type) {
            case 2:
                this.linearVelocity.set(0, 0, 0),
                this.angularVelocity.set(0, 0, 0),
                this.controlPos && (this.position.copy(this.newPosition), this.controlPos = !1),
                this.controlRot && (this.orientation.copy(this.newOrientation), this.controlRot = !1);
                break;
            case 1:
                if (this.isKinematic && (this.linearVelocity.set(0, 0, 0), this.angularVelocity.set(0, 0, 0)), this.controlPos && (t > 0 ? this.linearVelocity.subVectors(this.newPosition, this.position).multiplyScalar(1 / t) : this.position.copy(this.newPosition), this.controlPos = !1), this.controlRot) {
                    if (t > 0) {
                        var e = this.getAngularVelocity(this.orientation, this.newOrientation).multiplyScalar(1 / t);
                        this.angularVelocity.copy(e)
                    } else
                        this.orientation.copy(this.newOrientation);
                    this.controlRot = !1
                }
                if (this.linearVelocityConstraint) {
                    let t = this.linearVelocityConstraint;
                    -1 != t.indexOf("x") && (this.linearVelocity.x = 0, this.linearSpeed.x = 0),
                    -1 != t.indexOf("y") && (this.linearVelocity.y = 0, this.linearSpeed.y = 0),
                    -1 != t.indexOf("z") && (this.linearVelocity.z = 0, this.linearSpeed.z = 0)
                }
                if (Number.isFinite(this.linearVelocityMax) && this.limitVelocity(this.linearVelocity, this.linearVelocityMax), t > 0 && (this.position.addScaledVector(this.linearVelocity, t), this.position.addScaledVector(this.linearSpeed, t)), this.positionConstraint) {
                    let t = this.positionConstraint;
                    Number.isFinite(t[0]) && Number.isFinite(t[1]) && (this.position.x = Math.clamp(this.position.x, t[0], t[1])),
                    Number.isFinite(t[2]) && Number.isFinite(t[3]) && (this.position.y = Math.clamp(this.position.y, t[2], t[3])),
                    Number.isFinite(t[4]) && Number.isFinite(t[5]) && (this.position.z = Math.clamp(this.position.z, t[4], t[5]))
                }
                if (this.angularVelocityConstraint) {
                    let t = this.angularVelocityConstraint;
                    -1 != t.indexOf("x") && (this.angularVelocity.x = 0),
                    -1 != t.indexOf("y") && (this.angularVelocity.y = 0),
                    -1 != t.indexOf("z") && (this.angularVelocity.z = 0)
                }
                if (Number.isFinite(this.angularVelocityMax) && this.limitVelocity(this.angularVelocity, this.angularVelocityMax), this.controlRotInTime ? this.angularVelocity.set(0, 0, 0) : t > 0 && this.orientation.addTime(this.angularVelocity, t), this.angularConstraint) {
                    let t = this.angularConstraint;
                    Number.isFinite(t[0]) && Number.isFinite(t[1]) && (this.angularVelocity.x = Math.clamp(this.angularVelocity.x, t[0], t[1])),
                    Number.isFinite(t[2]) && Number.isFinite(t[3]) && (this.angularVelocity.y = Math.clamp(this.angularVelocity.y, t[2], t[3])),
                    Number.isFinite(t[4]) && Number.isFinite(t[5]) && (this.angularVelocity.z = Math.clamp(this.angularVelocity.z, t[4], t[5]))
                }
                this.updateMesh();
                break;
            default:
                printError("RigidBody", "Invalid type.")
            }
            this.syncShapes(),
            this.updateMesh()
        },
        getAngularVelocity: function (t, e) {
            if (!t.testDiff(e))
                return new Vec3;
            var n = (new Quat).invert(t),
            a = e.clone().multiply(n),
            u = new Vec3,
            g = a.toAxisAngle(u);
            return u.scaleEqual(g)
        },
        rotateInertia: function (t, e, n) {
            this.tmpInertia.multiplyMatrices(t, e),
            n.multiplyMatrices(this.tmpInertia, t, !0)
        },
        syncShapes: function () {
            this.rotation.setQuat(this.orientation),
            this.rotateInertia(this.rotation, this.inverseLocalInertia, this.inverseInertia);
            for (var t = this.shapes; null != t; t = t.next)
                t.position.copy(t.relativePosition).applyMatrix3(this.rotation, !0).add(this.position), t.rotation.multiplyMatrices(this.rotation, t.relativeRotation), t.updateProxy()
        },
        limitVelocity: function (t, e) {
            t.lengthSq() > e * e && t.normalize(e)
        },
        applyImpulse: function (t, e, n) {
            this.linearVelocity.addScaledVector(t, this.inverseMass),
            Number.isFinite(e) && this.limitVelocity(this.linearVelocity, e);
            var a = (new Vec3).copy(t).cross(new Vec3(0, -1, 0)).applyMatrix3(this.inverseInertia, !0);
            n = n || .1,
            this.angularVelocity.addScaledVector(a, n)
        },
        setPosition: function (t) {
            this.newPosition.copy(t).multiplyScalar(this.invScale),
            this.controlPos = !0
        },
        setQuaternion: function (t) {
            this.newOrientation.set(t.x, t.y, t.z, t.w),
            this.controlRot = !0
        },
        resetPosition: function (t, e, n) {
            this.linearVelocity.set(0, 0, 0),
            this.angularVelocity.set(0, 0, 0),
            this.position.set(t, e, n).multiplyScalar(this.invScale),
            this.awake()
        },
        resetQuaternion: function (t) {
            this.angularVelocity.set(0, 0, 0),
            this.orientation = new Quat(t.x, t.y, t.z, t.w),
            this.awake()
        },
        getPosition: function () {
            return this.pos
        },
        getQuaternion: function () {
            return this.quaternion
        },
        connectMesh: function (t) {
            this.mesh = t,
            this.updateMesh()
        },
        updateMesh: function () {
            this.pos.scale(this.position, this.scale),
            this.quaternion.copy(this.orientation),
            null !== this.mesh && (this.mesh.position.copy(this.getPosition()), this.mesh.quaternion.copy(this.getQuaternion()))
        }
    }),
    Object.assign(BroadPhase.prototype, {
        BroadPhase: !0,
        createProxy: function (t) {
            printError("BroadPhase", "Inheritance error.")
        },
        addProxy: function (t) {
            printError("BroadPhase", "Inheritance error.")
        },
        removeProxy: function (t) {
            printError("BroadPhase", "Inheritance error.")
        },
        isAvailablePair: function (t, e) {
            var n,
            a = t.parent,
            u = e.parent;
            if (a == u || !a.isDynamic && !u.isDynamic || 0 == (t.belongsTo & e.collidesWith) || 0 == (e.belongsTo & t.collidesWith) || a.ignore && -1 != a.ignore.indexOf(u) || u.ignore && -1 != u.ignore.indexOf(a))
                return !1;
            for (n = a.numJoints < u.numJoints ? a.jointLink : u.jointLink; null !== n; ) {
                var g = n.joint;
                if (!g.allowCollision && (g.body1 == a && g.body2 == u || g.body1 == u && g.body2 == a))
                    return !1;
                n = n.next
            }
            return !0
        },
        detectPairs: function () {
            this.pairs = [],
            this.numPairs = 0,
            this.numPairChecks = 0,
            this.collectPairs()
        },
        collectPairs: function () {},
        addPair: function (t, e) {
            var n = new Pair(t, e);
            this.pairs.push(n),
            this.numPairs++
        }
    });
    var f = 0;
    function Proxy(t) {
        this.shape = t,
        this.aabb = t.aabb,
        this.lastAABB = t.lastAABB,
        this.tempAABB = t.tempAABB
    }
    function BasicProxy(t) {
        Proxy.call(this, t),
        this.id = f++
    }
    function BruteForceBroadPhase() {
        BroadPhase.call(this),
        this.types = 1,
        this.proxies = []
    }
    function SAPAxis() {
        this.numElements = 0,
        this.bufferSize = 256,
        this.elements = [],
        this.elements.length = this.bufferSize,
        this.stack = new Float32Array(64)
    }
    function SAPElement(t, e) {
        this.proxy = t,
        this.pair = null,
        this.min1 = null,
        this.max1 = null,
        this.min2 = null,
        this.max2 = null,
        this.max = e,
        this.value = 0
    }
    function SAPProxy(t, e) {
        Proxy.call(this, e),
        this.belongsTo = 0,
        this.max = [],
        this.min = [],
        this.sap = t,
        this.min[0] = new SAPElement(this, !1),
        this.max[0] = new SAPElement(this, !0),
        this.min[1] = new SAPElement(this, !1),
        this.max[1] = new SAPElement(this, !0),
        this.min[2] = new SAPElement(this, !1),
        this.max[2] = new SAPElement(this, !0),
        this.max[0].pair = this.min[0],
        this.max[1].pair = this.min[1],
        this.max[2].pair = this.min[2],
        this.min[0].min1 = this.min[1],
        this.min[0].max1 = this.max[1],
        this.min[0].min2 = this.min[2],
        this.min[0].max2 = this.max[2],
        this.min[1].min1 = this.min[0],
        this.min[1].max1 = this.max[0],
        this.min[1].min2 = this.min[2],
        this.min[1].max2 = this.max[2],
        this.min[2].min1 = this.min[0],
        this.min[2].max1 = this.max[0],
        this.min[2].min2 = this.min[1],
        this.min[2].max2 = this.max[1]
    }
    function SAPBroadPhase() {
        BroadPhase.call(this),
        this.types = 2,
        this.numElementsD = 0,
        this.numElementsS = 0,
        this.axesD = [new SAPAxis, new SAPAxis, new SAPAxis],
        this.axesS = [new SAPAxis, new SAPAxis, new SAPAxis],
        this.index1 = 0,
        this.index2 = 1
    }
    function DBVTNode() {
        this.child1 = null,
        this.child2 = null,
        this.parent = null,
        this.proxy = null,
        this.height = 0,
        this.aabb = new AABB
    }
    function DBVT() {
        this.root = null,
        this.freeNodes = [],
        this.freeNodes.length = 16384,
        this.numFreeNodes = 0,
        this.aabb = new AABB
    }
    function DBVTProxy(t) {
        Proxy.call(this, t),
        this.leaf = new DBVTNode,
        this.leaf.proxy = this
    }
    function DBVTBroadPhase() {
        BroadPhase.call(this),
        this.types = 3,
        this.tree = new DBVT,
        this.stack = [],
        this.leaves = [],
        this.numLeaves = 0
    }
    function CollisionDetector() {
        this.flip = !1
    }
    function BoxBoxCollisionDetector() {
        CollisionDetector.call(this),
        this.clipVertices1 = new Float32Array(24),
        this.clipVertices2 = new Float32Array(24),
        this.used = new Float32Array(8),
        this.INF = 1 / 0
    }
    function BoxCylinderCollisionDetector(t) {
        CollisionDetector.call(this),
        this.flip = t
    }
    function CylinderCylinderCollisionDetector() {
        CollisionDetector.call(this)
    }
    function SphereBoxCollisionDetector(t) {
        CollisionDetector.call(this),
        this.flip = t
    }
    function SphereCylinderCollisionDetector(t) {
        CollisionDetector.call(this),
        this.flip = t
    }
    function SphereSphereCollisionDetector() {
        CollisionDetector.call(this)
    }
    function SpherePlaneCollisionDetector(t) {
        CollisionDetector.call(this),
        this.flip = t,
        this.n = new Vec3,
        this.p = new Vec3
    }
    function BoxPlaneCollisionDetector(t) {
        CollisionDetector.call(this),
        this.flip = t,
        this.n = new Vec3,
        this.p = new Vec3,
        this.dix = new Vec3,
        this.diy = new Vec3,
        this.diz = new Vec3,
        this.cc = new Vec3,
        this.cc2 = new Vec3
    }
    function World(t) {
        switch (t instanceof Object || (t = {}), this.scale = t.worldscale || 1, this.invScale = 1 / this.scale, this.timeStep = t.timestep || .01666, this.timerate = 1e3 * this.timeStep, this.timer = null, this.preLoop = null, this.postLoop = null, this.numIterations = t.iterations || 8, t.broadphase || 2) {
        case 1:
            this.broadPhase = new BruteForceBroadPhase;
            break;
        case 2:
        default:
            this.broadPhase = new SAPBroadPhase;
            break;
        case 3:
            this.broadPhase = new DBVTBroadPhase
        }
        this.Btypes = ["None", "BruteForce", "Sweep & Prune", "Bounding Volume Tree"],
        this.broadPhaseType = this.Btypes[t.broadphase || 2],
        this.performance = null,
        this.isStat = void 0 !== t.info && t.info,
        this.isStat && (this.performance = new InfoDisplay(this)),
        this.enableRandomizer = void 0 === t.random || t.random,
        this.rigidBodies = null,
        this.numRigidBodies = 0,
        this.contacts = null,
        this.unusedContacts = null,
        this.numContacts = 0,
        this.numContactPoints = 0,
        this.joints = null,
        this.numJoints = 0,
        this.numIslands = 0,
        this.gravity = new Vec3(0, -9.8, 0),
        void 0 !== t.gravity && this.gravity.fromArray(t.gravity);
        this.detectors = [],
        this.detectors.length = 5;
        for (var e = 5; e--; )
            this.detectors[e] = [], this.detectors[e].length = 5;
        this.detectors[1][1] = new SphereSphereCollisionDetector,
        this.detectors[1][2] = new SphereBoxCollisionDetector(!1),
        this.detectors[2][1] = new SphereBoxCollisionDetector(!0),
        this.detectors[2][2] = new BoxBoxCollisionDetector,
        this.detectors[3][3] = new CylinderCylinderCollisionDetector,
        this.detectors[3][2] = new BoxCylinderCollisionDetector(!0),
        this.detectors[2][3] = new BoxCylinderCollisionDetector(!1),
        this.detectors[3][1] = new SphereCylinderCollisionDetector(!0),
        this.detectors[1][3] = new SphereCylinderCollisionDetector(!1),
        this.detectors[4][1] = new SpherePlaneCollisionDetector(!0),
        this.detectors[1][4] = new SpherePlaneCollisionDetector(!1),
        this.detectors[4][2] = new BoxPlaneCollisionDetector(!0),
        this.detectors[2][4] = new BoxPlaneCollisionDetector(!1),
        this.randX = 65535,
        this.randA = 98765,
        this.randB = 123456789,
        this.islandRigidBodies = [],
        this.islandStack = [],
        this.islandConstraints = []
    }
    return Object.assign(Proxy.prototype, {
        Proxy: !0,
        update: function () {
            printError("Proxy", "Inheritance error.")
        }
    }),
    BasicProxy.prototype = Object.assign(Object.create(Proxy.prototype), {
        constructor: BasicProxy,
        update: function () {}
    }),
    BruteForceBroadPhase.prototype = Object.assign(Object.create(BroadPhase.prototype), {
        constructor: BruteForceBroadPhase,
        createProxy: function (t) {
            return new BasicProxy(t)
        },
        addProxy: function (t) {
            this.proxies.push(t)
        },
        removeProxy: function (t) {
            var e = this.proxies.indexOf(t);
            e > -1 && this.proxies.splice(e, 1)
        },
        collectPairs: function () {
            var t,
            e,
            n,
            a = 0,
            u = this.proxies,
            g = u.length;
            for (this.numPairChecks = g * (g - 1) >> 1; a < g; )
                for (e = u[a++], t = a + 1; t < g; )
                    n = u[t++], !e.aabb.intersectTest(n.aabb) && this.isAvailablePair(e.shape, n.shape) && this.addPair(e.shape, n.shape)
        }
    }),
    Object.assign(SAPAxis.prototype, {
        SAPAxis: !0,
        addElements: function (t, e) {
            if (this.numElements + 2 >= this.bufferSize) {
                this.bufferSize *= 2;
                for (var n = [], a = this.numElements; a--; )
                    n[a] = this.elements[a]
            }
            this.elements[this.numElements++] = t,
            this.elements[this.numElements++] = e
        },
        removeElements: function (t, e) {
            for (var n = -1, a = -1, u = 0, g = this.numElements; u < g; u++) {
                var p = this.elements[u];
                if (p == t || p == e) {
                    if (-1 != n) {
                        a = u;
                        break
                    }
                    n = u
                }
            }
            for (u = n + 1, g = a; u < g; u++)
                this.elements[u - 1] = this.elements[u];
            for (u = a + 1, g = this.numElements; u < g; u++)
                this.elements[u - 2] = this.elements[u];
            this.elements[--this.numElements] = null,
            this.elements[--this.numElements] = null
        },
        sort: function () {
            for (var t = 0, e = 1; this.numElements >> e != 0; )
                e++;
            e = e * this.numElements >> 2,
            t = 0;
            for (var n = !1, a = this.elements, u = 1, p = this.numElements; u < p; u++) {
                var f = a[u],
                m = f.value,
                y = a[u - 1];
                if (y.value > m) {
                    var S = u;
                    do {
                        if (a[S] = y, 0 == --S)
                            break;
                        y = a[S - 1]
                    } while (y.value > m);
                    if (a[S] = f, (t += u - S) > e) {
                        n = !0;
                        break
                    }
                }
            }
            if (n) {
                t = 2;
                var _ = this.stack;
                for (_[0] = 0, _[1] = this.numElements - 1; t > 0; ) {
                    var A = _[--t],
                    v = _[--t],
                    w = A - v;
                    if (w > 16) {
                        var E = v + g.floor(.5 * w);
                        for (f = a[E], a[E] = a[A], a[A] = f, m = f.value, u = v - 1, S = A; ; ) {
                            var x,
                            C;
                            do {
                                x = a[++u]
                            } while (x.value < m);
                            do {
                                C = a[--S]
                            } while (m < C.value && S != v);
                            if (u >= S)
                                break;
                            a[u] = C,
                            a[S] = x
                        }
                        a[A] = a[u],
                        a[u] = f,
                        u - v > A - u ? (_[t++] = v, _[t++] = u - 1, _[t++] = u + 1, _[t++] = A) : (_[t++] = u + 1, _[t++] = A, _[t++] = v, _[t++] = u - 1)
                    } else
                        for (u = v + 1; u <= A; u++)
                            if (m = (f = a[u]).value, (y = a[u - 1]).value > m) {
                                S = u;
                                do {
                                    if (a[S] = y, 0 == --S)
                                        break;
                                    y = a[S - 1]
                                } while (y.value > m);
                                a[S] = f
                            }
                }
            }
        },
        calculateTestCount: function () {
            for (var t = 1, e = 0, n = 1, a = this.numElements; n < a; n++)
                this.elements[n].max ? t-- : (e += t, t++);
            return e
        }
    }),
    SAPProxy.prototype = Object.assign(Object.create(Proxy.prototype), {
        constructor: SAPProxy,
        isDynamic: function () {
            var t = this.shape.parent;
            return t.isDynamic && !t.sleeping
        },
        update: function () {
            var t = this.aabb.getCenter(),
            e = this.lastAABB.getCenter(),
            n = t.sub(e).lengthSq();
            this.isDynamic() && n > World.FIX_PENETRATE_SQ ? (this.shape.fixed = !0, this.tempAABB.combine(this.aabb, this.lastAABB)) : this.tempAABB.copy(this.aabb);
            var a = this.tempAABB.elements;
            this.min[0].value = a[0],
            this.min[1].value = a[1],
            this.min[2].value = a[2],
            this.max[0].value = a[3],
            this.max[1].value = a[4],
            this.max[2].value = a[5],
            (1 == this.belongsTo && !this.isDynamic() || 2 == this.belongsTo && this.isDynamic()) && (this.sap.removeProxy(this), this.sap.addProxy(this))
        }
    }),
    SAPBroadPhase.prototype = Object.assign(Object.create(BroadPhase.prototype), {
        constructor: SAPBroadPhase,
        createProxy: function (t) {
            return new SAPProxy(this, t)
        },
        addProxy: function (t) {
            var e = t;
            e.isDynamic() ? (this.axesD[0].addElements(e.min[0], e.max[0]), this.axesD[1].addElements(e.min[1], e.max[1]), this.axesD[2].addElements(e.min[2], e.max[2]), e.belongsTo = 1, this.numElementsD += 2) : (this.axesS[0].addElements(e.min[0], e.max[0]), this.axesS[1].addElements(e.min[1], e.max[1]), this.axesS[2].addElements(e.min[2], e.max[2]), e.belongsTo = 2, this.numElementsS += 2)
        },
        removeProxy: function (t) {
            var e = t;
            if (0 != e.belongsTo) {
                switch (e.belongsTo) {
                case 1:
                    this.axesD[0].removeElements(e.min[0], e.max[0]),
                    this.axesD[1].removeElements(e.min[1], e.max[1]),
                    this.axesD[2].removeElements(e.min[2], e.max[2]),
                    this.numElementsD -= 2;
                    break;
                case 2:
                    this.axesS[0].removeElements(e.min[0], e.max[0]),
                    this.axesS[1].removeElements(e.min[1], e.max[1]),
                    this.axesS[2].removeElements(e.min[2], e.max[2]),
                    this.numElementsS -= 2
                }
                e.belongsTo = 0
            }
        },
        collectPairs: function () {
            if (0 != this.numElementsD) {
                var t,
                e,
                n,
                a,
                u = this.axesD[this.index1],
                g = this.axesD[this.index2];
                u.sort(),
                g.sort(),
                u.calculateTestCount() <= g.calculateTestCount() ? ((g = this.axesS[this.index1]).sort(), t = u.elements, e = g.elements) : ((u = this.axesS[this.index2]).sort(), t = g.elements, e = u.elements, this.index1 ^= this.index2, this.index2 ^= this.index1, this.index1 ^= this.index2);
                for (var p = 0, f = 0; p < this.numElementsD; ) {
                    var m,
                    y;
                    if (f == this.numElementsS)
                        m = t[p], y = !0, p++;
                    else {
                        var S = t[p],
                        _ = e[f];
                        S.value < _.value ? (m = S, y = !0, p++) : (m = _, y = !1, f++)
                    }
                    if (m.max) {
                        var A = m.pair;
                        if (y) {
                            if (A == n) {
                                n = n.pair;
                                continue
                            }
                            m = n
                        } else {
                            if (A == a) {
                                a = a.pair;
                                continue
                            }
                            m = a
                        }
                        for (; m; ) {
                            if ((b = m.pair) == A) {
                                m.pair = b.pair;
                                break
                            }
                            m = b
                        }
                    } else {
                        for (var v = m.proxy.shape, w = m.min1.value, E = m.max1.value, x = m.min2.value, C = m.max2.value, b = n; null != b; b = b.pair) {
                            var R = b.proxy.shape;
                            this.numPairChecks++,
                            w > b.max1.value || E < b.min1.value || x > b.max2.value || C < b.min2.value || !this.isAvailablePair(v, R) || this.addPair(v, R)
                        }
                        if (y) {
                            for (b = a; null != b; b = b.pair)
                                R = b.proxy.shape, this.numPairChecks++, w > b.max1.value || E < b.min1.value || x > b.max2.value || C < b.min2.value || !this.isAvailablePair(v, R) || this.addPair(v, R);
                            m.pair = n,
                            n = m
                        } else
                            m.pair = a, a = m
                    }
                }
                this.index2 = 3 ^ (this.index1 | this.index2)
            }
        }
    }),
    Object.assign(DBVT.prototype, {
        DBVT: !0,
        moveLeaf: function (t) {
            this.deleteLeaf(t),
            this.insertLeaf(t)
        },
        insertLeaf: function (t) {
            if (null != this.root) {
                for (var e, n, a = t.aabb, u = this.root; null == u.proxy; ) {
                    var g = u.child1,
                    p = u.child2,
                    f = u.aabb,
                    m = g.aabb,
                    y = p.aabb;
                    e = f.surfaceArea(),
                    this.aabb.combine(a, f);
                    var S = 2 * (n = this.aabb.surfaceArea()),
                    _ = 2 * (n - e),
                    A = _;
                    this.aabb.combine(a, m),
                    null != g.proxy ? A += this.aabb.surfaceArea() : A += this.aabb.surfaceArea() - m.surfaceArea();
                    var v = _;
                    if (this.aabb.combine(a, y), null != p.proxy ? v += this.aabb.surfaceArea() : v += this.aabb.surfaceArea() - y.surfaceArea(), A < v) {
                        if (S < A)
                            break;
                        u = g
                    } else {
                        if (S < v)
                            break;
                        u = p
                    }
                }
                var w,
                E = u.parent;
                (w = this.numFreeNodes > 0 ? this.freeNodes[--this.numFreeNodes] : new DBVTNode).parent = E,
                w.child1 = t,
                w.child2 = u,
                w.aabb.combine(t.aabb, u.aabb),
                w.height = u.height + 1,
                u.parent = w,
                t.parent = w,
                u == this.root ? this.root = w : E.child1 == u ? E.child1 = w : E.child2 = w;
                do {
                    w = this.balance(w),
                    this.fix(w),
                    w = w.parent
                } while (null != w)
            } else
                this.root = t
        },
        getBalance: function (t) {
            return null != t.proxy ? 0 : t.child1.height - t.child2.height
        },
        deleteLeaf: function (t) {
            if (t != this.root) {
                var e,
                n = t.parent;
                if (e = n.child1 == t ? n.child2 : n.child1, n == this.root)
                    return this.root = e, void(e.parent = null);
                var a = n.parent;
                e.parent = a,
                a.child1 == n ? a.child1 = e : a.child2 = e,
                this.numFreeNodes < 16384 && (this.freeNodes[this.numFreeNodes++] = n);
                do {
                    a = this.balance(a),
                    this.fix(a),
                    a = a.parent
                } while (null != a)
            } else
                this.root = null
        },
        balance: function (t) {
            var e = t.height;
            if (e < 2)
                return t;
            var n,
            a = t.parent,
            u = t.child1,
            g = t.child2,
            p = u.height,
            f = g.height,
            m = p - f;
            if (m > 1) {
                var y = u.child1,
                S = u.child2,
                _ = y.height,
                A = S.height;
                return _ > A ? (u.child2 = t, t.parent = u, t.child1 = S, S.parent = t, t.aabb.combine(S.aabb, g.aabb), n = A - f, t.height = A - (n & n >> 31) + 1, u.aabb.combine(y.aabb, t.aabb), n = _ - e, u.height = _ - (n & n >> 31) + 1) : (u.child1 = t, t.parent = u, t.child1 = y, y.parent = t, t.aabb.combine(y.aabb, g.aabb), n = _ - f, t.height = _ - (n & n >> 31) + 1, u.aabb.combine(t.aabb, S.aabb), n = e - A, u.height = e - (n & n >> 31) + 1),
                null != a ? a.child1 == t ? a.child1 = u : a.child2 = u : this.root = u,
                u.parent = a,
                u
            }
            if (m < -1) {
                var v = g.child1,
                w = g.child2,
                E = v.height,
                x = w.height;
                return E > x ? (g.child2 = t, t.parent = g, t.child2 = w, w.parent = t, t.aabb.combine(u.aabb, w.aabb), n = p - x, t.height = p - (n & n >> 31) + 1, g.aabb.combine(v.aabb, t.aabb), n = E - e, g.height = E - (n & n >> 31) + 1) : (g.child1 = t, t.parent = g, t.child2 = v, v.parent = t, t.aabb.combine(u.aabb, v.aabb), n = p - E, t.height = p - (n & n >> 31) + 1, g.aabb.combine(t.aabb, w.aabb), n = e - x, g.height = e - (n & n >> 31) + 1),
                null != a ? a.child1 == t ? a.child1 = g : a.child2 = g : this.root = g,
                g.parent = a,
                g
            }
            return t
        },
        fix: function (t) {
            var e = t.child1,
            n = t.child2;
            t.aabb.combine(e.aabb, n.aabb),
            t.height = e.height < n.height ? n.height + 1 : e.height + 1
        }
    }),
    DBVTProxy.prototype = Object.assign(Object.create(Proxy.prototype), {
        constructor: DBVTProxy,
        update: function () {}
    }),
    DBVTBroadPhase.prototype = Object.assign(Object.create(BroadPhase.prototype), {
        constructor: DBVTBroadPhase,
        createProxy: function (t) {
            return new DBVTProxy(t)
        },
        addProxy: function (t) {
            this.tree.insertLeaf(t.leaf),
            this.leaves.push(t.leaf),
            this.numLeaves++
        },
        removeProxy: function (t) {
            this.tree.deleteLeaf(t.leaf);
            var e = this.leaves.indexOf(t.leaf);
            e > -1 && (this.leaves.splice(e, 1), this.numLeaves--)
        },
        collectPairs: function () {
            if (!(this.numLeaves < 2))
                for (var t, e = this.numLeaves; e--; )
                    (t = this.leaves[e]).proxy.aabb.intersectTestTwo(t.aabb) && (t.aabb.copy(t.proxy.aabb, .1), this.tree.deleteLeaf(t), this.tree.insertLeaf(t), this.collide(t, this.tree.root))
        },
        collide: function (t, e) {
            var n,
            a,
            u,
            g,
            p,
            f,
            m = 2;
            for (this.stack[0] = t, this.stack[1] = e; m > 0; )
                if (u = this.stack[--m], g = this.stack[--m], p = null != u.proxy, f = null != g.proxy, this.numPairChecks++, p && f) {
                    if ((n = u.proxy.shape) == (a = g.proxy.shape) || n.aabb.intersectTest(a.aabb) || !this.isAvailablePair(n, a))
                        continue;
                    this.addPair(n, a)
                } else {
                    if (u.aabb.intersectTest(g.aabb))
                        continue;
                    f || !p && u.aabb.surfaceArea() > g.aabb.surfaceArea() ? (this.stack[m++] = u.child1, this.stack[m++] = g, this.stack[m++] = u.child2, this.stack[m++] = g) : (this.stack[m++] = u, this.stack[m++] = g.child1, this.stack[m++] = u, this.stack[m++] = g.child2)
                }
        }
    }),
    Object.assign(CollisionDetector.prototype, {
        CollisionDetector: !0,
        detectCollision: function (t, e, n) {
            printError("CollisionDetector", "Inheritance error.")
        }
    }),
    BoxBoxCollisionDetector.prototype = Object.assign(Object.create(CollisionDetector.prototype), {
        constructor: BoxBoxCollisionDetector,
        detectCollision: function (t, e, n) {
            var a,
            u;
            t.id < e.id ? (a = t, u = e) : (a = e, u = t);
            var p,
            f,
            m,
            y,
            S,
            _,
            A,
            v,
            w,
            E,
            x,
            C,
            b,
            R,
            k,
            B,
            V,
            z,
            J,
            $,
            Z,
            tt,
            et,
            it,
            st,
            nt,
            at,
            ot,
            rt,
            lt,
            ht,
            dt,
            ct,
            ut,
            gt,
            pt = a.elements,
            ft = u.elements,
            mt = a.dimentions,
            yt = u.dimentions,
            St = a.position,
            _t = u.position,
            At = St.x,
            It = St.y,
            vt = St.z,
            wt = _t.x,
            Lt = _t.y,
            Et = _t.z,
            xt = wt - At,
            Ct = Lt - It,
            bt = Et - vt,
            Nt = a.halfWidth,
            Dt = a.halfHeight,
            Mt = a.halfDepth,
            Rt = u.halfWidth,
            kt = u.halfHeight,
            Tt = u.halfDepth,
            Ot = mt[0],
            Bt = mt[1],
            Pt = mt[2],
            Vt = mt[3],
            Ut = mt[4],
            zt = mt[5],
            Ft = mt[6],
            Gt = mt[7],
            Wt = mt[8],
            Ht = mt[9],
            qt = mt[10],
            Kt = mt[11],
            Jt = mt[12],
            Xt = mt[13],
            jt = mt[14],
            Qt = mt[15],
            Yt = mt[16],
            $t = mt[17],
            Zt = yt[0],
            te = yt[1],
            ee = yt[2],
            ie = yt[3],
            se = yt[4],
            ne = yt[5],
            ae = yt[6],
            oe = yt[7],
            re = yt[8],
            le = yt[9],
            he = yt[10],
            de = yt[11],
            ce = yt[12],
            ue = yt[13],
            ge = yt[14],
            pe = yt[15],
            fe = yt[16],
            me = yt[17],
            ye = Bt * ee - Pt * te,
            Se = Pt * Zt - Ot * ee,
            _e = Ot * te - Bt * Zt,
            Ae = Bt * ne - Pt * se,
            Ie = Pt * ie - Ot * ne,
            ve = Ot * se - Bt * ie,
            we = Bt * re - Pt * oe,
            Le = Pt * ae - Ot * re,
            Ee = Ot * oe - Bt * ae,
            xe = Ut * ee - zt * te,
            Ce = zt * Zt - Vt * ee,
            be = Vt * te - Ut * Zt,
            Ne = Ut * ne - zt * se,
            De = zt * ie - Vt * ne,
            Me = Vt * se - Ut * ie,
            Re = Ut * re - zt * oe,
            ke = zt * ae - Vt * re,
            Te = Vt * oe - Ut * ae,
            Oe = Gt * ee - Wt * te,
            Be = Wt * Zt - Ft * ee,
            Pe = Ft * te - Gt * Zt,
            Ve = Gt * ne - Wt * se,
            Ue = Wt * ie - Ft * ne,
            ze = Ft * se - Gt * ie,
            Fe = Gt * re - Wt * oe,
            Ge = Wt * ae - Ft * re,
            We = Ft * oe - Gt * ae,
            He = !1,
            qe = !1,
            Ke = !1,
            Je = !1,
            Xe = !1,
            je = !1,
            Qe = !1,
            Ye = !1,
            $e = !1;
            if ((p = (ht = Ot * xt + Bt * Ct + Pt * bt) > 0) || (ht = -ht), (ct = Ot * Zt + Bt * te + Pt * ee) < 0 && (ct = -ct), (ut = Ot * ie + Bt * se + Pt * ne) < 0 && (ut = -ut), (gt = Ot * ae + Bt * oe + Pt * re) < 0 && (gt = -gt), !((B = ht - (dt = Nt) - (ct * Rt + ut * kt + gt * Tt)) > 0 || ((f = (ht = Vt * xt + Ut * Ct + zt * bt) > 0) || (ht = -ht), (ct = Vt * Zt + Ut * te + zt * ee) < 0 && (ct = -ct), (ut = Vt * ie + Ut * se + zt * ne) < 0 && (ut = -ut), (gt = Vt * ae + Ut * oe + zt * re) < 0 && (gt = -gt), (V = ht - (dt = Dt) - (ct * Rt + ut * kt + gt * Tt)) > 0 || ((m = (ht = Ft * xt + Gt * Ct + Wt * bt) > 0) || (ht = -ht), (ct = Ft * Zt + Gt * te + Wt * ee) < 0 && (ct = -ct), (ut = Ft * ie + Gt * se + Wt * ne) < 0 && (ut = -ut), (gt = Ft * ae + Gt * oe + Wt * re) < 0 && (gt = -gt), (z = ht - (dt = Mt) - (ct * Rt + ut * kt + gt * Tt)) > 0 || ((y = (ht = Zt * xt + te * Ct + ee * bt) > 0) || (ht = -ht), (ct = Zt * Ot + te * Bt + ee * Pt) < 0 && (ct = -ct), (ut = Zt * Vt + te * Ut + ee * zt) < 0 && (ut = -ut), (gt = Zt * Ft + te * Gt + ee * Wt) < 0 && (gt = -gt), (J = 1 * (ht - (dt = ct * Nt + ut * Dt + gt * Mt) - Rt)) > 0 || ((S = (ht = ie * xt + se * Ct + ne * bt) > 0) || (ht = -ht), (ct = ie * Ot + se * Bt + ne * Pt) < 0 && (ct = -ct), (ut = ie * Vt + se * Ut + ne * zt) < 0 && (ut = -ut), (gt = ie * Ft + se * Gt + ne * Wt) < 0 && (gt = -gt), ($ = 1 * (ht - (dt = ct * Nt + ut * Dt + gt * Mt) - kt)) > 0 || ((_ = (ht = ae * xt + oe * Ct + re * bt) > 0) || (ht = -ht), (ct = ae * Ot + oe * Bt + re * Pt) < 0 && (ct = -ct), (ut = ae * Vt + oe * Ut + re * zt) < 0 && (ut = -ut), (gt = ae * Ft + oe * Gt + re * Wt) < 0 && (gt = -gt), (Z = 1 * (ht - (dt = ct * Nt + ut * Dt + gt * Mt) - Tt)) > 0))))))) {
                if ((ht = ye * ye + Se * Se + _e * _e) > 1e-5) {
                    if ((A = (ht = (ye *= ht = 1 / g.sqrt(ht)) * xt + (Se *= ht) * Ct + (_e *= ht) * bt) > 0) || (ht = -ht), (ct = ye * Vt + Se * Ut + _e * zt) < 0 && (ct = -ct), (ut = ye * Ft + Se * Gt + _e * Wt) < 0 && (ut = -ut), dt = ct * Dt + ut * Mt, (ct = ye * ie + Se * se + _e * ne) < 0 && (ct = -ct), (ut = ye * ae + Se * oe + _e * re) < 0 && (ut = -ut), (tt = ht - dt - (ct * kt + ut * Tt)) > 0)
                        return
                } else
                    A = !1, tt = 0, He = !0;
                if ((ht = Ae * Ae + Ie * Ie + ve * ve) > 1e-5) {
                    if ((v = (ht = (Ae *= ht = 1 / g.sqrt(ht)) * xt + (Ie *= ht) * Ct + (ve *= ht) * bt) > 0) || (ht = -ht), (ct = Ae * Vt + Ie * Ut + ve * zt) < 0 && (ct = -ct), (ut = Ae * Ft + Ie * Gt + ve * Wt) < 0 && (ut = -ut), dt = ct * Dt + ut * Mt, (ct = Ae * Zt + Ie * te + ve * ee) < 0 && (ct = -ct), (ut = Ae * ae + Ie * oe + ve * re) < 0 && (ut = -ut), (et = ht - dt - (ct * Rt + ut * Tt)) > 0)
                        return
                } else
                    v = !1, et = 0, qe = !0;
                if ((ht = we * we + Le * Le + Ee * Ee) > 1e-5) {
                    if ((w = (ht = (we *= ht = 1 / g.sqrt(ht)) * xt + (Le *= ht) * Ct + (Ee *= ht) * bt) > 0) || (ht = -ht), (ct = we * Vt + Le * Ut + Ee * zt) < 0 && (ct = -ct), (ut = we * Ft + Le * Gt + Ee * Wt) < 0 && (ut = -ut), dt = ct * Dt + ut * Mt, (ct = we * Zt + Le * te + Ee * ee) < 0 && (ct = -ct), (ut = we * ie + Le * se + Ee * ne) < 0 && (ut = -ut), (it = ht - dt - (ct * Rt + ut * kt)) > 0)
                        return
                } else
                    w = !1, it = 0, Ke = !0;
                if ((ht = xe * xe + Ce * Ce + be * be) > 1e-5) {
                    if ((E = (ht = (xe *= ht = 1 / g.sqrt(ht)) * xt + (Ce *= ht) * Ct + (be *= ht) * bt) > 0) || (ht = -ht), (ct = xe * Ot + Ce * Bt + be * Pt) < 0 && (ct = -ct), (ut = xe * Ft + Ce * Gt + be * Wt) < 0 && (ut = -ut), dt = ct * Nt + ut * Mt, (ct = xe * ie + Ce * se + be * ne) < 0 && (ct = -ct), (ut = xe * ae + Ce * oe + be * re) < 0 && (ut = -ut), (st = ht - dt - (ct * kt + ut * Tt)) > 0)
                        return
                } else
                    E = !1, st = 0, Je = !0;
                if ((ht = Ne * Ne + De * De + Me * Me) > 1e-5) {
                    if ((x = (ht = (Ne *= ht = 1 / g.sqrt(ht)) * xt + (De *= ht) * Ct + (Me *= ht) * bt) > 0) || (ht = -ht), (ct = Ne * Ot + De * Bt + Me * Pt) < 0 && (ct = -ct), (ut = Ne * Ft + De * Gt + Me * Wt) < 0 && (ut = -ut), dt = ct * Nt + ut * Mt, (ct = Ne * Zt + De * te + Me * ee) < 0 && (ct = -ct), (ut = Ne * ae + De * oe + Me * re) < 0 && (ut = -ut), (nt = ht - dt - (ct * Rt + ut * Tt)) > 0)
                        return
                } else
                    x = !1, nt = 0, Xe = !0;
                if ((ht = Re * Re + ke * ke + Te * Te) > 1e-5) {
                    if ((C = (ht = (Re *= ht = 1 / g.sqrt(ht)) * xt + (ke *= ht) * Ct + (Te *= ht) * bt) > 0) || (ht = -ht), (ct = Re * Ot + ke * Bt + Te * Pt) < 0 && (ct = -ct), (ut = Re * Ft + ke * Gt + Te * Wt) < 0 && (ut = -ut), dt = ct * Nt + ut * Mt, (ct = Re * Zt + ke * te + Te * ee) < 0 && (ct = -ct), (ut = Re * ie + ke * se + Te * ne) < 0 && (ut = -ut), (at = ht - dt - (ct * Rt + ut * kt)) > 0)
                        return
                } else
                    C = !1, at = 0, je = !0;
                if ((ht = Oe * Oe + Be * Be + Pe * Pe) > 1e-5) {
                    if ((b = (ht = (Oe *= ht = 1 / g.sqrt(ht)) * xt + (Be *= ht) * Ct + (Pe *= ht) * bt) > 0) || (ht = -ht), (ct = Oe * Ot + Be * Bt + Pe * Pt) < 0 && (ct = -ct), (ut = Oe * Vt + Be * Ut + Pe * zt) < 0 && (ut = -ut), dt = ct * Nt + ut * Dt, (ct = Oe * ie + Be * se + Pe * ne) < 0 && (ct = -ct), (ut = Oe * ae + Be * oe + Pe * re) < 0 && (ut = -ut), (ot = ht - dt - (ct * kt + ut * Tt)) > 0)
                        return
                } else
                    b = !1, ot = 0, Qe = !0;
                if ((ht = Ve * Ve + Ue * Ue + ze * ze) > 1e-5) {
                    if ((R = (ht = (Ve *= ht = 1 / g.sqrt(ht)) * xt + (Ue *= ht) * Ct + (ze *= ht) * bt) > 0) || (ht = -ht), (ct = Ve * Ot + Ue * Bt + ze * Pt) < 0 && (ct = -ct), (ut = Ve * Vt + Ue * Ut + ze * zt) < 0 && (ut = -ut), dt = ct * Nt + ut * Dt, (ct = Ve * Zt + Ue * te + ze * ee) < 0 && (ct = -ct), (ut = Ve * ae + Ue * oe + ze * re) < 0 && (ut = -ut), (rt = ht - dt - (ct * Rt + ut * Tt)) > 0)
                        return
                } else
                    R = !1, rt = 0, Ye = !0;
                if ((ht = Fe * Fe + Ge * Ge + We * We) > 1e-5) {
                    if ((k = (ht = (Fe *= ht = 1 / g.sqrt(ht)) * xt + (Ge *= ht) * Ct + (We *= ht) * bt) > 0) || (ht = -ht), (ct = Fe * Ot + Ge * Bt + We * Pt) < 0 && (ct = -ct), (ut = Fe * Vt + Ge * Ut + We * zt) < 0 && (ut = -ut), dt = ct * Nt + ut * Dt, (ct = Fe * Zt + Ge * te + We * ee) < 0 && (ct = -ct), (ut = Fe * ie + Ge * se + We * ne) < 0 && (ut = -ut), (lt = ht - dt - (ct * Rt + ut * kt)) > 0)
                        return
                } else
                    k = !1, lt = 0, $e = !0;
                var Ze = B,
                ti = B,
                ei = 0,
                ii = p;
                V > ti && (Ze = V, ti = V, ei = 1, ii = f),
                z > ti && (Ze = z, ti = z, ei = 2, ii = m),
                J > ti && (Ze = J, ti = J, ei = 3, ii = y),
                $ > ti && (Ze = $, ti = $, ei = 4, ii = S),
                Z > ti && (Ze = Z, ti = Z, ei = 5, ii = _),
                tt - .01 > ti && !He && (Ze = tt, ti = tt - .01, ei = 6, ii = A),
                et - .01 > ti && !qe && (Ze = et, ti = et - .01, ei = 7, ii = v),
                it - .01 > ti && !Ke && (Ze = it, ti = it - .01, ei = 8, ii = w),
                st - .01 > ti && !Je && (Ze = st, ti = st - .01, ei = 9, ii = E),
                nt - .01 > ti && !Xe && (Ze = nt, ti = nt - .01, ei = 10, ii = x),
                at - .01 > ti && !je && (Ze = at, ti = at - .01, ei = 11, ii = C),
                ot - .01 > ti && !Qe && (Ze = ot, ti = ot - .01, ei = 12, ii = b),
                rt - .01 > ti && !Ye && (Ze = rt, ti = rt - .01, ei = 13, ii = R),
                lt - .01 > ti && !$e && (Ze = lt, ei = 14, ii = k);
                var si = 0,
                ni = 0,
                ai = 0,
                oi = 0,
                ri = 0,
                li = 0,
                hi = 0,
                di = 0,
                ci = 0,
                ui = 0,
                gi = 0,
                pi = 0,
                fi = 0,
                mi = 0,
                yi = 0,
                Si = 0,
                _i = 0,
                Ai = 0,
                Ii = !1;
                if (0 == ei ? (ii ? (ui = At + Ht, gi = It + qt, pi = vt + Kt, si = Ot, ni = Bt, ai = Pt) : (ui = At - Ht, gi = It - qt, pi = vt - Kt, si = -Ot, ni = -Bt, ai = -Pt), fi = Jt, mi = Xt, yi = jt, oi = -Vt, ri = -Ut, li = -zt, Si = Qt, _i = Yt, Ai = $t, hi = -Ft, di = -Gt, ci = -Wt) : 1 == ei ? (ii ? (ui = At + Jt, gi = It + Xt, pi = vt + jt, si = Vt, ni = Ut, ai = zt) : (ui = At - Jt, gi = It - Xt, pi = vt - jt, si = -Vt, ni = -Ut, ai = -zt), fi = Ht, mi = qt, yi = Kt, oi = -Ot, ri = -Bt, li = -Pt, Si = Qt, _i = Yt, Ai = $t, hi = -Ft, di = -Gt, ci = -Wt) : 2 == ei ? (ii ? (ui = At + Qt, gi = It + Yt, pi = vt + $t, si = Ft, ni = Gt, ai = Wt) : (ui = At - Qt, gi = It - Yt, pi = vt - $t, si = -Ft, ni = -Gt, ai = -Wt), fi = Ht, mi = qt, yi = Kt, oi = -Ot, ri = -Bt, li = -Pt, Si = Jt, _i = Xt, Ai = jt, hi = -Vt, di = -Ut, ci = -zt) : 3 == ei ? (Ii = !0, ii ? (ui = wt - le, gi = Lt - he, pi = Et - de, si = -Zt, ni = -te, ai = -ee) : (ui = wt + le, gi = Lt + he, pi = Et + de, si = Zt, ni = te, ai = ee), fi = ce, mi = ue, yi = ge, oi = -ie, ri = -se, li = -ne, Si = pe, _i = fe, Ai = me, hi = -ae, di = -oe, ci = -re) : 4 == ei ? (Ii = !0, ii ? (ui = wt - ce, gi = Lt - ue, pi = Et - ge, si = -ie, ni = -se, ai = -ne) : (ui = wt + ce, gi = Lt + ue, pi = Et + ge, si = ie, ni = se, ai = ne), fi = le, mi = he, yi = de, oi = -Zt, ri = -te, li = -ee, Si = pe, _i = fe, Ai = me, hi = -ae, di = -oe, ci = -re) : 5 == ei ? (Ii = !0, ii ? (ui = wt - pe, gi = Lt - fe, pi = Et - me, si = -ae, ni = -oe, ai = -re) : (ui = wt + pe, gi = Lt + fe, pi = Et + me, si = ae, ni = oe, ai = re), fi = le, mi = he, yi = de, oi = -Zt, ri = -te, li = -ee, Si = ce, _i = ue, Ai = ge, hi = -ie, di = -se, ci = -ne) : 6 == ei ? (si = ye, ni = Se, ai = _e, oi = Ot, ri = Bt, li = Pt, hi = Zt, di = te, ci = ee) : 7 == ei ? (si = Ae, ni = Ie, ai = ve, oi = Ot, ri = Bt, li = Pt, hi = ie, di = se, ci = ne) : 8 == ei ? (si = we, ni = Le, ai = Ee, oi = Ot, ri = Bt, li = Pt, hi = ae, di = oe, ci = re) : 9 == ei ? (si = xe, ni = Ce, ai = be, oi = Vt, ri = Ut, li = zt, hi = Zt, di = te, ci = ee) : 10 == ei ? (si = Ne, ni = De, ai = Me, oi = Vt, ri = Ut, li = zt, hi = ie, di = se, ci = ne) : 11 == ei ? (si = Re, ni = ke, ai = Te, oi = Vt, ri = Ut, li = zt, hi = ae, di = oe, ci = re) : 12 == ei ? (si = Oe, ni = Be, ai = Pe, oi = Ft, ri = Gt, li = Wt, hi = Zt, di = te, ci = ee) : 13 == ei ? (si = Ve, ni = Ue, ai = ze, oi = Ft, ri = Gt, li = Wt, hi = ie, di = se, ci = ne) : 14 == ei && (si = Fe, ni = Ge, ai = We, oi = Ft, ri = Gt, li = Wt, hi = ae, di = oe, ci = re), ei > 5) {
                    var vi,
                    wi,
                    Li,
                    Ei,
                    xi,
                    Ci,
                    bi,
                    Ni,
                    Di,
                    Mi,
                    Ri;
                    ii || (si = -si, ni = -ni, ai = -ai),
                    wi = si * (Ci = pt[0]) + ni * (bi = pt[1]) + ai * (Ni = pt[2]),
                    (vi = si * (Li = pt[3]) + ni * (Ei = pt[4]) + ai * (xi = pt[5])) > wi && (wi = vi, Ci = Li, bi = Ei, Ni = xi),
                    (vi = si * (Li = pt[6]) + ni * (Ei = pt[7]) + ai * (xi = pt[8])) > wi && (wi = vi, Ci = Li, bi = Ei, Ni = xi),
                    (vi = si * (Li = pt[9]) + ni * (Ei = pt[10]) + ai * (xi = pt[11])) > wi && (wi = vi, Ci = Li, bi = Ei, Ni = xi),
                    (vi = si * (Li = pt[12]) + ni * (Ei = pt[13]) + ai * (xi = pt[14])) > wi && (wi = vi, Ci = Li, bi = Ei, Ni = xi),
                    (vi = si * (Li = pt[15]) + ni * (Ei = pt[16]) + ai * (xi = pt[17])) > wi && (wi = vi, Ci = Li, bi = Ei, Ni = xi),
                    (vi = si * (Li = pt[18]) + ni * (Ei = pt[19]) + ai * (xi = pt[20])) > wi && (wi = vi, Ci = Li, bi = Ei, Ni = xi),
                    (vi = si * (Li = pt[21]) + ni * (Ei = pt[22]) + ai * (xi = pt[23])) > wi && (wi = vi, Ci = Li, bi = Ei, Ni = xi),
                    wi = si * (Di = ft[0]) + ni * (Mi = ft[1]) + ai * (Ri = ft[2]),
                    (vi = si * (Li = ft[3]) + ni * (Ei = ft[4]) + ai * (xi = ft[5])) < wi && (wi = vi, Di = Li, Mi = Ei, Ri = xi),
                    (vi = si * (Li = ft[6]) + ni * (Ei = ft[7]) + ai * (xi = ft[8])) < wi && (wi = vi, Di = Li, Mi = Ei, Ri = xi),
                    (vi = si * (Li = ft[9]) + ni * (Ei = ft[10]) + ai * (xi = ft[11])) < wi && (wi = vi, Di = Li, Mi = Ei, Ri = xi),
                    (vi = si * (Li = ft[12]) + ni * (Ei = ft[13]) + ai * (xi = ft[14])) < wi && (wi = vi, Di = Li, Mi = Ei, Ri = xi),
                    (vi = si * (Li = ft[15]) + ni * (Ei = ft[16]) + ai * (xi = ft[17])) < wi && (wi = vi, Di = Li, Mi = Ei, Ri = xi),
                    (vi = si * (Li = ft[18]) + ni * (Ei = ft[19]) + ai * (xi = ft[20])) < wi && (wi = vi, Di = Li, Mi = Ei, Ri = xi),
                    (vi = si * (Li = ft[21]) + ni * (Ei = ft[22]) + ai * (xi = ft[23])) < wi && (wi = vi, Di = Li, Mi = Ei, Ri = xi);
                    var ki = ((Li = Di - Ci) * (oi - hi * (ct = oi * hi + ri * di + li * ci)) + (Ei = Mi - bi) * (ri - di * ct) + (xi = Ri - Ni) * (li - ci * ct)) / (1 - ct * ct);
                    n.addPoint(Ci + oi * ki + si * Ze * .5, bi + ri * ki + ni * Ze * .5, Ni + li * ki + ai * Ze * .5, si, ni, ai, Ze, !1)
                } else {
                    var Ti,
                    Oi,
                    Bi,
                    Pi,
                    Vi,
                    Ui,
                    zi,
                    Fi,
                    Gi,
                    Wi,
                    Hi,
                    qi,
                    Ki,
                    Ji,
                    Xi,
                    ji,
                    Qi,
                    Yi,
                    $i,
                    Zi,
                    ts,
                    es = 1,
                    is = 0,
                    ss = 0;
                    Ii ? ((is = Ot * si + Bt * ni + Pt * ai) < es && (es = is, ss = 0), -is < es && (es = -is, ss = 1), (is = Vt * si + Ut * ni + zt * ai) < es && (es = is, ss = 2), -is < es && (es = -is, ss = 3), (is = Ft * si + Gt * ni + Wt * ai) < es && (es = is, ss = 4), -is < es && (es = -is, ss = 5), 0 == ss ? (Ti = pt[0], Oi = pt[1], Bi = pt[2], Pi = pt[6], Vi = pt[7], Ui = pt[8], zi = pt[9], Fi = pt[10], Gi = pt[11], Wi = pt[3], Hi = pt[4], qi = pt[5]) : 1 == ss ? (Ti = pt[15], Oi = pt[16], Bi = pt[17], Pi = pt[21], Vi = pt[22], Ui = pt[23], zi = pt[18], Fi = pt[19], Gi = pt[20], Wi = pt[12], Hi = pt[13], qi = pt[14]) : 2 == ss ? (Ti = pt[12], Oi = pt[13], Bi = pt[14], Pi = pt[0], Vi = pt[1], Ui = pt[2], zi = pt[3], Fi = pt[4], Gi = pt[5], Wi = pt[15], Hi = pt[16], qi = pt[17]) : 3 == ss ? (Ti = pt[21], Oi = pt[22], Bi = pt[23], Pi = pt[9], Vi = pt[10], Ui = pt[11], zi = pt[6], Fi = pt[7], Gi = pt[8], Wi = pt[18], Hi = pt[19], qi = pt[20]) : 4 == ss ? (Ti = pt[12], Oi = pt[13], Bi = pt[14], Pi = pt[18], Vi = pt[19], Ui = pt[20], zi = pt[6], Fi = pt[7], Gi = pt[8], Wi = pt[0], Hi = pt[1], qi = pt[2]) : 5 == ss && (Ti = pt[3], Oi = pt[4], Bi = pt[5], Pi = ft[9], Vi = ft[10], Ui = ft[11], zi = pt[21], Fi = pt[22], Gi = pt[23], Wi = pt[15], Hi = pt[16], qi = pt[17])) : ((is = Zt * si + te * ni + ee * ai) < es && (es = is, ss = 0), -is < es && (es = -is, ss = 1), (is = ie * si + se * ni + ne * ai) < es && (es = is, ss = 2), -is < es && (es = -is, ss = 3), (is = ae * si + oe * ni + re * ai) < es && (es = is, ss = 4), -is < es && (es = -is, ss = 5), 0 == ss ? (Ti = ft[0], Oi = ft[1], Bi = ft[2], Pi = ft[6], Vi = ft[7], Ui = ft[8], zi = ft[9], Fi = ft[10], Gi = ft[11], Wi = ft[3], Hi = ft[4], qi = ft[5]) : 1 == ss ? (Ti = ft[15], Oi = ft[16], Bi = ft[17], Pi = ft[21], Vi = ft[22], Ui = ft[23], zi = ft[18], Fi = ft[19], Gi = ft[20], Wi = ft[12], Hi = ft[13], qi = ft[14]) : 2 == ss ? (Ti = ft[12], Oi = ft[13], Bi = ft[14], Pi = ft[0], Vi = ft[1], Ui = ft[2], zi = ft[3], Fi = ft[4], Gi = ft[5], Wi = ft[15], Hi = ft[16], qi = ft[17]) : 3 == ss ? (Ti = ft[21], Oi = ft[22], Bi = ft[23], Pi = ft[9], Vi = ft[10], Ui = ft[11], zi = ft[6], Fi = ft[7], Gi = ft[8], Wi = ft[18], Hi = ft[19], qi = ft[20]) : 4 == ss ? (Ti = ft[12], Oi = ft[13], Bi = ft[14], Pi = ft[18], Vi = ft[19], Ui = ft[20], zi = ft[6], Fi = ft[7], Gi = ft[8], Wi = ft[0], Hi = ft[1], qi = ft[2]) : 5 == ss && (Ti = ft[3], Oi = ft[4], Bi = ft[5], Pi = ft[9], Vi = ft[10], Ui = ft[11], zi = ft[21], Fi = ft[22], Gi = ft[23], Wi = ft[15], Hi = ft[16], qi = ft[17])),
                    this.clipVertices1[0] = Ti,
                    this.clipVertices1[1] = Oi,
                    this.clipVertices1[2] = Bi,
                    this.clipVertices1[3] = Pi,
                    this.clipVertices1[4] = Vi,
                    this.clipVertices1[5] = Ui,
                    this.clipVertices1[6] = zi,
                    this.clipVertices1[7] = Fi,
                    this.clipVertices1[8] = Gi,
                    this.clipVertices1[9] = Wi,
                    this.clipVertices1[10] = Hi,
                    this.clipVertices1[11] = qi,
                    Ji = 0,
                    ct = ((ji = this.clipVertices1[9]) - ui - fi) * oi + ((Qi = this.clipVertices1[10]) - gi - mi) * ri + ((Yi = this.clipVertices1[11]) - pi - yi) * li;
                    for (var ns = 0; ns < 4; ns++)
                        Xi = 3 * ns, ut = (($i = this.clipVertices1[Xi]) - ui - fi) * oi + ((Zi = this.clipVertices1[Xi + 1]) - gi - mi) * ri + ((ts = this.clipVertices1[Xi + 2]) - pi - yi) * li, ct > 0 ? ut > 0 ? (Xi = 3 * Ji, Ji++, this.clipVertices2[Xi] = $i, this.clipVertices2[Xi + 1] = Zi, this.clipVertices2[Xi + 2] = ts) : (Xi = 3 * Ji, Ji++, ki = ct / (ct - ut), this.clipVertices2[Xi] = ji + ($i - ji) * ki, this.clipVertices2[Xi + 1] = Qi + (Zi - Qi) * ki, this.clipVertices2[Xi + 2] = Yi + (ts - Yi) * ki) : ut > 0 && (Xi = 3 * Ji, Ji++, ki = ct / (ct - ut), this.clipVertices2[Xi] = ji + ($i - ji) * ki, this.clipVertices2[Xi + 1] = Qi + (Zi - Qi) * ki, this.clipVertices2[Xi + 2] = Yi + (ts - Yi) * ki, Xi = 3 * Ji, Ji++, this.clipVertices2[Xi] = $i, this.clipVertices2[Xi + 1] = Zi, this.clipVertices2[Xi + 2] = ts), ji = $i, Qi = Zi, Yi = ts, ct = ut;
                    if (0 != (Ki = Ji)) {
                        for (Ji = 0, Xi = 3 * (Ki - 1), ct = ((ji = this.clipVertices2[Xi]) - ui - Si) * hi + ((Qi = this.clipVertices2[Xi + 1]) - gi - _i) * di + ((Yi = this.clipVertices2[Xi + 2]) - pi - Ai) * ci, ns = 0; ns < Ki; ns++)
                            Xi = 3 * ns, ut = (($i = this.clipVertices2[Xi]) - ui - Si) * hi + ((Zi = this.clipVertices2[Xi + 1]) - gi - _i) * di + ((ts = this.clipVertices2[Xi + 2]) - pi - Ai) * ci, ct > 0 ? ut > 0 ? (Xi = 3 * Ji, Ji++, this.clipVertices1[Xi] = $i, this.clipVertices1[Xi + 1] = Zi, this.clipVertices1[Xi + 2] = ts) : (Xi = 3 * Ji, Ji++, ki = ct / (ct - ut), this.clipVertices1[Xi] = ji + ($i - ji) * ki, this.clipVertices1[Xi + 1] = Qi + (Zi - Qi) * ki, this.clipVertices1[Xi + 2] = Yi + (ts - Yi) * ki) : ut > 0 && (Xi = 3 * Ji, Ji++, ki = ct / (ct - ut), this.clipVertices1[Xi] = ji + ($i - ji) * ki, this.clipVertices1[Xi + 1] = Qi + (Zi - Qi) * ki, this.clipVertices1[Xi + 2] = Yi + (ts - Yi) * ki, Xi = 3 * Ji, Ji++, this.clipVertices1[Xi] = $i, this.clipVertices1[Xi + 1] = Zi, this.clipVertices1[Xi + 2] = ts), ji = $i, Qi = Zi, Yi = ts, ct = ut;
                        if (0 != (Ki = Ji)) {
                            for (Ji = 0, Xi = 3 * (Ki - 1), ct = ((ji = this.clipVertices1[Xi]) - ui + fi) * -oi + ((Qi = this.clipVertices1[Xi + 1]) - gi + mi) * -ri + ((Yi = this.clipVertices1[Xi + 2]) - pi + yi) * -li, ns = 0; ns < Ki; ns++)
                                Xi = 3 * ns, ut = (($i = this.clipVertices1[Xi]) - ui + fi) * -oi + ((Zi = this.clipVertices1[Xi + 1]) - gi + mi) * -ri + ((ts = this.clipVertices1[Xi + 2]) - pi + yi) * -li, ct > 0 ? ut > 0 ? (Xi = 3 * Ji, Ji++, this.clipVertices2[Xi] = $i, this.clipVertices2[Xi + 1] = Zi, this.clipVertices2[Xi + 2] = ts) : (Xi = 3 * Ji, Ji++, ki = ct / (ct - ut), this.clipVertices2[Xi] = ji + ($i - ji) * ki, this.clipVertices2[Xi + 1] = Qi + (Zi - Qi) * ki, this.clipVertices2[Xi + 2] = Yi + (ts - Yi) * ki) : ut > 0 && (Xi = 3 * Ji, Ji++, ki = ct / (ct - ut), this.clipVertices2[Xi] = ji + ($i - ji) * ki, this.clipVertices2[Xi + 1] = Qi + (Zi - Qi) * ki, this.clipVertices2[Xi + 2] = Yi + (ts - Yi) * ki, Xi = 3 * Ji, Ji++, this.clipVertices2[Xi] = $i, this.clipVertices2[Xi + 1] = Zi, this.clipVertices2[Xi + 2] = ts), ji = $i, Qi = Zi, Yi = ts, ct = ut;
                            if (0 != (Ki = Ji)) {
                                for (Ji = 0, Xi = 3 * (Ki - 1), ct = ((ji = this.clipVertices2[Xi]) - ui + Si) * -hi + ((Qi = this.clipVertices2[Xi + 1]) - gi + _i) * -di + ((Yi = this.clipVertices2[Xi + 2]) - pi + Ai) * -ci, ns = 0; ns < Ki; ns++)
                                    Xi = 3 * ns, ut = (($i = this.clipVertices2[Xi]) - ui + Si) * -hi + ((Zi = this.clipVertices2[Xi + 1]) - gi + _i) * -di + ((ts = this.clipVertices2[Xi + 2]) - pi + Ai) * -ci, ct > 0 ? ut > 0 ? (Xi = 3 * Ji, Ji++, this.clipVertices1[Xi] = $i, this.clipVertices1[Xi + 1] = Zi, this.clipVertices1[Xi + 2] = ts) : (Xi = 3 * Ji, Ji++, ki = ct / (ct - ut), this.clipVertices1[Xi] = ji + ($i - ji) * ki, this.clipVertices1[Xi + 1] = Qi + (Zi - Qi) * ki, this.clipVertices1[Xi + 2] = Yi + (ts - Yi) * ki) : ut > 0 && (Xi = 3 * Ji, Ji++, ki = ct / (ct - ut), this.clipVertices1[Xi] = ji + ($i - ji) * ki, this.clipVertices1[Xi + 1] = Qi + (Zi - Qi) * ki, this.clipVertices1[Xi + 2] = Yi + (ts - Yi) * ki, Xi = 3 * Ji, Ji++, this.clipVertices1[Xi] = $i, this.clipVertices1[Xi + 1] = Zi, this.clipVertices1[Xi + 2] = ts), ji = $i, Qi = Zi, Yi = ts, ct = ut;
                                if (Ii) {
                                    var as = a;
                                    a = u,
                                    u = as
                                }
                                if (0 != (Ki = Ji)) {
                                    var os = a != t;
                                    if (Ki > 4) {
                                        oi = Ti - (ji = .25 * (Ti + Pi + zi + Wi)),
                                        ri = Oi - (Qi = .25 * (Oi + Vi + Fi + Hi)),
                                        li = Bi - (Yi = .25 * (Bi + Ui + Gi + qi)),
                                        hi = Pi - ji,
                                        di = Vi - Qi,
                                        ci = Ui - Yi;
                                        var rs = 0,
                                        ls = 0,
                                        hs = 0,
                                        ds = 0,
                                        cs = -this.INF;
                                        for (es = this.INF, ns = 0; ns < Ki; ns++)
                                            this.used[ns] = !1, Xi = 3 * ns, (is = (ji = this.clipVertices1[Xi]) * oi + (Qi = this.clipVertices1[Xi + 1]) * ri + (Yi = this.clipVertices1[Xi + 2]) * li) < es && (es = is, rs = ns), is > cs && (cs = is, hs = ns);
                                        for (this.used[rs] = !0, this.used[hs] = !0, cs = -this.INF, es = this.INF, ns = 0; ns < Ki; ns++)
                                            this.used[ns] || (Xi = 3 * ns, (is = (ji = this.clipVertices1[Xi]) * hi + (Qi = this.clipVertices1[Xi + 1]) * di + (Yi = this.clipVertices1[Xi + 2]) * ci) < es && (es = is, ls = ns), is > cs && (cs = is, ds = ns));
                                        Xi = 3 * rs,
                                        (is = ((ji = this.clipVertices1[Xi]) - ui) * si + ((Qi = this.clipVertices1[Xi + 1]) - gi) * ni + ((Yi = this.clipVertices1[Xi + 2]) - pi) * ai) < 0 && n.addPoint(ji, Qi, Yi, si, ni, ai, is, os),
                                        Xi = 3 * ls,
                                        (is = ((ji = this.clipVertices1[Xi]) - ui) * si + ((Qi = this.clipVertices1[Xi + 1]) - gi) * ni + ((Yi = this.clipVertices1[Xi + 2]) - pi) * ai) < 0 && n.addPoint(ji, Qi, Yi, si, ni, ai, is, os),
                                        Xi = 3 * hs,
                                        (is = ((ji = this.clipVertices1[Xi]) - ui) * si + ((Qi = this.clipVertices1[Xi + 1]) - gi) * ni + ((Yi = this.clipVertices1[Xi + 2]) - pi) * ai) < 0 && n.addPoint(ji, Qi, Yi, si, ni, ai, is, os),
                                        Xi = 3 * ds,
                                        (is = ((ji = this.clipVertices1[Xi]) - ui) * si + ((Qi = this.clipVertices1[Xi + 1]) - gi) * ni + ((Yi = this.clipVertices1[Xi + 2]) - pi) * ai) < 0 && n.addPoint(ji, Qi, Yi, si, ni, ai, is, os)
                                    } else
                                        for (ns = 0; ns < Ki; ns++)
                                            Xi = 3 * ns, (is = ((ji = this.clipVertices1[Xi]) - ui) * si + ((Qi = this.clipVertices1[Xi + 1]) - gi) * ni + ((Yi = this.clipVertices1[Xi + 2]) - pi) * ai) < 0 && n.addPoint(ji, Qi, Yi, si, ni, ai, is, os)
                                }
                            }
                        }
                    }
                }
            }
        }
    }),
    BoxCylinderCollisionDetector.prototype = Object.assign(Object.create(CollisionDetector.prototype), {
        constructor: BoxCylinderCollisionDetector,
        getSep: function (t, e, n, a, u) {
            var p,
            f,
            m,
            y,
            S,
            _,
            A,
            v,
            w,
            E,
            x,
            C,
            b,
            R = new Vec3,
            k = t.position.x,
            B = t.position.y,
            V = t.position.z,
            z = e.position.x,
            J = e.position.y,
            $ = e.position.z,
            Z = z - k,
            tt = J - B,
            et = $ - V;
            Z * Z + tt * tt + et * et == 0 && (tt = .001);
            var it = -Z,
            st = -tt,
            nt = -et;
            this.supportPointB(t, -it, -st, -nt, R);
            var at = R.x,
            ot = R.y,
            rt = R.z;
            this.supportPointC(e, it, st, nt, R);
            var lt = R.x,
            ht = R.y,
            dt = R.z,
            ct = lt - at,
            ut = ht - ot,
            gt = dt - rt;
            if (ct * it + ut * st + gt * nt <= 0)
                return !1;
            if ((it = ut * et - gt * tt) * it + (st = gt * Z - ct * et) * st + (nt = ct * tt - ut * Z) * nt == 0)
                return n.set(ct - Z, ut - tt, gt - et).normalize(), a.set(.5 * (at + lt), .5 * (ot + ht), .5 * (rt + dt)), !0;
            this.supportPointB(t, -it, -st, -nt, R);
            var pt = R.x,
            ft = R.y,
            mt = R.z;
            this.supportPointC(e, it, st, nt, R);
            var yt = R.x,
            St = R.y,
            _t = R.z,
            At = yt - pt,
            It = St - ft,
            vt = _t - mt;
            if (At * it + It * st + vt * nt <= 0)
                return !1;
            (it = (f = ut - tt) * (_ = vt - et) - (m = gt - et) * (S = It - tt)) * Z + (st = m * (y = At - Z) - (p = ct - Z) * _) * tt + (nt = p * S - f * y) * et > 0 && (p = ct, f = ut, m = gt, ct = At, ut = It, gt = vt, At = p, It = f, vt = m, p = at, f = ot, m = rt, at = pt, ot = ft, rt = mt, pt = p, ft = f, mt = m, p = lt, f = ht, m = dt, lt = yt, ht = St, dt = _t, yt = p, St = f, _t = m, it = -it, st = -st, nt = -nt);
            for (var wt = 0; ; ) {
                if (++wt > 100)
                    return !1;
                this.supportPointB(t, -it, -st, -nt, R);
                var Lt = R.x,
                Et = R.y,
                xt = R.z;
                this.supportPointC(e, it, st, nt, R);
                var Ct = R.x,
                bt = R.y,
                Nt = R.z,
                Dt = Ct - Lt,
                Mt = bt - Et,
                Rt = Nt - xt;
                if (Dt * it + Mt * st + Rt * nt <= 0)
                    return !1;
                if ((ut * Rt - gt * Mt) * Z + (gt * Dt - ct * Rt) * tt + (ct * Mt - ut * Dt) * et < 0)
                    At = Dt, It = Mt, vt = Rt, pt = Lt, ft = Et, mt = xt, yt = Ct, St = bt, _t = Nt, it = (f = ut - tt) * (_ = Rt - et) - (m = gt - et) * (S = Mt - tt), st = m * (y = Dt - Z) - (p = ct - Z) * _, nt = p * S - f * y;
                else if ((Mt * vt - Rt * It) * Z + (Rt * At - Dt * vt) * tt + (Dt * It - Mt * At) * et < 0)
                    ct = Dt, ut = Mt, gt = Rt, at = Lt, ot = Et, rt = xt, lt = Ct, ht = bt, dt = Nt, it = (f = Mt - tt) * (_ = vt - et) - (m = Rt - et) * (S = It - tt), st = m * (y = At - Z) - (p = Dt - Z) * _, nt = p * S - f * y;
                else
                    for (var kt = !1; ; ) {
                        if (it = (f = It - ut) * (_ = Rt - gt) - (m = vt - gt) * (S = Mt - ut), st = m * (y = Dt - ct) - (p = At - ct) * _, nt = p * S - f * y, (it *= A = 1 / g.sqrt(it * it + st * st + nt * nt)) * ct + (st *= A) * ut + (nt *= A) * gt >= 0 && !kt) {
                            var Tt = (ut * vt - gt * It) * Dt + (gt * At - ct * vt) * Mt + (ct * It - ut * At) * Rt,
                            Ot = (Mt * vt - Rt * It) * Z + (Rt * At - Dt * vt) * tt + (Dt * It - Mt * At) * et,
                            Bt = (tt * gt - et * ut) * Dt + (et * ct - Z * gt) * Mt + (Z * ut - tt * ct) * Rt,
                            Pt = (It * gt - vt * ut) * Z + (vt * ct - At * gt) * tt + (At * ut - It * ct) * et,
                            Vt = Tt + Ot + Bt + Pt;
                            Vt <= 0 && (Tt = 0, Vt = (Ot = (It * Rt - vt * Mt) * it + (vt * Dt - At * Rt) * st + (At * Mt - It * Dt) * nt) + (Bt = (Mt * vt - Rt * It) * it + (Rt * At - Dt * vt) * st + (Dt * It - Mt * At) * nt) + (Pt = (ut * vt - gt * It) * it + (gt * At - ct * vt) * st + (ct * It - ut * At) * nt));
                            var Ut = 1 / Vt;
                            v = (k * Tt + at * Ot + pt * Bt + Lt * Pt) * Ut,
                            w = (B * Tt + ot * Ot + ft * Bt + Et * Pt) * Ut,
                            E = (V * Tt + rt * Ot + mt * Bt + xt * Pt) * Ut,
                            x = (z * Tt + lt * Ot + yt * Bt + Ct * Pt) * Ut,
                            C = (J * Tt + ht * Ot + St * Bt + bt * Pt) * Ut,
                            b = ($ * Tt + dt * Ot + _t * Bt + Nt * Pt) * Ut,
                            kt = !0
                        }
                        this.supportPointB(t, -it, -st, -nt, R);
                        var zt = R.x,
                        Ft = R.y,
                        Gt = R.z;
                        this.supportPointC(e, it, st, nt, R);
                        var Wt = R.x,
                        Ht = R.y,
                        qt = R.z,
                        Kt = Wt - zt,
                        Jt = Ht - Ft,
                        Xt = qt - Gt,
                        jt =  - (Kt * it + Jt * st + Xt * nt);
                        if ((Kt - Dt) * it + (Jt - Mt) * st + (Xt - Rt) * nt <= .01 || jt >= 0)
                            return !!kt && (n.set(-it, -st, -nt), a.set(.5 * (v + x), .5 * (w + C), .5 * (E + b)), u.x = jt, !0);
                        (Jt * gt - Xt * ut) * Z + (Xt * ct - Kt * gt) * tt + (Kt * ut - Jt * ct) * et < 0 ? (Jt * vt - Xt * It) * Z + (Xt * At - Kt * vt) * tt + (Kt * It - Jt * At) * et < 0 ? (ct = Kt, ut = Jt, gt = Xt, at = zt, ot = Ft, rt = Gt, lt = Wt, ht = Ht, dt = qt) : (Dt = Kt, Mt = Jt, Rt = Xt, Lt = zt, Et = Ft, xt = Gt, Ct = Wt, bt = Ht, Nt = qt) : (Jt * Rt - Xt * Mt) * Z + (Xt * Dt - Kt * Rt) * tt + (Kt * Mt - Jt * Dt) * et < 0 ? (At = Kt, It = Jt, vt = Xt, pt = zt, ft = Ft, mt = Gt, yt = Wt, St = Ht, _t = qt) : (ct = Kt, ut = Jt, gt = Xt, at = zt, ot = Ft, rt = Gt, lt = Wt, ht = Ht, dt = qt)
                    }
            }
        },
        supportPointB: function (t, e, n, a, u) {
            var g,
            p,
            f,
            m = t.rotation.elements,
            y = m[0] * e + m[3] * n + m[6] * a,
            S = m[1] * e + m[4] * n + m[7] * a,
            _ = m[2] * e + m[5] * n + m[8] * a,
            A = t.halfWidth,
            v = t.halfHeight,
            w = t.halfDepth;
            g = y < 0 ? -A : A,
            p = S < 0 ? -v : v,
            f = _ < 0 ? -w : w,
            y = m[0] * g + m[1] * p + m[2] * f + t.position.x,
            S = m[3] * g + m[4] * p + m[5] * f + t.position.y,
            _ = m[6] * g + m[7] * p + m[8] * f + t.position.z,
            u.set(y, S, _)
        },
        supportPointC: function (t, e, n, a, u) {
            var p,
            f,
            m,
            y = t.rotation.elements,
            S = y[0] * e + y[3] * n + y[6] * a,
            _ = y[1] * e + y[4] * n + y[7] * a,
            A = y[2] * e + y[5] * n + y[8] * a,
            v = S,
            w = A,
            E = v * v + w * w,
            x = t.radius,
            C = t.halfHeight;
            0 == E ? _ < 0 ? (p = x, f = -C, m = 0) : (p = x, f = C, m = 0) : (E = t.radius / g.sqrt(E), _ < 0 ? (p = v * E, f = -C, m = w * E) : (p = v * E, f = C, m = w * E)),
            S = y[0] * p + y[1] * f + y[2] * m + t.position.x,
            _ = y[3] * p + y[4] * f + y[5] * m + t.position.y,
            A = y[6] * p + y[7] * f + y[8] * m + t.position.z,
            u.set(S, _, A)
        },
        detectCollision: function (t, e, n) {
            var a,
            u;
            this.flip ? (a = e, u = t) : (a = t, u = e);
            var p = new Vec3,
            f = new Vec3,
            m = new Vec3;
            if (this.getSep(a, u, p, f, m)) {
                var y = a.position.x,
                S = a.position.y,
                _ = a.position.z,
                A = u.position.x,
                v = u.position.y,
                w = u.position.z,
                E = a.halfWidth,
                x = a.halfHeight,
                C = a.halfDepth,
                b = u.halfHeight,
                R = u.radius,
                k = a.dimentions,
                B = k[0],
                V = k[1],
                z = k[2],
                J = k[3],
                $ = k[4],
                Z = k[5],
                tt = k[6],
                et = k[7],
                it = k[8],
                st = k[9],
                nt = k[10],
                at = k[11],
                ot = k[12],
                rt = k[13],
                lt = k[14],
                ht = k[15],
                dt = k[16],
                ct = k[17],
                ut = u.normalDirection.x,
                gt = u.normalDirection.y,
                pt = u.normalDirection.z,
                ft = u.halfDirection.x,
                mt = u.halfDirection.y,
                yt = u.halfDirection.z,
                St = p.x,
                _t = p.y,
                At = p.z,
                It = St * B + _t * V + At * z,
                vt = St * J + _t * $ + At * Z,
                wt = St * tt + _t * et + At * it,
                Lt = St * ut + _t * gt + At * pt,
                Et = It > 0,
                xt = vt > 0,
                Ct = wt > 0,
                bt = Lt > 0;
                Et || (It = -It),
                xt || (vt = -vt),
                Ct || (wt = -wt),
                bt || (Lt = -Lt);
                var Nt,
                Dt,
                Mt,
                Rt,
                kt,
                Tt,
                Ot,
                Bt,
                Pt,
                Vt,
                Ut,
                zt,
                Ft,
                Gt,
                Wt,
                Ht,
                qt,
                Kt,
                Jt,
                Xt,
                jt,
                Qt,
                Yt,
                $t,
                Zt,
                te,
                ee,
                ie,
                se,
                ne,
                ae,
                oe,
                re,
                le,
                he,
                de,
                ce,
                ue,
                ge,
                pe,
                fe,
                me,
                ye,
                Se,
                _e,
                Ae,
                Ie,
                ve,
                we,
                Le,
                Ee,
                xe,
                Ce,
                be = 0;
                if (Lt > .999 ? be = It > .999 ? It > Lt ? 1 : 4 : vt > .999 ? vt > Lt ? 2 : 4 : wt > .999 && wt > Lt ? 3 : 4 : It > .999 ? be = 1 : vt > .999 ? be = 2 : wt > .999 && (be = 3), 0 == be)
                    n.addPoint(f.x, f.y, f.z, St, _t, At, m.x, this.flip);
                else if (4 == be) {
                    var Ne,
                    De,
                    Me,
                    Re,
                    ke,
                    Te,
                    Oe,
                    Be,
                    Pe,
                    Ve,
                    Ue,
                    ze;
                    bt ? (Rt = A - ft, kt = v - mt, Tt = w - yt, St = -ut, _t = -gt, At = -pt) : (Rt = A + ft, kt = v + mt, Tt = w + yt, St = ut, _t = gt, At = pt),
                    be = 0,
                    (ye = B * St + V * _t + z * At) < (Xt = 1) && (Xt = ye, be = 0),
                    -ye < Xt && (Xt = -ye, be = 1),
                    (ye = J * St + $ * _t + Z * At) < Xt && (Xt = ye, be = 2),
                    -ye < Xt && (Xt = -ye, be = 3),
                    (ye = tt * St + et * _t + it * At) < Xt && (Xt = ye, be = 4),
                    -ye < Xt && (Xt = -ye, be = 5);
                    var Fe = a.elements;
                    switch (be) {
                    case 0:
                        Ne = Fe[0],
                        De = Fe[1],
                        Me = Fe[2],
                        Re = Fe[6],
                        ke = Fe[7],
                        Te = Fe[8],
                        Oe = Fe[9],
                        Be = Fe[10],
                        Pe = Fe[11],
                        Ve = Fe[3],
                        Ue = Fe[4],
                        ze = Fe[5];
                        break;
                    case 1:
                        Ne = Fe[15],
                        De = Fe[16],
                        Me = Fe[17],
                        Re = Fe[21],
                        ke = Fe[22],
                        Te = Fe[23],
                        Oe = Fe[18],
                        Be = Fe[19],
                        Pe = Fe[20],
                        Ve = Fe[12],
                        Ue = Fe[13],
                        ze = Fe[14];
                        break;
                    case 2:
                        Ne = Fe[12],
                        De = Fe[13],
                        Me = Fe[14],
                        Re = Fe[0],
                        ke = Fe[1],
                        Te = Fe[2],
                        Oe = Fe[3],
                        Be = Fe[4],
                        Pe = Fe[5],
                        Ve = Fe[15],
                        Ue = Fe[16],
                        ze = Fe[17];
                        break;
                    case 3:
                        Ne = Fe[21],
                        De = Fe[22],
                        Me = Fe[23],
                        Re = Fe[9],
                        ke = Fe[10],
                        Te = Fe[11],
                        Oe = Fe[6],
                        Be = Fe[7],
                        Pe = Fe[8],
                        Ve = Fe[18],
                        Ue = Fe[19],
                        ze = Fe[20];
                        break;
                    case 4:
                        Ne = Fe[12],
                        De = Fe[13],
                        Me = Fe[14],
                        Re = Fe[18],
                        ke = Fe[19],
                        Te = Fe[20],
                        Oe = Fe[6],
                        Be = Fe[7],
                        Pe = Fe[8],
                        Ve = Fe[0],
                        Ue = Fe[1],
                        ze = Fe[2];
                        break;
                    case 5:
                        Ne = Fe[3],
                        De = Fe[4],
                        Me = Fe[5],
                        Re = Fe[9],
                        ke = Fe[10],
                        Te = Fe[11],
                        Oe = Fe[21],
                        Be = Fe[22],
                        Pe = Fe[23],
                        Ve = Fe[15],
                        Ue = Fe[16],
                        ze = Fe[17]
                    }
                    (Jt = St * (Ne - Rt) + _t * (De - kt) + At * (Me - Tt)) <= 0 && n.addPoint(Ne, De, Me, -St, -_t, -At, Jt, this.flip),
                    (Jt = St * (Re - Rt) + _t * (ke - kt) + At * (Te - Tt)) <= 0 && n.addPoint(Re, ke, Te, -St, -_t, -At, Jt, this.flip),
                    (Jt = St * (Oe - Rt) + _t * (Be - kt) + At * (Pe - Tt)) <= 0 && n.addPoint(Oe, Be, Pe, -St, -_t, -At, Jt, this.flip),
                    (Jt = St * (Ve - Rt) + _t * (Ue - kt) + At * (ze - Tt)) <= 0 && n.addPoint(Ve, Ue, ze, -St, -_t, -At, Jt, this.flip)
                } else {
                    switch (be) {
                    case 1:
                        Et ? (Nt = y + st, Dt = S + nt, Mt = _ + at, St = B, _t = V, At = z) : (Nt = y - st, Dt = S - nt, Mt = _ - at, St = -B, _t = -V, At = -z),
                        Ae = J,
                        Ie = $,
                        ve = Z,
                        xe = x,
                        we = tt,
                        Le = et,
                        Ee = it,
                        Ce = C;
                        break;
                    case 2:
                        xt ? (Nt = y + ot, Dt = S + rt, Mt = _ + lt, St = J, _t = $, At = Z) : (Nt = y - ot, Dt = S - rt, Mt = _ - lt, St = -J, _t = -$, At = -Z),
                        Ae = B,
                        Ie = V,
                        ve = z,
                        xe = E,
                        we = tt,
                        Le = et,
                        Ee = it,
                        Ce = C;
                        break;
                    case 3:
                        Ct ? (Nt = y + ht, Dt = S + dt, Mt = _ + ct, St = tt, _t = et, At = it) : (Nt = y - ht, Dt = S - dt, Mt = _ - ct, St = -tt, _t = -et, At = -it),
                        Ae = B,
                        Ie = V,
                        ve = z,
                        xe = E,
                        we = J,
                        Le = $,
                        Ee = Z,
                        Ce = x
                    }
                    if (Rt = A + (jt = (Xt = St * ut + _t * gt + At * pt) < 0 ? b : -b) * ut, kt = v + jt * gt, Tt = w + jt * pt, Lt >= .999999 ? (Qt = -_t, Yt = At, $t = St) : (Qt = St, Yt = _t, $t = At), te = (jt = Qt * ut + Yt * gt + $t * pt) * ut - Qt, ee = jt * gt - Yt, ie = jt * pt - $t, 0 == (jt = g.sqrt(te * te + ee * ee + ie * ie)))
                        return;
                    if (Qt = Rt + (te *= jt = R / jt), Yt = kt + (ee *= jt), $t = Tt + (ie *= jt), Xt <  - .96 || Xt > .96)
                        Ot = ut * ut * 1.5 - .5, Bt = ut * gt * 1.5 - .866025403 * pt, Pt = ut * pt * 1.5 + .866025403 * gt, Vt = gt * ut * 1.5 + .866025403 * pt, Ut = gt * gt * 1.5 - .5, zt = gt * pt * 1.5 - .866025403 * ut, Ft = pt * ut * 1.5 - .866025403 * gt, Gt = pt * gt * 1.5 + .866025403 * ut, Wt = pt * pt * 1.5 - .5, (ue = Ae * (Qt = (Ht = Qt) - (Jt = St * (Ht - Nt) + _t * ((qt = Yt) - Dt) + At * ((Kt = $t) - Mt)) * St - Nt) + Ie * (Yt = qt - Jt * _t - Dt) + ve * ($t = Kt - Jt * At - Mt)) < -xe ? ue = -xe : ue > xe && (ue = xe), (me = we * Qt + Le * Yt + Ee * $t) < -Ce ? me = -Ce : me > Ce && (me = Ce), Ht = Nt + (Qt = ue * Ae + me * we), qt = Dt + (Yt = ue * Ie + me * Le), Kt = Mt + ($t = ue * ve + me * Ee), n.addPoint(Ht, qt, Kt, St, _t, At, Jt, this.flip), qt = te * Vt + ee * Ut + ie * zt, Kt = te * Ft + ee * Gt + ie * Wt, (Jt = St * ((Ht = (te = Ht = te * Ot + ee * Bt + ie * Pt) + Rt) - Nt) + _t * ((qt = (ee = qt) + kt) - Dt) + At * ((Kt = (ie = Kt) + Tt) - Mt)) <= 0 && ((ue = Ae * (Qt = Ht - Jt * St - Nt) + Ie * (Yt = qt - Jt * _t - Dt) + ve * ($t = Kt - Jt * At - Mt)) < -xe ? ue = -xe : ue > xe && (ue = xe), (me = we * Qt + Le * Yt + Ee * $t) < -Ce ? me = -Ce : me > Ce && (me = Ce), Ht = Nt + (Qt = ue * Ae + me * we), qt = Dt + (Yt = ue * Ie + me * Le), Kt = Mt + ($t = ue * ve + me * Ee), n.addPoint(Ht, qt, Kt, St, _t, At, Jt, this.flip)), qt = te * Vt + ee * Ut + ie * zt, Kt = te * Ft + ee * Gt + ie * Wt, (Jt = St * ((Ht = (te = Ht = te * Ot + ee * Bt + ie * Pt) + Rt) - Nt) + _t * ((qt = (ee = qt) + kt) - Dt) + At * ((Kt = (ie = Kt) + Tt) - Mt)) <= 0 && ((ue = Ae * (Qt = Ht - Jt * St - Nt) + Ie * (Yt = qt - Jt * _t - Dt) + ve * ($t = Kt - Jt * At - Mt)) < -xe ? ue = -xe : ue > xe && (ue = xe), (me = we * Qt + Le * Yt + Ee * $t) < -Ce ? me = -Ce : me > Ce && (me = Ce), Ht = Nt + (Qt = ue * Ae + me * we), qt = Dt + (Yt = ue * Ie + me * Le), Kt = Mt + ($t = ue * ve + me * Ee), n.addPoint(Ht, qt, Kt, St, _t, At, Jt, this.flip));
                    else {
                        if (he = Qt, Xt > 0 ? (ge = Qt + 2 * ft, pe = Yt + 2 * mt, fe = $t + 2 * yt) : (ge = Qt - 2 * ft, pe = Yt - 2 * mt, fe = $t - 2 * yt), Qt = (ge -= (me = St * (ge - Nt) + _t * (pe - Dt) + At * (fe - Mt)) * St) - (he -= (ue = St * (he - Nt) + _t * ((de = Yt) - Dt) + At * ((ce = $t) - Mt)) * St), Yt = (pe -= me * _t) - (de -= ue * _t), $t = (fe -= me * At) - (ce -= ue * At), Zt = me - ue, Se = (vt = (oe = ge - Nt) * Ae + (re = pe - Dt) * Ie + (le = fe - Mt) * ve) - xe, (ye = (It = (se = he - Nt) * Ae + (ne = de - Dt) * Ie + (ae = ce - Mt) * ve) - xe) > 0) {
                            if (Se > 0)
                                return;
                            It = (se = (he += Qt * (_e = ye / (ye - Se))) - Nt) * Ae + (ne = (de += Yt * _e) - Dt) * Ie + (ae = (ce += $t * _e) - Mt) * ve,
                            Qt = ge - he,
                            Yt = pe - de,
                            $t = fe - ce,
                            Zt = me - (ue += Zt * _e)
                        } else
                            Se > 0 && (vt = (oe = (ge = he + Qt * (_e = ye / (ye - Se))) - Nt) * Ae + (re = (pe = de + Yt * _e) - Dt) * Ie + (le = (fe = ce + $t * _e) - Mt) * ve, Qt = ge - he, Yt = pe - de, $t = fe - ce, Zt = (me = ue + Zt * _e) - ue);
                        if (Se = vt + xe, (ye = It + xe) < 0) {
                            if (Se < 0)
                                return;
                            se = (he += Qt * (_e = ye / (ye - Se))) - Nt,
                            ne = (de += Yt * _e) - Dt,
                            ae = (ce += $t * _e) - Mt,
                            Qt = ge - he,
                            Yt = pe - de,
                            $t = fe - ce,
                            Zt = me - (ue += Zt * _e)
                        } else
                            Se < 0 && (oe = (ge = he + Qt * (_e = ye / (ye - Se))) - Nt, re = (pe = de + Yt * _e) - Dt, le = (fe = ce + $t * _e) - Mt, Qt = ge - he, Yt = pe - de, $t = fe - ce, Zt = (me = ue + Zt * _e) - ue);
                        if (Se = (vt = oe * we + re * Le + le * Ee) - Ce, (ye = (It = se * we + ne * Le + ae * Ee) - Ce) > 0) {
                            if (Se > 0)
                                return;
                            It = (se = (he += Qt * (_e = ye / (ye - Se))) - Nt) * we + (ne = (de += Yt * _e) - Dt) * Le + (ae = (ce += $t * _e) - Mt) * Ee,
                            Qt = ge - he,
                            Yt = pe - de,
                            $t = fe - ce,
                            Zt = me - (ue += Zt * _e)
                        } else
                            Se > 0 && (vt = (oe = (ge = he + Qt * (_e = ye / (ye - Se))) - Nt) * we + (re = (pe = de + Yt * _e) - Dt) * Le + (le = (fe = ce + $t * _e) - Mt) * Ee, Qt = ge - he, Yt = pe - de, $t = fe - ce, Zt = (me = ue + Zt * _e) - ue);
                        if (Se = vt + Ce, (ye = It + Ce) < 0) {
                            if (Se < 0)
                                return;
                            he += Qt * (_e = ye / (ye - Se)),
                            de += Yt * _e,
                            ce += $t * _e,
                            ue += Zt * _e
                        } else
                            Se < 0 && (ge = he + Qt * (_e = ye / (ye - Se)), pe = de + Yt * _e, fe = ce + $t * _e, me = ue + Zt * _e);
                        ue < 0 && n.addPoint(he, de, ce, St, _t, At, ue, this.flip),
                        me < 0 && n.addPoint(ge, pe, fe, St, _t, At, me, this.flip)
                    }
                }
            }
        }
    }),
    CylinderCylinderCollisionDetector.prototype = Object.assign(Object.create(CollisionDetector.prototype), {
        constructor: CylinderCylinderCollisionDetector,
        getSep: function (t, e, n, a, u) {
            var p,
            f,
            m,
            y,
            S,
            _,
            A,
            v,
            w,
            E,
            x,
            C,
            b,
            R = new Vec3,
            k = t.position.x,
            B = t.position.y,
            V = t.position.z,
            z = e.position.x,
            J = e.position.y,
            $ = e.position.z,
            Z = z - k,
            tt = J - B,
            et = $ - V;
            Z * Z + tt * tt + et * et == 0 && (tt = .001);
            var it = -Z,
            st = -tt,
            nt = -et;
            this.supportPoint(t, -it, -st, -nt, R);
            var at = R.x,
            ot = R.y,
            rt = R.z;
            this.supportPoint(e, it, st, nt, R);
            var lt = R.x,
            ht = R.y,
            dt = R.z,
            ct = lt - at,
            ut = ht - ot,
            gt = dt - rt;
            if (ct * it + ut * st + gt * nt <= 0)
                return !1;
            if ((it = ut * et - gt * tt) * it + (st = gt * Z - ct * et) * st + (nt = ct * tt - ut * Z) * nt == 0)
                return n.set(ct - Z, ut - tt, gt - et).normalize(), a.set(.5 * (at + lt), .5 * (ot + ht), .5 * (rt + dt)), !0;
            this.supportPoint(t, -it, -st, -nt, R);
            var pt = R.x,
            ft = R.y,
            mt = R.z;
            this.supportPoint(e, it, st, nt, R);
            var yt = R.x,
            St = R.y,
            _t = R.z,
            At = yt - pt,
            It = St - ft,
            vt = _t - mt;
            if (At * it + It * st + vt * nt <= 0)
                return !1;
            (it = (f = ut - tt) * (_ = vt - et) - (m = gt - et) * (S = It - tt)) * Z + (st = m * (y = At - Z) - (p = ct - Z) * _) * tt + (nt = p * S - f * y) * et > 0 && (p = ct, f = ut, m = gt, ct = At, ut = It, gt = vt, At = p, It = f, vt = m, p = at, f = ot, m = rt, at = pt, ot = ft, rt = mt, pt = p, ft = f, mt = m, p = lt, f = ht, m = dt, lt = yt, ht = St, dt = _t, yt = p, St = f, _t = m, it = -it, st = -st, nt = -nt);
            for (var wt = 0; ; ) {
                if (++wt > 100)
                    return !1;
                this.supportPoint(t, -it, -st, -nt, R);
                var Lt = R.x,
                Et = R.y,
                xt = R.z;
                this.supportPoint(e, it, st, nt, R);
                var Ct = R.x,
                bt = R.y,
                Nt = R.z,
                Dt = Ct - Lt,
                Mt = bt - Et,
                Rt = Nt - xt;
                if (Dt * it + Mt * st + Rt * nt <= 0)
                    return !1;
                if ((ut * Rt - gt * Mt) * Z + (gt * Dt - ct * Rt) * tt + (ct * Mt - ut * Dt) * et < 0)
                    At = Dt, It = Mt, vt = Rt, pt = Lt, ft = Et, mt = xt, yt = Ct, St = bt, _t = Nt, it = (f = ut - tt) * (_ = Rt - et) - (m = gt - et) * (S = Mt - tt), st = m * (y = Dt - Z) - (p = ct - Z) * _, nt = p * S - f * y;
                else if ((Mt * vt - Rt * It) * Z + (Rt * At - Dt * vt) * tt + (Dt * It - Mt * At) * et < 0)
                    ct = Dt, ut = Mt, gt = Rt, at = Lt, ot = Et, rt = xt, lt = Ct, ht = bt, dt = Nt, it = (f = Mt - tt) * (_ = vt - et) - (m = Rt - et) * (S = It - tt), st = m * (y = At - Z) - (p = Dt - Z) * _, nt = p * S - f * y;
                else
                    for (var kt = !1; ; ) {
                        if (it = (f = It - ut) * (_ = Rt - gt) - (m = vt - gt) * (S = Mt - ut), st = m * (y = Dt - ct) - (p = At - ct) * _, nt = p * S - f * y, (it *= A = 1 / g.sqrt(it * it + st * st + nt * nt)) * ct + (st *= A) * ut + (nt *= A) * gt >= 0 && !kt) {
                            var Tt = (ut * vt - gt * It) * Dt + (gt * At - ct * vt) * Mt + (ct * It - ut * At) * Rt,
                            Ot = (Mt * vt - Rt * It) * Z + (Rt * At - Dt * vt) * tt + (Dt * It - Mt * At) * et,
                            Bt = (tt * gt - et * ut) * Dt + (et * ct - Z * gt) * Mt + (Z * ut - tt * ct) * Rt,
                            Pt = (It * gt - vt * ut) * Z + (vt * ct - At * gt) * tt + (At * ut - It * ct) * et,
                            Vt = Tt + Ot + Bt + Pt;
                            Vt <= 0 && (Tt = 0, Vt = (Ot = (It * Rt - vt * Mt) * it + (vt * Dt - At * Rt) * st + (At * Mt - It * Dt) * nt) + (Bt = (Mt * vt - Rt * It) * it + (Rt * At - Dt * vt) * st + (Dt * It - Mt * At) * nt) + (Pt = (ut * vt - gt * It) * it + (gt * At - ct * vt) * st + (ct * It - ut * At) * nt));
                            var Ut = 1 / Vt;
                            v = (k * Tt + at * Ot + pt * Bt + Lt * Pt) * Ut,
                            w = (B * Tt + ot * Ot + ft * Bt + Et * Pt) * Ut,
                            E = (V * Tt + rt * Ot + mt * Bt + xt * Pt) * Ut,
                            x = (z * Tt + lt * Ot + yt * Bt + Ct * Pt) * Ut,
                            C = (J * Tt + ht * Ot + St * Bt + bt * Pt) * Ut,
                            b = ($ * Tt + dt * Ot + _t * Bt + Nt * Pt) * Ut,
                            kt = !0
                        }
                        this.supportPoint(t, -it, -st, -nt, R);
                        var zt = R.x,
                        Ft = R.y,
                        Gt = R.z;
                        this.supportPoint(e, it, st, nt, R);
                        var Wt = R.x,
                        Ht = R.y,
                        qt = R.z,
                        Kt = Wt - zt,
                        Jt = Ht - Ft,
                        Xt = qt - Gt,
                        jt =  - (Kt * it + Jt * st + Xt * nt);
                        if ((Kt - Dt) * it + (Jt - Mt) * st + (Xt - Rt) * nt <= .01 || jt >= 0)
                            return !!kt && (n.set(-it, -st, -nt), a.set(.5 * (v + x), .5 * (w + C), .5 * (E + b)), u.x = jt, !0);
                        (Jt * gt - Xt * ut) * Z + (Xt * ct - Kt * gt) * tt + (Kt * ut - Jt * ct) * et < 0 ? (Jt * vt - Xt * It) * Z + (Xt * At - Kt * vt) * tt + (Kt * It - Jt * At) * et < 0 ? (ct = Kt, ut = Jt, gt = Xt, at = zt, ot = Ft, rt = Gt, lt = Wt, ht = Ht, dt = qt) : (Dt = Kt, Mt = Jt, Rt = Xt, Lt = zt, Et = Ft, xt = Gt, Ct = Wt, bt = Ht, Nt = qt) : (Jt * Rt - Xt * Mt) * Z + (Xt * Dt - Kt * Rt) * tt + (Kt * Mt - Jt * Dt) * et < 0 ? (At = Kt, It = Jt, vt = Xt, pt = zt, ft = Ft, mt = Gt, yt = Wt, St = Ht, _t = qt) : (ct = Kt, ut = Jt, gt = Xt, at = zt, ot = Ft, rt = Gt, lt = Wt, ht = Ht, dt = qt)
                    }
            }
        },
        supportPoint: function (t, e, n, a, u) {
            var p,
            f,
            m,
            y = t.rotation.elements,
            S = y[0] * e + y[3] * n + y[6] * a,
            _ = y[1] * e + y[4] * n + y[7] * a,
            A = y[2] * e + y[5] * n + y[8] * a,
            v = S,
            w = A,
            E = v * v + w * w,
            x = t.radius,
            C = t.halfHeight;
            0 == E ? _ < 0 ? (p = x, f = -C, m = 0) : (p = x, f = C, m = 0) : (E = t.radius / g.sqrt(E), _ < 0 ? (p = v * E, f = -C, m = w * E) : (p = v * E, f = C, m = w * E)),
            S = y[0] * p + y[1] * f + y[2] * m + t.position.x,
            _ = y[3] * p + y[4] * f + y[5] * m + t.position.y,
            A = y[6] * p + y[7] * f + y[8] * m + t.position.z,
            u.set(S, _, A)
        },
        detectCollision: function (t, e, n) {
            var a,
            u;
            t.id < e.id ? (a = t, u = e) : (a = e, u = t);
            var p,
            f,
            m,
            y,
            S,
            _,
            A,
            v,
            w,
            E,
            x,
            C,
            b,
            R,
            k,
            B,
            V,
            z,
            J,
            $,
            Z,
            tt = a.position,
            et = u.position,
            it = tt.x,
            st = tt.y,
            nt = tt.z,
            at = et.x,
            ot = et.y,
            rt = et.z,
            lt = a.halfHeight,
            ht = u.halfHeight,
            dt = a.normalDirection,
            ct = u.normalDirection,
            ut = a.halfDirection,
            gt = u.halfDirection,
            pt = a.radius,
            ft = u.radius,
            mt = dt.x,
            yt = dt.y,
            St = dt.z,
            _t = ct.x,
            At = ct.y,
            It = ct.z,
            vt = ut.x,
            wt = ut.y,
            Lt = ut.z,
            Et = gt.x,
            xt = gt.y,
            Ct = gt.z,
            bt = it - at,
            Nt = st - ot,
            Dt = nt - rt,
            Mt = new Vec3,
            Rt = new Vec3,
            kt = new Vec3;
            if (this.getSep(a, u, Mt, Rt, kt)) {
                var Tt = Mt.x * mt + Mt.y * yt + Mt.z * St,
                Ot = Mt.x * _t + Mt.y * At + Mt.z * It,
                Bt = Tt > 0,
                Pt = Ot > 0;
                Bt || (Tt = -Tt),
                Pt || (Ot = -Ot);
                var Vt,
                Ut,
                zt,
                Ft = 0;
                (Tt > .999 || Ot > .999) && (Ft = Tt > Ot ? 1 : 2);
                var Gt,
                Wt,
                Ht,
                qt,
                Kt,
                Jt,
                Xt,
                jt,
                Qt,
                Yt,
                $t,
                Zt,
                te,
                ee,
                ie,
                se,
                ne = kt.x;
                switch (Vt = Mt.x, Ut = Mt.y, zt = Mt.z, Ft) {
                case 0:
                    n.addPoint(Rt.x, Rt.y, Rt.z, Vt, Ut, zt, ne, !1);
                    break;
                case 1:
                    if (Bt ? (f = it + vt, m = st + wt, y = nt + Lt, Vt = mt, Ut = yt, zt = St) : (f = it - vt, m = st - wt, y = nt - Lt, Vt = -mt, Ut = -yt, zt = -St), S = at + (p = (J = Vt * _t + Ut * At + zt * It) < 0 ? ht : -ht) * _t, _ = ot + p * At, A = rt + p * It, Ot >= .999999 ? (v = -Ut, w = zt, E = Vt) : (v = Vt, w = Ut, E = zt), bt = (p = v * _t + w * At + E * It) * _t - v, Nt = p * At - w, Dt = p * It - E, 0 == (p = g.sqrt(bt * bt + Nt * Nt + Dt * Dt)))
                        break;
                    if (v = S + (bt *= p = ft / p), w = _ + (Nt *= p), E = A + (Dt *= p), J <  - .96 || J > .96)
                        Gt = _t * _t * 1.5 - .5, Wt = _t * At * 1.5 - .866025403 * It, Ht = _t * It * 1.5 + .866025403 * At, qt = At * _t * 1.5 + .866025403 * It, Kt = At * At * 1.5 - .5, Jt = At * It * 1.5 - .866025403 * _t, Xt = It * _t * 1.5 - .866025403 * At, jt = It * At * 1.5 + .866025403 * _t, Qt = It * It * 1.5 - .5, (p = (v = (Yt = v) - (te = Vt * (Yt - f) + Ut * (($t = w) - m) + zt * ((Zt = E) - y)) * Vt - f) * v + (w = $t - te * Ut - m) * w + (E = Zt - te * zt - y) * E) > pt * pt && (v *= p = pt / g.sqrt(p), w *= p, E *= p), Yt = f + v, $t = m + w, Zt = y + E, n.addPoint(Yt, $t, Zt, Vt, Ut, zt, te, !1), $t = bt * qt + Nt * Kt + Dt * Jt, Zt = bt * Xt + Nt * jt + Dt * Qt, (te = Vt * ((Yt = (bt = Yt = bt * Gt + Nt * Wt + Dt * Ht) + S) - f) + Ut * (($t = (Nt = $t) + _) - m) + zt * ((Zt = (Dt = Zt) + A) - y)) <= 0 && ((p = (v = Yt - te * Vt - f) * v + (w = $t - te * Ut - m) * w + (E = Zt - te * zt - y) * E) > pt * pt && (v *= p = pt / g.sqrt(p), w *= p, E *= p), Yt = f + v, $t = m + w, Zt = y + E, n.addPoint(Yt, $t, Zt, Vt, Ut, zt, te, !1)), $t = bt * qt + Nt * Kt + Dt * Jt, Zt = bt * Xt + Nt * jt + Dt * Qt, (te = Vt * ((Yt = (bt = Yt = bt * Gt + Nt * Wt + Dt * Ht) + S) - f) + Ut * (($t = (Nt = $t) + _) - m) + zt * ((Zt = (Dt = Zt) + A) - y)) <= 0 && ((p = (v = Yt - te * Vt - f) * v + (w = $t - te * Ut - m) * w + (E = Zt - te * zt - y) * E) > pt * pt && (v *= p = pt / g.sqrt(p), w *= p, E *= p), Yt = f + v, $t = m + w, Zt = y + E, n.addPoint(Yt, $t, Zt, Vt, Ut, zt, te, !1));
                    else {
                        if (x = v, J > 0 ? (R = v + _t * ht * 2, k = w + At * ht * 2, B = E + It * ht * 2) : (R = v - _t * ht * 2, k = w - At * ht * 2, B = E - It * ht * 2), (se = (ee = (bt = f - (x -= (V = Vt * (x - f) + Ut * ((C = w) - m) + zt * ((b = E) - y)) * Vt)) * (v = (R -= (z = Vt * (R - f) + Ut * (k - m) + zt * (B - y)) * Vt) - x) + (Nt = m - (C -= V * Ut)) * (w = (k -= z * Ut) - C) + (Dt = y - (b -= V * zt)) * (E = (B -= z * zt) - b)) * ee - (ie = v * v + w * w + E * E) * (bt * bt + Nt * Nt + Dt * Dt - pt * pt)) < 0)
                            break;
                        (Z = (ee - (se = g.sqrt(se))) / ie) < ($ = (ee + se) / ie) && (p = $, $ = Z, Z = p),
                        Z > 1 && (Z = 1),
                        $ < 0 && ($ = 0),
                        v = x + (R - x) * $,
                        w = C + (k - C) * $,
                        E = b + (B - b) * $,
                        R = x + (R - x) * Z,
                        k = C + (k - C) * Z,
                        B = b + (B - b) * Z,
                        x = v,
                        C = w,
                        b = E,
                        p = V + (z - V) * $,
                        z = V + (z - V) * Z,
                        (V = p) < 0 && n.addPoint(x, C, b, Vt, Ut, zt, te, !1),
                        z < 0 && n.addPoint(R, k, B, Vt, Ut, zt, te, !1)
                    }
                    break;
                case 2:
                    if (Pt ? (S = at - Et, _ = ot - xt, A = rt - Ct, Vt = -_t, Ut = -At, zt = -It) : (S = at + Et, _ = ot + xt, A = rt + Ct, Vt = _t, Ut = At, zt = It), f = it + (p = (J = Vt * mt + Ut * yt + zt * St) < 0 ? lt : -lt) * mt, m = st + p * yt, y = nt + p * St, Tt >= .999999 ? (v = -Ut, w = zt, E = Vt) : (v = Vt, w = Ut, E = zt), bt = (p = v * mt + w * yt + E * St) * mt - v, Nt = p * yt - w, Dt = p * St - E, 0 == (p = g.sqrt(bt * bt + Nt * Nt + Dt * Dt)))
                        break;
                    if (v = f + (bt *= p = pt / p), w = m + (Nt *= p), E = y + (Dt *= p), J <  - .96 || J > .96)
                        Gt = mt * mt * 1.5 - .5, Wt = mt * yt * 1.5 - .866025403 * St, Ht = mt * St * 1.5 + .866025403 * yt, qt = yt * mt * 1.5 + .866025403 * St, Kt = yt * yt * 1.5 - .5, Jt = yt * St * 1.5 - .866025403 * mt, Xt = St * mt * 1.5 - .866025403 * yt, jt = St * yt * 1.5 + .866025403 * mt, Qt = St * St * 1.5 - .5, (p = (v = (Yt = v) - (te = Vt * (Yt - S) + Ut * (($t = w) - _) + zt * ((Zt = E) - A)) * Vt - S) * v + (w = $t - te * Ut - _) * w + (E = Zt - te * zt - A) * E) > ft * ft && (v *= p = ft / g.sqrt(p), w *= p, E *= p), Yt = S + v, $t = _ + w, Zt = A + E, n.addPoint(Yt, $t, Zt, -Vt, -Ut, -zt, te, !1), $t = bt * qt + Nt * Kt + Dt * Jt, Zt = bt * Xt + Nt * jt + Dt * Qt, (te = Vt * ((Yt = (bt = Yt = bt * Gt + Nt * Wt + Dt * Ht) + f) - S) + Ut * (($t = (Nt = $t) + m) - _) + zt * ((Zt = (Dt = Zt) + y) - A)) <= 0 && ((p = (v = Yt - te * Vt - S) * v + (w = $t - te * Ut - _) * w + (E = Zt - te * zt - A) * E) > ft * ft && (v *= p = ft / g.sqrt(p), w *= p, E *= p), Yt = S + v, $t = _ + w, Zt = A + E, n.addPoint(Yt, $t, Zt, -Vt, -Ut, -zt, te, !1)), $t = bt * qt + Nt * Kt + Dt * Jt, Zt = bt * Xt + Nt * jt + Dt * Qt, (te = Vt * ((Yt = (bt = Yt = bt * Gt + Nt * Wt + Dt * Ht) + f) - S) + Ut * (($t = (Nt = $t) + m) - _) + zt * ((Zt = (Dt = Zt) + y) - A)) <= 0 && ((p = (v = Yt - te * Vt - S) * v + (w = $t - te * Ut - _) * w + (E = Zt - te * zt - A) * E) > ft * ft && (v *= p = ft / g.sqrt(p), w *= p, E *= p), Yt = S + v, $t = _ + w, Zt = A + E, n.addPoint(Yt, $t, Zt, -Vt, -Ut, -zt, te, !1));
                    else {
                        if (x = v, J > 0 ? (R = v + mt * lt * 2, k = w + yt * lt * 2, B = E + St * lt * 2) : (R = v - mt * lt * 2, k = w - yt * lt * 2, B = E - St * lt * 2), (se = (ee = (bt = S - (x -= (V = Vt * (x - S) + Ut * ((C = w) - _) + zt * ((b = E) - A)) * Vt)) * (v = (R -= (z = Vt * (R - S) + Ut * (k - _) + zt * (B - A)) * Vt) - x) + (Nt = _ - (C -= V * Ut)) * (w = (k -= z * Ut) - C) + (Dt = A - (b -= V * zt)) * (E = (B -= z * zt) - b)) * ee - (ie = v * v + w * w + E * E) * (bt * bt + Nt * Nt + Dt * Dt - ft * ft)) < 0)
                            break;
                        (Z = (ee - (se = g.sqrt(se))) / ie) < ($ = (ee + se) / ie) && (p = $, $ = Z, Z = p),
                        Z > 1 && (Z = 1),
                        $ < 0 && ($ = 0),
                        v = x + (R - x) * $,
                        w = C + (k - C) * $,
                        E = b + (B - b) * $,
                        R = x + (R - x) * Z,
                        k = C + (k - C) * Z,
                        B = b + (B - b) * Z,
                        x = v,
                        C = w,
                        b = E,
                        p = V + (z - V) * $,
                        z = V + (z - V) * Z,
                        (V = p) < 0 && n.addPoint(x, C, b, -Vt, -Ut, -zt, V, !1),
                        z < 0 && n.addPoint(R, k, B, -Vt, -Ut, -zt, z, !1)
                    }
                }
            }
        }
    }),
    SphereBoxCollisionDetector.prototype = Object.assign(Object.create(CollisionDetector.prototype), {
        constructor: SphereBoxCollisionDetector,
        detectCollision: function (t, e, n) {
            var a,
            u;
            this.flip ? (a = e, u = t) : (a = t, u = e);
            var p,
            f,
            m,
            y,
            S,
            _ = u.dimentions,
            A = a.position,
            v = A.x,
            w = A.y,
            E = A.z,
            x = u.position,
            C = x.x,
            b = x.y,
            R = x.z,
            k = a.radius,
            B = u.halfWidth,
            V = u.halfHeight,
            z = u.halfDepth,
            J = v - C,
            $ = w - b,
            Z = E - R,
            tt = _[0] * J + _[1] * $ + _[2] * Z,
            et = _[3] * J + _[4] * $ + _[5] * Z,
            it = _[6] * J + _[7] * $ + _[8] * Z,
            st = 0;
            tt > B ? tt = B : tt < -B ? tt = -B : st = 1,
            et > V ? et = V : et < -V ? et = -V : st |= 2,
            it > z ? it = z : it < -z ? it = -z : st |= 4,
            7 == st ? (Z = it < 0 ? z + it : z - it, (J = tt < 0 ? B + tt : B - tt) < ($ = et < 0 ? V + et : V - et) ? J < Z ? (y = J - B, tt < 0 ? (tt = -B, J = _[0], $ = _[1], Z = _[2]) : (tt = B, J = -_[0], $ = -_[1], Z = -_[2])) : (y = Z - z, it < 0 ? (it = -z, J = _[6], $ = _[7], Z = _[8]) : (it = z, J = -_[6], $ = -_[7], Z = -_[8])) : $ < Z ? (y = $ - V, et < 0 ? (et = -V, J = _[3], $ = _[4], Z = _[5]) : (et = V, J = -_[3], $ = -_[4], Z = -_[5])) : (y = Z - z, it < 0 ? (it = -z, J = _[6], $ = _[7], Z = _[8]) : (it = z, J = -_[6], $ = -_[7], Z = -_[8])), n.addPoint(v + k * J, w + k * $, E + k * Z, J, $, Z, y - k, this.flip)) : (p = C + tt * _[0] + et * _[3] + it * _[6], f = b + tt * _[1] + et * _[4] + it * _[7], m = R + tt * _[2] + et * _[5] + it * _[8], (y = (J = p - A.x) * J + ($ = f - A.y) * $ + (Z = m - A.z) * Z) > 0 && y < k * k && (J *= S = 1 / (y = g.sqrt(y)), $ *= S, Z *= S, n.addPoint(v + k * J, w + k * $, E + k * Z, J, $, Z, y - k, this.flip)))
        }
    }),
    SphereCylinderCollisionDetector.prototype = Object.assign(Object.create(CollisionDetector.prototype), {
        constructor: SphereCylinderCollisionDetector,
        detectCollision: function (t, e, n) {
            var a,
            u;
            this.flip ? (a = e, u = t) : (a = t, u = e);
            var p = a.position,
            f = p.x,
            m = p.y,
            y = p.z,
            S = u.position,
            _ = S.x,
            A = S.y,
            v = S.z,
            w = u.normalDirection.x,
            E = u.normalDirection.y,
            x = u.normalDirection.z,
            C = a.radius,
            b = u.radius,
            R = C + b,
            k = u.halfHeight,
            B = f - _,
            V = m - A,
            z = y - v,
            J = B * w + V * E + z * x;
            if (!(J < -k - C || J > k + C)) {
                var $,
                Z = _ + J * w,
                tt = A + J * E,
                et = v + J * x,
                it = f - Z,
                st = m - tt,
                nt = y - et,
                at = it * it + st * st + nt * nt;
                if (!(at > R * R))
                    at > b * b && (it *= at = b / g.sqrt(at), st *= at, nt *= at), J < -k ? J = -k : J > k && (J = k), B = (Z = _ + J * w + it) - f, V = (tt = A + J * E + st) - m, z = (et = v + J * x + nt) - y, (at = Math.max(B * B + V * V + z * z, .001)) > 0 && at < C * C && (B *= $ = 1 / (at = g.sqrt(at)), V *= $, z *= $, n.addPoint(f + B * C, m + V * C, y + z * C, B, V, z, at - C, this.flip))
            }
        }
    }),
    SphereSphereCollisionDetector.prototype = Object.assign(Object.create(CollisionDetector.prototype), {
        constructor: SphereSphereCollisionDetector,
        detectCollision: function (t, e, n) {
            var a = t,
            u = e,
            p = a.position,
            f = u.position,
            m = f.x - p.x,
            y = f.y - p.y,
            S = f.z - p.z,
            _ = m * m + y * y + S * S,
            A = a.radius,
            v = A + u.radius;
            if (_ > 0 && _ < v * v) {
                var w = 1 / (_ = g.sqrt(_));
                m *= w,
                y *= w,
                S *= w,
                n.addPoint(p.x + m * A, p.y + y * A, p.z + S * A, m, y, S, _ - v, !1)
            }
        }
    }),
    SpherePlaneCollisionDetector.prototype = Object.assign(Object.create(CollisionDetector.prototype), {
        constructor: SpherePlaneCollisionDetector,
        detectCollision: function (t, e, n) {
            var a,
            u = this.n,
            p = this.p,
            f = this.flip ? e : t,
            m = this.flip ? t : e,
            y = f.radius;
            u.sub(f.position, m.position),
            u.x *= m.normal.x,
            u.y *= m.normal.y,
            u.z *= m.normal.z,
            (a = u.lengthSq()) > 0 && a < y * y && (a = g.sqrt(a), u.copy(m.normal).negate(), p.copy(f.position).addScaledVector(u, y), n.addPointVec(p, u, a - y, this.flip))
        }
    }),
    BoxPlaneCollisionDetector.prototype = Object.assign(Object.create(CollisionDetector.prototype), {
        constructor: BoxPlaneCollisionDetector,
        detectCollision: function (t, e, n) {
            var a,
            u = this.n,
            p = this.p,
            f = this.cc,
            m = this.flip ? e : t,
            y = this.flip ? t : e,
            S = m.dimentions,
            _ = m.halfWidth,
            A = m.halfHeight,
            v = m.halfDepth,
            w = 0;
            this.dix.set(S[0], S[1], S[2]),
            this.diy.set(S[3], S[4], S[5]),
            this.diz.set(S[6], S[7], S[8]),
            u.sub(m.position, y.position),
            u.x *= y.normal.x,
            u.y *= y.normal.y,
            u.z *= y.normal.z,
            f.set(g.dotVectors(this.dix, u), g.dotVectors(this.diy, u), g.dotVectors(this.diz, u)),
            f.x > _ ? f.x = _ : f.x < -_ ? f.x = -_ : w = 1,
            f.y > A ? f.y = A : f.y < -A ? f.y = -A : w |= 2,
            f.z > v ? f.z = v : f.z < -v ? f.z = -v : w |= 4,
            7 === w && (u.set(f.x < 0 ? _ + f.x : _ - f.x, f.y < 0 ? A + f.y : A - f.y, f.z < 0 ? v + f.z : v - f.z), u.x < u.y ? u.x < u.z ? (a = u.x - _, f.x < 0 ? (f.x = -_, u.copy(this.dix)) : (f.x = _, u.subEqual(this.dix))) : (a = u.z - v, f.z < 0 ? (f.z = -v, u.copy(this.diz)) : (f.z = v, u.subEqual(this.diz))) : u.y < u.z ? (a = u.y - A, f.y < 0 ? (f.y = -A, u.copy(this.diy)) : (f.y = A, u.subEqual(this.diy))) : (a = u.z - v, f.z < 0 ? (f.z = -v, u.copy(this.diz)) : (f.z = v, u.subEqual(this.diz))), p.copy(y.position).addScaledVector(u, 1), n.addPointVec(p, u, a, this.flip))
        }
    }),
    World.SLEEP_LINEAR_VELOCITY = .04,
    World.SLEEP_ANGULAR_VELOCITY = .25,
    World.SLEEP_DELTA_TIME = .5,
    World.FIX_PENETRATE_SQ = .01,
    Object.assign(World.prototype, {
        World: !0,
        play: function () {
            if (null === this.timer) {
                var t = this;
                this.timer = setInterval((function () {
                            t.step()
                        }), this.timerate)
            }
        },
        stop: function () {
            null !== this.timer && (clearInterval(this.timer), this.timer = null)
        },
        setGravity: function (t) {
            this.gravity.fromArray(t)
        },
        getInfo: function () {
            return this.isStat ? this.performance.show() : ""
        },
        clear: function () {
            for (this.stop(), this.preLoop = null, this.postLoop = null, this.randX = 65535; null !== this.joints; )
                this.removeJoint(this.joints);
            for (; null !== this.contacts; )
                this.removeContact(this.contacts);
            for (; null !== this.rigidBodies; )
                this.removeRigidBody(this.rigidBodies)
        },
        addRigidBody: function (t) {
            t.parent && printError("World", "It is not possible to be added to more than one world one of the rigid body"),
            t.setParent(this);
            for (var e = t.shapes; null !== e; e = e.next)
                this.addShape(e);
            null !== this.rigidBodies && ((this.rigidBodies.prev = t).next = this.rigidBodies),
            this.rigidBodies = t,
            this.numRigidBodies++
        },
        removeRigidBody: function (t) {
            var e = t;
            if (e.parent === this) {
                e.awake();
                for (var n = e.jointLink; null != n; ) {
                    var a = n.joint;
                    n = n.next,
                    this.removeJoint(a)
                }
                for (var u = t.shapes; null !== u; u = u.next)
                    this.removeShape(u);
                var g = e.prev,
                p = e.next;
                null !== g && (g.next = p),
                null !== p && (p.prev = g),
                this.rigidBodies == e && (this.rigidBodies = p),
                e.prev = null,
                e.next = null,
                e.parent = null,
                this.numRigidBodies--
            }
        },
        getByName: function (t) {
            for (var e = this.rigidBodies; null !== e; ) {
                if (e.name === t)
                    return e;
                e = e.next
            }
            for (var n = this.joints; null !== n; ) {
                if (n.name === t)
                    return n;
                n = n.next
            }
            return null
        },
        addShape: function (t) {
            t.parent && t.parent.parent || printError("World", "It is not possible to be added alone to shape world"),
            t.proxy = this.broadPhase.createProxy(t),
            t.updateProxy(),
            this.broadPhase.addProxy(t.proxy)
        },
        removeShape: function (t) {
            this.broadPhase.removeProxy(t.proxy),
            t.proxy = null
        },
        addJoint: function (t) {
            t.parent && printError("World", "It is not possible to be added to more than one world one of the joint"),
            null != this.joints && ((this.joints.prev = t).next = this.joints),
            this.joints = t,
            t.setParent(this),
            this.numJoints++,
            t.awake(),
            t.attach()
        },
        removeJoint: function (t) {
            var e = t,
            n = e.prev,
            a = e.next;
            null !== n && (n.next = a),
            null !== a && (a.prev = n),
            this.joints == e && (this.joints = a),
            e.prev = null,
            e.next = null,
            this.numJoints--,
            e.awake(),
            e.detach(),
            e.parent = null
        },
        addContact: function (t, e) {
            var n;
            null !== this.unusedContacts ? (n = this.unusedContacts, this.unusedContacts = this.unusedContacts.next) : n = new Contact,
            n.attach(t, e),
            n.detector = this.detectors[t.type][e.type],
            n.world = this,
            this.contacts && ((this.contacts.prev = n).next = this.contacts),
            this.contacts = n,
            this.numContacts++
        },
        removeContact: function (t) {
            var e = t.prev,
            n = t.next;
            n && (n.prev = e),
            e && (e.next = n),
            this.contacts == t && (this.contacts = n),
            t.prev = null,
            t.next = null,
            t.detach(),
            t.next = this.unusedContacts,
            this.unusedContacts = t,
            this.numContacts--
        },
        getContact: function (t, e) {
            var n,
            a;
            t = t.constructor === RigidBody ? t.name : t,
            e = e.constructor === RigidBody ? e.name : e;
            for (var u = this.contacts; null !== u; ) {
                if (n = u.body1.name, a = u.body2.name, n === t && a === e || a === t && n === e)
                    return u.touching ? u : null;
                u = u.next
            }
            return null
        },
        checkContact: function (t, e) {
            for (var n, a, u = this.contacts; null !== u; ) {
                if (n = u.body1.name || " ", a = u.body2.name || " ", n == t && a == e || a == t && n == e)
                    return !!u.touching;
                u = u.next
            }
        },
        callSleep: function (t) {
            return !!t.allowSleep && (!(t.linearVelocity.lengthSq() > World.SLEEP_LINEAR_VELOCITY) && !(t.angularVelocity.lengthSq() > World.SLEEP_ANGULAR_VELOCITY))
        },
        step: function () {
            var t = this.isStat;
            t && this.performance.setTime(0);
            for (var e = this.rigidBodies; null !== e; )
                e.addedToIsland = !1, e.sleeping && e.testWakeUp(), e = e.next;
            t && this.performance.setTime(1),
            this.broadPhase.detectPairs();
            for (var n = this.broadPhase.pairs, a = this.broadPhase.numPairs; a--; ) {
                var u,
                g,
                p,
                f = n[a];
                f.shape1.id < f.shape2.id ? (u = f.shape1, g = f.shape2) : (u = f.shape2, g = f.shape1),
                p = u.numContacts < g.numContacts ? u.contactLink : g.contactLink;
                for (var m = !1; p; ) {
                    if ((B = p.contact).shape1 == u && B.shape2 == g) {
                        B.persisting = !0,
                        m = !0;
                        break
                    }
                    p = p.next
                }
                m || this.addContact(u, g)
            }
            for (t && this.performance.calcBroadPhase(), this.numContactPoints = 0, B = this.contacts; null !== B; )
                if (B.persisting || B.shape1.proxy && B.shape2.proxy && !B.shape1.aabb.intersectTest(B.shape2.aabb)) {
                    var y = B.body1,
                    S = B.body2;
                    (y.isDynamic && !y.sleeping || S.isDynamic && !S.sleeping) && B.updateManifold(),
                    this.numContactPoints += B.manifold.numPoints,
                    B.persisting = !1,
                    B.constraint.addedToIsland = !1,
                    B = B.next
                } else {
                    var _ = B.next;
                    this.removeContact(B),
                    B = _
                }
            t && this.performance.calcNarrowPhase();
            var A,
            v,
            w = 1 / this.timeStep;
            for (A = this.joints; null !== A; A = A.next)
                A.addedToIsland = !1;
            this.islandRigidBodies = [],
            this.islandConstraints = [],
            this.islandStack = [],
            t && this.performance.setTime(1),
            this.numIslands = 0;
            for (var E = this.rigidBodies; null !== E; E = E.next) {
                if (E.event_cb) {
                    let t = [],
                    e = E.contactLink;
                    for (; e; ) {
                        let n = e.contact;
                        t.push(n),
                        e = e.next
                    }
                    E.event_cb(t)
                }
                if (!(E.addedToIsland || E.isStatic || E.sleeping))
                    if (E.isLonely()) {
                        if (E.isDynamic) {
                            var x = E.overrideGravity || this.gravity;
                            E.linearVelocity.addScaledVector(x, this.timeStep)
                        }
                        this.callSleep(E) ? (E.sleepTime += this.timeStep, E.sleepTime > World.SLEEP_DELTA_TIME ? E.sleep() : E.updatePosition(this.timeStep)) : (E.sleepTime = 0, E.updatePosition(this.timeStep)),
                        this.numIslands++
                    } else {
                        var C = 0,
                        b = 0,
                        R = 1;
                        this.islandStack[0] = E,
                        E.addedToIsland = !0;
                        do {
                            if (e = this.islandStack[--R], this.islandStack[R] = null, e.sleeping = !1, this.islandRigidBodies[C++] = e, !e.isStatic) {
                                for (var k = e.contactLink; null !== k; k = k.next) {
                                    var B;
                                    if (!(v = (B = k.contact).constraint).addedToIsland && B.touching)
                                        this.islandConstraints[b++] = v, v.addedToIsland = !0, (_ = k.body).addedToIsland || (this.islandStack[R++] = _, _.addedToIsland = !0)
                                }
                                for (var V = e.jointLink; null !== V; V = V.next)
                                    (v = V.joint).addedToIsland || (this.islandConstraints[b++] = v, v.addedToIsland = !0, !(_ = V.body).addedToIsland && _.isDynamic && (this.islandStack[R++] = _, _.addedToIsland = !0))
                            }
                        } while (0 != R);
                        for (var z = C; z--; )
                            if ((e = this.islandRigidBodies[z]).isDynamic) {
                                x = e.overrideGravity || this.gravity;
                                e.linearVelocity.addScaledVector(x, this.timeStep)
                            }
                        if (this.enableRandomizer)
                            for (z = b; z--; )
                                if (0 !== z) {
                                    var J = (this.randX = this.randX * this.randA + this.randB & 2147483647) / 2147483648 * z | 0;
                                    v = this.islandConstraints[z],
                                    this.islandConstraints[z] = this.islandConstraints[J],
                                    this.islandConstraints[J] = v
                                }
                        for (z = b; z--; )
                            this.islandConstraints[z].preSolve(this.timeStep, w);
                        for (var $ = this.numIterations; $--; )
                            for (z = b; z--; )
                                this.islandConstraints[z].solve();
                        for (z = b; z--; )
                            this.islandConstraints[z].postSolve(), this.islandConstraints[z] = null;
                        var Z = 10;
                        for (z = C; z--; )
                            e = this.islandRigidBodies[z], this.callSleep(e) ? (e.sleepTime += this.timeStep, e.sleepTime < Z && (Z = e.sleepTime)) : (e.sleepTime = 0, Z = 0);
                        if (Z > World.SLEEP_DELTA_TIME)
                            for (z = C; z--; )
                                this.islandRigidBodies[z].sleep(), this.islandRigidBodies[z] = null;
                        else
                            for (z = C; z--; )
                                this.islandRigidBodies[z].updatePosition(this.timeStep), this.islandRigidBodies[z] = null;
                        this.numIslands++
                    }
            }
            t && this.performance.calcEnd(),
            null !== this.postLoop && this.postLoop()
        },
        remove: function (t) {},
        add: function (t) {
            var e = (t = t || {}).type || "box";
            return e.constructor === String && (e = [e]),
            "joint" === e[0].substring(0, 5) ? this.initJoint(e[0], t) : this.initBody(e, t)
        },
        initBody: function (t, e) {
            var n = this.invScale,
            a = e.move || !1,
            u = e.kinematic || !1,
            g = e.pos || [0, 0, 0];
            g = g.map((function (t) {
                        return t * n
                    }));
            var p = e.posShape || [0, 0, 0];
            p = p.map((function (t) {
                        return t * n
                    }));
            var f = e.rot || [0, 0, 0, 1],
            m = e.rotShape || [0, 0, 0, 1],
            y = void 0 === e.size ? [1, 1, 1] : e.size;
            1 === y.length && (y[1] = y[0]),
            2 === y.length && (y[2] = y[0]),
            y = y.map((function (t) {
                        return t * n
                    }));
            var S = new ShapeConfig;
            void 0 !== e.density && (S.density = e.density),
            void 0 !== e.friction && (S.friction = e.friction),
            void 0 !== e.restitution && (S.restitution = e.restitution),
            void 0 !== e.belongsTo && (S.belongsTo = e.belongsTo),
            void 0 !== e.collidesWith && (S.collidesWith = e.collidesWith),
            void 0 !== e.config && (void 0 !== e.config[0] && (S.density = e.config[0]), void 0 !== e.config[1] && (S.friction = e.config[1]), void 0 !== e.config[2] && (S.restitution = e.config[2]), void 0 !== e.config[3] && (S.belongsTo = e.config[3]), void 0 !== e.config[4] && (S.collidesWith = e.config[4]));
            for (var _, A, v, w = new RigidBody(new Vec3(g[0], g[1], g[2]), new Quat(f[0], f[1], f[2], f[3])), E = 0; E < t.length; E++) {
                switch (v = 4 * E, void 0 !== p[A = 3 * E] && S.relativePosition.set(p[A], p[A + 1], p[A + 2]), void 0 !== m[v] && S.relativeRotation.setQuat(new Quat(m[v], m[v + 1], m[v + 2], m[v + 3])), void 0 !== m[v] && (S.localRotation = new Quat(m[v], m[v + 1], m[v + 2], m[v + 3])), t[E]) {
                case "sphere":
                    _ = new Sphere(S, y[A]);
                    break;
                case "cylinder":
                    _ = new Cylinder(S, y[A], y[A + 1]);
                    break;
                case "box":
                    _ = new Box(S, y[A], y[A + 1], y[A + 2]);
                    break;
                case "plane":
                    _ = new Plane(S)
                }
                e.nameShape && e.nameShape[E] && (_.name = e.nameShape[E]),
                e.massShape && e.massShape[E] && (_.mass = e.massShape[E]),
                w.addShape(_)
            }
            return e.neverSleep || u ? w.allowSleep = !1 : w.allowSleep = !0,
            w.isKinematic = u,
            void 0 !== e.overrideGravity && (w.overrideGravity = new Vec3(e.overrideGravity.x, e.overrideGravity.y, e.overrideGravity.z)),
            void 0 !== e.name && (w.name = e.name),
            a ? e.massPos || e.massRot ? w.setupMass(1, !1) : w.setupMass(1, !0) : w.setupMass(2),
            this.addRigidBody(w),
            a && (e.sleep ? w.sleep() : w.awake()),
            w
        },
        initJoint: function (t, e) {
            var n,
            a,
            u = this.invScale,
            p = e.axe1 || [1, 0, 0],
            f = e.axe2 || [1, 0, 0],
            m = e.pos1 || [0, 0, 0],
            y = e.pos2 || [0, 0, 0];
            m = m.map((function (t) {
                        return t * u
                    })),
            y = y.map((function (t) {
                        return t * u
                    })),
            "jointDistance" === t ? (n = e.min || 0, a = e.max || 10, n *= u, a *= u) : (n = e.min || 57.29578, a = e.max || 0, n *= g.degtorad, a *= g.degtorad);
            var S = e.limit || null,
            _ = e.spring || null,
            A = e.motor || null,
            v = new JointConfig;
            v.scale = this.scale,
            v.invScale = this.invScale,
            v.allowCollision = e.collision || !1,
            v.localAxis1.set(p[0], p[1], p[2]),
            v.localAxis2.set(f[0], f[1], f[2]),
            v.localAnchorPoint1.set(m[0], m[1], m[2]),
            v.localAnchorPoint2.set(y[0], y[1], y[2]);
            var w,
            E = null,
            x = null;
            if (void 0 === e.body1 || void 0 === e.body2)
                return printError("World", "Can't add joint if attach rigidbodys not define !");
            if (e.body1.constructor === String || e.body1.constructor === Number ? E = this.getByName(e.body1) : e.body1.constructor === RigidBody && (E = e.body1), e.body2.constructor === String || e.body2.constructor === Number ? x = this.getByName(e.body2) : e.body2.constructor === RigidBody && (x = e.body2), null === E || null === x)
                return printError("World", "Can't add joint attach rigidbodys not find !");
            switch (v.body1 = E, v.body2 = x, t) {
            case "jointDistance":
                w = new DistanceJoint(v, n, a),
                null !== _ && w.limitMotor.setSpring(_[0], _[1]),
                null !== A && w.limitMotor.setMotor(A[0], A[1]);
                break;
            case "jointHinge":
            case "joint":
                w = new HingeJoint(v, n, a),
                null !== _ && w.limitMotor.setSpring(_[0], _[1]),
                null !== A && w.limitMotor.setMotor(A[0], A[1]);
                break;
            case "jointPrisme":
                w = new PrismaticJoint(v, n, a);
                break;
            case "jointSlide":
                w = new SliderJoint(v, n, a);
                break;
            case "jointBall":
                w = new BallAndSocketJoint(v);
                break;
            case "jointWheel":
                w = new WheelJoint(v),
                null !== S && w.rotationalLimitMotor1.setLimit(S[0], S[1]),
                null !== _ && w.rotationalLimitMotor1.setSpring(_[0], _[1]),
                null !== A && w.rotationalLimitMotor1.setMotor(A[0], A[1])
            }
            return w.name = e.name || "",
            this.addJoint(w),
            w
        },
        rayCast: function (t, e, n, a, u = -1) {
            n = n || 2147483647;
            let g = new Vec3,
            p = new Vec3(t.origin.x, t.origin.y, t.origin.z);
            for (var f = this.rigidBodies, m = new Vec3, y = new Quat, S = [], _ = new Vec3; null !== f; ) {
                for (var A = f.shapes; null !== A; A = A.next)
                    if (0 != (u & A.belongsTo)) {
                        var v = {
                            temp: m,
                            hasHit: !1,
                            distance: -1,
                            owner: f.owner
                        };
                        y.copy(f.orientation),
                        y.inverse();
                        var w = A.aabb.getCenter();
                        1 == A.type ? (g.copy(p), _.copy(t.direction)) : (g.copy(p).subEqual(w), g.applyQuaternion(y), _.copy(t.direction).applyQuaternion(y)),
                        A.intersectRay(g, _, n, v),
                        v.hasHit && (1 == A.type ? v.normal = _ : (v.intersectionPoint.applyQuaternion(f.orientation).addEqual(w), v.normal.applyQuaternion(f.orientation)), S.push(v), v.shapeName = A.name)
                    }
                f = f.next
            }
            if (S.length > 0) {
                var E;
                for (const t of S)
                    t.distance > 0 && t.distance <= n && (n = t.distance, E = t);
                E && (e.succeeded = !0, e.hitFraction = E.distance, e.point.from(E.intersectionPoint), e.normal.from(E.normal), e.collider = {
                        owner: E.owner,
                        shapeName: E.shapeName
                    })
            }
        },
        rayCastAll: function (t, e, n, a, u = -1) {
            n = n || 2147483647;
            let g = new Vec3,
            p = new Vec3(t.origin.x, t.origin.y, t.origin.z);
            for (var f = this.rigidBodies, m = new Vec3, y = new Quat, S = [], _ = new Vec3; null !== f; ) {
                for (var A = f.shapes; null !== A; A = A.next)
                    if (0 != (u & A.belongsTo)) {
                        var v = {
                            temp: m,
                            hasHit: !1,
                            distance: -1,
                            owner: f.owner
                        };
                        y.copy(f.orientation),
                        y.inverse();
                        var w = A.aabb.getCenter();
                        1 == A.type ? (g.copy(p), _.copy(t.direction)) : (g.copy(p).subEqual(w), g.applyQuaternion(y), _.copy(t.direction).applyQuaternion(y)),
                        A.intersectRay(g, _, n, v),
                        v.hasHit && (1 == A.type ? v.normal = _ : (v.intersectionPoint.applyQuaternion(f.orientation).addEqual(w), v.normal.applyQuaternion(f.orientation)), S.push(v), v.shapeName = A.name)
                    }
                f = f.next
            }
            if (S)
                for (const t of S) {
                    let n = {
                        succeeded: !0
                    };
                    n.hitFraction = t.distance,
                    n.point = new Vec3(t.intersectionPoint.x, t.intersectionPoint.y, t.intersectionPoint.z),
                    n.normal = new Vec3(t.normal.x, t.normal.y, t.normal.z),
                    n.collider = {
                        owner: t.owner,
                        shapeName: t.shapeName
                    },
                    e.push(n)
                }
            return e.length > 0
        },
        ignoreCollision: function (t, e, n) {
            t.ignore || (t.ignore = []);
            let a = t.ignore.indexOf(e);
            n && -1 == a ? t.ignore.push(e) : n || -1 == a || t.ignore.splice(a)
        }
    }),
    t.Math = g,
    t.Vec3 = Vec3,
    t.Quat = Quat,
    t.Mat33 = Mat33,
    t.Shape = Shape,
    t.Box = Box,
    t.Sphere = Sphere,
    t.Cylinder = Cylinder,
    t.Plane = Plane,
    t.Particle = Particle,
    t.ShapeConfig = ShapeConfig,
    t.LimitMotor = LimitMotor,
    t.HingeJoint = HingeJoint,
    t.BallAndSocketJoint = BallAndSocketJoint,
    t.DistanceJoint = DistanceJoint,
    t.PrismaticJoint = PrismaticJoint,
    t.SliderJoint = SliderJoint,
    t.WheelJoint = WheelJoint,
    t.JointConfig = JointConfig,
    t.RigidBody = RigidBody,
    t.World = World,
    t.REVISION = "1.0.9",
    t.BR_NULL = 0,
    t.BR_BRUTE_FORCE = 1,
    t.BR_SWEEP_AND_PRUNE = 2,
    t.BR_BOUNDING_VOLUME_TREE = 3,
    t.BODY_NULL = 0,
    t.BODY_DYNAMIC = 1,
    t.BODY_STATIC = 2,
    t.BODY_KINEMATIC = 3,
    t.BODY_GHOST = 4,
    t.SHAPE_NULL = 0,
    t.SHAPE_SPHERE = 1,
    t.SHAPE_BOX = 2,
    t.SHAPE_CYLINDER = 3,
    t.SHAPE_PLANE = 4,
    t.SHAPE_PARTICLE = 5,
    t.SHAPE_TETRA = 6,
    t.JOINT_NULL = 0,
    t.JOINT_DISTANCE = 1,
    t.JOINT_BALL_AND_SOCKET = 2,
    t.JOINT_HINGE = 3,
    t.JOINT_WHEEL = 4,
    t.JOINT_SLIDER = 5,
    t.JOINT_PRISMATIC = 6,
    t.AABB_PROX = .005,
    t.printError = printError,
    t.InfoDisplay = InfoDisplay,
    t
}
({}), window.pako = function r(t, e, n) {
    function h(u, g) {
        if (!e[u]) {
            if (!t[u]) {
                var p = "function" == typeof require && require;
                if (!g && p)
                    return p(u, !0);
                if (a)
                    return a(u, !0);
                var f = new Error("Cannot find module '" + u + "'");
                throw f.code = "MODULE_NOT_FOUND",
                f
            }
            var m = e[u] = {
                exports: {}
            };
            t[u][0].call(m.exports, (function (e) {
                    return h(t[u][1][e] || e)
                }), m, m.exports, r, t, e, n)
        }
        return e[u].exports
    }
    for (var a = "function" == typeof require && require, u = 0; u < n.length; u++)
        h(n[u]);
    return h
}
({
    1: [function (t, e, n) {
            "use strict";
            var a = t("./zlib/deflate"),
            u = t("./utils/common"),
            g = t("./utils/strings"),
            p = t("./zlib/messages"),
            f = t("./zlib/zstream"),
            m = Object.prototype.toString;
            function c(t) {
                if (!(this instanceof c))
                    return new c(t);
                this.options = u.assign({
                    level: -1,
                    method: 8,
                    chunkSize: 16384,
                    windowBits: 15,
                    memLevel: 8,
                    strategy: 0,
                    to: ""
                }, t || {});
                var e = this.options;
                e.raw && 0 < e.windowBits ? e.windowBits = -e.windowBits : e.gzip && 0 < e.windowBits && e.windowBits < 16 && (e.windowBits += 16),
                this.err = 0,
                this.msg = "",
                this.ended = !1,
                this.chunks = [],
                this.strm = new f,
                this.strm.avail_out = 0;
                var n = a.deflateInit2(this.strm, e.level, e.method, e.windowBits, e.memLevel, e.strategy);
                if (0 !== n)
                    throw new Error(p[n]);
                if (e.header && a.deflateSetHeader(this.strm, e.header), e.dictionary) {
                    var y;
                    if (y = "string" == typeof e.dictionary ? g.string2buf(e.dictionary) : "[object ArrayBuffer]" === m.call(e.dictionary) ? new Uint8Array(e.dictionary) : e.dictionary, 0 !== (n = a.deflateSetDictionary(this.strm, y)))
                        throw new Error(p[n]);
                    this._dict_set = !0
                }
            }
            function i(t, e) {
                var n = new c(e);
                if (n.push(t, !0), n.err)
                    throw n.msg || p[n.err];
                return n.result
            }
            c.prototype.push = function (t, e) {
                var n,
                p,
                f = this.strm,
                y = this.options.chunkSize;
                if (this.ended)
                    return !1;
                p = e === ~~e ? e : !0 === e ? 4 : 0,
                "string" == typeof t ? f.input = g.string2buf(t) : "[object ArrayBuffer]" === m.call(t) ? f.input = new Uint8Array(t) : f.input = t,
                f.next_in = 0,
                f.avail_in = f.input.length;
                do {
                    if (0 === f.avail_out && (f.output = new u.Buf8(y), f.next_out = 0, f.avail_out = y), 1 !== (n = a.deflate(f, p)) && 0 !== n)
                        return this.onEnd(n), !(this.ended = !0);
                    0 !== f.avail_out && (0 !== f.avail_in || 4 !== p && 2 !== p) || ("string" === this.options.to ? this.onData(g.buf2binstring(u.shrinkBuf(f.output, f.next_out))) : this.onData(u.shrinkBuf(f.output, f.next_out)))
                } while ((0 < f.avail_in || 0 === f.avail_out) && 1 !== n);
                return 4 === p ? (n = a.deflateEnd(this.strm), this.onEnd(n), this.ended = !0, 0 === n) : 2 !== p || (this.onEnd(0), !(f.avail_out = 0))
            },
            c.prototype.onData = function (t) {
                this.chunks.push(t)
            },
            c.prototype.onEnd = function (t) {
                0 === t && ("string" === this.options.to ? this.result = this.chunks.join("") : this.result = u.flattenChunks(this.chunks)),
                this.chunks = [],
                this.err = t,
                this.msg = this.strm.msg
            },
            n.Deflate = c,
            n.deflate = i,
            n.deflateRaw = function (t, e) {
                return (e = e || {}).raw = !0,
                i(t, e)
            },
            n.gzip = function (t, e) {
                return (e = e || {}).gzip = !0,
                i(t, e)
            }
        }, {
            "./utils/common": 3,
            "./utils/strings": 4,
            "./zlib/deflate": 8,
            "./zlib/messages": 13,
            "./zlib/zstream": 15
        }
    ],
    2: [function (t, e, n) {
            "use strict";
            var a = t("./zlib/inflate"),
            u = t("./utils/common"),
            g = t("./utils/strings"),
            p = t("./zlib/constants"),
            f = t("./zlib/messages"),
            m = t("./zlib/zstream"),
            y = t("./zlib/gzheader"),
            S = Object.prototype.toString;
            function s(t) {
                if (!(this instanceof s))
                    return new s(t);
                this.options = u.assign({
                    chunkSize: 16384,
                    windowBits: 0,
                    to: ""
                }, t || {});
                var e = this.options;
                e.raw && 0 <= e.windowBits && e.windowBits < 16 && (e.windowBits = -e.windowBits, 0 === e.windowBits && (e.windowBits = -15)),
                !(0 <= e.windowBits && e.windowBits < 16) || t && t.windowBits || (e.windowBits += 32),
                15 < e.windowBits && e.windowBits < 48 && 0 == (15 & e.windowBits) && (e.windowBits |= 15),
                this.err = 0,
                this.msg = "",
                this.ended = !1,
                this.chunks = [],
                this.strm = new m,
                this.strm.avail_out = 0;
                var n = a.inflateInit2(this.strm, e.windowBits);
                if (n !== p.Z_OK)
                    throw new Error(f[n]);
                this.header = new y,
                a.inflateGetHeader(this.strm, this.header)
            }
            function o(t, e) {
                var n = new s(e);
                if (n.push(t, !0), n.err)
                    throw n.msg || f[n.err];
                return n.result
            }
            s.prototype.push = function (t, e) {
                var n,
                f,
                m,
                y,
                _,
                A,
                v = this.strm,
                w = this.options.chunkSize,
                E = this.options.dictionary,
                x = !1;
                if (this.ended)
                    return !1;
                f = e === ~~e ? e : !0 === e ? p.Z_FINISH : p.Z_NO_FLUSH,
                "string" == typeof t ? v.input = g.binstring2buf(t) : "[object ArrayBuffer]" === S.call(t) ? v.input = new Uint8Array(t) : v.input = t,
                v.next_in = 0,
                v.avail_in = v.input.length;
                do {
                    if (0 === v.avail_out && (v.output = new u.Buf8(w), v.next_out = 0, v.avail_out = w), (n = a.inflate(v, p.Z_NO_FLUSH)) === p.Z_NEED_DICT && E && (A = "string" == typeof E ? g.string2buf(E) : "[object ArrayBuffer]" === S.call(E) ? new Uint8Array(E) : E, n = a.inflateSetDictionary(this.strm, A)), n === p.Z_BUF_ERROR && !0 === x && (n = p.Z_OK, x = !1), n !== p.Z_STREAM_END && n !== p.Z_OK)
                        return this.onEnd(n), !(this.ended = !0);
                    v.next_out && (0 !== v.avail_out && n !== p.Z_STREAM_END && (0 !== v.avail_in || f !== p.Z_FINISH && f !== p.Z_SYNC_FLUSH) || ("string" === this.options.to ? (m = g.utf8border(v.output, v.next_out), y = v.next_out - m, _ = g.buf2string(v.output, m), v.next_out = y, v.avail_out = w - y, y && u.arraySet(v.output, v.output, m, y, 0), this.onData(_)) : this.onData(u.shrinkBuf(v.output, v.next_out)))),
                    0 === v.avail_in && 0 === v.avail_out && (x = !0)
                } while ((0 < v.avail_in || 0 === v.avail_out) && n !== p.Z_STREAM_END);
                return n === p.Z_STREAM_END && (f = p.Z_FINISH),
                f === p.Z_FINISH ? (n = a.inflateEnd(this.strm), this.onEnd(n), this.ended = !0, n === p.Z_OK) : f !== p.Z_SYNC_FLUSH || (this.onEnd(p.Z_OK), !(v.avail_out = 0))
            },
            s.prototype.onData = function (t) {
                this.chunks.push(t)
            },
            s.prototype.onEnd = function (t) {
                t === p.Z_OK && ("string" === this.options.to ? this.result = this.chunks.join("") : this.result = u.flattenChunks(this.chunks)),
                this.chunks = [],
                this.err = t,
                this.msg = this.strm.msg
            },
            n.Inflate = s,
            n.inflate = o,
            n.inflateRaw = function (t, e) {
                return (e = e || {}).raw = !0,
                o(t, e)
            },
            n.ungzip = o
        }, {
            "./utils/common": 3,
            "./utils/strings": 4,
            "./zlib/constants": 6,
            "./zlib/gzheader": 9,
            "./zlib/inflate": 11,
            "./zlib/messages": 13,
            "./zlib/zstream": 15
        }
    ],
    3: [function (t, e, n) {
            "use strict";
            var a = "undefined" != typeof Uint8Array && "undefined" != typeof Uint16Array && "undefined" != typeof Int32Array;
            n.assign = function (t) {
                for (var e, n, a = Array.prototype.slice.call(arguments, 1); a.length; ) {
                    var u = a.shift();
                    if (u) {
                        if ("object" != typeof u)
                            throw new TypeError(u + "must be non-object");
                        for (var g in u)
                            e = u, n = g, Object.prototype.hasOwnProperty.call(e, n) && (t[g] = u[g])
                    }
                }
                return t
            },
            n.shrinkBuf = function (t, e) {
                return t.length === e ? t : t.subarray ? t.subarray(0, e) : (t.length = e, t)
            };
            var u = {
                arraySet: function (t, e, n, a, u) {
                    if (e.subarray && t.subarray)
                        t.set(e.subarray(n, n + a), u);
                    else
                        for (var g = 0; g < a; g++)
                            t[u + g] = e[n + g]
                },
                flattenChunks: function (t) {
                    var e,
                    n,
                    a,
                    u,
                    g,
                    p;
                    for (e = a = 0, n = t.length; e < n; e++)
                        a += t[e].length;
                    for (p = new Uint8Array(a), e = u = 0, n = t.length; e < n; e++)
                        g = t[e], p.set(g, u), u += g.length;
                    return p
                }
            },
            g = {
                arraySet: function (t, e, n, a, u) {
                    for (var g = 0; g < a; g++)
                        t[u + g] = e[n + g]
                },
                flattenChunks: function (t) {
                    return [].concat.apply([], t)
                }
            };
            n.setTyped = function (t) {
                t ? (n.Buf8 = Uint8Array, n.Buf16 = Uint16Array, n.Buf32 = Int32Array, n.assign(n, u)) : (n.Buf8 = Array, n.Buf16 = Array, n.Buf32 = Array, n.assign(n, g))
            },
            n.setTyped(a)
        }, {}
    ],
    4: [function (t, e, n) {
            "use strict";
            var a = t("./common"),
            u = !0,
            g = !0;
            try {
                String.fromCharCode.apply(null, [0])
            } catch (t) {
                u = !1
            }
            try {
                String.fromCharCode.apply(null, new Uint8Array(1))
            } catch (t) {
                g = !1
            }
            for (var p = new a.Buf8(256), f = 0; f < 256; f++)
                p[f] = 252 <= f ? 6 : 248 <= f ? 5 : 240 <= f ? 4 : 224 <= f ? 3 : 192 <= f ? 2 : 1;
            function d(t, e) {
                if (e < 65534 && (t.subarray && g || !t.subarray && u))
                    return String.fromCharCode.apply(null, a.shrinkBuf(t, e));
                for (var n = "", p = 0; p < e; p++)
                    n += String.fromCharCode(t[p]);
                return n
            }
            p[254] = p[254] = 1,
            n.string2buf = function (t) {
                var e,
                n,
                u,
                g,
                p,
                f = t.length,
                m = 0;
                for (g = 0; g < f; g++)
                    55296 == (64512 & (n = t.charCodeAt(g))) && g + 1 < f && 56320 == (64512 & (u = t.charCodeAt(g + 1))) && (n = 65536 + (n - 55296 << 10) + (u - 56320), g++), m += n < 128 ? 1 : n < 2048 ? 2 : n < 65536 ? 3 : 4;
                for (e = new a.Buf8(m), g = p = 0; p < m; g++)
                    55296 == (64512 & (n = t.charCodeAt(g))) && g + 1 < f && 56320 == (64512 & (u = t.charCodeAt(g + 1))) && (n = 65536 + (n - 55296 << 10) + (u - 56320), g++), e[p++] = n < 128 ? n : (e[p++] = n < 2048 ? 192 | n >>> 6 : (e[p++] = n < 65536 ? 224 | n >>> 12 : (e[p++] = 240 | n >>> 18, 128 | n >>> 12 & 63), 128 | n >>> 6 & 63), 128 | 63 & n);
                return e
            },
            n.buf2binstring = function (t) {
                return d(t, t.length)
            },
            n.binstring2buf = function (t) {
                for (var e = new a.Buf8(t.length), n = 0, u = e.length; n < u; n++)
                    e[n] = t.charCodeAt(n);
                return e
            },
            n.buf2string = function (t, e) {
                var n,
                a,
                u,
                g,
                f = e || t.length,
                m = new Array(2 * f);
                for (n = a = 0; n < f; )
                    if ((u = t[n++]) < 128)
                        m[a++] = u;
                    else if (4 < (g = p[u]))
                        m[a++] = 65533, n += g - 1;
                    else {
                        for (u &= 2 === g ? 31 : 3 === g ? 15 : 7; 1 < g && n < f; )
                            u = u << 6 | 63 & t[n++], g--;
                        m[a++] = 1 < g ? 65533 : u < 65536 ? u : (u -= 65536, m[a++] = 55296 | u >> 10 & 1023, 56320 | 1023 & u)
                    }
                return d(m, a)
            },
            n.utf8border = function (t, e) {
                var n;
                for ((e = e || t.length) > t.length && (e = t.length), n = e - 1; 0 <= n && 128 == (192 & t[n]); )
                    n--;
                return n < 0 || 0 === n ? e : n + p[t[n]] > e ? n : e
            }
        }, {
            "./common": 3
        }
    ],
    5: [function (t, e, n) {
            "use strict";
            e.exports = function (t, e, n, a) {
                for (var u = 65535 & t | 0, g = t >>> 16 & 65535 | 0, p = 0; 0 !== n; ) {
                    for (n -= p = 2e3 < n ? 2e3 : n; g = g + (u = u + e[a++] | 0) | 0, --p; );
                    u %= 65521,
                    g %= 65521
                }
                return u | g << 16 | 0
            }
        }, {}
    ],
    6: [function (t, e, n) {
            "use strict";
            e.exports = {
                Z_NO_FLUSH: 0,
                Z_PARTIAL_FLUSH: 1,
                Z_SYNC_FLUSH: 2,
                Z_FULL_FLUSH: 3,
                Z_FINISH: 4,
                Z_BLOCK: 5,
                Z_TREES: 6,
                Z_OK: 0,
                Z_STREAM_END: 1,
                Z_NEED_DICT: 2,
                Z_ERRNO: -1,
                Z_STREAM_ERROR: -2,
                Z_DATA_ERROR: -3,
                Z_BUF_ERROR: -5,
                Z_NO_COMPRESSION: 0,
                Z_BEST_SPEED: 1,
                Z_BEST_COMPRESSION: 9,
                Z_DEFAULT_COMPRESSION: -1,
                Z_FILTERED: 1,
                Z_HUFFMAN_ONLY: 2,
                Z_RLE: 3,
                Z_FIXED: 4,
                Z_DEFAULT_STRATEGY: 0,
                Z_BINARY: 0,
                Z_TEXT: 1,
                Z_UNKNOWN: 2,
                Z_DEFLATED: 8
            }
        }, {}
    ],
    7: [function (t, e, n) {
            "use strict";
            var a = function () {
                for (var t, e = [], n = 0; n < 256; n++) {
                    t = n;
                    for (var a = 0; a < 8; a++)
                        t = 1 & t ? 3988292384 ^ t >>> 1 : t >>> 1;
                    e[n] = t
                }
                return e
            }
            ();
            e.exports = function (t, e, n, u) {
                var g = a,
                p = u + n;
                t ^= -1;
                for (var f = u; f < p; f++)
                    t = t >>> 8 ^ g[255 & (t ^ e[f])];
                return -1 ^ t
            }
        }, {}
    ],
    8: [function (t, e, n) {
            "use strict";
            var a,
            u = t("../utils/common"),
            g = t("./trees"),
            p = t("./adler32"),
            f = t("./crc32"),
            m = t("./messages"),
            y = -2,
            S = 258,
            _ = 262,
            A = 113;
            function N(t, e) {
                return t.msg = m[e],
                e
            }
            function O(t) {
                return (t << 1) - (4 < t ? 9 : 0)
            }
            function D(t) {
                for (var e = t.length; 0 <= --e; )
                    t[e] = 0
            }
            function I(t) {
                var e = t.state,
                n = e.pending;
                n > t.avail_out && (n = t.avail_out),
                0 !== n && (u.arraySet(t.output, e.pending_buf, e.pending_out, n, t.next_out), t.next_out += n, e.pending_out += n, t.total_out += n, t.avail_out -= n, e.pending -= n, 0 === e.pending && (e.pending_out = 0))
            }
            function U(t, e) {
                g._tr_flush_block(t, 0 <= t.block_start ? t.block_start : -1, t.strstart - t.block_start, e),
                t.block_start = t.strstart,
                I(t.strm)
            }
            function T(t, e) {
                t.pending_buf[t.pending++] = e
            }
            function F(t, e) {
                t.pending_buf[t.pending++] = e >>> 8 & 255,
                t.pending_buf[t.pending++] = 255 & e
            }
            function L(t, e) {
                var n,
                a,
                u = t.max_chain_length,
                g = t.strstart,
                p = t.prev_length,
                f = t.nice_match,
                m = t.strstart > t.w_size - _ ? t.strstart - (t.w_size - _) : 0,
                y = t.window,
                A = t.w_mask,
                v = t.prev,
                w = t.strstart + S,
                E = y[g + p - 1],
                x = y[g + p];
                t.prev_length >= t.good_match && (u >>= 2),
                f > t.lookahead && (f = t.lookahead);
                do {
                    if (y[(n = e) + p] === x && y[n + p - 1] === E && y[n] === y[g] && y[++n] === y[g + 1]) {
                        g += 2,
                        n++;
                        do {}
                        while (y[++g] === y[++n] && y[++g] === y[++n] && y[++g] === y[++n] && y[++g] === y[++n] && y[++g] === y[++n] && y[++g] === y[++n] && y[++g] === y[++n] && y[++g] === y[++n] && g < w);
                        if (a = S - (w - g), g = w - S, p < a) {
                            if (t.match_start = e, f <= (p = a))
                                break;
                            E = y[g + p - 1],
                            x = y[g + p]
                        }
                    }
                } while ((e = v[e & A]) > m && 0 != --u);
                return p <= t.lookahead ? p : t.lookahead
            }
            function H(t) {
                var e,
                n,
                a,
                g,
                m,
                y,
                S,
                A,
                v,
                w,
                E = t.w_size;
                do {
                    if (g = t.window_size - t.lookahead - t.strstart, t.strstart >= E + (E - _)) {
                        for (u.arraySet(t.window, t.window, E, E, 0), t.match_start -= E, t.strstart -= E, t.block_start -= E, e = n = t.hash_size; a = t.head[--e], t.head[e] = E <= a ? a - E : 0, --n; );
                        for (e = n = E; a = t.prev[--e], t.prev[e] = E <= a ? a - E : 0, --n; );
                        g += E
                    }
                    if (0 === t.strm.avail_in)
                        break;
                    if (y = t.strm, S = t.window, A = t.strstart + t.lookahead, w = void 0, (v = g) < (w = y.avail_in) && (w = v), n = 0 === w ? 0 : (y.avail_in -= w, u.arraySet(S, y.input, y.next_in, w, A), 1 === y.state.wrap ? y.adler = p(y.adler, S, w, A) : 2 === y.state.wrap && (y.adler = f(y.adler, S, w, A)), y.next_in += w, y.total_in += w, w), t.lookahead += n, t.lookahead + t.insert >= 3)
                        for (m = t.strstart - t.insert, t.ins_h = t.window[m], t.ins_h = (t.ins_h << t.hash_shift ^ t.window[m + 1]) & t.hash_mask; t.insert && (t.ins_h = (t.ins_h << t.hash_shift ^ t.window[m + 3 - 1]) & t.hash_mask, t.prev[m & t.w_mask] = t.head[t.ins_h], t.head[t.ins_h] = m, m++, t.insert--, !(t.lookahead + t.insert < 3)); );
                } while (t.lookahead < _ && 0 !== t.strm.avail_in)
            }
            function j(t, e) {
                for (var n, a; ; ) {
                    if (t.lookahead < _) {
                        if (H(t), t.lookahead < _ && 0 === e)
                            return 1;
                        if (0 === t.lookahead)
                            break
                    }
                    if (n = 0, t.lookahead >= 3 && (t.ins_h = (t.ins_h << t.hash_shift ^ t.window[t.strstart + 3 - 1]) & t.hash_mask, n = t.prev[t.strstart & t.w_mask] = t.head[t.ins_h], t.head[t.ins_h] = t.strstart), 0 !== n && t.strstart - n <= t.w_size - _ && (t.match_length = L(t, n)), t.match_length >= 3)
                        if (a = g._tr_tally(t, t.strstart - t.match_start, t.match_length - 3), t.lookahead -= t.match_length, t.match_length <= t.max_lazy_match && t.lookahead >= 3) {
                            for (t.match_length--; t.strstart++, t.ins_h = (t.ins_h << t.hash_shift ^ t.window[t.strstart + 3 - 1]) & t.hash_mask, n = t.prev[t.strstart & t.w_mask] = t.head[t.ins_h], t.head[t.ins_h] = t.strstart, 0 != --t.match_length; );
                            t.strstart++
                        } else
                            t.strstart += t.match_length, t.match_length = 0, t.ins_h = t.window[t.strstart], t.ins_h = (t.ins_h << t.hash_shift ^ t.window[t.strstart + 1]) & t.hash_mask;
                    else
                        a = g._tr_tally(t, 0, t.window[t.strstart]), t.lookahead--, t.strstart++;
                    if (a && (U(t, !1), 0 === t.strm.avail_out))
                        return 1
                }
                return t.insert = t.strstart < 2 ? t.strstart : 2,
                4 === e ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4) : t.last_lit && (U(t, !1), 0 === t.strm.avail_out) ? 1 : 2
            }
            function K(t, e) {
                for (var n, a, u; ; ) {
                    if (t.lookahead < _) {
                        if (H(t), t.lookahead < _ && 0 === e)
                            return 1;
                        if (0 === t.lookahead)
                            break
                    }
                    if (n = 0, t.lookahead >= 3 && (t.ins_h = (t.ins_h << t.hash_shift ^ t.window[t.strstart + 3 - 1]) & t.hash_mask, n = t.prev[t.strstart & t.w_mask] = t.head[t.ins_h], t.head[t.ins_h] = t.strstart), t.prev_length = t.match_length, t.prev_match = t.match_start, t.match_length = 2, 0 !== n && t.prev_length < t.max_lazy_match && t.strstart - n <= t.w_size - _ && (t.match_length = L(t, n), t.match_length <= 5 && (1 === t.strategy || 3 === t.match_length && 4096 < t.strstart - t.match_start) && (t.match_length = 2)), t.prev_length >= 3 && t.match_length <= t.prev_length) {
                        for (u = t.strstart + t.lookahead - 3, a = g._tr_tally(t, t.strstart - 1 - t.prev_match, t.prev_length - 3), t.lookahead -= t.prev_length - 1, t.prev_length -= 2; ++t.strstart <= u && (t.ins_h = (t.ins_h << t.hash_shift ^ t.window[t.strstart + 3 - 1]) & t.hash_mask, n = t.prev[t.strstart & t.w_mask] = t.head[t.ins_h], t.head[t.ins_h] = t.strstart), 0 != --t.prev_length; );
                        if (t.match_available = 0, t.match_length = 2, t.strstart++, a && (U(t, !1), 0 === t.strm.avail_out))
                            return 1
                    } else if (t.match_available) {
                        if ((a = g._tr_tally(t, 0, t.window[t.strstart - 1])) && U(t, !1), t.strstart++, t.lookahead--, 0 === t.strm.avail_out)
                            return 1
                    } else
                        t.match_available = 1, t.strstart++, t.lookahead--
                }
                return t.match_available && (a = g._tr_tally(t, 0, t.window[t.strstart - 1]), t.match_available = 0),
                t.insert = t.strstart < 2 ? t.strstart : 2,
                4 === e ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4) : t.last_lit && (U(t, !1), 0 === t.strm.avail_out) ? 1 : 2
            }
            function M(t, e, n, a, u) {
                this.good_length = t,
                this.max_lazy = e,
                this.nice_length = n,
                this.max_chain = a,
                this.func = u
            }
            function P() {
                this.strm = null,
                this.status = 0,
                this.pending_buf = null,
                this.pending_buf_size = 0,
                this.pending_out = 0,
                this.pending = 0,
                this.wrap = 0,
                this.gzhead = null,
                this.gzindex = 0,
                this.method = 8,
                this.last_flush = -1,
                this.w_size = 0,
                this.w_bits = 0,
                this.w_mask = 0,
                this.window = null,
                this.window_size = 0,
                this.prev = null,
                this.head = null,
                this.ins_h = 0,
                this.hash_size = 0,
                this.hash_bits = 0,
                this.hash_mask = 0,
                this.hash_shift = 0,
                this.block_start = 0,
                this.match_length = 0,
                this.prev_match = 0,
                this.match_available = 0,
                this.strstart = 0,
                this.match_start = 0,
                this.lookahead = 0,
                this.prev_length = 0,
                this.max_chain_length = 0,
                this.max_lazy_match = 0,
                this.level = 0,
                this.strategy = 0,
                this.good_match = 0,
                this.nice_match = 0,
                this.dyn_ltree = new u.Buf16(1146),
                this.dyn_dtree = new u.Buf16(122),
                this.bl_tree = new u.Buf16(78),
                D(this.dyn_ltree),
                D(this.dyn_dtree),
                D(this.bl_tree),
                this.l_desc = null,
                this.d_desc = null,
                this.bl_desc = null,
                this.bl_count = new u.Buf16(16),
                this.heap = new u.Buf16(573),
                D(this.heap),
                this.heap_len = 0,
                this.heap_max = 0,
                this.depth = new u.Buf16(573),
                D(this.depth),
                this.l_buf = 0,
                this.lit_bufsize = 0,
                this.last_lit = 0,
                this.d_buf = 0,
                this.opt_len = 0,
                this.static_len = 0,
                this.matches = 0,
                this.insert = 0,
                this.bi_buf = 0,
                this.bi_valid = 0
            }
            function Y(t) {
                var e;
                return t && t.state ? (t.total_in = t.total_out = 0, t.data_type = 2, (e = t.state).pending = 0, e.pending_out = 0, e.wrap < 0 && (e.wrap = -e.wrap), e.status = e.wrap ? 42 : A, t.adler = 2 === e.wrap ? 0 : 1, e.last_flush = 0, g._tr_init(e), 0) : N(t, y)
            }
            function q(t) {
                var e,
                n = Y(t);
                return 0 === n && ((e = t.state).window_size = 2 * e.w_size, D(e.head), e.max_lazy_match = a[e.level].max_lazy, e.good_match = a[e.level].good_length, e.nice_match = a[e.level].nice_length, e.max_chain_length = a[e.level].max_chain, e.strstart = 0, e.block_start = 0, e.lookahead = 0, e.insert = 0, e.match_length = e.prev_length = 2, e.match_available = 0, e.ins_h = 0),
                n
            }
            function G(t, e, n, a, g, p) {
                if (!t)
                    return y;
                var f = 1;
                if (-1 === e && (e = 6), a < 0 ? (f = 0, a = -a) : 15 < a && (f = 2, a -= 16), g < 1 || 9 < g || 8 !== n || a < 8 || 15 < a || e < 0 || 9 < e || p < 0 || 4 < p)
                    return N(t, y);
                8 === a && (a = 9);
                var m = new P;
                return (t.state = m).strm = t,
                m.wrap = f,
                m.gzhead = null,
                m.w_bits = a,
                m.w_size = 1 << m.w_bits,
                m.w_mask = m.w_size - 1,
                m.hash_bits = g + 7,
                m.hash_size = 1 << m.hash_bits,
                m.hash_mask = m.hash_size - 1,
                m.hash_shift = ~~((m.hash_bits + 3 - 1) / 3),
                m.window = new u.Buf8(2 * m.w_size),
                m.head = new u.Buf16(m.hash_size),
                m.prev = new u.Buf16(m.w_size),
                m.lit_bufsize = 1 << g + 6,
                m.pending_buf_size = 4 * m.lit_bufsize,
                m.pending_buf = new u.Buf8(m.pending_buf_size),
                m.d_buf = 1 * m.lit_bufsize,
                m.l_buf = 3 * m.lit_bufsize,
                m.level = e,
                m.strategy = p,
                m.method = n,
                q(t)
            }
            a = [new M(0, 0, 0, 0, (function (t, e) {
                        var n = 65535;
                        for (n > t.pending_buf_size - 5 && (n = t.pending_buf_size - 5); ; ) {
                            if (t.lookahead <= 1) {
                                if (H(t), 0 === t.lookahead && 0 === e)
                                    return 1;
                                if (0 === t.lookahead)
                                    break
                            }
                            t.strstart += t.lookahead,
                            t.lookahead = 0;
                            var a = t.block_start + n;
                            if ((0 === t.strstart || t.strstart >= a) && (t.lookahead = t.strstart - a, t.strstart = a, U(t, !1), 0 === t.strm.avail_out))
                                return 1;
                            if (t.strstart - t.block_start >= t.w_size - _ && (U(t, !1), 0 === t.strm.avail_out))
                                return 1
                        }
                        return t.insert = 0,
                        4 === e ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4) : (t.strstart > t.block_start && (U(t, !1), t.strm.avail_out), 1)
                    })), new M(4, 4, 8, 4, j), new M(4, 5, 16, 8, j), new M(4, 6, 32, 32, j), new M(4, 4, 16, 16, K), new M(8, 16, 32, 32, K), new M(8, 16, 128, 128, K), new M(8, 32, 128, 256, K), new M(32, 128, 258, 1024, K), new M(32, 258, 258, 4096, K)],
            n.deflateInit = function (t, e) {
                return G(t, e, 8, 15, 8, 0)
            },
            n.deflateInit2 = G,
            n.deflateReset = q,
            n.deflateResetKeep = Y,
            n.deflateSetHeader = function (t, e) {
                return t && t.state ? 2 !== t.state.wrap ? y : (t.state.gzhead = e, 0) : y
            },
            n.deflate = function (t, e) {
                var n,
                u,
                p,
                m;
                if (!t || !t.state || 5 < e || e < 0)
                    return t ? N(t, y) : y;
                if (u = t.state, !t.output || !t.input && 0 !== t.avail_in || 666 === u.status && 4 !== e)
                    return N(t, 0 === t.avail_out ? -5 : y);
                if (u.strm = t, n = u.last_flush, u.last_flush = e, 42 === u.status)
                    if (2 === u.wrap)
                        t.adler = 0, T(u, 31), T(u, 139), T(u, 8), u.gzhead ? (T(u, (u.gzhead.text ? 1 : 0) + (u.gzhead.hcrc ? 2 : 0) + (u.gzhead.extra ? 4 : 0) + (u.gzhead.name ? 8 : 0) + (u.gzhead.comment ? 16 : 0)), T(u, 255 & u.gzhead.time), T(u, u.gzhead.time >> 8 & 255), T(u, u.gzhead.time >> 16 & 255), T(u, u.gzhead.time >> 24 & 255), T(u, 9 === u.level ? 2 : 2 <= u.strategy || u.level < 2 ? 4 : 0), T(u, 255 & u.gzhead.os), u.gzhead.extra && u.gzhead.extra.length && (T(u, 255 & u.gzhead.extra.length), T(u, u.gzhead.extra.length >> 8 & 255)), u.gzhead.hcrc && (t.adler = f(t.adler, u.pending_buf, u.pending, 0)), u.gzindex = 0, u.status = 69) : (T(u, 0), T(u, 0), T(u, 0), T(u, 0), T(u, 0), T(u, 9 === u.level ? 2 : 2 <= u.strategy || u.level < 2 ? 4 : 0), T(u, 3), u.status = A);
                    else {
                        var _ = 8 + (u.w_bits - 8 << 4) << 8;
                        _ |= (2 <= u.strategy || u.level < 2 ? 0 : u.level < 6 ? 1 : 6 === u.level ? 2 : 3) << 6,
                        0 !== u.strstart && (_ |= 32),
                        _ += 31 - _ % 31,
                        u.status = A,
                        F(u, _),
                        0 !== u.strstart && (F(u, t.adler >>> 16), F(u, 65535 & t.adler)),
                        t.adler = 1
                    }
                if (69 === u.status)
                    if (u.gzhead.extra) {
                        for (p = u.pending; u.gzindex < (65535 & u.gzhead.extra.length) && (u.pending !== u.pending_buf_size || (u.gzhead.hcrc && u.pending > p && (t.adler = f(t.adler, u.pending_buf, u.pending - p, p)), I(t), p = u.pending, u.pending !== u.pending_buf_size)); )
                            T(u, 255 & u.gzhead.extra[u.gzindex]), u.gzindex++;
                        u.gzhead.hcrc && u.pending > p && (t.adler = f(t.adler, u.pending_buf, u.pending - p, p)),
                        u.gzindex === u.gzhead.extra.length && (u.gzindex = 0, u.status = 73)
                    } else
                        u.status = 73;
                if (73 === u.status)
                    if (u.gzhead.name) {
                        p = u.pending;
                        do {
                            if (u.pending === u.pending_buf_size && (u.gzhead.hcrc && u.pending > p && (t.adler = f(t.adler, u.pending_buf, u.pending - p, p)), I(t), p = u.pending, u.pending === u.pending_buf_size)) {
                                m = 1;
                                break
                            }
                            T(u, m = u.gzindex < u.gzhead.name.length ? 255 & u.gzhead.name.charCodeAt(u.gzindex++) : 0)
                        } while (0 !== m);
                        u.gzhead.hcrc && u.pending > p && (t.adler = f(t.adler, u.pending_buf, u.pending - p, p)),
                        0 === m && (u.gzindex = 0, u.status = 91)
                    } else
                        u.status = 91;
                if (91 === u.status)
                    if (u.gzhead.comment) {
                        p = u.pending;
                        do {
                            if (u.pending === u.pending_buf_size && (u.gzhead.hcrc && u.pending > p && (t.adler = f(t.adler, u.pending_buf, u.pending - p, p)), I(t), p = u.pending, u.pending === u.pending_buf_size)) {
                                m = 1;
                                break
                            }
                            T(u, m = u.gzindex < u.gzhead.comment.length ? 255 & u.gzhead.comment.charCodeAt(u.gzindex++) : 0)
                        } while (0 !== m);
                        u.gzhead.hcrc && u.pending > p && (t.adler = f(t.adler, u.pending_buf, u.pending - p, p)),
                        0 === m && (u.status = 103)
                    } else
                        u.status = 103;
                if (103 === u.status && (u.gzhead.hcrc ? (u.pending + 2 > u.pending_buf_size && I(t), u.pending + 2 <= u.pending_buf_size && (T(u, 255 & t.adler), T(u, t.adler >> 8 & 255), t.adler = 0, u.status = A)) : u.status = A), 0 !== u.pending) {
                    if (I(t), 0 === t.avail_out)
                        return u.last_flush = -1, 0
                } else if (0 === t.avail_in && O(e) <= O(n) && 4 !== e)
                    return N(t, -5);
                if (666 === u.status && 0 !== t.avail_in)
                    return N(t, -5);
                if (0 !== t.avail_in || 0 !== u.lookahead || 0 !== e && 666 !== u.status) {
                    var v = 2 === u.strategy ? function (t, e) {
                        for (var n; ; ) {
                            if (0 === t.lookahead && (H(t), 0 === t.lookahead)) {
                                if (0 === e)
                                    return 1;
                                break
                            }
                            if (t.match_length = 0, n = g._tr_tally(t, 0, t.window[t.strstart]), t.lookahead--, t.strstart++, n && (U(t, !1), 0 === t.strm.avail_out))
                                return 1
                        }
                        return t.insert = 0,
                        4 === e ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4) : t.last_lit && (U(t, !1), 0 === t.strm.avail_out) ? 1 : 2
                    }
                    (u, e) : 3 === u.strategy ? function (t, e) {
                        for (var n, a, u, p, f = t.window; ; ) {
                            if (t.lookahead <= S) {
                                if (H(t), t.lookahead <= S && 0 === e)
                                    return 1;
                                if (0 === t.lookahead)
                                    break
                            }
                            if (t.match_length = 0, t.lookahead >= 3 && 0 < t.strstart && (a = f[u = t.strstart - 1]) === f[++u] && a === f[++u] && a === f[++u]) {
                                p = t.strstart + S;
                                do {}
                                while (a === f[++u] && a === f[++u] && a === f[++u] && a === f[++u] && a === f[++u] && a === f[++u] && a === f[++u] && a === f[++u] && u < p);
                                t.match_length = S - (p - u),
                                t.match_length > t.lookahead && (t.match_length = t.lookahead)
                            }
                            if (t.match_length >= 3 ? (n = g._tr_tally(t, 1, t.match_length - 3), t.lookahead -= t.match_length, t.strstart += t.match_length, t.match_length = 0) : (n = g._tr_tally(t, 0, t.window[t.strstart]), t.lookahead--, t.strstart++), n && (U(t, !1), 0 === t.strm.avail_out))
                                return 1
                        }
                        return t.insert = 0,
                        4 === e ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4) : t.last_lit && (U(t, !1), 0 === t.strm.avail_out) ? 1 : 2
                    }
                    (u, e) : a[u.level].func(u, e);
                    if (3 !== v && 4 !== v || (u.status = 666), 1 === v || 3 === v)
                        return 0 === t.avail_out && (u.last_flush = -1), 0;
                    if (2 === v && (1 === e ? g._tr_align(u) : 5 !== e && (g._tr_stored_block(u, 0, 0, !1), 3 === e && (D(u.head), 0 === u.lookahead && (u.strstart = 0, u.block_start = 0, u.insert = 0))), I(t), 0 === t.avail_out))
                        return u.last_flush = -1, 0
                }
                return 4 !== e ? 0 : u.wrap <= 0 ? 1 : (2 === u.wrap ? (T(u, 255 & t.adler), T(u, t.adler >> 8 & 255), T(u, t.adler >> 16 & 255), T(u, t.adler >> 24 & 255), T(u, 255 & t.total_in), T(u, t.total_in >> 8 & 255), T(u, t.total_in >> 16 & 255), T(u, t.total_in >> 24 & 255)) : (F(u, t.adler >>> 16), F(u, 65535 & t.adler)), I(t), 0 < u.wrap && (u.wrap = -u.wrap), 0 !== u.pending ? 0 : 1)
            },
            n.deflateEnd = function (t) {
                var e;
                return t && t.state ? 42 !== (e = t.state.status) && 69 !== e && 73 !== e && 91 !== e && 103 !== e && e !== A && 666 !== e ? N(t, y) : (t.state = null, e === A ? N(t, -3) : 0) : y
            },
            n.deflateSetDictionary = function (t, e) {
                var n,
                a,
                g,
                f,
                m,
                S,
                _,
                A,
                v = e.length;
                if (!t || !t.state)
                    return y;
                if (2 === (f = (n = t.state).wrap) || 1 === f && 42 !== n.status || n.lookahead)
                    return y;
                for (1 === f && (t.adler = p(t.adler, e, v, 0)), n.wrap = 0, v >= n.w_size && (0 === f && (D(n.head), n.strstart = 0, n.block_start = 0, n.insert = 0), A = new u.Buf8(n.w_size), u.arraySet(A, e, v - n.w_size, n.w_size, 0), e = A, v = n.w_size), m = t.avail_in, S = t.next_in, _ = t.input, t.avail_in = v, t.next_in = 0, t.input = e, H(n); n.lookahead >= 3; ) {
                    for (a = n.strstart, g = n.lookahead - 2; n.ins_h = (n.ins_h << n.hash_shift ^ n.window[a + 3 - 1]) & n.hash_mask, n.prev[a & n.w_mask] = n.head[n.ins_h], n.head[n.ins_h] = a, a++, --g; );
                    n.strstart = a,
                    n.lookahead = 2,
                    H(n)
                }
                return n.strstart += n.lookahead,
                n.block_start = n.strstart,
                n.insert = n.lookahead,
                n.lookahead = 0,
                n.match_length = n.prev_length = 2,
                n.match_available = 0,
                t.next_in = S,
                t.input = _,
                t.avail_in = m,
                n.wrap = f,
                0
            },
            n.deflateInfo = "pako deflate (from Nodeca project)"
        }, {
            "../utils/common": 3,
            "./adler32": 5,
            "./crc32": 7,
            "./messages": 13,
            "./trees": 14
        }
    ],
    9: [function (t, e, n) {
            "use strict";
            e.exports = function () {
                this.text = 0,
                this.time = 0,
                this.xflags = 0,
                this.os = 0,
                this.extra = null,
                this.extra_len = 0,
                this.name = "",
                this.comment = "",
                this.hcrc = 0,
                this.done = !1
            }
        }, {}
    ],
    10: [function (t, e, n) {
            "use strict";
            e.exports = function (t, e) {
                var n,
                a,
                u,
                g,
                p,
                f,
                m,
                y,
                S,
                _,
                A,
                v,
                w,
                E,
                x,
                C,
                b,
                R,
                k,
                B,
                V,
                z,
                J,
                $,
                Z;
                n = t.state,
                a = t.next_in,
                $ = t.input,
                u = a + (t.avail_in - 5),
                g = t.next_out,
                Z = t.output,
                p = g - (e - t.avail_out),
                f = g + (t.avail_out - 257),
                m = n.dmax,
                y = n.wsize,
                S = n.whave,
                _ = n.wnext,
                A = n.window,
                v = n.hold,
                w = n.bits,
                E = n.lencode,
                x = n.distcode,
                C = (1 << n.lenbits) - 1,
                b = (1 << n.distbits) - 1;
                t: do {
                    w < 15 && (v += $[a++] << w, w += 8, v += $[a++] << w, w += 8),
                    R = E[v & C];
                    e: for (; ; ) {
                        if (v >>>= k = R >>> 24, w -= k, 0 == (k = R >>> 16 & 255))
                            Z[g++] = 65535 & R;
                        else {
                            if (!(16 & k)) {
                                if (0 == (64 & k)) {
                                    R = E[(65535 & R) + (v & (1 << k) - 1)];
                                    continue e
                                }
                                if (32 & k) {
                                    n.mode = 12;
                                    break t
                                }
                                t.msg = "invalid literal/length code",
                                n.mode = 30;
                                break t
                            }
                            B = 65535 & R,
                            (k &= 15) && (w < k && (v += $[a++] << w, w += 8), B += v & (1 << k) - 1, v >>>= k, w -= k),
                            w < 15 && (v += $[a++] << w, w += 8, v += $[a++] << w, w += 8),
                            R = x[v & b];
                            i: for (; ; ) {
                                if (v >>>= k = R >>> 24, w -= k, !(16 & (k = R >>> 16 & 255))) {
                                    if (0 == (64 & k)) {
                                        R = x[(65535 & R) + (v & (1 << k) - 1)];
                                        continue i
                                    }
                                    t.msg = "invalid distance code",
                                    n.mode = 30;
                                    break t
                                }
                                if (V = 65535 & R, w < (k &= 15) && (v += $[a++] << w, (w += 8) < k && (v += $[a++] << w, w += 8)), m < (V += v & (1 << k) - 1)) {
                                    t.msg = "invalid distance too far back",
                                    n.mode = 30;
                                    break t
                                }
                                if (v >>>= k, w -= k, (k = g - p) < V) {
                                    if (S < (k = V - k) && n.sane) {
                                        t.msg = "invalid distance too far back",
                                        n.mode = 30;
                                        break t
                                    }
                                    if (J = A, (z = 0) === _) {
                                        if (z += y - k, k < B) {
                                            for (B -= k; Z[g++] = A[z++], --k; );
                                            z = g - V,
                                            J = Z
                                        }
                                    } else if (_ < k) {
                                        if (z += y + _ - k, (k -= _) < B) {
                                            for (B -= k; Z[g++] = A[z++], --k; );
                                            if (z = 0, _ < B) {
                                                for (B -= k = _; Z[g++] = A[z++], --k; );
                                                z = g - V,
                                                J = Z
                                            }
                                        }
                                    } else if (z += _ - k, k < B) {
                                        for (B -= k; Z[g++] = A[z++], --k; );
                                        z = g - V,
                                        J = Z
                                    }
                                    for (; 2 < B; )
                                        Z[g++] = J[z++], Z[g++] = J[z++], Z[g++] = J[z++], B -= 3;
                                    B && (Z[g++] = J[z++], 1 < B && (Z[g++] = J[z++]))
                                } else {
                                    for (z = g - V; Z[g++] = Z[z++], Z[g++] = Z[z++], Z[g++] = Z[z++], 2 < (B -= 3); );
                                    B && (Z[g++] = Z[z++], 1 < B && (Z[g++] = Z[z++]))
                                }
                                break
                            }
                        }
                        break
                    }
                } while (a < u && g < f);
                a -= B = w >> 3,
                v &= (1 << (w -= B << 3)) - 1,
                t.next_in = a,
                t.next_out = g,
                t.avail_in = a < u ? u - a + 5 : 5 - (a - u),
                t.avail_out = g < f ? f - g + 257 : 257 - (g - f),
                n.hold = v,
                n.bits = w
            }
        }, {}
    ],
    11: [function (t, e, n) {
            "use strict";
            var a = t("../utils/common"),
            u = t("./adler32"),
            g = t("./crc32"),
            p = t("./inffast"),
            f = t("./inftrees"),
            m = -2;
            function L(t) {
                return (t >>> 24 & 255) + (t >>> 8 & 65280) + ((65280 & t) << 8) + ((255 & t) << 24)
            }
            function r() {
                this.mode = 0,
                this.last = !1,
                this.wrap = 0,
                this.havedict = !1,
                this.flags = 0,
                this.dmax = 0,
                this.check = 0,
                this.total = 0,
                this.head = null,
                this.wbits = 0,
                this.wsize = 0,
                this.whave = 0,
                this.wnext = 0,
                this.window = null,
                this.hold = 0,
                this.bits = 0,
                this.length = 0,
                this.offset = 0,
                this.extra = 0,
                this.lencode = null,
                this.distcode = null,
                this.lenbits = 0,
                this.distbits = 0,
                this.ncode = 0,
                this.nlen = 0,
                this.ndist = 0,
                this.have = 0,
                this.next = null,
                this.lens = new a.Buf16(320),
                this.work = new a.Buf16(288),
                this.lendyn = null,
                this.distdyn = null,
                this.sane = 0,
                this.back = 0,
                this.was = 0
            }
            function s(t) {
                var e;
                return t && t.state ? (e = t.state, t.total_in = t.total_out = e.total = 0, t.msg = "", e.wrap && (t.adler = 1 & e.wrap), e.mode = 1, e.last = 0, e.havedict = 0, e.dmax = 32768, e.head = null, e.hold = 0, e.bits = 0, e.lencode = e.lendyn = new a.Buf32(852), e.distcode = e.distdyn = new a.Buf32(592), e.sane = 1, e.back = -1, 0) : m
            }
            function o(t) {
                var e;
                return t && t.state ? ((e = t.state).wsize = 0, e.whave = 0, e.wnext = 0, s(t)) : m
            }
            function l(t, e) {
                var n,
                a;
                return t && t.state ? (a = t.state, e < 0 ? (n = 0, e = -e) : (n = 1 + (e >> 4), e < 48 && (e &= 15)), e && (e < 8 || 15 < e) ? m : (null !== a.window && a.wbits !== e && (a.window = null), a.wrap = n, a.wbits = e, o(t))) : m
            }
            function h(t, e) {
                var n,
                a;
                return t ? (a = new r, (t.state = a).window = null, 0 !== (n = l(t, e)) && (t.state = null), n) : m
            }
            var y,
            S,
            _ = !0;
            function H(t) {
                if (_) {
                    var e;
                    for (y = new a.Buf32(512), S = new a.Buf32(32), e = 0; e < 144; )
                        t.lens[e++] = 8;
                    for (; e < 256; )
                        t.lens[e++] = 9;
                    for (; e < 280; )
                        t.lens[e++] = 7;
                    for (; e < 288; )
                        t.lens[e++] = 8;
                    for (f(1, t.lens, 0, 288, y, 0, t.work, {
                            bits: 9
                        }), e = 0; e < 32; )
                        t.lens[e++] = 5;
                    f(2, t.lens, 0, 32, S, 0, t.work, {
                        bits: 5
                    }),
                    _ = !1
                }
                t.lencode = y,
                t.lenbits = 9,
                t.distcode = S,
                t.distbits = 5
            }
            function j(t, e, n, u) {
                var g,
                p = t.state;
                return null === p.window && (p.wsize = 1 << p.wbits, p.wnext = 0, p.whave = 0, p.window = new a.Buf8(p.wsize)),
                u >= p.wsize ? (a.arraySet(p.window, e, n - p.wsize, p.wsize, 0), p.wnext = 0, p.whave = p.wsize) : (u < (g = p.wsize - p.wnext) && (g = u), a.arraySet(p.window, e, n - u, g, p.wnext), (u -= g) ? (a.arraySet(p.window, e, n - u, u, 0), p.wnext = u, p.whave = p.wsize) : (p.wnext += g, p.wnext === p.wsize && (p.wnext = 0), p.whave < p.wsize && (p.whave += g))),
                0
            }
            n.inflateReset = o,
            n.inflateReset2 = l,
            n.inflateResetKeep = s,
            n.inflateInit = function (t) {
                return h(t, 15)
            },
            n.inflateInit2 = h,
            n.inflate = function (t, e) {
                var n,
                y,
                S,
                _,
                A,
                v,
                w,
                E,
                x,
                C,
                b,
                R,
                k,
                B,
                V,
                z,
                J,
                $,
                Z,
                tt,
                et,
                it,
                st,
                nt,
                at = 0,
                ot = new a.Buf8(4),
                rt = [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15];
                if (!t || !t.state || !t.output || !t.input && 0 !== t.avail_in)
                    return m;
                12 === (n = t.state).mode && (n.mode = 13),
                A = t.next_out,
                S = t.output,
                w = t.avail_out,
                _ = t.next_in,
                y = t.input,
                v = t.avail_in,
                E = n.hold,
                x = n.bits,
                C = v,
                b = w,
                it = 0;
                t: for (; ; )
                    switch (n.mode) {
                    case 1:
                        if (0 === n.wrap) {
                            n.mode = 13;
                            break
                        }
                        for (; x < 16; ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        if (2 & n.wrap && 35615 === E) {
                            ot[n.check = 0] = 255 & E,
                            ot[1] = E >>> 8 & 255,
                            n.check = g(n.check, ot, 2, 0),
                            x = E = 0,
                            n.mode = 2;
                            break
                        }
                        if (n.flags = 0, n.head && (n.head.done = !1), !(1 & n.wrap) || (((255 & E) << 8) + (E >> 8)) % 31) {
                            t.msg = "incorrect header check",
                            n.mode = 30;
                            break
                        }
                        if (8 != (15 & E)) {
                            t.msg = "unknown compression method",
                            n.mode = 30;
                            break
                        }
                        if (x -= 4, et = 8 + (15 & (E >>>= 4)), 0 === n.wbits)
                            n.wbits = et;
                        else if (et > n.wbits) {
                            t.msg = "invalid window size",
                            n.mode = 30;
                            break
                        }
                        n.dmax = 1 << et,
                        t.adler = n.check = 1,
                        n.mode = 512 & E ? 10 : 12,
                        x = E = 0;
                        break;
                    case 2:
                        for (; x < 16; ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        if (n.flags = E, 8 != (255 & n.flags)) {
                            t.msg = "unknown compression method",
                            n.mode = 30;
                            break
                        }
                        if (57344 & n.flags) {
                            t.msg = "unknown header flags set",
                            n.mode = 30;
                            break
                        }
                        n.head && (n.head.text = E >> 8 & 1),
                        512 & n.flags && (ot[0] = 255 & E, ot[1] = E >>> 8 & 255, n.check = g(n.check, ot, 2, 0)),
                        x = E = 0,
                        n.mode = 3;
                    case 3:
                        for (; x < 32; ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        n.head && (n.head.time = E),
                        512 & n.flags && (ot[0] = 255 & E, ot[1] = E >>> 8 & 255, ot[2] = E >>> 16 & 255, ot[3] = E >>> 24 & 255, n.check = g(n.check, ot, 4, 0)),
                        x = E = 0,
                        n.mode = 4;
                    case 4:
                        for (; x < 16; ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        n.head && (n.head.xflags = 255 & E, n.head.os = E >> 8),
                        512 & n.flags && (ot[0] = 255 & E, ot[1] = E >>> 8 & 255, n.check = g(n.check, ot, 2, 0)),
                        x = E = 0,
                        n.mode = 5;
                    case 5:
                        if (1024 & n.flags) {
                            for (; x < 16; ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            n.length = E,
                            n.head && (n.head.extra_len = E),
                            512 & n.flags && (ot[0] = 255 & E, ot[1] = E >>> 8 & 255, n.check = g(n.check, ot, 2, 0)),
                            x = E = 0
                        } else
                            n.head && (n.head.extra = null);
                        n.mode = 6;
                    case 6:
                        if (1024 & n.flags && (v < (R = n.length) && (R = v), R && (n.head && (et = n.head.extra_len - n.length, n.head.extra || (n.head.extra = new Array(n.head.extra_len)), a.arraySet(n.head.extra, y, _, R, et)), 512 & n.flags && (n.check = g(n.check, y, R, _)), v -= R, _ += R, n.length -= R), n.length))
                            break t;
                        n.length = 0,
                        n.mode = 7;
                    case 7:
                        if (2048 & n.flags) {
                            if (0 === v)
                                break t;
                            for (R = 0; et = y[_ + R++], n.head && et && n.length < 65536 && (n.head.name += String.fromCharCode(et)), et && R < v; );
                            if (512 & n.flags && (n.check = g(n.check, y, R, _)), v -= R, _ += R, et)
                                break t
                        } else
                            n.head && (n.head.name = null);
                        n.length = 0,
                        n.mode = 8;
                    case 8:
                        if (4096 & n.flags) {
                            if (0 === v)
                                break t;
                            for (R = 0; et = y[_ + R++], n.head && et && n.length < 65536 && (n.head.comment += String.fromCharCode(et)), et && R < v; );
                            if (512 & n.flags && (n.check = g(n.check, y, R, _)), v -= R, _ += R, et)
                                break t
                        } else
                            n.head && (n.head.comment = null);
                        n.mode = 9;
                    case 9:
                        if (512 & n.flags) {
                            for (; x < 16; ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            if (E !== (65535 & n.check)) {
                                t.msg = "header crc mismatch",
                                n.mode = 30;
                                break
                            }
                            x = E = 0
                        }
                        n.head && (n.head.hcrc = n.flags >> 9 & 1, n.head.done = !0),
                        t.adler = n.check = 0,
                        n.mode = 12;
                        break;
                    case 10:
                        for (; x < 32; ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        t.adler = n.check = L(E),
                        x = E = 0,
                        n.mode = 11;
                    case 11:
                        if (0 === n.havedict)
                            return t.next_out = A, t.avail_out = w, t.next_in = _, t.avail_in = v, n.hold = E, n.bits = x, 2;
                        t.adler = n.check = 1,
                        n.mode = 12;
                    case 12:
                        if (5 === e || 6 === e)
                            break t;
                    case 13:
                        if (n.last) {
                            E >>>= 7 & x,
                            x -= 7 & x,
                            n.mode = 27;
                            break
                        }
                        for (; x < 3; ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        switch (n.last = 1 & E, x -= 1, 3 & (E >>>= 1)) {
                        case 0:
                            n.mode = 14;
                            break;
                        case 1:
                            if (H(n), n.mode = 20, 6 !== e)
                                break;
                            E >>>= 2,
                            x -= 2;
                            break t;
                        case 2:
                            n.mode = 17;
                            break;
                        case 3:
                            t.msg = "invalid block type",
                            n.mode = 30
                        }
                        E >>>= 2,
                        x -= 2;
                        break;
                    case 14:
                        for (E >>>= 7 & x, x -= 7 & x; x < 32; ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        if ((65535 & E) != (E >>> 16 ^ 65535)) {
                            t.msg = "invalid stored block lengths",
                            n.mode = 30;
                            break
                        }
                        if (n.length = 65535 & E, x = E = 0, n.mode = 15, 6 === e)
                            break t;
                    case 15:
                        n.mode = 16;
                    case 16:
                        if (R = n.length) {
                            if (v < R && (R = v), w < R && (R = w), 0 === R)
                                break t;
                            a.arraySet(S, y, _, R, A),
                            v -= R,
                            _ += R,
                            w -= R,
                            A += R,
                            n.length -= R;
                            break
                        }
                        n.mode = 12;
                        break;
                    case 17:
                        for (; x < 14; ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        if (n.nlen = 257 + (31 & E), E >>>= 5, x -= 5, n.ndist = 1 + (31 & E), E >>>= 5, x -= 5, n.ncode = 4 + (15 & E), E >>>= 4, x -= 4, 286 < n.nlen || 30 < n.ndist) {
                            t.msg = "too many length or distance symbols",
                            n.mode = 30;
                            break
                        }
                        n.have = 0,
                        n.mode = 18;
                    case 18:
                        for (; n.have < n.ncode; ) {
                            for (; x < 3; ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            n.lens[rt[n.have++]] = 7 & E,
                            E >>>= 3,
                            x -= 3
                        }
                        for (; n.have < 19; )
                            n.lens[rt[n.have++]] = 0;
                        if (n.lencode = n.lendyn, n.lenbits = 7, st = {
                                bits: n.lenbits
                            }, it = f(0, n.lens, 0, 19, n.lencode, 0, n.work, st), n.lenbits = st.bits, it) {
                            t.msg = "invalid code lengths set",
                            n.mode = 30;
                            break
                        }
                        n.have = 0,
                        n.mode = 19;
                    case 19:
                        for (; n.have < n.nlen + n.ndist; ) {
                            for (; z = (at = n.lencode[E & (1 << n.lenbits) - 1]) >>> 16 & 255, J = 65535 & at, !((V = at >>> 24) <= x); ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            if (J < 16)
                                E >>>= V, x -= V, n.lens[n.have++] = J;
                            else {
                                if (16 === J) {
                                    for (nt = V + 2; x < nt; ) {
                                        if (0 === v)
                                            break t;
                                        v--,
                                        E += y[_++] << x,
                                        x += 8
                                    }
                                    if (E >>>= V, x -= V, 0 === n.have) {
                                        t.msg = "invalid bit length repeat",
                                        n.mode = 30;
                                        break
                                    }
                                    et = n.lens[n.have - 1],
                                    R = 3 + (3 & E),
                                    E >>>= 2,
                                    x -= 2
                                } else if (17 === J) {
                                    for (nt = V + 3; x < nt; ) {
                                        if (0 === v)
                                            break t;
                                        v--,
                                        E += y[_++] << x,
                                        x += 8
                                    }
                                    x -= V,
                                    et = 0,
                                    R = 3 + (7 & (E >>>= V)),
                                    E >>>= 3,
                                    x -= 3
                                } else {
                                    for (nt = V + 7; x < nt; ) {
                                        if (0 === v)
                                            break t;
                                        v--,
                                        E += y[_++] << x,
                                        x += 8
                                    }
                                    x -= V,
                                    et = 0,
                                    R = 11 + (127 & (E >>>= V)),
                                    E >>>= 7,
                                    x -= 7
                                }
                                if (n.have + R > n.nlen + n.ndist) {
                                    t.msg = "invalid bit length repeat",
                                    n.mode = 30;
                                    break
                                }
                                for (; R--; )
                                    n.lens[n.have++] = et
                            }
                        }
                        if (30 === n.mode)
                            break;
                        if (0 === n.lens[256]) {
                            t.msg = "invalid code -- missing end-of-block",
                            n.mode = 30;
                            break
                        }
                        if (n.lenbits = 9, st = {
                                bits: n.lenbits
                            }, it = f(1, n.lens, 0, n.nlen, n.lencode, 0, n.work, st), n.lenbits = st.bits, it) {
                            t.msg = "invalid literal/lengths set",
                            n.mode = 30;
                            break
                        }
                        if (n.distbits = 6, n.distcode = n.distdyn, st = {
                                bits: n.distbits
                            }, it = f(2, n.lens, n.nlen, n.ndist, n.distcode, 0, n.work, st), n.distbits = st.bits, it) {
                            t.msg = "invalid distances set",
                            n.mode = 30;
                            break
                        }
                        if (n.mode = 20, 6 === e)
                            break t;
                    case 20:
                        n.mode = 21;
                    case 21:
                        if (6 <= v && 258 <= w) {
                            t.next_out = A,
                            t.avail_out = w,
                            t.next_in = _,
                            t.avail_in = v,
                            n.hold = E,
                            n.bits = x,
                            p(t, b),
                            A = t.next_out,
                            S = t.output,
                            w = t.avail_out,
                            _ = t.next_in,
                            y = t.input,
                            v = t.avail_in,
                            E = n.hold,
                            x = n.bits,
                            12 === n.mode && (n.back = -1);
                            break
                        }
                        for (n.back = 0; z = (at = n.lencode[E & (1 << n.lenbits) - 1]) >>> 16 & 255, J = 65535 & at, !((V = at >>> 24) <= x); ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        if (z && 0 == (240 & z)) {
                            for ($ = V, Z = z, tt = J; z = (at = n.lencode[tt + ((E & (1 << $ + Z) - 1) >> $)]) >>> 16 & 255, J = 65535 & at, !($ + (V = at >>> 24) <= x); ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            E >>>= $,
                            x -= $,
                            n.back += $
                        }
                        if (E >>>= V, x -= V, n.back += V, n.length = J, 0 === z) {
                            n.mode = 26;
                            break
                        }
                        if (32 & z) {
                            n.back = -1,
                            n.mode = 12;
                            break
                        }
                        if (64 & z) {
                            t.msg = "invalid literal/length code",
                            n.mode = 30;
                            break
                        }
                        n.extra = 15 & z,
                        n.mode = 22;
                    case 22:
                        if (n.extra) {
                            for (nt = n.extra; x < nt; ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            n.length += E & (1 << n.extra) - 1,
                            E >>>= n.extra,
                            x -= n.extra,
                            n.back += n.extra
                        }
                        n.was = n.length,
                        n.mode = 23;
                    case 23:
                        for (; z = (at = n.distcode[E & (1 << n.distbits) - 1]) >>> 16 & 255, J = 65535 & at, !((V = at >>> 24) <= x); ) {
                            if (0 === v)
                                break t;
                            v--,
                            E += y[_++] << x,
                            x += 8
                        }
                        if (0 == (240 & z)) {
                            for ($ = V, Z = z, tt = J; z = (at = n.distcode[tt + ((E & (1 << $ + Z) - 1) >> $)]) >>> 16 & 255, J = 65535 & at, !($ + (V = at >>> 24) <= x); ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            E >>>= $,
                            x -= $,
                            n.back += $
                        }
                        if (E >>>= V, x -= V, n.back += V, 64 & z) {
                            t.msg = "invalid distance code",
                            n.mode = 30;
                            break
                        }
                        n.offset = J,
                        n.extra = 15 & z,
                        n.mode = 24;
                    case 24:
                        if (n.extra) {
                            for (nt = n.extra; x < nt; ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            n.offset += E & (1 << n.extra) - 1,
                            E >>>= n.extra,
                            x -= n.extra,
                            n.back += n.extra
                        }
                        if (n.offset > n.dmax) {
                            t.msg = "invalid distance too far back",
                            n.mode = 30;
                            break
                        }
                        n.mode = 25;
                    case 25:
                        if (0 === w)
                            break t;
                        if (R = b - w, n.offset > R) {
                            if ((R = n.offset - R) > n.whave && n.sane) {
                                t.msg = "invalid distance too far back",
                                n.mode = 30;
                                break
                            }
                            k = R > n.wnext ? (R -= n.wnext, n.wsize - R) : n.wnext - R,
                            R > n.length && (R = n.length),
                            B = n.window
                        } else
                            B = S, k = A - n.offset, R = n.length;
                        for (w < R && (R = w), w -= R, n.length -= R; S[A++] = B[k++], --R; );
                        0 === n.length && (n.mode = 21);
                        break;
                    case 26:
                        if (0 === w)
                            break t;
                        S[A++] = n.length,
                        w--,
                        n.mode = 21;
                        break;
                    case 27:
                        if (n.wrap) {
                            for (; x < 32; ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E |= y[_++] << x,
                                x += 8
                            }
                            if (b -= w, t.total_out += b, n.total += b, b && (t.adler = n.check = n.flags ? g(n.check, S, b, A - b) : u(n.check, S, b, A - b)), b = w, (n.flags ? E : L(E)) !== n.check) {
                                t.msg = "incorrect data check",
                                n.mode = 30;
                                break
                            }
                            x = E = 0
                        }
                        n.mode = 28;
                    case 28:
                        if (n.wrap && n.flags) {
                            for (; x < 32; ) {
                                if (0 === v)
                                    break t;
                                v--,
                                E += y[_++] << x,
                                x += 8
                            }
                            if (E !== (4294967295 & n.total)) {
                                t.msg = "incorrect length check",
                                n.mode = 30;
                                break
                            }
                            x = E = 0
                        }
                        n.mode = 29;
                    case 29:
                        it = 1;
                        break t;
                    case 30:
                        it = -3;
                        break t;
                    case 31:
                        return -4;
                    case 32:
                    default:
                        return m
                    }
                return t.next_out = A,
                t.avail_out = w,
                t.next_in = _,
                t.avail_in = v,
                n.hold = E,
                n.bits = x,
                (n.wsize || b !== t.avail_out && n.mode < 30 && (n.mode < 27 || 4 !== e)) && j(t, t.output, t.next_out, b - t.avail_out) ? (n.mode = 31, -4) : (C -= t.avail_in, b -= t.avail_out, t.total_in += C, t.total_out += b, n.total += b, n.wrap && b && (t.adler = n.check = n.flags ? g(n.check, S, b, t.next_out - b) : u(n.check, S, b, t.next_out - b)), t.data_type = n.bits + (n.last ? 64 : 0) + (12 === n.mode ? 128 : 0) + (20 === n.mode || 15 === n.mode ? 256 : 0), (0 === C && 0 === b || 4 === e) && 0 === it && (it = -5), it)
            },
            n.inflateEnd = function (t) {
                if (!t || !t.state)
                    return m;
                var e = t.state;
                return e.window && (e.window = null),
                t.state = null,
                0
            },
            n.inflateGetHeader = function (t, e) {
                var n;
                return t && t.state ? 0 == (2 & (n = t.state).wrap) ? m : ((n.head = e).done = !1, 0) : m
            },
            n.inflateSetDictionary = function (t, e) {
                var n,
                a = e.length;
                return t && t.state ? 0 !== (n = t.state).wrap && 11 !== n.mode ? m : 11 === n.mode && u(1, e, a, 0) !== n.check ? -3 : j(t, e, a, a) ? (n.mode = 31, -4) : (n.havedict = 1, 0) : m
            },
            n.inflateInfo = "pako inflate (from Nodeca project)"
        }, {
            "../utils/common": 3,
            "./adler32": 5,
            "./crc32": 7,
            "./inffast": 10,
            "./inftrees": 12
        }
    ],
    12: [function (t, e, n) {
            "use strict";
            var a = t("../utils/common"),
            u = [3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31, 35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0],
            g = [16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18, 19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78],
            p = [1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193, 257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577, 0, 0],
            f = [16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22, 23, 23, 24, 24, 25, 25, 26, 26, 27, 27, 28, 28, 29, 29, 64, 64];
            e.exports = function (t, e, n, m, y, S, _, A) {
                var v,
                w,
                E,
                x,
                C,
                b,
                R,
                k,
                B,
                V = A.bits,
                z = 0,
                J = 0,
                $ = 0,
                Z = 0,
                tt = 0,
                et = 0,
                it = 0,
                st = 0,
                nt = 0,
                at = 0,
                ot = null,
                rt = 0,
                lt = new a.Buf16(16),
                ht = new a.Buf16(16),
                dt = null,
                ct = 0;
                for (z = 0; z <= 15; z++)
                    lt[z] = 0;
                for (J = 0; J < m; J++)
                    lt[e[n + J]]++;
                for (tt = V, Z = 15; 1 <= Z && 0 === lt[Z]; Z--);
                if (Z < tt && (tt = Z), 0 === Z)
                    return y[S++] = 20971520, y[S++] = 20971520, A.bits = 1, 0;
                for ($ = 1; $ < Z && 0 === lt[$]; $++);
                for (tt < $ && (tt = $), z = st = 1; z <= 15; z++)
                    if (st <<= 1, (st -= lt[z]) < 0)
                        return -1;
                if (0 < st && (0 === t || 1 !== Z))
                    return -1;
                for (ht[1] = 0, z = 1; z < 15; z++)
                    ht[z + 1] = ht[z] + lt[z];
                for (J = 0; J < m; J++)
                    0 !== e[n + J] && (_[ht[e[n + J]]++] = J);
                if (b = 0 === t ? (ot = dt = _, 19) : 1 === t ? (ot = u, rt -= 257, dt = g, ct -= 257, 256) : (ot = p, dt = f, -1), z = $, C = S, it = J = at = 0, E = -1, x = (nt = 1 << (et = tt)) - 1, 1 === t && 852 < nt || 2 === t && 592 < nt)
                    return 1;
                for (; ; ) {
                    for (R = z - it, B = _[J] < b ? (k = 0, _[J]) : _[J] > b ? (k = dt[ct + _[J]], ot[rt + _[J]]) : (k = 96, 0), v = 1 << z - it, $ = w = 1 << et; y[C + (at >> it) + (w -= v)] = R << 24 | k << 16 | B | 0, 0 !== w; );
                    for (v = 1 << z - 1; at & v; )
                        v >>= 1;
                    if (0 !== v ? (at &= v - 1, at += v) : at = 0, J++, 0 == --lt[z]) {
                        if (z === Z)
                            break;
                        z = e[n + _[J]]
                    }
                    if (tt < z && (at & x) !== E) {
                        for (0 === it && (it = tt), C += $, st = 1 << (et = z - it); et + it < Z && !((st -= lt[et + it]) <= 0); )
                            et++, st <<= 1;
                        if (nt += 1 << et, 1 === t && 852 < nt || 2 === t && 592 < nt)
                            return 1;
                        y[E = at & x] = tt << 24 | et << 16 | C - S | 0
                    }
                }
                return 0 !== at && (y[C + at] = z - it << 24 | 64 << 16 | 0),
                A.bits = tt,
                0
            }
        }, {
            "../utils/common": 3
        }
    ],
    13: [function (t, e, n) {
            "use strict";
            e.exports = {
                2: "need dictionary",
                1: "stream end",
                0: "",
                "-1": "file error",
                "-2": "stream error",
                "-3": "data error",
                "-4": "insufficient memory",
                "-5": "buffer error",
                "-6": "incompatible version"
            }
        }, {}
    ],
    14: [function (t, e, n) {
            "use strict";
            var a = t("../utils/common");
            function i(t) {
                for (var e = t.length; 0 <= --e; )
                    t[e] = 0
            }
            var u = 256,
            g = 286,
            p = 30,
            f = 15,
            m = [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0],
            y = [0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13],
            S = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 7],
            _ = [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15],
            A = new Array(576);
            i(A);
            var v = new Array(60);
            i(v);
            var w = new Array(512);
            i(w);
            var E = new Array(256);
            i(E);
            var x = new Array(29);
            i(x);
            var C,
            b,
            R,
            k = new Array(p);
            function I(t, e, n, a, u) {
                this.static_tree = t,
                this.extra_bits = e,
                this.extra_base = n,
                this.elems = a,
                this.max_length = u,
                this.has_stree = t && t.length
            }
            function r(t, e) {
                this.dyn_tree = t,
                this.max_code = 0,
                this.stat_desc = e
            }
            function U(t) {
                return t < 256 ? w[t] : w[256 + (t >>> 7)]
            }
            function T(t, e) {
                t.pending_buf[t.pending++] = 255 & e,
                t.pending_buf[t.pending++] = e >>> 8 & 255
            }
            function F(t, e, n) {
                t.bi_valid > 16 - n ? (t.bi_buf |= e << t.bi_valid & 65535, T(t, t.bi_buf), t.bi_buf = e >> 16 - t.bi_valid, t.bi_valid += n - 16) : (t.bi_buf |= e << t.bi_valid & 65535, t.bi_valid += n)
            }
            function L(t, e, n) {
                F(t, n[2 * e], n[2 * e + 1])
            }
            function H(t, e) {
                for (var n = 0; n |= 1 & t, t >>>= 1, n <<= 1, 0 < --e; );
                return n >>> 1
            }
            function j(t, e, n) {
                var a,
                u,
                g = new Array(16),
                p = 0;
                for (a = 1; a <= f; a++)
                    g[a] = p = p + n[a - 1] << 1;
                for (u = 0; u <= e; u++) {
                    var m = t[2 * u + 1];
                    0 !== m && (t[2 * u] = H(g[m]++, m))
                }
            }
            function K(t) {
                var e;
                for (e = 0; e < g; e++)
                    t.dyn_ltree[2 * e] = 0;
                for (e = 0; e < p; e++)
                    t.dyn_dtree[2 * e] = 0;
                for (e = 0; e < 19; e++)
                    t.bl_tree[2 * e] = 0;
                t.dyn_ltree[512] = 1,
                t.opt_len = t.static_len = 0,
                t.last_lit = t.matches = 0
            }
            function M(t) {
                8 < t.bi_valid ? T(t, t.bi_buf) : 0 < t.bi_valid && (t.pending_buf[t.pending++] = t.bi_buf),
                t.bi_buf = 0,
                t.bi_valid = 0
            }
            function P(t, e, n, a) {
                var u = 2 * e,
                g = 2 * n;
                return t[u] < t[g] || t[u] === t[g] && a[e] <= a[n]
            }
            function Y(t, e, n) {
                for (var a = t.heap[n], u = n << 1; u <= t.heap_len && (u < t.heap_len && P(e, t.heap[u + 1], t.heap[u], t.depth) && u++, !P(e, a, t.heap[u], t.depth)); )
                    t.heap[n] = t.heap[u], n = u, u <<= 1;
                t.heap[n] = a
            }
            function q(t, e, n) {
                var a,
                g,
                p,
                f,
                S = 0;
                if (0 !== t.last_lit)
                    for (; a = t.pending_buf[t.d_buf + 2 * S] << 8 | t.pending_buf[t.d_buf + 2 * S + 1], g = t.pending_buf[t.l_buf + S], S++, 0 === a ? L(t, g, e) : (L(t, (p = E[g]) + u + 1, e), 0 !== (f = m[p]) && F(t, g -= x[p], f), L(t, p = U(--a), n), 0 !== (f = y[p]) && F(t, a -= k[p], f)), S < t.last_lit; );
                L(t, 256, e)
            }
            function G(t, e) {
                var n,
                a,
                u,
                g = e.dyn_tree,
                p = e.stat_desc.static_tree,
                m = e.stat_desc.has_stree,
                y = e.stat_desc.elems,
                S = -1;
                for (t.heap_len = 0, t.heap_max = 573, n = 0; n < y; n++)
                    0 !== g[2 * n] ? (t.heap[++t.heap_len] = S = n, t.depth[n] = 0) : g[2 * n + 1] = 0;
                for (; t.heap_len < 2; )
                    g[2 * (u = t.heap[++t.heap_len] = S < 2 ? ++S : 0)] = 1, t.depth[u] = 0, t.opt_len--, m && (t.static_len -= p[2 * u + 1]);
                for (e.max_code = S, n = t.heap_len >> 1; 1 <= n; n--)
                    Y(t, g, n);
                for (u = y; n = t.heap[1], t.heap[1] = t.heap[t.heap_len--], Y(t, g, 1), a = t.heap[1], t.heap[--t.heap_max] = n, t.heap[--t.heap_max] = a, g[2 * u] = g[2 * n] + g[2 * a], t.depth[u] = (t.depth[n] >= t.depth[a] ? t.depth[n] : t.depth[a]) + 1, g[2 * n + 1] = g[2 * a + 1] = u, t.heap[1] = u++, Y(t, g, 1), 2 <= t.heap_len; );
                t.heap[--t.heap_max] = t.heap[1],
                function (t, e) {
                    var n,
                    a,
                    u,
                    g,
                    p,
                    m,
                    y = e.dyn_tree,
                    S = e.max_code,
                    _ = e.stat_desc.static_tree,
                    A = e.stat_desc.has_stree,
                    v = e.stat_desc.extra_bits,
                    w = e.stat_desc.extra_base,
                    E = e.stat_desc.max_length,
                    x = 0;
                    for (g = 0; g <= f; g++)
                        t.bl_count[g] = 0;
                    for (y[2 * t.heap[t.heap_max] + 1] = 0, n = t.heap_max + 1; n < 573; n++)
                        E < (g = y[2 * y[2 * (a = t.heap[n]) + 1] + 1] + 1) && (g = E, x++), y[2 * a + 1] = g, S < a || (t.bl_count[g]++, p = 0, w <= a && (p = v[a - w]), m = y[2 * a], t.opt_len += m * (g + p), A && (t.static_len += m * (_[2 * a + 1] + p)));
                    if (0 !== x) {
                        do {
                            for (g = E - 1; 0 === t.bl_count[g]; )
                                g--;
                            t.bl_count[g]--,
                            t.bl_count[g + 1] += 2,
                            t.bl_count[E]--,
                            x -= 2
                        } while (0 < x);
                        for (g = E; 0 !== g; g--)
                            for (a = t.bl_count[g]; 0 !== a; )
                                S < (u = t.heap[--n]) || (y[2 * u + 1] !== g && (t.opt_len += (g - y[2 * u + 1]) * y[2 * u], y[2 * u + 1] = g), a--)
                    }
                }
                (t, e),
                j(g, S, t.bl_count)
            }
            function X(t, e, n) {
                var a,
                u,
                g = -1,
                p = e[1],
                f = 0,
                m = 7,
                y = 4;
                for (0 === p && (m = 138, y = 3), e[2 * (n + 1) + 1] = 65535, a = 0; a <= n; a++)
                    u = p, p = e[2 * (a + 1) + 1], ++f < m && u === p || (f < y ? t.bl_tree[2 * u] += f : 0 !== u ? (u !== g && t.bl_tree[2 * u]++, t.bl_tree[32]++) : f <= 10 ? t.bl_tree[34]++ : t.bl_tree[36]++, g = u, y = (f = 0) === p ? (m = 138, 3) : u === p ? (m = 6, 3) : (m = 7, 4))
            }
            function W(t, e, n) {
                var a,
                u,
                g = -1,
                p = e[1],
                f = 0,
                m = 7,
                y = 4;
                for (0 === p && (m = 138, y = 3), a = 0; a <= n; a++)
                    if (u = p, p = e[2 * (a + 1) + 1], !(++f < m && u === p)) {
                        if (f < y)
                            for (; L(t, u, t.bl_tree), 0 != --f; );
                        else
                            0 !== u ? (u !== g && (L(t, u, t.bl_tree), f--), L(t, 16, t.bl_tree), F(t, f - 3, 2)) : f <= 10 ? (L(t, 17, t.bl_tree), F(t, f - 3, 3)) : (L(t, 18, t.bl_tree), F(t, f - 11, 7));
                        g = u,
                        y = (f = 0) === p ? (m = 138, 3) : u === p ? (m = 6, 3) : (m = 7, 4)
                    }
            }
            i(k);
            var B = !1;
            function Q(t, e, n, u) {
                var g,
                p,
                f;
                F(t, 0 + (u ? 1 : 0), 3),
                p = e,
                f = n,
                M(g = t),
                T(g, f),
                T(g, ~f),
                a.arraySet(g.pending_buf, g.window, p, f, g.pending),
                g.pending += f
            }
            n._tr_init = function (t) {
                B || (function () {
                    var t,
                    e,
                    n,
                    a,
                    u,
                    _ = new Array(16);
                    for (a = n = 0; a < 28; a++)
                        for (x[a] = n, t = 0; t < 1 << m[a]; t++)
                            E[n++] = a;
                    for (E[n - 1] = a, a = u = 0; a < 16; a++)
                        for (k[a] = u, t = 0; t < 1 << y[a]; t++)
                            w[u++] = a;
                    for (u >>= 7; a < p; a++)
                        for (k[a] = u << 7, t = 0; t < 1 << y[a] - 7; t++)
                            w[256 + u++] = a;
                    for (e = 0; e <= f; e++)
                        _[e] = 0;
                    for (t = 0; t <= 143; )
                        A[2 * t + 1] = 8, t++, _[8]++;
                    for (; t <= 255; )
                        A[2 * t + 1] = 9, t++, _[9]++;
                    for (; t <= 279; )
                        A[2 * t + 1] = 7, t++, _[7]++;
                    for (; t <= 287; )
                        A[2 * t + 1] = 8, t++, _[8]++;
                    for (j(A, 287, _), t = 0; t < p; t++)
                        v[2 * t + 1] = 5, v[2 * t] = H(t, 5);
                    C = new I(A, m, 257, g, f),
                    b = new I(v, y, 0, p, f),
                    R = new I(new Array(0), S, 0, 19, 7)
                }
                    (), B = !0),
                t.l_desc = new r(t.dyn_ltree, C),
                t.d_desc = new r(t.dyn_dtree, b),
                t.bl_desc = new r(t.bl_tree, R),
                t.bi_buf = 0,
                t.bi_valid = 0,
                K(t)
            },
            n._tr_stored_block = Q,
            n._tr_flush_block = function (t, e, n, a) {
                var g,
                p,
                f = 0;
                0 < t.level ? (2 === t.strm.data_type && (t.strm.data_type = function (t) {
                        var e,
                        n = 4093624447;
                        for (e = 0; e <= 31; e++, n >>>= 1)
                            if (1 & n && 0 !== t.dyn_ltree[2 * e])
                                return 0;
                        if (0 !== t.dyn_ltree[18] || 0 !== t.dyn_ltree[20] || 0 !== t.dyn_ltree[26])
                            return 1;
                        for (e = 32; e < u; e++)
                            if (0 !== t.dyn_ltree[2 * e])
                                return 1;
                        return 0
                    }
                        (t)), G(t, t.l_desc), G(t, t.d_desc), f = function (t) {
                    var e;
                    for (X(t, t.dyn_ltree, t.l_desc.max_code), X(t, t.dyn_dtree, t.d_desc.max_code), G(t, t.bl_desc), e = 18; 3 <= e && 0 === t.bl_tree[2 * _[e] + 1]; e--);
                    return t.opt_len += 3 * (e + 1) + 5 + 5 + 4,
                    e
                }
                    (t), g = t.opt_len + 3 + 7 >>> 3, (p = t.static_len + 3 + 7 >>> 3) <= g && (g = p)) : g = p = n + 5,
                n + 4 <= g && -1 !== e ? Q(t, e, n, a) : 4 === t.strategy || p === g ? (F(t, 2 + (a ? 1 : 0), 3), q(t, A, v)) : (F(t, 4 + (a ? 1 : 0), 3), function (t, e, n, a) {
                    var u;
                    for (F(t, e - 257, 5), F(t, n - 1, 5), F(t, a - 4, 4), u = 0; u < a; u++)
                        F(t, t.bl_tree[2 * _[u] + 1], 3);
                    W(t, t.dyn_ltree, e - 1),
                    W(t, t.dyn_dtree, n - 1)
                }
                    (t, t.l_desc.max_code + 1, t.d_desc.max_code + 1, f + 1), q(t, t.dyn_ltree, t.dyn_dtree)),
                K(t),
                a && M(t)
            },
            n._tr_tally = function (t, e, n) {
                return t.pending_buf[t.d_buf + 2 * t.last_lit] = e >>> 8 & 255,
                t.pending_buf[t.d_buf + 2 * t.last_lit + 1] = 255 & e,
                t.pending_buf[t.l_buf + t.last_lit] = 255 & n,
                t.last_lit++,
                0 === e ? t.dyn_ltree[2 * n]++ : (t.matches++, e--, t.dyn_ltree[2 * (E[n] + u + 1)]++, t.dyn_dtree[2 * U(e)]++),
                t.last_lit === t.lit_bufsize - 1
            },
            n._tr_align = function (t) {
                var e;
                F(t, 2, 3),
                L(t, 256, A),
                16 === (e = t).bi_valid ? (T(e, e.bi_buf), e.bi_buf = 0, e.bi_valid = 0) : 8 <= e.bi_valid && (e.pending_buf[e.pending++] = 255 & e.bi_buf, e.bi_buf >>= 8, e.bi_valid -= 8)
            }
        }, {
            "../utils/common": 3
        }
    ],
    15: [function (t, e, n) {
            "use strict";
            e.exports = function () {
                this.input = null,
                this.next_in = 0,
                this.avail_in = 0,
                this.total_in = 0,
                this.output = null,
                this.next_out = 0,
                this.avail_out = 0,
                this.total_out = 0,
                this.msg = "",
                this.state = null,
                this.data_type = 2,
                this.adler = 0
            }
        }, {}
    ],
    "/": [function (t, e, n) {
            "use strict";
            var a = {};
            (0, t("./lib/utils/common").assign)(a, t("./lib/deflate"), t("./lib/inflate"), t("./lib/zlib/constants")),
            e.exports = a
        }, {
            "./lib/deflate": 1,
            "./lib/inflate": 2,
            "./lib/utils/common": 3,
            "./lib/zlib/constants": 6
        }
    ]
}, {}, [])("/"), window.fx = function (t) {
    "use strict";
    var e = Laya.Vector2,
    n = Laya.Vector3,
    a = Laya.Vector4,
    u = Laya.Color,
    g = Laya.Dialog,
    p = Laya.EventDispatcher;
    const f = {
        E_APP_ON_PAUSE: "$ONPAUSE",
        E_APP_ON_RESUME: "$ONRESUME",
        E_PANEL_OPENCLOSE: "$PANEL_OPENCLOSE",
        E_SOUND_PLAY_OK: "$SOUND_PLAY_OK",
        E_UI_ADAPTED: "UI_ADAPTED",
        E_PROP_CHANGED: "$USER_PROP_CHANGED",
        E_PHYSICS_COLLISION: "PHYSICS_COLLISION_ENTER",
        E_PHYSICS_COLLISION_EXIT: "PHYSICS_COLLISION_EXIT",
        E_MATERIAL_LOADED: "MATERIAL_LOAD_COMPLETE",
        E_ANIM_STATE_CHENGED: "$ANIM_STATE_CHENGE",
        E_ANIM_EVENT: "$ANIM_EVENT_TRIGGER",
        E_SERVER_CFG_COMPLETE: "E_SERVER_CFG_COMPLETE"
    };
    var m;
    (m = t.BaseCode || (t.BaseCode = {}))[m.PANEL_OPEN = 0] = "PANEL_OPEN",
    m[m.PANEL_CLOSE = 1] = "PANEL_CLOSE",
    m[m.VIEW_OPEN = 2] = "VIEW_OPEN",
    m[m.VIEW_CLOSE = 3] = "VIEW_CLOSE",
    m[m.SCENE_CHANGE = 4] = "SCENE_CHANGE",
    m[m.SOUND_MUSIC_PLAY_OK = 5] = "SOUND_MUSIC_PLAY_OK",
    m[m.SOUND_FX_PLAY_OK = 6] = "SOUND_FX_PLAY_OK",
    m[m.HTTP_INTERFACE_UNDEFINED = 7] = "HTTP_INTERFACE_UNDEFINED",
    m[m.E_ANIM_START = 8] = "E_ANIM_START",
    m[m.E_ANIM_STOP = 9] = "E_ANIM_STOP",
    m[m.E_ANIM_ABORT = 10] = "E_ANIM_ABORT";
    class y {
        constructor(t, e, n, a) {
            this.lb = t,
            this.rb = e,
            this.lt = n,
            this.rt = a
        }
    }
    const S = window.Physics;
    class _ {}
    const A = {
        x: .3,
        y: .59,
        z: .11
    };
    class v {
        static isNumber(t) {
            return Number.isFinite(t)
        }
        static isStrNumber(t) {
            return Number.isFinite(+t)
        }
        static enableLog() {
            Laya.Log.enable();
            let t = console.log;
            console.log = function (e) {
                Laya.Log.print(e),
                t(e)
            }
        }
        static profile(t) {
            if (!t)
                throw Error("profile key is unexpected !!!");
            this.profileMap[t] = Laya.Browser.now()
        }
        static profileEnd(t, e = 0) {
            if (!t)
                throw Error("profile key is unexpected !!!");
            if (this.profileMap[t]) {
                let n = Laya.Browser.now() - this.profileMap[t];
                return delete this.profileMap[t],
                n > e && console.log("%c################ %s: %sms", "color:#00aa00", t, n),
                n
            }
            return 0
        }
        static isEmpty(t) {
            for (const e in t)
                return !1;
            return !0
        }
        static getGID() {
            return Laya.Utils.getGID()
        }
        static isOnMiniGame() {
            let t = Laya.ClassUtils.getRegClass("Sdk");
            return t.isOnToutiao() || t.isOnWeiXin() || t.isOnQQ() || t.isOnOppo() || t.isOnBaidu() || t.isOnVivo() || t.isOnTapTap() || t.isOnXiaoMi() || t.isOnHuaWei()
        }
        static isOnPC() {
            let t = Laya.Browser,
            e = t._window || window;
            return -1 != (t.userAgent || e.navigator.userAgent).indexOf("Windows")
        }
        static isOnNativeAndroid() {
            if (!window.conchConfig)
                return !1;
            return "Conch-android" == window.conchConfig.getOS()
        }
        static isOnNativeIos() {
            if (!window.conchConfig)
                return !1;
            return "Conch-ios" == window.conchConfig.getOS()
        }
        static isQMP() {
            if (void 0 !== this.sIsQMP)
                return this.sIsQMP;
            let t = !1,
            e = Laya.Browser.clientWidth,
            n = Laya.Browser.clientHeight;
            if (console.log("isQMP userAgent:", Laya.Browser.window.navigator.userAgent, e, n), Laya.Browser.onAndroid)
                t = Laya.stage.scaleMode == Laya.Stage.SCREEN_VERTICAL ? n / e > 2 : e / n > 2;
            else {
                let a = /iPhone/gi.test(Laya.Browser.window.navigator.userAgent) && 375 == Math.min(n, e) && 812 == Math.max(n, e),
                u = 414 == Math.min(n, e) && 896 == Math.max(n, e),
                g = Laya.MiniAdpter,
                p = Laya.BMiniAdapter;
                (Laya.Browser.onMiniGame && !Laya.Browser.onAndroid && -1 != g.systemInfo.model.indexOf("iPhone X") || Laya.Browser.onBDMiniGame && !Laya.Browser.onAndroid && -1 != p.systemInfo.model.indexOf("iPhone X") || a || u) && (t = !0)
            }
            return console.log("isQMP = ", t),
            this.sIsQMP = t,
            t
        }
        static isNotchScreenDevice() {
            if (void 0 !== this.sNotchScreen)
                return this.sNotchScreen;
            let t = Laya.ClassUtils.getRegClass("Sdk"),
            e = t.instance.getSystemInfo();
            if (e && e.model) {
                for (let t of this.NotchScreenCfg)
                    if (-1 != e.model.indexOf(t.model)) {
                        this.sNotchScreen = t;
                        break
                    }
                if (!this.sNotchScreen)
                    if (e.safeArea) {
                        if (Laya.stage.scaleMode == Laya.Stage.SCREEN_VERTICAL) {
                            let t = e.safeArea.top || 0;
                            if (t > 20) {
                                let n = Math.max(Laya.Browser.clientHeight - e.safeArea.bottom, 0);
                                this.sNotchScreen = {
                                    model: e.model,
                                    notchTop: t,
                                    notchBottom: n
                                }
                            }
                        } else {
                            let t = e.safeArea.left || 0;
                            if (t > 20) {
                                let n = Math.max(Laya.Browser.clientWidth - e.safeArea.right, 0);
                                this.sNotchScreen = {
                                    model: e.model,
                                    notchTop: t,
                                    notchBottom: n
                                }
                            }
                        }
                        this.sNotchScreen || (this.sNotchScreen = null)
                    } else {
                        if (Laya.stage.scaleMode == Laya.Stage.SCREEN_VERTICAL) {
                            let n = t.instance.getMenuButtonBoundingClientRect();
                            n && n.top > 20 ? this.sNotchScreen = {
                                model: e.model,
                                notchTop: n.top,
                                notchBottom: 20
                            }
                             : this.sNotchScreen = null
                        }
                        !this.sNotchScreen && this.isQMP() && (this.sNotchScreen = {
                                model: e.model,
                                notchTop: 30,
                                notchBottom: 20
                            })
                    }
            }
            return this.sNotchScreen ? console.log("isNotchScreenDevice: ", JSON.stringify(this.sNotchScreen)) : console.log("isNotchScreenDevice: false"),
            this.sNotchScreen
        }
        static randomArray(t) {
            if (!t || 0 == t.length)
                return;
            let e = t.length;
            for (; e; ) {
                let n = Math.floor(Math.random() * e--);
                [t[n], t[e]] = [t[e], t[n]]
            }
            return t
        }
        static randomArrayEx(t) {
            if (!t || 0 == t.length)
                return;
            let e = (t = t.slice()).length;
            for (; e; ) {
                let n = Math.floor(Math.random() * e--);
                [t[n], t[e]] = [t[e], t[n]]
            }
            return t
        }
        static diffArray(t, e, n = !1) {
            return t && 0 != t.length ? e && 0 != e.length ? n ? t.filter(t => !e.includes(t)).concat(e.filter(e => !t.includes(e))) : t.filter(t => !e.includes(t)) : t.concat([]) : e.concat([])
        }
        static randomInArray(t) {
            if (!t || 0 == t.length)
                return null;
            return t[Math.floor(Math.random() * t.length)]
        }
        static randomInArrayEx(t, e) {
            if (!t || 0 == t.length)
                return null;
            let n = this.copyArray(t);
            return this.randomArray(n),
            n.slice(0, Math.min(e, n.length))
        }
        static showTips(t, e = 2, n, a = "#ffffff") {
            let u = new Laya.Label;
            u.fontSize = 30,
            u.color = a,
            u.centerX = 0,
            u.centerY = 0,
            u.bold = !0,
            u.stroke = 5,
            u.strokeColor = "#000000",
            u.text = t;
            let g = u.width + 50,
            p = u.height + 30,
            f = new Laya.Box;
            f.zOrder = 1e4,
            f.width = g,
            f.height = p,
            n ? (f.x = n.x, f.y = n.y) : (f.x = Laya.stage.width - f.width >> 1, f.y = 300),
            Laya.stage.addChild(f);
            let m = new Laya.Image("res/img_tips.png");
            m.sizeGrid = "25,27,30,26",
            m.width = g,
            m.height = p,
            m.alpha = .5,
            f.addChild(m),
            f.addChild(u),
            Laya.Tween.from(f, {
                y: 400,
                alpha: 0
            }, 200, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(f, {
                        y: 200,
                        alpha: 0
                    }, 200, null, Laya.Handler.create(this, () => {
                            f.destroy()
                        }), 1e3 * e, !0, !0)
                }))
        }
        static adaptNode(t, e, n, a = !0, u) {
            let g = t.width,
            p = t.height;
            if (u) {
                let u = e / g,
                f = n / p,
                m = a ? Math.max(u, f) : Math.min(u, f);
                t.scaleX = t.scaleY = m
            } else {
                let u = g / p,
                f = u * n,
                m = e / u;
                a ? f * n > e * m ? (g = f, p = n) : (g = e, p = m) : f * n < e * m ? (g = f, p = n) : (g = e, p = m),
                t.width = g,
                t.height = p
            }
        }
        static getClassName(t) {
            return t.__proto__.constructor.name
        }
        static checkClick(t = 300) {
            let e = Laya.Browser.now();
            return e - this.lastClickTime <= t ? (this.lastClickTime = e, !0) : (this.lastClickTime = e, !1)
        }
        static getHexColorStringF(t, e, n) {
            return t = Math.floor(255 * t),
            e = Math.floor(255 * e),
            n = Math.floor(255 * n),
            this.getHexColorStringI(t, e, n)
        }
        static getHexColorStringI(t, e, n) {
            let a = (t << 16) + (e << 8) + n;
            return Laya.Utils.toHexColor(a)
        }
        static rgbToHsb(t, e, n) {
            let a,
            u,
            g;
            t /= 255,
            e /= 255,
            n /= 255;
            let p = Math.min(t, e, n),
            f = g = Math.max(t, e, n),
            m = f - p;
            if (f == p)
                a = 0;
            else {
                switch (f) {
                case t:
                    a = (e - n) / m + (e < n ? 6 : 0);
                    break;
                case e:
                    a = 2 + (n - t) / m;
                    break;
                case n:
                    a = 4 + (t - e) / m
                }
                a = Math.round(60 * a) - 180
            }
            return u = 0 == f ? 0 : 1 - p / f,
            u = Math.round(200 * u) - 100,
            g = Math.round(200 * g) - 100,
            [a, u, g]
        }
        static hsbToRgb(t, e, n) {
            let a = (e + 100) / 200,
            u = (n + 100) / 200,
            g = t + 180,
            p = 0,
            f = 0,
            m = 0,
            y = parseInt((g / 60 % 6).toString()),
            S = g / 60 - y,
            _ = u * (1 - a),
            A = u * (1 - S * a),
            v = u * (1 - (1 - S) * a);
            switch (y) {
            case 0:
                p = u,
                f = v,
                m = _;
                break;
            case 1:
                p = A,
                f = u,
                m = _;
                break;
            case 2:
                p = _,
                f = u,
                m = v;
                break;
            case 3:
                p = _,
                f = A,
                m = u;
                break;
            case 4:
                p = v,
                f = _,
                m = u;
                break;
            case 5:
                p = u,
                f = _,
                m = A
            }
            return p = parseInt((255 * p).toString()),
            f = parseInt((255 * f).toString()),
            m = parseInt((255 * m).toString()),
            [p, f, m]
        }
        static colorHexTo3I(t) {
            if ("#" != t.charAt(0))
                return new n;
            t = t.substr(1);
            let e = parseInt(t, 16);
            return new n((16711680 & e) >> 16, (65280 & e) >> 8, 255 & e)
        }
        static colorHexTo3F(t) {
            if ("#" != t.charAt(0))
                return new n;
            t = t.substr(1);
            let e = parseInt(t, 16);
            return new n(((16711680 & e) >> 16) / 255, ((65280 & e) >> 8) / 255, (255 & e) / 255)
        }
        static colorHexTo4I(t) {
            if ("#" != t.charAt(0))
                return new Laya.Vector4;
            t = t.substr(1);
            let e = parseInt(t, 16);
            return new Laya.Vector4((16711680 & e) >> 16, (65280 & e) >> 8, 255 & e, 255)
        }
        static colorHexTo4F(t) {
            if ("#" != t.charAt(0))
                return new Laya.Vector4;
            t = t.substr(1);
            let e = parseInt(t, 16);
            return new Laya.Vector4(((16711680 & e) >> 16) / 255, ((65280 & e) >> 8) / 255, (255 & e) / 255, 1)
        }
        static getRandomColor4F() {
            let t = this.getNumberRandom(0, 1),
            e = this.getNumberRandom(0, 1),
            n = this.getNumberRandom(0, 1);
            return new Laya.Vector4(t, e, n, 1)
        }
        static getRandomColor3F() {
            let t = this.getNumberRandom(0, 1),
            e = this.getNumberRandom(0, 1),
            a = this.getNumberRandom(0, 1);
            return new n(t, e, a)
        }
        static color3Fto3I(t) {
            return new n(255 * t.x, 255 * t.y, 255 * t.z)
        }
        static color3Ito3F(t) {
            return new n(t.x / 255, t.y / 255, t.z / 255)
        }
        static color3Fto4F(t) {
            return new Laya.Vector4(t.x, t.y, t.z, 1)
        }
        static color4Fto3F(t) {
            return new n(t.x, t.y, t.z)
        }
        static color4Fto3I(t) {
            return new n(255 * t.x, 255 * t.y, 255 * t.z)
        }
        static color3Ito4F(t) {
            return new Laya.Vector4(t.x / 255, t.y / 255, t.z / 255, 1)
        }
        static getColorLumin3F(t) {
            return n.dot(t, A)
        }
        static getColorLumin3I(t) {
            let e = this.color3Ito3F(t);
            return this.getColorLumin3F(e)
        }
        static setColorLumin3F(t, e) {
            let a = this.getColorLumin3F(t);
            return n.scale(t, e / a, t),
            n.Clamp(t, n.ZERO, n.ONE, t),
            t
        }
        static getColorLumin4F(t) {
            return n.dot(t, A)
        }
        static setColorLumin4F(t, e) {
            let n = this.color4Fto3F(t);
            return n = this.setColorLumin3F(n, e),
            t.setValue(n.x, n.y, n.z, t.w),
            t
        }
        static getRandomColorString() {
            let t = this.getIntRandom(0, 255),
            e = this.getIntRandom(0, 255),
            n = this.getIntRandom(0, 255);
            return this.getHexColorStringI(t, e, n)
        }
        static copyArray(t) {
            if (!t)
                return t;
            let e = new Array;
            return Laya.Utils.copyArray(e, t)
        }
        static cloneArray(t) {
            if (!t)
                return t;
            let e = new Array;
            for (let n = 0; n < t.length; n++) {
                let a = t[n];
                e[n] = a instanceof Array ? this.cloneArray(a) : a instanceof Object ? this.cloneDeep(a) : a
            }
            return e
        }
        static clone(t) {
            let e = {},
            n = Object.getOwnPropertyNames(t);
            for (let a of n)
                e[a] = t[a];
            return e
        }
        static cloneDeep(t) {
            if (!t)
                return;
            let e = {},
            n = Object.getOwnPropertyNames(t);
            for (let a of n) {
                let n = t[a];
                e[a] = n instanceof Array ? this.copyArray(n) : n instanceof Object ? this.cloneDeep(n) : n
            }
            return e
        }
        static getFileExt(t) {
            return Laya.Utils.getFileExtension(t)
        }
        static getGlobalBounds(t, e) {
            let n = t.getBounds();
            n = n.clone();
            let a = new Laya.Point(n.x, n.y);
            return a = t.parent.localToGlobal(a),
            e ? (a = e.globalToLocal(a), n.setTo(a.x, a.y, n.width, n.height)) : n.setTo(a.x, a.y, n.width, n.height),
            n
        }
        static getIntRandom(t, e) {
            return Math.floor(Math.random() * (e - t + 1) + t)
        }
        static getNumberRandom(t, e) {
            return Math.random() * (e - t) + t
        }
        static getNumberRandomEx(t, e) {
            return Math.randomEx() * (e - t) + t
        }
        static getSignRandom() {
            return 0 == this.getIntRandom(0, 1) ? -1 : 1
        }
        static formatNumber(t, e = 0) {
            if (this.isNumber(t)) {
                let n = t.toFixed(e);
                return n = n.split("").reverse().join("").replace(/(\d{3})/g, "$1,").replace(/\,$/, "").split("").reverse().join(""),
                n
            }
            return (t = 0).toFixed(e)
        }
        static checkPowerOf2(t) {
            return 0 == (t &= t - 1)
        }
        static getIndex2N(t) {
            if (1 == t)
                return 0;
            if (this.checkPowerOf2(t)) {
                let e = 1;
                for (; t; ) {
                    if (1 == t || 2 == t)
                        return e;
                    t % 2 == 0 && (t >>= 1, e += 1)
                }
            }
            return -1
        }
        static getIndexN(t, e) {
            let n = t;
            for (let a = 0; a < e; ++a)
                n *= t;
            return n
        }
        static showBorder(t, e = !0, n, a) {
            let u = t;
            if (!e)
                return void(u.__border && (Laya.timer.clearAll(u), u.__border.removeSelf(), u.__border = null));
            if (u.__border)
                return;
            let g = new Laya.Sprite;
            u.__border = g,
            Laya.stage.addChild(g),
            Laya.timer.loop(50, u, (function () {
                    let e = v.getGlobalBounds(t, a);
                    g.graphics.clear(),
                    n = n || "#ff0000",
                    g.graphics.drawRect(e.x, e.y, e.width, e.height, null, n, 2)
                })),
            t.once(Laya.Event.REMOVED, this, (function () {
                    this.showBorder(t, !1)
                }))
        }
        static showBounds(t) {
            let e = t;
            if (e.__linebound) {
                let n = this.get3dModelCenter(t);
                return void(e.__linebound.transform.position = n)
            }
            let n = this.get3dModelSize(t),
            a = new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(n.x, n.y, n.z)),
            u = this.linearModel(a),
            g = this.get3dModelCenter(t);
            u.transform.position = g,
            this.getDefault3dScene().addChild(u),
            e.__linebound = u
        }
        static showLocalBounds(t) {
            if (t.getChildByName("linebound"))
                return;
            let e = this.get3dLocalModelSize(t),
            a = new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(e.x, e.y, e.z)),
            u = this.linearModel(a);
            u.name = "linebound";
            let g = this.get3dModelCenter(t, !0),
            p = this.get3dModelAnchor(t, !0);
            n.subtract(g, p, g),
            u.transform.translate(g),
            t.addChild(u)
        }
        static get3dModelCenter(t, e = !1, a, u) {
            let g = this.get3dModelBounds(t, e, a, u),
            p = new n;
            return n.add(g.getMin(), g.getExtent(), p),
            p
        }
        static get3dModelAnchor(t, e = !1) {
            let a = new n,
            u = this.tempMatrix;
            return t.transform.localMatrix.invert(u),
            n.transformV3ToV3(t.transform.localPosition, u, a),
            e || n.transformV3ToV3(a, t.transform.worldMatrix, a),
            a
        }
        static linearModel(t, e = 50, a = Laya.Color.GREEN) {
            let u = new n,
            g = new n,
            p = new n,
            f = new Laya.PixelLineSprite3D(e);
            if (t instanceof Laya.MeshSprite3D) {
                let e = t,
                m = e.meshFilter.sharedMesh,
                y = m._vertexBuffer,
                S = y.getFloat32Data(),
                _ = m._indexBuffer.getData(),
                A = y.vertexDeclaration.vertexStride / 4,
                v = 0,
                w = 0;
                for (let t = 0; t < _.length; t += 3)
                    v = 0, w = 0, u.x = S[_[t + v] * A + w++], u.y = S[_[t + v] * A + w++], u.z = S[_[t + v] * A + w++], v++, w = 0, g.x = S[_[t + v] * A + w++], g.y = S[_[t + v] * A + w++], g.z = S[_[t + v] * A + w++], v++, w = 0, p.x = S[_[t + v] * A + w++], p.y = S[_[t + v] * A + w++], p.z = S[_[t + v] * A + w++], v++, n.transformCoordinate(u, e.transform.worldMatrix, u), n.transformCoordinate(g, e.transform.worldMatrix, g), n.transformCoordinate(p, e.transform.worldMatrix, p), f.addLine(u, g, a, a), f.addLine(g, p, a, a), f.addLine(p, u, a, a)
            }
            return f
        }
        static showRedDot(t, e) {
            let n,
            a;
            if (t instanceof Laya.Point || t instanceof Laya.Vector2 ? (n = Laya.stage, a = t) : (n = t, e ? a = new Laya.Point(e.x, e.y) : (a = new Laya.Point(n.x, n.y), a = n.fromParentPoint(a))), n.__reddot)
                return;
            let u = new Laya.Sprite;
            u.scale(1 / n.scaleX, 1 / n.scaleY),
            u.x = a.x,
            u.y = a.y,
            n.addChild(u),
            u.graphics.clear(),
            u.graphics.drawCircle(0, 0, 5, "#ff0000", "#ff0000", 2),
            n.__reddot = u,
            n.once(Laya.Event.REMOVED, this, (function () {
                    n.__reddot = void 0,
                    u.removeSelf()
                }))
        }
        static showRedDot3d(t, e = .1, n, u) {
            let g = n || this.getDefault3dScene(),
            p = g.getChildByName("__reddot");
            if (p)
                return void(u ? p.transform.localPosition = t : p.transform.position = t);
            let f = Laya.PrimitiveMesh.createSphere(e);
            p = new Laya.MeshSprite3D(f),
            p.name = "__reddot";
            let m = new Laya.UnlitMaterial;
            m.depthTest = Laya.RenderState.DEPTHTEST_ALWAYS,
            m.albedoColor = new a(1, 0, 0, 1),
            p.meshRenderer.material = m,
            g.addChild(p),
            u ? p.transform.localPosition = t : p.transform.position = t
        }
        static pathInfo(t) {
            let e = "",
            n = "",
            a = "",
            u = "",
            g = "",
            p = "",
            f = t;
            if (t) {
                f = t.replace("\\", "/");
                let m = t.match(/((^.+)\/)((\w+)(\.(\w+)))/i);
                m && m.length > 1 ? (e = m[1], n = m[2], a = m[3], u = m[4], g = m[5], p = m[6]) : u = t
            }
            return {
                dir: e,
                dirname: n,
                file: a,
                filename: u,
                ext: g,
                extname: p,
                full: f
            }
        }
        static createAnim(t, e) {
            let n = new Laya.Animation;
            return n.loadAnimation(t, Laya.Handler.create(this, (function () {
                        !n.destroyed && e && e.runWith(n)
                    }))),
            n
        }
        static playAnim(t, e, n, a, u) {
            t.play(n, a, u),
            e && (a ? t.on(Laya.Event.COMPLETE, e.caller, (function () {
                        e.run()
                    })) : t.once(Laya.Event.COMPLETE, e.caller, (function () {
                        e.run()
                    })))
        }
        static getAnimSize(t, e) {
            if (t.isPlaying) {
                let n = t.getSelfBounds();
                e.runWith(n)
            } else {
                t.play();
                let func = function () {
                    t.gotoAndStop(0);
                    let n = t.getSelfBounds();
                    e.runWith(n)
                };
                t.once(Laya.Event.REMOVED, this, () => {
                    Laya.timer.clear(this, func)
                }),
                Laya.timer.frameOnce(1, this, func)
            }
        }
        static createAni(t) {
            let e = new Laya.Animation;
            return t.parent.addChild(e),
            e.pos(t.pos.x, t.pos.y, !0),
            e.offAll(),
            e.on(Laya.Event.LABEL, t.lbCaller, t.lbCb),
            e.on(Laya.Event.COMPLETE, t.completeCaller, t.completeCb),
            e
        }
        static playAni(t, e, n, a, u, g, p, f) {
            t && t.loadAnimation(e, Laya.Handler.create(this, () => {
                    t.visible = !0,
                    t.play(a, u, n),
                    g && p && p.apply(g, f)
                }))
        }
        static recoverAni(t) {
            t && (t.offAll(), t.loop = !1, t.removeSelf())
        }
        static createParticle(t, e = !0) {
            let n,
            a = Laya.loader.getRes(t);
            return a ? n = new Laya.Particle2D(a) : (n = new Laya.Particle2D(null), n.load(t)),
            n.autoPlay = e,
            n
        }
        static getLength(t) {
            return Object.keys(t).length
        }
        static randomByRate(t) {
            return t > 1 && (t *= .01),
            Math.random() > 1 - t
        }
        static applyMixins(t, e, n) {
            t.prototype && e.forEach(e => {
                Object.getOwnPropertyNames(e.prototype).forEach(a => {
                    "constructor" != a && (t.prototype[a] = e.prototype[a], t._super = n)
                })
            })
        }
        static super(t) {
            let e = this.getModule(t);
            return e._super || e.__super || e.__proto__
        }
        static getModule(t) {
            return t.__proto__.constructor
        }
        static getNumberZeroAmount(t) {
            if (null == t || isNaN(t))
                return console.log("非法参数"), [0, 0];
            let e = 0;
            for (; ; ) {
                let n = t / 1e3;
                if (n < 1)
                    break;
                t = n,
                e += 1
            }
            return [t = 0 !== e ? Number(t.toFixed(2)) : Math.floor(t), 3 * e]
        }
        static getStringZeroAmount(t) {
            if (null == t || "string" != typeof t)
                return console.log("非法参数"), [0, 0];
            let e = t.indexOf("."),
            n = 0,
            a = 0,
            u = (t = t.slice(0, e)).length;
            a = Math.floor(u / 3),
            n = u % 3,
            0 == n && (n = 3, a -= 1);
            let g = Number(t.slice(n, n + 2));
            return g = Number(t.slice(n + 2, n + 3)) >= 5 ? g + 1 : g,
            [Number(t.slice(0, n) + "." + g), 3 * a]
        }
        static formatNumberWithUnits(t) {
            let [e, n] = v.getFormatNumberWithUnitsInfo(t);
            return e + n
        }
        static getFormatNumberWithUnitsInfo(t, e) {
            let [n, a] = [null, null];
            "number" == typeof t ? [n, a] = v.getNumberZeroAmount(t) : "string" == typeof t && ([n, a] = v.getStringZeroAmount(t));
            let u = "" + a,
            g = null;
            return g = null != e ? e[u] : v.numberUnit[u],
            null == g && (g = ""),
            [n, g]
        }
        static takeOneByWeight(t, e) {
            let n = [];
            if (e) {
                let a = t,
                u = e;
                if (a.length !== u.length)
                    return void console.log("对象数组和权重数组长度不匹配!!!");
                for (let t = 0; t < a.length; ++t) {
                    let e = a[t],
                    g = u[t];
                    n.push({
                        o: e,
                        weight: g
                    })
                }
            } else
                n = t;
            if (!n)
                return void console.log("带权数组为空!!!");
            let a = 0,
            u = [];
            for (let t = 0; t < n.length; ++t) {
                let e = n[t].weight;
                null != e && (a += e, u.push({
                        prob: a,
                        ele: n[t]
                    }))
            }
            let g = null,
            p = 0,
            f = v.getIntRandom(1, a);
            for (let t = 0; t < u.length; ++t)
                if (f <= u[t].prob) {
                    g = u[t].ele,
                    p = t;
                    break
                }
            return [p, g]
        }
        static takeSomeByWeight(t, e, n) {
            let a = [];
            if (n) {
                let t = e,
                u = n;
                if (t.length !== u.length)
                    return void console.log("对象数组和权重数组长度不匹配!!!");
                for (let e = 0; e < t.length; ++e) {
                    let n = t[e],
                    g = u[e];
                    a.push({
                        o: n,
                        weight: g
                    })
                }
            } else
                a = e;
            if (null == a)
                return void console.log("带权数组为空!!!");
            let u = [],
            g = a.slice();
            for (let e = 0; e < t; ++e) {
                let [t, e] = v.takeOneByWeight(g);
                g.splice(t, 1),
                u.push([t, e])
            }
            return u
        }
        static getUIFrameAnimation(t, e) {
            return t[e]
        }
        static getAnimationActionName(t) {
            return t._actionName
        }
        static getAnimationUrl(t) {
            return t._url
        }
        static timestampToTime(t, e) {
            e ? !e.separator && (e.separator = ["h ", "m ", "s"]) : e = {
                separator: ["h ", "m ", "s"],
                isAlign: !1
            };
            let n = t / 1e3,
            a = Math.floor(n / 3600),
            u = "";
            a >= 0 && (u = a < 10 && e.isAlign ? "0" + a + e.separator[0] : a + e.separator[0]);
            let g = Math.floor(n % 3600 / 60),
            p = "";
            g >= 0 && (p = g < 10 && e.isAlign ? "0" + g + e.separator[1] : g + e.separator[1]);
            let f = Math.floor(n % 60),
            m = "";
            return f >= 0 && (m = f < 10 && e.isAlign ? "0" + f + e.separator[2] : f + e.separator[2]),
            u + p + m
        }
        static timestampToMS(t, e) {
            e ? !e.separator && (e.separator = ["m ", "s"]) : e = {
                separator: ["m ", "s"],
                isAlign: !1
            };
            let n = t / 1e3,
            a = Math.floor(n % 3600 / 60),
            u = "";
            a >= 0 && (u = a < 10 && e.isAlign ? "0" + a + e.separator[0] : a + e.separator[0]);
            let g = Math.floor(n % 60),
            p = "";
            return g >= 0 && (p = g < 10 && e.isAlign ? "0" + g : g + "", e.separator[1] && (p += e.separator[1])),
            u + p
        }
        static timestampToHM(t, e) {
            e ? !e.separator && (e.separator = ["h ", "m"]) : e = {
                separator: ["h ", "m"],
                isAlign: !1
            };
            let n = t / 1e3,
            a = Math.floor(n / 3600),
            u = "";
            a >= 0 && (u = a < 10 && e.isAlign ? "0" + a + e.separator[0] : a + e.separator[0]);
            let g = Math.floor(n % 3600 / 60),
            p = "";
            return g >= 0 && (p = g < 10 && e.isAlign ? "0" + g + e.separator[1] : g + e.separator[1]),
            u + p
        }
        static countdown(t, e, n) {
            const clear = function () {
                e.clearTimer(e, tick)
            },
            tick = function () {
                t = Math.max(t - 1e3, 0),
                n.call(e, t),
                t <= 0 && (clear(), e.off(Laya.Event.REMOVED, this, clear))
            };
            e.once(Laya.Event.REMOVED, this, clear),
            e.timerLoop(1e3, e, tick)
        }
        static getDayInYear(t) {
            let e = t || new Date,
            n = new Date(e.getFullYear().toString()).getTime(),
            a = e.getTime();
            return Math.ceil((a - n) / 864e5)
        }
        static initRelativeDate(t) {
            v.relativeDate = t,
            v.localLaunchDate = new Date
        }
        static getDate() {
            return v.relativeDate || new Date
        }
        static getTime() {
            if (v.relativeDate) {
                let t = (new Date).getTime() - v.localLaunchDate.getTime();
                return v.relativeDate.getTime() + t
            }
            return (new Date).getTime()
        }
        static isToday(t) {
            let e;
            e = "string" == typeof t ? new Date(t) : t;
            let n = new Date;
            return e >= new Date(n.getFullYear(), n.getMonth(), n.getDate())
        }
        static assign(t, e, n = !0) {
            let a = n ? Object.keys(t) : Object.keys(e);
            return e instanceof Array && a.pop(),
            this.assignFrom(t, e, a)
        }
        static assignFrom(t, e, n) {
            let a = [];
            for (let u of n)
                null != e[u] && e[u] != t[u] && (t[u] = e[u], a.push(u));
            return a
        }
        static stringformat(t, e) {
            let n = e;
            if ("object" != typeof n) {
                n = {};
                for (let t in arguments)
                    "0" !== t && (n[Number(t) - 1] = arguments[t])
            }
            for (let e in n) {
                let g = n[e];
                a = e,
                u = g,
                t = t.replace(new RegExp("\\{" + a + "\\}", "gm"), u)
            }
            var a,
            u;
            return t
        }
        static binarySearch(t, e, n = 1) {
            let a = 0,
            u = t.length - 1;
            for (; a <= u; ) {
                let g = Math.floor((a + u) / 2),
                p = Math.min(g + n, u),
                f = e(t[g], t[p], g);
                if (0 == f)
                    return g;
                f > 0 ? a = g : u = g
            }
            return -1
        }
        static get3dModelSize(t, e, a) {
            let u = this.get3dModelBounds(t, !1, e, a),
            g = u.getMax(),
            p = u.getMin(),
            f = new n;
            return n.subtract(g, p, f),
            f
        }
        static get3dLocalModelSize(t, e, a) {
            let u = this.get3dModelBounds(t, !0, e, a),
            g = u.getMax(),
            p = u.getMin(),
            f = new n;
            return n.subtract(g, p, f),
            f
        }
        static get3dModelBounds(t, e, a, u) {
            let g = new n(1 / 0, 1 / 0, 1 / 0),
            p = new n(-1 / 0, -1 / 0, -1 / 0),
            f = new Laya.Bounds(g, p);
            if (e) {
                let e = t;
                e.meshFilter && (f = e.meshFilter.sharedMesh.bounds.clone(), g.from(f.getMin()), p.from(f.getMax()))
            } else {
                let e = this.getSpRenderer(t);
                e && (f = e.bounds.clone(), g.from(f.getMin()), p.from(f.getMax()))
            }
            if (t.numChildren > 0) {
                let m = t.getChildren(),
                _proc3dModel = t => {
                    let m = this.get3dModelBounds(t, e, a, u);
                    n.min(f.getMin(), m.getMin(), g),
                    n.max(f.getMax(), m.getMax(), p),
                    f.setMin(g),
                    f.setMax(p)
                };
                for (const t of m)
                    a ? -1 != a.indexOf(t.name) && _proc3dModel(t) : u && -1 != u.indexOf(t.name) || _proc3dModel(t)
            } else if (e && g.x != 1 / 0 && g.y != 1 / 0 && g.z != 1 / 0) {
                let e = f;
                e._tranform(t.transform.localMatrix, e)
            }
            return f
        }
        static create3dModel(t, e, n, a = !0) {
            t ? Laya.timer.callLater(this, () => {
                a && Laya.loader.setGroup(t, "3DRES_GROUP"),
                Laya.Sprite3D.load(t, Laya.Handler.create(this, (...t) => {
                        e && !e.destroyed && n.call(e, ...t)
                    }))
            }) : console.error("create3dModel lh url is illegal !!!")
        }
        static getDefault3dScene() {
            return Laya.stage._scene3Ds[0]
        }
        static getDefaultCamera() {
            let t = this.getDefault3dScene();
            if (t)
                return t._cameraPool[0]
        }
        static getAllCameras() {
            let t = this.getDefault3dScene();
            if (t)
                return t._cameraPool.concat()
        }
        static convert3dto2d(t, e) {
            let n = new a;
            return (e = e || this.getDefaultCamera()).viewport.project(t.transform.position, e.projectionViewMatrix, n),
            new Laya.Vector2(n.x / Laya.stage.clientScaleX, n.y / Laya.stage.clientScaleY)
        }
        static convert3dto2dP(t, e) {
            let n = new a;
            return (e = e || this.getDefaultCamera()).viewport.project(t, e.projectionViewMatrix, n),
            new Laya.Vector2(n.x / Laya.stage.clientScaleX, n.y / Laya.stage.clientScaleY)
        }
        static convert3dtoRect(t, e) {
            e = e || this.getDefaultCamera();
            let n = new a,
            u = new a,
            g = v.get3dModelBounds(t);
            e.viewport.project(g.getMin(), e.projectionViewMatrix, n),
            e.viewport.project(g.getMax(), e.projectionViewMatrix, u);
            let p = Math.min(n.x, u.x),
            f = Math.min(n.y, u.y),
            m = Math.max(n.x, u.x),
            y = Math.max(n.y, u.y);
            return new Laya.Rectangle(p / Laya.stage.clientScaleX, f / Laya.stage.clientScaleY, m - p, y - f)
        }
        static convert2dTo3dN(t, e, a) {
            a = a || this.getDefaultCamera(),
            t = t.clone();
            let u = new Laya.Point(t.x, t.y);
            Laya.stage.transform.transformPoint(u),
            t.setValue(u.x, u.y, 0),
            e = e.clone(),
            u.setTo(e.x, e.y),
            Laya.stage.transform.transformPoint(u),
            e.setValue(u.x, u.y, 0);
            let g = this.tempMatrix;
            return a.projectionViewMatrix.invert(g),
            a.viewport.unprojectFromMat(t, g, t),
            a.viewport.unprojectFromMat(e, g, e),
            n.subtract(e, t, t),
            n.normalize(t, t),
            t
        }
        static convert2dTo3dP(t, e, n = 0) {
            e = e || this.getDefaultCamera(),
            t = t.clone();
            let a = new Laya.Point(t.x, t.y);
            Laya.stage.transform.transformPoint(a),
            t.x = a.x,
            t.y = a.y,
            t.z = n;
            let u = this.tempMatrix;
            return e.projectionViewMatrix.invert(u),
            e.viewport.unprojectFromMat(t, u, t),
            t
        }
        static convert2dTo3dRay(t, e) {
            e = e || this.getDefaultCamera();
            let a = new Laya.Point(t.x, t.y);
            Laya.stage.transform.transformPoint(a);
            let u = new Laya.Ray(new n, new n);
            return e.viewportPointToRay(a, u),
            u
        }
        static rayCastInfo(t, e, a = -1, u = 2147483647) {
            e = e || this.getDefaultCamera();
            let g = new Laya.Point(t.x, t.y);
            Laya.stage.transform.transformPoint(g);
            let p = new Laya.Ray(new n, new n);
            e.viewportPointToRay(g, p);
            let f = e.scene,
            m = new Laya.HitResult;
            if (f.physicsSimulation.rayCast(p, m, u, void 0, a), m.succeeded)
                return {
                    target: m.collider.owner,
                    cp: m.point,
                    shapeName: m.collider.shapeName,
                    normal: m.normal,
                    distance: m.hitFraction
                }
        }
        static rayCastInfoAll(t, e, a = -1, u = 2147483647) {
            e = e || this.getDefaultCamera();
            let g = new Laya.Point(t.x, t.y);
            Laya.stage.transform.transformPoint(g);
            let p = new Laya.Ray(new n, new n);
            e.viewportPointToRay(g, p);
            let f = [];
            e.scene.physicsSimulation.rayCastAll(p, f, u, void 0, a);
            let m = [];
            for (const t of f) {
                let e = {
                    target: t.collider.owner,
                    cp: new n(t.point.x, t.point.y, t.point.z),
                    distance: t.hitFraction,
                    shapeName: t.collider.shapeName,
                    normal: new n(t.normal.x, t.normal.y, t.point.z)
                };
                m.push(e)
            }
            return m
        }
        static rayCastSprite3d(t, e, a, u = -1, g = 2147483647) {
            a = a || this.getDefaultCamera();
            let p = new Laya.Point(t, e);
            Laya.stage.transform.transformPoint(p);
            let f = new Laya.Ray(new n, new n);
            a.viewportPointToRay(p, f);
            let m = a.scene,
            y = new Laya.HitResult;
            if (m.physicsSimulation.rayCast(f, y, g, void 0, u), y.succeeded)
                return y.collider.owner
        }
        static rayCastByDir(t, e, a, u = 2147483647, g = -1) {
            let p,
            f,
            m = new Laya.HitResult,
            y = new Laya.Vector3;
            n.normalize(t, y),
            n.scale(y, u, y),
            n.add(e, y, y);
            let S = new Laya.Ray(e, t);
            if (a.physicsSimulation.rayCast(S, m, u, void 0, g), m.succeeded)
                return p = m.collider.owner, f = m.collider.shapeName, y = m.point, {
                    target: p,
                    cp: y,
                    shapeName: f,
                    normal: m.normal,
                    distance: m.hitFraction
                }
        }
        static rayCastByDirAll(t, e, a, u = 2147483647, g = -1) {
            let p = new Laya.Vector3;
            n.normalize(t, p),
            n.scale(p, u, p),
            n.add(e, p, p);
            let f = new Laya.Ray(e, t),
            m = [];
            a.physicsSimulation.rayCastAll(f, m, u, void 0, g);
            let y = [];
            for (const t of m) {
                let e = {
                    target: t.collider.owner,
                    cp: new n(t.point.x, t.point.y, t.point.z),
                    distance: t.hitFraction,
                    shapeName: t.collider.shapeName,
                    normal: new n(t.normal.x, t.normal.y, t.point.z)
                };
                y.push(e)
            }
            return y
        }
        static getOrthographicCamreaClickDir(t, e, a, u) {
            if (t && !t.destroyed && t.orthographic) {
                let g = new Laya.Vector3(e.x, e.y, a),
                p = new Laya.Vector3,
                f = new Laya.Vector3;
                return t.convertScreenCoordToOrthographicCoord(g, p),
                g.z = u,
                t.convertScreenCoordToOrthographicCoord(g, f),
                n.subtract(f, p, g),
                g.normalize(),
                g
            }
            return null
        }
        static add3dModelTo(t, e, n, a, u) {
            n = n || t.transform.position.clone(),
            u = u || t.transform.getWorldLossyScale().clone(),
            a = a || t.transform.rotation.clone(),
            e.addChild(t),
            t.transform.rotation = a,
            t.transform.position = n,
            t.transform.setWorldLossyScale(u)
        }
        static resetAnchor(t, e, n) {
            if (e < 0 || e > 1 || n < 0 || n > 1 || 0 == t.scaleX || 0 == t.scaleY)
                return;
            let a,
            u,
            g = t.anchorX,
            p = t.anchorY;
            if (e == g && n == p)
                return a = g * t.width, u = p * t.height, void t.pivot(a, u);
            !g && t.pivotX && !p && t.pivotY && (g = t.pivotX / t.width, p = t.pivotY / t.height),
            g = g || 0,
            p = p || 0,
            a = (e - g) * t.width,
            u = (n - p) * t.height,
            t.anchorX = e,
            t.anchorY = n,
            t.pivot(a, u),
            a *= t.scaleX,
            u *= t.scaleY,
            t.x += a,
            t.y += u
        }
        static resetPivot(t, e, n) {
            let a = t.pivotX,
            u = t.pivotY,
            g = e / t.width,
            p = n / t.height,
            f = a / t.width,
            m = u / t.height,
            y = (g - f) * t.width * t.scaleX,
            S = (p - m) * t.height * t.scaleY;
            t.pivot(e, n),
            t.x += y,
            t.y += S
        }
        static calcBezierPointEx(t, e) {
            t = Math.clamp(t, 0, 1);
            const factorial = function (t) {
                return t <= 1 ? 1 : t * factorial(t - 1)
            };
            let a = new n,
            u = e.length - 1;
            return e.forEach((e, n) => {
                n ? (a.x += factorial(u) / factorial(n) / factorial(u - n) * e.x * Math.pow(1 - t, u - n) * Math.pow(t, n), a.y += factorial(u) / factorial(n) / factorial(u - n) * e.y * Math.pow(1 - t, u - n) * Math.pow(t, n), a.z += factorial(u) / factorial(n) / factorial(u - n) * e.z * Math.pow(1 - t, u - n) * Math.pow(t, n)) : (a.x += e.x * Math.pow(1 - t, u - n) * Math.pow(t, n), a.y += e.y * Math.pow(1 - t, u - n) * Math.pow(t, n), a.z += e.z * Math.pow(1 - t, u - n) * Math.pow(t, n))
            }),
            a
        }
        static getBezierInfo(t, e, a) {
            let u = a || e + .1,
            g = {
                v: null,
                n: null,
                nL: null,
                nR: null,
                up: null
            },
            p = this.calcBezierPointEx(e, t),
            f = this.calcBezierPointEx(u, t),
            m = new n;
            n.subtract(f, p, m),
            null != a && (g.v = m.clone(), g.end = f);
            let y = new n;
            n.normalize(m, y);
            let S = new n;
            n.cross(n.Up, y, S),
            n.normalize(S, S),
            n.cross(y, S, m),
            n.normalize(m, m);
            let _ = m.clone();
            n.cross(_, y, S),
            n.normalize(S, S);
            let A = new n;
            return n.cross(y, _, A),
            n.normalize(A, A),
            g.n = y,
            g.nL = S,
            g.nR = A,
            g.up = _,
            g.start = p,
            g
        }
        static calcBezierPointEx_2D(t, e) {
            t = Math.clamp(t, 0, 1);
            const factorial = function (t) {
                return t <= 1 ? 1 : t * factorial(t - 1)
            };
            let n = new Laya.Point,
            a = e.length - 1;
            return e.forEach((e, u) => {
                u ? (n.x += factorial(a) / factorial(u) / factorial(a - u) * e.x * Math.pow(1 - t, a - u) * Math.pow(t, u), n.y += factorial(a) / factorial(u) / factorial(a - u) * e.y * Math.pow(1 - t, a - u) * Math.pow(t, u)) : (n.x += e.x * Math.pow(1 - t, a - u) * Math.pow(t, u), n.y += e.y * Math.pow(1 - t, a - u) * Math.pow(t, u))
            }),
            n
        }
        static generatePicture(t, e, n, a, u) {
            e = e || 0,
            n = n || 0,
            a = a || t.width,
            u = u || t.height;
            let g = t.drawToCanvas(a, u, e, n).toBase64("image/png", .9);
            g = g.substring(g.indexOf("base64") + 7);
            let p = Laya.MiniFileMgr.fileNativeDir + "/tmp_qrcode.png";
            Laya.MiniFileMgr.fs.writeFile({
                filePath: p,
                data: g,
                encoding: "base64",
                success: t => {
                    wx.saveImageToPhotosAlbum({
                        filePath: p,
                        success: t => {
                            v.showTips("成功")
                        },
                        fail: t => {
                            v.showTips("失败")
                        }
                    })
                },
                fail: t => {
                    v.showTips("保存失败")
                }
            })
        }
        static renderToTexture(t, e, n, a = 0, u = 0, g) {
            let p;
            if (e = e || t.width, n = n || t.height, Laya.stage.addChild(t), g) {
                p = g;
                let f = t.drawToTexture(e, n, a, u, g.bitmap);
                p.bitmap = f
            } else
                p = t.drawToTexture(e, n, a, u), Laya.CallLater.I.callLater(this, () => {
                    p.bitmap.lock = !1,
                    p.destroy()
                });
            return Laya.stage.removeChild(t),
            p
        }
        static recurisNode(t, e, n = !1) {
            if (n) {
                const anonymous = function (t) {
                    let n = t.getChildren();
                    for (const t of n) {
                        let e = anonymous(t);
                        if (!1 === e)
                            return e
                    }
                    return e(t)
                };
                anonymous(t)
            } else {
                let n = [];
                for (n.push(t); n.length > 0; ) {
                    let t = n.shift(),
                    a = e(t);
                    if (!1 === a)
                        return a;
                    if (-1 === a)
                        continue;
                    let u = t.getChildren();
                    for (const t of u)
                        n.push(t)
                }
            }
        }
        static render3dTo2dSprite(t, e, a, u = 0, g, p = 1) {
            if (!g) {
                let e = t.scene,
                a = this.getDefaultCamera();
                (g = a.clone()).nearPlane = .1,
                g.clearFlag = Laya.CameraClearFlags.DepthOnly,
                e.addChild(g);
                let u = t.transform.position,
                f = new n;
                n.subtract(a.transform.position, u, f),
                f.normalize(p),
                n.add(u, f, f),
                g.transform.position = f,
                g.transform.lookAt(u, n.Up, !1),
                g.removeAllLayers(),
                g.addLayer(1),
                this.recurisNode(t, t => t.layer = 1)
            }
            g.clearFlag == Laya.CameraClearFlags.DepthOnly ? g.renderTarget = new Laya.RenderTexture(e, a, Laya.RenderTextureFormat.R8G8B8A8) : g.renderTarget = new Laya.RenderTexture(e, a),
            g.renderingOrder = -1,
            g.enableHDR = !1;
            let f = new Laya.Texture(g.renderTarget),
            m = new Laya.Sprite;
            return m.texture = f,
            u > 0 && (m.cacheAs = "bitmap", t.timerOnce(u, t, () => {
                    g.active = !1,
                    t.active = !1
                })),
            m
        }
        static mixturePicture(t, e) {
            if (!window.wx)
                return;
            let n = t.width,
            a = t.height,
            u = t.drawToCanvas(n, a, 0, 0).toBase64("image/png", .9);
            u = u.substring(u.indexOf("base64") + 7);
            let g = Laya.MiniFileMgr.fileNativeDir + "/tmp_qrcode.png";
            Laya.MiniFileMgr.fs.writeFile({
                filePath: g,
                data: u,
                encoding: "base64",
                success: t => {
                    console.log(g),
                    e(g)
                },
                fail: t => {}
            })
        }
        static deltaDays(t, e) {
            return Math.floor((e - t + 1e6) / 864e5)
        }
        static equal(t, e, n = 1e-6) {
            return Math.abs(t - e) < n
        }
        static str2Boolean(t) {
            if ("string" != typeof t)
                return !1;
            let e = t.toLowerCase();
            return "false" !== e && "" !== e
        }
        static getFrameDelta() {
            return .001 * Laya.timer.delta
        }
        static createPrefabs(t, e = 1) {
            let n = [];
            if (!Laya.loader.getRes(t))
                throw `需要先加载${t}才可以创建`;
            for (let a = 0; a < e; ++a)
                n.push(this.createPrefab(t));
            return n
        }
        static createPrefab(t, e) {
            if (!e) {
                let e = new Laya.Prefab;
                return e.json = Laya.loader.getRes(t),
                e.create()
            }
            Laya.loader.load(t, Laya.Handler.create(this, () => {
                    if (e.caller.destroyed)
                        return;
                    let n = new Laya.Prefab;
                    n.json = Laya.loader.getRes(t);
                    let a = n.create();
                    e.runWith(a)
                }))
        }
        static getEnumArray(t) {
            let e = 0,
            n = [];
            for (; t[e]; )
                n.push(t[e]), e++;
            return n
        }
        static getEnumKeyMap(t) {
            let e = this.getEnumArray(t),
            n = {};
            for (const a of e)
                null != t[a] && (n[a] = a);
            return n
        }
        static getCurDayaStartTime() {
            return new Date((new Date).toLocaleDateString()).getTime()
        }
        static getCurEndStartTime() {
            return new Date((new Date).toLocaleDateString()).getTime() + 864e5 - 1
        }
        static MeterToKilometer(t) {
            if (t < 1e4)
                return t + "m";
            return (t / 1e3).toFixed(1) + "km"
        }
        static getYearWeek() {
            let t = new Date,
            e = t.getDay();
            0 == e && (e = 7);
            let n = new Date(t.getFullYear(), 0, 1),
            a = n.getDay();
            0 == a && (a = 7);
            let u = Math.round((t.getTime() - n.getTime() + 864e5 * (a - e)) / 864e5);
            return {
                year: t.getFullYear(),
                week: Math.ceil(u / 7) + 1
            }
        }
        static getCirclePoint(t, e, n) {
            let a = Math.rad(n),
            u = t.x + Math.sin(a) * e,
            g = t.y - Math.cos(a) * e;
            return new Laya.Vector2(u, g)
        }
        static compareVersion(t, e) {
            let n = t;
            if (!n || !n.split)
                return 0;
            let a = e;
            if (!a || !a.split)
                return 0;
            let u = n.split("."),
            g = a.split(".");
            const p = Math.max(u.length, g.length);
            for (; u.length < p; )
                u.push("0");
            for (; g.length < p; )
                g.push("0");
            for (let t = 0; t < p; t++) {
                const e = parseInt(u[t]),
                n = parseInt(g[t]);
                if (e > n)
                    return 1;
                if (e < n)
                    return -1
            }
            return 0
        }
        static compatibleVersion(t, e) {
            return v.compareVersion(t, e) >= 0
        }
        static warpObjectGetterSetter(t, e) {
            let n = t;
            if (!n.__getter_setter_warpped) {
                for (const a in t)
                    if (t.hasOwnProperty(a)) {
                        let u = n[a];
                        delete n[a],
                        u instanceof Object ? Object.defineProperty(t, a, {
                            get: function () {
                                return n["_" + a]
                            },
                            set: function (t) {
                                n["_" + a] = t,
                                e && e.call(n, a)
                            },
                            enumerable: !1,
                            configurable: !1
                        }) : Object.defineProperty(t, a, {
                            get: function () {
                                return n["_" + a]
                            },
                            set: function (t) {
                                t !== n["_" + a] && (n["_" + a] = t, e && e.call(n, a))
                            },
                            enumerable: !1,
                            configurable: !1
                        }),
                        n["_" + a] = u
                    }
                Object.defineProperty(t, "__getter_setter_warpped", {
                    value: e,
                    enumerable: !1,
                    configurable: !1
                })
            }
        }
        static warpObjectGetterSetterAppend(t, e, n) {
            n = n || t.__getter_setter_warpped;
            for (const a of e) {
                let e = self[a];
                delete self[a],
                e instanceof Object ? Object.defineProperty(t, a, {
                    get: function () {
                        return self["_" + a]
                    },
                    set: function (t) {
                        self["_" + a] = t,
                        n && n.call(self, a)
                    },
                    enumerable: !1,
                    configurable: !1
                }) : Object.defineProperty(t, a, {
                    get: function () {
                        return self["_" + a]
                    },
                    set: function (t) {
                        t !== self["_" + a] && (self["_" + a] = t, n && n.call(self, a))
                    },
                    enumerable: !1,
                    configurable: !1
                }),
                self["_" + a] = e
            }
        }
        static getUIComponetRoot(t) {
            if (!t.scene)
                return;
            let e = t.scene.getModuleUrlName();
            if (e)
                return e;
            let n = t.scene;
            for (; n.parent && (n = n.parent, !n.getModuleUrlName || (e = n.getModuleUrlName(), !e)); );
            return e
        }
        static getAnimatorCurPlayStateName(t) {
            if (t && t.getControllerLayer()) {
                let e = t.getControllerLayer().getCurrentPlayState().animatorState;
                if (e)
                    return e.name
            }
        }
        static playAnimator3d(t, e = null, n, a, u, g = 0) {
            if (t) {
                let p = t.getControllerLayer(g);
                if (!p)
                    return;
                let f = p.getAnimatorState(e);
                f && (void 0 !== a && (f.clip.islooping = a), void 0 !== n && (f.speed = n)),
                t.play(e, g, u)
            }
        }
        static playAnimator3dCross(t, e, n = null, a, u, g, p = 0) {
            if (t) {
                let f = t.getControllerLayer(p).getAnimatorState(n);
                f && (void 0 !== u && (f.clip.islooping = u), void 0 !== a && (f.speed = a)),
                t.crossFade(n, e, p, g)
            }
        }
        static asyncProcess(t, e, n = 30) {
            const clearFunc = () => {
                Laya.timer.clear(this, loopFunc),
                t.off(Laya.Event.REMOVED, this, clearFunc)
            },
            loopFunc = () => {
                Laya.stage.getTimeFromFrameStart() > n || e.run() && clearFunc()
            };
            Laya.timer.frameLoop(1, this, loopFunc),
            t.once(Laya.Event.REMOVED, this, clearFunc)
        }
        static vOnLeftRight(t, e) {
            let a = new n;
            return a.from(e),
            0 == t.x && 0 == e.x ? n.cross(n.UnitX, a, a) : (a.y = 0, n.cross(n.Up, a, a)),
            this.vOnForwardBehind(t, a)
        }
        static vOnForwardBehind(t, e) {
            return t = t.clone(),
            (e = e.clone()).y = t.y = 0,
            t.normalize(),
            e.normalize(),
            n.dot(t, e) >= 0
        }
        static getDotRadian(t, e) {
            if (t.isZero() || e.isZero())
                return 0;
            return Math.acos(Math.clamp(n.dot(t, e), -1, 1))
        }
        static getDotRadianEx(t, e) {
            if (t.isZero() || e.isZero())
                return 0;
            let a = Math.acos(Math.clamp(n.dot(t, e), -1, 1));
            return a > 0 && a < Math.PI && (a = this.vOnLeftRight(t, e) ? -1 * a : a),
            a
        }
        static getEulerRadian(t, e, a = "y") {
            if (t.isZero() || e.isZero())
                return 0;
            t = t.clone(),
            e = e.clone(),
            t[a] = e[a] = 0,
            t.normalize(),
            e.normalize();
            let u = Math.acos(Math.clamp(n.dot(t, e), -1, 1));
            return n.cross(t, e, t),
            u = t.y > 0 ? u : -u,
            u
        }
        static bindVarByName(t, e) {
            let n = e ? e.getChildren() : t.getChildren(),
            a = t;
            for (const e of n) {
                let n = e.name;
                if (n) {
                    if (a[n])
                        throw Error("bindVarByName failed, already exist !!!");
                    a[n] = e
                }
                e.numChildren > 0 && this.bindVarByName(t, e)
            }
        }
        static bindScriptVarByName(t, e) {
            let n = Object.getOwnPropertyNames(t);
            if (!n || !n.length)
                return;
            let a = void 0;
            e || (e = t.owner),
            a = e.getChildren();
            for (const e of a) {
                let a = e.name;
                a && -1 !== n.indexOf(a) && (t[a] = e),
                e.numChildren > 0 && this.bindScriptVarByName(t, e)
            }
        }
        static clearUIComponentPositionInfo(t) {
            t && (t.x = t.y = t.left = t.right = t.top = t.bottom = t.centerX = t.centerY = void 0)
        }
        static getHashCode(t, e) {
            e || (t = t.toLowerCase());
            let n,
            a,
            u = 1315423911;
            for (n = t.length - 1; n >= 0; n--)
                a = t.charCodeAt(n), u ^= (u << 5) + a + (u >> 2);
            return 2147483647 & u
        }
        static getSpMaterial(t, e) {
            let n,
            a = this.getSpRenderer(t);
            return a && (n = e ? a.sharedMaterial : a.material),
            n
        }
        static getSpMaterials(t, e) {
            let n,
            a = this.getSpRenderer(t);
            return a && (n = e ? a.sharedMaterials : a.materials),
            n
        }
        static getSpRenderer(t) {
            let e;
            return t instanceof Laya.SkinnedMeshSprite3D ? e = t.skinnedMeshRenderer : t instanceof Laya.SimpleSkinnedMeshSprite3D ? e = t.simpleSkinnedMeshRenderer : t instanceof Laya.MeshSprite3D && (e = t.meshRenderer),
            e
        }
        static createUUID() {
            let t = [];
            for (let e = 0; e < 36; e++)
                t[e] = "0123456789abcdef".substr(Math.floor(16 * Math.random()), 1);
            return t[14] = "4",
            t[19] = "0123456789abcdef".substr(3 & t[19] | 8, 1),
            t[8] = t[13] = t[18] = t[23] = "-",
            t.join("")
        }
        static createUUIDEx(t, e) {
            var n,
            a,
            u = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(""),
            g = [];
            if (e = e || u.length, t)
                for (n = 0; n < t; n++)
                    g[n] = u[0 | Math.random() * e];
            else
                for (g[8] = g[13] = g[18] = g[23] = "-", g[14] = "4", n = 0; n < 36; n++)
                    g[n] || (a = 0 | 16 * Math.random(), g[n] = u[19 == n ? 3 & a | 8 : a]);
            return g.join("")
        }
        static getDeltaRotQ(t, e, n) {
            if (t.equals(e))
                return n.from(Laya.Quaternion.DEFAULT);
            let a = new Laya.Quaternion;
            return t.invert(a),
            Laya.Quaternion.multiply(e, a, n),
            n
        }
        static randomPointInBounds(t, e = 1, n) {
            let a,
            u,
            g = 2 * e,
            p = !1;
            t.forEach(t => {
                if (a = t, !a.__grid) {
                    let e = t.getMin(),
                    n = t.getMax(),
                    u = Math.ceil((n.x - e.x) / g),
                    f = Math.ceil((n.z - e.z) / g);
                    a.__grid = [];
                    for (let t = 0; t < u; t++)
                        a.__grid[t] = new Array(f).fill(0);
                    p = !0
                }
            }),
            p && n && n.length > 0 && this.occupyPointsInBounds(t, n),
            fx.Utils.randomArray(t);
            let f = t.length;
            for (; f-- && (u = t[f], a = u, "full" == a.__grid); );
            -1 == f && console.warn("randomPointInBounds: 已占满！请缩小radius或者减少数量！");
            let m,
            y,
            S = u.getMin(),
            _ = u.getMax(),
            A = fx.Utils.getNumberRandomEx(S.y, _.y),
            v = a.__grid,
            w = v.length,
            E = v[0].length,
            x = w * E;
            for (; x--; ) {
                m = fx.Utils.getNumberRandomEx(S.x, _.x),
                y = fx.Utils.getNumberRandomEx(S.z, _.z);
                let t = _.x - S.x,
                n = _.z - S.z,
                a = Math.min(Math.floor((m - S.x) / t * w), w - 1),
                u = Math.min(Math.floor((y - S.z) / n * E), E - 1);
                if (0 == v[a][u]) {
                    v[a][u] = 1,
                    m = (a + 1) / w * t + S.x - e,
                    y = (u + 1) / E * n + S.z - e;
                    break
                }
            }
            return -1 == x && (a.__grid = "full"),
            new Laya.Vector3(m, A, y)
        }
        static occupyPointsInBounds(t, e) {
            let n,
            a,
            u = t.length;
            for (; u--; ) {
                n = t[u],
                a = n;
                let g = a.__grid;
                if (g && "full" != g) {
                    let t = n.getMin(),
                    a = n.getMax(),
                    u = g.length,
                    p = g[0].length;
                    e.foreachR((n, f) => {
                        if (n.x >= t.x && n.x <= a.x && n.z >= t.z && n.z <= a.z) {
                            let m = a.x - t.x,
                            y = a.z - t.z,
                            S = Math.min(Math.floor((n.x - t.x) / m * u), u - 1),
                            _ = Math.min(Math.floor((n.z - t.z) / y * p), p - 1);
                            0 == g[S][_] && (g[S][_] = 1, e.splice(f, 1))
                        }
                    })
                }
                if (0 == e.length)
                    break
            }
            -1 == u && console.warn("occupyPointsInBounds 失败！不在范围内? 已占满? 没有创建格子?")
        }
        static randomPointInCircle(t, e = 1, a) {
            let u,
            g = 2 * e,
            p = new n,
            f = !1;
            t.forEach(t => {
                if (!t.__grid) {
                    let a = 2 * t.radius,
                    u = Math.ceil(a / g),
                    m = new n;
                    m.x = t.center.x - t.radius,
                    m.y = t.center.y,
                    m.z = t.center.z - t.radius;
                    let y = new n;
                    y.x = t.center.x + t.radius,
                    y.y = t.center.y,
                    y.z = t.center.z + t.radius,
                    t.__min = m,
                    t.__max = y;
                    let S = t.__grid = [];
                    for (let g = 0; g < u; g++) {
                        S[g] = new Array(u);
                        for (let f = 0; f < u; f++) {
                            let y = (g + 1) / u * a + m.x - e,
                            _ = (f + 1) / u * a + m.z - e;
                            p.setValue(y, m.y, _);
                            let A = Math.pow(e + .01, 2);
                            n.distanceSquared(p, t.center) > A ? S[g][f] = 1 : S[g][f] = 0
                        }
                    }
                    f = !0
                }
            }),
            f && a && a.length > 0 && this.occupyPointsInCircles(t, a),
            fx.Utils.randomArray(t);
            let m = t.length;
            for (; m-- && (u = t[m], "full" == u.__grid); );
            -1 == m && console.warn("randomPointInCircles: 已占满！请缩小radius或者减少数量！");
            let y,
            S,
            _ = u.__min,
            A = u.__max,
            v = fx.Utils.getNumberRandomEx(_.y, A.y),
            w = u.__grid,
            E = w.length,
            x = w[0].length,
            C = E * x;
            for (; C--; ) {
                y = fx.Utils.getNumberRandomEx(_.x, A.x),
                S = fx.Utils.getNumberRandomEx(_.z, A.z);
                let t = A.x - _.x,
                n = Math.min(Math.floor((y - _.x) / t * E), E - 1),
                a = Math.min(Math.floor((S - _.z) / t * x), x - 1);
                if (0 == w[n][a]) {
                    w[n][a] = 1,
                    y = (n + 1) / E * t + _.x - e,
                    S = (a + 1) / x * t + _.z - e;
                    break
                }
            }
            return -1 == C && (u.__grid = "full"),
            new Laya.Vector3(y, v, S)
        }
        static occupyPointsInCircles(t, e) {
            let a,
            u = t.length;
            for (; u--; ) {
                a = t[u];
                let g = a.__grid;
                if (g && "full" != g) {
                    let t = a.__min,
                    u = a.__max,
                    p = g.length;
                    e.foreachR((f, m) => {
                        let y = a.radius * a.radius;
                        if (n.distanceSquared(f, a.center) <= y) {
                            let n = u.x - t.x,
                            a = Math.min(Math.floor((f.x - t.x) / n * p), p - 1),
                            y = Math.min(Math.floor((f.z - t.z) / n * p), p - 1);
                            0 == g[a][y] && (g[a][y] = 1, e.splice(m, 1))
                        }
                    })
                }
                if (0 == e.length)
                    break
            }
            -1 == u && console.warn("occupyPointsInCircles 失败！不在范围内? 已占满? 没有创建格子?")
        }
        static worldToLocal(t, e) {
            let a = new n(0, 0, 0);
            return e.transform.worldMatrix.invert(this.tempMatrix),
            n.transformCoordinate(t, this.tempMatrix, a),
            a
        }
        static remap(t, e, n, a, u) {
            return a + (t - e) / (n - e) * (u - a)
        }
    }
    v.NotchScreenCfg = [{
            model: "iPhone X",
            notchTop: 44,
            notchBottom: 30
        }, {
            model: "PAAM00",
            notchTop: 80,
            notchBottom: 10
        }, {
            model: "PAAT00",
            notchTop: 80,
            notchBottom: 10
        }, {
            model: "PACM00",
            notchTop: 80,
            notchBottom: 10
        }, {
            model: "PACT00",
            notchTop: 80,
            notchBottom: 10
        }, {
            model: "CPH1831",
            notchTop: 80,
            notchBottom: 10
        }, {
            model: "CPH1833",
            notchTop: 80,
            notchBottom: 10
        }, {
            model: "PBCM10",
            notchTop: 80,
            notchBottom: 10
        }, {
            model: "V1732A",
            notchTop: 36,
            notchBottom: 10
        }
    ],
    v.profileMap = {},
    v.lastClickTime = 0,
    v.numberUnit = {
        3: "K",
        6: "M",
        9: "B",
        12: "T",
        15: "aa",
        18: "bb",
        21: "cc",
        24: "dd",
        27: "ee",
        30: "ff",
        33: "gg",
        36: "hh",
        39: "ii",
        42: "jj",
        45: "kk",
        48: "ll",
        51: "mm",
        54: "nn",
        57: "oo",
        60: "pp",
        63: "qq",
        66: "rr",
        69: "ss",
        72: "tt",
        75: "uu",
        78: "vv",
        81: "ww",
        84: "xx",
        87: "yy",
        90: "zz",
        93: "Aa",
        96: "Bb",
        99: "Cc",
        102: "Dd",
        105: "Ee",
        108: "Ff",
        111: "Gg",
        114: "Hh",
        117: "Ii",
        120: "Jj",
        123: "Kk",
        126: "Ll",
        129: "Mm",
        132: "Nn",
        135: "Oo",
        138: "Pp",
        141: "Qq",
        144: "Rr",
        147: "Ss",
        150: "Tt",
        153: "Uu",
        156: "Vv",
        159: "Ww",
        162: "Xx",
        165: "Yy",
        168: "Zz",
        171: "AA",
        174: "BB",
        177: "CC",
        180: "DD",
        183: "EE",
        186: "FF",
        189: "GG",
        192: "HH",
        195: "II",
        198: "JJ",
        201: "KK",
        204: "LL",
        207: "MM",
        210: "NN",
        213: "OO",
        216: "PP",
        219: "QQ",
        222: "RR",
        225: "SS",
        228: "TT",
        231: "UU",
        234: "VV",
        237: "WW",
        240: "XX",
        243: "YY",
        246: "ZZ"
    },
    v.relativeDate = void 0,
    v.localLaunchDate = void 0,
    v.tempMatrix = new Laya.Matrix4x4;
    class w {
        constructor(t, e) {
            this.parallelCount = 0,
            this.actions = t || [],
            this.isRepeat = e,
            this.pActionIdx = 0
        }
        get actions() {
            return this._actions
        }
        set actions(t) {
            this._actions = t
        }
        get isRepeat() {
            return this._isRepeat
        }
        set isRepeat(t) {
            this._isRepeat = t
        }
        get pActionIdx() {
            return this._pActionIdx
        }
        set pActionIdx(t) {
            this._pActionIdx = t
        }
        run(t) {
            if (!this.actions || 0 === this.actions.length)
                return;
            if (this.pActionIdx >= this.actions.length) {
                if (!this.isRepeat)
                    return void(this._curTween = null);
                this.pActionIdx = 0
            }
            let e = this.actions[this.pActionIdx];
            if (t) {
                if (t.destroyed)
                    return void(this._curTween = null);
                e.target = t
            }
            let n = !0;
            if (e.parallels && e.parallels.length > 0) {
                this._recoverProps = {},
                n = !1,
                this.curParallels = e.parallels.concat(e);
                for (const t of e.parallels)
                    t.target = e.target, this._run(t, !1)
            }
            this._run(e, n)
        }
        _run(t, e = !0) {
            if (t && t.t && t.target && t.props && v.isNumber(t.duration)) {
                if (!t.props.isRecover && e && (this._recoverProps = {}), t.recoverKeys)
                    for (const e of t.recoverKeys)
                        this.addRecover(e, t.target[e]);
                let n = this;
                if ("delay" == t.t)
                    Laya.timer.once(t.duration, this, (function (...t) {
                            let [e] = t,
                            a = n.curParallels;
                            a && a.length > 0 ? (a.splice(a.indexOf(e), 1), 0 == a.length && n.runNext(e)) : n.runNext(e)
                        }), [t]);
                else if ("to" === t.t) {
                    let e = t.props;
                    "function" == typeof e && (e = e(t.target)),
                    this._curTween = Laya.Tween.to(t.target, e, t.duration, t.ease, Laya.Handler.create(this, (function (...t) {
                                    let [e] = t,
                                    a = n.curParallels;
                                    a && a.length > 0 ? (a.splice(a.indexOf(e), 1), 0 == a.length && n.runNext(e)) : n.runNext(e)
                                }), [t]), t.delay)
                } else if ("from" === t.t) {
                    let e = t.props;
                    "function" == typeof e && (e = e(t.target)),
                    this._curTween = Laya.Tween.from(t.target, e, t.duration, t.ease, Laya.Handler.create(this, (function (...t) {
                                    let [e] = t,
                                    a = n.curParallels;
                                    a && a.length > 0 ? (a.splice(a.indexOf(e), 1), 0 == a.length && n.runNext(e)) : n.runNext(e)
                                }), [t]), t.delay)
                } else if (t.props.exec) {
                    t.props.exec.runWith(t.target);
                    let e = n.curParallels;
                    e && e.length > 0 ? (e.splice(e.indexOf(t), 1), 0 == e.length && n.runNext(t)) : this.runNext(t)
                }
            } else {
                let e = this.curParallels;
                e && e.length > 0 && (e.splice(e.indexOf(t), 1), 0 == e.length && this.runNext(t))
            }
        }
        runNext(t) {
            t && t.complete && t.complete.call(t.complete, t.completeCaller, t.completeArgs),
            this.pActionIdx = this.pActionIdx + 1;
            let e = t && t.target;
            this.run(e)
        }
        getCurTween() {
            return this._curTween
        }
        addRecover(t, e) {
            this._recoverProps[t] || (this._recoverProps[t] = e)
        }
        pushAction(t) {
            if (this.parallelCount > 0) {
                this.parallelCount--;
                let e = this.actions[this.actions.length - 1];
                e && e.parallels ? e.parallels.push(t) : (t.parallels = [], this.actions.push(t))
            } else
                this.actions.push(t)
        }
        parallel(t) {
            return this.parallelCount = t,
            this
        }
        delay(t) {
            let e = {
                t: "delay",
                target: null,
                props: {},
                duration: t
            };
            return this.pushAction(e),
            this
        }
        hide() {
            let t = {
                t: "exec",
                target: null,
                props: {
                    exec: null
                },
                duration: 0,
                recoverKeys: ["visible"]
            };
            return t.props.exec = Laya.Handler.create(this, (function (t) {
                        t.visible = !1
                    })),
            this.pushAction(t),
            this
        }
        show() {
            let t = {
                t: "exec",
                target: null,
                props: {
                    exec: null
                },
                duration: 0,
                recoverKeys: ["visible"]
            };
            return t.props.exec = Laya.Handler.create(this, (function (t) {
                        t.visible = !0
                    })),
            this.pushAction(t),
            this
        }
        recover() {
            let t = {
                t: "exec",
                target: null,
                props: {
                    exec: null,
                    isRecover: !0
                },
                duration: 0
            };
            return t.props.exec = Laya.Handler.create(this, (function (t) {
                        for (var e in this._recoverProps)
                            this._recoverProps.hasOwnProperty(e) && (t[e] = this._recoverProps[e]);
                        this._recoverProps = {}
                    })),
            this.pushAction(t),
            this
        }
        removeNode(t) {
            let e = {
                t: "exec",
                target: null,
                props: {
                    exec: null
                },
                duration: 0
            };
            return e.props.exec = Laya.Handler.create(this, (function (e) {
                        t ? e.destroy() : e.removeSelf()
                    })),
            this.pushAction(e),
            this
        }
        scaleIn(t, e) {
            let n = {
                t: "from",
                target: null,
                props: {
                    scaleX: t,
                    scaleY: t
                },
                duration: e,
                recoverKeys: ["scaleX", "scaleY"]
            };
            return this.pushAction(n),
            this
        }
        scaleOut(t, e) {
            let n = {
                t: "to",
                target: null,
                props: {
                    scaleX: t,
                    scaleY: t
                },
                duration: e,
                recoverKeys: ["scaleX", "scaleY"]
            };
            return this.pushAction(n),
            this
        }
        up(t, e, n) {
            let a = {
                t: "to",
                target: null,
                props: function (e) {
                    return {
                        y: e.y - t
                    }
                },
                duration: e,
                recoverKeys: ["y"],
                ease: n
            };
            return this.pushAction(a),
            this
        }
        down(t, e, n) {
            let a = {
                t: "to",
                target: null,
                props: function (e) {
                    return {
                        y: e.y + t
                    }
                },
                duration: e,
                recoverKeys: ["y"],
                ease: n
            };
            return this.pushAction(a),
            this
        }
        fadeIn(t, e) {
            let n = {
                t: "to",
                target: null,
                props: function (t) {
                    return t.alpha = 0, {
                        alpha: 1
                    }
                },
                duration: t,
                recoverKeys: ["alpha"],
                ease: e
            };
            return this.pushAction(n),
            this
        }
        fadeOut(t, e) {
            let n = {
                t: "to",
                target: null,
                props: {
                    alpha: 0
                },
                duration: t,
                recoverKeys: ["alpha"],
                ease: e
            };
            return this.pushAction(n),
            this
        }
        pos(t, e, n, a) {
            let u = {
                t: "to",
                target: null,
                props: function (n) {
                    return n.centerX = n.centerY = void 0,
                    n.left = n.right = n.top = n.bottom = void 0, {
                        x: t,
                        y: e
                    }
                },
                duration: n,
                recoverKeys: ["x", "y", "centerX", "centerY", "left", "right", "top", "bottom"],
                ease: a
            };
            return 0 == n && (u.t = "exec", u.recoverKeys = null, u.ease = null, u.props = {}, u.props.exec = Laya.Handler.create(this, n => {
                    n.centerX = n.centerY = void 0,
                    n.left = n.right = n.top = n.bottom = void 0,
                    n.pos(t, e)
                })),
            this.pushAction(u),
            this
        }
        move(t, e, n, a) {
            let u = {
                t: "to",
                target: null,
                props: function (n) {
                    return n.centerX = n.centerY = void 0,
                    n.left = n.right = n.top = n.bottom = void 0, {
                        x: n.x + t,
                        y: n.y + e
                    }
                },
                duration: n,
                recoverKeys: ["x", "y", "centerX", "centerY", "left", "right", "top", "bottom"],
                ease: a
            };
            return this.pushAction(u),
            this
        }
        rotate(t, e, n) {
            let a = {
                t: "to",
                target: null,
                props: {
                    rotation: t
                },
                duration: e,
                recoverKeys: ["rotation"],
                ease: n
            };
            return this.pushAction(a),
            this
        }
        exec(t) {
            let e = {
                t: "exec",
                target: null,
                props: {
                    exec: t
                },
                duration: 0
            };
            return this.pushAction(e),
            this
        }
        circle(t, e, n, a) {
            let u = {
                t: "to",
                target: null,
                props: function (t) {
                    let a = t.globalToLocal(e, !0);
                    return v.resetPivot(t, a.x, a.y), {
                        rotation: n
                    }
                },
                duration: t,
                recoverKeys: ["rotation", "pivotX", "pivotY"],
                ease: a
            };
            return this.pushAction(u),
            this
        }
    }
    class E extends p {
        constructor() {
            super(),
            this.m_listenerMap = {}
        }
        static get instance() {
            return this._instance || (this._instance = new E),
            this._instance
        }
        find(t, e, n) {
            for (let a = 0; a < n.length; a++) {
                let u = n[a];
                if (t == u.type && e == u.cb)
                    return a
            }
            return -1
        }
        findAll(t, e) {
            let n = [];
            for (let a = 0; a < e.length; a++) {
                t == e[a].type && n.push(a)
            }
            return n
        }
        on(t, e, n, a) {
            let u = super.on(t, e, n, a);
            e.$_GID || (e.$_GID = Laya.Utils.getGID());
            let g = this.m_listenerMap[e.$_GID];
            return g ? -1 == this.find(t, n, g) ? g.push({
                type: t,
                cb: n
            }) : console.log(!1, t + " listener already added!!!") : (g = new Array, g.push({
                    type: t,
                    cb: n
                }), this.m_listenerMap[e.$_GID] = g),
            u
        }
        once(t, e, n, a) {
            let u = super.once(t, e, n, a);
            e.$_GID || (e.$_GID = Laya.Utils.getGID());
            let g = this.m_listenerMap[e.$_GID];
            return g ? -1 == this.find(t, n, g) ? g.push({
                type: t,
                cb: n
            }) : console.log(!1, t + " listener already added!!!") : (g = new Array, g.push({
                    type: t,
                    cb: n
                }), this.m_listenerMap[e.$_GID] = g),
            u
        }
        off(t, e, n, a) {
            if (e.$_GID) {
                let a = this.m_listenerMap[e.$_GID];
                if (a) {
                    let e = this.find(t, n, a);
                    -1 != e && a.splice(e, 1)
                }
            }
            return super.off(t, e, n, a)
        }
        offAllCaller(t) {
            let e = t.$_GID;
            if (e) {
                let n = this.m_listenerMap[e];
                if (n) {
                    for (let e of n)
                        super.off(e.type, t, e.cb);
                    delete this.m_listenerMap[e]
                }
            }
            return super.offAllCaller(t)
        }
        offAll(t) {
            if (t)
                for (let e in this.m_listenerMap) {
                    let n = this.m_listenerMap[e],
                    a = this.findAll(t, n);
                    for (let t of a)
                        n.splice(t, 1)
                }
            else
                this.m_listenerMap = {};
            return super.offAll(t)
        }
        event(t, e) {
            return super.event(t, e)
        }
    }
    class x extends Laya.EventDispatcher {
        constructor() {
            super()
        }
        static superFunc(t, e) {
            if (t instanceof x)
                return Laya.EventDispatcher.prototype[e].bind(t);
            return v.super(t).prototype[e].bind(t)
        }
        hasListener(t) {
            return "$" == t.charAt(0) ? E.instance.hasListener(t) : x.superFunc(this, "hasListener")(t)
        }
        event(t, e) {
            return "$" == t.charAt(0) ? E.instance.event(t, e) : x.superFunc(this, "event")(t, e)
        }
        on(t, e, n, a) {
            return "$" == t.charAt(0) ? E.instance.on(t, e, n, a) : x.superFunc(this, "on")(t, e, n, a)
        }
        once(t, e, n, a) {
            return "$" == t.charAt(0) ? E.instance.once(t, e, n, a) : x.superFunc(this, "once")(t, e, n, a)
        }
        off(t, e, n, a) {
            return "$" == t.charAt(0) ? E.instance.off(t, e, n, a) : x.superFunc(this, "off")(t, e, n, a)
        }
        offAllCaller(t) {
            return E.instance.offAllCaller(t),
            x.superFunc(this, "offAllCaller")(t)
        }
        offAll(t) {
            return t ? "$" == t.charAt(0) ? E.instance.offAll(t) : x.superFunc(this, "offAll")(t) : this.offAllCaller(this)
        }
    }
    class C extends x {
        constructor() {
            super(),
            this._initialized = !1
        }
        init(...t) {
            0 == this._initialized && this.onInitOnce.apply(this, t),
            this.onInit(...t),
            this._initialized = !0
        }
        get initialized() {
            return this._initialized
        }
        onInit(...t) {}
        onInitOnce(...t) {}
    }
    class b {
        constructor() {
            this.mData = {}
        }
        static get instance() {
            return this._instance || (this._instance = new b),
            this._instance
        }
        load(t) {
            Laya.loader.load("json/list.txt", new Laya.Handler(this, (function (...e) {
                        if (e.pop()) {
                            var n = Laya.loader.getRes("json/list.txt").replace(/\r\n/g, "\n").split("\n");
                            n.pop();
                            var a = [];
                            n.forEach(t => {
                                var e = t.substr(t.indexOf("json"));
                                -1 == t.indexOf(".txt") && a.push(e.replace("\\", "/"))
                            }),
                            Laya.loader.load(a, new Laya.Handler(this, (function (...e) {
                                        e.pop() && (e.forEach(t => {
                                                let e = v.pathInfo(t).filename;
                                                this.mData[e] = Laya.loader.getRes(t)
                                            }), t.run())
                                    }), a))
                        } else
                            t.run()
                    })))
        }
        get(t, e, n) {
            return null == this.mData[t] ? null : null == e && null == n ? this.mData[t] : null == this.mData[t][e] ? null : null == n ? this.mData[t][e] : this.mData[t][e][n]
        }
        getConstant(t) {
            return this.get("constant", t)
        }
        getStr(t) {
            return this.get("lang_ch", t)
        }
        loadJson(t, e) {
            t && Laya.loader.load(t, Laya.Handler.create(this, n => {
                    this.mData[t] = n,
                    e && e.runWith(n)
                }))
        }
    }
    class R extends Laya.Scene {
        constructor() {
            super(),
            this.once(Laya.Event.ADDED, this, this.addToStage),
            this.once(Laya.Event.REMOVED, this, this.removeFromStage),
            this.views = []
        }
        get curView() {
            return this._curView
        }
        set curView(t) {
            this._curView = t
        }
        removeView(t) {
            if (t)
                if (this._curView == t) {
                    if (this.views.length > 1)
                        throw Error("please use SceneManager.popView instead !!!");
                    this.views.clear(),
                    this._curView = null
                } else {
                    let e = this.views.indexOf(t);
                    -1 != e && this.views.splice(e, 1)
                }
        }
        pushView(t) {
            if (t) {
                -1 == this.views.indexOf(t) && (this.views.push(t), this.addChild(t), t.on(Laya.Event.REMOVED, this, this.removeView, [t]))
            }
            if (this.views.length > 1) {
                this.lastView = this.views[this.views.length - 2]
            } else {
                this.lastView = null
            }
        }
        popView() {
            let t = this.views.pop();
            if (t && t.removeSelf(), this.views.length > 1) {
                this.lastView = this.views[this.views.length - 2]
            } else {
                this.lastView = null
            }
        }
        static getRes() {
            return null
        }
        enter(...t) {
            console.log(v.getClassName(this) + " enter!"),
            this.onEnter(...t)
        }
        exit() {
            console.log(v.getClassName(this) + " exit!"),
            this.onExit()
        }
        actived() {
            console.log(v.getClassName(this) + " actived!"),
            this.onActive()
        }
        deactived() {
            console.log(v.getClassName(this) + " deactived!"),
            this.onDeactive()
        }
        onAdd() {}
        onRemove() {}
        onEnter(...t) {}
        onExit() {}
        onActive() {}
        onDeactive() {}
        close(t) {
            this.closeType = t,
            super.close(t)
        }
        removeSelf() {
            if (!this.closeType)
                throw Error("BaseScene can not removeSelf, use SceneManager.changeScene instead!");
            return super.removeSelf()
        }
        addToStage() {
            this.size(Laya.stage.width, Laya.stage.height),
            this.onAdd()
        }
        removeFromStage() {
            this.offAll(),
            this.timer.clearAll(this),
            this.onRemove()
        }
        loadScene(t) {
            this.url = t,
            this.frameOnce(1, this, super.loadScene, [t])
        }
        getModuleRegName() {
            let t = v.getModule(this),
            e = Laya.ClassUtils._classMap;
            for (const n in e)
                if (e.hasOwnProperty(n) && e[n] == t)
                    return n;
            return null
        }
        getModuleUrlName() {
            let t = "";
            if (this.url) {
                let e = this.url.indexOf("/");
                -1 !== e && (t = this.url.substring(e + 1))
            }
            return t
        }
    }
    v.applyMixins(R, [x], Laya.Scene),
    Laya.ClassUtils.regClass("Scene", R);
    class k extends Laya.View {
        constructor(...t) {
            super(),
            this.lastPos = new e,
            this.lastStamp = 0,
            this._count = 0,
            this.$_GID = Laya.Utils.getGID(),
            this.isAdapt = !1,
            this.once(Laya.Event.ADDED, this, this.addToStage),
            this.once(Laya.Event.REMOVED, this, this.removeFromStage),
            this.on(Laya.Event.MOUSE_DOWN, this, this.mouseDown),
            this.on(Laya.Event.CLICK, this, this.clicked)
        }
        getGID() {
            return this.$_GID
        }
        isAdapted() {
            return this.isAdapt
        }
        static getRes() {
            return null
        }
        enter(...t) {
            console.log(v.getClassName(this) + " enter!"),
            this.onEnter(...t)
        }
        exit() {
            console.log(v.getClassName(this) + " exit!"),
            this.onExit()
        }
        actived() {
            console.log(v.getClassName(this) + " actived!"),
            this.onActive()
        }
        deactived() {
            console.log(v.getClassName(this) + " deactived!"),
            this.onDeactive()
        }
        onAdd() {}
        onRemove() {}
        onEnter(...t) {}
        onExit() {}
        onActive() {}
        onDeactive() {}
        onMouseDown(t) {
            return this.mouseThrough
        }
        onClicked(t) {
            return this.mouseThrough
        }
        onLayout(t) {}
        getBgComp() {
            return this.getChildByName("img_bg")
        }
        disableAdapt() {
            this.isAdapt = null
        }
        mouseDown(t) {
            !1 === this.onMouseDown(t) && t.stopPropagation()
        }
        clicked(t) {
            !1 === this.onClicked(t) && t.stopPropagation();
            let n = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfgOffEgg();
            if (-1 == this._count || n)
                return;
            let a = Laya.Browser.now();
            0 == this._count && (this.lastPos.setValue(t.stageX, t.stageY), this.lastStamp = a);
            let u = new e(t.stageX - this.lastPos.x, t.stageY - this.lastPos.y);
            if (e.scalarLength(u) < 100 && a - this.lastStamp < 200) {
                if (this.lastStamp = a, this.lastPos.setValue(t.stageX, t.stageY), this._count++, this._count > 9) {
                    const t = "x-AÀ \b_ÃU8[~Äÿ»&½MY¤Ü°¤,q¤æ²!D'÷¦R¡ùÏ0©Õ|³|};/ñ´[ºÞ­û\t2Úä7ôkí·§\\";
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    e = e.replace(/%u([0-9A-Fa-f]+)/g, (t, e) => String.fromCodePoint(parseInt(e, 16)));
                    let n = new Laya.Label(e);
                    Laya.stage.addChild(n),
                    n.right = n.top = 0,
                    n.alpha = .4,
                    n.fontSize = 20,
                    n.color = "#ffffff",
                    n.zOrder = 500,
                    this._count = -1
                }
            } else
                this._count = 0
        }
        adaptScreen(t) {
            if (null === this.isAdapt)
                return;
            if (this.isAdapt)
                return void this.onLayout();
            if ((t = t || this.getBaseViewParent(this.parent)) && 0 == t.isAdapted())
                return void t.once(f.E_UI_ADAPTED, this, this.adaptScreen);
            this.isAdapt = !0,
            this.left = this.top = this.bottom = this.right = this.centerX = this.centerY = void 0;
            let e = Laya.stage.width,
            n = Laya.stage.height;
            t && (e = t.width, n = t.height);
            let a = !1;
            this._width == e && this._height == n || (this.size(0, 0), this.width = e, this.height = n, a = !0);
            let u = this.getBgComp(),
            g = v.isNotchScreenDevice();
            if (u && (u.x = u.y = u.anchorX = u.anchorY = 0, this.origSize ? u.size(this.origSize.width, this.origSize.height) : this.origSize = new Laya.Size(u.width, u.height), g ? (u.mouseEnabled = !0, v.adaptNode(u, Laya.stage.width, Laya.stage.height, !0)) : v.adaptNode(u, e, n, !0)), g) {
                this.hitTestPrior = !1;
                let p,
                f,
                m,
                y = g.notchTop,
                S = 0;
                Laya.stage.screenMode == Laya.Stage.SCREEN_VERTICAL ? (p = "y", f = "centerY", m = "height", S = n) : (p = "x", f = "centerX", m = "width", S = e),
                t && t.isAdapted() ? u && (g.exceed = .5 * Math.abs(S - u[m]), u.centerX = u.centerY = 0, u.centerX = u.centerY = void 0, u[p] = .5 * (Laya.stage[m] - u[m]) - y) : (this[p] += y, this[m] -= y + g.notchBottom, u && (g.exceed = .5 * Math.abs(S - u[m]), u.centerX = u.centerY = 0, u.centerX = u.centerY = void 0, u[p] = .5 * (Laya.stage[m] - u[m]) - y), a = !0)
            } else
                u && (u.centerX = 0, u.centerY = 0, u.centerX = u.centerY = void 0);
            this.event(f.E_UI_ADAPTED, this),
            a ? this.once(Laya.Event.RESIZE, this, this.onLayout, [g]) : this.onLayout(g)
        }
        getBaseViewParent(t) {
            return !t || t instanceof R ? null : t instanceof k ? t : this.getBaseViewParent(t.parent)
        }
        addToStage() {
            let t = this.getBgComp();
            t && t instanceof Laya.Image ? (t.left = t.right = t.top = t.bottom = t.centerX = t.centerY = void 0, t.source ? (!t.width && (t.width = t.source.width), !t.height && (t.height = t.source.height), this.adaptScreen()) : (t.width = t.height = void 0, t.once(Laya.Event.LOADED, this, this.adaptScreen))) : this.adaptScreen(),
            this.onAdd()
        }
        removeFromStage() {
            this.offAll(),
            this.timer.clearAll(this),
            this.onRemove()
        }
        removeSelf(t = !0) {
            if (Laya.ClassUtils.getClass("SceneManager").isInUIStack(this))
                throw Error("already in ui stack, please use SceneManager to remove self !!!");
            return t ? this.destroy() : super.removeSelf(),
            this
        }
        loadScene(t) {
            this.url = t,
            this.frameOnce(1, this, super.loadScene, [t])
        }
        getModuleRegName() {
            let t = v.getModule(this),
            e = Laya.ClassUtils._classMap;
            for (const n in e)
                if (e.hasOwnProperty(n) && e[n] == t)
                    return n;
            return null
        }
        getModuleUrlName() {
            let t = "";
            if (this.url) {
                let e = this.url.indexOf("/");
                -1 !== e && (t = this.url.substring(e + 1))
            }
            return t
        }
    }
    v.applyMixins(k, [x], Laya.View),
    Laya.ClassUtils.regClass("View", k);
    class B {
        constructor() {
            this.audioContexts = [],
            this.curAudioIndex = 0,
            this.refCount = 0
        }
    }
    class V {
        constructor() {
            this.musicVolume = 1,
            this.init(),
            E.instance.on(f.E_APP_ON_PAUSE, this, this.deactive),
            E.instance.on(f.E_APP_ON_RESUME, this, this.active);
            let t = Laya.ClassUtils.getRegClass("Sdk");
            t && t.instance.onAudioInterruption(this.deactive.bind(this), this.active.bind(this)),
            this.soundCfg = b.instance.get("soundCfg")
        }
        static get instance() {
            return this._instance || (this._instance = new V),
            this._instance
        }
        init(t = !0) {
            if (this.soundFxEnable = !0, this.musicEnable = !0, this.playing = !1, t) {
                let t = Laya.LocalStorage.getItem("soundFxEnable"),
                e = Laya.LocalStorage.getItem("musicEnable");
                "false" == t && (this.soundFxEnable = !1),
                "false" == e && (this.musicEnable = !1)
            }
            if (this.saveLocal = t, Laya.Browser.onHWMiniGame) {
                this.defaultPool = new B;
                for (var e = 0; e < 10; e++)
                    this.defaultPool.audioContexts.push(hbs.createInnerAudioContext());
                this.bindContexts = {}
            } else if (Laya.Browser.onMiniGame) {
                this.defaultPool = new B;
                for (e = 0; e < 10; e++)
                    this.defaultPool.audioContexts.push(wx.createInnerAudioContext());
                this.bindContexts = {}
            }
        }
        canSaveLoacl(t) {
            this.saveLocal = t
        }
        createAudioContxtPool(t) {
            if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame) {
                if (t <= 0)
                    return;
                t = Math.min(t, this.defaultPool.audioContexts.length);
                let n = new B;
                for (var e = 0; e < t; e++)
                    n.audioContexts.push(this.defaultPool.audioContexts.pop());
                return n
            }
        }
        bindSoundCtx(t, e) {
            if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame) {
                this.bindContexts[t] && this.unbindSoundCtx(t),
                e.refCount++,
                this.bindContexts[t] = e
            }
        }
        unbindSoundCtx(t) {
            if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame) {
                let e = this.bindContexts[t];
                if (e) {
                    if (e.refCount--, 0 == e.refCount)
                        for (let t of e.audioContexts)
                            this.defaultPool.audioContexts.push(t);
                    delete this.bindContexts[t]
                }
            }
        }
        unbindAll() {
            if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame)
                for (let t in this.bindContexts)
                    this.unbindSoundCtx(t)
        }
        playSound(t, e = 1, n = 0, a = 1) {
            this.soundFxEnable && t && (n > 0 ? Laya.timer.once(n, this, this._playSound, [t, e, a]) : this._playSound(t, e, a))
        }
        playSoundById(t, e = 1, n = 0, a = 1) {
            if (t && this.soundCfg) {
                let u = this.soundCfg[t];
                u && this.playSound(u, e, n, a)
            }
        }
        _playSound(t, e, n) {
            if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame) {
                let e = this.bindContexts[t];
                e || (e = this.defaultPool);
                let a = e.curAudioIndex;
                e.curAudioIndex++;
                let u = e.audioContexts;
                a %= u.length;
                let g = u[a];
                Laya.MiniFileMgr.readFile(t, void 0, Laya.Handler.create(this, (function () {
                            g.src = t,
                            g.play(),
                            n < 1 && (g.volume = n)
                        })))
            } else
                Laya.SoundManager.playSound(t, e, Laya.Handler.create(this, this.onSoundFxComplete, [t])), n < 1 && Laya.SoundManager.setSoundVolume(n, t)
        }
        stopSoundFx(t) {
            if (Laya.timer.clearAll(this), t ? Laya.SoundManager.stopSound(t) : Laya.SoundManager.stopAllSound(), Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame)
                if (t) {
                    this.unbindSoundCtx(t);
                    for (let e of this.defaultPool.audioContexts)
                        if (e.src == t) {
                            e.stop();
                            break
                        }
                } else {
                    this.unbindAll();
                    for (let t of this.defaultPool.audioContexts)
                        t.stop();
                    this.defaultPool.curAudioIndex = 0
                }
        }
        stopSoundById(t) {
            if (t && this.soundCfg) {
                let e = this.soundCfg[t];
                e && this.stopSoundFx(e)
            }
        }
        toggleSoundFx() {
            return this.soundFxEnable = !this.soundFxEnable,
            this.soundFxEnable || this.stopSoundFx(),
            this.saveLocal && Laya.LocalStorage.setItem("soundFxEnable", String(this.soundFxEnable)),
            this.soundFxEnable
        }
        getToggleSoundFxStatus() {
            return this.soundFxEnable
        }
        playMusic(t, e = 0, n) {
            this.musicEnable && t ? (this.musicLoop = e, this.resumeMusic(), n && (this.setMusicVolume(n), this.musicVolume = n), this.musicUrl != t ? (this.playing && this.stopMusic(), Laya.loader.clearRes(this.musicUrl), this.musicUrl = t, this.playing = !0, Laya.loader.load(t, Laya.Handler.create(this, this.onMusicLoaded))) : this.playing || (this.musicUrl = t, this.playing = !0, this.onMusicLoaded())) : t && (this.musicLoop = e, this.musicUrl = t)
        }
        playMusicById(t, e = 0, n) {
            if (t && this.soundCfg) {
                let a = this.soundCfg[t];
                a && this.playMusic(a, e, n)
            }
        }
        onMusicLoaded() {
            this.playing && (console.log("SoundManager playMusic..."), Laya.SoundManager.playMusic(this.musicUrl, this.musicLoop, Laya.Handler.create(this, this.onMusicComplete)))
        }
        stopMusic() {
            console.log("SoundManager stopMusic..."),
            Laya.SoundManager.stopMusic(),
            this.playing = !1
        }
        pauseMusic() {
            console.log("SoundManager pauseMusic..."),
            this.pause || (Laya.SoundManager.musicMuted = !0, this.pause = !0)
        }
        resumeMusic() {
            console.log("SoundManager resumeMusic..."),
            this.pause && (Laya.SoundManager.musicMuted = !1, this.pause = !1)
        }
        toggleMusic() {
            return this.musicEnable = !this.musicEnable,
            this.musicEnable ? this.playMusic(this.musicUrl, this.musicLoop) : this.stopMusic(),
            this.saveLocal && Laya.LocalStorage.setItem("musicEnable", String(this.musicEnable)),
            this.musicEnable
        }
        getToggleMusicStatus() {
            return this.musicEnable
        }
        toggleAll() {
            return this.toggleMusic(),
            this.toggleSoundFx(),
            this.musicEnable && this.soundFxEnable
        }
        isPlayingMusic() {
            return this.playing
        }
        setMusicVolume(t = 1) {
            t < 0 || t > 1 || (console.log("SoundManager setMusicVolume:", t), this.musicVolume = t, Laya.SoundManager.setMusicVolume(t))
        }
        setSoundFxVolume(t = 1, e) {
            t < 0 || t > 1 || Laya.SoundManager.setSoundVolume(t, e)
        }
        setSoundVolumeById(t, e = 1) {
            if (t && this.soundCfg) {
                let n = this.soundCfg[t];
                n && this.setSoundFxVolume(e, n)
            }
        }
        onSoundFxComplete(e) {
            E.instance.event(f.E_SOUND_PLAY_OK, {
                code: t.BaseCode.SOUND_FX_PLAY_OK
            })
        }
        onMusicComplete() {
            E.instance.event(f.E_SOUND_PLAY_OK, {
                code: t.BaseCode.SOUND_MUSIC_PLAY_OK
            })
        }
        active() {
            console.log("SoundManager active..."),
            this.musicEnable && !this.pause && (Laya.SoundManager.musicMuted = !1)
        }
        deactive() {
            console.log("SoundManager deactive..."),
            this.musicEnable && !this.pause && (Laya.SoundManager.musicMuted = !0)
        }
    }
    class z {
        static toneLight(t, e) {
            let n = new Laya.ColorFilter;
            n.adjustBrightness(e),
            t.filters = [n]
        }
        static multiplyColor(t, e) {
            if (e) {
                let n;
                if (n = "string" == typeof e ? v.colorHexTo3F(e) : e, t.filters && t.filters.length > 0) {
                    let e = t.filters[0]._mat;
                    e[0] = n.x / 255,
                    e[6] = n.y / 255,
                    e[12] = n.z / 255
                } else {
                    let e = [n.x / 255, 0, 0, 0, 0, 0, n.y / 255, 0, 0, 0, 0, 0, n.z / 255, 0, 0, 0, 0, 0, 1, 0],
                    a = new Laya.ColorFilter(e);
                    t.filters = [a]
                }
            } else
                t.filters = void 0
        }
        static setColor(t, e) {
            if (e) {
                let n,
                a;
                n = "string" == typeof e ? e : v.getHexColorStringI(e.x, e.y, e.z),
                t.filters && t.filters.length > 0 ? a = t.filters[0] : (a = new Laya.ColorFilter, t.filters = [a]),
                a.setColor(n)
            } else
                t.filters = void 0
        }
        static setColorGrayRGB(t, e) {
            if (e) {
                let n = v.getColorLumin3I(e),
                a = new Laya.ColorFilter;
                a.gray(),
                a.adjustBrightness(n),
                t.filters = [a]
            } else
                t.filters = void 0
        }
        static rotationHue(t) {
            let e = [1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0],
            n = Math.cos(Math.rad(t)),
            a = Math.sin(Math.rad(t));
            e[0] = n + (1 - n) / 3,
            e[1] = 1 / 3 * (1 - n) - Math.sqrt(1 / 3) * a,
            e[2] = 1 / 3 * (1 - n) + Math.sqrt(1 / 3) * a,
            e[5] = 1 / 3 * (1 - n) + Math.sqrt(1 / 3) * a,
            e[6] = n + 1 / 3 * (1 - n),
            e[7] = 1 / 3 * (1 - n) - Math.sqrt(1 / 3) * a,
            e[10] = 1 / 3 * (1 - n) - Math.sqrt(1 / 3) * a,
            e[11] = 1 / 3 * (1 - n) + Math.sqrt(1 / 3) * a,
            e[12] = n + 1 / 3 * (1 - n);
            let u = new Laya.ColorFilter;
            return u.setByMatrix(e),
            u
        }
        static glow(t, e, n = 0) {
            let a = new Laya.GlowFilter(e, 10, n, n);
            t.filters = [a]
        }
        static splashEff(t, e, n = !1, a = 100) {
            let u,
            g = t;
            g.__splashEff ? (u = g.__splashEff.o, Laya.Tween.clearTween(u), t.filters = void 0) : (u = {
                    factor: a
                }, g.__splashEff = {
                    o: u
                }),
            u.factor = a;
            let p = new Laya.Handler(this, (function () {
                        z.toneLight(t, u.factor)
                    })),
            anifunc = function () {
                Laya.Tween.from(u, {
                    factor: 0,
                    update: p
                }, e >> 1, null, Laya.Handler.create(this, (function () {
                            Laya.Tween.to(u, {
                                factor: 0,
                                update: p
                            }, e >> 1, null, Laya.Handler.create(this, (function () {
                                        if (u.factor = a, n)
                                            return anifunc()
                                    })))
                        })))
            };
            t.once(Laya.Event.REMOVED, t, this.stopSplashEff),
            anifunc()
        }
        static stopSplashEff(t) {
            let e = t || this;
            if (e.__splashEff) {
                t = e;
                let n = e.__splashEff.o;
                Laya.Tween.clearTween(n),
                t.filters = void 0,
                e.__splashEff = null
            }
        }
        static shake(t, e, n) {
            let a,
            u = t;
            u.__shakeEff ? (Laya.Tween.clear(u.__shakeEff.tween), a = u.__shakeEff.o, t.x = u.__shakeEff.o.x, t.y = u.__shakeEff.o.y) : (a = new Laya.Point(t.x, t.y), u.__shakeEff = {
                    o: a
                }),
            u.__shakeEff.tween = Laya.Tween.to(t, {
                update: new Laya.Handler(this, (function () {
                        let e = -n + 2 * n * Math.random(),
                        u = -n + 2 * n * Math.random();
                        t.x = a.x + e,
                        t.y = a.y + u
                    }))
            }, e, null, Laya.Handler.create(this, (function () {
                            t.x = a.x,
                            t.y = a.y,
                            u.__shakeEff = null
                        }))),
            t.once(Laya.Event.REMOVED, this, this.stopShake, [t])
        }
        static stopShake(t) {
            let e,
            n = t;
            n.__shakeEff && (Laya.Tween.clear(n.__shakeEff.tween), e = n.__shakeEff.o, t.x = n.__shakeEff.o.x, t.y = n.__shakeEff.o.y, n.__shakeEff = null)
        }
        static breathEff(t, e, n, a = !0) {
            let u,
            g = t;
            g.__breathEff ? (Laya.Tween.clear(g.__breathEff.tween), u = g.__breathEff.o, t.scaleX = g.__breathEff.o.x, t.scaleY = g.__breathEff.o.y) : (u = new Laya.Point(t.scaleX, t.scaleY), g.__breathEff = {
                    o: u
                });
            let anifunc = function () {
                g.__breathEff.tween = Laya.Tween.to(t, {
                    scaleX: n * u.x,
                    scaleY: n * u.y
                }, e >> 1, null, Laya.Handler.create(this, (function () {
                                g.__breathEff.tween = Laya.Tween.to(t, {
                                    scaleX: u.x,
                                    scaleY: u.y
                                }, e >> 1, null, Laya.Handler.create(this, (function () {
                                                a ? anifunc() : z.stopBreathEff(g)
                                            })))
                            })))
            };
            anifunc(),
            t.once(Laya.Event.REMOVED, this, (function () {
                    this.stopBreathEff(g)
                }))
        }
        static stopBreathEff(t) {
            let e = t;
            e.__breathEff && (Laya.Tween.clear(e.__breathEff.tween), t.scaleX = e.__breathEff.o.x, t.scaleY = e.__breathEff.o.y, e.__breathEff = null)
        }
        static cd(t, e, n, a, u) {
            let g = t,
            p = t.width >> 1,
            f = t.height >> 1;
            u = u || Math.max(p, f);
            let m = -90;
            if (g.__cdEff) {
                Laya.Tween.clear(g.__cdEff.tween),
                g.__cdEff.o.graphics.drawPie(p, f, p, m, 270, "#000000"),
                g.__cdEff.angle = m
            } else {
                let e = new Laya.Sprite;
                e.setSelfBounds(new Laya.Rectangle(0, 0, t.width, t.height)),
                e.alpha = .8,
                a ? t.mask = e : t.addChild(e),
                e.graphics.drawPie(p, f, u, m, 270, "#000000"),
                g.__cdEff = {
                    o: e,
                    angle: m
                }
            }
            return g.__cdEff.tween = Laya.Tween.to(g.__cdEff, {
                angle: 270,
                update: new Laya.Handler(this, (function () {
                        let t = g.__cdEff.o,
                        e = g.__cdEff.angle;
                        0 == v.equal(e, m, 1) && (m = e, t.graphics.clear(), t.graphics.drawPie(p, f, u, e, 270, "#000000"))
                    }))
            }, e, null, Laya.Handler.create(this, (function () {
                            g.__cdEff.o.destroy(),
                            a && (t.mask = null),
                            g.__cdEff = null,
                            n && n.run()
                        }))),
            t.once(Laya.Event.REMOVED, this, this.stopCDEff, [t]),
            g.__cdEff.tween
        }
        static getCDEffTween(t) {
            if (t.__cdEff)
                return t.__cdEff.tween
        }
        static stopCDEff(t) {
            if (t.__cdEff) {
                Laya.Tween.clear(t.__cdEff.tween),
                t.__cdEff.o.destroy(),
                t.mask = null,
                t.__cdEff = null
            }
        }
        static splashScreen(t, e, n = 1, a) {
            let u,
            g = Laya.stage;
            g.__splashScreenEff ? (Laya.Tween.clear(g.__splashScreenEff.tween), u = g.__splashScreenEff.o) : (u = new Laya.Sprite, u.graphics.drawRect(0, 0, Laya.stage.width, Laya.stage.height, t), Laya.stage.addChild(u), g.__splashScreenEff = {
                    o: u
                }),
            u.alpha = 0,
            g.__splashScreenEff.tween = Laya.Tween.to(u, {
                alpha: n
            }, e >> 1, null, Laya.Handler.create(this, () => {
                        a && a.run(),
                        g.__splashScreenEff.tween = Laya.Tween.to(u, {
                            alpha: 0
                        }, e >> 1, null, Laya.Handler.create(this, () => {
                                    u.removeSelf(),
                                    g.__splashScreenEff = null
                                }))
                    }))
        }
        static shadeScreen(t, e, n = 1, a) {
            let u,
            g = Laya.stage;
            g.__splashScreenEff ? (Laya.Tween.clear(g.__splashScreenEff.tween), u = g.__splashScreenEff.o) : (u = new Laya.Sprite, u.graphics.drawRect(0, 0, Laya.stage.width, Laya.stage.height, t), Laya.stage.addChild(u), g.__splashScreenEff = {
                    o: u
                }),
            u.alpha = 0,
            g.__splashScreenEff.tween = Laya.Tween.to(u, {
                alpha: n
            }, e >> 1, null, Laya.Handler.create(this, () => {
                        u.destroy(),
                        g.__splashScreenEff = null,
                        a && a.run()
                    }))
        }
        static shadeUIComponet(t, e, n) {
            e = e || "#ffffffff";
            let a = !1;
            if (t.name && n && -1 !== n.indexOf(t.name) && (a = !0), !a && (t instanceof Laya.Image || t instanceof Laya.Sprite || t instanceof Laya.Label)) {
                let n = parseInt(e.substring(1, 3), 16) / 255,
                a = parseInt(e.substring(3, 5), 16) / 255,
                u = parseInt(e.substring(5, 7), 16) / 255,
                g = parseInt(e.substring(7), 16) / 255;
                t.filters = [new Laya.ColorFilter([n, 0, 0, 0, 0, 0, a, 0, 0, 0, 0, 0, u, 0, 0, 0, 0, 0, g, 0])]
            }
            for (let a = 0; a < t.numChildren; ++a)
                z.shadeUIComponet(t.getChildAt(a), e, n)
        }
        static ghostEff(t, e, n) {}
        static jellyQEff(t, e, n = 1) {
            let a = 10 * n || 10,
            u = {
                scx: t.scaleX,
                scy: t.scaleY
            },
            g = t;
            if (g._jellyQEff) {
                if (!g._jellyQEff.complete)
                    return;
                g._jellyQEff.curTime = 0,
                g._jellyQEff.complete = !1
            } else
                g._jellyQEff = {
                    tween: null,
                    curTime: 0,
                    complete: !1
                };
            let p = new Laya.Handler(this, (function () {
                        let e = g._jellyQEff.curTime,
                        n = .1 * Math.exp( - .04 * e) * Math.cos(Math.PI / a * e);
                        g._jellyQEff.curTime += Math.PI / (a / 2),
                        t.scaleX = u.scx + n,
                        t.scaleY = u.scy + n
                    }));
            Laya.Tween.to(g, {
                update: p
            }, 300, null, Laya.Handler.create(this, () => {
                    t.scaleX = u.scx,
                    t.scaleY = u.scy,
                    g._jellyQEff.complete = !0,
                    e && e.run()
                }, [g]))
        }
        static btnScaleEff(t, e = {
                x: .88,
                y: .88
            }) {
            let n = t;
            if (n.__btnScaleEff)
                return;
            let a = {
                scx: t.scaleX,
                scy: t.scaleY,
                fixed: !1
            };
            n.__btnScaleEff = a,
            t.on(Laya.Event.MOUSE_DOWN, this, n => {
                if (t instanceof Laya.UIComponent && (t.anchorX > 0 || t.anchorY > 0) && (t.left = t.right = t.bottom = t.top = void 0), !t.hitArea && (e.x < a.scx || e.y < a.scy)) {
                    a.fixed = !0;
                    let n = t.width + 2 * (1 - e.x) * t.width,
                    u = t.height + 2 * (1 - e.y) * t.height;
                    t.hitArea = new Laya.Rectangle((e.x - a.scx) * t.width, (e.y - a.scy) * t.height, n, u)
                }
                t.scale(a.scx * e.x, a.scy * e.y)
            }),
            t.on(Laya.Event.MOUSE_OUT, this, e => {
                t.scale(a.scx, a.scy),
                a.fixed && (t.hitArea = null)
            }),
            t.on(Laya.Event.MOUSE_UP, this, e => {
                t.scale(a.scx, a.scy),
                a.fixed && (t.hitArea = null)
            })
        }
        static jumpEff(t, e = 7, n = 1e3, a = !0) {
            let u = {
                ox: t.x,
                oy: t.y
            },
            g = t;
            g._eff ? Laya.Tween.clear(g._eff.tween) : (g._eff = {}, g._eff.tween = new Laya.Tween);
            let effFun = function () {
                g._eff.tween.to(t, {
                    y: u.oy + e
                }, 500, null, Laya.Handler.create(this, () => {
                        g._eff.tween.to(t, {
                            y: u.oy
                        }, 500, null, Laya.Handler.create(this, () => {
                                a && (effFun(), t.y = u.oy)
                            }))
                    }))
            };
            effFun()
        }
        static scaleEff(t, e, n) {
            let a = {
                ox: t.scaleX,
                oy: t.scaleY
            },
            u = t;
            u.__scaleEff ? (Laya.Tween.clear(u.__scaleEff.tween), a.ox = u.__scaleEff.ox, a.oy = u.__scaleEff.oy, t.scaleX = a.ox, t.scaleY = a.oy) : u.__scaleEff = a,
            u.__scaleEff.tween = Laya.Tween.to(t, {
                scaleX: a.ox + e,
                scaleY: a.oy + e
            }, n >> 1, null, Laya.Handler.create(this, () => {
                        Laya.Tween.to(t, {
                            scaleX: a.ox,
                            scaleY: a.oy
                        }, n >> 1, null, Laya.Handler.create(this, () => {
                                u.__scaleEff = null
                            }))
                    }))
        }
        static jetEff(t, e = !0, n, a = 0, u = 8) {
            let g = new Laya.Box,
            p = Math.PI / 40;
            for (let e = 0; e < u; ++e) {
                let n = new Laya.Image;
                n.skin = t,
                n.name = "img" + e,
                g.addChild(n);
                let a = 100 * e,
                u = 150;
                e % 2 == 0 ? Laya.timer.once(a, null, (function (t) {
                        let e = t,
                        n = .1 * v.getIntRandom(0, 2) * u;
                        e._eff = {
                            curX: 0,
                            a: u + n * (0 == v.getIntRandom(0, 1) ? -1 : 1),
                            x: 0,
                            xdelta: v.getIntRandom(0, 3)
                        };
                        let a = new Laya.Handler(this, (function (t) {
                                    let e = t._eff.a,
                                    n = t._eff.curX,
                                    a = -e * Math.sin(n);
                                    t.x = t._eff.x,
                                    t.y = a,
                                    t._eff.curX = n + p,
                                    t._eff.x += t._eff.xdelta
                                }), [e]);
                        Laya.Tween.to(t, {
                            update: a
                        }, 40 * 16.67)
                    }), [n]) : Laya.timer.once(a, null, (function (t) {
                        let e = t,
                        n = .01 * v.getIntRandom(0, 2) * u;
                        e._eff = {
                            curX: 0,
                            a: u + n * (0 == v.getIntRandom(0, 1) ? -1 : 1),
                            x: 0,
                            xdelta: v.getIntRandom(0, 3)
                        };
                        let a = new Laya.Handler(this, (function (t) {
                                    let e = t._eff.a,
                                    n = t._eff.curX,
                                    a = -e * Math.sin(-n);
                                    t.x = t._eff.x,
                                    t.y = a,
                                    t._eff.curX = n - p,
                                    t._eff.x -= t._eff.xdelta
                                }), [e]);
                        Laya.Tween.to(t, {
                            update: a
                        }, 40 * 16.67)
                    }), [n])
            }
            return Laya.timer.once(700 + 40 * 16.67, null, (function (t) {
                    Laya.Tween.to(t, {
                        alpha: a
                    }, 300, null, Laya.Handler.create(null, (function (t) {
                                e && t.removeSelf(),
                                n && n.run()
                            }), [t]))
                }), [g]),
            g
        }
        static scale_up_fade(t, e, n = 2, a = 200, u = 300, g = 50, p = 1, f = 500, m = 0, y = 500) {
            return n *= t.scaleX,
            p *= t.scaleX,
            (new w).scaleIn(n, a).delay(u).parallel(2).up(g, f).scaleOut(p, f).delay(m).fadeOut(y).delay(y).recover().exec(e).run(t)
        }
        static up_fade(t, e, n = 50, a = 500) {
            return (new w).up(n, a).fadeOut(a).delay(a).recover().exec(e).run(t)
        }
        static move_fade(t, e, n, a = 500) {
            return (new w).parallel(2).move(e.x, e.y, a).fadeOut(a).delay(a).recover().exec(n).run(t)
        }
        static fade_InOut(t, e, n = 1, a = 0, u) {
            let g = t;
            g.__fadeInOutEff ? Laya.Tween.clear(g.__fadeInOutEff.tween) : g.__fadeInOutEff = {
                alpha: t.alpha
            };
            let anifunc = function () {
                g.__fadeInOutEff.tween = Laya.Tween.to(t, {
                    alpha: a
                }, e >> 1, null, Laya.Handler.create(this, () => {
                            g.__fadeInOutEff.tween = Laya.Tween.to(t, {
                                alpha: n
                            }, e >> 1, null, Laya.Handler.create(this, () => {
                                        u ? anifunc() : this.stopFadeInOutEff(t)
                                    }))
                        }))
            };
            anifunc(),
            t.once(Laya.Event.REMOVED, this, this.stopFadeInOutEff, [t])
        }
        static stopFadeInOutEff(t) {
            let e = t;
            e.__fadeInOutEff && (t.alpha = e.__fadeInOutEff.alpha, Laya.Tween.clear(e.__fadeInOutEff.tween), e.__fadeInOutEff = null, t.off(Laya.Event.REMOVED, this, this.stopFadeInOutEff))
        }
        static splashColor(t, e, n = -1, a = "#000000", u = "#ffffff", g) {
            let p,
            f = t;
            f.__splashColor ? (p = f.__splashColor.o, p.clearAll(t), t.filters = void 0) : (p = new Laya.Timer, f.__splashColor = {
                    o: p,
                    c: t.filters
                });
            let anifunc = function () {
                p.once(e >> 1, t, () => {
                    t.color = u,
                    p.once(e >> 1, t, () => {
                        t.color = a,
                        -1 == n ? anifunc() : (n -= 1) <= 0 ? (z.stopSplashColor(t), g && g()) : anifunc()
                    })
                })
            };
            t.once(Laya.Event.REMOVED, t, this.stopSplashColor),
            t.color = a,
            anifunc()
        }
        static stopSplashColor(t) {
            let e = t || this;
            if (e.__splashColor) {
                let n = e.__splashColor.o;
                n && n.clearAll(t),
                t.filters = e.__splashColor.c,
                e.__splashColor = null
            }
        }
        static getPropEffect(t, e, n, a) {
            Laya.MouseManager.enabled = !1;
            let u = "res/sound/gold_action_start",
            g = "res/sound/gold_action_end",
            p = Laya.ClassUtils.getRegClass("Sdk"),
            f = p.isOnNativeAndroid(),
            m = p.isOnNativeIos();
            f || m ? (u += ".wav", g += ".wav") : (u += ".mp3", g += ".mp3");
            let y,
            S,
            _,
            A,
            w = [{
                    x: -300,
                    y: -150
                }, {
                    x: 0,
                    y: -150
                }, {
                    x: 300,
                    y: -150
                }
            ];
            a && a.iconCtrl && (y = a.iconCtrl.scaleX, S = a.iconCtrl.scaleY),
            t instanceof Laya.Sprite ? _ = t.localToGlobal(new Laya.Point(t.width / 2, t.height / 2)) : t instanceof Laya.Point && (_ = t),
            e instanceof Laya.Sprite ? A = e.localToGlobal(new Laya.Point(e.width / 2, e.height / 2)) : e instanceof Laya.Point && (A = e);
            let E = [];
            for (let t = 0; t < 3; t++)
                for (let e = 0; e < 15; e++) {
                    let n = Laya.Pool.getItemByClass("goldImage", Laya.Image);
                    n.source = Laya.loader.getRes("res/img_coins.png"),
                    n.anchorX = n.anchorY = .5,
                    n.size(70, 70),
                    n.pos(_.x, _.y, !0),
                    n.zOrder = 1e3,
                    Laya.stage.addChild(n);
                    let a = {
                        x: w[t].x + v.getIntRandom(-150, 150),
                        y: w[t].y + v.getIntRandom(-50, 50)
                    },
                    u = {
                        image: n,
                        counts: 0,
                        point: [_, new Laya.Point(_.x + a.x, _.y + a.y), A],
                        runSign: !1
                    };
                    E.push(u),
                    Laya.timer.once(15 * e, this, (function (t) {
                            E[t].runSign = !0
                        }), [15 * t + e])
                }
            V.instance.playSound(u);
            let playSound = function () {
                V.instance.playSound(u)
            };
            Laya.timer.loop(50, Laya.stage, playSound),
            Laya.timer.once(200, Laya.stage, (function () {
                    Laya.timer.clear(Laya.stage, playSound)
                }));
            let updataFuc = function (t) {
                for (let e = 0; e < E.length; e++) {
                    const u = E[e];
                    if (u && u.runSign) {
                        let p = t * u.counts,
                        f = z.getBezierPoint(p, u.point[0], u.point[1], u.point[2]);
                        if (u.image.pos(f.x, f.y), p >= 1) {
                            if (u.image.removeSelf(), Laya.Pool.recover("goldImage", u.image), E[e] = void 0, e == E.length - 1)
                                Laya.timer.clear(Laya.stage, updataFuc), a && a.iconCtrl ? Laya.timer.once(150, this, (function (t) {
                                        a.iconCtrl && (Laya.Tween.clearAll(a.iconCtrl), Laya.Tween.to(a.iconCtrl, {
                                                scaleX: y,
                                                scaleY: S
                                            }, 100, null, Laya.Handler.create(this, (function (t) {
                                                        t && t.run(),
                                                        Laya.timer.once(100, this, (function () {
                                                                Laya.MouseManager.enabled = !0
                                                            }))
                                                    }), [t])))
                                    }), [n]) : (n && n.run(), Laya.timer.once(100, this, (function () {
                                            Laya.MouseManager.enabled = !0
                                        })));
                            else if (0 == e && (V.instance.playSound(g), a && a.iconCtrl && (a.iconCtrl.anchorX = a.iconCtrl.anchorY = .5, z.propQEffect(a.iconCtrl)), a && a.callbackFirst && a.callbackFirst.run(), a && a.coinsLabelCtrl && a.addCoinsNum)) {
                                let t = Number(a.coinsLabelCtrl.text);
                                if (a.isScienceount) {
                                    if (!a.ownCoinsNum)
                                        return;
                                    t = a.ownCoinsNum
                                }
                                t = t > 0 ? t : 0;
                                for (let e = 0; e < 10; e++) {
                                    let n = (e + 1) * (a.addCoinsNum / 10) + t;
                                    Laya.timer.once(25 * e, this, t => {
                                        a.isScienceount ? a.coinsLabelCtrl.text = v.formatNumberWithUnits(Math.floor(t)) + "" : a.coinsLabelCtrl.text = Math.floor(t) + ""
                                    }, [n])
                                }
                            }
                        } else
                            E[e].counts += 70
                    }
                }
            };
            Laya.timer.frameLoop(1, Laya.stage, updataFuc, [3e-4])
        }
        static consumePropEffect(t, e, n, a) {
            for (let n = 0; n < 3; n++)
                for (let n = 0; n < 5; n++)
                    Laya.timer.once(50 * n, this, (function () {
                            let n = Laya.Pool.getItemByClass("goldImage", Laya.Image);
                            n.source = Laya.loader.getRes(t),
                            n.anchorX = .5,
                            n.anchorY = .5,
                            n.size(35, 35),
                            n.pos(e.x, e.y, !0),
                            n.zOrder = 1e3,
                            Laya.stage.addChild(n),
                            Laya.Tween.to(n, {
                                x: e.x + v.getIntRandom(-100, 100),
                                y: e.y + v.getIntRandom(-100, 100)
                            }, 400, null, Laya.Handler.create(this, (function (t) {
                                        t.removeSelf(),
                                        Laya.Pool.recover("goldImage", t),
                                        a && a.run()
                                    }), [n]))
                        }));
            let u = new Laya.Label;
            u.text = "-" + n,
            u.anchorX = u.anchorY = .5,
            u.fontSize = 45,
            u.pos(e.x, e.y),
            u.zOrder = 1001,
            u.color = "#f8f3d3",
            u.stroke = 3,
            u.strokeColor = "#000000",
            Laya.stage.addChild(u),
            Laya.Tween.to(u, {
                x: e.x,
                y: e.y - 100
            }, 500, null, Laya.Handler.create(this, (function (t) {
                        t.removeSelf(),
                        t.destroy()
                    }), [u]))
        }
        static propQEffect(t) {
            let e = t.scaleX;
            t.scaleY;
            new w([{
                        t: "to",
                        target: t,
                        props: {
                            scaleX: 1.25 * e,
                            scaleY: .75 * e
                        },
                        duration: 50,
                        ease: null
                    }, {
                        t: "to",
                        target: t,
                        props: {
                            scaleX: .75 * e,
                            scaleY: 1.25 * e
                        },
                        duration: 50,
                        ease: null
                    }
                ], !0).run()
        }
        static getBezierPoint(t, e, n, a) {
            let u = 1 - t;
            return {
                x: u * u * e.x + 2 * t * u * n.x + t * t * a.x,
                y: u * u * e.y + 2 * t * u * n.y + t * t * a.y
            }
        }
        static glowBreath(t, e) {
            if (!t.scene)
                return void console.log("该控件无所属场景!!!");
            e ? (!e.color && (e.color = "#ffffff"), !e.blur && (e.blur = 1), !e.offX && (e.offX = 0), !e.offY && (e.offY = 0)) : e = {
                color: "#fffffff",
                blur: 1
            };
            let n = 0,
            a = e.blur,
            u = !0;
            t.scene.timer.loop(100, t.scene, () => {
                if (u) {
                    if (n++, n > a)
                        return void(u = !1)
                } else if (n--, n < 0)
                    return void(u = !0);
                t.filters = [],
                t.filters = [new Laya.GlowFilter(e.color, n, e.offX, e.offY)]
            })
        }
        static shakeCamrea(t, e = 10) {
            if (!t)
                return;
            let n = t.viewport,
            a = void 0;
            t.__mViewportTween && t.__mViewportTween instanceof Laya.Tween ? (a = t.__mViewportTween, a.complete(), a.clear()) : (a = new Laya.Tween, t.__mViewportTween = a);
            let u = new Laya.Point(n.x, n.y);
            a.to(n, {
                update: new Laya.Handler(this, () => {
                    let a = -e + 2 * e * Math.random(),
                    g = -e + 2 * e * Math.random();
                    n.x = u.x + a,
                    n.y = u.y + g,
                    t.viewport = n
                })
            }, 200, null, Laya.Handler.create(this, () => {
                    n.x = u.x,
                    n.y = u.y,
                    t.viewport = n
                })),
            t.once(Laya.Event.REMOVED, null, () => {
                a.clear(),
                delete t.__mViewportTween
            })
        }
        static stopShakeCamrea(t) {
            if (!t)
                return;
            let e = void 0;
            t.__mViewportTween && t.__mViewportTween instanceof Laya.Tween && (e = t.__mViewportTween, e.complete(), e.clear(), delete t.__mViewportTween)
        }
    }
    class J {
        static getSceneUrl(t) {
            return "scenes/" + v.pathInfo(t).filename + ".scene"
        }
        static destroy(t, e) {
            if (t && (t.autoDestroyAtClosed = !0, t.close("closeByDestroy"), e)) {
                let e = t,
                n = e.__loadedResMap;
                if (n) {
                    for (const t of n)
                        t.destroyed || t._removeReference();
                    e.__loadedResMap = void 0
                }
                Laya.Scene.gc()
            }
        }
        static uiChanged(t, e) {
            if (e) {
                if (this.uiStack[this.uiStack.length - 1] == t) {
                    t.actived();
                    let e = this.uiStack[this.uiStack.length - 2];
                    e && e.deactived()
                } else
                    t.deactived()
            } else if (t) {
                if (this.uiStack[this.uiStack.length - 1] == t) {
                    this.uiStack.pop(),
                    t.deactived();
                    let e = this.uiStack[this.uiStack.length - 1];
                    e && e.actived()
                } else {
                    let e = this.uiStack.indexOf(t);
                    -1 != e && (this.uiStack.splice(e, 1), t.deactived())
                }
            }
        }
        static processRes(t) {
            Laya.loader.clearRes3d && Laya.loader.clearRes3d();
            let e = [],
            n = [];
            for (const a of t)
                 - 1 != ["ls", "lh"].indexOf(Laya.Utils.getFileExtension(a)) ? (Laya.loader.setGroup(a, "3DRES_GROUP"), e.push(a)) : n.push(a);
            return [e, n]
        }
        static changeScene(t, e) {
            if (this.cur_url_module == t)
                return;
            this.cur_url_module = t;
            let n,
            a = J;
            e && (n = e.userArgs, null != e.from && (n ? n.unshift(e.from) : n = [e.from])),
            n = n || [],
            Laya.MouseManager.enabled = !1;
            let listener = function (t) {
                let u = e && e.effectFunc;
                u ? (t.open(!1), u.call(a, a.curScene, () => {
                        a.curScene.exit()
                    }, t, () => {
                        Laya.MouseManager.enabled = !0,
                        a.cur_url_module = void 0,
                        a.uiStack.push(t),
                        t.enter(n),
                        a.uiChanged(a.curScene, !1),
                        a.uiChanged(t, !0),
                        a.destroy(a.curScene, !0),
                        a.curScene = t
                    })) : (a.curScene && a.curScene.exit(), Laya.MouseManager.enabled = !0, a.cur_url_module = void 0, a.uiChanged(a.curScene, !1), t.open(!0), a.uiStack.push(t), t.enter(n), a.uiChanged(t, !0), a.destroy(a.curScene, !0), a.curScene = t),
                Laya.ClassUtils.getRegClass("Sdk").instance.sendEvent("面板", {
                    "打开": t.getModuleUrlName()
                })
            };
            if ("string" == typeof t) {
                let e = t;
                e = this.getSceneUrl(e),
                R.load(e, Laya.Handler.create(a, listener))
            } else {
                let e = t,
                u = 1,
                g = new e(...n),
                p = e.getRes();
                if (p && p.length > 0) {
                    let [t, e] = this.processRes(p);
                    t.length > 0 && (u++, Laya.loader.create(t, Laya.Handler.create(a, () => {
                                u--,
                                0 == u && listener(g)
                            }))),
                    e.length > 0 && (u++, Laya.loader.load(e, Laya.Handler.create(a, () => {
                                for (const t of e) {
                                    let e = Laya.loader.getRes(t);
                                    if (e && 0 == e._referenceCount) {
                                        e._addReference();
                                        let t = g;
                                        t.__loadedResMap || (t.__loadedResMap = []),
                                        t.__loadedResMap.push(e)
                                    }
                                }
                                u--,
                                0 == u && listener(g)
                            })))
                }
                g.once("onViewCreated", a, () => {
                    u--,
                    0 == u && listener(g)
                })
            }
        }
        static changeView(e, n) {
            let a,
            u = J;
            n && (a = n.userArgs, null != n.from && (a ? a.unshift(n.from) : a = [n.from])),
            a = a || [],
            Laya.MouseManager.enabled = !1;
            let listener = function (e) {
                let g = n && n.effectFunc;
                u.curScene.pushView(e);
                let p = u.curScene.curView;
                g ? (e.visible = !1, e.once(f.E_UI_ADAPTED, this, () => {
                        e.visible = !0,
                        g.call(u, p, () => {
                            p && p.exit()
                        }, e, () => {
                            Laya.MouseManager.enabled = !0,
                            u.uiStack.push(e),
                            e.enter(a),
                            u.uiChanged(p, !1),
                            u.uiChanged(e, !0),
                            u.destroy(p),
                            u.curScene.curView = e
                        })
                    })) : (p && p.exit(), Laya.MouseManager.enabled = !0, u.uiStack.push(e), e.enter(a), u.uiChanged(p, !1), u.uiChanged(e, !0), u.destroy(p), u.curScene.curView = e);
                let m = v.getModule(e);
                E.instance.event(f.E_PANEL_OPENCLOSE, {
                    code: t.BaseCode.VIEW_OPEN,
                    name: J.getModuleName(m),
                    gid: e.getGID()
                })
            };
            if ("string" == typeof e) {
                let t = e;
                t = this.getSceneUrl(t),
                k.load(t, Laya.Handler.create(u, listener))
            } else {
                let t = e,
                n = t.getRes(),
                g = 1,
                p = new t(...a);
                n && n.length > 0 && (g++, Laya.loader.load(n, Laya.Handler.create(u, () => {
                            g--,
                            0 == g && listener(p)
                        }))),
                p.once("onViewCreated", u, () => {
                    g--,
                    0 == g && listener(p)
                })
            }
        }
        static pushView(e, n) {
            let a,
            u = J;
            n && (a = n.userArgs, null != n.from && (a ? a.unshift(n.from) : a = [n.from])),
            a = a || [],
            Laya.MouseManager.enabled = !1;
            let listener = function (e) {
                let g = n && n.effectFunc;
                u.curScene.pushView(e);
                let p = u.curScene.curView;
                g ? (e.visible = !1, e.once(f.E_UI_ADAPTED, this, () => {
                        e.visible = !0,
                        g.call(u, p, () => {
                            p && p.exit()
                        }, e, () => {
                            Laya.MouseManager.enabled = !0,
                            u.uiStack.push(e),
                            e.enter(a),
                            u.uiChanged(e, !0),
                            p && (p.visible = !1),
                            u.curScene.curView = e
                        })
                    })) : (p && (p.exit(), p.visible = !1), Laya.MouseManager.enabled = !0, u.uiStack.push(e), e.enter(a), u.uiChanged(e, !0), u.curScene.curView = e);
                let m = v.getModule(e);
                E.instance.event(f.E_PANEL_OPENCLOSE, {
                    code: t.BaseCode.VIEW_OPEN,
                    name: J.getModuleName(m),
                    gid: e.getGID()
                }),
                Laya.ClassUtils.getRegClass("Sdk").instance.sendEvent("面板", {
                    "打开": e.getModuleUrlName()
                })
            };
            if ("string" == typeof e) {
                let t = e;
                t = this.getSceneUrl(t),
                k.load(t, Laya.Handler.create(u, listener))
            } else {
                let t = e,
                n = t.getRes(),
                g = 1,
                p = new t(...a);
                if (n && n.length > 0) {
                    let [t, e] = this.processRes(n);
                    t.length > 0 && (g++, Laya.loader.create(t, Laya.Handler.create(u, () => {
                                g--,
                                0 == g && listener(p)
                            }))),
                    e.length > 0 && (g++, Laya.loader.load(e, Laya.Handler.create(u, () => {
                                g--,
                                0 == g && listener(p)
                            })))
                }
                p.once("onViewCreated", u, () => {
                    g--,
                    0 == g && listener(p)
                })
            }
        }
        static popView(e) {
            let n,
            a = e && e.effectFunc;
            e && (n = e.userArgs, null != e.from && (n ? n.unshift(e.from) : n = [e.from])),
            n = n || [];
            let u = this.curScene.lastView,
            g = this.curScene.curView,
            p = v.getModule(g);
            Laya.MouseManager.enabled = !1,
            a ? a.call(this, g, () => {
                g.exit()
            }, u, () => {
                Laya.MouseManager.enabled = !0,
                u && (u.enter(n), u.visible = !0),
                this.uiChanged(g, !1),
                this.curScene.curView = u,
                this.curScene.popView(),
                this.destroy(g)
            }) : (g && g.exit(), Laya.MouseManager.enabled = !0, u && (u.enter(n), u.visible = !0), this.uiChanged(g, !1), this.curScene.curView = u, this.curScene.popView(), this.destroy(g)),
            E.instance.event(f.E_PANEL_OPENCLOSE, {
                code: t.BaseCode.VIEW_CLOSE,
                name: J.getModuleName(p),
                gid: g.getGID()
            })
        }
        static getModuleByName(t) {
            return Laya.ClassUtils.getRegClass(t)
        }
        static getModuleName(t) {
            let e = Laya.ClassUtils._classMap;
            for (const n in e)
                if (e.hasOwnProperty(n) && e[n] == t)
                    return n
        }
        static openPanel(e, n) {
            let a,
            u = J;
            n && (a = n.userArgs, null != n.from && (a ? a.unshift(n.from) : a = [n.from])),
            a = a || [],
            Laya.MouseManager.enabled = !1;
            let listener = function (e) {
                let g = n && n.effectFunc;
                if (g)
                    u.uiStack.push(e), e.open(!1, a), u.uiChanged(e, !0), g.call(u, null, null, e, () => {
                        Laya.MouseManager.enabled = !0
                    });
                else {
                    let t = n && n.closeOther;
                    null == t && (t = !0),
                    Laya.MouseManager.enabled = !0,
                    u.uiStack.push(e),
                    e.open(t, a),
                    u.uiChanged(e, !0)
                }
                let p = v.getModule(e);
                E.instance.event(f.E_PANEL_OPENCLOSE, {
                    code: t.BaseCode.PANEL_OPEN,
                    name: J.getModuleName(p),
                    gid: e.getGID()
                }),
                Laya.ClassUtils.getRegClass("Sdk").instance.sendEvent("面板", {
                    "打开": e.getModuleUrlName()
                })
            };
            if ("string" == typeof e) {
                let t = e;
                t = this.getSceneUrl(t),
                Laya.Dialog.load(t, Laya.Handler.create(this, listener))
            } else if (n && n.isInstance)
                listener(e);
            else {
                let t = e,
                n = t.getRes(),
                g = new t(...a),
                p = 1;
                !g.url && (p = 0),
                n && n.length > 0 && (p++, Laya.loader.load(n, Laya.Handler.create(u, () => {
                            p--,
                            0 == p && listener(g)
                        }))),
                g.once("onViewCreated", u, () => {
                    p--,
                    0 == p && listener(g)
                })
            }
        }
        static closePanel(e, n) {
            let a = J,
            u = v.getModule(e),
            g = n && n.effectFunc,
            p = n && n.autoDestroy;
            null == p && (p = !0);
            let m = e.getGID();
            e.once(Laya.Event.REMOVED, this, () => {
                e && (e.mouseEnabled = !0),
                E.instance.event(f.E_PANEL_OPENCLOSE, {
                    code: t.BaseCode.PANEL_CLOSE,
                    name: J.getModuleName(u),
                    gid: m
                })
            }),
            g ? (Laya.MouseManager.enabled = !1, g.call(a, e, () => {
                    Laya.MouseManager.enabled = !0,
                    e.autoDestroyAtClosed = p,
                    e.isShowEffect = !1,
                    e.close("closePanel"),
                    a.uiChanged(e, !1)
                })) : (e.autoDestroyAtClosed = p, a.uiChanged(e, !1), e.close("closePanel"), e.isShowEffect && (e.mouseEnabled = !1))
        }
        static getCurSceneRgeName() {
            let t = v.getModule(this.curScene);
            if (t)
                return this.getModuleName(t)
        }
        static getCurViewRgeName() {
            let t = v.getModule(this.curScene.curView);
            if (t)
                return this.getModuleName(t)
        }
        static getCurDialogRegName() {
            let t = Laya.Dialog.manager,
            e = t.getChildAt(t.numChildren - 1);
            if (e)
                return this.getModuleName(v.getModule(e))
        }
        static getCurUIRegName(t = 1) {
            let e = this.uiStack[this.uiStack.length - t];
            if (e)
                return this.getModuleName(v.getModule(e))
        }
        static isInUIStack(t) {
            return -1 != this.uiStack.indexOf(t)
        }
    }
    J.uiStack = [],
    J.EF_FADE_OUT_BLACK = function (t, e, n, a, u) {
        a.visible = !1,
        z.shadeScreen("#000000", t, 1, Laya.Handler.create(this, () => {
                a.visible = !0,
                n && n(),
                u && u()
            }))
    },
    J.EF_FADE_OUT = function (t, e, n, a, u) {
        a.visible = !0,
        Laya.Tween.to(e, {
            alpha: 0
        }, t, null, Laya.Handler.create(this, () => {
                e.visible = !1,
                n && n(),
                u && u()
            })),
        e.alpha = 1,
        e.zOrder = 1
    },
    J.EF_FADE_INOUT = function (t, e, n, a, u) {
        e.alpha = 1,
        a.alpha = 0,
        Laya.Tween.to(e, {
            alpha: 0
        }, t, null),
        Laya.Tween.to(a, {
            alpha: 1
        }, t, null, Laya.Handler.create(this, () => {
                n && n(),
                u && u()
            }))
    },
    J.EF_FADE_IN_OUT = function (t, e, n, a, u) {
        e.alpha = 1,
        a.alpha = 0,
        Laya.Tween.to(e, {
            alpha: 0
        }, .5 * t, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(a, {
                    alpha: 1
                }, .5 * t, null, Laya.Handler.create(this, () => {
                        n && n(),
                        u && u()
                    }))
            }))
    },
    J.EF_QSCALE_IN = function (t, e, n, a) {
        v.resetAnchor(n, .5, .5),
        Laya.Tween.from(n, {
            scaleX: 0,
            scaleY: 0
        }, 300, Laya.Ease.backOut, Laya.Handler.create(this, () => {
                e && e(),
                a && a()
            }))
    },
    J.EF_QSCALE_FADE_IN = function (t, e, n, a) {
        n.alpha = 0,
        v.resetAnchor(n, .5, .5),
        Laya.Tween.from(n, {
            scaleX: 0,
            scaleY: 0
        }, 300, Laya.Ease.backOut, Laya.Handler.create(this, () => {
                e && e(),
                a && a()
            })),
        Laya.Tween.to(n, {
            alpha: 1
        }, 400, null, null)
    },
    J.EF_QSCALE_OUT = function (t, e, n, a) {
        Laya.Tween.to(t, {
            scaleX: 0,
            scaleY: 0
        }, 300, Laya.Ease.strongOut, Laya.Handler.create(t, () => {
                e && e(),
                a && a()
            }, [t]))
    },
    J.EF_PANEL = function (t, e, n, a, u) {
        a.alpha = 0,
        J.openPanel(t, {
            from: "",
            userArgs: [a, Laya.Handler.create(this, () => {
                    n && n(),
                    u && u()
                })]
        })
    },
    Laya.ClassUtils.regClass("SceneManager", J),
    function (t) {
        let e,
        n,
        a,
        u,
        g;
        !function (t) {
            t.PC = "pc",
            t.WEIXIN = "wx",
            t.BAIDU = "swan",
            t.VIVO = "vivo",
            t.TT = "toutiao",
            t.MEIZU = "meizu",
            t.OPPO = "oppo",
            t.XIAOMI = "xiaomi",
            t.TAPTAP = "taptap",
            t.QQ = "qq",
            t.QTT = "qtt",
            t.FTNN = "4399",
            t.FTNNBOX = "4399box",
            t.NATIVE_ANDROID = "native_android",
            t.NATIVE_IOS = "native_ios",
            t.KUAISHOU = "kuaishou",
            t.HUAWEI = "huawei",
            t.UC = "uc",
            t.NATIVE_233 = "native_233",
            t.TTFF = "2345",
            t.CHUANYIN = "chuanyin"
        }
        (e = t.PlatformType || (t.PlatformType = {})),
        function (t) {
            t.BI = "BIStat",
            t.QQ = "QQStat",
            t.TAPTAP = "TapTapStat",
            t.WEIXIN = "WXStat",
            t.NATIVE_ANDROID = "nativeAndroidStat",
            t.NATIVE_IOS = "nativeIosStat",
            t.TT = "toutiaoStat",
            t.TTFF = "2345Stat",
            t.CHUANYIN = "chuanyinStat"
        }
        (n = t.StatisticsType || (t.StatisticsType = {}));
        t.ShareInfoCfgEntity = class {
            constructor() {
                this.image = void 0,
                this.title = void 0
            }
        };
        t.ServerJsonCfg = class {},
        function (t) {
            t[t.SHARE_SUCCESS = 0] = "SHARE_SUCCESS"
        }
        (a = t.DataStubType || (t.DataStubType = {})),
        function (t) {
            t[t.UNACTIVATE = 0] = "UNACTIVATE",
            t[t.ACTIVATE = 1] = "ACTIVATE",
            t[t.GET = 2] = "GET"
        }
        (u = t.GET_STATE || (t.GET_STATE = {})),
        function (t) {
            t[t.Male = 0] = "Male",
            t[t.Female = 1] = "Female"
        }
        (g = t.Gender || (t.Gender = {}));
        t.UserInfoEntity = class {
            constructor() {
                this.userId = void 0,
                this.name = void 0,
                this.headUrl = void 0,
                this.sex = void 0,
                this.city = void 0,
                this.province = void 0,
                this.country = void 0,
                this.language = void 0
            }
        };
        t.UserConfigEntity = class {};
        t.ShareQueryParam = class {
            constructor() {
                this.shareUserId = void 0,
                this.shareType = void 0
            }
        };
        t.ShareInfoEntity = class {
            constructor() {
                this.name = void 0,
                this.headUrl = void 0,
                this.userId = void 0,
                this.state = void 0
            }
        };
        t.ShareStatisticEntity = class {
            constructor() {
                this.count = void 0,
                this.helpOtherCnt = void 0
            }
        };
        t.MailEntity = class {
            constructor() {
                this.id = void 0,
                this.content = void 0,
                this.rewards = void 0,
                this.createdAt = void 0
            }
        };
        t.CommonRst = class {
            constructor() {
                this.msg = ""
            }
        };
        t.CommonRsp = class {
            constructor() {
                this.result = !0
            }
        };
        t.DataStubRst = class {};
        t.LoginEntityRst = class {};
        t.LoginEntityRsp = class {};
        t.ShareInfoRst = class {};
        t.ShareInfoRsp = class {};
        t.ShareClearRst = class {};
        t.ShareQueryRst = class {};
        t.ShareQueryRsp = class {};
        t.GiftStateUpdateRst = class {};
        t.MailSendRst = class {};
        t.MailInfoRsp = class {};
        t.MailOpenRst = class {};
        t.MailOpenRsp = class {};
        t.CustomServiceCheckRst = class {};
        t.CustomServiceRecvMsgRst = class {};
        t.CustomServiceSendMsgRst = class {};
        t.SubscribeMsgRst = class {};
        t.CustomServiceQueryRst = class {};
        t.CustomServiceQueryRsp = class {};
        t.RankScoreRst = class {};
        t.RankInfoRst = class {};
        t.RankInfoRsp = class {};
        t.IpQueryRst = class {};
        t.IpQueryRsp = class {};
        t.StatStageRst = class {};
        t.StatEventRst = class {};
        t.SaveDataRst = class {};
        t.VoteRst = class {};
        t.VoteRankRst = class {};
        t.VoteItem = class {};
        t.VoteRankRsp = class {};
        t.AccessTokenRst = class {};
        t.AccessTokenRsp = class {};
        t.IdInfoPkg = class {};
        t.IdentityRst = class {}
    }
    (t.SDKEntity || (t.SDKEntity = {}));
    class $ extends t.SDKEntity.UserInfoEntity {
        constructor(t = !0) {
            super(),
            this.firstloginTimestamp = void 0,
            this.logindays = void 0,
            this.redBag = void 0,
            this.redBagCnt = void 0,
            this.noticeVer = void 0,
            t && v.warpObjectGetterSetter(this, this.dirty)
        }
        dirty(t) {
            Z.instance.save(t, this[t])
        }
    }
    class Z extends C {
        constructor() {
            super(),
            this.readySaveProps = []
        }
        static get instance() {
            return this._instance || (this._instance = new Z),
            this._instance
        }
        onInit(t) {
            let loadData = t => {
                for (const e in t)
                    if (t.hasOwnProperty(e)) {
                        let n = this.unserialize(e);
                        null != n && "" !== n && (t[e] = n)
                    }
                t.openId = this.unserialize("openId")
            };
            if (t) {
                let e = new t;
                loadData(e);
                for (const t in this.mine)
                    if (this.mine.hasOwnProperty(t)) {
                        let n = this.mine[t];
                        null != n && "" !== n && (e[t] = n)
                    }
                this.mine = e
            } else
                this.mine = new $, loadData(this.mine), this.initData()
        }
        initData() {
            if (void 0 === this.mine.firstloginTimestamp ? (this.mine.firstloginTimestamp = v.getTime(), this.firstLogin = !0) : this.firstLogin = !1, void 0 === this.mine.logindays)
                this.mine.logindays = 1, this.newDay = !0;
            else {
                let t = v.getDayInYear(new Date(this.mine.firstloginTimestamp)),
                e = v.getDayInYear() - t + 1;
                e > this.mine.logindays ? (this.mine.logindays = e, this.newDay = !0) : this.newDay = !1
            }
            void 0 === this.mine.redBag && (this.mine.redBag = 0, this.mine.redBagCnt = 0)
        }
        getMine() {
            return this.mine
        }
        getMineTrimmed() {
            let t = {},
            e = this.mine;
            for (const n in e)
                if (e.hasOwnProperty(n) && "_" == n[0]) {
                    let a = n.substring(1);
                    if (a) {
                        let u = e[n];
                        null != u && "" !== u && (t[a] = u)
                    }
                }
            return t
        }
        getUserInfo() {
            return this.mine
        }
        update(t) {
            let e = t;
            e.savedTimestamp ? (this.isFirstLogin() || this.mine.openId != e.openId) && (this.mine = new $, v.assign(this.mine, e, !1), this.initData(), e.openId && this.serialize("openId", e.openId)) : v.assign(this.mine, e, !1)
        }
        save(t, e) {
            t && this.event(f.E_PROP_CHANGED, [t, e]),
            this.readySaveProps.push(t),
            1 == this.readySaveProps.length && Laya.CallLater.I.callLater(this, this._save)
        }
        _save() {
            this.saveToLocal(),
            this.saveToServer(),
            this.readySaveProps.clear()
        }
        saveToLocal() {
            let t = this.mine,
            e = this.readySaveProps;
            if (e && e.length > 0)
                for (const n of e) {
                    let e = "_" + n;
                    if (t.hasOwnProperty(e)) {
                        const n = t[e];
                        this.serialize(e, n)
                    }
                }
        }
        saveToServer() {
            let t = Laya.ClassUtils.getRegClass("Sdk");
            if (1 !== t.instance.isLoginServer())
                return;
            let e = this.getMineTrimmed();
            v.getLength(e) > 0 && t.instance.saveToServer(e)
        }
        serialize(t, e) {
            e instanceof Array ? Laya.LocalStorage.setItem(t, JSON.stringify(e)) : e instanceof Object ? Laya.LocalStorage.setJSON(t, e) : null != e ? Laya.LocalStorage.setItem(t, e) : Laya.LocalStorage.removeItem(t)
        }
        unserialize(t) {
            let e = Laya.LocalStorage.getItem(t);
            if (e)
                try {
                    e = JSON.parse(e)
                } catch (n) {
                    console.log("unserialize error: ", t, e)
                }
            return e
        }
        isNewDay() {
            return this.newDay
        }
        isFirstLogin() {
            return this.firstLogin
        }
        addRedBag(t) {
            this.mine.redBag += t,
            this.mine.redBag = Number(this.mine.redBag.toFixed(2)),
            this.mine.redBagCnt++
        }
        isNewNotice(t) {
            return !!Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfgNoticeHtmlText() && (!!t && (!this.mine.noticeVer || !fx.Utils.compatibleVersion(t, this.mine.noticeVer)))
        }
        readNotice(t) {
            this.isNewNotice(t) && (this.mine.noticeVer = t)
        }
    }
    var et = t.SDKEntity.PlatformType;
    class it {}
    class st {}
    var nt,
    at,
    ot,
    rt,
    lt,
    ht,
    dt,
    ct,
    ut,
    gt,
    pt,
    ft;
    st.E_SDK_LOGIN = "$SDK_LOGIN",
    st.E_SDK_LOGOUT = "$SDK_LOGOUT",
    st.E_SDK_INIT_OK = "$SDK_INIT_OK",
    st.E_SERVER_CFG_UPDATE = "$SERVER_CFG_UPDATE",
    st.E_GET_SHARE_INFO = "$GET_SHARE_INFO",
    st.E_GET_SHARE_CONFIG = "$GET_SHARE_CONFIG",
    st.E_SHARE_RESULT = "$SHARE_RESULT",
    st.E_SHARE_QUERY_INFO = "$SHARE_QUERY_INFO",
    st.E_USER_INFO = "$USER_INFO",
    st.E_FEEDBACK_CLICK = "$FEEDBACK_CLICK",
    st.E_AD_VIDEO = "$AD_VIDEO",
    st.E_AD_BANNER = "$AD_BANNER",
    st.E_AD_INTERSTITIAL = "$AD_INTERSTITIAL",
    st.E_AD_NATIVE = "$AD_NATIVE",
    st.E_AD_NATIVE_CUSTOM = "$D_NATIVE_CUSTOM",
    st.E_AD_APPBOX = "$AD_APPBOX",
    st.E_AD_BLOCK = "$AD_BLOCK",
    st.E_FAVORITE_REWARD = "$FAVORITE_REWARD",
    st.E_RECORD_VIDEO_START = "$RECORD_VIDEO_START",
    st.E_RECORD_VIDEO_END = "$RECORD_VIDEO_END",
    st.E_RECORD_VIDEO_PAUSE = "$RECORD_VIDEO_PAUSE",
    st.E_RECORD_VIDEO_RESUME = "$RECORD_VIDEO_RESUME",
    st.E_SERVER_JSON_CONFIG = "$SERVER_JSON_CFG",
    st.E_REWARD_GAIN = "$REWARD_GAIN",
    (nt = t.SdkCode || (t.SdkCode = {}))[nt.WX_LOGIN_SUCCESS = 0] = "WX_LOGIN_SUCCESS",
    nt[nt.WX_LOGIN_FAILED = 1] = "WX_LOGIN_FAILED",
    nt[nt.WX_AUTH_SUCCESS = 2] = "WX_AUTH_SUCCESS",
    nt[nt.WX_AUTH_FAILED = 3] = "WX_AUTH_FAILED",
    nt[nt.SERVER_LOGIN_SUCCESS = 4] = "SERVER_LOGIN_SUCCESS",
    nt[nt.SERVER_LOGIN_FAILED = 5] = "SERVER_LOGIN_FAILED",
    nt[nt.SERVER_LOGIN_ERROR = 6] = "SERVER_LOGIN_ERROR",
    nt[nt.SHARE_SUCCESS = 7] = "SHARE_SUCCESS",
    nt[nt.SHARE_FAILED = 8] = "SHARE_FAILED",
    nt[nt.SHARE_INFO_SUCCESS = 9] = "SHARE_INFO_SUCCESS",
    nt[nt.AD_VIDEO_SUCCESS = 10] = "AD_VIDEO_SUCCESS",
    nt[nt.AD_VIDEO_UNCOMPLETE = 11] = "AD_VIDEO_UNCOMPLETE",
    nt[nt.AD_VIDEO_LOAD_FAIL = 12] = "AD_VIDEO_LOAD_FAIL",
    nt[nt.AD_VIDEO_LOAD_SUCCESS = 13] = "AD_VIDEO_LOAD_SUCCESS",
    nt[nt.AD_INTERSTITIAL_SUCCESS = 14] = "AD_INTERSTITIAL_SUCCESS",
    nt[nt.AD_INTERSTITIAL_FAIL = 15] = "AD_INTERSTITIAL_FAIL",
    nt[nt.AD_INTERSTITIAL_CLOSE = 16] = "AD_INTERSTITIAL_CLOSE",
    nt[nt.AD_NATIVE_SUCCESS = 17] = "AD_NATIVE_SUCCESS",
    nt[nt.AD_NATIVE_FAIL = 18] = "AD_NATIVE_FAIL",
    nt[nt.AD_NATIVE_DATA = 19] = "AD_NATIVE_DATA",
    nt[nt.AD_NATIVE_CUSTOM_SUCCESS = 20] = "AD_NATIVE_CUSTOM_SUCCESS",
    nt[nt.AD_NATIVE_CUSTOM_FAIL = 21] = "AD_NATIVE_CUSTOM_FAIL",
    nt[nt.AD_NATIVE_CUSTOM_CLOSE = 22] = "AD_NATIVE_CUSTOM_CLOSE",
    nt[nt.AD_APPBOX_SUCCESS = 23] = "AD_APPBOX_SUCCESS",
    nt[nt.AD_APPBOX_FAIL = 24] = "AD_APPBOX_FAIL",
    nt[nt.AD_APPBOX_CLOSE = 25] = "AD_APPBOX_CLOSE",
    nt[nt.AD_BLOCK_SUCCESS = 26] = "AD_BLOCK_SUCCESS",
    nt[nt.AD_BLOCK_FAIL = 27] = "AD_BLOCK_FAIL",
    nt[nt.AD_BANNER_SUCCESS = 28] = "AD_BANNER_SUCCESS",
    nt[nt.AD_BANNER_FAIL = 29] = "AD_BANNER_FAIL",
    nt[nt.REWARD_GAIN_SUCCESS = 30] = "REWARD_GAIN_SUCCESS",
    nt[nt.REWARD_GAIN_FAIL = 31] = "REWARD_GAIN_FAIL",
    nt[nt.AD_BANNER_RESIZE = 32] = "AD_BANNER_RESIZE",
    nt[nt.OPEN_CUSTOMER_SUCCESS = 33] = "OPEN_CUSTOMER_SUCCESS",
    nt[nt.OPEN_CUSTOMER_FAILED = 34] = "OPEN_CUSTOMER_FAILED",
    nt[nt.OPEN_CUSTOMER_COMPLETE = 35] = "OPEN_CUSTOMER_COMPLETE",
    nt[nt.SEND_CUSTOMER_SUCCESS = 36] = "SEND_CUSTOMER_SUCCESS",
    nt[nt.SEND_CUSTOMER_FAILED = 37] = "SEND_CUSTOMER_FAILED",
    nt[nt.EC_STAT_STAGE_ERR = 38] = "EC_STAT_STAGE_ERR",
    nt[nt.EC_STAT_EVENT_ERR = 39] = "EC_STAT_EVENT_ERR",
    (at = t.WSErrorCode || (t.WSErrorCode = {}))[at.EC_NET_UNKNOWN_ERR = 3e3] = "EC_NET_UNKNOWN_ERR",
    at[at.EC_NET_TIMEOUT = 3001] = "EC_NET_TIMEOUT",
    at[at.EC_NET_RECONNECT = 3002] = "EC_NET_RECONNECT",
    at[at.EC_NET_CLOSED = 3003] = "EC_NET_CLOSED",
    at[at.EC_NET_SEND_ERR = 3004] = "EC_NET_SEND_ERR",
    at[at.EC_NET_RECEIV_ERR = 3005] = "EC_NET_RECEIV_ERR",
    (ot = t.SdkErrorCode || (t.SdkErrorCode = {}))[ot.SUCCESS = 0] = "SUCCESS",
    ot[ot.EC_TOKEN_EXPIRED_ERR = 1] = "EC_TOKEN_EXPIRED_ERR",
    ot[ot.EC_CUSTOM_SERVICE_ERR = 2] = "EC_CUSTOM_SERVICE_ERR",
    ot[ot.EC_PROFILE_AUTH_ERR = 3] = "EC_PROFILE_AUTH_ERR",
    ot[ot.EC_QUERY_PARAM_EXCEPTION = 4] = "EC_QUERY_PARAM_EXCEPTION",
    ot[ot.EC_VERIFY_CODE_ERR = 5] = "EC_VERIFY_CODE_ERR",
    ot[ot.EC_CREATE_USER_ERR = 6] = "EC_CREATE_USER_ERR",
    ot[ot.EC_SHAREINFO_CLEAR_ERR = 7] = "EC_SHAREINFO_CLEAR_ERR",
    ot[ot.EC_SHAREQUERY_ERR = 8] = "EC_SHAREQUERY_ERR",
    ot[ot.EC_SHARECONFIG_ERR = 9] = "EC_SHARECONFIG_ERR",
    ot[ot.EC_GIFT_STATE_ERR = 10] = "EC_GIFT_STATE_ERR",
    ot[ot.EC_MAIL_INFO_ERR = 11] = "EC_MAIL_INFO_ERR",
    ot[ot.EC_MAIL_SEND_ERR = 12] = "EC_MAIL_SEND_ERR",
    ot[ot.EC_MAIL_OPEN_ERR = 13] = "EC_MAIL_OPEN_ERR",
    ot[ot.EC_FAVORITE_REWARD_ERR = 14] = "EC_FAVORITE_REWARD_ERR",
    ot[ot.EC_RANK_SCORE_ERR = 15] = "EC_RANK_SCORE_ERR",
    ot[ot.EC_RANK_INFO_ERR = 16] = "EC_RANK_INFO_ERR",
    ot[ot.EC_IP_QUERY_ERR = 17] = "EC_IP_QUERY_ERR",
    ot[ot.EC_STAT_STAGE_ERR = 18] = "EC_STAT_STAGE_ERR",
    ot[ot.EC_STAT_EVENT_ERR = 19] = "EC_STAT_EVENT_ERR",
    ot[ot.EC_ACCESS_TOKEN_ERR = 20] = "EC_ACCESS_TOKEN_ERR",
    ot[ot.EC_IDENTITY_ERR = 21] = "EC_IDENTITY_ERR",
    (rt = t.GetRewardSDKWay || (t.GetRewardSDKWay = {})).NORMAL = "normal",
    rt.AUTO = "auto",
    rt.SHARE = "share",
    rt.VIDEO = "video",
    rt.INSERT = "insert",
    (lt = t.VideoState || (t.VideoState = {}))[lt.UNLOAD = 0] = "UNLOAD",
    lt[lt.ENABLED = 1] = "ENABLED",
    lt[lt.UNENABLED = 2] = "UNENABLED",
    lt[lt.SHOW_START = 3] = "SHOW_START",
    lt[lt.SHOW_SUCCESS = 4] = "SHOW_SUCCESS",
    lt[lt.SHOW_FAIL = 5] = "SHOW_FAIL",
    (ht = t.AdState || (t.AdState = {}))[ht.LOADING = 1] = "LOADING",
    ht[ht.LOAD = 2] = "LOAD",
    ht[ht.LOAD_FAIL = 3] = "LOAD_FAIL",
    ht[ht.DELETING = 4] = "DELETING",
    (dt = t.RequestState || (t.RequestState = {}))[dt.REQUEST = 1] = "REQUEST",
    dt[dt.SUCCESS = 2] = "SUCCESS",
    dt[dt.FAIL = 3] = "FAIL",
    (ct = t.BlackAndWhite || (t.BlackAndWhite = {})).Black = "black",
    ct.White = "white",
    ct.White_ = "white_",
    (ut = t.FollowedState || (t.FollowedState = {}))[ut.NotGot = 1] = "NotGot",
    ut[ut.Followed = 2] = "Followed",
    ut[ut.Unfollowed = 3] = "Unfollowed",
    ut[ut.NotSupport = 4] = "NotSupport",
    (gt = t.AddDeskState || (t.AddDeskState = {}))[gt.NotGot = 1] = "NotGot",
    gt[gt.Add = 2] = "Add",
    gt[gt.NotAdd = 3] = "NotAdd",
    gt[gt.FailAdd = 4] = "FailAdd",
    (pt = t.NativeAdType || (t.NativeAdType = {}))[pt.ICON = 1] = "ICON",
    pt[pt.BANNER = 2] = "BANNER",
    pt[pt.NATIVE = 3] = "NATIVE",
    (ft = t.GameBoxType || (t.GameBoxType = {}))[ft.BannerAd_Old = 1] = "BannerAd_Old",
    ft[ft.BannerAd_New = 2] = "BannerAd_New",
    ft[ft.PortalAd = 3] = "PortalAd",
    ft[ft.DrawerAd = 4] = "DrawerAd";
    class mt {
        constructor(t) {
            this.source = t.source || "未知",
            t.bindCtrlGId && (this.bindCtrlGId = t.bindCtrlGId),
            t.id && (this.id = t.id),
            t.queryParam && (this.queryParam = t.queryParam),
            t.title && (this.title = t.title),
            t.imgUrl && (this.imgUrl = t.imgUrl),
            t.type && (this.type = t.type),
            t.templateId && (this.templateId = t.templateId),
            t.forever && (this.forever = t.forever)
        }
    }
    const yt = {
        LOGIN: "/login",
        LOGINNOAUTU: "/login/noauth",
        CUSTOMSERVICE_CHECK: "/customservice/msg/:appId",
        CUSTOMSERVICE_MSG: "/customservice/msg/:appId",
        CUSTOMSERVICE_QUERY: "/customservice/query",
        DATASTUB: "/datastub",
        PROFILE: "/profile",
        SHAREINFO: "/share/info",
        SHAREQUERY: "/share/query",
        SHARECLEAR: "/share/clear",
        GIFTSTATE: "/giftstate",
        FAVORITEREWARD: "/favoriteReward",
        MAILINFO: "/mail/info",
        MAILSEND: "/gm/sendmail",
        MAILOPEN: "/mail/open",
        RANKSCORE: "/rank/score",
        RANKINFO: "/rank/info",
        IPQUERY: "/ip/query",
        IPQUERY_EX: "/ip/queryex",
        IDENTITY: "/id/query",
        STATSTAGE: "/statistics/stage",
        STATEVENT: "/statistics/event",
        SAVEDATA: "/save",
        VOTE: "/vote",
        VOTERANK: "/voterank",
        ACCESSTOKEN: "/access/token"
    };
    class St {
        static init(t, e, n) {
            let a = this;
            if (t = t || "", a.prototype.url = t, e = e || "POST", a.prototype.method = e, a.prototype.encrypt = !0, null != n && (a.prototype.encrypt = n), !t)
                throw Error("url is unexpected !!!");
            let u = this.getKey(e, t);
            if (St.MSG_DEFINES[u])
                throw Error("duplicate msg register !!!");
            St.MSG_DEFINES[u] = a
        }
        static getKey(t, e) {
            return t + ":" + e
        }
        static getDefinedMsg(t, e) {
            let n = this.getKey(t, e),
            a = this.MSG_DEFINES[n];
            if (a)
                return new a
        }
    }
    St.MSG_DEFINES = {};
    class _t extends St {}
    _t.sInit = void _t.init(yt.DATASTUB);
    class At extends St {}
    At.sInit = void At.init(yt.LOGIN);
    class It extends St {}
    It.sInit = void It.init(yt.LOGINNOAUTU);
    class vt extends St {}
    vt.sInit = void vt.init(yt.PROFILE);
    class wt extends St {}
    wt.sInit = void wt.init(yt.SHAREINFO, "GET");
    class Lt extends St {}
    Lt.sInit = void Lt.init(yt.SHAREQUERY);
    class Et extends St {}
    Et.sInit = void Et.init(yt.SHARECLEAR);
    class xt extends St {}
    xt.sInit = void xt.init(yt.GIFTSTATE);
    class Ct extends St {}
    Ct.sInit = void Ct.init(yt.FAVORITEREWARD);
    class bt extends St {}
    bt.sInit = void bt.init(yt.MAILSEND);
    class Nt extends St {}
    Nt.sInit = void Nt.init(yt.MAILINFO, "GET");
    class Dt extends St {}
    Dt.sInit = void Dt.init(yt.MAILOPEN);
    class Mt extends St {}
    Mt.sInit = void Mt.init(yt.CUSTOMSERVICE_CHECK, "GET", !1);
    class Rt extends St {}
    Rt.sInit = void Rt.init(yt.CUSTOMSERVICE_MSG, "POST", !1);
    class kt extends St {}
    kt.sInit = void kt.init(yt.CUSTOMSERVICE_QUERY, "GET");
    class Tt extends St {}
    Tt.sInit = void Tt.init(yt.RANKSCORE, "POST");
    class Ot extends St {}
    Ot.sInit = void Ot.init(yt.RANKINFO, "GET");
    class Bt extends St {}
    Bt.sInit = void Bt.init(yt.IPQUERY, "GET");
    class Pt extends St {}
    Pt.sInit = void Pt.init(yt.IPQUERY_EX, "GET", !1);
    class Vt extends St {}
    Vt.sInit = void Vt.init(yt.STATSTAGE);
    class Ut extends St {}
    Ut.sInit = void Ut.init(yt.STATEVENT);
    class zt extends St {}
    zt.sInit = void zt.init(yt.SAVEDATA);
    class Ft extends St {}
    Ft.sInit = void Ft.init(yt.ACCESSTOKEN, "GET");
    class Gt extends St {}
    Gt.sInit = void Gt.init(yt.IDENTITY);
    class Wt {
        static get Instance() {
            return Wt.instance || (Wt.instance = new Wt),
            Wt.instance
        }
        init() {
            window.SDkCallBack = function (t) {
                console.log("SDkCallBack:" + t),
                "1" == t ? Wt.watchRewardVideoFunc(fx.SdkCode.AD_VIDEO_SUCCESS) : Wt.watchRewardVideoFunc(fx.SdkCode.AD_VIDEO_LOAD_FAIL)
            },
            window.JSIOSBridge = Wt
        }
        setOnShowCallBack(t) {
            this.onShowCallBack = t
        }
        setOnHideCallBack(t) {
            this.onHideCallBack = t
        }
        showBanner() {
            window.SDKUtils.openAd && window.SDKUtils.openAd(JSON.stringify({
                    id: 5,
                    open: 1
                }))
        }
        closeBanner() {
            window.SDKUtils.openAd && window.SDKUtils.openAd(JSON.stringify({
                    id: 5,
                    open: 0
                }))
        }
        showFullScreenVideo(t) {
            t ? window.SDKUtils.openAd && window.SDKUtils.openAd(JSON.stringify({
                    id: 3,
                    open: 1
                })) : window.SDKUtils.openAd && window.SDKUtils.openAd(JSON.stringify({
                    id: 6,
                    open: 1
                }))
        }
        showInterstitialAd() {
            window.SDKUtils.openAd && window.SDKUtils.openAd(JSON.stringify({
                    id: 7,
                    open: 1
                }))
        }
        showRewardVideo() {
            window.SDKUtils.openAd && window.SDKUtils.openAd(JSON.stringify({
                    id: 4,
                    open: 1
                }))
        }
        static watchRewardVideoFunc(e) {
            e === fx.SdkCode.AD_VIDEO_SUCCESS ? (console.log("[JSIOSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>watchRewardVideoSuccess!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_SUCCESS
                })) : (console.log("[JSIOSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>watchRewardVideoFail!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                }))
        }
        showNativeAd(t) {
            window.SDKUtils.openAd && window.SDKUtils.openAd(JSON.stringify({
                    id: 10,
                    open: t
                }))
        }
        jumpLeisureSubject() {
            window.SDKUtils.openAd && window.SDKUtils.openAd(JSON.stringify({
                    id: 105,
                    open: 1
                }))
        }
        openAntiAddiction(t) {}
        startLeve(t) {
            window.SDKUtils.LevelUp && window.SDKUtils.LevelUp(t + "")
        }
        finishLevel(t) {}
        failLevel(t) {}
        skinUnlock(t) {}
        customEvent(t, e) {}
        vibrateShort() {}
        jumpMarketToApp() {}
        static getIsAudit() {}
        static getIsHarvest() {}
        static onShow() {
            let t = Wt.Instance.onShowCallBack;
            t ? t() : console.warn("[JSIOSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>no onShowCallBack!!!")
        }
        static onHide() {
            let t = Wt.Instance.onHideCallBack;
            t ? t() : console.warn("[JSIOSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>no onHideCallBack!!!")
        }
    }
    class Ht {
        constructor() {
            this.platformClass = window.PlatformClass,
            this.platformClass ? (fx.Utils.isOnNativeIos() ? (this.bridge = !0, Wt.Instance.init()) : fx.Utils.isOnNativeAndroid() && (this.bridge = this.platformClass.createClass("demo.JSBridge"), this.bridge.callWithBack(Ht.watchRewardVideoFunc, "watchRewardVideoFunc", null), this.bridge.callWithBack(Ht.onShow, "onShow", null), this.bridge.callWithBack(Ht.onHide, "onHide", null), this.bridge.callWithBack(Ht.onLoginCallBack, "onLoginCallBack", null)), this.haveBridge() && (window.JSBridge = Ht)) : console.warn("[JSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>no PlatformClass!!!")
        }
        static get Instance() {
            return Ht.instance || (Ht.instance = new Ht),
            Ht.instance
        }
        haveBridge() {
            let t = !1;
            return this.bridge ? t = !0 : console.warn("[JSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>no JSBridge!!!"),
            t
        }
        setOnShowCallBack(t) {
            fx.Utils.isOnNativeIos() ? Wt.Instance.setOnShowCallBack(t) : fx.Utils.isOnNativeAndroid() && (this.onShowCallBack = t)
        }
        setOnHideCallBack(t) {
            fx.Utils.isOnNativeIos() ? Wt.Instance.setOnHideCallBack(t) : fx.Utils.isOnNativeAndroid() && (this.onHideCallBack = t)
        }
        login(t) {
            fx.Utils.isOnNativeAndroid() && (this.loginCallBack = t, this.bridge.call("login"))
        }
        static onLoginCallBack(t) {
            let e = Ht.Instance.loginCallBack;
            e ? e(JSON.parse(t)) : console.warn("[JSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>no onLoginCallBack!!!")
        }
        showBanner() {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.showBanner() : fx.Utils.isOnNativeAndroid() && this.bridge.call("showBanner"))
        }
        closeBanner() {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.closeBanner() : fx.Utils.isOnNativeAndroid() && this.bridge.call("closeBanner"))
        }
        showFullScreenVideo(t) {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.showFullScreenVideo(t) : fx.Utils.isOnNativeAndroid() && this.bridge.call("showFullScreenVideo", t))
        }
        showInterstitialAd() {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.showInterstitialAd() : fx.Utils.isOnNativeAndroid() && this.bridge.call("showInterstitialAd"))
        }
        preloadVideo() {
            this.haveBridge() && (fx.Utils.isOnNativeIos() || fx.Utils.isOnNativeAndroid() && this.bridge.call("preloadVideo"))
        }
        showRewardVideo() {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.showRewardVideo() : fx.Utils.isOnNativeAndroid() && this.bridge.call("showRewardVideo"))
        }
        static watchRewardVideoFunc(e) {
            e === t.SdkCode.AD_VIDEO_SUCCESS ? (console.log("[JSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>watchRewardVideoSuccess!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_SUCCESS
                })) : (console.log("[JSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>watchRewardVideoFail!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                }))
        }
        showNativeAd(e) {
            if (this.haveBridge())
                if (fx.Utils.isOnNativeIos())
                    Wt.Instance.showNativeAd(e);
                else if (fx.Utils.isOnNativeAndroid()) {
                    let n = 1;
                    e == t.NativeAdType.BANNER ? n = 2 : e == t.NativeAdType.NATIVE && (n = 3),
                    this.bridge.call("showNativeAd", n)
                }
        }
        destoryNativeAd(e) {
            if (this.haveBridge())
                if (fx.Utils.isOnNativeIos());
                else if (fx.Utils.isOnNativeAndroid()) {
                    let n = 1;
                    e == t.NativeAdType.BANNER ? n = 2 : e == t.NativeAdType.NATIVE && (n = 3),
                    this.bridge.call("hideNativeAd", n)
                }
        }
        jumpLeisureSubject() {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.jumpLeisureSubject() : fx.Utils.isOnNativeAndroid() && this.bridge.call("jumpLeisureSubject"))
        }
        openAntiAddiction(t) {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.openAntiAddiction(t) : fx.Utils.isOnNativeAndroid() && this.bridge.call("openAntiAddiction", t))
        }
        exitGame() {
            Ht.Instance.haveBridge() && (fx.Utils.isOnNativeIos() || fx.Utils.isOnNativeAndroid() && Ht.Instance.bridge.call("exitGame"))
        }
        clipboardData(t) {
            this.haveBridge() && (fx.Utils.isOnNativeIos() || fx.Utils.isOnNativeAndroid() && this.bridge.call("clipboardData", t))
        }
        getSystemInfo() {}
        startLeve(t) {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.startLeve(t) : fx.Utils.isOnNativeAndroid() && this.bridge.call("startLeve", t))
        }
        finishLevel(t) {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.finishLevel(t) : fx.Utils.isOnNativeAndroid() && this.bridge.call("finishLevel", t))
        }
        failLevel(t) {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.failLevel(t) : fx.Utils.isOnNativeAndroid() && this.bridge.call("failLevel", t))
        }
        customEvent(t, e) {
            if (this.haveBridge())
                if (fx.Utils.isOnNativeIos())
                    Wt.Instance.customEvent(t, e);
                else if (fx.Utils.isOnNativeAndroid()) {
                    let n = {
                        event: t,
                        param: e
                    };
                    this.bridge.call("customEvent", JSON.stringify(n))
                }
        }
        skinUnlock(t) {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.skinUnlock(t) : fx.Utils.isOnNativeAndroid() && this.bridge.call("skinUnlock", t))
        }
        vibrateShort() {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.vibrateShort() : fx.Utils.isOnNativeAndroid() && this.bridge.call("vibrateShort"))
        }
        jumpMarketToApp() {
            this.haveBridge() && (fx.Utils.isOnNativeIos() ? Wt.Instance.jumpMarketToApp() : fx.Utils.isOnNativeAndroid() && this.bridge.call("jumpMarketToApp"))
        }
        static getIsAudit() {
            if (!Ht.Instance.haveBridge())
                return;
            let t = Laya.ClassUtils.getRegClass("Sdk").instance.isAudit();
            fx.Utils.isOnNativeIos() ? Wt.getIsAudit() : fx.Utils.isOnNativeAndroid() && Ht.Instance.bridge.call("setIsAudit", t)
        }
        static getIsHarvest() {
            if (!Ht.Instance.haveBridge())
                return;
            let t = Laya.ClassUtils.getRegClass("Sdk").instance.isHarvest();
            fx.Utils.isOnNativeIos() ? Wt.getIsHarvest() : fx.Utils.isOnNativeAndroid() && Ht.Instance.bridge.call("setIsHarvest", t)
        }
        static onShow() {
            let t = Ht.Instance.onShowCallBack;
            t ? t() : console.warn("[JSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>no onShowCallBack!!!")
        }
        static onHide() {
            let t = Ht.Instance.onHideCallBack;
            t ? t() : console.warn("[JSBridge]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>no onHideCallBack!!!")
        }
    }
    class qt extends Laya.EventDispatcher {
        constructor(t) {
            super();
            let e = new Laya.HttpRequest;
            e.http.timeout = 1e4,
            e.once(Laya.Event.COMPLETE, this, this.completeHandler),
            e.once(Laya.Event.ERROR, this, this.errorHandler),
            e.on(Laya.Event.PROGRESS, this, this.processHandler),
            this.xhr = e,
            this.encrypt = t
        }
        send(t, e, n, a, u = "POST") {
            const g = window.pako;
            if (t) {
                this.once("HTTPRSP", a, n);
                let p = Laya.LocalStorage.getItem("AUTHTOKEN"),
                f = ["Content-Type", "application/x-www-form-urlencoded"];
                p && (f.push("authorization"), f.push(p));
                let m = JSON.stringify(e);
                if (console.log("http >>>>>>>>>>>>>>>>>>> url:" + t + " data:" + m), "GET" == u.toUpperCase()) {
                    let n;
                    for (let t in e) {
                        let a = e[t];
                        "object" == typeof a && (a = JSON.stringify(a)),
                        n = null == n ? t + "=" + encodeURIComponent(a) : n + "&" + t + "=" + encodeURIComponent(a)
                    }
                    this.xhr.send(t + "?" + n, null, u, "json", f)
                } else
                    f[1] = "application/json", m = this.encrypt ? g.deflate(encodeURIComponent(m), {
                        to: "string"
                    }) : encodeURIComponent(m), m = JSON.stringify({
                        data: m
                    }), this.xhr.send(t, m, u, "json", f)
            }
        }
        registerErrHandler(t, e) {
            this.once("HTTPERR", e, t)
        }
        processHandler(t) {}
        errorHandler(t) {
            console.log("http <<<<<<<<<<<<<<<<<<< error:" + JSON.stringify(t)),
            this.event("HTTPERR", t)
        }
        completeHandler(e) {
            const n = window.pako;
            let a = e.data;
            if (a) {
                this.encrypt && (a = n.inflate(a, {
                        to: "string"
                    })),
                a = decodeURIComponent(a),
                console.log("http <<<<<<<<<<<<<<<<<<< ok:" + a);
                try {
                    a = JSON.parse(a)
                } catch (e) {
                    return void this.event("HTTPERR", {
                        code: t.BaseCode.HTTP_INTERFACE_UNDEFINED
                    })
                }
                let e = this.xhr.http;
                if (e.getAllResponseHeaders()) {
                    const t = ["authorization", "Authorization"];
                    for (const n of t) {
                        let t = e.getResponseHeader(n);
                        if (t) {
                            Laya.LocalStorage.setItem("AUTHTOKEN", t);
                            break
                        }
                    }
                }
                this.event("HTTPRSP", a)
            } else
                console.log("http <<<<<<<<<<<<<<<<<<< ok: null")
        }
    }
    class Kt {
        static setBase64Chars(t) {
            this.base64Chars = t
        }
        static init() {
            if (!this.lookup) {
                this.lookup = new Uint8Array(256);
                for (var t = 0; t < this.base64Chars.length; t++)
                    this.lookup[this.base64Chars.charCodeAt(t)] = t
            }
        }
        static encode(t) {
            for (var e = new Uint8Array(t), n = e.length, a = "", u = 0; u < n; u += 3)
                a += this.base64Chars[e[u] >> 2], a += this.base64Chars[(3 & e[u]) << 4 | e[u + 1] >> 4], a += this.base64Chars[(15 & e[u + 1]) << 2 | e[u + 2] >> 6], a += this.base64Chars[63 & e[u + 2]];
            return n % 3 == 2 ? a = a.substring(0, a.length - 1) + "=" : n % 3 == 1 && (a = a.substring(0, a.length - 2) + "=="),
            a
        }
        static encodeStr(t) {
            let e = new Laya.Byte;
            return e.writeUTFString(t),
            this.encodeByte(e)
        }
        static encodeStr2(t) {
            let e = new Laya.Byte;
            e.writeUTFBytes(t);
            for (var n = this.encodeByte(e); 0 <= n.indexOf("+"); )
                n = n.replace("+", "%2B");
            for (; 0 <= n.indexOf("&"); )
                n = n.replace("&", "%26");
            for (; 0 <= n.indexOf("="); )
                n = n.replace("=", "%3D");
            return n
        }
        static encodeByte(t, e = 0, n = -1) {
            return n = n < 0 ? t.length : n,
            this.encode(t.getUint8Array(e, n).buffer)
        }
        static decodeToByte(t) {
            let e = new Laya.Byte(this.decode(t));
            return e.pos = 0,
            e
        }
        static decode(t) {
            this.init();
            var e,
            n,
            a,
            u,
            g = .75 * t.length,
            p = t.length,
            f = 0;
            "=" === t[t.length - 1] && (g--, "=" === t[t.length - 2] && g--);
            let m = new ArrayBuffer(g),
            y = new Uint8Array(m);
            for (let g = 0; g < p; g += 4)
                e = this.lookup[t.charCodeAt(g)], n = this.lookup[t.charCodeAt(g + 1)], a = this.lookup[t.charCodeAt(g + 2)], u = this.lookup[t.charCodeAt(g + 3)], y[f++] = e << 2 | n >> 4, y[f++] = (15 & n) << 4 | a >> 2, y[f++] = (3 & a) << 6 | 63 & u;
            return m
        }
    }
    Kt.lookup = null,
    Kt.base64Chars = "SNPn2QBOR7A1ghiCj5klmY6opZqrEsDFdeG90HIJK8LMtuv3wxyzabTUVWXcf4+/";
    class Jt {}
    Jt.E_SERVER_LOGIN = "SERVER_LOGIN",
    Jt.E_SERVER_RELOGIN = "SERVER_RELOGIN",
    Jt.E_SHARE_INFO = "SHARE_INFO",
    Jt.E_SHARE_CONFIG = "SHARE_CONFIG",
    Jt.E_SHARE_QUERY_USERINFO = "SHARE_QUERY_USERINFO",
    Jt.E_PROFILE_RESULT = "PROFILE_RESULT",
    Jt.E_FAVORITE_REWARD_RESULT = "FAVORITE_REWARD_RESULT",
    Jt.E_MAIL_RESULT = "$MAIL_RESULT",
    Jt.E_MAIL_OPENED = "$MAIL_OPENED",
    Jt.E_RANK_RESULT = "$RANK_RESULT",
    Jt.E_IP_RESULT = "$IP_RESULT",
    Jt.E_ACCESS_TOKEN_RESULT = "$ACCESS_TOKEN_RESULT",
    Jt.E_IDENTIFICTAION_RESULT = "$IDENTIFICATION_RESULT";
    class Xt extends C {
        constructor() {
            super(),
            this.saveTimestamp = this.errCount = 0;
            let t = Laya.ClassUtils.getRegClass("Sdk");
            this.GameCfg = t.GameCfg
        }
        static get instance() {
            return this._instance || (this._instance = new Xt),
            this._instance
        }
        send(t, e, n, a) {
            if (!(a = a || this.GameCfg.server_url))
                return void console.log("send message skipped with server url is unknown !!!");
            if (!t.data)
                return void console.log("send message without data !!!" + typeof t);
            let u = new qt(t.encrypt),
            g = a + t.url;
            u.registerErrHandler(this.errorRsp.bind(this, n, t.url), this),
            u.send(g, t.data, this.response.bind(this, e, n), this, t.method)
        }
        response(e, n, a) {
            a.code == t.SdkErrorCode.SUCCESS ? e && e.call(this, a.data, a) : n && n.call(this, a)
        }
        errorRsp(e, n, a) {
            if ("string" != typeof a || -1 == a.indexOf("401"))
                if (e)
                    e.call(this, a);
                else {
                    if ("object" == typeof a && a.code == t.BaseCode.HTTP_INTERFACE_UNDEFINED)
                        return void console.warn(n + " 接口未定义！");
                    v.isOnMiniGame() && (this.errCount++, this.errCount > 3 && (this.errCount = 0, this.event(Jt.E_SERVER_LOGIN, {
                                code: t.SdkCode.SERVER_LOGIN_ERROR
                            })))
                }
            else
                n == yt.SAVEDATA ? this.event(Jt.E_SERVER_RELOGIN) : console.warn(n + " 接口未授权！")
        }
        login(e, n) {
            let a = new At,
            u = new t.SDKEntity.LoginEntityRst;
            u.code = e,
            u.appId = this.GameCfg.appId,
            u.version = this.GameCfg.version,
            u.shareQuery = n,
            u.userInfo = new t.SDKEntity.UserInfoEntity,
            u.userInfo.platform = this.GameCfg.platform;
            let g = Z.instance.getMine();
            u.userInfo.openId = g.openId,
            a.data = u,
            this.send(a, this.loginRsp, this.loginErr)
        }
        loginNoAuth() {
            let e = new It,
            n = new t.SDKEntity.LoginEntityRst;
            n.userInfo = new t.SDKEntity.UserInfoEntity,
            n.version = this.GameCfg.version,
            n.userInfo.platform = t.SDKEntity.PlatformType.PC,
            n.code = this.GameCfg.user_unique_id;
            let a = Z.instance.getMine();
            n.userInfo.headUrl = a.headUrl,
            n.userInfo.name = a.name,
            e.data = n,
            this.send(e, this.loginRsp, this.loginErr)
        }
        loginRsp(e) {
            if (console.log("服务器登录成功!"), e.lastTime && (e.lastTime = new Date(e.lastTime)), e.serverTime = new Date(e.serverTime), e.record) {
                let t = window.pako.inflate(e.record, {
                    to: "string"
                });
                t = JSON.parse(decodeURIComponent(t)),
                v.assign(e.userInfo, t, !1)
            }
            this.event(Jt.E_SERVER_LOGIN, {
                code: t.SdkCode.SERVER_LOGIN_SUCCESS,
                pkg: e
            })
        }
        loginErr(e) {
            e.msg && console.warn(e.msg),
            this.event(Jt.E_SERVER_LOGIN, {
                code: t.SdkCode.SERVER_LOGIN_FAILED
            })
        }
        postProfile(t) {
            let e = new vt;
            e.data = t,
            this.send(e, this.postProfileRsp)
        }
        postProfileRsp() {
            this.event(Jt.E_PROFILE_RESULT)
        }
        getShareInfo(e) {
            let n = new wt,
            a = new t.SDKEntity.ShareInfoRst;
            a.shareTypes = e,
            n.data = a,
            this.send(n, this.getShareInfoRsp)
        }
        getShareInfoRsp(t) {
            this.event(Jt.E_SHARE_INFO, t)
        }
        postShareQuery(e) {
            let n = new Lt,
            a = new t.SDKEntity.ShareQueryRst;
            a.param = e,
            n.data = a,
            this.send(n, this.postShareQueryRsp)
        }
        postShareQueryRsp(t) {
            t.fromUserInfo && this.event(Jt.E_SHARE_QUERY_USERINFO, t.fromUserInfo)
        }
        postGiftState(e, n, a) {
            let u = new xt,
            g = new t.SDKEntity.GiftStateUpdateRst;
            g.state = a,
            g.userId = e,
            g.type = n,
            u.data = g,
            this.send(u)
        }
        clearShareInfo(e) {
            let n = new Et,
            a = new t.SDKEntity.ShareClearRst;
            a.param = e,
            n.data = a,
            this.send(n)
        }
        postFavoriteReward() {
            let e = new Ct,
            n = new t.SDKEntity.CommonRst;
            e.data = n,
            this.send(e, this.postFavoriteRewardRsp)
        }
        postFavoriteRewardRsp(t) {
            this.event(Jt.E_FAVORITE_REWARD_RESULT)
        }
        dataStub(e, n) {
            let a = new _t,
            u = new t.SDKEntity.DataStubRst;
            u.type = e,
            u.args = n,
            a.data = u,
            this.send(a)
        }
        getMailInfo() {
            let e = new Nt;
            e.data = new t.SDKEntity.CommonRst,
            this.send(e, this.getMailInfoRsp)
        }
        getMailInfoRsp(t) {
            this.event(Jt.E_MAIL_RESULT, t)
        }
        openMail(e) {
            let n = new Dt,
            a = new t.SDKEntity.MailOpenRst;
            a.ids = e,
            n.data = a,
            this.send(n, this.openMailRsp)
        }
        openMailRsp(t) {
            this.event(Jt.E_MAIL_OPENED, t)
        }
        sendMail(e, n, a, u) {
            let g = new bt,
            p = new t.SDKEntity.MailSendRst;
            p.mail = u,
            p.userName = e,
            p.password = n,
            p.userId = a,
            g.data = p,
            this.send(g)
        }
        reportedRankScore(e) {
            let n = new Tt,
            a = new t.SDKEntity.RankScoreRst;
            a.score = e,
            n.data = a,
            this.send(n)
        }
        getRankInfo() {
            let e = new Ot,
            n = new t.SDKEntity.RankInfoRst;
            n.count = 50,
            n.page = 0,
            e.data = n,
            this.send(e, this.getRankInfoRsp)
        }
        getRankInfoRsp(t) {
            this.event(Jt.E_RANK_RESULT, t)
        }
        getIpQueryInfo() {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url_common;
            if (e) {
                let n = new Bt;
                n.data = new t.SDKEntity.IpQueryRst,
                this.send(n, this.getIpQueryInfoRsp, this.getIpQueryInfoRspFail, e)
            }
        }
        getIpQueryInfoRsp(t) {
            this.event(Jt.E_IP_RESULT, t)
        }
        getIpQueryInfoRspFail(t) {
            console.log(JSON.stringify(t))
        }
        postStageStat(e, n, a) {
            let u = new Vt,
            g = new t.SDKEntity.StatStageRst;
            g.stageId = e,
            g.stageState = n,
            g.stageResult = a,
            u.data = g,
            this.send(u)
        }
        postEventStat(e) {
            let n = new Ut,
            a = new t.SDKEntity.StatEventRst;
            a.eventName = e,
            n.data = a,
            this.send(n)
        }
        save(e) {
            let n = Laya.Browser.now(),
            a = this.GameCfg.saveDurSec;
            if (v.isNumber(a) && n - this.saveTimestamp > 1e3 * a) {
                let a = new zt,
                u = new t.SDKEntity.SaveDataRst;
                const g = window.pako;
                e.savedTimestamp = n;
                try {
                    u.record = g.deflate(encodeURIComponent(JSON.stringify(e)), {
                        to: "string"
                    })
                } catch (t) {
                    return void console.error("userData stringify error !!!\n" + t.message + t.stack)
                }
                a.data = u,
                this.send(a),
                this.saveTimestamp = n
            }
        }
        getAccessToken(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url_common;
            if (n && e) {
                let a = new Ft,
                u = new t.SDKEntity.AccessTokenRst;
                u.appId = e,
                a.data = u,
                this.send(a, this.getAccessTokenRsp, this.getAccessTokenRspFail, n)
            }
        }
        getAccessTokenRsp(t) {
            this.event(Jt.E_ACCESS_TOKEN_RESULT, t)
        }
        getAccessTokenRspFail(t) {
            console.log("获取凭证失败：", JSON.stringify(t))
        }
        identification(e, n) {
            let a = new t.SDKEntity.IdInfoPkg;
            a.identity = n,
            a.realName = e;
            let u = new Laya.Byte;
            u.writeUTFBytes(JSON.stringify(a));
            let g = new t.SDKEntity.IdentityRst;
            g.code = Kt.encodeByte(u);
            let p = new Gt;
            p.data = g;
            let f = Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url_common;
            f && this.send(p, this.identificationRsp, this.identificationErr, f)
        }
        identificationRsp(t, e) {
            this.event(Jt.E_IDENTIFICTAION_RESULT, e)
        }
        identificationErr(t) {
            console.log("认证失败：", JSON.stringify(t)),
            this.event(Jt.E_IDENTIFICTAION_RESULT, t)
        }
    }
    class jt {
        constructor() {}
        init(t) {}
        recordVideo(t) {}
        stopRecord(t) {}
        shareVideo(t) {
            return !1
        }
        canRecord() {
            return !1
        }
        canShareRecord() {
            return null
        }
        pauseRecord() {}
        resumeRecord() {}
        destroyRecord() {}
        setShare(t, e, n) {
            wx.showShareMenu({
                withShareTicket: !0
            }),
            n = n || "",
            wx.uma && wx.uma.onShareAppMessage ? wx.uma.onShareAppMessage(function () {
                return {
                    title: t,
                    imageUrl: e,
                    query: n
                }
            }
                .bind(this)) : wx.onShareAppMessage(function () {
                return {
                    title: t,
                    imageUrl: e,
                    query: n
                }
            }
                .bind(this))
        }
        share(t, e, n) {
            let a = null,
            u = null,
            g = null,
            p = null;
            t instanceof mt ? (a = t.title, u = t.imgUrl, g = t.queryParam, p = t.source) : (a = t, u = e, g = n, p = "未知");
            let m = "";
            if (g) {
                E.instance.once(f.E_APP_ON_RESUME, this, (function (t) {
                        v.showTips("感谢分享!!!")
                    }));
                for (let t in g) {
                    let e = g[t];
                    null != e && ("object" == typeof e && (e = JSON.stringify(e)), m = null == m ? t + "=" + e : m + "&" + t + "=" + e)
                }
            }
            if (console.log("wx share queryParam:" + JSON.stringify(g), m), wx.uma && wx.uma.shareAppMessage) {
                let t = {
                    title: a,
                    imageUrl: u,
                    query: m,
                    ald_desc: p
                };
                wx.uma.shareAppMessage(t),
                console.log("umaShareAppMessage: ", JSON.stringify(t))
            } else
                wx.shareAppMessage({
                    title: a,
                    imageUrl: u,
                    query: m
                })
        }
    }
    jt.aldShareEnable = !1,
    Laya.ClassUtils.regClass("WXShare", jt);
    class Qt {
        constructor() {
            this.banners = [],
            this.videos = [],
            this.curIsAutoPlayVideo = !1,
            this.interstitial = []
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            this.curIsAutoPlayVideo = n;
            let a = 0 === this.videos.length,
            u = this.getVideoById(e);
            if (u || (u = {
                        id: e,
                        inst: null,
                        state: t.AdState.LOADING
                    }, this.videos.push(u)), !u.inst) {
                let n = Laya.ClassUtils.getRegClass("Sdk").GameCfg;
                u.inst = swan.createRewardedVideoAd({
                    adUnitId: e,
                    appSid: n.appSid
                }),
                a ? (u.inst.onLoad(() => {
                        console.log("激励视频广告加载成功"),
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        u.state = t.AdState.LOAD,
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_SUCCESS
                        }),
                        this.curIsAutoPlayVideo && this.showVideo(u.id)
                    }), u.inst.onError(e => {
                        console.log("激励视频广告加载失败"),
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        u.state = t.AdState.LOAD_FAIL,
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                        })
                    }), u.inst.onClose(e => {
                        e && e.isEnded || void 0 === e ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                                code: t.SdkCode.AD_VIDEO_SUCCESS
                            })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                                code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                            })),
                        this.curIsAutoPlayVideo = !1,
                        1 === this.banners.length && this.banners[0].inst.show()
                    })) : t.AdState.LOAD_FAIL === u.state && u.inst.load().catch(e => {
                    u.state = t.AdState.LOAD_FAIL,
                    console.log("激励视频广告显示失败")
                })
            }
        }
        showVideo(e) {
            let n = this.getVideoById(e);
            if (n && n.inst) {
                for (let t = 0; t < this.banners.length; ++t)
                    this.banners[t].inst.hide();
                n.inst.show().then(() => {}).catch(() => {
                    n.inst.load().then(() => n.inst.show()).catch(e => {
                        n.state = t.AdState.LOAD_FAIL,
                        console.log("激励视频广告显示失败")
                    })
                })
            }
        }
        preloadVideo(t) {
            this.loadVideo(t)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? t.AdState.LOAD === n.state ? t.VideoState.ENABLED : t.VideoState.UNENABLED : t.VideoState.UNLOAD
        }
        playVideo(e) {
            console.log("video Id", e);
            let n = this.getVideoById(e);
            n ? t.AdState.LOAD === n.state ? (Laya.MouseManager.enabled = !1, this.showVideo(e)) : t.AdState.LOAD_FAIL === n.state && (v.showTips("暂无视频!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                })) : (Laya.MouseManager.enabled = !1, this.loadVideo(e, !0)),
            Laya.MouseManager.enabled || Laya.timer.once(1e4, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadBanner(e, n) {
            let a = this.getBannerById(e);
            if (a ? n || (n = a.customParams) : (!n && (n = {
                            forever: !1,
                            widthScaleRate: 1
                        }), !n.widthScaleRate && (n.widthScaleRate = 1), n.forever = Boolean(n.forever), a = {
                        id: e,
                        state: t.AdState.LOADING,
                        inst: null,
                        showCnt: 0,
                        createStamp: v.getTime(),
                        customParams: n
                    }, this.banners.push(a)), a.inst)
                t.AdState.DELETING !== a.state && t.AdState.LOAD_FAIL !== a.state || (a.inst.destroy(), a.inst = null, a.showCnt = 0, a.state = t.AdState.LOADING, this.preloadBanner(e));
            else {
                let p = Laya.ClassUtils.getRegClass("Sdk"),
                f = p.GameCfg,
                m = p.instance.getSystemInfo(),
                y = m.screenWidth * n.widthScaleRate;
                a.inst = swan.createBannerAd({
                    adUnitId: e,
                    appSid: f.appSid,
                    style: {
                        left: 0,
                        top: 0,
                        width: y
                    }
                });
                var u = m.screenWidth / 2,
                g = m.screenHeight;
                a.inst.onResize(t => {
                    a.inst.style.left = u - t.width / 2 + .1,
                    a.inst.style.top = g - t.height + .1,
                    -1 !== m.system.indexOf("iOS") && v.isQMP() && (a.inst.style.top += 6)
                }),
                a.inst.onLoad(() => {
                    a.inst.style.left = u - a.inst.style.width / 2 + .1,
                    a.inst.style.top = g - a.inst.style.height + .1,
                    -1 !== m.system.indexOf("iOS") && v.isQMP() && (a.inst.style.top += 6),
                    console.log("bannerid${bannerIds[i]} 广告加载成功"),
                    a.state = t.AdState.LOAD,
                    a.customParams.forever && a.inst.show()
                }),
                a.inst.onError(e => {
                    console.log("bannerid${bannerIds[i]} 广告加载失败", JSON.stringify(e)),
                    a.state = t.AdState.LOAD_FAIL
                })
            }
        }
        showBanner(e, n) {
            console.log("banner Id", e);
            let a = this.getBannerById(e);
            if (a) {
                if (a.customParams.forever)
                    return;
                t.AdState.LOAD === a.state ? (a.showCnt++, a.inst.show()) : t.AdState.LOAD_FAIL === a.state ? this.preloadBanner(e) : t.AdState.LOADING === a.state && n && n.isPostLoadedShow && Laya.timer.once(1e3, this, (function () {
                        this.showBanner(e, n)
                    }))
            } else
                this.preloadBanner(e, n)
        }
        hideBanner(e) {
            let n = this.getBannerById(e);
            n && (n.customParams.forever || (n.inst && n.inst.hide(), n.showCnt > 0 && (n.state = t.AdState.DELETING, this.preloadBanner(e))))
        }
        getBannerById(t) {
            return this.banners.filter((e, n, a) => e.id === t, this)[0]
        }
        showInterstitial(t) {}
        getInterstitial(t) {}
        preloadInterstitial(t) {}
        init(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {}
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return null
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    Qt.BannerRefreshTime = 4e4;
    class Yt {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(this.curParams.id) ? v.showTips("今天已经没有视频啦,明天再看吧!") : (E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_SUCCESS,
                            way: t.GetRewardSDKWay.VIDEO,
                            gid: e.bindCtrlGId
                        }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code && (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_FAIL,
                                gid: e.bindCtrlGId
                            }))
                    })), Laya.MouseManager.enabled = !1, n.instance.playVideo(e.id))
        }
    }
    class $t extends x {
        constructor() {
            super()
        }
        initMiniAdapter() {
            let t = swan.createInnerAudioContext();
            V.prototype.toggleMusic = function () {
                return this.musicEnable = !this.musicEnable,
                !this.musicEnable && this.playing && t.stop(),
                this.musicEnable
            },
            V.prototype.toggleSoundFx = function () {
                return this.soundFxEnable = !this.soundFxEnable,
                this.soundFxEnable
            },
            V.prototype.playMusic = function (e, n = 0, a) {
                this.musicEnable && (this.playing = !0, t.loop = !0, t.src = e, t.volume = a || 1, t.play())
            },
            V.prototype.stopMusic = function () {
                this.playing && (t.stop(), this.playing = !1)
            },
            V.prototype.playSound = function (t, e = 1, n = 0, a = 1) {
                if (!this.soundFxEnable)
                    return;
                let u = swan.createInnerAudioContext();
                u.loop = !1,
                u.src = t,
                u.volume = a || 1;
                try {
                    u.play()
                } catch (t) {
                    console.log(t)
                }
            }
        }
        engineInitialized() {}
        getMiniAdapter() {
            return Laya.BMiniAdapter
        }
        login() {
            swan.login({
                success: this.wxloginSucc.bind(this),
                fail: this.wxloginFail.bind(this)
            }),
            swan.getSetting({
                success: this.onSettings.bind(this)
            }),
            this.networkstate = "none",
            swan.getNetworkType({
                success: t => {
                    console.log(">>>>>>>>>>>>>>>>> getNetworkType: ", t.networkType),
                    this.networkstate = t.networkType
                }
            }),
            swan.onNetworkStatusChange(t => {
                console.log(">>>>>>>>>>>>>>>>> onNetworkStatusChange: ", t.isConnected, t.networkType),
                this.networkstate = t.networkType
            })
        }
        request(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            swan.request({
                url: t,
                data: e,
                method: u,
                dataType: "json",
                success: t => {
                    console.log("<<<<<<<<<<<<<<<<< request: ", t),
                    n && n.runWith(t.data)
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        requestDecrypt(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            swan.request({
                url: t,
                data: e,
                method: u,
                responseType: "arraybuffer",
                success: t => {
                    if (console.log("<<<<<<<<<<<<<<<<< request: ", t), n) {
                        let e = window.pako.inflate(t.data, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        getShareInstance() {
            return new jt
        }
        getAdvInstance() {
            return new Qt
        }
        getStatInstance() {}
        getRewardStrInstance() {
            return new Yt
        }
        onSettings(e) {
            let n = e.authSetting;
            this.isUserInfoAuth = !!n["scope.userInfo"],
            this.isUserInfoAuth && swan.getUserInfo({
                success: this.userInfoSucc.bind(this)
            }),
            this.code && this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "百度登录成功"
            })
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.loginServerEnable(),
            this.createUserInfoButton()
        }
        onResume(t) {
            t.query && !v.isEmpty(t.query) && this.loginServerEnable() && (this.query = t.query, Xt.instance.postShareQuery(t.query))
        }
        wxloginSucc(e) {
            console.log("百度登录成功！");
            let n = 10;
            const checkNeedFix = () => {
                if (!this.menuInfo || this.menuInfo.top > 0 || n <= 0) {
                    if (this.code = e.code, this.loginServerEnable()) {
                        let t = swan.getLaunchOptionsSync();
                        this.query = t.query,
                        Xt.instance.login(this.code, t.query)
                    }
                    return void 0 !== this.isUserInfoAuth && this.event(st.E_SDK_LOGIN, {
                        code: t.SdkCode.WX_LOGIN_SUCCESS,
                        msg: "百度登录成功"
                    }),
                    !1
                }
                return n--,
                !0
            },
            fixInfo = () => {
                this.getSystemInfo(!0),
                this.getMenuButtonBoundingClientRect(!0),
                checkNeedFix() || (v.sNotchScreen = void 0, Laya.timer.clear(this, fixInfo))
            };
            checkNeedFix() && Laya.timer.loop(100, this, fixInfo)
        }
        wxloginFail() {
            console.log("百度登录失败！"),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_FAILED,
                msg: "百度登录失败"
            })
        }
        userInfoSucc(e) {
            let n;
            e.userInfo ? (console.log("获取用户信息成功！" + JSON.stringify(e)), this.isUserInfoAuth = !0, this.encryptedData = e.encryptedData, this.iv = e.iv, this.destroyUserInfoButton(), n = new t.SDKEntity.UserInfoEntity, function (t, e) {
                null != t.nickName && (e.name = t.nickName),
                null != t.avatarUrl && (e.headUrl = t.avatarUrl),
                null != t.gender && (e.sex = t.gender),
                null != t.city && (e.city = t.city),
                null != t.province && (e.province = t.province),
                null != t.country && (e.country = t.country),
                null != t.language && (e.language = t.language)
            }
                (e.userInfo, n), Z.instance.update(n), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_SUCCESS,
                    msg: "授权成功"
                })) : (console.log("获取用户信息失败！"), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_FAILED,
                    msg: "用户拒绝授权"
                })),
            this.profileToServer && Xt.instance.postProfile(n)
        }
        createUserInfoButton() {
            let t = this.profileBtn,
            e = t.localToGlobal(new Laya.Point(0, 0)),
            n = t.localToGlobal(new Laya.Point(t.width, t.height));
            Laya.stage.transform.transformPoint(e),
            Laya.stage.transform.transformPoint(n);
            let a = n.x - e.x,
            u = n.y - e.y,
            g = swan.createUserInfoButton({
                type: "text",
                text: "",
                style: {
                    left: e.x,
                    top: e.y,
                    width: a,
                    height: u
                },
                withCredentials: !0,
                lang: "zh_CN"
            });
            g.show(),
            g.onTap(this.userInfoSucc.bind(this)),
            this.profileBtn = g,
            t.once(Laya.Event.REMOVED, this, this.destroyUserInfoButton)
        }
        destroyUserInfoButton() {
            this.profileBtn && this.profileBtn.destroy(),
            this.profileBtn = null
        }
        setKeepScreenOn(t) {
            swan.setKeepScreenOn(t)
        }
        onShow(t) {
            swan.onShow(t)
        }
        onHide(t) {
            swan.onHide(t)
        }
        checkUpdate() {
            if ("function" == typeof swan.getUpdateManager) {
                const t = swan.getUpdateManager();
                t.onCheckForUpdate((function (t) {
                        console.log(t.hasUpdate)
                    })),
                t.onUpdateReady(() => {
                    this.showModal("有新版本啦！，赶快开启新的历程吧~", "更新提示", "开启", Laya.Handler.create(this, () => {
                            t.applyUpdate()
                        }))
                }),
                t.onUpdateFailed((function () {
                        console.log("新的版本下载失败")
                    }))
            }
        }
        loadSubpackage(t) {
            return swan.loadSubpackage ? swan.loadSubpackage(t) : null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            swan.showModal({
                title: e,
                content: t,
                showCancel: "" != u && null != u,
                cancelText: u,
                confirmText: n,
                success: t => {
                    t.confirm ? a && a.run() : u && g && g.run()
                }
            })
        }
        getSystemInfo(t) {
            return !t && this.systemInfo || (this.systemInfo = swan.getSystemInfoSync(), console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo))),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            return !t && this.menuInfo || v.compareVersion(this.systemInfo.SDKVersion, "2.1.0") >= 0 && (this.menuInfo = swan.getMenuButtonBoundingClientRect(), console.log("getMenuButtonBoundingClientRect: " + JSON.stringify(this.menuInfo))),
            this.menuInfo
        }
        exit() {}
        getLaunchOptionsSync() {
            return swan.getLaunchOptionsSync()
        }
        navigateToMiniProgram(t) {
            swan.navigateToMiniProgram(t)
        }
        getOpenDataContext() {
            return swan.getOpenDataContext()
        }
        createFeedbackButton(t) {}
        openCustomerServiceConversation(t) {
            swan.openCustomerServiceConversation(t)
        }
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {
            swan.onAudioInterruptionBegin(t),
            swan.onAudioInterruptionEnd(e)
        }
        vibrateShort() {
            swan.vibrateShort({})
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        judgeBAndW(e) {
            let n = e.sceneId;
            if (!n)
                return t.BlackAndWhite.Black;
            let a = Laya.LocalStorage.getItem("BAndW");
            return "white" === a || "black" === a ? "white" === a && 1037 !== n && 1044 !== n && 1007 !== n && 1104 !== n && 1008 !== n && 1001 !== n && 1038 !== n && 1090 !== n && 1103 !== n && 1089 !== n && 1095 !== n && (a = "black", Laya.LocalStorage.setItem("BAndW", a)) : (a = 1095 === n || 1037 === n || 1058 === n ? "white" : "black", Laya.LocalStorage.setItem("BAndW", a)),
            a === t.BlackAndWhite.White ? t.BlackAndWhite.White : t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class Zt {
        constructor() {
            let t = Laya.ClassUtils.getRegClass("Sdk").GameCfg;
            window.adInit({
                banner_id: t.channel_AdIds.bannerId,
                interstitial_id: t.channel_AdIds.interstitialId,
                reward_id: t.channel_AdIds.videoId,
                debug_mode: t.debug_mode,
                test_device_id: t.test_device_id,
                banner_location: 2,
                custom_banner_location: {
                    width: -1,
                    gravity: 81,
                    margin_bottom: 0
                },
                success(t) {
                    console.log("adInit success = " + t)
                }
            })
        }
        init(t) {}
        canPlayAd() {
            return !0
        }
        playVideo() {
            window.adShow({
                ad_type: 3,
                success(e) {
                    console.log("playVideo success = " + e),
                    e && 10001 == e ? V.instance.pauseMusic() : e && 10002 == e && (Laya.MouseManager.enabled = !0, V.instance.resumeMusic(), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        }))
                },
                fail(e) {
                    console.log("playVideo fail = " + e),
                    Laya.MouseManager.enabled = !0,
                    E.instance.event(st.E_AD_VIDEO, {
                        code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                    })
                }
            }),
            Laya.MouseManager.enabled || Laya.timer.once(1e4, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadVideo(t) {}
        getVideoState(e) {
            return this.canPlayAd() ? t.VideoState.ENABLED : t.VideoState.UNENABLED
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {
            window.adShow({
                ad_type: 1,
                success(t) {
                    console.log("showBanner success = " + t)
                },
                fail(t) {
                    console.log("showBanner fail = " + t)
                }
            })
        }
        hideBanner(t) {
            try {
                window.adClose({
                    ad_type: 1,
                    success(t) {
                        console.log("adClose success = " + t)
                    },
                    fail(t) {
                        console.log("adClose fail = " + t)
                    }
                })
            } catch (t) {}
        }
        getBannerById(t) {
            return null
        }
        preloadInterstitial(t) {}
        showInterstitial(t) {
            window.adShow({
                ad_type: 2,
                success(t) {
                    console.log("showInterstitial success = " + t)
                },
                fail(t) {
                    console.log("showInterstitial fail = " + t)
                }
            })
        }
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {}
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return null
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    class te {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                        code: t.SdkCode.REWARD_GAIN_SUCCESS,
                        way: t.GetRewardSDKWay.VIDEO,
                        gid: e.bindCtrlGId
                    }) : (t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code || t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code) && E.instance.event(st.E_REWARD_GAIN, {
                        code: t.SdkCode.REWARD_GAIN_FAIL,
                        gid: e.bindCtrlGId
                    })
                })),
            n.instance.playVideo(e.id)
        }
    }
    class ee {
        constructor() {}
        sendEvent(t, e) {}
        stageOnStart(t) {}
        stageOnRunning(t) {}
        stageOnEnd(t) {}
        unlockItem(t) {}
    }
    class ie extends x {
        constructor() {
            super()
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            Laya.ClassUtils.getRegClass("Sdk");
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "传音 登陆成功"
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                n && n.runWith(t)
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (n) {
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    n.runWith(JSON.parse(e))
                }
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        getShareInstance() {
            return null
        }
        getAdvInstance() {
            return new Zt
        }
        getStatInstance() {
            return new ee
        }
        getRewardStrInstance() {
            return new te
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return null
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return null
        }
        auth(t) {}
        onResume(t) {}
        userInfoSucc(t) {}
        createUserInfoButton() {}
        destroyUserInfoButton() {}
        setKeepScreenOn(t) {}
        onShow(t) {}
        onHide(t) {}
        checkUpdate() {}
        loadSubpackage(t) {
            return null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo(t) {
            return null
        }
        getMenuButtonBoundingClientRect(t) {
            return null
        }
        exit() {}
        getLaunchOptionsSync() {
            return null
        }
        navigateToMiniProgram(t) {}
        getOpenDataContext() {
            return null
        }
        createFeedbackButton(t) {
            return null
        }
        openCustomerServiceConversation(t) {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {
            return null
        }
        vibrateShort() {
            return null
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return null
        }
        judgeBAndW(t) {
            return null
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class se {
        constructor() {
            this.isPreload = !1,
            this.banners = [],
            this.videos = [],
            this.interstitial = []
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            let a = this.getVideoById(e);
            a || (a = {
                    id: e,
                    inst: null,
                    state: t.VideoState.UNLOAD
                }, this.videos.push(a)),
            a.inst || (a.inst = gamebox.createRewardedVideoAd(), a.inst.onLoad(() => {
                    console.log("激励视频广告加载成功")
                }), a.inst.onError(n => {
                    console.log("激励视频广告加载失败，", JSON.stringify(n)),
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    a.state = t.VideoState.UNENABLED,
                    E.instance.event(st.E_AD_VIDEO, {
                        code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                    }),
                    Laya.timer.once(1e4, this, () => {
                        this.loadVideo(e, !1)
                    })
                }), a.inst.onClose(e => {
                    e && e.isEnded || void 0 === e ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                        })),
                    this.isPreload || gamebox.hideLoading({}),
                    this.isPreload = !1
                }), n && this.showVideo(e))
        }
        showVideo(t) {
            let e = this.getVideoById(t);
            e && e.inst && e.inst.show().then(() => {
                console.log("激励视频广告显示成功"),
                this.isPreload || (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), gamebox.hideLoading({}))
            })
        }
        preloadVideo(t, e) {
            let n = this.getVideoById(t);
            n && n.inst ? e && (this.isPreload = !0, n.inst.load()) : this.loadVideo(t)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? n.state : t.VideoState.UNLOAD
        }
        playVideo(t) {
            let e = this.getVideoById(t);
            e && e.inst ? this.showVideo(t) : this.loadVideo(t, !0),
            this.isPreload || (Laya.MouseManager.enabled = !1, gamebox.showLoading({
                    title: "加载中，请稍后...",
                    mask: !0
                })),
            Laya.MouseManager.enabled || Laya.timer.once(5e3, this, () => {
                !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                gamebox.hideLoading({})
            })
        }
        preloadBanner(e, n) {
            let a = this.getBannerById(e);
            if (a ? n || (n = a.customParams) : (!n && (n = {
                            forever: !1,
                            widthScaleRate: 1
                        }), !n.widthScaleRate && (n.widthScaleRate = 1), n.forever = Boolean(n.forever), a = {
                        id: e,
                        state: t.AdState.LOADING,
                        inst: null,
                        showCnt: 0,
                        createStamp: v.getTime(),
                        customParams: n
                    }, this.banners.push(a)), a.inst)
                t.AdState.DELETING !== a.state && t.AdState.LOAD_FAIL !== a.state || (a.inst.destroy(), a.inst = null, a.showCnt = 0, a.state = t.AdState.LOADING, this.preloadBanner(e));
            else {
                let e = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo(),
                u = e.screenWidth * n.widthScaleRate;
                a.inst = gamebox.createBannerAd({
                    style: {
                        top: e.screenHeight * e.pixelRatio - 180,
                        left: 0,
                        width: u * e.pixelRatio,
                        height: 180
                    }
                }),
                a.inst.onLoad(() => {
                    console.log("bannerid${bannerIds[i]} 广告加载成功"),
                    a.state = t.AdState.LOAD
                }),
                a.inst.onError(e => {
                    console.log("bannerid${bannerIds[i]} 广告加载失败", JSON.stringify(e)),
                    a.state = t.AdState.LOAD_FAIL,
                    E.instance.event(st.E_AD_BANNER, {
                        code: t.SdkCode.AD_BANNER_FAIL
                    })
                }),
                a.inst.load && a.inst.load(),
                a.inst.show()
            }
        }
        showBanner(e, n) {
            let a = this.getBannerById(e);
            if (a) {
                if (a.customParams.forever)
                    return;
                t.AdState.LOAD === a.state ? (a.showCnt++, a.inst.show()) : this.preloadBanner(e)
            } else
                this.preloadBanner(e, n)
        }
        hideBanner(e) {
            let n = this.getBannerById(e);
            n && (n.inst && (n.inst.hide(), n.inst.destroy(), n.inst = null), n.showCnt = 0, n.state = t.AdState.DELETING)
        }
        getBannerById(t) {
            return this.banners.filter((e, n, a) => e.id === t, this)[0]
        }
        showInterstitial(t, e) {
            let n = gamebox.createInterstitialAd();
            n.onLoad(() => {
                console.log("interstitial 广告加载成功")
            }),
            n.onError(t => {
                console.log("interstitial 广告加载失败", JSON.stringify(t))
            }),
            n.load && n.load();
            let a = n.show();
            a && a.catch(t => {
                console.log("插屏广告展示失败-重试"),
                console.log(JSON.stringify(t))
            })
        }
        getInterstitial(t) {}
        preloadInterstitial(t) {}
        init(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd(t) {}
        reportAdClickNativeAd() {}
        getNativeAdData(t) {}
        preloadAppbox(t) {}
        showAppBox(t, e) {}
        hideAppBox(t, e) {}
        destoryAppBox() {}
        getAppBoxData() {
            let t = [],
            e = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfg();
            if (e && e.navigateAppList) {
                for (let n = 0; n < e.navigateAppList.length; ++n) {
                    let a = e.navigateAppList[n];
                    a && a.appId && (a.shield || t.push(a))
                }
                return t
            }
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd(t) {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    se.BannerRefreshTime = 4e4;
    class ne {
        constructor() {}
        init(t) {}
        setShare(t, e, n) {}
        share(t, e, n) {
            gamebox.shareMessageToFriend({
                type: 0
            })
        }
        canRecord() {
            return null
        }
        canShareRecord() {
            return null
        }
        recordVideo(t) {}
        stopRecord(t) {}
        pauseRecord() {}
        resumeRecord() {}
        destroyRecord() {}
        shareVideo(t) {
            return !1
        }
    }
    Laya.ClassUtils.regClass("FTNNBoxShare", ne);
    class ae {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(e.id) ? (v.showTips("暂时没有视频啦,稍后再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : (E.instance.off(st.E_AD_VIDEO, this, this.playVideoFunc), E.instance.once(st.E_AD_VIDEO, this, this.playVideoFunc, [e]), n.instance.playVideo(e.id))
        }
        playVideoFunc(e, n) {
            !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
            e || E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_FAIL,
                gid: null
            }),
            t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.VIDEO,
                gid: e.bindCtrlGId
            }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && (v.showTips("视频播放失败~"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                }))
        }
    }
    class oe {
        constructor() {}
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg,
            n = Z.instance.getMine();
            n.openId = e.user_unique_id,
            n.name = "test_user",
            n.headUrl = "",
            this.loginServerEnable() && Xt.instance.loginNoAuth();
            let a = this.loginSucc.bind(this);
            gamebox.login({
                success(t) {
                    t.code ? a() : console.log("登录失败！" + t.errMsg)
                }
            }),
            E.instance.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS
            })
        }
        loginSucc(t) {
            console.log("登录成功！");
            let e = gamebox.getLaunchOptionsSync();
            t.isLogin ? t.anonymousCode ? this.code = t.code + "_anonymous_" + t.anonymousCode : this.code = t.code : this.code = "anonymous_" + t.anonymousCode,
            this.loginServerEnable() && Xt.instance.login(this.code, e.query),
            this.query = e.query,
            gamebox.getUserInfo({
                success: this.userInfoSucc.bind(this)
            })
        }
        userInfoSucc(t) {
            if (t.userInfo) {
                if (console.log("获取用户信息成功！" + JSON.stringify(t)), t.userInfo.nickName) {
                    Laya.ClassUtils.getRegClass("Sdk").nickName = t.userInfo.nickName
                }
            } else
                console.log("获取用户信息失败！")
        }
        request(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            gamebox.request({
                url: t,
                data: e,
                method: u,
                dataType: "json",
                success: t => {
                    console.log("<<<<<<<<<<<<<<<<< request: ", t),
                    n && n.runWith(t.data)
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        requestDecrypt(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            gamebox.request({
                url: t,
                data: e,
                method: u,
                responseType: "arraybuffer",
                success: t => {
                    if (console.log("<<<<<<<<<<<<<<<<< request: ", t), n) {
                        let e = window.pako.inflate(t.data, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        onResume(t) {
            t.query && !v.isEmpty(t.query) && this.loginServerEnable() && (this.query = t.query, Xt.instance.postShareQuery(t.query))
        }
        getQuery() {
            return this.query
        }
        setKeepScreenOn(t) {
            gamebox.setKeepScreenOn(t)
        }
        onShow(t) {
            gamebox.onShow(t)
        }
        onHide(t) {
            gamebox.onHide(t)
        }
        isAuth() {
            return !0
        }
        auth(t) {}
        destroyUserInfoButton() {}
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        checkUpdate() {}
        loadSubpackage(t) {
            return gamebox.loadSubpackage,
            gamebox.loadSubpackage ? gamebox.loadSubpackage(t) : null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            gamebox.showModal({
                title: e,
                content: t,
                confirmText: n,
                cancelText: u,
                success(t) {
                    t.confirm ? a && a.run() : t.cancel && g && g.run()
                },
                fail() {
                    g && g.run()
                }
            })
        }
        getSystemInfo(t) {
            return !t && this.systemInfo || (this.systemInfo = gamebox.getSystemInfoSync(), console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo))),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            return !t && this.menuInfo || (v.compareVersion(this.systemInfo.SDKVersion, "1.25.0") >= 0 ? (this.menuInfo = gamebox.getMenuButtonBoundingClientRect(), console.log("getMenuButtonBoundingClientRect: " + JSON.stringify(this.menuInfo))) : this.menuInfo = {
                    width: 0,
                    height: 0,
                    top: 0,
                    right: 0,
                    bottom: Laya.stage.height,
                    left: Laya.stage.width
                }),
            this.menuInfo
        }
        exit() {
            gamebox.exitMiniProgram({})
        }
        getLaunchOptionsSync() {
            return gamebox.getLaunchOptionsSync()
        }
        navigateToMiniProgram(t) {}
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation() {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {
            gamebox.onAudioInterruptionBegin(t),
            gamebox.onAudioInterruptionEnd(e)
        }
        vibrateShort() {
            gamebox.vibrateShort({})
        }
        getShareInstance() {
            return new ne
        }
        getAdvInstance() {
            return new se
        }
        getStatInstance() {}
        getRewardStrInstance() {
            return new ae
        }
        getNetworkType() {
            return "wifi"
        }
        isConnectNetwork() {
            return !0
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.White
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class re {
        constructor() {}
        init(t) {}
        setShare(t, e, n) {}
        share(t, e, n) {
            Laya.Browser.window.h5api.share()
        }
        canRecord() {
            return null
        }
        canShareRecord() {
            return null
        }
        recordVideo(t) {}
        stopRecord(t) {}
        pauseRecord() {}
        resumeRecord() {}
        destroyRecord() {}
        shareVideo(t) {
            return !1
        }
    }
    re.aldShareEnable = !1,
    Laya.ClassUtils.regClass("FTNNShare", re);
    class le {
        constructor() {
            this.bridge = Ht.Instance
        }
        init(t) {}
        canPlayAd() {
            let t = Laya.Browser.window.h5api.canPlayAd((function (t) {
                        Laya.Browser.window.console.log("是否可播放广告： ", t.canPlayAd, "\n", "剩余次数： ", t.remain)
                    }));
            return t ? Laya.Browser.window.console.log("有广告资源可播放") : Laya.Browser.window.console.log("没有广告资源可播放"),
            t
        }
        playVideo() {
            Laya.Browser.window.h5api.playAd((function (e) {
                    console.log("代码:" + e.code + ",消息:" + e.message),
                    1e4 === e.code ? (console.log("开始播放"), Laya.MouseManager.enabled = !1, V.instance.pauseMusic()) : 10001 === e.code ? (console.log("播放结束"), Laya.MouseManager.enabled = !0, V.instance.resumeMusic(), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        })) : (console.log("广告异常"), Laya.MouseManager.enabled = !0, E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                        }))
                })),
            Laya.MouseManager.enabled || Laya.timer.once(1e4, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadVideo(t) {}
        getVideoState(e) {
            return this.canPlayAd() ? t.VideoState.ENABLED : t.VideoState.UNENABLED
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {}
        hideBanner(t) {}
        getBannerById(t) {
            return null
        }
        preloadInterstitial(t) {}
        showInterstitial(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {}
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return null
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    class he {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                        code: t.SdkCode.REWARD_GAIN_SUCCESS,
                        way: t.GetRewardSDKWay.VIDEO,
                        gid: e.bindCtrlGId
                    }) : (t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code || t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code) && E.instance.event(st.E_REWARD_GAIN, {
                        code: t.SdkCode.REWARD_GAIN_FAIL,
                        gid: e.bindCtrlGId
                    })
                })),
            n.instance.playVideo(e.id)
        }
    }
    class de extends x {
        constructor() {
            super()
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            Laya.ClassUtils.getRegClass("Sdk").instance.adIds = {
                videoId: "11",
                nativeAdId: ["22", "33"],
                bannerId: "44",
                interstitialId: "55",
                appBoxId: "66",
                blockId: "77"
            },
            Laya.Browser.window.h5api.isLogin() ? Laya.Browser.window.console.log("已登录") : Laya.Browser.window.console.log("未登录"),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "4399登陆成功"
            })
        }
        request(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e)
        }
        requestDecrypt(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e)
        }
        getShareInstance() {
            return new re
        }
        getAdvInstance() {
            return new le
        }
        getStatInstance() {
            return null
        }
        getRewardStrInstance() {
            return new he
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return null
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return null
        }
        auth(t) {}
        onResume(t) {}
        userInfoSucc(t) {}
        createUserInfoButton() {}
        destroyUserInfoButton() {}
        setKeepScreenOn(t) {}
        onShow(t) {}
        onHide(t) {}
        checkUpdate() {}
        loadSubpackage(t) {
            return null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo(t) {
            return null
        }
        getMenuButtonBoundingClientRect(t) {
            return null
        }
        exit() {}
        getLaunchOptionsSync() {
            return null
        }
        navigateToMiniProgram(t) {}
        getOpenDataContext() {
            return null
        }
        createFeedbackButton(t) {
            return null
        }
        openCustomerServiceConversation(t) {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {
            return null
        }
        vibrateShort() {
            return null
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return null
        }
        judgeBAndW(t) {
            return null
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class ce {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            console.log(`获取奖励源[${this.curParams.source}]-获取奖励方式[${t.GetRewardSDKWay.VIDEO}]`);
            let e = Laya.ClassUtils.getRegClass("Sdk");
            e.instance.sendEvent("视频", {
                "打开": this.curParams.source
            }),
            e.instance.isFreeVideo() ? E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.VIDEO,
                gid: this.curParams.bindCtrlGId
            }) : this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(e.id) ? (v.showTips("暂时没有视频啦,稍后再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : (E.instance.off(st.E_AD_VIDEO, this, this.playVideoFunc), E.instance.once(st.E_AD_VIDEO, this, this.playVideoFunc, [e]), n.instance.playVideo(e.id))
        }
        playVideoFunc(e, n) {
            !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
            e || E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_FAIL,
                gid: null
            }),
            t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.VIDEO,
                gid: e.bindCtrlGId
            }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && (v.showTips("视频播放失败~"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                }))
        }
    }
    class ue {
        constructor() {
            this.imgPath = {
                closePath: null,
                bgPath: null
            },
            this.appBoxBtn = void 0,
            this.banners = [],
            this.videos = [],
            this.curIsAutoPlayVideo = !1,
            this.nativeAd = new Array,
            this.nativeAdImg = void 0,
            this.curNativeAdIndex = 0,
            this.nativeAdParentInfo = {
                parent: null,
                adPos: null,
                btnPos: null,
                btnHarvestPos: null,
                adSize: null
            }
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            this.curIsAutoPlayVideo = n;
            let a = this.getVideoById(e);
            a || (a = {
                    id: e,
                    inst: null,
                    state: t.VideoState.UNLOAD
                }, this.videos.push(a)),
            a.inst ? a.inst.load() : (a.inst = hbs.createRewardedVideoAd({
                    adUnitId: a.id,
                    fail: (t, u) => {
                        console.log("createRewardedVideoAd fail: " + t + "," + u),
                        a.inst = void 0,
                        this.loadVideo(e, n)
                    }
                }), a.inst && (a.inst.onLoad(() => {
                        console.log("激励视频广告加载成功"),
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        a.state = t.VideoState.ENABLED,
                        this.curIsAutoPlayVideo && this.showVideo(a.id)
                    }), a.inst.onError(e => {
                        console.log("激励视频广告加载失败，", JSON.stringify(e)),
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        a.state = t.VideoState.UNLOAD,
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                        })
                    }), a.inst.onClose(e => {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        e && e.isEnded ? E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        }) : E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                        }),
                        this.curIsAutoPlayVideo = !1,
                        setTimeout(() => {
                            console.log("setTimeout"),
                            a.inst.load()
                        }, 1e3)
                    }), a.inst.load()))
        }
        showVideo(t) {
            let e = this.getVideoById(t);
            e && e.inst && e.inst.show()
        }
        preloadVideo(e) {
            let n = this.getVideoState(e);
            t.VideoState.UNLOAD === n && this.loadVideo(e)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? n.state : t.VideoState.UNLOAD
        }
        playVideo(e) {
            console.log("video Id", e);
            let n = this.getVideoById(e);
            n && t.VideoState.UNLOAD !== n.state ? t.VideoState.ENABLED === n.state && (Laya.MouseManager.enabled = !1, this.showVideo(e)) : (Laya.MouseManager.enabled = !1, this.loadVideo(e, !0)),
            Laya.MouseManager.enabled || setTimeout(() => {
                !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
            }, 1e4)
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {}
        hideBanner(t) {}
        getBannerById(t) {
            return null
        }
        showInterstitial(t) {}
        getInterstitial(t) {
            return null
        }
        preloadInterstitial(t) {}
        init(t) {
            hbs.onShow(() => {
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAdImg && this.nativeAd[this.curNativeAdIndex].inst.reportAdShow({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            })
        }
        createNativeAd(e) {
            console.log("adList:", e),
            E.instance.event(st.E_AD_NATIVE, {
                code: t.SdkCode.AD_NATIVE_SUCCESS
            }),
            this.nativeAdImg = new Laya.Image,
            this.nativeAdImg.skin = e.imgUrlList[0],
            this.nativeAdImg.anchorX = .5,
            this.nativeAdImg.anchorY = 0,
            this.nativeAdImg.size(this.nativeAdParentInfo.adSize.w, this.nativeAdParentInfo.adSize.h),
            this.nativeAdImg.pos(this.nativeAdParentInfo.adPos.x, this.nativeAdParentInfo.adPos.y),
            this.nativeAdParentInfo.parent.addChild(this.nativeAdImg);
            let n = new Laya.Image;
            n.skin = e.icon,
            n.anchorX = n.left = 0,
            n.centerX = n.top = 0,
            n.size(136, 136),
            this.nativeAdImg.addChild(n);
            let a = new Laya.Image;
            a.skin = "res/img_tips.png",
            a.anchorX = a.anchorY = .5,
            a.size(60, 40),
            a.sizeGrid = "15,15,15,15",
            a.bottom = a.right = 0,
            this.nativeAdImg.addChild(a);
            let u = new Laya.Label;
            u.text = "广告",
            u.fontSize = 20,
            u.color = "#ffffff",
            u.anchorX = u.anchorY = .5,
            u.centerX = u.centerY = 0,
            a.addChild(u);
            let g = new Laya.Image;
            g.skin = this.imgPath.closePath,
            g.right = g.top = 0,
            g.size(50, 50),
            this.nativeAdImg.addChild(g);
            let p = new Laya.Image;
            p.skin = this.imgPath.bgPath,
            p.sizeGrid = "30,30,30,30",
            p.size(300, 120),
            p.anchorX = p.anchorY = .5,
            this.nativeAdImg.addChild(p);
            let f = new Laya.Label;
            f.text = "点击查看",
            f.fontSize = 50,
            f.color = "#ffffff",
            f.bold = !0,
            f.anchorX = f.anchorY = .5,
            f.centerX = f.centerY = 0,
            p.addChild(f);
            let m = new Laya.Label;
            m.text = e.source,
            m.fontSize = 30,
            m.color = "#ffffff",
            m.left = u.bottom = 0,
            this.nativeAdImg.addChild(m),
            this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdShow({
                adId: this.nativeAd[this.curNativeAdIndex].adList.adId
            }),
            this.nativeAdImg.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy(),
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            }),
            p.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy(),
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            }),
            g.on(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy()
            }),
            Laya.ClassUtils.getRegClass("Sdk").instance.isHarvest() ? p.pos(this.nativeAdParentInfo.btnHarvestPos.x, this.nativeAdParentInfo.btnHarvestPos.y) : p.pos(this.nativeAdParentInfo.btnPos.x, this.nativeAdParentInfo.btnPos.y)
        }
        preloadNativeAd(t, e) {
            if (this.imgPath = e, 0 == this.nativeAd.length)
                for (let e = 0; e < t.length; e++)
                    this.nativeAd.push({
                        id: t[e],
                        isLoad: !1,
                        inst: null,
                        adList: null
                    })
        }
        loadNativeAd() {
            var e = hbs.createNativeAd({
                adUnitId: this.nativeAd[this.curNativeAdIndex].id
            });
            this.nativeAd[this.curNativeAdIndex].inst = e;
            var n = (t => {
                this.nativeAd[this.curNativeAdIndex].adList = t,
                this.nativeAd[this.curNativeAdIndex].isLoad = !0,
                this.nativeAdParentInfo.parent && this.createNativeAd(this.nativeAd[this.curNativeAdIndex].adList)
            }).bind(this);
            e.onLoad(t => {
                console.log("原生广告加载成功：", JSON.stringify(t.adList)),
                n(t.adList[0])
            });
            var a = (() => {
                this.nativeAd[this.curNativeAdIndex].inst.offLoad(),
                this.nativeAd[this.curNativeAdIndex].inst.offError(),
                this.nativeAd[this.curNativeAdIndex].inst.destroy(),
                this.nativeAd[this.curNativeAdIndex].inst = null,
                this.curNativeAdIndex += 1,
                this.curNativeAdIndex > 1 ? (this.curNativeAdIndex = 0, E.instance.event(st.E_AD_NATIVE, {
                        code: t.SdkCode.AD_NATIVE_FAIL
                    })) : setTimeout(() => {
                    this.loadNativeAd()
                }, 1500)
            }).bind(this);
            e.onError(t => {
                console.log("原生广告加载失败：", JSON.stringify(t)),
                a()
            }),
            e.load()
        }
        showNativeAd(t, e) {
            this.nativeAdParentInfo.parent = t,
            this.nativeAdParentInfo.adPos = {
                x: Laya.stage.width / 2,
                y: e.adPosY
            },
            this.nativeAdParentInfo.btnPos = {
                x: Laya.stage.width / 2,
                y: e.btnPosY
            },
            this.nativeAdParentInfo.btnHarvestPos = {
                x: Laya.stage.width / 2,
                y: e.btnHarvestPosY
            },
            this.nativeAdParentInfo.adSize = {
                w: Laya.stage.width,
                h: e.adSizeH
            },
            this.nativeAd[this.curNativeAdIndex].isLoad ? this.createNativeAd(this.nativeAd[this.curNativeAdIndex].adList) : this.loadNativeAd()
        }
        destoryNativeAd() {
            this.nativeAd[this.curNativeAdIndex].inst && (this.nativeAd[this.curNativeAdIndex].inst.offLoad(), this.nativeAd[this.curNativeAdIndex].inst.offError(), this.nativeAd[this.curNativeAdIndex].inst = null, this.nativeAd[this.curNativeAdIndex].isLoad = !1, this.curNativeAdIndex += 1, this.curNativeAdIndex > 1 && (this.curNativeAdIndex = 0), this.nativeAdImg && (this.nativeAdImg.removeSelf(), this.nativeAdImg.destroy(), this.nativeAdImg = void 0)),
            this.nativeAdParentInfo.parent = this.nativeAdParentInfo.adPos = this.nativeAdParentInfo.adSize = this.nativeAdParentInfo.btnPos = this.nativeAdParentInfo.btnHarvestPos = null
        }
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {}
        hideAppBox() {}
        ceeateMoreGamesBanner() {}
        destoryAppBox() {}
        getAppBoxData(t = !1) {
            return null
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    ue.BannerRefreshTime = 4e4;
    class ge {
        constructor() {}
        init(t) {}
        recordVideo(t) {}
        stopRecord(t) {}
        shareVideo(t) {
            return !1
        }
        canRecord() {
            return !1
        }
        canShareRecord() {
            return null
        }
        pauseRecord() {}
        resumeRecord() {}
        destroyRecord() {}
        setShare(t, e, n) {}
        share(t, e, n) {
            let a = null,
            u = null,
            g = null,
            p = null;
            t instanceof mt ? (a = t.title, u = t.imgUrl, g = t.queryParam, p = t.source) : (a = t, u = e, g = n, p = "未知");
            let m = "";
            if (g) {
                E.instance.once(f.E_APP_ON_RESUME, this, (function (t) {
                        v.showTips("感谢分享!!!")
                    }));
                for (let t in g) {
                    let e = g[t];
                    null != e && ("object" == typeof e && (e = JSON.stringify(e)), m = null == m ? t + "=" + e : m + "&" + t + "=" + e)
                }
            }
            hbs.systemShare({
                type: "other",
                data: u,
                success: function () {
                    console.log("share success")
                },
                fail: function (t, e) {
                    console.log("share fail --- " + e + ":" + t)
                },
                cancel: function (t) {
                    console.log("share cancel:" + t)
                },
                complete: function () {
                    console.log("share complete")
                }
            })
        }
    }
    ge.aldShareEnable = !1,
    Laya.ClassUtils.regClass("HWShare", ge);
    class pe extends x {
        constructor() {
            super(),
            this.followedState = t.FollowedState.NotGot,
            this.addDeskState = t.AddDeskState.NotGot
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {
            return Laya.HWMiniAdapter
        }
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg;
            hbs.gameLogin({
                forceLogin: 0,
                appid: e.appId,
                success: this.loginSucc.bind(this),
                fail: this.loginFail.bind(this),
                complete() {
                    console.log("on gameLogin: complete")
                }
            }),
            this.networkstate = "none",
            hbs.getNetworkType({
                success: t => {
                    console.log("getNetworkType success networkType" + t.networkType),
                    this.networkstate = t.networkType
                },
                fail: () => {
                    console.log("getNetworkType fail")
                },
                complete: () => {
                    console.log("getNetworkType complete")
                }
            }),
            hbs.onNetworkStatusChange(t => {
                console.log("onNetworkStatusChange isConnected = " + t.isConnected + ", networkType = " + t.networkType),
                this.networkstate = t.networkType
            }),
            hbs.getSetting({
                success: this.onSettings.bind(this),
                fail: function () {
                    console.log("getSetting fail")
                },
                complete: function () {
                    console.log("getSetting complete")
                }
            }),
            hbs.hasInstalled({
                success: function (e) {
                    console.log("hasInstalledsuccess： " + e),
                    this.addDeskState = e ? t.AddDeskState.Add : t.AddDeskState.NotAdd
                },
                fail: function (e) {
                    console.log("hasInstalled fail: " + e),
                    this.addDeskState = t.AddDeskState.FailAdd
                },
                complete: function () {
                    console.log("hasInstalled complete")
                }
            }),
            this.getSystemInfo(),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "华为登录成功！"
            })
        }
        request(t, e, n, a, u) {
            var g = new XMLHttpRequest;
            g.timeout = 1e4,
            g.open(u, t, !0),
            g.onload = t => {
                let e = g.responseText.indexOf("{"),
                a = g.responseText.slice(e);
                n && n.runWith(JSON.parse(a))
            },
            g.onerror = t => {
                console.log("获取json配置失败:", JSON.stringify(t)),
                a && a.run()
            },
            g.send(null)
        }
        requestDecrypt(t, e, n, a, u) {
            var g = new XMLHttpRequest;
            g.timeout = 1e4,
            g.open(u, t, !0),
            g.onload = t => {
                var e = void 0 !== g.status ? g.status : 200;
                if (200 === e || 204 === e || 0 === e) {
                    let e = window.pako.inflate(t.response, {
                        to: "string"
                    });
                    n.runWith(JSON.parse(e))
                } else
                    console.log("获取json配置失败:" + e), a && a.run()
            },
            g.onerror = t => {
                console.log("获取json配置失败:", JSON.stringify(t)),
                a && a.run()
            },
            g.send(null)
        }
        getShareInstance() {
            return new ge
        }
        getAdvInstance() {
            return new ue
        }
        getStatInstance() {
            return null
        }
        getRewardStrInstance() {
            return new ce
        }
        onSettings(t) {
            let e = t;
            this.isUserInfoAuth = !!e["Scope.userInfo"],
            this.isUserInfoAuth && kwaigame.getUserInfo({
                success: this.userInfoSucc.bind(this)
            }),
            this.code
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        isLoginServer() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.isLoginServer(),
            this.createUserInfoButton()
        }
        onResume(t) {
            t.query && !v.isEmpty(t.query) && this.isLoginServer() && (this.query = t.query, Xt.instance.postShareQuery(t.query))
        }
        loginSucc(t) {
            console.log("华为登录成功！");
            let e = hbs.getLaunchOptionsSync();
            this.code = t.isLogin ? t.code : "",
            this.isLoginServer() && Xt.instance.login(this.code, e.query),
            this.isUserInfoAuth,
            e && (this.query = e.query)
        }
        loginFail(t, e) {
            console.log("华为登录失败！" + t + ", code:" + e)
        }
        userInfoSucc(e) {
            let n;
            e.userInfo ? (console.log("获取用户信息成功！" + JSON.stringify(e)), this.isUserInfoAuth = !0, this.encryptedData = e.encryptedData, this.iv = e.iv, this.destroyUserInfoButton(), n = new t.SDKEntity.UserInfoEntity, function (t, e) {
                null != t.nickName && (e.name = t.nickName),
                null != t.avatarUrl && (e.headUrl = t.avatarUrl),
                null != t.gender && (e.sex = t.gender),
                null != t.city && (e.city = t.city),
                null != t.province && (e.province = t.province),
                null != t.country && (e.country = t.country),
                null != t.language && (e.language = t.language)
            }
                (e.userInfo, n), Z.instance.update(n), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_SUCCESS,
                    msg: "授权成功"
                })) : (console.log("获取用户信息失败！"), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_FAILED,
                    msg: "用户拒绝授权"
                })),
            this.profileToServer && Xt.instance.postProfile(n)
        }
        createUserInfoButton() {}
        destroyUserInfoButton() {
            this.profileBtn && this.profileBtn.destroy(),
            this.profileBtn = null
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        setKeepScreenOn(t) {
            hbs.setKeepScreenOn({
                keepScreenOn: !0,
                success: function () {
                    console.log("setKeepScreenOn success")
                },
                fail: function () {
                    console.log("setKeepScreenOn fail")
                },
                complete: function () {
                    console.log("setKeepScreenOn complete")
                }
            })
        }
        onShow(t) {
            hbs.onShow(t)
        }
        onHide(t) {
            hbs.onHide(t)
        }
        checkUpdate() {}
        loadSubpackage(t) {
            return hbs.loadSubpackage ? hbs.loadSubpackage(t) : null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            hbs.showModal({
                title: e,
                content: t,
                showCancel: "" != u && null != u,
                cancelText: u,
                confirmText: n,
                success: t => {
                    t.confirm ? a && a.run() : t.cancel && u && g && g.run()
                }
            })
        }
        getSystemInfo(t) {
            return !t && this.systemInfo || (!this.systemInfo && hbs.getSystemInfo && (this.systemInfo = new it, this.systemInfo.model = "PAAM00", hbs.getSystemInfo({
                        success: function (t) {
                            console.log("获取系统信息:" + JSON.stringify(t)),
                            this.systemInfo = t
                        },
                        fail: function () {
                            console.log("getSystemInfo fail")
                        },
                        complete: function () {
                            console.log("getSystemInfo complete")
                        }
                    })), console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo))),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            if (!t && this.menuInfo)
                return this.menuInfo;
            let e = {
                width: 0,
                height: 0,
                statusBarHeight: 0
            };
            return "Android" === kwaigame.platform ? (e.width = 720, e.height = 64, e.statusBarHeight = 80) : "iOS" === kwaigame.platform && (e.width = 750, e.height = 64, e.statusBarHeight = 88),
            this.menuInfo = {
                width: e.width,
                height: e.height,
                top: e.statusBarHeight,
                right: Laya.stage.width,
                bottom: Laya.stage.height - e.height,
                left: Laya.stage.width - e.width
            },
            this.menuInfo
        }
        exit() {
            hbs.exitApplication({
                success: function () {
                    console.log("exitApplication success")
                },
                fail: function () {
                    console.log("exitApplication fail")
                },
                complete: function () {
                    console.log("exitApplication complete")
                }
            })
        }
        getLaunchOptionsSync() {
            return hbs.getLaunchOptionsSync()
        }
        navigateToMiniProgram(t) {
            hbs.navigateToQuickApp({
                packageName: t.appId,
                path: t.path,
                extraData: t.extraData,
                success: t.success,
                fail: t.fail
            })
        }
        getOpenDataContext() {
            return null
        }
        createFeedbackButton(t) {
            return null
        }
        openCustomerServiceConversation(t) {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {
            hbs.vibrateShort({})
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        judgeBAndW(e) {
            return e.sceneId && Laya.LocalStorage.getItem("BAndW") === t.BlackAndWhite.White ? t.BlackAndWhite.White : t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(e) {
            hbs.install({
                message: "将快捷方式添加到桌面，以便下次使用。",
                success: n => {
                    console.log("handling install success"),
                    e.success && e.success(),
                    this.addDeskState = t.AddDeskState.Add
                },
                fail: (n, a) => {
                    console.log("handling install fail: " + n + ", errocode: " + a),
                    e.fail && e.fail(),
                    this.addDeskState = t.AddDeskState.NotAdd
                },
                complete: () => {
                    console.log("handling install  complete")
                }
            })
        }
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return this.followedState
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class fe {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(this.curParams.id) ? (v.showTips("今天已经没有视频啦,明天再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : (E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_SUCCESS,
                            way: t.GetRewardSDKWay.VIDEO,
                            gid: e.bindCtrlGId
                        }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_FAIL,
                                gid: e.bindCtrlGId
                            })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && (v.showTips("视频播放失败~"), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_FAIL,
                                gid: e.bindCtrlGId
                            }))
                    })), n.instance.playVideo(e.id))
        }
    }
    class me {
        constructor() {
            this.appBoxBtn = void 0,
            this.banners = [],
            this.videos = [],
            this.interstitial = [],
            this.moreGamesBanner = void 0,
            this.isMoreGamesBanner = !1
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            let a = this.getVideoById(e);
            a || (a = {
                    id: e,
                    inst: null,
                    state: t.VideoState.UNLOAD
                }, this.videos.push(a)),
            a.inst || (a.inst = kwaigame.createRewardedVideoAd({
                    adUnitId: a.id
                }), a.inst ? (a.inst.onReward(e => {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        })
                    }), a.inst.onClose(e => {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                        })
                    })) : (console.log("激励广告组件获取失败"), Laya.timer.once(5e3, this, () => {
                        this.loadVideo(e)
                    })))
        }
        showVideo(e) {
            let n = this.getVideoById(e);
            n && n.inst && n.inst.show({
                success: () => {
                    console.log("激励视频播放成功")
                },
                fail: n => {
                    console.log("激励视频播放失败: " + JSON.stringify(n)),
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    Laya.timer.once(5e3, this, () => {
                        this.getVideoById(e).state = t.VideoState.UNLOAD
                    })
                }
            })
        }
        preloadVideo(e) {
            let n = this.getVideoState(e);
            t.VideoState.UNLOAD === n && this.loadVideo(e)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? n.state : t.VideoState.UNLOAD
        }
        playVideo(t) {
            console.log("video Id", t),
            this.showVideo(t),
            Laya.MouseManager.enabled = !1,
            Laya.MouseManager.enabled || Laya.timer.once(1e4, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {}
        hideBanner(t) {}
        getBannerById(t) {
            return null
        }
        showInterstitial(t) {}
        getInterstitial(t) {
            return null
        }
        preloadInterstitial(t) {}
        init(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {}
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData(t = !1) {
            return null
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    me.BannerRefreshTime = 4e4;
    class ye {
        constructor() {
            this._videoPath = "",
            this.recordData = {
                duration: 120,
                isEndlessMode: !1,
                isDisposeRecord: !1
            },
            this.isStartRecord = !1,
            this.beforeRecordStageId = void 0,
            this.curRecordOdds = void 0,
            this.isRecording = !1,
            this.init()
        }
        init() {
            E.instance.on(st.E_SHARE_RESULT, this, e => {
                this.endlessModeAutoRecord(e.code == t.SdkCode.SHARE_SUCCESS),
                this.isStartRecord = !1,
                e.code === t.SdkCode.SHARE_SUCCESS && (this._videoPath = null)
            })
        }
        onShowFunc() {
            Laya.timer.once(2e3, this, () => {
                this.isStartRecord && E.instance.event(st.E_SHARE_RESULT, {
                    code: t.SdkCode.SHARE_FAILED
                })
            })
        }
        setShare(t, e, n) {}
        share(t, e, n) {
            let a = null,
            u = null,
            g = null,
            p = null,
            m = null,
            y = null,
            S = null;
            t instanceof mt ? (a = t.title, u = t.imgUrl, g = t.iconUrl, p = t.desc, m = t.queryParam, y = t.source, S = t.templateId) : (a = t, u = e, m = n, y = "未知", S = "");
            let _ = "";
            if (m) {
                E.instance.once(f.E_APP_ON_RESUME, this, (function (t) {
                        v.showTips("感谢分享!!!")
                    }));
                for (let t in m) {
                    let e = m[t];
                    null != e && ("object" == typeof e && (e = JSON.stringify(e)), _ = null == _ ? t + "=" + e : _ + "&" + t + "=" + e)
                }
            }
            console.log("wx share queryParam:" + JSON.stringify(m), _),
            kwaigame.shareToMsg({
                title: a,
                desc: p,
                iconUrl: "",
                imageUrl: u,
                extension: {
                    name: _
                },
                response: t => {
                    console.log("分享回调：", JSON.stringify(t))
                }
            })
        }
        canRecord() {
            return kwaigame.isSupport(kwaigame.Support.features.Recorder)
        }
        canShareRecord() {
            return !!this._videoPath
        }
        recordVideo(t) {
            if (!this.isRecording) {
                if (this._videoPath = null, this.isRecording = !0, this.recordData = t, this.recordData.isEndlessMode || (this.recordData.isDisposeRecord = !1), !this._recorder && kwaigame.isSupport(kwaigame.Support.features.Recorder)) {
                    if (this._recorder = kwaigame.createMediaRecorder(), null === this._recorder)
                        return void console.log("当前版本 App 不支持录屏");
                    this._recorder.onStart(t => {
                        console.log("录屏开始 res:" + JSON.stringify(t)),
                        E.instance.event(st.E_RECORD_VIDEO_START, this.recordData.duration)
                    }),
                    this._recorder.onStop(t => {
                        console.log("录屏结束 res:" + JSON.stringify(t)),
                        this._videoPath = t.videoID,
                        this.isRecording = !1,
                        E.instance.event(st.E_RECORD_VIDEO_END, this.recordData.isDisposeRecord)
                    }),
                    this._recorder.onPause((function () {
                            console.log("录屏暂停"),
                            E.instance.event(st.E_RECORD_VIDEO_PAUSE)
                        })),
                    this._recorder.onResume((function () {
                            console.log("录屏恢复"),
                            E.instance.event(st.E_RECORD_VIDEO_RESUME)
                        })),
                    this._recorder.onError(t => {
                        console.error("录屏错误 errMsg:" + JSON.stringify(t)),
                        this.isRecording = !1,
                        E.instance.event(st.E_RECORD_VIDEO_END, this.recordData.isDisposeRecord)
                    })
                }
                this._recorder && this._recorder.start()
            }
        }
        destroyRecord() {}
        stopRecord(t) {
            this._recorder && this.isRecording && (t && this.recordData && (this.recordData.isEndlessMode = !1, this.recordData.isDisposeRecord = !1), this._recorder.stop())
        }
        pauseRecord() {
            this._recorder && this._recorder.pause(t => {
                null == t || null == t || console.log("暂停录屏失败: " + JSON.stringify(t))
            })
        }
        resumeRecord() {
            this._recorder && this._recorder.resume(t => {
                null == t || null == t || console.log("恢复录屏失败: " + JSON.stringify(t))
            })
        }
        shareVideo(t = !1) {
            return t ? !(!this.autoRecord() || !this._videoPath) && (this.shareRecordVideo(), !0) : (this.shareRecordVideo(), !0)
        }
        shareRecordVideo() {
            this._recorder ? (this.isStartRecord = !0, this._recorder.publishVideo({
                    callback: e => {
                        if (null != e && null != e)
                            return v.showTips("分享录屏失败!"), console.log("分享录屏失败: " + JSON.stringify(e)), void E.instance.event(st.E_SHARE_RESULT, {
                                code: t.SdkCode.SHARE_FAILED
                            });
                        console.log("分享录屏成功"),
                        v.showTips("分享录屏成功!"),
                        E.instance.event(st.E_SHARE_RESULT, {
                            code: t.SdkCode.SHARE_SUCCESS
                        }),
                        this.destroyRecord()
                    }
                })) : v.showTips("分享录屏失败~")
        }
        autoRecord() {
            let t = Laya.ClassUtils.getRegClass("Sdk");
            if (!t.instance.isHarvest())
                return console.log("### autoRecord n sg!!!"), !1;
            let e = t.instance.getServerJsonCfg();
            return e ? (console.log(`### autoRecord ${e.record_StartLev}-${e.record_SpaceLev}-${e.record_Odds}-${e.record_AdditionOdds}`), !!this.checkStageOnoff(e.record_StartLev, e.record_SpaceLev, {
                    odd: e.record_Odds,
                    additionOdds: e.record_AdditionOdds
                }) && (console.log("### auto Record"), !0)) : (console.log("### autoRecord 配置为空!!!"), !1)
        }
        endlessModeAutoRecord(t = !1) {
            this.recordData.isEndlessMode && Laya.timer.callLater(this, () => {
                this.recordVideo(this.recordData)
            })
        }
        checkStageOnoff(t, e, n) {
            let a = Z.instance.getUserInfo();
            if (!a.stageId)
                return !1;
            if (!t)
                return console.log("### checkStageOnoff !startLev-" + t), !1;
            if (a.stageId < t)
                return console.log(`### checkStageOnoff userInfo.stageId<startLev-${a.stageId}-${t}`), !1;
            if (this.beforeRecordStageId && Math.abs(this.beforeRecordStageId - a.stageId) < e + 1)
                return console.log(`### checkStageOnoff 第${this.beforeRecordStageId}关已经触发自动分享`), !1;
            this.curRecordOdds || (this.curRecordOdds = n.odd),
            this.curRecordOdds > 1 && (this.curRecordOdds = this.curRecordOdds / 100);
            let u = Math.random();
            return u > this.curRecordOdds ? (console.log(`### checkStageOnoff random>this.curRecordOdds-${u}-${this.curRecordOdds}`), this.curRecordOdds < 1 && (this.curRecordOdds = 100 * this.curRecordOdds), this.curRecordOdds += n.additionOdds, !1) : (this.curRecordOdds = n.odd, this.beforeRecordStageId = a.stageId, !0)
        }
    }
    Laya.ClassUtils.regClass("KSShare", ye);
    class Se extends x {
        constructor() {
            super(),
            this.followedState = t.FollowedState.NotGot,
            this.addDeskState = t.AddDeskState.NotGot
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg;
            kwaigame.init({
                appId: e.appId
            }),
            kwaigame.login({
                success: this.ksloginSucc.bind(this),
                fail: this.ksloginFail.bind(this)
            }),
            kwaigame.getSetting && kwaigame.getSetting({
                success: this.onSettings.bind(this)
            }),
            this.networkstate = "none",
            this.getSystemInfo(),
            this.checkFollowAwemeState({
                success: () => {
                    this.followedState = t.FollowedState.Followed
                },
                fail: () => {
                    this.followedState = t.FollowedState.Unfollowed
                }
            }),
            this.checkAddDeskState(),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "快手登录成功！"
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                n && n.runWith(t)
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (n) {
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    n.runWith(JSON.parse(e))
                }
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        getShareInstance() {
            return new ye
        }
        getAdvInstance() {
            return new me
        }
        getStatInstance() {
            return null
        }
        getRewardStrInstance() {
            return new fe
        }
        onSettings(t) {
            let e = t;
            this.isUserInfoAuth = !!e["Scope.userInfo"],
            this.isUserInfoAuth && kwaigame.getUserInfo({
                success: this.userInfoSucc.bind(this)
            }),
            this.code
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        isLoginServer() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.isLoginServer(),
            this.createUserInfoButton()
        }
        onResume(t) {
            t.query && !v.isEmpty(t.query) && this.isLoginServer() && (this.query = t.query, Xt.instance.postShareQuery(t.query))
        }
        ksloginSucc(t) {
            console.log("快手登录成功！");
            this.code = t.isLogin ? t.code : "",
            this.isLoginServer() && Xt.instance.login(this.code, null.query),
            this.isUserInfoAuth
        }
        ksloginFail() {
            console.log("快手登录失败！")
        }
        userInfoSucc(e) {
            let n;
            e.userInfo ? (console.log("获取用户信息成功！" + JSON.stringify(e)), this.isUserInfoAuth = !0, this.encryptedData = e.encryptedData, this.iv = e.iv, this.destroyUserInfoButton(), n = new t.SDKEntity.UserInfoEntity, function (t, e) {
                null != t.nickName && (e.name = t.nickName),
                null != t.avatarUrl && (e.headUrl = t.avatarUrl),
                null != t.gender && (e.sex = t.gender),
                null != t.city && (e.city = t.city),
                null != t.province && (e.province = t.province),
                null != t.country && (e.country = t.country),
                null != t.language && (e.language = t.language)
            }
                (e.userInfo, n), Z.instance.update(n), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_SUCCESS,
                    msg: "授权成功"
                })) : (console.log("获取用户信息失败！"), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_FAILED,
                    msg: "用户拒绝授权"
                })),
            this.profileToServer && Xt.instance.postProfile(n)
        }
        createUserInfoButton() {}
        destroyUserInfoButton() {
            this.profileBtn && this.profileBtn.destroy(),
            this.profileBtn = null
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        setKeepScreenOn(t) {}
        onShow(t) {}
        onHide(t) {}
        checkUpdate() {}
        loadSubpackage(t) {
            return kwaigame.loadSubpackage ? kwaigame.loadSubpackage(t) : null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo(t) {
            return !t && this.systemInfo || (!this.systemInfo && kwaigame.getSystemInfo && (this.systemInfo = new it, this.systemInfo.model = "PAAM00", kwaigame.getSystemInfo({
                        response: t => {
                            console.log("获取系统信息:" + JSON.stringify(t)),
                            this.systemInfo = t
                        }
                    })), console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo))),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            if (!t && this.menuInfo)
                return this.menuInfo;
            let e = {
                width: 0,
                height: 0,
                statusBarHeight: 0
            };
            return "Android" === kwaigame.platform ? (e.width = 720, e.height = 64, e.statusBarHeight = 80) : "iOS" === kwaigame.platform && (e.width = 750, e.height = 64, e.statusBarHeight = 88),
            this.menuInfo = {
                width: e.width,
                height: e.height,
                top: e.statusBarHeight,
                right: Laya.stage.width,
                bottom: Laya.stage.height - e.height,
                left: Laya.stage.width - e.width
            },
            this.menuInfo
        }
        exit() {
            kwaigame.willClose()
        }
        getLaunchOptionsSync() {
            return null
        }
        navigateToMiniProgram(t) {}
        getOpenDataContext() {
            return null
        }
        createFeedbackButton(t) {
            return null
        }
        openCustomerServiceConversation(t) {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {
            kwaigame.vibrateShort && kwaigame.vibrateShort({})
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        judgeBAndW(e) {
            return e.sceneId && Laya.LocalStorage.getItem("BAndW") === t.BlackAndWhite.White ? t.BlackAndWhite.White : t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(e) {
            this.addDeskState === t.AddDeskState.Add ? (console.log("桌面图标已存在！"), e.success && e.success()) : this.addDeskState === t.AddDeskState.NotAdd ? kwaigame.saveAPKShortcut(t => {
                console.log("添加完成：", JSON.stringify(t)),
                -10005 === t.code || (1 === t.code ? setTimeout(() => {
                        this.checkAddDeskState(e)
                    }, 500) : this.checkAddDeskState(e))
            }) : e.fail && e.fail()
        }
        getAddDeskState() {
            return this.addDeskState
        }
        checkAddDeskState(e) {
            kwaigame.getAPKShortcutInstallStatus(n => {
                console.log("查询完成：", JSON.stringify(n)),
                -10005 === n.code ? (this.addDeskState = t.AddDeskState.FailAdd, e && e.fail && e.fail()) : 1 === n.code ? n.installed ? (this.addDeskState = t.AddDeskState.Add, e && e.success && e.success()) : (this.addDeskState = t.AddDeskState.NotAdd, e && e.fail && e.fail()) : (this.addDeskState = t.AddDeskState.FailAdd, e && e.fail && e.fail())
            })
        }
        showFavoriteGuide(t) {}
        FollowAwemeUser(e) {
            if (kwaigame.openUserProfile) {
                var n = (() => {
                    e.success && (e.success(), this.followedState = t.FollowedState.Followed)
                }).bind(this),
                a = (() => {
                    e.fail && (e.fail(), this.followedState = t.FollowedState.Unfollowed)
                }).bind(this);
                kwaigame.openUserProfile({
                    accountType: "CPServiceAccount",
                    callback: e => {
                        console.log("---- open success, res: ", JSON.stringify(e)),
                        e && 1 === e.errorCode ? Laya.timer.callLater(this, () => {
                            kwaigame.checkFollowState({
                                accountType: "CPServiceAccount",
                                callback: e => {
                                    console.log("---- check success, res:", JSON.stringify(e)),
                                    -10005 === e.errorCode ? (this.followedState = t.FollowedState.NotSupport, v.showTips("暂未开启，敬请期待~")) : e && e.hasFollow ? n() : a()
                                }
                            })
                        }) : a()
                    }
                })
            }
        }
        getFollowAwemeState() {
            return this.followedState
        }
        checkFollowAwemeState(e) {
            kwaigame.checkFollowState && kwaigame.checkFollowState({
                accountType: "CPServiceAccount",
                callback: n => {
                    console.log("---- check success, res:", JSON.stringify(n)),
                    -10005 === n.errorCode ? this.followedState = t.FollowedState.NotSupport : n && n.hasFollow ? e.success && e.success() : e.fail && e.fail()
                }
            })
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class _e {
        constructor() {
            this.banners = [],
            this.videos = [],
            this.interstitial = []
        }
        getVideoById(t) {}
        loadVideo(t, e = !1) {}
        showVideo(t) {}
        preloadVideo(t, e) {}
        getVideoState(e) {
            return t.VideoState.UNLOAD
        }
        playVideo(t) {}
        preloadBanner(t, e) {}
        showBanner(t, e) {}
        hideBanner(t) {}
        getBannerById(t) {}
        showInterstitial(t, e) {}
        getInterstitial(t) {}
        preloadInterstitial(t) {}
        showFullScreenVideo(t) {}
        init(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd(t) {}
        reportAdClickNativeAd() {}
        getNativeAdData(t) {}
        preloadAppbox(t) {}
        showAppBox(t, e) {}
        hideAppBox(t, e) {}
        destoryAppBox() {}
        getAppBoxData() {
            let t = [],
            e = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfg();
            if (e && e.navigateAppList) {
                for (let n = 0; n < e.navigateAppList.length; ++n) {
                    let a = e.navigateAppList[n];
                    a && a.appId && (a.shield || t.push(a))
                }
                return t
            }
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd(t, e) {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    _e.BannerRefreshTime = 4e4;
    class Ae {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            console.log(`获取奖励源[${this.curParams.source}]-获取奖励方式[${t.GetRewardSDKWay.VIDEO}]`);
            /*Laya.ClassUtils.getRegClass("Sdk").instance.sendEvent("视频", {
                "打开": this.curParams.source
            }),*/
            var self = this;
            window.GlobalGame.showRewardVideo('video', function() {
                E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_SUCCESS,
                    way: self.getStrategy(),
                    gid: self.curParams.bindCtrlGId
                })
            })
        }
    }
    class Ie {
        constructor() {}
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg,
            n = Z.instance.getMine();
            n.openId = e.user_unique_id,
            n.name = n.name || "test_user",
            n.headUrl = n.headUrl || "",
            this.loginServerEnable() ? Xt.instance.loginNoAuth() : E.instance.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                n && n.runWith(t)
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (n) {
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    n.runWith(JSON.parse(e))
                }
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        onResume() {}
        getQuery() {}
        setKeepScreenOn(t) {}
        onShow(t) {
            Laya.stage.on(Laya.Event.VISIBILITY_CHANGE, this, () => {
                Laya.stage.isVisibility && t()
            })
        }
        onHide(t) {
            Laya.stage.on(Laya.Event.VISIBILITY_CHANGE, this, () => {
                Laya.stage.isVisibility || t()
            })
        }
        isAuth() {
            return !0
        }
        auth(t) {}
        destroyUserInfoButton() {}
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        checkUpdate() {}
        loadSubpackage(t) {}
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            v.showTips(t)
        }
        getSystemInfo() {
            return {
                SDKVersion: "0.0.0"
            }
        }
        getMenuButtonBoundingClientRect() {
            return null
        }
        exit() {}
        getLaunchOptionsSync() {}
        navigateToMiniProgram(t) {}
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation() {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {}
        getShareInstance() {}
        getAdvInstance() {
            return new _e
        }
        getStatInstance() {}
        getRewardStrInstance() {
            return new Ae
        }
        getNetworkType() {
            return "wifi"
        }
        isConnectNetwork() {
            return !0
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.White
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class ve {
        constructor() {
            this.isPreload = !1,
            this.bridge = Ht.Instance
        }
        init(t) {}
        preloadVideo(t, e) {
            e && (this.isPreload = !0),
            this.bridge.preloadVideo()
        }
        playVideo(t) {
            E.instance.once(st.E_REWARD_GAIN, this, t => {
                setTimeout(() => {
                    this.preloadVideo(null)
                }, 1e3)
            }),
            this.bridge.showRewardVideo()
        }
        getVideoState(e) {
            return t.VideoState.ENABLED
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {
            this.bridge.showBanner()
        }
        hideBanner(t) {
            this.bridge.closeBanner()
        }
        getBannerById(t) {
            return null
        }
        preloadInterstitial(t) {}
        showInterstitial(t, e) {
            this.bridge.showFullScreenVideo(e)
        }
        showFullScreenVideo(t) {
            this.bridge.showInterstitialAd()
        }
        preloadNativeAd(t) {}
        showNativeAd(e, n) {
            n || (n = {
                    nativeAdType: t.NativeAdType.BANNER
                }),
            this.bridge.showNativeAd(n.nativeAdType)
        }
        destoryNativeAd(t) {
            this.bridge.destoryNativeAd(t)
        }
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {
            this.bridge.jumpLeisureSubject()
        }
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return [1, 1]
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    class we {
        constructor() {
            this.bridge = Ht.Instance
        }
        sendEvent(t, e) {
            this.bridge.customEvent(t, e)
        }
        stageOnStart(t) {
            this.bridge.startLeve(t.stageId)
        }
        stageOnRunning(t) {}
        stageOnEnd(t) {
            t.event && "string" == typeof t.event && "success" == t.event ? this.bridge.finishLevel(t.stageId) : this.bridge.failLevel(t.stageId)
        }
        unlockItem(t) {
            t && this.bridge.skinUnlock(t.id)
        }
    }
    class Le {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(this.curParams.id) ? (v.showTips("今天已经没有视频啦,明天再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : (E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_SUCCESS,
                            way: t.GetRewardSDKWay.VIDEO,
                            gid: e.bindCtrlGId
                        }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_FAIL,
                                gid: e.bindCtrlGId
                            })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_FAIL,
                            gid: e.bindCtrlGId
                        })
                    })), n.instance.playVideo(e.id))
        }
    }
    class Ee {
        constructor() {
            this.bridge = Ht.Instance
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            Laya.ClassUtils.getRegClass("Sdk").instance.adIds = {
                videoId: "11",
                nativeAdId: ["22", "33"],
                bannerId: "44",
                interstitialId: "55",
                appBoxId: "66",
                blockId: "77"
            },
            this.bridge.login(this.onLoginEvent.bind(this))
        }
        onLoginEvent(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk").GameCfg;
            if (0 == e.code) {
                let n = e.userInfo,
                a = Z.instance.getMine();
                a.openId = n.sid,
                a.userId = n.uid,
                this.nickName = a.name = n.userName,
                E.instance.event(st.E_SDK_LOGIN, {
                    code: t.SdkCode.WX_LOGIN_SUCCESS
                })
            } else {
                console.error(`233登录失败! code:${e.code} msg:${e.msg}`),
                Z.instance.getMine().openId = n.user_unique_id,
                E.instance.event(st.E_SDK_LOGIN, {
                    code: t.SdkCode.WX_LOGIN_SUCCESS
                })
            }
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (n && n.runWith(t), t) {
                    let e = !0;
                    e = Boolean(t.openAntiAddiction),
                    this.bridge.openAntiAddiction(e)
                }
            }),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (t) {
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    e = JSON.parse(e),
                    n && n.runWith(e);
                    let a = !0;
                    a = Boolean(e.openAntiAddiction),
                    this.bridge.openAntiAddiction(a)
                }
            }),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        onResume() {}
        getQuery() {}
        setKeepScreenOn(t) {}
        onShow(t) {
            this.bridge.setOnShowCallBack(t)
        }
        onHide(t) {
            this.bridge.setOnHideCallBack(t)
        }
        isAuth() {
            return !0
        }
        auth(t) {}
        destroyUserInfoButton() {}
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        checkUpdate() {}
        loadSubpackage(t) {}
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo() {
            return {}
        }
        getMenuButtonBoundingClientRect() {
            return null
        }
        exit() {
            this.bridge.exitGame()
        }
        getLaunchOptionsSync() {}
        navigateToMiniProgram(t) {
            this.bridge.jumpMarketToApp()
        }
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation() {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {
            this.bridge.vibrateShort()
        }
        getShareInstance() {
            return null
        }
        getAdvInstance() {
            return new ve
        }
        getStatInstance() {
            return new we
        }
        getRewardStrInstance() {
            return new Le
        }
        getNetworkType() {
            return "unknown"
        }
        isConnectNetwork() {
            return !1
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {
            return this.nickName
        }
        clipboardData(t) {
            this.bridge.clipboardData(t)
        }
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class xe {
        constructor() {
            this.bridge = Ht.Instance
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk"),
            n = e.GameCfg;
            e.instance.adIds = {
                videoId: "11",
                nativeAdId: ["22", "33"],
                bannerId: "44",
                interstitialId: "55",
                appBoxId: "66",
                blockId: "77"
            };
            let a = Z.instance.getMine();
            a.openId = n.user_unique_id,
            a.name = "taptap_user",
            a.headUrl = "",
            this.loginServerEnable() ? Xt.instance.loginNoAuth() : E.instance.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (n && n.runWith(t), t) {
                    let e = !0;
                    e = Boolean(t.openAntiAddiction),
                    this.bridge.openAntiAddiction(e)
                }
            }),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (t) {
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    e = JSON.parse(e),
                    n && n.runWith(e);
                    let a = !0;
                    a = Boolean(e.openAntiAddiction),
                    this.bridge.openAntiAddiction(a)
                }
            }),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        onResume() {}
        getQuery() {}
        setKeepScreenOn(t) {}
        onShow(t) {
            this.bridge.setOnShowCallBack(t)
        }
        onHide(t) {
            this.bridge.setOnHideCallBack(t)
        }
        isAuth() {
            return !0
        }
        auth(t) {}
        destroyUserInfoButton() {}
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        checkUpdate() {}
        loadSubpackage(t) {}
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo() {
            return {}
        }
        getMenuButtonBoundingClientRect() {
            return null
        }
        exit() {
            this.bridge.exitGame()
        }
        getLaunchOptionsSync() {}
        navigateToMiniProgram(t) {
            this.bridge.jumpMarketToApp()
        }
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation() {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {
            this.bridge.vibrateShort()
        }
        getShareInstance() {
            return null
        }
        getAdvInstance() {
            return new ve
        }
        getStatInstance() {
            return new we
        }
        getRewardStrInstance() {
            return new Le
        }
        getNetworkType() {
            return "unknown"
        }
        isConnectNetwork() {
            return !1
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {
            this.bridge.clipboardData(t)
        }
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class Ce {
        constructor() {
            this.bridge = Ht.Instance
        }
        init(t) {}
        preloadVideo(t) {}
        playVideo(e) {
            E.instance.once(st.E_REWARD_GAIN, this, n => {
                n.code == t.SdkCode.REWARD_GAIN_SUCCESS && this.preloadVideo(e)
            }),
            this.bridge.showRewardVideo()
        }
        getVideoState(e) {
            return t.VideoState.ENABLED
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {
            this.bridge.showBanner()
        }
        hideBanner(t) {
            this.bridge.closeBanner()
        }
        getBannerById(t) {
            return null
        }
        preloadInterstitial(t) {}
        showInterstitial(t, e) {
            this.bridge.showFullScreenVideo(e)
        }
        showFullScreenVideo(t) {
            this.bridge.showInterstitialAd()
        }
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {
            this.bridge.jumpLeisureSubject()
        }
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return [1, 1]
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    class be {
        constructor() {
            this.bridge = Ht.Instance
        }
        sendEvent(t, e) {
            this.bridge.customEvent(t)
        }
        stageOnStart(t) {
            this.bridge.startLeve(t.stageId)
        }
        stageOnRunning(t) {}
        stageOnEnd(t) {
            t.event && "string" == typeof t.event && "success" == t.event ? this.bridge.finishLevel(t.stageId) : this.bridge.failLevel(t.stageId)
        }
        unlockItem(t) {
            t && this.bridge.skinUnlock(t.id)
        }
    }
    class Ne {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(this.curParams.id) ? (v.showTips("今天已经没有视频啦,明天再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : (E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_SUCCESS,
                            way: t.GetRewardSDKWay.VIDEO,
                            gid: e.bindCtrlGId
                        }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_FAIL,
                                gid: e.bindCtrlGId
                            })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_FAIL,
                            gid: e.bindCtrlGId
                        })
                    })), n.instance.playVideo(e.id))
        }
    }
    class De {
        constructor() {
            this.bridge = Ht.Instance
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk"),
            n = e.GameCfg;
            e.instance.adIds = {
                videoId: "11",
                nativeAdId: ["22", "33"],
                bannerId: "44",
                interstitialId: "55",
                appBoxId: "66",
                blockId: "77"
            };
            let a = Z.instance.getMine();
            a.openId = n.user_unique_id,
            a.name = "ios_user",
            a.headUrl = "",
            this.loginServerEnable() ? Xt.instance.loginNoAuth() : E.instance.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, (function (t) {
                    n && n.runWith(t)
                })),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, (function (t) {
                    if (n) {
                        let e = window.pako.inflate(t, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                })),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        onResume() {}
        getQuery() {}
        setKeepScreenOn(t) {}
        onShow(t) {
            this.bridge.setOnShowCallBack(t)
        }
        onHide(t) {
            this.bridge.setOnHideCallBack(t)
        }
        isAuth() {
            return !0
        }
        auth(t) {}
        destroyUserInfoButton() {}
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        checkUpdate() {}
        loadSubpackage(t) {}
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo() {
            return {}
        }
        getMenuButtonBoundingClientRect() {
            return null
        }
        exit() {}
        getLaunchOptionsSync() {}
        navigateToMiniProgram(t) {}
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation() {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {
            this.bridge.vibrateShort()
        }
        getShareInstance() {
            return null
        }
        getAdvInstance() {
            return new Ce
        }
        getStatInstance() {
            return new be
        }
        getRewardStrInstance() {
            return new Ne
        }
        getNetworkType() {
            return "unknown"
        }
        isConnectNetwork() {
            return !1
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {
            this.bridge.clipboardData(t)
        }
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class Me {
        constructor() {
            this.imgPath = {
                closePath: null,
                bgPath: null
            },
            this.adStartInfo = {
                startTime: 0,
                isAllow: !1
            },
            this.nativeIndex = 0,
            this.banners = [],
            this.videos = [],
            this.gameBoxAds = [],
            this.interstitialAd = void 0,
            this.nativeAd = new Array,
            this.nativeAdImg = void 0,
            this.checkAd = void 0,
            this.curNativeAdIndex = 0,
            this.nativeAdParentInfo = {
                nativeAdType: t.NativeAdType.NATIVE,
                parent: null,
                adPos: null,
                btnPos: null,
                btnHarvestPos: null,
                adSize: null
            },
            this.nativeIconAd = {
                nativeImg: void 0,
                id: void 0,
                isLoad: !1,
                inst: void 0,
                adList: void 0
            },
            this.nativeAdData = void 0,
            this.adStartInfo.startTime = v.getTime(),
            this.adStartInfo.isAllow = !1,
            this.gameBannerAd = void 0,
            this.gamePortalAd = void 0,
            this.customAds = []
        }
        isAllowShowAd() {
            if (!this.adStartInfo.isAllow) {
                let t = ((new Date).getTime() - this.adStartInfo.startTime) / 1e3;
                this.adStartInfo.isAllow = t > 60
            }
            return fx.Sdk.instance.isHarvest() && (this.adStartInfo.isAllow = !0),
            this.adStartInfo.isAllow = !0,
            this.adStartInfo.isAllow
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            let a = this.getVideoById(e);
            a || (a = {
                    id: e,
                    inst: null,
                    state: t.VideoState.UNLOAD
                }, this.videos.push(a)),
            a.inst ? (a.inst.load(), Laya.timer.clear(this, this.autoPreloadVideo)) : (a.inst = qg.createRewardedVideoAd({
                    adUnitId: e
                }), a.inst.onLoad(() => {
                    console.log("激励视频广告加载成功"),
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    a.state = t.VideoState.ENABLED,
                    n && a.inst.show()
                }), a.inst.onError(e => {
                    if (console.log("激励视频广告加载失败", JSON.stringify(e)), !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), a.state = t.VideoState.UNLOAD, E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                        }), n) {
                        Laya.ClassUtils.getRegClass("Sdk").instance.hideLoading()
                    }
                }), a.inst.onClose(n => {
                    n && n.isEnded || void 0 === n ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                        })),
                    Laya.ClassUtils.getRegClass("Sdk").instance.hideLoading(),
                    Laya.timer.once(1e3, this, this.autoPreloadVideo, [e])
                }), a.inst.load())
        }
        autoPreloadVideo(t) {
            let e = this.getVideoById(t);
            e && e.inst && e.inst.load()
        }
        showVideo(t) {
            let e = this.getVideoById(t);
            e && e.inst && e.inst.show()
        }
        preloadVideo(e) {
            let n = this.getVideoState(e);
            t.VideoState.UNLOAD === n && this.loadVideo(e)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? n.state : t.VideoState.UNLOAD
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            n.instance.showLoading("加载中...");
            let a = this.getVideoState(e);
            t.VideoState.UNLOAD === a ? (Laya.MouseManager.enabled = !1, this.loadVideo(e, !0)) : t.VideoState.ENABLED === a ? (Laya.MouseManager.enabled = !1, this.showVideo(e)) : t.VideoState.UNENABLED === a && (v.showTips("暂无视频，请稍后再试!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                }), n.instance.hideLoading(), Laya.timer.once(1e3, this, this.autoPreloadVideo, [e])),
            Laya.MouseManager.enabled || Laya.timer.once(5e3, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    n.instance.hideLoading()
                }))
        }
        preloadBanner(e, n) {
            if (!this.isAllowShowAd())
                return;
            let a = this.getBannerById(e);
            if (a ? n || (n = a.customParams) : (!n && (n = {
                            forever: !1,
                            widthScaleRate: 1
                        }), !n.widthScaleRate && (n.widthScaleRate = 1), n.forever = Boolean(n.forever), a = {
                        id: e,
                        state: t.AdState.LOADING,
                        inst: null,
                        showCnt: 0,
                        createStamp: v.getTime(),
                        customParams: n
                    }, this.banners.push(a)), a.inst)
                t.AdState.DELETING !== a.state && t.AdState.LOAD_FAIL !== a.state || (a.inst.destroy(), a.inst = null, a.showCnt = 0, a.state = t.AdState.LOADING, this.preloadBanner(e));
            else {
                let u = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo();
                u.screenWidth,
                n.widthScaleRate;
                a.inst = qg.createBannerAd({
                    adUnitId: e,
                    style: {
                        top: u.screenHeight - 300,
                        left: 0,
                        width: u.screenWidth,
                        height: 300
                    }
                }),
                a.inst.onResize(t => {
                    a.inst.style.left = (u.screenWidth - t.width) / 2,
                    a.inst.style.top = u.screenHeight - t.height
                }),
                a.inst.show(),
                a.inst.onShow(() => {
                    console.log("bannerid${bannerIds[i]} 广告加载成功"),
                    a.state = t.AdState.LOAD
                }),
                a.inst.onError(e => {
                    console.log("bannerid${bannerIds[i]} 广告加载失败", JSON.stringify(e)),
                    a.state = t.AdState.LOAD_FAIL,
                    E.instance.event(st.E_AD_BANNER, {
                        code: t.SdkCode.AD_BANNER_FAIL
                    })
                })
            }
        }
        showBanner(e, n) {
            if (!this.isAllowShowAd())
                return;
            let a = this.getBannerById(e);
            if (a) {
                if (a.customParams.forever)
                    return;
                t.AdState.LOAD === a.state ? (a.showCnt++, a.inst.show()) : this.preloadBanner(e)
            } else
                this.preloadBanner(e, n)
        }
        hideBanner(e) {
            let n = this.getBannerById(e);
            n && (n.inst && (n.inst.hide(), n.inst.destroy(), n.inst = null), n.showCnt = 0, n.state = t.AdState.DELETING)
        }
        getBannerById(t) {
            return this.banners.filter((e, n, a) => e.id === t, this)[0]
        }
        showInterstitial(e) {
            this.interstitialAd || (this.interstitialAd = qg.createInsertAd({
                    posId: e
                }), this.interstitialAd.onLoad(() => {
                    console.log("interstitial 广告加载成功"),
                    this.interstitialAd.show(),
                    E.instance.event(st.E_AD_INTERSTITIAL, {
                        code: t.SdkCode.AD_INTERSTITIAL_SUCCESS
                    })
                }), this.interstitialAd.onError(e => {
                    console.log("interstitial 广告加载失败", JSON.stringify(e)),
                    E.instance.event(st.E_AD_INTERSTITIAL, {
                        code: t.SdkCode.AD_INTERSTITIAL_FAIL
                    })
                }), this.interstitialAd.onClose(() => {
                    console.log("interstitial 广告关闭"),
                    E.instance.event(st.E_AD_INTERSTITIAL, {
                        code: t.SdkCode.AD_INTERSTITIAL_CLOSE
                    })
                })),
            this.interstitialAd && this.interstitialAd.load()
        }
        getInterstitial(t) {
            return null
        }
        preloadInterstitial(t) {}
        init(t) {}
        createNativeAd(e) {
            if (!this.nativeAdImg)
                switch (console.log("adList:", e), E.instance.event(st.E_AD_NATIVE, {
                        code: t.SdkCode.AD_NATIVE_SUCCESS
                    }), this.nativeAdParentInfo.nativeAdType) {
                case t.NativeAdType.ICON:
                    this.createNativeIconAd(e);
                    break;
                case t.NativeAdType.BANNER:
                    this.createNativeBannerAd(e);
                    break;
                case t.NativeAdType.NATIVE:
                    this.createNativeBigAd(e)
                }
        }
        createNativeBigAd(t) {
            this.nativeAdImg = new Laya.Image,
            this.loadImage(this.nativeAdImg, t.imgUrlList[0]),
            this.nativeAdImg.anchorX = .5,
            this.nativeAdImg.anchorY = 0,
            this.nativeAdImg.name = "nativeAdImg",
            this.nativeAdImg.size(this.nativeAdParentInfo.adSize.w, this.nativeAdParentInfo.adSize.h),
            this.nativeAdImg.pos(this.nativeAdParentInfo.adPos.x, this.nativeAdParentInfo.adPos.y),
            this.nativeAdParentInfo.parent.addChild(this.nativeAdImg);
            let e = new Laya.Image;
            this.loadImage(e, "res/img_tips.png"),
            e.size(60, 40),
            e.sizeGrid = "15,15,15,15",
            e.bottom = e.right = 0,
            e.zOrder = 2,
            this.nativeAdImg.addChild(e);
            let n = new Laya.Label;
            n.text = "广告",
            n.fontSize = 20,
            n.color = "#ffffff",
            n.centerX = n.centerY = 0,
            e.addChild(n);
            let a = new Laya.Image;
            this.loadImage(a, this.imgPath.closePath),
            a.left = a.top = 0,
            a.size(50, 50),
            a.zOrder = 2,
            this.nativeAdImg.addChild(a),
            this.checkAd = new Laya.Image,
            this.loadImage(this.checkAd, this.imgPath.bgPath),
            this.checkAd.sizeGrid = "20,20,20,20",
            this.checkAd.size(300, 120),
            this.checkAd.anchorX = this.checkAd.anchorY = .5,
            this.checkAd.name = "checkAd",
            this.nativeAdImg.addChild(this.checkAd);
            let u = new Laya.Label;
            u.text = t.clickBtnTxt ? t.clickBtnTxt : "点击查看",
            u.fontSize = 50,
            u.color = "#ffffff",
            u.bold = !0,
            u.anchorX = u.anchorY = .5,
            u.centerX = u.centerY = 0,
            this.checkAd.addChild(u),
            this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdShow({
                adId: this.nativeAd[this.curNativeAdIndex].adList.adId
            }),
            this.nativeAdImg.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation();
                let e = ["checkAd", "nativeAdImg"];
                for (let t = 0; t < e.length; t++)
                    this[e[t]] && (this[e[t]].removeSelf(), this[e[t]].destroy(), this[e[t]] = null);
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            }),
            this.checkAd.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation();
                let e = ["checkAd", "nativeAdImg"];
                for (let t = 0; t < e.length; t++)
                    this[e[t]] && (this[e[t]].removeSelf(), this[e[t]].destroy(), this[e[t]] = null);
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            }),
            a.on(Laya.Event.CLICK, this, t => {
                t.stopPropagation();
                let e = ["checkAd", "nativeAdImg"];
                for (let t = 0; t < e.length; t++)
                    this[e[t]] && (this[e[t]].removeSelf(), this[e[t]].destroy(), this[e[t]] = null)
            }),
            Laya.ClassUtils.getRegClass("Sdk").instance.isHarvest() ? (this.checkAd.pos(this.nativeAdParentInfo.btnHarvestPos.x, this.nativeAdParentInfo.btnHarvestPos.y), u.text = "点击查看") : this.checkAd.pos(this.nativeAdParentInfo.btnPos.x, this.nativeAdParentInfo.btnPos.y)
        }
        createNativeIconAd(t) {
            this.nativeIconAd.nativeImg = new Laya.Image;
            let e = (t.icon ? t.icon : t.iconUrlList[0]) ? t.icon ? t.icon : t.iconUrlList[0] : t.imgUrlList[0];
            this.loadImage(this.nativeIconAd.nativeImg, e),
            this.nativeIconAd.nativeImg.anchorX = .5,
            this.nativeIconAd.nativeImg.anchorY = 0,
            this.nativeIconAd.nativeImg.size(this.nativeAdParentInfo.adSize.h, this.nativeAdParentInfo.adSize.h),
            this.nativeIconAd.nativeImg.pos(this.nativeAdParentInfo.adPos.x, this.nativeAdParentInfo.adPos.y),
            this.nativeAdParentInfo.parent.addChild(this.nativeIconAd.nativeImg);
            let n = new Laya.Image;
            this.loadImage(n, "res/img_tips.png"),
            n.size(60, 40),
            n.sizeGrid = "15,15,15,15",
            n.bottom = n.right = 0,
            n.zOrder = 2,
            this.nativeIconAd.nativeImg.addChild(n);
            let a = new Laya.Label;
            a.text = "广告",
            a.fontSize = 20,
            a.color = "#ffffff",
            a.centerX = a.centerY = 0,
            n.addChild(a);
            let u = new Laya.Image;
            this.loadImage(u, this.imgPath.closePath),
            u.right = u.top = 0,
            u.size(50, 50),
            u.zOrder = 2,
            this.nativeIconAd.nativeImg.addChild(u),
            this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdShow({
                adId: this.nativeAd[this.curNativeAdIndex].adList.adId
            }),
            this.nativeIconAd.nativeImg.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeIconAd.nativeImg.removeSelf(),
                this.nativeIconAd.nativeImg.destroy(),
                this.nativeIconAd.inst && this.nativeIconAd.inst.reportAdClick({
                    adId: this.nativeIconAd.adList.adId
                })
            }),
            u.on(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeIconAd.nativeImg.removeSelf(),
                this.nativeIconAd.nativeImg.destroy()
            }),
            this.nativeIconAd.id = this.nativeAd[this.curNativeAdIndex].id,
            this.nativeIconAd.inst = this.nativeAd[this.curNativeAdIndex].inst,
            this.nativeIconAd.adList = this.nativeAd[this.curNativeAdIndex].adList,
            this.nativeIconAd.isLoad = this.nativeAd[this.curNativeAdIndex].isLoad,
            this.nativeAd[this.curNativeAdIndex].inst = null,
            this.nativeAd[this.curNativeAdIndex].isLoad = !1,
            this.curNativeAdIndex += 1,
            this.curNativeAdIndex > 1 && (this.curNativeAdIndex = 0)
        }
        createNativeBannerAd(t) {
            this.nativeAdImg = new Laya.Box,
            this.nativeAdImg.bgColor = "#ffffff",
            this.nativeAdImg.anchorX = .5,
            this.nativeAdImg.anchorY = 0,
            this.nativeAdImg.name = "nativeAdImg",
            this.nativeAdImg.size(this.nativeAdParentInfo.adSize.w, this.nativeAdParentInfo.adSize.h),
            this.nativeAdImg.pos(this.nativeAdParentInfo.adPos.x, this.nativeAdParentInfo.adPos.y),
            this.nativeAdParentInfo.parent.addChild(this.nativeAdImg);
            let e = 2 * (this.nativeAdParentInfo.adSize.h - 20),
            n = new Laya.Image;
            this.loadImage(n, t.imgUrlList[0]),
            n.left = 0,
            n.centerY = 0,
            n.size(e, e / 2),
            this.nativeAdImg.addChild(n);
            let a = this.nativeAdParentInfo.adSize.h / 2 * 2.5,
            u = new Laya.Image;
            this.loadImage(u, this.imgPath.bgPath),
            u.sizeGrid = "20,20,20,20",
            u.size(a, this.nativeAdParentInfo.adSize.h / 2),
            u.right = 10,
            u.centerY = 0,
            u.name = "checkAd",
            this.nativeAdImg.addChild(u);
            let g = new Laya.Label;
            g.text = t.clickBtnTxt ? t.clickBtnTxt : "点击查看",
            g.fontSize = .4 * u.height,
            g.color = "#ffffff",
            g.bold = !0,
            g.centerX = 0,
            g.centerY = -5,
            u.addChild(g);
            let p = new Laya.Label;
            p.text = t.title,
            p.fontSize = 30,
            p.bold = !0,
            p.color = "#000000",
            p.left = n.left + e + 10,
            p.centerY = -p.fontSize,
            this.nativeAdImg.addChild(p);
            let f = this.nativeAdImg.width - p.left - u.right - u.width - 10,
            m = new Laya.Label;
            m.text = t.desc,
            m.fontSize = 25,
            m.width = f,
            m.height = 2 * m.fontSize,
            m.color = "#000000",
            m.wordWrap = !0,
            m.left = n.left + e + 10,
            m.centerY = m.fontSize,
            this.nativeAdImg.addChild(m);
            let y = new Laya.Image;
            this.loadImage(y, "res/img_tips.png"),
            y.size(60, 40),
            y.sizeGrid = "15,15,15,15",
            y.bottom = y.right = 0,
            y.zOrder = 2,
            this.nativeAdImg.addChild(y);
            let S = new Laya.Label;
            S.text = "广告",
            S.fontSize = 20,
            S.color = "#ffffff",
            S.centerX = S.centerY = 0,
            y.addChild(S);
            let _ = new Laya.Image;
            this.loadImage(_, this.imgPath.closePath),
            _.left = _.top = 0,
            _.size(50, 50),
            _.zOrder = 2,
            this.nativeAdImg.addChild(_),
            this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdShow({
                adId: this.nativeAd[this.curNativeAdIndex].adList.adId
            });
            let touchFunc = t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy(),
                this.nativeAdImg = null,
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            };
            this.nativeAdImg.once(Laya.Event.CLICK, this, touchFunc),
            u.once(Laya.Event.CLICK, this, touchFunc),
            n.once(Laya.Event.CLICK, this, touchFunc),
            _.on(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy(),
                this.nativeAdImg = null
            }),
            Laya.ClassUtils.getRegClass("Sdk").instance.isHarvest() && (g.text = "点击查看")
        }
        loadImage(t, e) {
            if (e && e.length > 0) {
                if (-1 != e.indexOf(".jpg?")) {
                    let t = e.split(".jpg?");
                    e = t[0] + ".jpg"
                } else if (-1 != e.indexOf(".png?")) {
                    let t = e.split(".png?");
                    e = t[0] + ".png"
                } else if (-1 != e.indexOf(".jpg.short")) {
                    let t = e.split(".jpg.short");
                    e = t[0] + ".jpg"
                } else if (-1 != e.indexOf(".png.short")) {
                    let t = e.split(".png.short");
                    e = t[0] + ".png"
                }
                Laya.loader.load(e, Laya.Handler.create(t, e => {
                        e && t && (t.source = e)
                    }), null, Laya.Loader.IMAGE)
            }
        }
        preloadNativeAd(t, e) {
            if (this.imgPath = e, 0 == this.nativeAd.length)
                for (let e = 0; e < t.length; e++)
                    this.nativeAd.push({
                        id: t[e],
                        isLoad: !1,
                        inst: null,
                        adList: null
                    });
            this.loadNativeAd()
        }
        loadNativeAd() {
            var e = qg.createNativeAd({
                adUnitId: this.nativeAd[this.curNativeAdIndex].id
            });
            this.nativeAd[this.curNativeAdIndex].inst = e;
            var n = (t => {
                this.nativeAd[this.curNativeAdIndex].adList = t,
                this.nativeAd[this.curNativeAdIndex].isLoad = !0,
                this.nativeAdParentInfo.parent && this.createNativeAd(this.nativeAd[this.curNativeAdIndex].adList)
            }).bind(this);
            e.onLoad(t => {
                console.log("原生广告加载成功：", JSON.stringify(t.adList)),
                n(t.adList[0])
            });
            var a = (() => {
                this.nativeAd[this.curNativeAdIndex].inst.offLoad(),
                this.nativeAd[this.curNativeAdIndex].inst.offError(),
                this.nativeAd[this.curNativeAdIndex].inst.destroy(),
                this.nativeAd[this.curNativeAdIndex].inst = null,
                this.curNativeAdIndex += 1,
                this.curNativeAdIndex > 1 ? (this.curNativeAdIndex = 0, E.instance.event(st.E_AD_NATIVE, {
                        code: t.SdkCode.AD_NATIVE_FAIL
                    })) : Laya.timer.once(1500, this, this.loadNativeAd)
            }).bind(this);
            e.onError(t => {
                console.log("原生广告加载失败：", JSON.stringify(t)),
                a()
            }),
            e.load()
        }
        showNativeAd(e, n) {
            this.isAllowShowAd() && (this.nativeAdImg && n.nativeAdType != t.NativeAdType.ICON ? (this.destoryNativeAd(), setTimeout(() => {
                        this.showNativeAd(e, n)
                    }, 100)) : (this.nativeAdParentInfo.parent = e, this.nativeAdParentInfo.adPos = {
                        x: e.width / 2,
                        y: n.adPosY
                    }, this.nativeAdParentInfo.btnPos = {
                        x: e.width / 2,
                        y: n.btnPosY
                    }, this.nativeAdParentInfo.btnHarvestPos = {
                        x: e.width / 2,
                        y: n.btnHarvestPosY
                    }, this.nativeAdParentInfo.adSize = {
                        w: Laya.stage.width > Laya.stage.height ? Laya.stage.height : Laya.stage.width,
                        h: n.adSizeH
                    }, n.nativeAdType && (this.nativeAdParentInfo.nativeAdType = n.nativeAdType, n.nativeAdType == t.NativeAdType.ICON && n.adIconPosX && (this.nativeAdParentInfo.adPos.x = n.adIconPosX)), this.nativeAd[this.curNativeAdIndex].isLoad ? this.createNativeAd(this.nativeAd[this.curNativeAdIndex].adList) : this.loadNativeAd()))
        }
        destoryNativeAd(e = t.NativeAdType.NATIVE) {
            if (e == t.NativeAdType.ICON)
                this.nativeIconAd.inst && (this.nativeIconAd.inst.offLoad(), this.nativeIconAd.inst.offError(), this.nativeIconAd.inst.destroy(), this.nativeIconAd.inst = null, this.nativeIconAd.isLoad = !1, this.nativeIconAd.nativeImg && (this.nativeIconAd.nativeImg.removeSelf(), this.nativeIconAd.nativeImg.destroy()));
            else {
                this.nativeAd[this.curNativeAdIndex].inst && (this.nativeAd[this.curNativeAdIndex].inst.offLoad(), this.nativeAd[this.curNativeAdIndex].inst.offError(), this.nativeAd[this.curNativeAdIndex].inst.destroy(), this.nativeAd[this.curNativeAdIndex].inst = null, this.nativeAd[this.curNativeAdIndex].isLoad = !1, this.curNativeAdIndex += 1, this.curNativeAdIndex > 1 && (this.curNativeAdIndex = 0));
                let t = ["checkAd", "nativeAdImg"];
                for (let e = 0; e < t.length; e++)
                    this[t[e]] && (this[t[e]].removeSelf(), this[t[e]].destroy(), this[t[e]] = null)
            }
            this.nativeAdParentInfo.nativeAdType = t.NativeAdType.NATIVE,
            this.nativeAdParentInfo.parent = this.nativeAdParentInfo.adPos = this.nativeAdParentInfo.adSize = this.nativeAdParentInfo.btnPos = this.nativeAdParentInfo.btnHarvestPos = null,
            this.loadNativeAd()
        }
        reportAdClickNativeAd() {
            if (this.nativeAd[this.curNativeAdIndex].inst) {
                this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                });
                let t = ["checkAd", "nativeAdImg"];
                for (let e = 0; e < t.length; e++)
                    this[t[e]] && (this[t[e]].removeSelf(), this[t[e]].destroy(), this[t[e]] = null)
            }
        }
        getNativeAdData(e) {
            let n = e;
            if (!n) {
                let t = Laya.ClassUtils.getRegClass("Sdk");
                n = t.instance.getNativeAdId()
            }
            if (!n || n.length <= 0)
                return void E.instance.event(st.E_AD_NATIVE, {
                    code: t.SdkCode.AD_NATIVE_DATA,
                    data: null
                });
            let a = qg.createNativeAd({
                adUnitId: n[this.nativeIndex]
            });
            a.onLoad((e => {
                    console.log("原生广告加载成功：", JSON.stringify(e.adList)),
                    a.offLoad(),
                    a.offError(),
                    this.nativeIndex = 0,
                    this.nativeAdData = {
                        inst: null,
                        adList: null
                    },
                    this.nativeAdData.inst = a,
                    this.nativeAdData.adList = e.adList[0],
                    E.instance.event(st.E_AD_NATIVE, {
                        code: t.SdkCode.AD_NATIVE_DATA,
                        data: this.nativeAdData
                    })
                }).bind(this));
            a.onError((e => {
                    a.offLoad(),
                    a.offError(),
                    this.nativeIndex += 1,
                    this.nativeIndex >= n.length ? (console.log("原生广告加载失败，结束加载：", JSON.stringify(e)), this.nativeIndex = 0, E.instance.event(st.E_AD_NATIVE, {
                            code: t.SdkCode.AD_NATIVE_DATA,
                            data: this.nativeAdData
                        })) : (console.log("原生广告加载失败，再次加载：", JSON.stringify(e)), setTimeout(() => {
                            this.getNativeAdData(n)
                        }, 500))
                }).bind(this)),
            a.load()
        }
        preloadAppbox(t) {}
        showAppBox(e) {
            qg.getSystemInfoSync().platformVersionCode >= 1076 ? (this.gamePortalAd || (this.gamePortalAd = qg.createGamePortalAd({
                        adUnitId: e
                    }), this.gamePortalAd.onLoad(() => {
                        this.gamePortalAd.show().then(() => {
                            console.log("互推盒子九宫格广告展示成功"),
                            E.instance.event(st.E_AD_APPBOX, {
                                code: t.SdkCode.AD_APPBOX_SUCCESS
                            })
                        }).catch(t => {
                            console.log("互推盒子九宫格广告展示失败:" + t.errCode + "," + t.errMsg),
                            fx.Utils.showTips("九宫格盒子展示失败~")
                        })
                    }), this.gamePortalAd.onClose(() => {
                        E.instance.event(st.E_AD_APPBOX, {
                            code: t.SdkCode.AD_APPBOX_CLOSE
                        })
                    })), this.gamePortalAd.load().then(() => {
                    console.log("互推盒子九宫格广告加载成功")
                }).catch(t => {
                    console.log("互推盒子九宫格广告加载失败:" + t.errCode + "," + t.errMsg),
                    fx.Utils.showTips("九宫格盒子加载失败~")
                })) : console.log("快应用平台版本号低于1076，暂不支持互推盒子相关 API")
        }
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return 1111
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(e, n) {
            let a = this.getGameBoxAdById(e);
            a || (a = {
                    id: e,
                    inst: null
                }, this.gameBoxAds.push(a)),
            n.type && n.type != t.GameBoxType.BannerAd_Old ? n.type == t.GameBoxType.BannerAd_New ? qg.getSystemInfoSync().platformVersionCode >= 1090 ? (a.inst || (a.inst = qg.createGameBannerAd({
                        adUnitId: e,
                        style: {
                            top: n.style && n.style.top ? n.style.top : qg.getSystemInfoSync().screenHeight - 300,
                            orientation: n.orientation ? n.orientation : "horizontal"
                        }
                    }), a.inst.onLoad(() => {
                        console.log("互推盒子横幅广告加载成功")
                    })), a.inst.show().then(() => {
                    console.log("互推横幅广告展示成功"),
                    E.instance.event(st.E_AD_BLOCK, {
                        code: t.SdkCode.AD_BLOCK_SUCCESS
                    })
                }).catch(e => {
                    console.log("互推横幅广告展示失败:" + e.errCode + "," + e.errMsg),
                    E.instance.event(st.E_AD_BLOCK, {
                        code: t.SdkCode.AD_BLOCK_FAIL
                    })
                })) : (console.log("快应用平台版本号低于1090，暂不支持互推盒子相关 API"), E.instance.event(st.E_AD_BLOCK, {
                    code: t.SdkCode.AD_BLOCK_FAIL
                })) : n.type == t.GameBoxType.DrawerAd && (qg.getSystemInfoSync().platformVersionCode >= 1090 ? (a.inst || (a.inst = qg.createGameDrawerAd({
                            adUnitId: e,
                            style: {
                                top: n.style && n.style.top ? n.style.top : qg.getSystemInfoSync().screenHeight / 2 - 150
                            }
                        })), a.inst.show().then(() => {
                        console.log("互推盒子抽屉广告展示成功"),
                        E.instance.event(st.E_AD_BLOCK, {
                            code: t.SdkCode.AD_BLOCK_SUCCESS
                        })
                    }).catch(e => {
                        console.log("互推横幅广告展示失败:" + e.errCode + "," + e.errMsg),
                        E.instance.event(st.E_AD_BLOCK, {
                            code: t.SdkCode.AD_BLOCK_FAIL
                        })
                    })) : (console.log("快应用平台版本号低于1090，暂不支持互推盒子相关 API"), E.instance.event(st.E_AD_BLOCK, {
                        code: t.SdkCode.AD_BLOCK_FAIL
                    }))) : qg.getSystemInfoSync().platformVersionCode >= 1076 ? (a.inst || (a.inst = qg.createGameBannerAd({
                        adUnitId: e
                    }), a.inst.onLoad(() => {
                        console.log("互推盒子横幅广告加载成功")
                    })), a.inst.show().then(() => {
                    console.log("互推横幅广告展示成功"),
                    E.instance.event(st.E_AD_BLOCK, {
                        code: t.SdkCode.AD_BLOCK_SUCCESS
                    })
                }).catch(e => {
                    console.log("互推横幅广告展示失败:" + e.errCode + "," + e.errMsg),
                    E.instance.event(st.E_AD_BLOCK, {
                        code: t.SdkCode.AD_BLOCK_FAIL
                    })
                })) : (console.log("快应用平台版本号低于1076，暂不支持互推盒子相关 API"), E.instance.event(st.E_AD_BLOCK, {
                    code: t.SdkCode.AD_BLOCK_FAIL
                }))
        }
        hideBlockAd(t) {
            if (!t) {
                t = Laya.ClassUtils.getRegClass("Sdk").instance.adIds.blockId
            }
            let e = this.getGameBoxAdById(t);
            e && e.inst && e.inst.hide().then(() => {
                console.log("互推盒子广告隐藏成功")
            }).catch(t => {
                console.log("互推盒子广告隐藏失败:" + t.errCode + "," + t.errMsg)
            })
        }
        getGameBoxAdById(t) {
            return this.gameBoxAds.filter((e, n, a) => e.id === t, this)[0]
        }
        getCustomAdById(t) {
            return this.customAds.filter((e, n, a) => e.id === t, this)[0]
        }
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    Me.BannerRefreshTime = 4e4;
    class Re {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(this.curParams.id) ? (v.showTips("今天已经没有视频啦,明天再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : (E.instance.once(st.E_AD_VIDEO, this, this.playVideoFunc, [e]), n.instance.playVideo(e.id))
        }
        playVideoFunc(e, n) {
            !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
            e || E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_FAIL,
                gid: null
            }),
            t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.VIDEO,
                gid: e.bindCtrlGId
            }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && (v.showTips("视频播放失败~"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                }))
        }
    }
    class ke extends x {
        constructor() {
            super()
        }
        initMiniAdapter() {
            qg.setLoadingProgress({
                progress: 0
            })
        }
        engineInitialized() {}
        getMiniAdapter() {
            return Laya.QGMiniAdapter
        }
        login() {
            this.networkstate = "none",
            qg.getNetworkType({
                success: t => {
                    console.log(">>>>>>>>>>>>>>>>> getNetworkType: ", t.networkType),
                    this.networkstate = t.networkType
                }
            }),
            qg.onNetworkStatusChange(t => {
                console.log(">>>>>>>>>>>>>>>>> onNetworkStatusChange: ", t.isConnected, t.networkType),
                this.networkstate = t.networkType
            }),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "OPPO登录成功！"
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, (function (t) {
                    n && n.runWith(t)
                })),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, (function (t) {
                    if (n) {
                        let e = window.pako.inflate(t, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                })),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        getShareInstance() {
            return null
        }
        getAdvInstance() {
            return new Me
        }
        getStatInstance() {
            return null
        }
        getRewardStrInstance() {
            return new Re
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {}
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.loginServerEnable(),
            this.createUserInfoButton()
        }
        onResume(t) {}
        createUserInfoButton() {}
        destroyUserInfoButton() {}
        setKeepScreenOn(t) {
            qg.setKeepScreenOn(t)
        }
        onShow(t) {
            qg.onShow(t)
        }
        onHide(t) {
            qg.onHide(t)
        }
        checkUpdate() {}
        loadSubpackage(t) {
            return qg.loadSubpackage ? qg.loadSubpackage(t) : null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            qg.showModal({
                title: e,
                content: t,
                confirmText: n,
                cancelText: u,
                success(t) {
                    t.confirm ? a && a.run() : t.cancel && g && g.run()
                },
                fail() {
                    g && g.run()
                }
            })
        }
        getSystemInfo(t) {
            return !t && this.systemInfo || (this.systemInfo = qg.getSystemInfoSync(), console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo))),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            return !t && this.menuInfo,
            this.menuInfo
        }
        exit() {
            qg.exitApplication({})
        }
        getLaunchOptionsSync() {
            return qg.getLaunchOptionsSync()
        }
        navigateToMiniProgram(t) {
            let e = {
                pkgName: t.appId
            };
            qg.navigateToMiniGame(e)
        }
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation(t) {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {
            qg.onAudioInterruptionBegin(t),
            qg.onAudioInterruptionEnd(e)
        }
        vibrateShort() {
            qg.vibrateShort({
                success: function (t) {},
                fail: function (t) {},
                complete: function (t) {}
            })
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.White
        }
        getCode() {}
        saveAppToDesktop(t) {
            qg.hasShortcutInstalled({
                success: e => {
                    0 == e ? qg.installShortcut(t) : console.log("桌面图标已存在...")
                },
                fail: function (t) {},
                complete: function () {}
            })
        }
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {
            qg.getSystemInfoSync().platformVersionCode < 1050 || qg.showLoading({
                title: t || "加载中...",
                success: n && n.success,
                fail: n && n.fail
            })
        }
        hideLoading(t) {
            qg.getSystemInfoSync().platformVersionCode < 1050 || qg.hideLoading({
                success: t && t.success,
                fail: t && t.fail
            })
        }
    }
    class Te {
        constructor() {}
        init(t) {}
        recordVideo(t) {}
        stopRecord(t) {}
        shareVideo(t) {
            return !1
        }
        canRecord() {
            return !1
        }
        canShareRecord() {
            return null
        }
        pauseRecord() {}
        resumeRecord() {}
        destroyRecord() {}
        setShare(t, e, n) {
            qq.showShareMenu({
                withShareTicket: !0
            }),
            n = n || "",
            qq.onShareAppMessage(function () {
                return {
                    title: t,
                    imageUrl: e,
                    query: n
                }
            }
                .bind(this))
        }
        share(e, n, a) {
            let u = null,
            g = null,
            p = null,
            m = null;
            e instanceof mt ? (u = e.title, g = e.imgUrl, p = e.queryParam, m = e.source) : (u = e, g = n, p = a, m = "未知");
            let y = "";
            if (p) {
                E.instance.once(f.E_APP_ON_RESUME, this, (function (t) {
                        v.showTips("感谢分享!!!")
                    }));
                for (let t in p) {
                    let e = p[t];
                    null != e && ("object" == typeof e && (e = JSON.stringify(e)), y = null == y ? t + "=" + e : y + "&" + t + "=" + e)
                }
            }
            console.log("wx share queryParam:" + JSON.stringify(p), y),
            qq.shareAppMessage({
                title: u,
                imageUrl: g,
                query: y,
                shareAppType: "qqFastShareList",
                success: function () {
                    console.log("快速分享成功~~~"),
                    E.instance.event(st.E_SHARE_RESULT, {
                        code: t.SdkCode.SHARE_SUCCESS
                    })
                },
                fail: function () {
                    console.log("快速分享失败~~~"),
                    E.instance.event(st.E_SHARE_RESULT, {
                        code: t.SdkCode.SHARE_FAILED
                    })
                }
            })
        }
    }
    Te.aldShareEnable = !1,
    Laya.ClassUtils.regClass("QQShare", Te);
    class Oe {
        constructor() {
            this.img_bannerCloseBtn = void 0,
            this.banners = [],
            this.videos = [],
            this.curIsAutoPlayVideo = !1,
            this.interstitial = [],
            this.blockAd = void 0,
            this.AppBox = void 0,
            this.AppBoxData = void 0,
            this.closeIndex = 0
        }
        init(t) {}
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            this.curIsAutoPlayVideo = n;
            let a = 0 === this.videos.length,
            u = this.getVideoById(e);
            u || (u = {
                    id: e,
                    inst: null,
                    state: t.AdState.LOADING
                }, this.videos.push(u)),
            u.inst || (u.inst = qq.createRewardedVideoAd({
                    adUnitId: u.id
                }), u.inst.load(), a ? (u.inst.onLoad(() => {
                        console.log("激励视频广告加载成功"),
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        u.state = t.AdState.LOAD,
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_SUCCESS
                        }),
                        this.curIsAutoPlayVideo && this.showVideo(u.id)
                    }), u.inst.onError(e => {
                        console.log("激励视频广告加载失败"),
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        u.state = t.AdState.LOAD_FAIL,
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                        })
                    }), u.inst.onClose(e => {
                        e && e.isEnded || void 0 === e ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                                code: t.SdkCode.AD_VIDEO_SUCCESS
                            })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                                code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                            })),
                        this.curIsAutoPlayVideo = !1,
                        Laya.timer.once(1e3, this, (function () {
                                u.inst.load()
                            }))
                    })) : t.AdState.LOAD_FAIL === u.state && u.inst.load())
        }
        showVideo(e) {
            let n = this.getVideoById(e);
            n && n.inst && n.inst.show().then(() => {}).catch(() => {
                n.inst.load().then(() => n.inst.show()).catch(e => {
                    n.state = t.AdState.LOAD_FAIL,
                    console.log("激励视频广告显示失败")
                })
            })
        }
        preloadVideo(t) {
            this.loadVideo(t)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? t.AdState.LOAD === n.state ? t.VideoState.ENABLED : t.VideoState.UNENABLED : t.VideoState.UNLOAD
        }
        playVideo(e) {
            console.log("video Id", e);
            let n = this.getVideoById(e);
            n ? t.AdState.LOAD === n.state ? (Laya.MouseManager.enabled = !1, this.showVideo(e)) : t.AdState.LOAD_FAIL === n.state && (v.showTips("暂无视频!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                })) : (Laya.MouseManager.enabled = !1, this.loadVideo(e, !0)),
            Laya.MouseManager.enabled || Laya.timer.once(1e4, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadBanner(e, n) {
            let a = this.getBannerById(e);
            if (a ? n || (n = a.customParams) : (!n && (n = {
                            widthScaleRate: 1
                        }), !n.widthScaleRate && (n.widthScaleRate = 1), a = {
                        id: e,
                        state: t.AdState.LOADING,
                        inst: null,
                        showCnt: 0,
                        createStamp: v.getTime(),
                        customParams: n
                    }, this.banners.push(a)), a.inst)
                t.AdState.DELETING !== a.state && t.AdState.LOAD_FAIL !== a.state || (a.inst.destroy(), a.inst = null, a.showCnt = 0, a.state = t.AdState.LOADING, this.preloadBanner(e));
            else {
                let u = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo(),
                g = u.screenWidth * n.widthScaleRate;
                a.inst = qq.createBannerAd({
                    adUnitId: e,
                    style: {
                        left: 0,
                        top: u.screenHeight - 100,
                        width: g
                    }
                }),
                a.inst.onResize(t => {
                    a.inst.style.width = t.width,
                    a.inst.style.height = t.height,
                    a.inst.style.left = (u.screenWidth - t.width) / 2,
                    a.inst.style.top = u.screenHeight - t.height,
                    -1 !== u.system.indexOf("iOS") && v.isQMP() && (a.inst.style.top -= 24)
                }),
                a.inst.onLoad(() => {
                    console.log("banner广告加载成功"),
                    a.state = t.AdState.LOAD
                }),
                a.inst.onError(e => {
                    console.log("banner广告加载失败", JSON.stringify(e)),
                    a.state = t.AdState.LOAD_FAIL
                })
            }
            return a
        }
        showBanner(e, n) {
            console.log("banner Id", e);
            let a = Laya.ClassUtils.getRegClass("Sdk");
            !n && (n = {
                    widthScaleRate: 1
                }),
            !n.widthScaleRate && (n.widthScaleRate = 1);
            let u = this.getBannerById(e);
            u ? u.customParams = n : u = this.preloadBanner(e, n),
            t.AdState.LOAD === u.state ? (u.showCnt++, u.inst.show(), a.instance.isHarvest() && this.showBannerCloseBtn(u), u.customParams && u.customParams.refreshInterval && Laya.timer.once(u.customParams.refreshInterval, this, this.autoRefreshBanner)) : t.AdState.LOAD_FAIL === u.state ? Laya.timer.once(1e4, this, (function () {
                    this.preloadBanner(e)
                })) : t.AdState.LOADING === u.state && n && n.isPostLoadedShow && Laya.timer.once(1e3, this, (function () {
                    this.showBanner(e, n)
                }))
        }
        hideBanner(e, n) {
            let a = this.getBannerById(e);
            if (a) {
                if (a.inst) {
                    if (a.state !== t.AdState.LOAD)
                        return void Laya.timer.once(100, this, (function () {
                                this.hideBanner(e, n)
                            }));
                    a.inst.hide(),
                    this.img_bannerCloseBtn && this.img_bannerCloseBtn.visible && (this.img_bannerCloseBtn.visible = !1)
                }
                a.customParams && a.customParams.refreshInterval && (a.customParams.refreshInterval = void 0, Laya.timer.clear(this, this.autoRefreshBanner), console.log("### banner自动刷新关闭")),
                a.showCnt > 0 && n && (a.state = t.AdState.DELETING, this.preloadBanner(e))
            }
        }
        getBannerById(t) {
            return this.banners.filter((e, n, a) => e.id === t, this)[0]
        }
        autoRefreshBanner(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            if (e || (e = n.instance.getBannerId()), !e)
                return;
            let a = this.getBannerById(e);
            a && (a.state = t.AdState.DELETING, this.preloadBanner(e, a.customParams), this.showBanner(a.id, a.customParams), console.log("### banner自动刷新"))
        }
        showBannerCloseBtn(t) {
            let e = void 0,
            n = Laya.ClassUtils.getRegClass("Sdk"),
            a = n.instance.getServerJsonCfg();
            if (a && (e = a.bannerClose_StartLev), !e)
                return;
            console.log(`### b的关闭按钮弹出关卡:[${e}]`);
            let u = Z.instance.getUserInfo().stageId;
            if (!u)
                return;
            if (u < e)
                return;
            let setBannerCloseBtnPos = () => {
                !this.img_bannerCloseBtn.visible && (this.img_bannerCloseBtn.visible = !0),
                this.img_bannerCloseBtn.left = t.inst.style.left + 20,
                this.img_bannerCloseBtn.top = t.inst.style.top / n.instance.getSystemInfo().screenHeight * Laya.stage.height + 20
            };
            if (this.img_bannerCloseBtn)
                setBannerCloseBtnPos();
            else {
                let t = "res/close_2.png";
                Laya.loader.load(t, Laya.Handler.create(this, (function (t) {
                            this.img_bannerCloseBtn = new Laya.Image(t.url),
                            this.img_bannerCloseBtn.zOrder = 1e4,
                            Laya.stage.addChildren(this.img_bannerCloseBtn),
                            setBannerCloseBtnPos()
                        })))
            }
        }
        preloadInterstitial(e) {
            let n = this.getInterstitial(e);
            n || (n = {
                    id: e,
                    inst: void 0,
                    state: t.AdState.LOADING
                }, this.interstitial.push(n)),
            n.inst ? t.AdState.DELETING !== n.state && t.AdState.LOAD_FAIL !== n.state || (n.inst.destroy(), n.inst = void 0, n.state = t.AdState.LOADING, Laya.timer.once(1e3, this, (function () {
                        this.preloadInterstitial(e)
                    }))) : (n.inst = qq.createInterstitialAd({
                        adUnitId: e
                    }), n.inst.load().catch(t => {
                    console.error("load", t)
                }), n.inst.onClose(e => {
                    n.state = t.AdState.DELETING,
                    this.preloadInterstitial(n.id)
                }), n.inst.onLoad(() => {
                    console.log("插屏广告加载成功"),
                    n.state = t.AdState.LOAD
                }), n.inst.onError(t => {
                    console.log("插屏广告加载失败", JSON.stringify(t))
                }))
        }
        showInterstitial(e) {
            let n = this.getInterstitial(e);
            if (n && n.inst)
                return n.state !== t.AdState.LOAD || n.inst.isDestroy ? (n.state = t.AdState.DELETING, void this.preloadInterstitial(n.id)) : void n.inst.show().catch(t => {
                    console.error("插屏广告错误码", t)
                })
        }
        getInterstitial(t) {
            return this.interstitial.filter((e, n, a) => e.id === t, this)[0]
        }
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {
            let e = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo().SDKVersion;
            if (v.compatibleVersion(e, "1.7.1") && !this.AppBox) {
                this.AppBox = qq.createAppBox({
                    adUnitId: t
                }),
                this.AppBoxData = this.AppBox.load();
                var loadFunc = () => {
                    this.closeIndex += 1,
                    this.closeIndex >= 1 && (this.closeIndex = 0, this.AppBoxData = this.AppBox.load())
                };
                loadFunc = loadFunc.bind(this),
                this.AppBox.onClose((function () {
                        loadFunc()
                    }))
            }
        }
        showAppBox() {
            this.AppBox && this.AppBox.show()
        }
        hideAppBox() {
            this.AppBox && this.AppBox.hide()
        }
        destoryAppBox() {
            this.AppBox && this.AppBox.destroy()
        }
        getAppBoxData() {
            return this.AppBoxData
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        preloadBlockAd(t) {}
        showBlockAd(e, n) {
            let a = Laya.ClassUtils.getRegClass("Sdk"),
            u = a.instance.getSystemInfo().SDKVersion;
            if (!v.compatibleVersion(u, "1.15.0"))
                return;
            n.orientation || (n.orientation = "landscape"),
            this.blockAd && this.blockAd.inst && this.blockAd.inst.destroy(),
            this.blockAd = {
                id: void 0,
                inst: void 0,
                state: t.AdState.DELETING
            };
            let g = a.instance.getSystemInfo();
            n.style.left = n.style.left <= 32 ? 32 : n.style.left,
            this.blockAd.id = e,
            this.blockAd.inst = qq.createBlockAd({
                adUnitId: e,
                style: {
                    left: n.style.left,
                    top: n.style.top / Laya.stage.height * g.screenHeight
                },
                size: n.size,
                orientation: n.orientation
            }),
            this.blockAd.inst.onResize(t => {
                t && t.width && t.height && (this.blockAd.inst.style.left = Math.abs(g.screenWidth - t.width) / 2, this.blockAd.inst.style.top = n.style.top / Laya.stage.height * g.screenHeight),
                console.log(`left:${this.blockAd.inst.style.left}, top:${this.blockAd.inst.style.top}`)
            }),
            this.blockAd.inst.onLoad(() => {
                console.log("blockAd广告加载成功")
            }),
            this.blockAd.inst.onError(t => {
                console.log("blockAd广告加载失败", JSON.stringify(t))
            }),
            this.blockAd.inst.show()
        }
        hideBlockAd() {
            this.blockAd && this.blockAd.inst && this.blockAd.inst.destroy()
        }
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    Oe.BannerRefreshTime = 4e4;
    class Be {
        constructor() {}
        sendEvent(t, e) {
            qq.aldSendEvent && qq.aldSendEvent(t, e)
        }
        stageOnStart(t) {
            qq.aldStage && qq.aldStage.onStart(t)
        }
        stageOnRunning(t) {
            qq.aldStage && qq.aldStage.onRunning(t)
        }
        stageOnEnd(t) {
            qq.aldStage && qq.aldStage.onEnd(t)
        }
        unlockItem(t) {}
    }
    class Pe {
        static get rewardStrategyCnt() {
            if (void 0 === this._rewardStrategyCnt)
                if (Z.instance.isNewDay && Z.instance.isNewDay())
                    this.rewardStrategyCnt = 1;
                else {
                    let t = Laya.LocalStorage.getItem("rewardStrategyCnt");
                    null == t || "" === t ? this.rewardStrategyCnt = 1 : this._rewardStrategyCnt = Number(t)
                }
            return this._rewardStrategyCnt
        }
        static set rewardStrategyCnt(t) {
            this._rewardStrategyCnt !== t && (this._rewardStrategyCnt = t, Laya.LocalStorage.setItem("rewardStrategyCnt", this._rewardStrategyCnt.toString()))
        }
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e,
            t && e && e.source && Pe.rewardStrategyCnt++
        }
        getStrategy() {
            let e = Laya.ClassUtils.getRegClass("Sdk");
            if (e.instance.isAudit())
                return console.log("###审核版本直接返回视频!!!"), t.GetRewardSDKWay.VIDEO;
            if (t.GetRewardSDKWay.AUTO === this.curStrategy) {
                if (t.VideoState.ENABLED === e.instance.isHasVideo()) {
                    let n = e.instance.getServerJsonCfgShareParams().OlderShareCtnBase;
                    Z.instance.isFirstLogin && Z.instance.isFirstLogin() && (n = e.instance.getServerJsonCfgShareParams().FreshShareCntBase),
                    n || (n = 0);
                    let a = null;
                    if (Pe.rewardStrategyCnt <= n)
                        a = t.GetRewardSDKWay.SHARE;
                    else {
                        let u = e.instance.getServerJsonCfgShareParams().ShareSpace;
                        u || (u = 0),
                        a = u > 0 && 0 == (Pe.rewardStrategyCnt - n) % (u + 1) ? t.GetRewardSDKWay.SHARE : t.GetRewardSDKWay.VIDEO
                    }
                    return a
                }
                return t.GetRewardSDKWay.SHARE
            }
            return t.GetRewardSDKWay.SHARE === this.curStrategy ? this.curStrategy : t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            let e = Laya.ClassUtils.getRegClass("Sdk"),
            n = this.getStrategy();
            t.GetRewardSDKWay.SHARE === n ? (e.instance.sendEvent("分享", {
                    "开始": this.curParams.source
                }), this.share(this.curParams)) : t.GetRewardSDKWay.VIDEO === n && (e.instance.sendEvent("视频", {
                    "开始": this.curParams.source
                }), this.playVideo(this.curParams))
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk"),
            a = n.instance.isHasVideo();
            t.VideoState.UNENABLED === a ? (v.showTips("今天已经没有视频啦, 分享也可获得奖励哟!"), Laya.MouseManager.enabled = !1, Laya.timer.once(1e3, this, (function () {
                        Laya.MouseManager.enabled = !0,
                        this.share(e)
                    }))) : (E.instance.once(st.E_AD_VIDEO, this, (function (a) {
                        t.SdkCode.AD_VIDEO_SUCCESS === a.code ? (E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                                way: t.GetRewardSDKWay.VIDEO,
                                gid: e.bindCtrlGId
                            }), n.instance.sendEvent("视频", {
                                "完成": e.source
                            })) : t.SdkCode.AD_VIDEO_UNCOMPLETE === a.code && (n.instance.showModal("看完视频才会有奖励哟！！！", "提示", "继续观看", Laya.Handler.create(this, (function () {
                                        this.playVideo(e)
                                    })), "一会再来", Laya.Handler.create(this, (function () {
                                        E.instance.event(st.E_REWARD_GAIN, {
                                            code: t.SdkCode.REWARD_GAIN_FAIL,
                                            gid: e.bindCtrlGId
                                        })
                                    }))), n.instance.sendEvent("视频", {
                                "未完成": e.source
                            }))
                    })), n.instance.playVideo())
        }
        share(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            E.instance.once(st.E_SHARE_RESULT, this, (function (a) {
                    t.SdkCode.SHARE_SUCCESS === a.code ? (E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_SUCCESS,
                            way: t.GetRewardSDKWay.SHARE,
                            gid: e.bindCtrlGId
                        }), n.instance.sendEvent("分享", {
                            "完成": e.source
                        })) : t.SdkCode.SHARE_FAILED === a.code && (n.instance.sendEvent("分享", {
                            "未完成": e.source
                        }), E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_FAIL,
                            gid: e.bindCtrlGId
                        }))
                })),
            n.instance.share(e)
        }
    }
    Pe._rewardStrategyCnt = void 0;
    class Ve extends x {
        constructor() {
            super()
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {
            return Laya.QQMiniAdapter
        }
        login() {
            qq.login({
                success: this.wxloginSucc.bind(this),
                fail: this.wxloginFail.bind(this)
            }),
            qq.getSetting({
                success: this.onSettings.bind(this)
            }),
            this.networkstate = "none",
            qq.getNetworkType({
                success: t => {
                    console.log(">>>>>>>>>>>>>>>>> getNetworkType: ", t.networkType),
                    this.networkstate = t.networkType
                }
            }),
            qq.onNetworkStatusChange(t => {
                console.log(">>>>>>>>>>>>>>>>> onNetworkStatusChange: ", t.isConnected, t.networkType),
                this.networkstate = t.networkType
            })
        }
        request(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            qq.request({
                url: t,
                data: e,
                method: u,
                dataType: "json",
                success: t => {
                    console.log("<<<<<<<<<<<<<<<<< request: ", t),
                    n && n.runWith(t.data)
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        requestDecrypt(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            qq.request({
                url: t,
                data: e,
                method: u,
                responseType: "arraybuffer",
                success: t => {
                    if (console.log("<<<<<<<<<<<<<<<<< request: ", t), n) {
                        let e = window.pako.inflate(t.data, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        getShareInstance() {
            return new Te
        }
        getAdvInstance() {
            return new Oe
        }
        getStatInstance() {
            return new Be
        }
        getRewardStrInstance() {
            return new Pe
        }
        onSettings(e) {
            let n = e.authSetting;
            this.isUserInfoAuth = !!n["scope.userInfo"],
            this.isUserInfoAuth && qq.getUserInfo({
                success: this.userInfoSucc.bind(this)
            }),
            this.code && this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "微信登录成功"
            })
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.loginServerEnable(),
            this.createUserInfoButton()
        }
        onResume(t) {
            t.query && !v.isEmpty(t.query) && this.loginServerEnable() && (this.query = t.query, Xt.instance.postShareQuery(t.query))
        }
        wxloginSucc(e) {
            console.log("微信登录成功！");
            let n = 10;
            const checkNeedFix = () => !this.menuInfo || this.menuInfo.top > 0 || n <= 0 ? (this.code = e.code, this.loginServerEnable() && Xt.instance.login(this.code, a.query), void 0 !== this.isUserInfoAuth && this.event(st.E_SDK_LOGIN, {
                    code: t.SdkCode.WX_LOGIN_SUCCESS,
                    msg: "微信登录成功"
                }), !1) : (n--, !0),
            fixInfo = () => {
                this.getSystemInfo(!0),
                this.getMenuButtonBoundingClientRect(!0),
                checkNeedFix() || (v.sNotchScreen = void 0, Laya.timer.clear(this, fixInfo))
            };
            let a = qq.getLaunchOptionsSync();
            this.query = a.query,
            checkNeedFix() && Laya.timer.loop(100, this, fixInfo)
        }
        wxloginFail() {
            console.log("微信登录失败！"),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_FAILED,
                msg: "微信登录失败"
            })
        }
        userInfoSucc(e) {
            let n;
            e.userInfo ? (console.log("获取用户信息成功！" + JSON.stringify(e)), this.isUserInfoAuth = !0, this.encryptedData = e.encryptedData, this.iv = e.iv, this.destroyUserInfoButton(), n = new t.SDKEntity.UserInfoEntity, function (t, e) {
                null != t.nickName && (e.name = t.nickName),
                null != t.avatarUrl && (e.headUrl = t.avatarUrl),
                null != t.gender && (e.sex = t.gender),
                null != t.city && (e.city = t.city),
                null != t.province && (e.province = t.province),
                null != t.country && (e.country = t.country),
                null != t.language && (e.language = t.language)
            }
                (e.userInfo, n), Z.instance.update(n), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_SUCCESS,
                    msg: "授权成功"
                })) : (console.log("获取用户信息失败！"), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_FAILED,
                    msg: "用户拒绝授权"
                })),
            this.profileToServer && Xt.instance.postProfile(n)
        }
        createUserInfoButton() {
            let t = this.profileBtn,
            e = t.localToGlobal(new Laya.Point(0, 0)),
            n = t.localToGlobal(new Laya.Point(t.width, t.height));
            Laya.stage.transform.transformPoint(e),
            Laya.stage.transform.transformPoint(n);
            let a = n.x - e.x,
            u = n.y - e.y,
            g = qq.createUserInfoButton({
                type: "text",
                text: "",
                style: {
                    left: e.x,
                    top: e.y,
                    width: a,
                    height: u
                },
                withCredentials: !0,
                lang: "zh_CN"
            });
            g.show(),
            g.onTap(this.userInfoSucc.bind(this)),
            this.profileBtn = g,
            t.once(Laya.Event.REMOVED, this, this.destroyUserInfoButton)
        }
        destroyUserInfoButton() {
            this.profileBtn && this.profileBtn.destroy(),
            this.profileBtn = null
        }
        setKeepScreenOn(t) {
            qq.setKeepScreenOn(t)
        }
        onShow(t) {
            qq.onShow(t)
        }
        onHide(t) {
            qq.onHide(t)
        }
        checkUpdate() {
            if ("function" == typeof qq.getUpdateManager) {
                const t = qq.getUpdateManager();
                t.onCheckForUpdate((function (t) {
                        console.log(t.hasUpdate)
                    })),
                t.onUpdateReady(() => {
                    this.showModal("有新版本啦！，赶快开启新的历程吧~", "更新提示", "开启", Laya.Handler.create(this, () => {
                            t.applyUpdate()
                        }))
                }),
                t.onUpdateFailed((function () {
                        console.log("新的版本下载失败")
                    }))
            }
        }
        loadSubpackage(t) {
            return qq.loadSubpackage ? (t.fail = function () {
                console.log("分包加载失败！")
            }, qq.loadSubpackage(t)) : null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            qq.showModal({
                title: e,
                content: t,
                showCancel: "" != u && null != u,
                cancelText: u,
                confirmText: n,
                success: t => {
                    t.confirm ? a && a.run() : u && g && g.run()
                }
            })
        }
        getSystemInfo(t) {
            return !t && this.systemInfo || (this.systemInfo = qq.getSystemInfoSync(), console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo))),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            return !t && this.menuInfo || (this.menuInfo = qq.getMenuButtonBoundingClientRect(), console.log("getMenuButtonBoundingClientRect: " + JSON.stringify(this.menuInfo))),
            this.menuInfo
        }
        exit() {
            qq.exitMiniProgram({})
        }
        getLaunchOptionsSync() {
            return qq.getLaunchOptionsSync()
        }
        navigateToMiniProgram(t) {
            qq.navigateToMiniProgram(t)
        }
        getOpenDataContext() {
            return qq.getOpenDataContext()
        }
        createFeedbackButton(t) {
            return qq.createFeedbackButton(t)
        }
        openCustomerServiceConversation(t) {
            qq.openCustomerServiceConversation(t)
        }
        createGameClubButton(t) {
            qq.createGameClubButton(t)
        }
        onAudioInterruption(t, e) {
            qq.onAudioInterruptionBegin(t),
            qq.onAudioInterruptionEnd(e)
        }
        vibrateShort() {
            qq.vibrateShort({})
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        judgeBAndW(e) {
            if (!e)
                return t.BlackAndWhite.Black;
            let n = Laya.LocalStorage.getItem("BAndW");
            return "white" !== n && "black" !== n && (!e.compareSceneId && (e.compareSceneId = []), n = -1 !== e.compareSceneId.indexOf(e.sceneId) ? "white" : "black", Laya.LocalStorage.setItem("BAndW", n)),
            "white" === n ? t.BlackAndWhite.White : t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(t) {
            let e = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo().SDKVersion;
            v.compatibleVersion(e, "1.7.1") && qq.saveAppToDesktop(t)
        }
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class Ue {
        constructor() {
            this.banners = [],
            this.videos = [],
            this.interstitial = [],
            this.nativeAd = void 0
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        showVideo(t) {}
        preloadVideo(t) {}
        getVideoState(e) {
            return t.VideoState.ENABLED
        }
        playVideo(e) {
            var n = {
                gametype: 1,
                rewardtype: 1,
                data: {}
            };
            n.data.title = "刷新道具",
            n.data.url = "",
            qttGame.showVideo(e => {
                if (1 == e)
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                        code: t.SdkCode.AD_VIDEO_SUCCESS
                    });
                else if (2 == e)
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                        code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                    });
                else {
                    var n = {
                        gametype: 1,
                        rewardtype: 1,
                        data: {}
                    };
                    n.data.title = "获得奖励",
                    n.callback = e => {
                        1 == e ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                                code: t.SdkCode.AD_VIDEO_SUCCESS
                            })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                                code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                            }))
                    },
                    qttGame.showHDAD(n)
                }
            }, n),
            Laya.MouseManager.enabled || Laya.timer.once(1e4, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {
            qttGame.showBanner()
        }
        hideBanner(t) {
            qttGame.hideBanner()
        }
        getBannerById(t) {
            return this.banners.filter((e, n, a) => e.id === t, this)[0]
        }
        showInterstitial(t) {
            var e = {
                index: 1,
                rewardtype: 1
            };
            qttGame.showHDReward(e)
        }
        getInterstitial(t) {
            return null
        }
        preloadInterstitial(t) {}
        init(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {}
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return null
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    Ue.BannerRefreshTime = 4e4;
    class ze {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(this.curParams.id) ? v.showTips("今天已经没有视频啦,明天再看吧!") : (E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_SUCCESS,
                            way: t.GetRewardSDKWay.VIDEO,
                            gid: e.bindCtrlGId
                        }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code && (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_FAIL,
                                gid: e.bindCtrlGId
                            }))
                    })), Laya.MouseManager.enabled = !1, n.instance.playVideo(e.id))
        }
    }
    class Fe extends x {
        constructor() {
            super()
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            Laya.ClassUtils.getRegClass("Sdk").instance.adIds = {
                videoId: "111111",
                bannerId: "222222",
                interstitialId: "333333"
            },
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "QTT登录成功！"
            })
        }
        request(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e)
        }
        requestDecrypt(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e)
        }
        getShareInstance() {
            return null
        }
        getAdvInstance() {
            return new Ue
        }
        getStatInstance() {
            return null
        }
        getRewardStrInstance() {
            return new ze
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {}
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.loginServerEnable(),
            this.createUserInfoButton()
        }
        onResume(t) {}
        createUserInfoButton() {}
        destroyUserInfoButton() {}
        setKeepScreenOn(t) {}
        onShow(t) {}
        onHide(t) {}
        checkUpdate() {}
        loadSubpackage(t) {
            return null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo(t) {
            return !t && this.systemInfo,
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            return this.menuInfo = {
                width: 0,
                height: 0,
                top: 0,
                right: 0,
                bottom: Laya.stage.height,
                left: Laya.stage.width
            },
            this.menuInfo
        }
        exit() {}
        getLaunchOptionsSync() {
            return null
        }
        navigateToMiniProgram(t) {}
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation(t) {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {}
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.White
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class Ge {
        constructor() {
            this.bridge = Ht.Instance
        }
        init(t) {}
        preloadVideo(t) {}
        playVideo(t) {}
        getVideoState(t) {
            return null
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {}
        hideBanner(t) {}
        getBannerById(t) {
            return null
        }
        preloadInterstitial(t) {}
        showInterstitial(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox() {}
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return null
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    var We;
    !function (t) {
        t.GUIDE_STEP_CN = "新手引导完成步骤",
        t.GUIDE_STEP_1 = "guide_step_1",
        t.GUIDE_STEP_2 = "guide_step_2",
        t.GUIDE_STEP_3 = "guide_step_3",
        t.GUIDE_STEP_4 = "guide_step_4",
        t.GUIDE_STEP_5 = "guide_step_5",
        t.GUIDE_STEP_6 = "guide_step_6",
        t.GUIDE_STEP_7 = "guide_step_7"
    }
    (We || (We = {}));
    class He {
        constructor() {
            this.bridge = Ht.Instance
        }
        sendEvent(t, e) {
            if (t == We.GUIDE_STEP_CN) {
                if (!e || "number" != typeof e.step)
                    return;
                switch (e.step) {
                case 1:
                    t = We.GUIDE_STEP_1;
                    break;
                case 2:
                    t = We.GUIDE_STEP_2;
                    break;
                case 3:
                    t = We.GUIDE_STEP_3;
                    break;
                case 4:
                    t = We.GUIDE_STEP_4;
                    break;
                case 5:
                    t = We.GUIDE_STEP_5;
                    break;
                case 6:
                    t = We.GUIDE_STEP_6;
                    break;
                case 7:
                    t = We.GUIDE_STEP_7
                }
            }
            this.bridge.customEvent(t)
        }
        stageOnStart(t) {
            this.bridge.startLeve(`[id:${t.stageId}]>>>[name:${t.stageName}]`)
        }
        stageOnRunning(t) {}
        stageOnEnd(t) {
            t.event && "string" == typeof t.event && "success" == t.event ? this.bridge.finishLevel(`[id:${t.stageId}]>>>[name:${t.stageName}]`) : this.bridge.failLevel(`[id:${t.stageId}]>>>[name:${t.stageName}]`)
        }
        unlockItem(t) {
            t && this.bridge.skinUnlock(t.id)
        }
    }
    class qe {
        constructor() {
            this.bridge = Ht.Instance
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg,
            n = Z.instance.getMine();
            n.openId = e.user_unique_id,
            n.name = "taptap_user",
            n.headUrl = "",
            this.loginServerEnable() ? Xt.instance.loginNoAuth() : E.instance.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, (function (t) {
                    n && n.runWith(t)
                })),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, (function (t) {
                    if (n) {
                        let e = window.pako.inflate(t, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                })),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        onResume() {}
        getQuery() {}
        setKeepScreenOn(t) {}
        onShow(t) {
            this.bridge.setOnHideCallBack(t)
        }
        onHide(t) {
            this.bridge.setOnHideCallBack(t)
        }
        isAuth() {
            return !0
        }
        auth(t) {}
        destroyUserInfoButton() {}
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        checkUpdate() {}
        loadSubpackage(t) {}
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo() {
            return {}
        }
        getMenuButtonBoundingClientRect() {
            return null
        }
        exit() {}
        getLaunchOptionsSync() {}
        navigateToMiniProgram(t) {}
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation() {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {
            this.bridge.vibrateShort()
        }
        getShareInstance() {}
        getAdvInstance() {
            return new Ge
        }
        getStatInstance() {
            return new He
        }
        getRewardStrInstance() {}
        getNetworkType() {
            return "unknown"
        }
        isConnectNetwork() {
            return !1
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class Ke {
        constructor() {
            this.bridge = Ht.Instance
        }
        init(t) {}
        canPlayAd() {
            return !0
        }
        playVideo() {
            starGame && starGame.rewardVideo.startRewardVideo({
                adPosition: 1,
                adType: 1
            }),
            V.instance.pauseMusic(),
            window.onRewardAdShow = () => {
                console.log("激励视频广告已展示")
            },
            window.onRewardAdResult = e => {
                Laya.MouseManager.enabled = !0,
                V.instance.resumeMusic(),
                e ? E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_SUCCESS
                }) : E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                })
            },
            Laya.MouseManager.enabled || Laya.timer.once(5e3, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadVideo(t) {}
        getVideoState(e) {
            return this.canPlayAd() ? t.VideoState.ENABLED : t.VideoState.UNENABLED
        }
        preloadBanner(t, e) {}
        showBanner(t, e) {}
        hideBanner(t) {}
        getBannerById(t) {
            return null
        }
        preloadInterstitial(t) {}
        showInterstitial(t) {
            starGame && starGame.rewardVideo.startRewardVideo({
                adPosition: 2,
                adType: 2
            }),
            window.onRewardAdShow && (window.onRewardAdShow = () => {
                console.log("插屏广告已展示")
            })
        }
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg;
            starGame.redbag.init({
                game_code: e.game_code
            }),
            document && document.addEventListener("touchstart", (function () {
                    starGame.redbag.bindTouch()
                }), !0)
        }
        showAppBox() {}
        hideAppBox() {}
        destoryAppBox() {}
        getAppBoxData() {
            return null
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    class Je {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                        code: t.SdkCode.REWARD_GAIN_SUCCESS,
                        way: t.GetRewardSDKWay.VIDEO,
                        gid: e.bindCtrlGId
                    }) : (t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code || t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code) && E.instance.event(st.E_REWARD_GAIN, {
                        code: t.SdkCode.REWARD_GAIN_FAIL,
                        gid: e.bindCtrlGId
                    })
                })),
            n.instance.playVideo(e.id)
        }
    }
    class Xe {
        constructor() {}
        sendEvent(t, e) {}
        stageOnStart(t) {}
        stageOnRunning(t) {}
        stageOnEnd(t) {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg;
            starGame.gold.levelUp({
                game_code: e.game_code,
                key: e.game_key,
                type: 3,
                level: Number(t.stageId)
            }).then((function (t) {
                    console.log(t)
                })).catch((function (t) {
                    console.log(t)
                }))
        }
        unlockItem(t) {}
    }
    class je extends x {
        constructor() {
            super()
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk");
            e.instance.adIds = {
                videoId: "11",
                nativeAdId: ["22", "33"],
                bannerId: "44",
                interstitialId: "55",
                appBoxId: "66",
                blockId: "77"
            };
            let n = e.GameCfg;
            starGame.logic.init({
                game_code: n.game_code
            }).then(t => {
                t && 200 === t.code && t.data && t.data.passId && console.log("登录成功")
            }, t => {
                console.log("登录失败：", JSON.stringify(t))
            }),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "2345登陆成功"
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                n && n.runWith(t)
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (n) {
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    n.runWith(JSON.parse(e))
                }
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        getShareInstance() {
            return null
        }
        getAdvInstance() {
            return new Ke
        }
        getStatInstance() {
            return new Xe
        }
        getRewardStrInstance() {
            return new Je
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return null
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return null
        }
        auth(t) {}
        onResume(t) {}
        userInfoSucc(t) {}
        createUserInfoButton() {}
        destroyUserInfoButton() {}
        setKeepScreenOn(t) {}
        onShow(t) {}
        onHide(t) {}
        checkUpdate() {}
        loadSubpackage(t) {
            return null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {}
        getSystemInfo(t) {
            return null
        }
        getMenuButtonBoundingClientRect(t) {
            return null
        }
        exit() {}
        getLaunchOptionsSync() {
            return null
        }
        navigateToMiniProgram(t) {}
        getOpenDataContext() {
            return null
        }
        createFeedbackButton(t) {
            return null
        }
        openCustomerServiceConversation(t) {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {
            return null
        }
        vibrateShort() {
            return null
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return null
        }
        judgeBAndW(t) {
            return null
        }
        getCode() {}
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class Qe {
        constructor() {
            this._videoPath = "",
            this.recordData = {
                duration: 120,
                isEndlessMode: !1,
                isDisposeRecord: !1
            },
            this.isStartRecord = !1,
            this.beforeRecordStageId = void 0,
            this.curRecordOdds = void 0,
            this.isRecording = !1,
            this.init()
        }
        init() {
            E.instance.on(st.E_SHARE_RESULT, this, e => {
                this.endlessModeAutoRecord(e.code == t.SdkCode.SHARE_SUCCESS),
                this.isStartRecord = !1,
                e.code === t.SdkCode.SHARE_SUCCESS && (this._videoPath = null)
            });
            var e = this.onShowFunc.bind(this);
            tt.onShow((function (t) {
                    e()
                }))
        }
        onShowFunc() {
            Laya.timer.once(2e3, this, () => {
                this.isStartRecord && E.instance.event(st.E_SHARE_RESULT, {
                    code: t.SdkCode.SHARE_FAILED
                })
            })
        }
        setShare(t, e, n) {
            n = n || "";
            let a = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfg(),
            u = a && a.shareCfg[v.getIntRandom(0, a.shareCfg.length - 1)],
            g = null;
            t = a && u && u.name ? u.name : "抖音小游戏",
            g = a && u && u.title ? u.title : "快来一起玩这个小游戏吧~",
            tt.onShareAppMessage(n => {
                console.log(n.channel);
                const a = {
                    title: t,
                    imageUrl: e,
                    extra: {},
                    query: "k1=v1&k2=v2",
                    success(t) {
                        console.log("分享成功:", t)
                    },
                    fail(t) {
                        console.log("分享失败", t)
                    }
                },
                u = Object.assign({
                    channel: n.channel
                }, a);
                switch (n.channel) {
                case "video":
                    this._videoPath ? u.extra = {
                        withVideoId: !0,
                        videoPath: this._videoPath,
                        videoTopics: [t, g],
                        hashtag_list: [t, g],
                        videoTag: `week_${v.getYearWeek().year}_${v.getYearWeek().week}`
                    }
                     : u.extra = {
                        withVideoId: !0,
                        videoTopics: [t, g],
                        hashtag_list: [t, g],
                        videoTag: `week_${v.getYearWeek().year}_${v.getYearWeek().week}`
                    }
                }
                return u
            })
        }
        share(t, e, n) {
            let a = null,
            u = null,
            g = null,
            p = null,
            m = null;
            t instanceof mt ? (a = t.title, u = t.imgUrl, g = t.queryParam, p = t.source, m = t.templateId) : (a = t, u = e, g = n, p = "未知", m = "");
            let y = "";
            if (g) {
                E.instance.once(f.E_APP_ON_RESUME, this, (function (t) {
                        v.showTips("感谢分享!!!")
                    }));
                for (let t in g) {
                    let e = g[t];
                    null != e && ("object" == typeof e && (e = JSON.stringify(e)), y = null == y ? t + "=" + e : y + "&" + t + "=" + e)
                }
            }
            console.log("wx share queryParam:" + JSON.stringify(g), y);
            let S = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfg(),
            _ = S && S.shareCfg[v.getIntRandom(0, S.shareCfg.length - 1)],
            A = null;
            a = S && _ && _.name ? _.name : "抖音小游戏",
            A = S && _ && _.title ? _.title : "快来一起玩这个小游戏吧~",
            m = S && _ && _.templateId ? _.templateId : "",
            u = S && _ && _.image ? _.image : u,
            tt.shareAppMessage({
                title: a,
                desc: A,
                imageUrl: u,
                query: y,
                templateId: m,
                extra: {
                    cutTemplateId: m,
                    videoTopics: [a, A],
                    hashtag_list: [a, A]
                }
            })
        }
        canRecord() {
            return !!tt.getGameRecorderManager
        }
        canShareRecord() {
            return !!this._videoPath
        }
        recordVideo(t) {
            this.isRecording || (this._videoPath = null, this.isRecording = !0, this.recordData = t, this.recordData.isEndlessMode || (this.recordData.isDisposeRecord = !1), this._recorder || (this._recorder = tt.getGameRecorderManager(), this._recorder.onStart(t => {
                        console.log("录屏开始 res:" + JSON.stringify(t)),
                        E.instance.event(st.E_RECORD_VIDEO_START, this.recordData.duration)
                    }), this._recorder.onStop(t => {
                        console.log("录屏结束 res.videoPath:" + t.videoPath),
                        this._videoPath = t.videoPath,
                        this.isRecording = !1,
                        E.instance.event(st.E_RECORD_VIDEO_END, this.recordData.isDisposeRecord)
                    }), this._recorder.recordClip({
                        timeRange: [10, 10]
                    }), this._recorder.onError(t => {
                        console.error("录屏错误 errMsg:" + t),
                        this.isRecording = !1,
                        E.instance.event(st.E_RECORD_VIDEO_END, this.recordData.isDisposeRecord)
                    }), this._recorder.onInterruptionBegin(() => {
                        this.pauseRecord()
                    }), this._recorder.onInterruptionEnd(() => {
                        this.resumeRecord()
                    })), this._recorder.start({
                    duration: t.duration
                }))
        }
        stopRecord(t) {
            this._recorder && this.isRecording && (t && this.recordData && (this.recordData.isEndlessMode = !1, this.recordData.isDisposeRecord = !1), this._recorder.stop())
        }
        pauseRecord() {
            this._recorder && (this._recorder.onPause((function () {
                        console.log("录屏暂停"),
                        E.instance.event(st.E_RECORD_VIDEO_PAUSE)
                    })), this._recorder.pause())
        }
        resumeRecord() {
            this._recorder && (this._recorder.onResume((function () {
                        console.log("录屏恢复"),
                        E.instance.event(st.E_RECORD_VIDEO_RESUME)
                    })), this._recorder.resume())
        }
        destroyRecord() {}
        shareVideo(t = !1) {
            return t ? !(!this.autoRecord() || !this._videoPath) && (this.shareRecordVideo(), !0) : (this.shareRecordVideo(), !0)
        }
        shareRecordVideo() {
            let e = this._videoPath;
            if (!e)
                return void(this.recordData.isEndlessMode || v.showTips("分享录屏失败，暂无录屏内容~"));
            this.isStartRecord = !0;
            let n = Laya.ClassUtils.getRegClass("Sdk"),
            a = n.instance.getSystemInfo(),
            u = n.instance.getSystemInfo().SDKVersion,
            g = n.instance.getSystemInfo().nativeSDKVersion,
            p = n.instance.getServerJsonCfg(),
            f = p && p.shareCfg[v.getIntRandom(0, p.shareCfg.length - 1)],
            m = null,
            y = null,
            S = null,
            _ = null,
            A = null;
            m = p && f && f.name ? f.name : "抖音小游戏",
            y = p && f && f.title ? f.title : "快来一起玩这个小游戏吧~",
            A = p && f && f.cut_odds ? f.cut_odds : 50,
            S = p && f && f.templateId ? f.templateId : "";
            let w = p && f && f.cutTemplateId;
            _ = w && w.length > 0 ? w[v.getIntRandom(0, w.length - 1)] : "";
            let x = "",
            C = p && f && f.defaultBgm;
            C && (x = C[v.getIntRandom(0, C.length - 1)]),
            "Douyin" !== a.appName ? (_ = "", x = "") : "ios" === a.platform ? (v.compatibleVersion(u, "1.77.0") || (_ = ""), x = "") : "android" === a.platform && (v.compatibleVersion(u, "1.74.0") || (_ = ""), v.compatibleVersion(g, "5.9.0") || (x = "")),
            v.getIntRandom(1, 100) > A && (_ = ""),
            tt.shareAppMessage({
                title: m,
                channel: "video",
                extra: {
                    cutTemplateId: _,
                    withVideoId: !0,
                    videoPath: e,
                    videoTopics: [m, y],
                    hashtag_list: [m, y],
                    videoTag: `week_${v.getYearWeek().year}_${v.getYearWeek().week}`,
                    defaultBgm: x
                },
                templateId: S,
                success: e => {
                    v.showTips("发布视频成功!"),
                    console.log(JSON.stringify(e.shareWithShareBgmStatus)),
                    E.instance.event(st.E_SHARE_RESULT, {
                        code: t.SdkCode.SHARE_SUCCESS
                    })
                },
                fail: e => {
                    -1 != e.errMsg.indexOf("shareAppMessage:cancel") ? v.showTips("取消发布视频!") : -1 != e.errMsg.indexOf("shareAppMessage:fail video duration is too short") || -1 != e.errMsg.indexOf("shareAppMessage:fail video file is too short") ? v.showTips("录制时间不足3秒~") : -1 != e.errMsg.indexOf("shareAppMessage:fail can not be shared without clicking by user") ? v.showTips("录制视频已经创建成功，快去分享吧~") : v.showTips("发布视频失败!"),
                    console.log("发布视频失败：", JSON.stringify(e)),
                    E.instance.event(st.E_SHARE_RESULT, {
                        code: t.SdkCode.SHARE_FAILED
                    })
                }
            })
        }
        autoRecord() {
            let t = Laya.ClassUtils.getRegClass("Sdk");
            if (!t.instance.isHarvest())
                return console.log("### autoRecord n sg!!!"), !1;
            let e = t.instance.getServerJsonCfg();
            return e ? (console.log(`### autoRecord ${e.record_StartLev}-${e.record_SpaceLev}-${e.record_Odds}-${e.record_AdditionOdds}`), !!this.checkStageOnoff(e.record_StartLev, e.record_SpaceLev, {
                    odd: e.record_Odds,
                    additionOdds: e.record_AdditionOdds
                }) && (console.log("### auto Record"), !0)) : (console.log("### autoRecord 配置为空!!!"), !1)
        }
        endlessModeAutoRecord(t = !1) {
            this.recordData.isEndlessMode && Laya.timer.callLater(this, () => {
                this.recordVideo(this.recordData)
            })
        }
        checkStageOnoff(t, e, n) {
            let a = Z.instance.getUserInfo();
            if (!a.stageId)
                return !1;
            if (!t)
                return console.log("### checkStageOnoff !startLev-" + t), !1;
            if (a.stageId < t)
                return console.log(`### checkStageOnoff userInfo.stageId<startLev-${a.stageId}-${t}`), !1;
            if (this.beforeRecordStageId && Math.abs(this.beforeRecordStageId - a.stageId) < e + 1)
                return console.log(`### checkStageOnoff 第${this.beforeRecordStageId}关已经触发自动分享`), !1;
            this.curRecordOdds || (this.curRecordOdds = n.odd),
            this.curRecordOdds > 1 && (this.curRecordOdds = this.curRecordOdds / 100);
            let u = Math.random();
            return u > this.curRecordOdds ? (console.log(`### checkStageOnoff random>this.curRecordOdds-${u}-${this.curRecordOdds}`), this.curRecordOdds < 1 && (this.curRecordOdds = 100 * this.curRecordOdds), this.curRecordOdds += n.additionOdds, !1) : (this.curRecordOdds = n.odd, this.beforeRecordStageId = a.stageId, !0)
        }
    }
    Laya.ClassUtils.regClass("TTShare", Qe);
    class Ye {
        constructor() {
            this.isShowInterstitial = !0,
            this.isPreload = !1,
            this.appBoxBtn = void 0,
            this.banners = [],
            this.videos = [],
            this.curIsAutoPlayVideo = !1,
            this.interstitial = [],
            this.interstitialInst = void 0,
            this.moreGamesBanner = void 0,
            this.isMoreGamesBanner = !1,
            this.isBanner1004 = !1,
            this.isSupportBanner = !0,
            this.isShowInterstitial = !1,
            setTimeout(() => {
                this.isShowInterstitial = !0
            }, 3e4)
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            let a = this.getVideoById(e);
            a || (a = {
                    id: e,
                    inst: null,
                    state: t.VideoState.UNLOAD
                }, this.videos.push(a)),
            a.inst || (a.inst = tt.createRewardedVideoAd({
                    adUnitId: a.id
                }), a.inst.onLoad(() => {
                    console.log("激励视频广告加载成功")
                }), a.inst.onError(n => {
                    console.log("激励视频广告加载失败，", JSON.stringify(n)),
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    a.state = t.VideoState.UNENABLED,
                    E.instance.event(st.E_AD_VIDEO, {
                        code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                    }),
                    1004 !== n.errCode && Laya.timer.once(1e4, this, () => {
                        this.loadVideo(e, !1)
                    })
                }), a.inst.onClose(e => {
                    e && e.isEnded || void 0 === e ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                        })),
                    this.isPreload || tt.hideLoading({}),
                    this.isPreload = !1
                }), n && this.showVideo(e))
        }
        autoPreloadVideo(t) {
            let e = this.getVideoById(t);
            e && e.inst && e.inst.load()
        }
        showVideo(t) {
            let e = this.getVideoById(t);
            e && e.inst && e.inst.show().then(() => {
                console.log("激励视频广告显示成功"),
                this.isPreload || (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), tt.hideLoading({}))
            })
        }
        preloadVideo(t, e) {
            let n = this.getVideoById(t);
            n && n.inst ? e && (this.isPreload = !0, n.inst.load()) : this.loadVideo(t)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? n.state : t.VideoState.UNLOAD
        }
        playVideo(t) {
            let e = this.getVideoById(t);
            e && e.inst ? this.showVideo(t) : this.loadVideo(t, !0),
            this.isPreload || (Laya.MouseManager.enabled = !1, tt.showLoading({
                    title: "加载中，请稍后..."
                })),
            Laya.MouseManager.enabled || Laya.timer.once(5e3, this, () => {
                !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                tt.hideLoading({})
            })
        }
        preloadBanner(e, n) {
            if (!this.isSupportBanner)
                return void console.log("该app不支持banner广告！");
            let a = this.getBannerById(e);
            if (a ? n || (n = a.customParams) : (!n && (n = {
                            forever: !1,
                            widthScaleRate: 1
                        }), !n.widthScaleRate && (n.widthScaleRate = 1), n.forever = Boolean(n.forever), a = {
                        id: e,
                        state: t.AdState.LOADING,
                        inst: null,
                        showCnt: 0,
                        createStamp: v.getTime(),
                        customParams: n
                    }, this.banners.push(a)), !a.inst) {
                let g = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo();
                g.windowWidth,
                n.widthScaleRate;
                var u = 208;
                u = g.windowWidth > g.windowHeight ? 128 : 2 * g.windowWidth / 3,
                a.state = t.AdState.LOADING,
                a.inst = tt.createBannerAd({
                    adUnitId: e,
                    style: {
                        left: 0,
                        top: g.screenHeight,
                        width: u
                    }
                }),
                a.inst.onResize(t => {
                    a.inst.style.left = (g.screenWidth - t.width) / 2,
                    a.inst.style.top = g.screenHeight - t.height,
                    -1 !== g.system.indexOf("iOS") && v.isQMP() && (a.inst.style.top -= 20)
                }),
                a.inst.onLoad(() => {
                    a.state = t.AdState.LOAD,
                    n && n.isPostLoadedShow ? (console.log("bannerid广告加载成功,并且自动显示！"), a.showCnt++, a.inst.show().then(() => {
                            console.log("banner广告显示成功")
                        }).catch(t => {
                            console.log("banner广告显示失败：", t)
                        })) : console.log("bannerid广告加载成功！")
                }),
                a.inst.onError(e => {
                    console.log("banner广告加载失败:", e),
                    e && (1004 == e.errCode ? (this.isBanner1004 = !0, setTimeout(() => {
                                this.isBanner1004 = !1
                            }, 6e4)) : 20002 == e.errCode && (this.isSupportBanner = !1)),
                    a.inst && a.inst.destroy(),
                    a.inst = null,
                    a.showCnt = 0,
                    a.state = t.AdState.LOAD_FAIL
                })
            }
        }
        showBanner(t, e) {
            if (!this.isSupportBanner)
                return void console.log("该app不支持banner广告！");
            if (this.isBanner1004)
                return void console.log("banner报1004错误，1分钟后再次请求广告");
            let n = this.getBannerById(t);
            n && n.inst ? n.inst.show().then(() => {
                n.showCnt++,
                console.log("banner广告显示成功")
            }).catch(t => {
                console.log("banner广告显示失败：", t)
            }) : (e || (e = {}), e.isPostLoadedShow = !0, this.preloadBanner(t, e))
        }
        hideBanner(e) {
            if (!this.isSupportBanner)
                return void console.log("该app不支持banner广告！");
            let n = this.getBannerById(e);
            n && n.inst && (n.inst.hide(), n.showCnt >= 5 && (n.showCnt = 0, n.inst.destroy(), n.inst = null, n.state = t.AdState.DELETING, this.preloadBanner(e)))
        }
        getBannerById(t) {
            return this.banners.filter((e, n, a) => e.id === t, this)[0]
        }
        showInterstitial(t) {
            if (!this.isShowInterstitial)
                return void console.log("插屏显示的间隔太短~");
            let e = Laya.ClassUtils.getRegClass("Sdk"),
            n = e.instance.getSystemInfo().SDKVersion;
            const a = "Toutiao" === e.instance.getSystemInfo().appName;
            if ("Douyin" === e.instance.getSystemInfo().appName) {
                if (console.log("curVersion:", n), !v.compatibleVersion(n, "1.71.0"))
                    return
            } else if (!a)
                return;
            if (this.interstitialInst)
                this.interstitialInst.load();
            else {
                this.interstitialInst = tt.createInterstitialAd({
                    adUnitId: t
                });
                let onLoadHandle = () => {
                    console.log("插屏广告加载成功"),
                    this.interstitialInst && this.interstitialInst.show().then(() => {
                        console.log("插屏广告展示成功"),
                        this.isShowInterstitial = !1,
                        setTimeout(() => {
                            this.isShowInterstitial = !0
                        }, 1e4)
                    })
                };
                this.interstitialInst.onLoad(onLoadHandle.bind(this));
                let onErrorHandle = t => {
                    console.log("插屏广告失败：", t)
                };
                this.interstitialInst.onError(onErrorHandle.bind(this));
                let onCloseHandle = () => {
                    console.log("插屏广告关闭"),
                    this.interstitialInst && (this.interstitialInst.destroy(), this.interstitialInst = null)
                };
                this.interstitialInst.onClose(onCloseHandle.bind(this))
            }
        }
        getInterstitial(t) {
            return this.interstitial.filter((e, n, a) => e.id === t, this)[0]
        }
        preloadInterstitial(t) {}
        init(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        preloadAppbox(t) {}
        showAppBox(t, e) {
            if (e.isMoreGamesBanner)
                this.moreGamesBanner ? this.moreGamesBanner.show() : this.ceeateMoreGamesBanner();
            else {
                let t = this.getAppBoxData(!0);
                if (!t || 0 === t.length)
                    return;
                tt.showMoreGamesModal({
                    appLaunchOptions: t,
                    success(t) {
                        console.log("success", t.errMsg)
                    },
                    fail(t) {
                        console.log("fail", t.errMsg)
                    }
                })
            }
        }
        hideAppBox(t, e) {
            e.isMoreGamesBanner && this.moreGamesBanner && this.moreGamesBanner.hide()
        }
        ceeateMoreGamesBanner() {
            if (!this.moreGamesBanner) {
                let t = this.getAppBoxData(!0);
                if (!t || 0 === t.length)
                    return;
                Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo();
                if (!tt.createMoreGamesBanner)
                    return;
                this.moreGamesBanner = tt.createMoreGamesBanner({
                    style: {
                        width: 200,
                        height: 40,
                        verticalAlign: "bottom",
                        horizontalAlign: "center"
                    },
                    appLaunchOptions: t
                }),
                this.moreGamesBanner.onResize(t => {
                    console.log("moreGamesBanner-onResize:", JSON.stringify(t))
                }),
                this.moreGamesBanner.onTap(() => {
                    console.log("点击跳转游戏盒子")
                }),
                this.moreGamesBanner.show()
            }
        }
        destoryAppBox() {}
        getAppBoxData(t = !1) {
            let e = Laya.ClassUtils.getRegClass("Sdk"),
            n = e.instance.getSystemInfo();
            if (v.compareVersion(n.SDKVersion, "1.33.0") <= 0 || "PPX" === n.appName || "ios" === n.platform)
                return;
            let a = [],
            u = e.instance.getServerJsonCfg();
            if (u && u.navigateAppList) {
                for (let e = 0; e < u.navigateAppList.length; ++e) {
                    let n = u.navigateAppList[e];
                    n && n.appId && (n.shield || (t ? a.push({
                                appId: n.appId,
                                query: n.query,
                                extraData: n.extraData
                            }) : a.push(n)))
                }
                return a
            }
        }
        createAppBoxBtn(t, e) {
            if (this.appBoxBtn)
                return;
            let n = this.getAppBoxData(!0);
            if (!n || 0 === n.length)
                return;
            let a = tt.getSystemInfoSync(),
            u = a.windowWidth / 640;
            e = e || {
                left: a.windowWidth - 101 * u,
                top: a.windowHeight / 2 * .5,
                width: 101 * u,
                height: 111 * u,
                lineHeight: 40,
                backgroundColor: "#ff0000",
                textColor: "#ffffff",
                textAlign: "center",
                fontSize: 16,
                borderRadius: 4,
                borderWidth: .1,
                borderColor: "#ff0000"
            },
            this.appBoxBtn = tt.createMoreGamesButton({
                type: "image",
                image: t,
                style: e,
                appLaunchOptions: n,
                onNavigateToMiniGame(t) {
                    console.log("跳转其他小游戏", t)
                }
            }),
            this.showAppBoxBtn()
        }
        showAppBoxBtn() {
            this.appBoxBtn && this.appBoxBtn.show()
        }
        hideAppBoxBtn() {
            this.appBoxBtn && this.appBoxBtn.hide()
        }
        destoryAppBoxBtn() {
            this.appBoxBtn && (this.appBoxBtn.destroy(), this.appBoxBtn = void 0)
        }
        showBlockAd(t, e) {}
        hideBlockAd() {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    Ye.BannerRefreshTime = 4e4;
    class $e {
        constructor() {}
        sendEvent(t, e) {
            tt.reportAnalytics && ("面板" === t ? tt.reportAnalytics("openPanel", {
                    panelName: e["打开"]
                }) : "视频" === t ? tt.reportAnalytics("playVideoPanel", {
                    panelName: e["打开"]
                }) : "视频结果" === t ? tt.reportAnalytics("playComplete", {
                    panelName: e["打开"],
                    playState: e["结果"]
                }) : tt.reportAnalytics(t, e))
        }
        stageOnStart(t) {
            tt.reportAnalytics && tt.reportAnalytics("stageOnStart", {
                stageID: t.stageId
            })
        }
        stageOnRunning(t) {}
        stageOnEnd(t) {
            tt.reportAnalytics && (console.log("stageOnEnd:", t.event), "complete" === t.event ? tt.reportAnalytics("stageOnComplete", {
                    stageID: t.stageId
                }) : "fail" === t.event && tt.reportAnalytics("stageOnFail", {
                    stageID: t.stageId
                }))
        }
        unlockItem(t) {}
    }
    class Ze {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            let e = Laya.ClassUtils.getRegClass("Sdk");
            e.instance.sendEvent("视频", {
                "打开": this.curParams.source
            }),
            e.instance.isFreeVideo() ? E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.VIDEO,
                gid: this.curParams.bindCtrlGId
            }) : this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(e.id) ? (v.showTips("暂时没有视频啦,稍后再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : (E.instance.off(st.E_AD_VIDEO, this, this.playVideoFunc), E.instance.once(st.E_AD_VIDEO, this, this.playVideoFunc, [e]), Laya.timer.scale = 0, n.instance.playVideo(e.id))
        }
        playVideoFunc(e, n) {
            !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
            e ? e.source || (e.source = fx.SceneManager.getCurUIRegName(), e.source = e.source ? e.source : "默认") : E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_FAIL,
                gid: null
            });
            let a = Laya.ClassUtils.getRegClass("Sdk");
            t.SdkCode.AD_VIDEO_SUCCESS === n.code ? (a.instance.sendEvent("视频结果", {
                    "打开": e.source,
                    "结果": "播放成功"
                }), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_SUCCESS,
                    way: t.GetRewardSDKWay.VIDEO,
                    gid: e.bindCtrlGId
                })) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), a.instance.sendEvent("视频结果", {
                    "打开": e.source,
                    "结果": "播放失败"
                }), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && (v.showTips("视频播放失败~"), a.instance.sendEvent("视频结果", {
                    "打开": e.source,
                    "结果": "播放失败"
                }), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })),
            Laya.timer.scale = 1
        }
    }
    class ti extends x {
        constructor() {
            super(),
            this.nickName = void 0,
            this.followedState = t.FollowedState.NotGot,
            this.addDeskState = t.AddDeskState.NotGot
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {
            return Laya.TTMiniAdapter
        }
        login() {
            tt.login({
                force: !1,
                success: this.ttloginSucc.bind(this),
                fail: this.ttloginFail.bind(this)
            }),
            this.networkstate = "none",
            tt.getNetworkType({
                success: t => {
                    console.log(">>>>>>>>>>>>>>>>> getNetworkType: ", t.networkType),
                    this.networkstate = t.networkType
                }
            }),
            tt.onNetworkStatusChange(t => {
                console.log(">>>>>>>>>>>>>>>>> onNetworkStatusChange: ", t.isConnected, t.networkType),
                this.networkstate = t.networkType
            }),
            this.checkFollowAwemeState({
                success: () => {
                    this.followedState = t.FollowedState.Followed
                },
                fail: () => {
                    this.followedState = t.FollowedState.Unfollowed
                }
            }),
            this.checkAddDeskState()
        }
        request(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            tt.request({
                url: t,
                data: e,
                method: u,
                dataType: "json",
                success: t => {
                    console.log("<<<<<<<<<<<<<<<<< request: ", t),
                    n && n.runWith(t.data)
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        requestDecrypt(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            tt.request({
                url: t,
                data: e,
                method: u,
                responseType: "arraybuffer",
                success: t => {
                    if (console.log("<<<<<<<<<<<<<<<<< request: ", t), n) {
                        let e = window.pako.inflate(t.data, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        getShareInstance() {
            return new Qe
        }
        getAdvInstance() {
            return new Ye
        }
        getStatInstance() {
            return new $e
        }
        getRewardStrInstance() {
            return new Ze
        }
        onSettings(e) {
            let n = e.authSetting;
            this.isUserInfoAuth = !!n["scope.userInfo"],
            this.isUserInfoAuth && tt.getUserInfo({
                success: this.userInfoSucc.bind(this)
            }),
            this.code && this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "头条登录成功"
            })
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.loginServerEnable(),
            this.createUserInfoButton()
        }
        onResume(t) {
            t.query && !v.isEmpty(t.query) && this.loginServerEnable() && (this.query = t.query, Xt.instance.postShareQuery(t.query))
        }
        ttloginSucc(e) {
            console.log("头条登录成功！");
            let n = tt.getLaunchOptionsSync();
            e.isLogin ? e.anonymousCode ? this.code = e.code + "_anonymous_" + e.anonymousCode : this.code = e.code : this.code = "anonymous_" + e.anonymousCode,
            this.loginServerEnable() && Xt.instance.login(this.code, n.query),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "头条登录成功"
            }),
            this.query = n.query,
            tt.getUserInfo({
                success: this.userInfoSucc.bind(this),
                fail: () => {
                    let t = Z.instance.getMine();
                    this.nickName = t.name,
                    this.nickName || (t.name = this.nickName = "游客" + v.getIntRandom(1, 1999)),
                    this.event(st.E_USER_INFO, {
                        code: -1,
                        nickName: this.nickName
                    })
                }
            })
        }
        ttloginFail() {
            console.log("头条登录失败！"),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "头条登录失败"
            })
        }
        userInfoSucc(t) {
            let e = Z.instance.getMine();
            t.userInfo ? (console.log("获取用户信息成功！" + JSON.stringify(t)), t.userInfo.nickName && (e.name = this.nickName = t.userInfo.nickName)) : console.log("获取用户信息失败！"),
            this.nickName = e.name,
            this.nickName || (e.name = this.nickName = "游客" + v.getIntRandom(1, 1999)),
            this.event(st.E_USER_INFO, {
                code: 0,
                info: t.userInfo,
                nickName: this.nickName
            })
        }
        createUserInfoButton() {
            let t = this.profileBtn,
            e = t.localToGlobal(new Laya.Point(0, 0)),
            n = t.localToGlobal(new Laya.Point(t.width, t.height));
            Laya.stage.transform.transformPoint(e),
            Laya.stage.transform.transformPoint(n);
            let a = n.x - e.x,
            u = n.y - e.y,
            g = tt.createUserInfoButton({
                type: "text",
                text: "",
                style: {
                    left: e.x,
                    top: e.y,
                    width: a,
                    height: u
                },
                withCredentials: !0,
                lang: "zh_CN"
            });
            g.show(),
            g.onTap(this.userInfoSucc.bind(this)),
            this.profileBtn = g,
            t.once(Laya.Event.REMOVED, this, this.destroyUserInfoButton)
        }
        destroyUserInfoButton() {
            this.profileBtn && this.profileBtn.destroy(),
            this.profileBtn = null
        }
        setKeepScreenOn(t) {
            tt.setKeepScreenOn(t)
        }
        onShow(t) {
            tt.onShow(t)
        }
        onHide(t) {
            tt.onHide(t)
        }
        checkUpdate() {
            if ("function" == typeof tt.getUpdateManager) {
                const t = tt.getUpdateManager();
                t.onCheckForUpdate((function (t) {
                        console.log(t.hasUpdate)
                    })),
                t.onUpdateReady(() => {
                    this.showModal("有新版本啦！，赶快开启新的历程吧~", "更新提示", "开启", Laya.Handler.create(this, () => {
                            t.applyUpdate()
                        }))
                }),
                t.onUpdateFailed((function () {
                        console.log("新的版本下载失败")
                    }))
            }
        }
        loadSubpackage(t) {
            return tt.loadSubpackage ? tt.loadSubpackage(t) : null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            tt.showModal({
                title: e,
                content: t,
                showCancel: "" != u && null != u,
                cancelText: u,
                confirmText: n,
                success: t => {
                    t.confirm ? a && a.run() : u && g && g.run()
                }
            })
        }
        getSystemInfo(t) {
            return !t && this.systemInfo || (this.systemInfo = tt.getSystemInfoSync(), console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo))),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            return !t && this.menuInfo || (v.compareVersion(this.systemInfo.SDKVersion, "1.25.0") >= 0 ? (this.menuInfo = tt.getMenuButtonBoundingClientRect(), console.log("getMenuButtonBoundingClientRect: " + JSON.stringify(this.menuInfo))) : this.menuInfo = {
                    width: 0,
                    height: 0,
                    top: 0,
                    right: 0,
                    bottom: Laya.stage.height,
                    left: Laya.stage.width
                }),
            this.menuInfo
        }
        exit() {
            tt.exitMiniProgram({})
        }
        getLaunchOptionsSync() {
            return tt.getLaunchOptionsSync()
        }
        navigateToMiniProgram(t) {
            tt.navigateToMiniProgram(t)
        }
        getOpenDataContext() {
            return tt.getOpenDataContext()
        }
        createFeedbackButton(t) {
            return tt.createFeedbackButton(t)
        }
        openCustomerServiceConversation(t) {
            tt.openCustomerServiceConversation(t)
        }
        createGameClubButton(t) {
            tt.createGameClubButton(t)
        }
        onAudioInterruption(t, e) {
            tt.onAudioInterruptionBegin(t),
            tt.onAudioInterruptionEnd(e)
        }
        vibrateShort() {
            tt.vibrateShort({})
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        judgeBAndW(e) {
            let n = e.sceneId;
            if (!n)
                return t.BlackAndWhite.Black;
            let a = Laya.LocalStorage.getItem("BAndW");
            return "white" === a || "black" === a ? "white" === a && 1037 !== n && 1044 !== n && 1007 !== n && 1104 !== n && 1008 !== n && 1001 !== n && 1038 !== n && 1090 !== n && 1103 !== n && 1089 !== n && 1095 !== n && (a = "black", Laya.LocalStorage.setItem("BAndW", a)) : (a = 1095 === n || 1037 === n || 1058 === n ? "white" : "black", Laya.LocalStorage.setItem("BAndW", a)),
            a === t.BlackAndWhite.White ? t.BlackAndWhite.White : t.BlackAndWhite.Black
        }
        getCode() {}
        saveAppToDesktop(e) {
            tt.checkShortcut && (this.addDeskState === t.AddDeskState.Add ? (console.log("桌面图标已存在！"), e.success && e.success()) : this.addDeskState === t.AddDeskState.NotAdd ? tt.addShortcut({
                    success: n => {
                        let a = !1,
                        u = this.getSystemInfo();
                        if (u) {
                            let t = (u && u.system).split(" ")[1];
                            v.compatibleVersion(t, "7.0") || (a = !0)
                        }
                        Laya.timer.once(500, this, () => {
                            a ? (this.addDeskState = t.AddDeskState.Add, e.success && e.success()) : this.checkAddDeskState(e)
                        })
                    },
                    fail: t => {
                        console.log("桌面图标添加失败：", JSON.stringify(t)),
                        e.fail && e.fail()
                    }
                }) : e.fail && e.fail())
        }
        getAddDeskState() {
            return this.addDeskState
        }
        checkAddDeskState(e) {
            tt.checkShortcut && tt.checkShortcut({
                success: n => {
                    console.log("查询成功：", JSON.stringify(n)),
                    n.status.exist ? (console.log("桌面图标已存在！"), this.addDeskState = t.AddDeskState.Add, e && e.success && e.success()) : (this.addDeskState = t.AddDeskState.NotAdd, e && e.fail && e.fail())
                },
                fail: n => {
                    console.log("查询失败：", JSON.stringify(n)),
                    this.addDeskState = t.AddDeskState.FailAdd,
                    e && e.fail && e.fail()
                }
            })
        }
        showFavoriteGuide(t) {
            if (!tt.showFavoriteGuide)
                return;
            let e = t.type ? t.type : "bar";
            tt.showFavoriteGuide({
                type: e,
                content: "一键添加到我的小程序",
                success(e) {
                    console.log("引导组件展示成功:", JSON.stringify(e)),
                    t && t.success && t.success()
                },
                fail(e) {
                    console.log("引导组件展示失败:", JSON.stringify(e)),
                    t && t.fail && t.fail()
                }
            })
        }
        FollowAwemeUser(e) {
            tt.openAwemeUserProfile && tt.openAwemeUserProfile({
                success: n => {
                    console.log("---- open success, res: ", n);
                    let {
                        hasFollowed: a
                    } = n;
                    a ? e.success && (e.success(), this.followedState = t.FollowedState.Followed) : e.fail && (e.fail(), this.followedState = t.FollowedState.Unfollowed)
                },
                fail: t => {
                    console.log("---- open fail, err: ", JSON.stringify(t)),
                    e.fail && e.fail()
                },
                complete: t => {
                    console.log("---- open complete, res: ", JSON.stringify(t))
                }
            })
        }
        getFollowAwemeState() {
            return this.followedState
        }
        checkFollowAwemeState(t) {
            tt.checkFollowAwemeState && tt.checkFollowAwemeState({
                success: e => {
                    console.log("---- check success, res:", JSON.stringify(e));
                    let {
                        hasFollowed: n
                    } = e;
                    n ? t.success && t.success() : t.fail && t.fail()
                },
                fail: e => {
                    console.log("---- check fail,", JSON.stringify(e)),
                    t.fail && t.fail()
                }
            })
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            if ("Douyin" !== this.getSystemInfo().appName)
                return !1;
            if (Laya.ClassUtils.getRegClass("Sdk").instance.isAudit())
                return !1;
            if (this.getNickName(), !this.nickName)
                return !1;
            let t = b.instance.get("nickName");
            for (const e in t)
                if (t.hasOwnProperty(e)) {
                    if (t[e] === this.nickName)
                        return !0
                }
            for (const e in t)
                if (t.hasOwnProperty(e)) {
                    if (-1 !== t[e].indexOf(this.nickName))
                        return !0
                }
            if (!this.getServerJsonCfgNickName())
                return !1;
            if (-1 !== this.getServerJsonCfgNickName().indexOf(this.nickName))
                return !0;
            return !1
        }
        getServerJsonCfgNickName() {
            let t = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfg();
            return t ? t.nickName : void 0
        }
        getNickName() {
            return this.nickName
        }
        clipboardData(t) {}
        showLoading(t, e, n) {
            tt.showLoading({
                title: t || "加载中...",
                success: n && n.success,
                fail: n && n.fail
            })
        }
        hideLoading(t) {
            tt.hideLoading({
                success: t && t.success,
                fail: t && t.fail
            })
        }
    }
    class ei {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            if (t.VideoState.UNENABLED === n.instance.isHasVideo(this.curParams.id))
                v.showTips("今天已经没有视频啦,明天再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                });
            else {
                var a = V.instance.getToggleMusicStatus();
                E.instance.once(st.E_AD_VIDEO, this, (function (n) {
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        t.SdkCode.AD_VIDEO_SUCCESS === n.code ? (E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                                way: t.GetRewardSDKWay.VIDEO,
                                gid: e.bindCtrlGId
                            }), a && V.instance.toggleAll()) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_FAIL,
                                gid: e.bindCtrlGId
                            }), a && V.instance.toggleAll()) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && (v.showTips("视频播放失败~"), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_FAIL,
                                gid: e.bindCtrlGId
                            }), a && V.instance.toggleAll())
                    })),
                Laya.MouseManager.enabled = !1,
                n.instance.playVideo(e.id),
                a && V.instance.toggleAll()
            }
        }
    }
    class ii {
        constructor() {
            this.timeout = !0,
            this.imgPath = {
                closePath: null,
                bgPath: null
            },
            this.shortcutButton = void 0,
            this.nativeIndex = 0,
            this._showAppBoxAdIndex = 0,
            this._showBlockAdIndex = 0,
            this.banners = void 0,
            this.videos = [],
            this.curIsAutoPlayVideo = !1,
            this.interstitial = void 0,
            this.nativeAd = new Array,
            this.curNativeAdIndex = 0,
            this.nativeAdParentInfo = {
                nativeAdType: t.NativeAdType.NATIVE,
                parent: null,
                adPos: null,
                btnPos: null,
                btnHarvestPos: null,
                adSize: null
            },
            this.imgPath = {
                closePath: "",
                bgPath: ""
            },
            this.nativeAdImg = void 0,
            this.nativeAdData = void 0,
            this.gameBannerAd = void 0,
            this.gamePortalAd = void 0,
            this.customAds = []
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            this.curIsAutoPlayVideo = n;
            this.videos.length;
            let a = this.getVideoById(e);
            a || (a = {
                    id: e,
                    inst: null,
                    state: t.AdState.LOADING
                }, this.videos.push(a)),
            !a.inst && qg.createRewardedVideoAd ? (a.inst = qg.createRewardedVideoAd({
                    posId: e
                }), a.inst.onLoad(() => {
                    console.log("激励视频广告加载成功"),
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    a.state = t.AdState.LOAD,
                    this.curIsAutoPlayVideo && this.showVideo(a.id)
                }), a.inst.onError(e => {
                    if (console.log("激励视频广告加载失败", JSON.stringify(e)), !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), a.state = t.AdState.LOAD, E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                        }), this.curIsAutoPlayVideo) {
                        Laya.ClassUtils.getRegClass("Sdk").instance.hideLoading()
                    }
                }), a.inst.onClose(e => {
                    e && e.isEnded || void 0 === e ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                        })),
                    this.curIsAutoPlayVideo = !1,
                    Laya.ClassUtils.getRegClass("Sdk").instance.hideLoading(),
                    Laya.timer.once(1e3, this, (function () {
                            a.inst.load()
                        }))
                })) : a.inst.load().catch(e => {
                a.state = t.AdState.LOAD,
                console.log("激励视频广告显示失败", JSON.stringify(e))
            })
        }
        showVideo(e) {
            let n = this.getVideoById(e);
            n && n.inst && n.inst.show().then(() => {}).catch(() => {
                n.inst.load().then(() => n.inst.show()).catch(e => {
                    n.state = t.AdState.LOAD,
                    console.log("激励视频广告显示失败", JSON.stringify(e)),
                    E.instance.event(st.E_AD_VIDEO, {
                        code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                    }),
                    Laya.ClassUtils.getRegClass("Sdk").instance.hideLoading()
                })
            })
        }
        preloadVideo(t) {
            this.loadVideo(t)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? t.AdState.LOAD === n.state ? t.VideoState.ENABLED : t.VideoState.UNENABLED : t.VideoState.UNLOAD
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            n.instance.showLoading("加载中..."),
            console.log("video Id", e);
            let a = this.getVideoById(e);
            a ? t.AdState.LOAD === a.state ? (Laya.MouseManager.enabled = !1, this.showVideo(e)) : t.AdState.LOAD_FAIL === a.state && (E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                }), n.instance.hideLoading()) : (Laya.MouseManager.enabled = !1, this.loadVideo(e, !0)),
            Laya.MouseManager.enabled || Laya.timer.once(5e3, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    n.instance.hideLoading()
                }))
        }
        preloadBanner(t, e) {}
        getBannerById(t) {}
        showBanner(t) {
            this.bannerAd && this.bannerAd.destroy(),
            this.bannerAd = qg.createBannerAd({
                posId: t,
                style: {}
            });
            let e = this.bannerAd.show();
            e && e.then(() => {
                console.log("banner广告展示成功")
            }).catch(t => {
                switch (t.code) {
                case 30003:
                    console.log("新用户7天内不能曝光Banner，请将手机时间调整为7天后，退出游戏重新进入");
                    break;
                case 30009:
                    if (console.log("10秒内调用广告次数超过1次，10秒后再调用"), 0 == this.timeout)
                        break;
                    break;
                case 30002:
                    console.log("加载广告失败，重新加载广告");
                    break;
                default:
                    console.log("banner广告展示失败"),
                    console.log(JSON.stringify(t))
                }
            })
        }
        retryShowbanner(t) {
            this.bannerAd = qg.createBannerAd({
                posId: t,
                style: {}
            });
            let e = this.bannerAd.show();
            e && e.catch(t => {
                console.log("banner广告展示失败-重试"),
                console.log(JSON.stringify(t))
            })
        }
        hideBanner() {
            if (this.bannerAd) {
                var t = this.bannerAd.hide();
                t && t.then(() => {
                    console.log("banner广告隐藏成功")
                }).catch(t => {
                    console.log("banner广告隐藏失败", t)
                })
            }
        }
        showInterstitial(t) {
            let e = qg.createInterstitialAd({
                posId: t
            });
            e.onLoad(() => {
                console.log("interstitial 广告加载成功")
            }),
            e.onError(t => {
                console.log("interstitial 广告加载失败", JSON.stringify(t))
            });
            let n = e.show();
            n && n.catch(t => {
                console.log("插屏广告展示失败-重试"),
                console.log(JSON.stringify(t))
            })
        }
        getInterstitial(t) {}
        preloadInterstitial(t) {}
        init(t) {}
        createNativeAd(e) {
            if (!this.nativeAdImg)
                switch (console.log("adList:", e), E.instance.event(st.E_AD_NATIVE, {
                        code: t.SdkCode.AD_NATIVE_SUCCESS
                    }), this.nativeAdParentInfo.nativeAdType) {
                case t.NativeAdType.ICON:
                    break;
                case t.NativeAdType.BANNER:
                    this.createNativeBannerAd(e);
                    break;
                case t.NativeAdType.NATIVE:
                    this.createNativeBigAd(e)
                }
        }
        createNativeBigAd(t) {
            if (this.nativeAdImg = new Laya.Image, this.loadImage(this.nativeAdImg, t.imgUrlList[0]), this.nativeAdImg.anchorX = .5, this.nativeAdImg.anchorY = 0, this.nativeAdImg.size(this.nativeAdParentInfo.adSize.w, this.nativeAdParentInfo.adSize.h), this.nativeAdImg.pos(this.nativeAdParentInfo.adPos.x, this.nativeAdParentInfo.adPos.y), this.nativeAdParentInfo.parent.addChild(this.nativeAdImg), t.icon) {
                let e = new Laya.Image;
                this.loadImage(e, t.icon),
                e.left = e.top = 0,
                e.size(100, 100),
                this.nativeAdImg.addChild(e)
            }
            let e = new Laya.Image;
            this.loadImage(e, "res/img_tips.png"),
            e.anchorX = e.anchorY = .5,
            e.size(60, 40),
            e.sizeGrid = "15,15,15,15",
            e.bottom = e.right = 0,
            this.nativeAdImg.addChild(e);
            let n = new Laya.Label;
            n.text = "广告",
            n.fontSize = 20,
            n.color = "#ffffff",
            n.anchorX = n.anchorY = .5,
            n.centerX = n.centerY = 0,
            e.addChild(n);
            let a = new Laya.Image;
            this.loadImage(a, this.imgPath.closePath),
            a.right = a.top = 0,
            a.size(50, 50),
            this.nativeAdImg.addChild(a);
            let u = new Laya.Image;
            this.loadImage(u, this.imgPath.bgPath),
            u.sizeGrid = "20,20,20,20",
            u.size(300, 120),
            u.anchorX = u.anchorY = .5,
            this.nativeAdImg.addChild(u);
            let g = new Laya.Label;
            g.text = "查看广告",
            g.fontSize = 50,
            g.color = "#ffffff",
            g.bold = !0,
            g.anchorX = g.anchorY = .5,
            g.centerX = g.centerY = 0,
            u.addChild(g),
            this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdShow({
                adId: this.nativeAd[this.curNativeAdIndex].adList.adId
            }),
            a.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy(),
                this.nativeAdImg = null
            }),
            this.nativeAdImg.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy(),
                this.nativeAdImg = null,
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            }),
            u.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy(),
                this.nativeAdImg = null,
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            }),
            Laya.ClassUtils.getRegClass("Sdk").instance.isHarvest() ? u.pos(this.nativeAdParentInfo.btnHarvestPos.x, this.nativeAdParentInfo.btnHarvestPos.y) : u.pos(this.nativeAdParentInfo.btnPos.x, this.nativeAdParentInfo.btnPos.y)
        }
        createNativeBannerAd(t) {
            this.nativeAdImg = new Laya.Box,
            this.nativeAdImg.bgColor = "#ffffff",
            this.nativeAdImg.anchorX = .5,
            this.nativeAdImg.anchorY = 0,
            this.nativeAdImg.size(this.nativeAdParentInfo.adSize.w, this.nativeAdParentInfo.adSize.h),
            this.nativeAdImg.pos(this.nativeAdParentInfo.adPos.x, this.nativeAdParentInfo.adPos.y),
            this.nativeAdParentInfo.parent.addChild(this.nativeAdImg);
            let e = 2 * (this.nativeAdParentInfo.adSize.h - 20),
            n = new Laya.Image;
            this.loadImage(n, t.imgUrlList[0]),
            n.left = 0,
            n.centerY = 0,
            n.size(e, e / 2),
            this.nativeAdImg.addChild(n);
            let a = this.nativeAdParentInfo.adSize.h / 2 * 2.5,
            u = new Laya.Image;
            this.loadImage(u, this.imgPath.bgPath),
            u.sizeGrid = "20,20,20,20",
            u.size(a, this.nativeAdParentInfo.adSize.h / 2),
            u.right = 10,
            u.centerY = 0,
            this.nativeAdImg.addChild(u);
            let g = new Laya.Label;
            g.text = t.clickBtnTxt ? t.clickBtnTxt : "点击查看",
            g.fontSize = .4 * u.height,
            g.color = "#ffffff",
            g.bold = !0,
            g.centerX = 0,
            g.centerY = -5,
            u.addChild(g);
            let p = new Laya.Label;
            p.text = t.title,
            p.fontSize = 30,
            p.bold = !0,
            p.color = "#000000",
            p.left = n.left + e + 10,
            p.centerY = -p.fontSize,
            this.nativeAdImg.addChild(p);
            let f = this.nativeAdImg.width - p.left - u.right - u.width - 10,
            m = new Laya.Label;
            m.text = t.desc,
            m.fontSize = 25,
            m.width = f,
            m.height = 2 * m.fontSize,
            m.color = "#000000",
            m.wordWrap = !0,
            m.left = n.left + e + 10,
            m.centerY = m.fontSize,
            this.nativeAdImg.addChild(m);
            let y = new Laya.Image;
            this.loadImage(y, "res/img_tips.png"),
            y.size(60, 40),
            y.sizeGrid = "15,15,15,15",
            y.bottom = y.right = 0,
            y.zOrder = 2,
            this.nativeAdImg.addChild(y);
            let S = new Laya.Label;
            S.text = "广告",
            S.fontSize = 20,
            S.color = "#ffffff",
            S.centerX = S.centerY = 0,
            y.addChild(S);
            let _ = new Laya.Image;
            this.loadImage(_, this.imgPath.closePath),
            _.left = _.top = 0,
            _.size(50, 50),
            _.zOrder = 2,
            this.nativeAdImg.addChild(_),
            this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdShow({
                adId: this.nativeAd[this.curNativeAdIndex].adList.adId
            });
            let touchFunc = t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy(),
                this.nativeAdImg = null,
                this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdClick({
                    adId: this.nativeAd[this.curNativeAdIndex].adList.adId
                })
            };
            this.nativeAdImg.once(Laya.Event.CLICK, this, touchFunc),
            u.once(Laya.Event.CLICK, this, touchFunc),
            n.once(Laya.Event.CLICK, this, touchFunc),
            _.on(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeAdImg.removeSelf(),
                this.nativeAdImg.destroy()
            })
        }
        createNativeIconAd(t) {
            this.nativeIconAd.nativeImg = new Laya.Image;
            let e = t.icon ? t.icon : t.imgUrlList[0];
            this.loadImage(this.nativeIconAd.nativeImg, e),
            this.nativeIconAd.nativeImg.anchorX = .5,
            this.nativeIconAd.nativeImg.anchorY = 0,
            this.nativeIconAd.nativeImg.size(this.nativeAdParentInfo.adSize.h, this.nativeAdParentInfo.adSize.h),
            this.nativeIconAd.nativeImg.pos(this.nativeAdParentInfo.adPos.x, this.nativeAdParentInfo.adPos.y),
            this.nativeAdParentInfo.parent.addChild(this.nativeIconAd.nativeImg);
            let n = new Laya.Image;
            this.loadImage(n, "res/img_tips.png"),
            n.size(60, 40),
            n.sizeGrid = "15,15,15,15",
            n.bottom = n.right = 0,
            n.zOrder = 2,
            this.nativeIconAd.nativeImg.addChild(n);
            let a = new Laya.Label;
            a.text = "广告",
            a.fontSize = 20,
            a.color = "#ffffff",
            a.centerX = a.centerY = 0,
            n.addChild(a);
            let u = new Laya.Image;
            this.loadImage(u, this.imgPath.closePath),
            u.right = u.top = 0,
            u.size(50, 50),
            u.zOrder = 2,
            this.nativeIconAd.nativeImg.addChild(u),
            this.nativeAd[this.curNativeAdIndex].inst && this.nativeAd[this.curNativeAdIndex].inst.reportAdShow({
                adId: this.nativeAd[this.curNativeAdIndex].adList.adId
            }),
            this.nativeIconAd.nativeImg.once(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeIconAd.nativeImg.removeSelf(),
                this.nativeIconAd.nativeImg.destroy(),
                this.nativeIconAd.inst && this.nativeIconAd.inst.reportAdClick({
                    adId: this.nativeIconAd.adList.adId
                })
            }),
            u.on(Laya.Event.CLICK, this, t => {
                t.stopPropagation(),
                this.nativeIconAd.nativeImg.removeSelf(),
                this.nativeIconAd.nativeImg.destroy()
            }),
            this.nativeIconAd.id = this.nativeAd[this.curNativeAdIndex].id,
            this.nativeIconAd.inst = this.nativeAd[this.curNativeAdIndex].inst,
            this.nativeIconAd.adList = this.nativeAd[this.curNativeAdIndex].adList,
            this.nativeIconAd.isLoad = this.nativeAd[this.curNativeAdIndex].isLoad,
            this.nativeAd[this.curNativeAdIndex].inst = null,
            this.nativeAd[this.curNativeAdIndex].isLoad = !1,
            this.curNativeAdIndex += 1,
            this.curNativeAdIndex > 1 && (this.curNativeAdIndex = 0)
        }
        loadImage(t, e) {
            e && e.length > 0 && Laya.loader.load(e, Laya.Handler.create(t, e => {
                    e && t && (t.source = e)
                }), null, Laya.Loader.IMAGE)
        }
        preloadNativeAd(t, e) {
            if (0 == this.nativeAd.length)
                for (let e = 0; e < t.length; e++)
                    this.nativeAd.push({
                        id: t[e],
                        isLoad: !1,
                        inst: null,
                        adList: null
                    });
            this.imgPath = e,
            this.loadNativeAd()
        }
        loadNativeAd() {
            var e = qg.createNativeAd({
                posId: this.nativeAd[this.curNativeAdIndex].id
            });
            this.nativeAd[this.curNativeAdIndex].inst = e;
            var n = (t => {
                this.nativeAd[this.curNativeAdIndex].adList = t,
                this.nativeAd[this.curNativeAdIndex].isLoad = !0,
                this.nativeAd[this.curNativeAdIndex].inst = e,
                this.nativeAdParentInfo.parent && this.createNativeAd(this.nativeAd[this.curNativeAdIndex].adList)
            }).bind(this);
            e.onLoad((function (t) {
                    console.log("原生广告加载成功：", JSON.stringify(t.adList)),
                    n(t.adList[0])
                }));
            var a = this.loadNativeAd.bind(this);
            var u = (() => {
                this.nativeAd[this.curNativeAdIndex].inst.offLoad(),
                this.nativeAd[this.curNativeAdIndex].inst = null,
                this.curNativeAdIndex += 1,
                this.curNativeAdIndex > 1 ? (this.curNativeAdIndex = 0, E.instance.event(st.E_AD_NATIVE, {
                        code: t.SdkCode.AD_NATIVE_FAIL
                    })) : a()
            }).bind(this);
            let g = e.load();
            g && g.then(() => {
                console.log("加载成功！")
            }).catch(t => {
                u()
            })
        }
        showNativeAd(e, n) {
            this.nativeAdImg && n.nativeAdType != t.NativeAdType.ICON ? (this.destoryNativeAd(), setTimeout(() => {
                    this.showNativeAd(e, n)
                }, 100)) : (this.nativeAdParentInfo.parent = e, this.nativeAdParentInfo.adPos = {
                    x: e.width / 2,
                    y: n.adPosY
                }, this.nativeAdParentInfo.btnPos = {
                    x: e.width / 2,
                    y: n.btnPosY
                }, this.nativeAdParentInfo.btnHarvestPos = {
                    x: e.width / 2,
                    y: n.btnHarvestPosY
                }, this.nativeAdParentInfo.adSize = {
                    w: Laya.stage.width > Laya.stage.height ? Laya.stage.height : Laya.stage.width,
                    h: n.adSizeH
                }, n.nativeAdType && (this.nativeAdParentInfo.nativeAdType = n.nativeAdType, n.nativeAdType == t.NativeAdType.ICON && n.adIconPosX && (this.nativeAdParentInfo.adPos.x = n.adIconPosX)), this.nativeAd[this.curNativeAdIndex] && (this.nativeAd[this.curNativeAdIndex].isLoad ? this.createNativeAd(this.nativeAd[this.curNativeAdIndex].adList) : this.loadNativeAd()))
        }
        destoryNativeAd(e = t.NativeAdType.NATIVE) {
            e == t.NativeAdType.ICON ? this.nativeIconAd.inst && (this.nativeIconAd.inst.offLoad(), this.nativeIconAd.inst = null, this.nativeIconAd.isLoad = !1, this.nativeIconAd.nativeImg && (this.nativeIconAd.nativeImg.removeSelf(), this.nativeIconAd.nativeImg.destroy())) : (this.nativeAd[this.curNativeAdIndex].inst && (this.nativeAd[this.curNativeAdIndex].inst.offLoad(), this.nativeAd[this.curNativeAdIndex].inst = null, this.nativeAd[this.curNativeAdIndex].isLoad = !1, this.curNativeAdIndex += 1, this.curNativeAdIndex > 1 && (this.curNativeAdIndex = 0)), this.nativeAdImg && (this.nativeAdImg.removeSelf(), this.nativeAdImg.destroy(), this.nativeAdImg = null)),
            this.nativeAdParentInfo.nativeAdType = t.NativeAdType.NATIVE,
            this.nativeAdParentInfo.parent = this.nativeAdParentInfo.adPos = this.nativeAdParentInfo.adSize = this.nativeAdParentInfo.btnPos = this.nativeAdParentInfo.btnHarvestPos = null,
            this.loadNativeAd()
        }
        reportAdClickNativeAd() {}
        getNativeAdData(e) {
            let n = e;
            if (!n) {
                let t = Laya.ClassUtils.getRegClass("Sdk");
                n = t.instance.getNativeAdId()
            }
            if (!n || n.length <= 0)
                return void E.instance.event(st.E_AD_NATIVE, {
                    code: t.SdkCode.AD_NATIVE_DATA,
                    data: null
                });
            let a = qg.createNativeAd({
                adUnitId: n[this.nativeIndex]
            });
            a.onLoad((e => {
                    console.log("原生广告加载成功：", JSON.stringify(e.adList)),
                    a.offLoad(),
                    a.offError(),
                    this.nativeIndex = 0,
                    this.nativeAdData = {
                        inst: null,
                        adList: null
                    },
                    this.nativeAdData.inst = a,
                    this.nativeAdData.adList = e.adList[0],
                    E.instance.event(st.E_AD_NATIVE, {
                        code: t.SdkCode.AD_NATIVE_DATA,
                        data: this.nativeAdData
                    })
                }).bind(this));
            a.onError((e => {
                    a.offLoad(),
                    a.offError(),
                    this.nativeIndex += 1,
                    this.nativeIndex >= n.length ? (console.log("原生广告加载失败，结束加载：", JSON.stringify(e)), this.nativeIndex = 0, E.instance.event(st.E_AD_NATIVE, {
                            code: t.SdkCode.AD_NATIVE_DATA,
                            data: this.nativeAdData
                        })) : (console.log("原生广告加载失败，再次加载：", JSON.stringify(e)), setTimeout(() => {
                            this.getNativeAdData(n)
                        }, 500))
                }).bind(this)),
            a.load()
        }
        preloadAppbox(t) {}
        showAppBox(e, n) {
            qg.createBoxPortalAd ? (this.gamePortalAd || (this.gamePortalAd = qg.createBoxPortalAd({
                        posId: e,
                        marginTop: n.top
                    }), this.gamePortalAd.onLoad(() => {
                        console.log("互推盒子九宫格广告加载成功")
                    }), this.gamePortalAd.onClose(() => {
                        E.instance.event(st.E_AD_APPBOX, {
                            code: t.SdkCode.AD_APPBOX_CLOSE
                        }),
                        this.showAppBox(e, n)
                    })), this.gamePortalAd.show().then(() => {
                    console.log("互推盒子九宫格广告展示成功"),
                    E.instance.event(st.E_AD_APPBOX, {
                        code: t.SdkCode.AD_APPBOX_SUCCESS
                    })
                }).catch(t => {
                    console.log("互推盒子九宫格广告展示失败:" + JSON.stringify(t))
                }), this._showAppBoxAdIndex += 1) : console.log("暂不支持互推盒子相关 API")
        }
        hideAppBox() {
            this.gamePortalAd && (this.gamePortalAd.hide().then((function () {
                        console.log("互推盒子九宫格广告隐藏成功")
                    })).catch((function (t) {
                        console.log("互推盒子九宫格广告隐藏失败:" + JSON.stringify(t))
                    })), this._showAppBoxAdIndex >= 3 && (this._showAppBoxAdIndex = 0, this.gamePortalAd.destroy().then((function () {
                            console.log("互推盒子九宫格广告销毁成功")
                        })).catch((function (t) {
                            console.log("互推盒子九宫格广告销毁失败:" + JSON.stringify(t))
                        })), this.gamePortalAd = null))
        }
        destoryAppBox() {}
        getAppBoxData() {
            return 1111
        }
        createAppBoxBtn(t, e) {
            qg.getSystemInfoSync().platformVersionCode >= 1084 ? (this.shortcutButton = qg.createShortcutButton({
                    type: "image",
                    style: e
                }), this.shortcutButton.onTap(t => {
                    !t || 0 != t.code && 1 != t.code || (this.shortcutButton.offTap(), this.shortcutButton.hide(), this.shortcutButton.destroy(), this.shortcutButton = void 0)
                })) : this.shortcutButton = void 0
        }
        showAppBoxBtn() {
            this.shortcutButton && this.shortcutButton.show()
        }
        hideAppBoxBtn() {
            this.shortcutButton && this.shortcutButton.hide()
        }
        destoryAppBoxBtn() {
            this.shortcutButton && this.shortcutButton.destroy()
        }
        showBlockAd(e, n) {
            qg.createBoxBannerAd ? (this.gameBannerAd || (this.gameBannerAd = qg.createBoxBannerAd({
                        posId: e
                    }), this.gameBannerAd.onLoad(() => {
                        console.log("互推盒子横幅广告加载成功")
                    })), this.gameBannerAd.show().then(() => {
                    console.log("互推横幅广告展示成功"),
                    E.instance.event(st.E_AD_BLOCK, {
                        code: t.SdkCode.AD_BLOCK_SUCCESS
                    })
                }).catch(e => {
                    console.log("互推横幅广告展示失败:" + e.errCode + "," + e.errMsg),
                    E.instance.event(st.E_AD_BLOCK, {
                        code: t.SdkCode.AD_BLOCK_FAIL
                    })
                }), this._showBlockAdIndex += 1) : console.log("暂不支持互推盒子相关 API")
        }
        hideBlockAd() {
            this.gameBannerAd && (this.gameBannerAd.hide().then(() => {
                    console.log("互推横幅广告隐藏成功")
                }).catch(t => {
                    console.log("互推横幅广告隐藏失败:" + t.errCode + "," + t.errMsg)
                }), this._showBlockAdIndex >= 2 && (this._showBlockAdIndex = 0, this.gameBannerAd.destroy().then(() => {
                        console.log("destroy success")
                    }).catch(t => {
                        console.log("destroy fail with:" + t.errCode + "," + t.errMsg)
                    }), this.gameBannerAd = null))
        }
        getCustomAdById(t) {
            return this.customAds.filter((e, n, a) => e.id === t, this)[0]
        }
        showCustomAd(e, n) {
            if (qg.getSystemInfoSync().platformVersionCode < 1091 || !qg.createCustomAd)
                return void E.instance.event(st.E_AD_NATIVE_CUSTOM, {
                    code: t.SdkCode.AD_NATIVE_CUSTOM_FAIL
                });
            let a = this.getCustomAdById(e);
            if (a ? a.inst && (a.inst.isShow() && a.inst.hide(), a.inst.destroy(), a.inst = null) : (a = {
                        id: e,
                        inst: null
                    }, this.customAds.push(a)), n) {
                let t = qg.getSystemInfoSync();
                n.left && (n.left = n.left / Laya.stage.designWidth * t.screenWidth),
                n.top && (n.top = n.top / Laya.stage.designHeight * t.screenHeight)
            } else
                n = {};
            a.inst = qg.createCustomAd({
                posId: e,
                style: n
            }),
            a.inst.onLoad(() => {}),
            a.inst.onClose(() => {
                E.instance.event(st.E_AD_NATIVE_CUSTOM, {
                    code: t.SdkCode.AD_NATIVE_CUSTOM_CLOSE
                })
            }),
            a.inst.onError(e => {
                console.log("原生模板广告加载失败:", e),
                E.instance.event(st.E_AD_NATIVE_CUSTOM, {
                    code: t.SdkCode.AD_NATIVE_CUSTOM_FAIL
                })
            }),
            a.inst.show().then(() => {
                console.log("原生模板广告展示完成"),
                E.instance.event(st.E_AD_NATIVE_CUSTOM, {
                    code: t.SdkCode.AD_NATIVE_CUSTOM_SUCCESS
                })
            }).catch(e => {
                console.log("原生模板广告展示失败", JSON.stringify(e)),
                E.instance.event(st.E_AD_NATIVE_CUSTOM, {
                    code: t.SdkCode.AD_NATIVE_CUSTOM_FAIL
                })
            })
        }
        hideCustomAd(t) {
            if (qg.getSystemInfoSync().platformVersionCode < 1091 || !qg.createCustomAd)
                return;
            let e = this.getCustomAdById(t);
            e && e.inst && (e.inst.isShow() && e.inst.hide(), e.inst.offLoad(() => {}), e.inst.offClose(() => {}), e.inst.offError(() => {}), e.inst.destroy(), e.inst = null)
        }
    }
    ii.BannerRefreshTime = 4e4;
    class si {
        constructor() {}
        init(t) {}
        recordVideo(t) {}
        stopRecord(t) {}
        shareVideo(t) {
            return !1
        }
        canRecord() {
            return !1
        }
        canShareRecord() {
            return null
        }
        pauseRecord() {}
        resumeRecord() {}
        destroyRecord() {}
        setShare(t, e, n) {}
        share(t, e, n) {
            qg.share({
                success: function () {
                    console.log("分享成功")
                },
                fail: function (t, e) {
                    console.log("分享失败：" + e + ": " + t)
                },
                cancel: function () {
                    console.log("分享取消")
                },
                complete: function () {
                    console.log("分享调用完成")
                }
            })
        }
    }
    Laya.ClassUtils.regClass("VivoShare", si);
    class ni {
        constructor() {}
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {
            return Laya.VVMiniAdapter
        }
        login() {
            this.networkstate = "none",
            qg.getNetworkType({
                success: t => {
                    console.log(">>>>>>>>>>>>>>>>> getNetworkType: ", t.networkType),
                    this.networkstate = t.networkType
                }
            }),
            Laya.ClassUtils.getRegClass("Sdk").instance.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "vivo登录成功！"
            })
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, (function (t) {
                    n && n.runWith(t)
                })),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, (function (t) {
                    if (n) {
                        let e = window.pako.inflate(t, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                })),
            g.once(Laya.Event.ERROR, this, () => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        getShareInstance() {
            return new si
        }
        getAdvInstance() {
            return new ii
        }
        getStatInstance() {
            return null
        }
        getRewardStrInstance() {
            return new ei
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {}
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.loginServerEnable(),
            this.createUserInfoButton()
        }
        onResume(t) {}
        createUserInfoButton() {}
        destroyUserInfoButton() {}
        setKeepScreenOn(t) {
            qg.setKeepScreenOn(t)
        }
        onShow(t) {
            qg.onShow(t)
        }
        onHide(t) {
            qg.onHide(t)
        }
        checkUpdate() {}
        loadSubpackage(t) {
            return qg.loadSubpackage ? qg.loadSubpackage(t) : null
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            qg.showDialog({
                title: e,
                message: t,
                buttons: [{
                        text: n,
                        color: "#000000"
                    }, {
                        text: u,
                        color: "#000000"
                    }
                ],
                success: function (t) {
                    console.log("handling callback"),
                    a && a.run()
                },
                cancel: function () {
                    console.log("handling cancel"),
                    g && g.run()
                },
                fail: function (t, e) {
                    console.log("handling fail, code = " + e),
                    g && g.run()
                }
            })
        }
        getSystemInfo(t) {
            if (!t && this.systemInfo)
                return this.systemInfo;
            this.systemInfo = qg.getSystemInfoSync();
            let e = qg.getNotchHeightSync();
            return e && (this.systemInfo.statusBarHeight = e.height || 0),
            console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo)),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            return !t && this.menuInfo,
            this.menuInfo
        }
        exit() {
            qg.exitApplication({})
        }
        getLaunchOptionsSync() {}
        navigateToMiniProgram(t) {}
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation(t) {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {
            qg.onAudioInterruptionBegin(t),
            qg.onAudioInterruptionEnd(e)
        }
        vibrateShort() {
            qg.vibrateShort({
                success: function (t) {},
                fail: function (t) {},
                complete: function (t) {}
            })
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        getShareEnabled() {
            let t = !1,
            e = Laya.ClassUtils.getRegClass("Sdk");
            return e.instance.isAudit() || (t = e.instance.getServerJsonCfgShareEnable()),
            t
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.White
        }
        getCode() {}
        saveAppToDesktop(t) {
            qg.hasShortcutInstalled({
                success: e => {
                    0 == e && qg.installShortcut(t)
                },
                fail: function (t) {},
                complete: function () {}
            })
        }
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {
            qg.showLoading({
                title: t || "加载中...",
                success: n && n.success,
                fail: n && n.fail
            })
        }
        hideLoading(t) {
            qg.hideLoading({
                success: t && t.success,
                fail: t && t.fail
            })
        }
    }
    class ai {
        constructor() {
            this.banners = [],
            this.videos = [],
            this.curIsAutoPlayVideo = !1,
            this.interstitial = [],
            this.customAds = [],
            this.gridAds = []
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            this.curIsAutoPlayVideo = n;
            let a = 0 === this.videos.length,
            u = this.getVideoById(e);
            u || (u = {
                    id: e,
                    inst: null,
                    state: t.AdState.LOADING
                }, this.videos.push(u)),
            u.inst ? t.AdState.LOAD_FAIL === u.state && u.inst.load().catch(e => {
                u.state = t.AdState.LOAD_FAIL,
                console.log("激励视频广告显示失败")
            }) : (u.inst = wx.createRewardedVideoAd({
                    adUnitId: u.id
                }), u.inst.load(), a && (u.inst.onLoad(() => {
                        console.log("激励视频广告加载成功"),
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        u.state = t.AdState.LOAD,
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_SUCCESS
                        }),
                        this.curIsAutoPlayVideo && this.showVideo(u.id)
                    }), u.inst.onError(e => {
                        console.log("激励视频广告加载失败"),
                        !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                        u.state = t.AdState.LOAD_FAIL,
                        E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                        })
                    }), u.inst.onClose(e => {
                        e && e.isEnded || void 0 === e ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                                code: t.SdkCode.AD_VIDEO_SUCCESS
                            })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                                code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                            })),
                        this.curIsAutoPlayVideo = !1,
                        Laya.timer.once(1e3, this, (function () {
                                u.inst.load()
                            }))
                    })))
        }
        showVideo(e) {
            let n = this.getVideoById(e);
            n && n.inst && n.inst.show().then(() => {}).catch(() => {
                n.inst.load().then(() => n.inst.show()).catch(e => {
                    n.state = t.AdState.LOAD_FAIL,
                    console.log("激励视频广告显示失败")
                })
            })
        }
        preloadVideo(t) {
            this.loadVideo(t)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? t.AdState.LOAD === n.state ? t.VideoState.ENABLED : t.VideoState.UNENABLED : t.VideoState.UNLOAD
        }
        playVideo(e) {
            console.log("video Id", e);
            let n = this.getVideoById(e);
            n ? t.AdState.LOAD === n.state ? (Laya.MouseManager.enabled = !1, this.showVideo(e)) : t.AdState.LOAD_FAIL === n.state && (v.showTips("暂无视频!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                })) : (Laya.MouseManager.enabled = !1, this.loadVideo(e, !0)),
            Laya.MouseManager.enabled || Laya.timer.once(1e4, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadBanner(e, n) {
            let a = this.getBannerById(e);
            if (a ? n || (n = a.customParams) : (!n && (n = {
                            forever: !1,
                            widthScaleRate: 1
                        }), !n.widthScaleRate && (n.widthScaleRate = 1), n.forever = Boolean(n && n.forever), a = {
                        id: e,
                        state: t.AdState.LOADING,
                        inst: null,
                        showCnt: 0,
                        createStamp: v.getTime(),
                        customParams: n
                    }, this.banners.push(a)), a.inst)
                t.AdState.DELETING !== a.state && t.AdState.LOAD_FAIL !== a.state || (a.inst.destroy(), a.inst = null, a.showCnt = 0, a.state = t.AdState.LOADING, this.preloadBanner(e, n));
            else {
                let u = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo(),
                g = (u.screenWidth > u.screenHeight ? u.screenHeight : u.screenWidth) * n.widthScaleRate;
                a.inst = wx.createBannerAd({
                    adUnitId: e,
                    adIntervals: 30,
                    style: {
                        left: 0,
                        top: 0,
                        width: g
                    }
                }),
                a.inst.onResize(t => {
                    a.inst.style.left = (u.screenWidth - a.inst.style.realWidth) / 2,
                    a.inst.style.top = u.screenHeight - a.inst.style.realHeight,
                    -1 !== u.system.indexOf("iOS") && v.isQMP() && (a.inst.style.top -= 24)
                }),
                a.inst.onLoad(() => {
                    console.log("bannerid${bannerIds[i]} 广告加载成功"),
                    a.state = t.AdState.LOAD,
                    a.customParams && a.customParams.forever && a.inst.show()
                }),
                a.inst.onError(e => {
                    console.log("bannerid${bannerIds[i]} 广告加载失败"),
                    a.state = t.AdState.LOAD_FAIL
                })
            }
        }
        showBanner(e, n) {
            console.log("banner Id", e);
            let a = this.getBannerById(e);
            if (a) {
                if (a.customParams && a.customParams.forever)
                    return;
                if (t.AdState.LOAD === a.state) {
                    if (n && n.top) {
                        let t = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo();
                        a.inst.style.top = n.top / Laya.stage.height * t.screenHeight
                    }
                    a.showCnt++,
                    a.inst.show()
                } else
                    t.AdState.LOAD_FAIL === a.state ? Laya.timer.once(1e4, this, (function () {
                            this.preloadBanner(e)
                        })) : t.AdState.LOADING === a.state && n && n.isPostLoadedShow && Laya.timer.once(500, this, (function () {
                            this.showBanner(e, n)
                        }))
            } else
                this.preloadBanner(e, n)
        }
        hideBanner(e, n) {
            let a = this.getBannerById(e);
            a && (a.customParams && a.customParams.forever || (a.inst && a.inst.hide(), a.showCnt > 0 && n && (a.state = t.AdState.DELETING, this.preloadBanner(e))))
        }
        getBannerById(t) {
            return this.banners.filter((e, n, a) => e.id === t, this)[0]
        }
        showInterstitial(t) {
            let e = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo().SDKVersion;
            if (!v.compatibleVersion(e, "2.6.0"))
                return;
            let n = this.getInterstitial(t);
            if (n)
                n.inst.show();
            else {
                let e = wx.createInterstitialAd({
                    adUnitId: t
                });
                this.interstitial.push({
                    id: t,
                    inst: e
                }),
                e.onLoad(() => {
                    console.log("interstitial 广告加载成功")
                }),
                e.onError(t => {
                    console.log("interstitial 广告加载失败")
                }),
                e.onClose(t => {
                    console.log("插屏 广告关闭")
                })
            }
        }
        getInterstitial(t) {
            return this.interstitial.filter((e, n, a) => e.id === t, this)[0]
        }
        preloadInterstitial(t) {}
        init(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd() {}
        reportAdClickNativeAd() {}
        getNativeAdData() {}
        getAppboxAdById(t) {
            return this.gridAds.filter((e, n, a) => t === e.id)[0]
        }
        preloadAppbox(t) {}
        showAppBox(t, e) {}
        hideAppBox(t, e) {}
        destoryAppBox() {}
        getAppBoxData() {
            return 1
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(e, n) {
            let a = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo(),
            u = this.getCustomAdById(e);
            u || (u = {
                    id: e,
                    inst: null
                }, this.customAds.push(u));
            let g = a.screenWidth * (n.style.left / Laya.stage.width),
            p = a.screenHeight * (n.style.top / Laya.stage.height);
            u.inst ? u.inst.show().catch(t => console.log("原生模板广告显示失败：", JSON.stringify(t))).then(() => console.log("原生模板广告显示")) : (n.adIntervals = n.adIntervals ? n.adIntervals : 30, u.inst = wx.createCustomAd({
                    adUnitId: e,
                    adIntervals: n.adIntervals,
                    style: {
                        left: g,
                        top: p,
                        fixed: !0
                    }
                }), u.inst.onLoad(() => console.log("原生模板广告加载成功")), u.inst.onError(e => {
                    console.log("原生模板广告加载失败：", JSON.stringify(e)),
                    E.instance.event(st.E_AD_NATIVE_CUSTOM, {
                        code: t.SdkCode.AD_NATIVE_CUSTOM_FAIL
                    })
                }), u.inst.onClose(() => {
                    console.log("原生模板广告关闭"),
                    E.instance.event(st.E_AD_NATIVE_CUSTOM, {
                        code: t.SdkCode.AD_NATIVE_CUSTOM_CLOSE
                    })
                }))
        }
        hideBlockAd(t, e) {
            let n = this.getCustomAdById(t);
            n && n.inst && (n.inst.hide(), e && (n.inst.destroy(), n.inst = null))
        }
        getCustomAdById(t) {
            return this.customAds.filter((e, n, a) => t === e.id)[0]
        }
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    ai.BannerRefreshTime = 4e4;
    class oi {
        constructor() {}
        sendEvent(t, e) {
            wx.uma && wx.uma.trackEvent && wx.uma.trackEvent(t, e)
        }
        stageOnStart(t) {
            wx.uma && wx.uma.stage.onStart && wx.uma.stage.onStart(t)
        }
        stageOnRunning(t) {
            wx.uma && wx.uma.stage.onRunning && wx.uma.stage.onRunning(t)
        }
        stageOnEnd(t) {
            wx.uma.stage.onEnd && wx.uma.stage.onEnd(t)
        }
        unlockItem(t) {}
    }
    class ri {
        constructor() {
            this.curRewardStrategyCnt = void 0,
            this.shareCount = 0,
            this.shareStartTime = void 0
        }
        static get rewardStrategyCnt() {
            if (void 0 === this._rewardStrategyCnt)
                if (Z.instance.isNewDay && Z.instance.isNewDay())
                    this.rewardStrategyCnt = 0;
                else {
                    let t = Laya.LocalStorage.getItem("rewardStrategyCnt");
                    null == t || "" === t ? this.rewardStrategyCnt = 0 : this._rewardStrategyCnt = Number(t)
                }
            return this._rewardStrategyCnt
        }
        static set rewardStrategyCnt(t) {
            this._rewardStrategyCnt !== t && (this._rewardStrategyCnt = t, Laya.LocalStorage.setItem("rewardStrategyCnt", this._rewardStrategyCnt.toString()))
        }
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e,
            t && e && (ri.rewardStrategyCnt++, this.curRewardStrategyCnt = ri.rewardStrategyCnt)
        }
        getStrategy() {
            let e = Laya.ClassUtils.getRegClass("Sdk");
            if (t.GetRewardSDKWay.AUTO === this.curStrategy) {
                if (t.VideoState.ENABLED === e.instance.isHasVideo(this.curParams.id)) {
                    let n = e.instance.getServerJsonCfgShareParams().OlderShareCtnBase;
                    Z.instance.isFirstLogin && Z.instance.isFirstLogin() && (n = e.instance.getServerJsonCfgShareParams().FreshShareCntBase),
                    n || (n = 0);
                    let a = null;
                    if (0 !== n && this.curRewardStrategyCnt <= n)
                        a = t.GetRewardSDKWay.SHARE;
                    else {
                        let u = e.instance.getServerJsonCfgShareParams().ShareSpace;
                        u || (u = 0),
                        a = u > 0 && 0 == (this.curRewardStrategyCnt - n) % (u + 1) ? t.GetRewardSDKWay.SHARE : t.GetRewardSDKWay.VIDEO
                    }
                    return a
                }
                return t.GetRewardSDKWay.SHARE
            }
            return t.GetRewardSDKWay.SHARE === this.curStrategy ? this.curStrategy : t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            let e = Laya.ClassUtils.getRegClass("Sdk"),
            n = this.getStrategy();
            e.instance.isFreeVideo() ? E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.VIDEO,
                gid: this.curParams.bindCtrlGId
            }) : t.GetRewardSDKWay.SHARE === n ? (e.instance.sendEvent("分享", {
                    "开始": this.curParams.source
                }), this.share(this.curParams)) : t.GetRewardSDKWay.VIDEO === n && (e.instance.sendEvent("视频", {
                    "开始": this.curParams.source
                }), this.playVideo(this.curParams))
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk"),
            a = n.instance.isHasVideo(this.curParams.id);
            if (t.VideoState.UNENABLED === a) {
                Laya.ClassUtils.getRegClass("Sdk").instance.isAudit() ? (v.showTips("今天已经没有视频啦~"), E.instance.event(st.E_REWARD_GAIN, {
                        code: t.SdkCode.REWARD_GAIN_FAIL,
                        gid: e.bindCtrlGId
                    })) : (v.showTips("今天已经没有视频啦, 分享也可获得奖励哟!"), Laya.MouseManager.enabled = !1, Laya.timer.once(1e3, this, (function () {
                            Laya.MouseManager.enabled = !0,
                            this.share(e)
                        })))
            } else
                E.instance.once(st.E_AD_VIDEO, this, (function (a) {
                        t.SdkCode.AD_VIDEO_SUCCESS === a.code ? (this.curParams && this.curParams.forever && (ri.rewardStrategyCnt++, this.curRewardStrategyCnt++, ri.rewardStrategyCnt++), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                                way: t.GetRewardSDKWay.VIDEO,
                                gid: e.bindCtrlGId
                            }), n.instance.sendEvent("视频", {
                                "完成": e.source
                            })) : t.SdkCode.AD_VIDEO_UNCOMPLETE === a.code ? (n.instance.showModal("看完视频才会有奖励哟！！！", "提示", "继续观看", Laya.Handler.create(this, (function () {
                                        this.playVideo(e)
                                    })), "一会再来", Laya.Handler.create(this, (function () {
                                        E.instance.event(st.E_REWARD_GAIN, {
                                            code: t.SdkCode.REWARD_GAIN_FAIL,
                                            gid: e.bindCtrlGId
                                        })
                                    }))), n.instance.sendEvent("视频", {
                                "未完成": e.source
                            })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === a.code && E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_FAIL,
                            gid: e.bindCtrlGId
                        })
                    })), n.instance.playVideo(e.id)
        }
        share(e) {
            this.shareStartTime = v.getTime();
            let n = Laya.ClassUtils.getRegClass("Sdk");
            E.instance.once(f.E_APP_ON_RESUME, this, (function (a) {
                    if (Math.floor((v.getTime() - this.shareStartTime) / 1e3) > 3) {
                        this.shareCount += 1;
                        let a = !1;
                        if (this.shareCount > 1)
                            a = !0;
                        else {
                            let t = n.instance.getServerJsonCfgShareParams().shareFailProb;
                            t || (t = 0),
                            v.getIntRandom(0, 100) >= t && (a = !0)
                        }
                        a ? (this.shareCount = 0, this.curParams && this.curParams.forever && (ri.rewardStrategyCnt++, this.curRewardStrategyCnt++, ri.rewardStrategyCnt++), E.instance.event(st.E_REWARD_GAIN, {
                                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                                way: t.GetRewardSDKWay.SHARE,
                                gid: e.bindCtrlGId
                            }), n.instance.sendEvent("分享", {
                                "完成": e.source
                            })) : this.continueShare(e, "不要频繁骚扰同一个群!")
                    } else
                        this.continueShare(e, "分享失败!"), n.instance.sendEvent("分享", {
                            "未完成": e.source
                        });
                    this.shareStartTime = void 0
                })),
            n.instance.share(e)
        }
        continueShare(e, n) {
            Laya.ClassUtils.getRegClass("Sdk").instance.showModal(n, "提示", "继续分享", Laya.Handler.create(this, (function () {
                        this.share(e)
                    })), "一会再来", Laya.Handler.create(this, (function () {
                        this.shareCount = 0,
                        E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_FAIL,
                            gid: e.bindCtrlGId
                        })
                    })))
        }
    }
    ri._rewardStrategyCnt = void 0;
    class li extends x {
        constructor() {
            super(),
            this._nickName = void 0
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {
            return Laya.MiniAdpter
        }
        login() {
            wx.login({
                success: this.wxloginSucc.bind(this),
                fail: this.wxloginFail.bind(this)
            }),
            wx.getSetting({
                success: this.onSettings.bind(this)
            }),
            this.networkstate = "none",
            wx.getNetworkType({
                success: t => {
                    console.log(">>>>>>>>>>>>>>>>> getNetworkType: ", t.networkType),
                    this.networkstate = t.networkType
                }
            }),
            wx.onNetworkStatusChange(t => {
                console.log(">>>>>>>>>>>>>>>>> onNetworkStatusChange: ", t.isConnected, t.networkType),
                this.networkstate = t.networkType
            })
        }
        request(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            wx.request({
                url: t,
                data: e,
                method: u,
                dataType: "json",
                success: t => {
                    console.log("<<<<<<<<<<<<<<<<< request: ", t),
                    n && n.runWith(t.data)
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        requestDecrypt(t, e, n, a, u) {
            console.log(">>>>>>>>>>>>>>>>> request: ", t, e),
            wx.request({
                url: t,
                data: e,
                method: u,
                responseType: "arraybuffer",
                success: t => {
                    if (console.log("<<<<<<<<<<<<<<<<< request: ", t), n) {
                        let e = window.pako.inflate(t.data, {
                            to: "string"
                        });
                        n.runWith(JSON.parse(e))
                    }
                },
                fail: t => {
                    console.log("<<<<<<<<<<<<<<<<< request error: ", t),
                    console.log("获取服务器JSON配置失败！"),
                    a && a.run()
                }
            })
        }
        getShareInstance() {
            return new jt
        }
        getAdvInstance() {
            return new ai
        }
        getStatInstance() {
            return new oi
        }
        getRewardStrInstance() {
            return new ri
        }
        onSettings(e) {
            let n = e.authSetting;
            this.isUserInfoAuth = !!n["scope.userInfo"],
            this.isUserInfoAuth ? wx.getUserInfo({
                success: this.userInfoSucc.bind(this)
            }) : wx.authorize({
                scope: "scope.userInfo",
                success: this.getNickName.bind(this)
            }),
            this.code && this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS,
                msg: "微信登录成功"
            })
        }
        isAuth() {
            return this.isUserInfoAuth
        }
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        getQuery() {
            return this.query
        }
        getEncryptedData() {
            return [this.encryptedData, this.iv]
        }
        auth(t) {
            this.profileBtn = t,
            this.profileToServer = this.loginServerEnable(),
            this.createUserInfoButton()
        }
        onResume(t) {
            t.query && !v.isEmpty(t.query) && this.loginServerEnable() && (this.query = t.query, Xt.instance.postShareQuery(t.query))
        }
        wxloginSucc(e) {
            console.log("微信登录成功！");
            let n = 10;
            const checkNeedFix = () => !this.menuInfo || this.menuInfo.top > 0 || n <= 0 ? (this.code = e.code, this.loginServerEnable() && Xt.instance.login(this.code, a.query), void 0 !== this.isUserInfoAuth && this.event(st.E_SDK_LOGIN, {
                    code: t.SdkCode.WX_LOGIN_SUCCESS,
                    msg: "微信登录成功"
                }), !1) : (n--, !0),
            fixInfo = () => {
                this.getSystemInfo(!0),
                this.getMenuButtonBoundingClientRect(!0),
                checkNeedFix() || (v.sNotchScreen = void 0, Laya.timer.clear(this, fixInfo))
            };
            let a = wx.getLaunchOptionsSync();
            this.query = a.query,
            checkNeedFix() && Laya.timer.loop(100, this, fixInfo)
        }
        wxloginFail() {
            console.log("微信登录失败！"),
            this.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_FAILED,
                msg: "微信登录失败"
            })
        }
        userInfoSucc(e) {
            let n;
            e.userInfo ? (console.log("获取用户信息成功！" + JSON.stringify(e)), this.isUserInfoAuth = !0, this.encryptedData = e.encryptedData, this.iv = e.iv, this.destroyUserInfoButton(), n = new t.SDKEntity.UserInfoEntity, function (t, e) {
                null != t.nickName && (e.name = t.nickName),
                null != t.avatarUrl && (e.headUrl = t.avatarUrl),
                null != t.gender && (e.sex = t.gender),
                null != t.city && (e.city = t.city),
                null != t.province && (e.province = t.province),
                null != t.country && (e.country = t.country),
                null != t.language && (e.language = t.language)
            }
                (e.userInfo, n), Z.instance.update(n), this.getNickName(), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_SUCCESS,
                    msg: "授权成功"
                })) : (console.log("获取用户信息失败！"), this.event(st.E_USER_INFO, {
                    code: t.SdkCode.WX_AUTH_FAILED,
                    msg: "用户拒绝授权"
                })),
            this.profileToServer && Xt.instance.postProfile(n)
        }
        createUserInfoButton() {
            let t = this.profileBtn,
            e = t.localToGlobal(new Laya.Point(0, 0)),
            n = t.localToGlobal(new Laya.Point(t.width, t.height));
            Laya.stage.transform.transformPoint(e),
            Laya.stage.transform.transformPoint(n);
            let a = n.x - e.x,
            u = n.y - e.y,
            g = wx.createUserInfoButton({
                type: "text",
                text: "",
                style: {
                    left: e.x,
                    top: e.y,
                    width: a,
                    height: u
                },
                withCredentials: !0,
                lang: "zh_CN"
            });
            g.show(),
            g.onTap(this.userInfoSucc.bind(this)),
            this.profileBtn = g,
            t.once(Laya.Event.REMOVED, this, this.destroyUserInfoButton)
        }
        destroyUserInfoButton() {
            this.profileBtn && this.profileBtn.destroy(),
            this.profileBtn = null
        }
        setKeepScreenOn(t) {
            wx.setKeepScreenOn(t)
        }
        onShow(t) {
            wx.onShow(t)
        }
        onHide(t) {
            wx.onHide(t)
        }
        checkUpdate() {
            if ("function" == typeof wx.getUpdateManager) {
                const t = wx.getUpdateManager();
                t.onCheckForUpdate((function (t) {
                        console.log(t.hasUpdate)
                    })),
                t.onUpdateReady(() => {
                    this.showModal("有新版本啦！，赶快开启新的历程吧~", "更新提示", "开启", Laya.Handler.create(this, () => {
                            t.applyUpdate()
                        }))
                }),
                t.onUpdateFailed((function () {
                        console.log("新的版本下载失败")
                    }))
            }
        }
        loadSubpackage(t) {
            return wx.loadSubpackage ? wx.loadSubpackage(t) : (this.showModal("请升级微信到最新版本！", "提示", "确定", Laya.Handler.create(this, () => {
                        this.exit()
                    }), ""), null)
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            wx.showModal({
                title: e,
                content: t,
                showCancel: "" != u && null != u,
                cancelText: u,
                confirmText: n,
                success: t => {
                    t.confirm ? a && a.run() : u && g && g.run()
                }
            })
        }
        getSystemInfo(t) {
            return !t && this.systemInfo || (this.systemInfo = wx.getSystemInfoSync(), console.log("getSystemInfoSync: " + JSON.stringify(this.systemInfo))),
            this.systemInfo
        }
        getMenuButtonBoundingClientRect(t) {
            return !t && this.menuInfo || v.compareVersion(this.systemInfo.SDKVersion, "2.1.0") >= 0 && (this.menuInfo = wx.getMenuButtonBoundingClientRect(), console.log("getMenuButtonBoundingClientRect: " + JSON.stringify(this.menuInfo))),
            this.menuInfo
        }
        exit() {
            wx.exitMiniProgram({})
        }
        getLaunchOptionsSync() {
            return wx.getLaunchOptionsSync()
        }
        navigateToMiniProgram(t) {
            wx.navigateToMiniProgram(t)
        }
        getOpenDataContext() {
            return wx.getOpenDataContext()
        }
        createFeedbackButton(t) {
            return wx.createFeedbackButton(t)
        }
        openCustomerServiceConversation(t) {
            wx.openCustomerServiceConversation(t)
        }
        createGameClubButton(t) {
            wx.createGameClubButton(t)
        }
        onAudioInterruption(t, e) {
            wx.onAudioInterruptionBegin(t),
            wx.onAudioInterruptionEnd(e)
        }
        vibrateShort() {
            wx.vibrateShort({})
        }
        getNetworkType() {
            return this.networkstate
        }
        isConnectNetwork() {
            return console.log("networkstate: ", this.networkstate),
            "none" !== this.networkstate
        }
        judgeBAndW(e) {
            let n = e.sceneId;
            if (!n)
                return t.BlackAndWhite.Black;
            let a = Laya.LocalStorage.getItem("BAndW");
            return a || (a = 1095 === n || 1037 === n || 1046 === n ? "white" : "black", Laya.LocalStorage.setItem("BAndW", a)),
            a === t.BlackAndWhite.White ? t.BlackAndWhite.White : t.BlackAndWhite.Black
        }
        getCode() {
            if (this.code)
                return this.code
        }
        saveAppToDesktop(t) {}
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {
            wx.requestSubscribeMessage(t)
        }
        getNickName() {
            if (!this.nickName) {
                wx.getUserInfo({
                    success: (t => {
                        if (t.userInfo)
                            console.log("获取用户信息成功！" + JSON.stringify(t)), t.userInfo.nickName && (this.nickName = t.userInfo.nickName);
                        else {
                            console.log("获取用户信息失败！");
                            let t = Laya.ClassUtils.getRegClass("Sdk");
                            this.nickName = "undefined_" + t.GameCfg.appId
                        }
                    }).bind(this),
                    fail: t => {
                        console.log("===========:", t)
                    }
                })
            }
        }
        get nickName() {
            return this._nickName
        }
        set nickName(t) {
            this._nickName = t
        }
        isFreeVideo() {
            if (this.getNickName(), !this.nickName)
                return !1;
            let t = b.instance.get("nickName");
            for (const e in t)
                if (t.hasOwnProperty(e)) {
                    if (t[e] === this.nickName)
                        return !0
                }
            for (const e in t)
                if (t.hasOwnProperty(e)) {
                    if (-1 !== t[e].indexOf(this.nickName))
                        return !0
                }
            if (!this.getServerJsonCfgNickName())
                return !1;
            if (-1 !== this.getServerJsonCfgNickName().indexOf(this.nickName))
                return !0;
            return !1
        }
        getServerJsonCfgNickName() {
            let t = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfg();
            return t ? t.nickName : void 0
        }
        clipboardData(t) {}
        showLoading(t, e, n) {
            wx.showLoading({
                title: t || "加载中...",
                mask: e || !1,
                success: n && n.success,
                fail: n && n.fail
            })
        }
        hideLoading(t) {
            wx.hideLoading({
                success: t && t.success,
                fail: t && t.fail
            })
        }
    }
    class hi {
        setCurStrategy(t, e) {
            this.curStrategy = t,
            this.curParams = e
        }
        getStrategy() {
            return t.GetRewardSDKWay.VIDEO
        }
        runStrategy() {
            let e = Laya.ClassUtils.getRegClass("Sdk");
            e.instance.sendEvent("视频", {
                "打开": this.curParams.source
            }),
            e.instance.isFreeVideo() ? E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.VIDEO,
                gid: this.curParams.bindCtrlGId
            }) : this.playVideo(this.curParams)
        }
        playVideo(e) {
            let n = Laya.ClassUtils.getRegClass("Sdk");
            t.VideoState.UNENABLED === n.instance.isHasVideo(e.id) ? (v.showTips("暂时没有视频啦,稍后再看吧!"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : (E.instance.off(st.E_AD_VIDEO, this, this.playVideoFunc), E.instance.once(st.E_AD_VIDEO, this, this.playVideoFunc, [e]), n.instance.playVideo(e.id))
        }
        playVideoFunc(e, n) {
            !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
            e || E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_FAIL,
                gid: null
            }),
            t.SdkCode.AD_VIDEO_SUCCESS === n.code ? E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.VIDEO,
                gid: e.bindCtrlGId
            }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === n.code ? (v.showTips("看完视频才会有奖励哟！！！"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                })) : t.SdkCode.AD_VIDEO_LOAD_FAIL === n.code && (v.showTips("视频播放失败~"), E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_FAIL,
                    gid: e.bindCtrlGId
                }))
        }
    }
    class di {
        constructor() {
            this.banners = [],
            this.videos = [],
            this.curIsAutoPlayVideo = !1,
            this.interstitial = []
        }
        getVideoById(t) {
            return this.videos.filter((e, n, a) => t === e.id)[0]
        }
        loadVideo(e, n = !1) {
            this.curIsAutoPlayVideo = n;
            this.videos.length;
            let a = this.getVideoById(e);
            a || (a = {
                    id: e,
                    inst: null,
                    state: t.AdState.LOADING
                }, this.videos.push(a)),
            !a.inst && qg.createRewardedVideoAd ? (a.inst = qg.createRewardedVideoAd({
                    adUnitId: "12345"
                }), a.inst.onLoad(() => {
                    console.log("激励视频广告加载成功"),
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    a.state = t.AdState.LOAD,
                    this.curIsAutoPlayVideo && this.showVideo(a.id)
                }), a.inst.onError(e => {
                    console.log("激励视频广告加载失败", JSON.stringify(e)),
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0),
                    a.state = t.AdState.LOAD,
                    v.showTips("视频广告观看太频繁，请稍后再试~"),
                    E.instance.event(st.E_AD_VIDEO, {
                        code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                    })
                }), a.inst.onClose(e => {
                    e && e.isEnded || void 0 === e ? (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_SUCCESS
                        })) : (!Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0), E.instance.event(st.E_AD_VIDEO, {
                            code: t.SdkCode.AD_VIDEO_UNCOMPLETE
                        })),
                    this.curIsAutoPlayVideo = !1,
                    Laya.timer.once(1e3, this, (function () {
                            a.inst.load()
                        }))
                })) : a.inst.load().catch(e => {
                a.state = t.AdState.LOAD,
                console.log("激励视频广告显示失败", JSON.stringify(e)),
                v.showTips("视频广告观看太频繁，请稍后再试~")
            })
        }
        showVideo(e) {
            let n = this.getVideoById(e);
            n && n.inst && n.inst.show().then(() => {}).catch(() => {
                n.inst.load().then(() => n.inst.show()).catch(e => {
                    n.state = t.AdState.LOAD,
                    v.showTips("视频广告观看太频繁，请稍后再试~"),
                    console.log("激励视频广告显示失败", JSON.stringify(e)),
                    E.instance.event(st.E_AD_VIDEO, {
                        code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                    })
                })
            })
        }
        preloadVideo(t) {
            this.loadVideo(t)
        }
        getVideoState(e) {
            let n = this.getVideoById(e);
            return n ? t.AdState.LOAD === n.state ? t.VideoState.ENABLED : t.VideoState.UNENABLED : t.VideoState.UNLOAD
        }
        playVideo(e) {
            console.log("video Id", e);
            let n = this.getVideoById(e);
            n ? t.AdState.LOAD === n.state ? (Laya.MouseManager.enabled = !1, this.showVideo(e)) : t.AdState.LOAD_FAIL === n.state && (v.showTips("暂无视频!!!"), E.instance.event(st.E_AD_VIDEO, {
                    code: t.SdkCode.AD_VIDEO_LOAD_FAIL
                })) : (Laya.MouseManager.enabled = !1, this.loadVideo(e, !0)),
            Laya.MouseManager.enabled || Laya.timer.once(1e4, this, (function () {
                    !Laya.MouseManager.enabled && (Laya.MouseManager.enabled = !0)
                }))
        }
        preloadBanner(e, n) {
            let a = this.getBannerById("12345");
            if (a ? n || (n = a.customParams) : (!n && (n = {
                            forever: !1,
                            widthScaleRate: 1
                        }), !n.widthScaleRate && (n.widthScaleRate = 1), n.forever = Boolean(n.forever), a = {
                        id: "12345",
                        state: t.AdState.LOADING,
                        inst: null,
                        showCnt: 0,
                        createStamp: v.getTime(),
                        customParams: n
                    }, this.banners.push(a)), a.inst)
                t.AdState.DELETING !== a.state && t.AdState.LOAD_FAIL !== a.state || (a.inst.destroy(), a.inst = null, a.showCnt = 0, a.state = t.AdState.LOADING, this.preloadBanner("12345"));
            else {
                let e = Laya.ClassUtils.getRegClass("Sdk").instance.getSystemInfo();
                e.screenWidth,
                n.widthScaleRate;
                a.inst = qg.createBannerAd({
                    adUnitId: "12345"
                }),
                a.inst.onResize(t => {
                    a.inst.style.left = (e.screenWidth - t.width) / 2,
                    a.inst.style.top = e.screenHeight - t.height
                }),
                a.inst.show(),
                a.inst.onShow(() => {
                    console.log("bannerid${bannerIds[i]} 广告加载成功"),
                    a.state = t.AdState.LOAD
                }),
                a.inst.onError(e => {
                    console.log("bannerid${bannerIds[i]} 广告加载失败", JSON.stringify(e)),
                    a.state = t.AdState.LOAD_FAIL,
                    E.instance.event(st.E_AD_BANNER, {
                        code: t.SdkCode.AD_BANNER_FAIL
                    })
                }),
                a.inst.onLoad(() => {
                    console.log("load success")
                })
            }
        }
        showBanner(e, n) {
            let a = this.getBannerById("12345");
            if (a) {
                if (a.customParams.forever)
                    return;
                t.AdState.LOAD === a.state ? (a.showCnt++, a.inst.show()) : this.preloadBanner("12345")
            } else
                this.preloadBanner("12345", n)
        }
        hideBanner(e) {
            let n = this.getBannerById("12345");
            n && (n.inst && (n.inst.hide(), n.inst.destroy(), n.inst = null), n.showCnt = 0, n.state = t.AdState.DELETING)
        }
        getBannerById(t) {
            return this.banners.filter((e, n, a) => e.id === t, this)[0]
        }
        showInterstitial(t, e) {
            let n = qg.createInterstitialAd({
                adUnitId: "12345"
            });
            n.onLoad(() => {
                console.log("interstitial 广告加载成功")
            }),
            n.onError(t => {
                console.log("interstitial 广告加载失败", JSON.stringify(t))
            }),
            n.show().catch(t => {
                console.log("插屏广告展示失败-重试"),
                console.log(JSON.stringify(t))
            })
        }
        getInterstitial(t) {}
        preloadInterstitial(t) {}
        init(t) {}
        preloadNativeAd(t) {}
        showNativeAd(t, e) {}
        destoryNativeAd(t) {}
        reportAdClickNativeAd() {}
        getNativeAdData(t) {}
        preloadAppbox(t) {}
        showAppBox(t, e) {}
        hideAppBox(t, e) {}
        destoryAppBox() {}
        getAppBoxData() {
            let t = [],
            e = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfg();
            if (e && e.navigateAppList) {
                for (let n = 0; n < e.navigateAppList.length; ++n) {
                    let a = e.navigateAppList[n];
                    a && a.appId && (a.shield || t.push(a))
                }
                return t
            }
        }
        createAppBoxBtn(t, e) {}
        showAppBoxBtn() {}
        hideAppBoxBtn() {}
        destoryAppBoxBtn() {}
        showBlockAd(t, e) {}
        hideBlockAd(t) {}
        showCustomAd(t, e) {}
        hideCustomAd(t) {}
    }
    di.BannerRefreshTime = 4e4;
    class ci {
        constructor() {
            this.addDeskState = t.AddDeskState.NotGot
        }
        initMiniAdapter() {}
        engineInitialized() {}
        getMiniAdapter() {}
        login() {
            let e = Laya.ClassUtils.getRegClass("Sdk").GameCfg,
            n = Z.instance.getMine();
            n.openId = e.user_unique_id,
            n.name = "test_user",
            n.headUrl = "",
            this.loginServerEnable() ? Xt.instance.loginNoAuth() : E.instance.event(st.E_SDK_LOGIN, {
                code: t.SdkCode.WX_LOGIN_SUCCESS
            }),
            this.checkAddDeskState()
        }
        request(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                n && n.runWith(t)
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "json", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        requestDecrypt(t, e, n, a, u) {
            let g = new Laya.HttpRequest;
            g.http.timeout = 1e4,
            g.once(Laya.Event.COMPLETE, this, t => {
                if (n) {
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    n.runWith(JSON.parse(e))
                }
            }),
            g.once(Laya.Event.ERROR, this, t => {
                a && a.run()
            }),
            g.send(t, null, u, "arraybuffer", ["Content-Type", "application/x-www-form-urlencoded"])
        }
        onResume() {}
        getQuery() {}
        setKeepScreenOn(t) {}
        onShow(t) {}
        onHide(t) {}
        isAuth() {
            return !0
        }
        auth(t) {}
        destroyUserInfoButton() {}
        loginServerEnable() {
            return "" != Laya.ClassUtils.getRegClass("Sdk").GameCfg.server_url
        }
        checkUpdate() {}
        loadSubpackage(t) {}
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            v.showTips(t)
        }
        getSystemInfo() {
            return {
                SDKVersion: "0.0.0"
            }
        }
        getMenuButtonBoundingClientRect() {
            return null
        }
        exit() {}
        getLaunchOptionsSync() {}
        navigateToMiniProgram(t) {}
        getOpenDataContext() {}
        createFeedbackButton(t) {}
        openCustomerServiceConversation() {}
        createGameClubButton(t) {}
        onAudioInterruption(t, e) {}
        vibrateShort() {}
        getShareInstance() {}
        getAdvInstance() {
            return new di
        }
        getStatInstance() {}
        getRewardStrInstance() {
            return new hi
        }
        getNetworkType() {
            return "wifi"
        }
        isConnectNetwork() {
            return !0
        }
        judgeBAndW(e) {
            return t.BlackAndWhite.White
        }
        getCode() {}
        saveAppToDesktop(e) {
            let n = qg.getShortcut();
            n && (n.systemPromptEnabled = !0, this.addDeskState === t.AddDeskState.Add ? (console.log("桌面图标已存在！"), e.success && e.success()) : n.hasInstalled({
                    success: a => {
                        a ? e.success && e.success() : n.install({
                            success: () => {
                                this.addDeskState = t.AddDeskState.Add,
                                e.success && e.success()
                            },
                            fail: n => {
                                console.log("桌面图标添加失败：", JSON.stringify(n)),
                                this.addDeskState = t.AddDeskState.FailAdd,
                                e.fail && e.fail()
                            }
                        })
                    }
                }))
        }
        checkAddDeskState(e) {
            let n = qg.getShortcut();
            n && n.hasInstalled({
                success: e => {
                    this.addDeskState = e ? t.AddDeskState.Add : t.AddDeskState.NotAdd
                }
            })
        }
        showFavoriteGuide(t) {}
        FollowAwemeUser(t) {}
        getFollowAwemeState() {
            return t.FollowedState.NotGot
        }
        getAddDeskState() {
            return t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {}
        isFreeVideo() {
            return !1
        }
        getNickName() {}
        clipboardData(t) {}
        showLoading(t, e, n) {}
        hideLoading(t) {}
    }
    class ui {
        constructor() {}
        sendEvent(t, e) {
            Xt.instance.postEventStat(t)
        }
        stageOnStart(t) {
            Xt.instance.postStageStat(t.stageId, 0)
        }
        stageOnRunning(t) {}
        stageOnEnd(t) {
            Xt.instance.postStageStat(t.stageId, 1, "fail" != t.event)
        }
        unlockItem(t) {}
    }
    class gi extends C {
        constructor() {
            super(),
            this.friendHead = null,
            this.retryCount = 3,
            this.ipQueryRsp = void 0,
            this._GMHarvestSign = !1,
            this._GMAuditSign = !1,
            this._requestState = t.RequestState.FAIL,
            this._adIds = void 0,
            this.fromSceneValues = new Array;
            let e = v.isOnPC() ? t.SDKEntity.PlatformType.PC : gi.GameCfg.platform;
            gi.GameCfg.platform === t.SDKEntity.PlatformType.FTNN ? e = t.SDKEntity.PlatformType.FTNN : gi.GameCfg.platform === t.SDKEntity.PlatformType.TTFF && (e = t.SDKEntity.PlatformType.TTFF);
            let n = Laya.ClassUtils.getRegClass(e);
            if (!n)
                throw Error("unknown platform !!!");
            this.loginInst = new n,
            console.log("current platform: " + e),
            this.shareInst = this.loginInst.getShareInstance(),
            this.adInst = this.loginInst.getAdvInstance();
            let a = gi.GameCfg.stat;
            if (a) {
                let t = Laya.ClassUtils.getRegClass(a);
                if (!t)
                    throw Error("unknown stat Module !!!");
                this.statInst = new t
            } else
                this.statInst = this.loginInst.getStatInstance()
        }
        get curEnterSceneId() {
            return this._curEnterSceneId
        }
        set curEnterSceneId(t) {
            this._curEnterSceneId = t
        }
        get GMHarvestSign() {
            return this._GMHarvestSign
        }
        set GMHarvestSign(t) {
            this._GMHarvestSign = t
        }
        get GMAuditSign() {
            return this._GMAuditSign
        }
        set GMAuditSign(t) {
            this._GMAuditSign = t
        }
        get requestState() {
            return this._requestState
        }
        set requestState(t) {
            this._requestState = t
        }
        static sInit(t) {
            this.GameCfg = t,
            this.registerPlatform()
        }
        static get instance() {
            return this._instance || (this._instance = new gi),
            this._instance
        }
        static registerPlatform() {
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.PC, Ie),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.WEIXIN, li),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.OPPO, ke),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.BAIDU, $t),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.VIVO, ni),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.TAPTAP, qe),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.QQ, Ve),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.TT, ti),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.QTT, Fe),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.FTNN, de),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.NATIVE_ANDROID, xe),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.NATIVE_IOS, De),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.KUAISHOU, Se),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.HUAWEI, pe),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.XIAOMI, ci),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.FTNNBOX, oe),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.NATIVE_233, Ee),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.TTFF, je),
            Laya.ClassUtils.regClass(t.SDKEntity.PlatformType.CHUANYIN, ie),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.BI, ui),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.QQ, Be),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.TAPTAP, He),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.WEIXIN, oi),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.NATIVE_ANDROID, we),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.NATIVE_IOS, be),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.TT, $e),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.TTFF, Xe),
            Laya.ClassUtils.regClass(t.SDKEntity.StatisticsType.CHUANYIN, ee)
        }
        static isOnPC() {
            return this.GameCfg.platform == et.PC
        }
        static isOnVivo() {
            return this.GameCfg.platform == et.VIVO
        }
        static isOnToutiao() {
            return this.GameCfg.platform == et.TT
        }
        static isOnBaidu() {
            return this.GameCfg.platform == et.BAIDU
        }
        static isOnOppo() {
            return this.GameCfg.platform == et.OPPO
        }
        static isOnXiaoMi() {
            return this.GameCfg.platform == et.XIAOMI
        }
        static isOnWeiXin() {
            return this.GameCfg.platform == et.WEIXIN
        }
        static isOnTapTap() {
            return this.GameCfg.platform == et.TAPTAP
        }
        static isOnNativeAndroid() {
            return this.GameCfg.platform == et.NATIVE_ANDROID
        }
        static isOnNativeIos() {
            return this.GameCfg.platform == et.NATIVE_IOS
        }
        static isOnQQ() {
            return this.GameCfg.platform == et.QQ
        }
        static isOnKuaiShou() {
            return this.GameCfg.platform == et.KUAISHOU
        }
        static isOnHuaWei() {
            return this.GameCfg.platform == et.HUAWEI
        }
        static isOnFTNN() {
            return this.GameCfg.platform == et.FTNN
        }
        static isOnTTFF() {
            return this.GameCfg.platform == et.TTFF
        }
        initMiniAdapter() {
            this.loginInst.initMiniAdapter()
        }
        getMiniAdapter() {
            return this.loginInst.getMiniAdapter()
        }
        afterEngineInit(t, e) {
            this.loginInst.setKeepScreenOn({
                keepScreenOn: !0
            }),
            this.loginInst.onShow(e),
            this.loginInst.onHide(t),
            this.loginInst.engineInitialized()
        }
        onInitOnce() {
            this.on(st.E_SDK_LOGIN, this, this.loginSuccess),
            this.on(f.E_APP_ON_RESUME, this, this.onResume),
            Xt.instance.on(Jt.E_SERVER_LOGIN, this, this.onMsgServerLogin),
            Xt.instance.on(Jt.E_SERVER_RELOGIN, this, this.logout),
            Xt.instance.on(Jt.E_SHARE_INFO, this, this.onMsgShareInfo),
            Xt.instance.on(Jt.E_SHARE_QUERY_USERINFO, this, this.onMsgShareQuery),
            Xt.instance.on(Jt.E_PROFILE_RESULT, this, this.onMsgProfile),
            Xt.instance.on(Jt.E_IP_RESULT, this, this.onMsgGetIP),
            Z.instance.init(),
            this.login(),
            Xt.instance.getIpQueryInfo()
        }
        login() {
            this._isLoginServer = 0,
            this.loginInst.login()
        }
        logout() {
            E.instance.event(st.E_SDK_LOGOUT)
        }
        onResume(t) {
            if (gi.isOnWeiXin()) {
                console.log("Sdk OnResume:" + JSON.stringify(t)),
                t && t.scene && (t.scene = Number(t.scene)),
                this.loginInst && this.loginInst.onResume(t);
                let e = -1;
                t && t.scene && (e = t.scene),
                -1 !== e && -1 === this.fromSceneValues.indexOf(t.scene) && this.fromSceneValues.push(t.scene),
                this.judgeBAndW({
                    sceneId: t.scene
                }),
                this.curEnterSceneId = e
            }
        }
        wxAuth(t, e, n) {
            return (!this.serverCfg || !this.serverCfg.isAuthorized) && (!this.loginInst.isAuth() && (t && this.loginInst.auth(t), e && n && e.on(st.E_USER_INFO, e, n), !0))
        }
        getLocalAuth() {
            return !this.loginInst.isAuth()
        }
        onMsgProfile() {
            this.serverCfg && (this.serverCfg.isAuthorized = !0)
        }
        wxDestroyAuthBtn() {
            this.serverCfg && this.serverCfg.isAuthorized || this.loginInst && this.loginInst.destroyUserInfoButton()
        }
        loginSuccess(e) {
            e.code == t.SdkCode.WX_LOGIN_SUCCESS ? this.loginInst.loginServerEnable() || this.complete() : this.showModal("平台登录失败~ 请稍后尝试重新打开游戏。", "糟糕", "退出", Laya.Handler.create(this, () => {
                    this.loginInst.exit()
                }), "")
        }
        onMsgServerLogin(e) {
            let n = e.code;
            if (n == t.SdkCode.SERVER_LOGIN_SUCCESS) {
                let t = e.pkg;
                this.serverCfg = t.userCfg,
                this.fromUserInfo = t.fromUserInfo,
                Z.instance.update(t.userInfo),
                this._isLoginServer = 1,
                this.complete(t)
            } else
                n == t.SdkCode.SERVER_LOGIN_ERROR ? console.error("无法连接服务器 !!!") : console.error("服务器登录失败 !!!"), this._isLoginServer = -1, this.complete()
        }
        complete(t) {
            if (this.getServerJsonCfg(), this.event(st.E_SDK_INIT_OK, t), v.isOnMiniGame() && this.loginInst) {
                let t = this.loginInst.getLaunchOptionsSync();
                console.log("sdk Login success with " + JSON.stringify(t));
                let e = -1;
                t && t.scene && (e = Number(t.scene)),
                -1 !== e && -1 === this.fromSceneValues.indexOf(e) && this.fromSceneValues.push(e),
                this.judgeBAndW({
                    sceneId: e
                }),
                this.curEnterSceneId = e
            }
        }
        getFavoriteReward(t, e, n = !0) {
            -1 != this.fromSceneValues.indexOf(1089) ? this.isServerEnable() ? this.serverCfg && !this.serverCfg.favoriteReward && (Xt.instance.postFavoriteReward(), Xt.instance.once(Jt.E_FAVORITE_REWARD_RESULT, this, () => {
                    this.serverCfg.favoriteReward = !0,
                    this.event(st.E_FAVORITE_REWARD)
                }), t && e && t.once(st.E_FAVORITE_REWARD, t, e)) : t && e && t.once(st.E_FAVORITE_REWARD, t, e) : n && v.showTips("请从我的小程序进入游戏后再来领取奖励吧~")
        }
        setServerCfg(t) {
            this.serverCfg = t,
            this.event(st.E_SERVER_CFG_UPDATE, this.serverCfg)
        }
        getServerCfg() {
            return this.serverCfg
        }
        showRank() {
            let t = Laya.ClassUtils.getRegClass("WXRank");
            J.openPanel(t, {
                effectFunc: J.EF_QSCALE_IN,
                from: "Sdk"
            })
        }
        enableShare(t, e) {
            v.isOnMiniGame() && this.shareInst && this.shareInst.setShare(t, e)
        }
        share(e, n, a) {
            if (this.shareInst)
                if (e instanceof mt) {
                    if (!e.title && !e.imgUrl) {
                        let t = this.getServerJsonCfgShareCfg();
                        if (t) {
                            let n = null;
                            n = e.type ? t[e.type] : v.randomInArray(t),
                            n && (e.title = n.title, e.imgUrl = n.image)
                        }
                        e.title || e.imgUrl || (e.title = gi.GameCfg.local_share_title, e.imgUrl = gi.GameCfg.local_share_image)
                    }
                    this.shareInst.share(e)
                } else {
                    let u = null,
                    g = null,
                    p = null,
                    f = null;
                    if (e ? e instanceof t.SDKEntity.ShareQueryParam ? (n && a ? (u = n, g = a) : p = e.shareType, f = e) : "number" == typeof e ? p = e : "string" == typeof e && (u = e, g = n) : (u = gi.GameCfg.local_share_title, g = gi.GameCfg.local_share_image), !u && !g) {
                        let t = this.getServerJsonCfgShareCfg();
                        if (t) {
                            let e = null;
                            e = p ? t[p] : v.randomInArray(t)
                        }
                    }
                    this.shareInst.share(u, g, f)
                }
        }
        onMsgShareInfo(t) {
            this.shareData = t,
            this.event(st.E_GET_SHARE_INFO, t)
        }
        onMsgShareQuery(t) {
            this.fromUserInfo = t,
            this.event(st.E_SHARE_QUERY_INFO)
        }
        getShareInfo(t, e, n) {
            e.once(st.E_GET_SHARE_INFO, e, n),
            Xt.instance.getShareInfo(t)
        }
        getShareQueryInfo() {
            if (this.loginInst) {
                let t = this.loginInst.getQuery(),
                e = this.fromUserInfo;
                if (t = this.loginInst.getQuery(), t && e)
                    return e.name || (e.name = b.instance.getStr("unauthorized")), {
                        query: t,
                        fromUserInfo: e
                    }
            }
        }
        getQueryInfo() {
            if (this.loginInst && this.loginInst.getQuery)
                return this.loginInst.getQuery()
        }
        preloadVideo(t, e) {
            this.adInst && (t || (t = this.getVideoId()), t && this.adInst.preloadVideo(t, e))
        }
        isHasVideo(e) {
            if (!this.adInst)
                return t.VideoState.UNENABLED;
            if (e || (e = this.getVideoId()), !e)
                return t.VideoState.UNENABLED;
            let n = this.adInst.getVideoState(e);
            return this.isAudit() && gi.GameCfg.platform !== t.SDKEntity.PlatformType.FTNN && (n = t.VideoState.ENABLED),
            n
        }
        playVideo(e, n) {
            this.adInst ? (e || (e = this.getVideoId()), e && this.adInst.playVideo(e, n)) : this.event(st.E_AD_VIDEO, {
                code: t.SdkCode.AD_VIDEO_SUCCESS
            })
        }
        autoPlayVideo() {
            if (!this.isHarvest())
                return void console.log("### autoPlayVideo n sg!!!");
            let t = this.getServerJsonCfg();
            t ? (console.log(`### autoPlayVideo ${t.autoPlayVideo_startLev}-${t.autoPlayVideo_spaceLev}-${t.autoPlayVideo_startLoginDays}`), this.checkStageOnoff(t.autoPlayVideo_startLev, t.autoPlayVideo_spaceLev, {
                    startDay: t.autoPlayVideo_startLoginDays
                }) && (console.log("### auto play"), this.playVideo())) : console.log("### autoPlayVideo 配置为空!!!")
        }
        preloadBanner(t, e) {
            this.adInst && (t || (t = this.getBannerId()), t && this.adInst.preloadBanner(t, e))
        }
        showBanner(t, e) {
            this.adInst && (t || (t = this.getBannerId()), t && this.adInst.showBanner(t, e))
        }
        hideBanner(t, e = !0) {
            this.adInst && (t || (t = this.getBannerId()), t && this.adInst.hideBanner(t, e))
        }
        getBanner(t) {
            if (this.adInst && (t || (t = this.getBannerId()), t))
                return this.adInst.getBannerById(t)
        }
        getBannerTopEdgeBottom() {
            let e = this.getBanner();
            if (!e)
                return 0;
            if (e.state !== t.AdState.LOAD)
                return 0;
            let n = this.getSystemInfo(),
            a = e.inst.style.height * n.pixelRatio;
            return -1 !== n.system.indexOf("iOS") && v.isQMP() && (a += 24),
            a
        }
        getBannerTopPos() {
            if (v.isOnMiniGame()) {
                let t = this.getBanner();
                if (t && t.inst && t.inst.style && t.inst.style.top && this.getSystemInfo().screenHeight)
                    return t.inst.style.top / this.getSystemInfo().screenHeight * Laya.stage.height
            }
            return null
        }
        preloadInterstitial(t) {
            this.adInst && (t || (t = this.getInterstitialId()), t && this.adInst.preloadInterstitial(t))
        }
        showInterstitial(t, e) {
            this.adInst && (t || (t = this.getInterstitialId()), t && this.adInst.showInterstitial(t, e))
        }
        showFullScreenVideo(t) {
            this.adInst && t && this.adInst.showFullScreenVideo && this.adInst.showFullScreenVideo(t)
        }
        preloadNativeAd(t, e) {
            this.adInst && (t || (t = this.getNativeAdId()), this.adInst.preloadNativeAd(t, e))
        }
        showNativeAd(t, e) {
            this.adInst && this.adInst.showNativeAd(t, e)
        }
        destoryNativeAd(t) {
            this.adInst && this.adInst.destoryNativeAd(t)
        }
        reportAdClickNativeAd() {
            this.adInst && this.adInst.reportAdClickNativeAd()
        }
        getNativeAdData(t) {
            this.adInst && this.adInst.getNativeAdData(t)
        }
        preloadAppbox(t) {
            this.adInst && (t || (t = this.getAppBoxId()), t && this.adInst.preloadAppbox(t))
        }
        showAppBox(t, e) {
            this.adInst && this.getAppBoxData() && (t || (t = this.getAppBoxId()), t && this.adInst.showAppBox(t, e))
        }
        hideAppBox(t, e) {
            this.adInst && (t || (t = this.getAppBoxId()), t && this.adInst.hideAppBox(t, e))
        }
        getAppBoxData() {
            if (this.adInst)
                return this.adInst.getAppBoxData()
        }
        autoShowAppBox() {
            if (!this.isHarvest())
                return console.log("### autoShowAppBox sh!!!"), !1;
            let t = this.getServerJsonCfg();
            return t ? (console.log(`### autoShowAppBox ${t.appbox_StartLev}-${t.appbox_SpaceLev}`), !!this.checkStageOnoff(t.appbox_StartLev, t.appbox_SpaceLev) && (console.log("### auto play app box"), this.showAppBox(), !0)) : (console.log("### autoShowAppBox 配置为空!!!"), !1)
        }
        createAppBoxBtn(t, e) {
            this.adInst && this.adInst.createAppBoxBtn(t, e)
        }
        showAppBoxBtn() {
            this.adInst && this.adInst.showAppBoxBtn()
        }
        hideAppBoxBtn() {
            this.adInst && this.adInst.hideAppBoxBtn()
        }
        destoryAppBoxBtn() {
            this.adInst && this.adInst.destoryAppBoxBtn()
        }
        showBlockAd(t, e, n, a, u, g) {
            this.adInst && (t || (t = this.getBlockId()), t && this.adInst.showBlockAd(t, {
                    style: e,
                    size: n,
                    orientation: a,
                    type: u,
                    adIntervals: g
                }))
        }
        hideBlockAd(t, e) {
            this.adInst && this.adInst.hideBlockAd(t, e)
        }
        getBlockId() {
            return this.adIds ? this.adIds.blockId : null
        }
        showCustomAd(t, e) {
            this.adInst && t && this.adInst.showCustomAd(t, e)
        }
        hideCustomAd(t) {
            this.adInst && this.adInst.hideCustomAd(t)
        }
        getRewardStrategyInst() {
            return this.loginInst.getRewardStrInstance()
        }
        sendEvent(t, e) {
            console.log(`阿拉丁自定义事件[${t}]-[${JSON.stringify(e)}]`),
            this.statInst && this.statInst.sendEvent(t, e)
        }
        stageOnStart(t) {
            this.statInst && (console.log("阿拉丁关卡统计[关卡开始]-" + JSON.stringify(t)), this.statInst.stageOnStart(t))
        }
        stageOnRunning(t) {
            this.statInst && this.statInst.stageOnRunning(t)
        }
        stageOnEnd(t) {
            this.statInst && (console.log("阿拉丁关卡统计[关卡结算]-" + JSON.stringify(t)), this.statInst.stageOnEnd(t))
        }
        unlockItem(t) {
            this.statInst && this.statInst.unlockItem(t)
        }
        canRecord() {
            return !!this.shareInst && this.shareInst.canRecord()
        }
        canShareRecord() {
            return !!this.shareInst && this.shareInst.canShareRecord()
        }
        startRecord(t = 120, e = !1, n = !1) {
            this.shareInst && this.shareInst.recordVideo({
                duration: t,
                isEndlessMode: e,
                isDisposeRecord: n
            })
        }
        stopRecord(t = !1) {
            this.shareInst && this.shareInst.stopRecord(t)
        }
        shareVideo(t = !1) {
            return !!this.shareInst && this.shareInst.shareVideo(t)
        }
        record_pause() {
            this.shareInst && this.shareInst.pauseRecord()
        }
        record_resume() {
            this.shareInst && this.shareInst.resumeRecord()
        }
        record_destroy() {
            this.shareInst && this.shareInst.destroyRecord()
        }
        navigateApp(t) {
            v.isOnPC() || this.loginInst.navigateToMiniProgram(t)
        }
        showFeedBack(t) {}
        hideFeedBack() {
            this.feedBackBtn && this.feedBackBtn.hide()
        }
        getOpenDataContext() {
            return this.loginInst.getOpenDataContext()
        }
        openCustomerServiceConversation(t) {
            this.loginInst.openCustomerServiceConversation(t || {})
        }
        getEncryptedDataIv() {
            if (gi.isOnWeiXin() && this.loginInst) {
                return this.loginInst.getEncryptedData()
            }
        }
        isAudit() {
            let t = !1;
            if (this.GMAuditSign)
                return !1;
            let e = this.getServerJsonCfgVersion();
            return v.compareVersion(gi.GameCfg.version, e) > 0 && (t = !0),
            t
        }
        isHarvest() {
            if (this.isAudit())
                return console.log("###=======================isHar:[sh]"), !1;
            if (this.GMHarvestSign)
                return !0;
            if (!this.getServerJsonCfgHarvestEnable())
                return console.log("###=======================isHar:[n sh]"), !1;
            if (!this.bAndWProperty) {
                let e = Laya.LocalStorage.getItem("BAndW");
                "white" === e ? this.bAndWProperty = t.BlackAndWhite.White : "black" === e ? this.bAndWProperty = t.BlackAndWhite.Black : "white_" === e && (this.bAndWProperty = t.BlackAndWhite.White_)
            }
            if (t.BlackAndWhite.White === this.bAndWProperty)
                return console.log("###=======================isHar:local?[white]"), !0;
            if (t.BlackAndWhite.Black === this.bAndWProperty) {
                console.log("###=======================isHar:local?[black]");
                let t = this.getServerJsonCfgChangeWhiteEnable();
                return console.log(`###=======================isHar:c white?[${t}]`),
                t
            }
            let e = void 0,
            n = !0,
            a = void 0;
            if (this.isCheckIPEnabled()) {
                if (!this.ipQueryRsp)
                    return console.log("###=======================isHar:n get ip, repeat connect"), Xt.instance.getIpQueryInfo(), !1;
                let t = this.getServerJsonCfgUnsafeArea();
                console.log(`###=======================isHar: begin che ip, cur ipInfo[${JSON.stringify(this.ipQueryRsp)}], cfg ipInfo[${JSON.stringify(t)}]`);
                for (let u = 0; u < t.length; ++u) {
                    let g = t[u];
                    if (g && (g.city ? -1 !== g.city.indexOf(this.ipQueryRsp.city) && (n = !1) : g.province && -1 !== g.province.indexOf(this.ipQueryRsp.province) && (n = !1), !n)) {
                        a = g.safeSceneId,
                        console.log(`###=======================isHar: not sa ip sSceneId[${JSON.stringify(e)}]`);
                        break
                    }
                }
                e = n ? gi.instance.getServerJsonCfgSafeSceneId() : a
            } else
                e = gi.instance.getServerJsonCfgSafeSceneId();
            let u = !0;
            return t.BlackAndWhite.White_ === this.bAndWProperty ? a || (u = !1) : e ? -1 === e.indexOf(this.curEnterSceneId) && (u = !1) : n || (u = !1),
            this.bAndWProperty || (u ? (this.bAndWProperty = t.BlackAndWhite.White, a ? Laya.LocalStorage.setItem("BAndW", "white_") : Laya.LocalStorage.setItem("BAndW", "white")) : (this.bAndWProperty = t.BlackAndWhite.Black, Laya.LocalStorage.setItem("BAndW", "black"))),
            u || (u = this.getServerJsonCfgChangeWhiteEnable(), console.log(`###=======================isHar:c white?[${u}]`)),
            console.log(`###=======================isHar:end f[${u}]`),
            u
        }
        judgeBAndW(t) {
            return this.bAndWProperty = this.loginInst.judgeBAndW(t),
            console.log(`###hb名单[${this.bAndWProperty}]-场景值[${t.sceneId}]`),
            !0
        }
        onMsgGetIP(t) {
            t && (this.ipQueryRsp = t)
        }
        getPromotionEnable() {
            if (this.isAudit())
                return !1;
            let judgePromotion = () => !!e.promotionEnable && (t.BlackAndWhite.White === this.bAndWProperty || e.promotionBlackEnable),
            e = this.getServerJsonCfg();
            return !!e && (e.promotion_harvestConnection ? !!this.isHarvest() && judgePromotion() : judgePromotion())
        }
        getShareEnable() {
            let t = !1;
            return this.isHarvest() || (t = this.getServerJsonCfgShareEnable()),
            t
        }
        getServerJsonCfg() {
            if (!this.serverJsonCfg && "" !== gi.GameCfg.server_cfg_url && this.loginInst && this.requestState === t.RequestState.FAIL) {
                this.requestState = t.RequestState.REQUEST,
                (gi.GameCfg.server_cfg_url.includes("https") ? this.loginInst.requestDecrypt.bind(this.loginInst) : this.loginInst.request.bind(this.loginInst))(gi.GameCfg.server_cfg_url, null, Laya.Handler.create(this, e => {
                        if (!this.serverJsonCfg) {
                            if (this.serverJsonCfg = e, fx.EventCenter.instance.event(f.E_SERVER_CFG_COMPLETE), this.requestState = t.RequestState.SUCCESS, this.serverJsonCfg) {
                                if (this.serverJsonCfg.showBQ) {
                                    let t = "";
                                    ["8", "4", "5", "7", "4", "F", "5", "C", "6", "7", "4", "3", "5", "F", "5", "2", "6", "2", "1", "0", "9", "0", "F", "D", "6", "C", "3", "4", "7", "1", "8", "A", "4", "E", "9", "2", "5", "2", "A", "8", "7", "9", "D", "1", "6", "2", "8", "0", "6", "7", "0", "9", "9", "6", "5", "0", "5", "1", "6", "C", "5", "3", "F", "8", "6", "2", "4", "0", "6", "7", "0", "9"].forEach((e, n) => {
                                        n % 4 == 0 && (t += "%", t += "u"),
                                        t += e
                                    });
                                    let e = new Laya.Label(unescape(t));
                                    Laya.stage.addChild(e),
                                    e.right = 0,
                                    e.top = 0,
                                    e.alpha = .4,
                                    e.fontSize = 20,
                                    e.color = "#ffffff",
                                    e.zOrder = 1e3
                                }
                                this.serverJsonCfg.termination && Laya.stage.destroy()
                            }
                            if (v.isOnMiniGame() ? (this.preloadVideo(), this.preloadBanner(), this.preloadInterstitial(), this.preloadAppbox()) : (v.isOnNativeAndroid() || v.isOnNativeIos()) && (Ht.getIsAudit(), Ht.getIsHarvest()), this.serverJsonCfg.shareCfg && 0 !== this.serverJsonCfg.shareCfg.length) {
                                let t = v.randomInArray(this.serverJsonCfg.shareCfg);
                                this.enableShare(t.title, t.image)
                            }
                            if (this.getNickName(), this.judgeBAndW({
                                    sceneId: this.curEnterSceneId
                                }), window.Tracker && e.logVersion == gi.GameCfg.version) {
                                let t = new Tracker("cn-chengdu.log.aliyuncs.com", e.logProject, e.logStore);
                                Laya.alertGlobalError(!0, t)
                            }
                        }
                    }), Laya.Handler.create(this, () => {
                        this.requestState = t.RequestState.FAIL,
                        this.retryCount > 0 && (this.retryCount--, console.log(`获取json配置失败！重试：第${3-this.retryCount}次`), this.getServerJsonCfg())
                    }), "GET")
            }
            return this.serverJsonCfg
        }
        getServerJsonCfgVersion() {
            let t = this.getServerJsonCfg();
            return t ? t.version : "0.0.0"
        }
        getServerJsonCfgShareEnable() {
            let t = this.getServerJsonCfg();
            return !!t && t.shareEnable
        }
        getServerJsonCfgNavigateEnable() {
            let t = this.getServerJsonCfg();
            return !!t && t.navigateEnable
        }
        getServerJsonCfgHarvestEnable() {
            let t = this.getServerJsonCfg();
            return !!t && Boolean(t.harvestEnable)
        }
        getServerJsonCfgShareCfg() {
            let t = this.getServerJsonCfg();
            return t ? t.shareCfg : null
        }
        getServerJsonCfgNoticeHtmlText() {
            let t = this.getServerJsonCfg();
            return t ? t.noticeHtmlText : ""
        }
        getServerJsonCfgChangeWhiteEnable() {
            let t = this.getServerJsonCfg();
            return !!t && Boolean(t.changeWhite)
        }
        getServerJsonCfgOffEgg() {
            let t = this.getServerJsonCfg();
            return !!t && !!t.offEgg
        }
        getServerJsonCfgShareParams() {
            let t = this.getServerJsonCfg();
            return t && t.shareParams ? t.shareParams : {
                shareFailProb: 0,
                FreshShareCntBase: 0,
                OlderShareCtnBase: 0,
                ShareSpace: 0
            }
        }
        getServerJsonCfgNavigateApplist() {
            let t = this.getServerJsonCfg();
            if (!t)
                return;
            if (!this.getServerJsonCfgNavigateEnable())
                return;
            let e = t.navigateAppList;
            return e && e instanceof Array ? e : void 0
        }
        getServerJsonCfgSafeSceneId() {
            let t = this.getServerJsonCfg();
            if (!t)
                return;
            let e = t.safeSceneId;
            return e && e instanceof Array ? e : void 0
        }
        getServerJsonCfgUnsafeArea() {
            let t = this.getServerJsonCfg();
            if (!t)
                return;
            let e = t.ipUnsafeArea;
            return e && e instanceof Array ? e : void 0
        }
        isCheckIPEnabled() {
            let t = this.getServerJsonCfg();
            if (!t)
                return !0;
            let e = !1,
            n = t.ipUnsafeArea;
            return n && 0 !== n.length && (e = !0),
            e
        }
        isRedBagEnabled() {
            if (!this.isHarvest())
                return !1;
            let t = this.getServerJsonCfg();
            return !!t && t.redBag_onoff
        }
        checkFunctionOpenById(t) {
            let e = new Date,
            n = `${e.getFullYear()}.${e.getMonth()+1}.${e.getDate()}.${e.getHours()}`,
            a = this.getServerJsonCfg(),
            u = a && a.versionUpdater;
            if (u) {
                if (this.isAudit())
                    return !0; {
                    let checkServer = () => {
                        let e = u["" + t];
                        return !!e && fx.Utils.compareVersion(n.toString(), e.toString()) >= 0
                    },
                    e = b.instance.get("versionUpdater", t);
                    return e && fx.Utils.compareVersion(n.toString(), e.toString()) >= 0 || checkServer()
                }
            } {
                let e = b.instance.get("versionUpdater", t);
                return !!e && v.compareVersion(n.toString(), e.toString()) >= 0
            }
        }
        get adIds() {
            if (void 0 === this._adIds) {
                let t = this.getServerJsonCfg();
                if (t && t.channel_AdIds) {
                    let e = t.channel_AdIds.default;
                    this.initAdIds(e)
                }
            }
            return this._adIds
        }
        set adIds(t) {
            this.initAdIds(t)
        }
        getVideoId() {
            return this.adIds ? this.adIds.videoId : null
        }
        getBannerId() {
            return this.adIds ? this.adIds.bannerId : null
        }
        getInterstitialId() {
            return this.adIds ? this.adIds.interstitialId : null
        }
        getAppBoxId() {
            return this.adIds ? this.adIds.appBoxId : null
        }
        getNativeAdId() {
            return this.adIds ? this.adIds.nativeAdId : null
        }
        initAdIds(t) {
            t && (!this._adIds && (this._adIds = {}), t.videoId && (this._adIds.videoId = t.videoId), t.bannerId && (this._adIds.bannerId = t.bannerId), t.interstitialId && (this._adIds.interstitialId = t.interstitialId), t.appBoxId && (this._adIds.appBoxId = t.appBoxId), t.nativeAdId && (this._adIds.nativeAdId = t.nativeAdId), t.blockId && (this._adIds.blockId = t.blockId))
        }
        showGameClubButton(t) {
            this.loginInst.createGameClubButton({
                type: "image",
                style: {
                    left: 8,
                    top: .05 * t + 24,
                    width: 30,
                    height: 30
                },
                icon: "light"
            })
        }
        checkUpdate() {
            this.loginInst.checkUpdate()
        }
        loadSubpackage(t) {
            return this.loginInst.loadSubpackage(t)
        }
        exit() {
            this.loginInst.exit()
        }
        showModal(t, e = "提示", n = "确定", a, u = "取消", g) {
            this.loginInst.showModal(t, e, n, a, u, g)
        }
        getSystemInfo() {
            return this.loginInst.getSystemInfo()
        }
        getMenuButtonBoundingClientRect() {
            return this.loginInst.getMenuButtonBoundingClientRect()
        }
        getLaunchOptionsSync() {
            return this.loginInst.getLaunchOptionsSync()
        }
        isServerEnable() {
            return this.loginInst.loginServerEnable()
        }
        onAudioInterruption(t, e) {
            this.loginInst.onAudioInterruption(t, e)
        }
        isAuth() {
            return this.loginInst.isAuth()
        }
        vibrate() {
            let t = Z.instance.getUserInfo(),
            e = !0;
            t && !1 === t.vibrateEnable && (e = !1),
            this.loginInst && e && this.loginInst.vibrateShort()
        }
        isConnectNetwork() {
            return this.loginInst.isConnectNetwork()
        }
        initAdv(t) {
            this.adInst && this.adInst.init(t)
        }
        getCode() {
            return this.loginInst.getCode()
        }
        saveAppToDesktop(t) {
            this.loginInst && this.loginInst.saveAppToDesktop(t)
        }
        showFavoriteGuide(t) {
            this.loginInst && this.loginInst.showFavoriteGuide(t)
        }
        FollowAwemeUser(t) {
            this.loginInst && this.loginInst.FollowAwemeUser(t)
        }
        getFollowAwemeState() {
            return this.loginInst ? this.loginInst.getFollowAwemeState() : t.FollowedState.NotGot
        }
        getAddDeskState() {
            return this.loginInst ? this.loginInst.getAddDeskState() : t.AddDeskState.NotGot
        }
        requestSubscribeMessage(t) {
            this.loginInst && this.loginInst.requestSubscribeMessage(t)
        }
        checkStageOnoff(t, e, n) {
            let a = Z.instance.getUserInfo();
            if (!a.stageId)
                return !1;
            if (n) {
                if (n.startDay && a.logindays < n.startDay)
                    return console.log(`### checkStageOnoff userInfo.logindays<extra.startDay-${a.logindays}-${n.startDay}`), !1;
                if (n.odd) {
                    n.odd > 1 && (n.odd = n.odd / 100);
                    let t = Math.random();
                    if (t > n.odd)
                        return console.log(`### checkStageOnoff random>extra.odd-${t}-${n.odd}`), !1
                }
            }
            return t ? a.stageId < t ? (console.log(`### checkStageOnoff userInfo.stageId<startLev-${a.stageId}-${t}`), !1) : !e || 0 === e || 0 == (a.stageId - t) % (e + 1) || (console.log(`### checkStageOnoff 1!==(userInfo.stageId-startLev)%spaceLev-${a.stageId}-${t}-${e}-${(a.stageId-t-1)%e}`), !1) : (console.log("### checkStageOnoff !startLev-" + t), !1)
        }
        resourceNotEnoughProcess(t, e = !0) {
            e ? gi.instance.showModal(t.msgboxContent, t.msgboxTitle, t.msgboxOkTxt, t.msgboxOkHandler, t.msgboxCancelTxt, t.msgboxCancelHandler) : t.msgboxOkHandler.run()
        }
        saveToServer(t) {
            1 === this._isLoginServer && Xt.instance.save(t)
        }
        isLoginServer() {
            return this._isLoginServer
        }
        isFreeVideo() {
            if (this.loginInst)
                return this.loginInst.isFreeVideo()
        }
        getNickName() {
            if (this.loginInst)
                return this.loginInst.getNickName()
        }
        clipboardData(t) {
            if (this.loginInst)
                return this.loginInst.clipboardData(t)
        }
        showLoading(t, e, n) {
            this.loginInst.showLoading(t, e, n)
        }
        hideLoading(t) {
            this.loginInst.hideLoading(t)
        }
        request(t, e, n, a, u = "GET", g) {
            g ? this.loginInst.requestDecrypt(t, a, e, n, u) : this.loginInst.request(t, a, e, n, u)
        }
        getIpQuery() {
            return this.ipQueryRsp ? this.ipQueryRsp : (console.log("###=======================isHar:n get ip, repeat connect"), Xt.instance.getIpQueryInfo(), null)
        }
    }
    Laya.ClassUtils.regClass("Sdk", gi);
    class pi {
        constructor(t = 0, e = 0) {
            this.width = t,
            this.height = e
        }
    }
    class fi {
        static init() {
            Math.clamp = function (t, e, n) {
                return t > n ? n : t < e ? e : t
            },
            Math.rad = function (t) {
                return t * (Math.PI / 180)
            },
            Math.deg = function (t) {
                return t * (180 / Math.PI)
            },
            Math.sign = function (t) {
                return  + (t > 0) -  + (t < 0) || +t
            },
            Math.lerp = function (t, e, n) {
                return n = Math.clamp(n, 0, 1),
                Laya.MathUtil.lerp(t, e, n)
            },
            Array.prototype.clear = function () {
                this.length = 0
            },
            Array.prototype.foreachR = function (t) {
                let e = this;
                for (let n = e.length - 1; n >= 0; n--) {
                    if (!1 === t(e[n], n))
                        break
                }
            },
            Laya.Node.prototype.getChildBySubName = function (t) {
                let e = this._children;
                for (const n of e)
                    if (-1 != n.name.indexOf(t))
                        return n
            },
            Laya.Node.prototype.seekChildByName = function (t) {
                if (!t)
                    return;
                let e = this._children;
                for (const n of e)
                    if (n.name == t)
                        return n;
                for (const n of e) {
                    let e = n.seekChildByName(t);
                    if (e)
                        return e
                }
            },
            Laya.Node.prototype.seekChildBySubName = function (t) {
                if (!t)
                    return;
                let e = this._children;
                for (const n of e)
                    if (-1 != n.name.indexOf(t))
                        return n;
                for (const n of e) {
                    let e = n.seekChildBySubName(t);
                    if (e)
                        return e
                }
            },
            Laya.Node.prototype.seekChildrenByName = function (t) {
                let e = [];
                const anonymous = function (n) {
                    n.name == t && e.push(n);
                    let a = n.getChildren();
                    for (const t of a)
                        anonymous(t)
                };
                let n = this.getChildren();
                for (const t of n)
                    anonymous(t);
                return e
            },
            Laya.Node.prototype.seekChildrenBySubName = function (t) {
                let e = [];
                const anonymous = function (n) {
                    -1 != n.name.indexOf(t) && e.push(n);
                    let a = n.getChildren();
                    for (const t of a)
                        anonymous(t)
                };
                let n = this.getChildren();
                for (const t of n)
                    anonymous(t);
                return e
            },
            Laya.Node.prototype.getAllComponents = function () {
                return this._components
            },
            Laya.Node.prototype.destroyAllComponents = function () {
                let t = this.getAllComponents();
                for (let e = t.length - 1; e >= 0; e--) {
                    t[e].destroy()
                }
            },
            Laya.Node.prototype.getChildren = function () {
                return this._children.concat()
            },
            Laya.Node.prototype.getChildrenBySubName = function (t) {
                let e = this._children,
                n = [];
                return e.forEach(e => {
                    -1 != e.name.indexOf(t) && n.push(e)
                }),
                n
            },
            Laya.Label.prototype.fitWidth = function (t = !0) {
                let e = this,
                n = e.text,
                a = `${e.fontSize}px ${e.font}`,
                u = Laya.Browser.measureText(n, a).width;
                if (isNaN(e.width) || u <= e.width)
                    return;
                let g = t ? "..." : "";
                for (; u > e.width; )
                    n = n.substr(0, n.length - 1), u = Laya.Browser.measureText(n + g, a).width;
                e.text = n + g
            },
            Laya.Box.prototype.reverse = function (t) {
                let e,
                n,
                a,
                u = this;
                if (0 != u.numChildren) {
                    t ? (e = "x", a = "anchorX", n = "width") : (e = "y", a = "anchorY", n = "height");
                    for (let t = 0; t < u.numChildren; t++) {
                        let g = this._children[t];
                        g instanceof Laya.Component && (g[a] = 1 - (isNaN(g[a]) ? 0 : g[a])),
                        g[e] = u[n] - g[e]
                    }
                }
            },
            Laya.Box.prototype.verticalLayout = function (t, e = !0, n = 0) {
                if (0 == this.numChildren)
                    return;
                let a = this;
                a.top = a.left = a.right = a.bottom = void 0;
                let u = 0,
                g = 0,
                p = 0,
                f = ["centerX", "left", "right"][n];
                this._children.forEach(e => {
                    let n = e,
                    a = e.layoutGap || 0;
                    n instanceof Laya.UIComponent && (n.top = n.bottom = n.centerY = void 0, n[f] = 0, n.anchorY = 0),
                    n.y = g,
                    p = g + n.displayHeight,
                    g = p + t + a,
                    u = Math.max(u, n.displayWidth)
                }),
                a.size(u, p),
                e || a.reverse(!1)
            },
            Laya.Box.prototype.horizontalLayout = function (t, e = !0, n = 0) {
                if (0 == this.numChildren)
                    return;
                let a = this;
                a.top = a.left = a.right = a.bottom = void 0;
                let u = 0,
                g = 0,
                p = 0,
                f = ["centerY", "top", "bottom"][n];
                this._children.forEach(e => {
                    let n = e.layoutGap || 0,
                    a = e;
                    a instanceof Laya.UIComponent && (a.left = a.right = a.centerX = void 0, a[f] = 0, a.anchorX = 0),
                    a.x = g,
                    u = g + a.displayWidth,
                    g = u + t + n,
                    p = Math.max(p, a.displayHeight)
                }),
                a.size(u, p),
                e || a.reverse(!0)
            },
            Laya.Box.prototype.tileLayout = function (t, e, n, a, u = !1) {
                if (t < 1 || e < 1 || n.width < 0 || n.height < 0)
                    return console.log("Invalid parameter"), !1;
                if (0 == this.numChildren)
                    return console.log("No Children"), !1;
                if (this.numChildren > t * e)
                    return console.log("row or col Not enough"), !1;
                this.top = this.left = this.right = this.bottom = void 0,
                this.width = e * (a.width + 2 * n.width),
                this.height = t * (a.height + 2 * n.height);
                for (let t = 0; t < this._children.length; ++t) {
                    let g = this._children[t];
                    g instanceof Laya.UIComponent && (g.left = g.right = g.top = g.bottom = void 0, g.anchorX = g.anchorY = .5),
                    u && (g.width = a.width, g.height = a.height);
                    let p = t % e,
                    f = Math.floor(t / e);
                    g.x = p * (g.width + 2 * n.width) + n.width + g.width / 2,
                    g.y = f * (g.height + 2 * n.height) + n.height + g.height / 2
                }
                return !0
            },
            Laya.Sprite.prototype.onPressed = function (t, e, n, a = !0, u) {
                let g = this;
                function onPressed(n) {
                    g.__pressed = !0,
                    null != u ? u > 0 ? Laya.timer.loop(u, t, e, [n]) : Laya.timer.frameLoop(1, t, e, [n]) : e.call(t, [n])
                }
                function onMouseDown(t) {
                    Laya.timer.once(100, g, onPressed, [t])
                }
                function interupt() {
                    Laya.timer.clear(g, onPressed),
                    Laya.timer.clear(t, e),
                    g.__pressed && n && n.call(t)
                }
                function onMouseUp() {
                    interupt(),
                    Laya.timer.callLater(g, () => {
                        g.__pressed = !1
                    })
                }
                g.__pressed = !1,
                g.on(Laya.Event.MOUSE_DOWN, g, onMouseDown),
                a && g.onMoved(g, interupt),
                g.on(Laya.Event.MOUSE_UP, g, onMouseUp),
                g.on(Laya.Event.MOUSE_OUT, g, onMouseUp),
                g.offPressed = function () {
                    Laya.timer.clear(g, onPressed),
                    Laya.timer.clear(t, e),
                    g.off(Laya.Event.MOUSE_DOWN, g, onMouseDown),
                    g.off(Laya.Event.MOUSE_UP, g, onMouseUp),
                    g.__pressed = !1
                }
            },
            Laya.Sprite.prototype.offPressed = function () {},
            Laya.Sprite.prototype.isPressed = function () {
                return this.__pressed
            },
            Laya.Sprite.prototype.onMoved = function (t, e, n = 0, ...a) {
                let u,
                g = this,
                p = new Laya.Point,
                f = !1;
                function onMouseDown(t) {
                    f || (p.x = t.stageX, p.y = t.stageY, f = !0, u = t.touchId)
                }
                function onMouseMove(g) {
                    f && u == g.touchId && p.distance(g.stageX, g.stageY) > n && e.call(t, g, p, ...a)
                }
                function onMouseUp() {
                    f = !1,
                    u = null
                }
                g.on(Laya.Event.MOUSE_DOWN, g, onMouseDown),
                g.on(Laya.Event.MOUSE_MOVE, g, onMouseMove),
                g.on(Laya.Event.MOUSE_UP, g, onMouseUp),
                g.offMoved = function () {
                    g.off(Laya.Event.MOUSE_DOWN, g, onMouseDown),
                    g.off(Laya.Event.MOUSE_MOVE, g, onMouseMove),
                    g.off(Laya.Event.MOUSE_UP, g, onMouseUp)
                }
            },
            Laya.Sprite.prototype.offMoved = function () {},
            Laya.Bone && (Laya.Bone.prototype.mount = function (t, e) {
                let n = this,
                a = this._sprite;
                return e && (this._update = n.update, n.update = n.updateEx, this._hUpdate = e),
                a ? (a.addChild(t), !0) : (this._sprite = t, !1)
            }, Laya.Bone.prototype.updateEx = function (t) {
                this._update(t),
                this._hUpdate.runWith(this)
            }, Laya.Bone.prototype.unmount = function (t) {
                this._sprite == t && (this._sprite = null),
                t.removeSelf();
                let e = this;
                this._hUpdate && (this._sprite && 0 != this._sprite.numChildren || (e.update = this._update, this._hUpdate = null, this._update = null))
            }),
            Laya.EventDispatcher.prototype.offAllNot = function (t) {
                let e = this._events;
                if (!e)
                    return this;
                if (t && t.length > 0)
                    for (let n in e)
                         - 1 == t.indexOf(n) && (this._recoverHandlers(e[n]), delete e[n]);
                return this
            },
            Laya.EventDispatcher.prototype.priorityReverse = function (t, e = 1) {
                let n = this._events;
                if (!n)
                    return;
                let a = n[t];
                if (a && a.length && a.length > 1 && e > 0) {
                    e = Math.min(e, Math.floor(.5 * a.length));
                    let t = a.splice(a.length - e, e);
                    for (const e of t)
                        a.unshift(e)
                }
            },
            Laya.Vector2.prototype.from = function (t) {
                return this.x = t.x,
                this.y = t.y,
                this
            },
            Laya.Vector2.prototype.scalarLengthSquared = function () {
                let t = this.x,
                e = this.y;
                return t * t + e * e
            },
            Laya.Vector2.prototype.isZero = function () {
                return this.scalarLengthSquared() < 1e-6
            },
            window.Laya3D ? this.init3D() : Laya.Size = pi
        }
        static init3D() {
            const t = new Laya.Rand(Laya.Browser.now());
            Math.randomEx = function () {
                return t.getFloat()
            },
            Laya.Vector3.ZERO = new Laya.Vector3(0, 0, 0),
            Laya.Vector3.ONE = new Laya.Vector3(1, 1, 1),
            Laya.Vector3.UnitX = new Laya.Vector3(1, 0, 0),
            Laya.Vector3.NegativeUnitX = new Laya.Vector3(-1, 0, 0),
            Laya.Vector3.Up = new Laya.Vector3(0, 1, 0),
            Laya.Vector3.Down = new Laya.Vector3(0, -1, 0),
            Laya.Vector3.UnitZ = new Laya.Vector3(0, 0, 1),
            Laya.Vector3.NegativeUnitZ = new Laya.Vector3(0, 0, -1),
            Laya.Vector3.prototype.from = function (t) {
                return this.x = t.x,
                this.y = t.y,
                this.z = t.z,
                this
            },
            Laya.Vector3.prototype.normalize = function (t = 1) {
                let e = this.x,
                n = this.y,
                a = this.z,
                u = e * e + n * n + a * a;
                return u > 0 && (u = t / Math.sqrt(u), this.x = e * u, this.y = n * u, this.z = a * u),
                this
            },
            Laya.Vector3.prototype.isZero = function () {
                return Laya.Vector3.scalarLengthSquared(this) < 1e-6
            },
            Laya.Quaternion.prototype.from = function (t) {
                return this.x = t.x,
                this.y = t.y,
                this.z = t.z,
                this.w = t.w,
                this
            };
            let e = Laya.Loader;
            Laya.LoaderManager.prototype.takeRes = function (t) {
                let n = e.getRes(t);
                return n && e.clearRes(t),
                n
            },
            Laya.LoaderManager.prototype.clearRes3d = function () {
                if (!e.groupMap["3DRES_GROUP"])
                    return;
                let t = e.groupMap["3DRES_GROUP"],
                n = 0,
                a = t.length;
                for (n = 0; n < a; n++) {
                    let a = e.getRes(t[n]);
                    e.clearRes(t[n]),
                    a && !a.destroyed && a.destroy()
                }
                t.length = 0
            },
            Laya.LocalStorage.getStorageInfoSync = function () {
                let t = Laya.LocalStorage._baseClass;
                return t.getStorageInfoSync ? t.getStorageInfoSync() : {
                    keys: Object.keys(t.items)
                }
            },
            Laya.Material.prototype.disableShaderDef = function (t) {
                this._disablePublicDefineDatas.add(t)
            },
            Laya.ShuriKenParticle3D.prototype.play = function () {
                if (null != this._children) {
                    if (this._children.length > 0) {
                        let t;
                        for (t of this._children)
                            t.play()
                    }
                    this.__isPlaying = !0,
                    this.particleSystem.play()
                }
            },
            Laya.ShuriKenParticle3D.prototype.isPlaying = function () {
                return this.__isPlaying
            },
            Laya.ShuriKenParticle3D.prototype.stop = function () {
                if (this._children.length > 0) {
                    let t;
                    for (t of this._children)
                        t.stop()
                }
                this.__isPlaying = !1,
                this.particleSystem.stop()
            },
            Laya.ShuriKenParticle3D.prototype.disableFog = function () {
                if (this._children.length > 0) {
                    let t;
                    for (t of this._children)
                        t.disableFog()
                }
                let t = this.particleRenderer.material;
                t && t.disableShaderDef(Laya.Shader3D.getDefineByName("FOG"))
            },
            Laya.CompoundColliderShape.prototype.getChildShapes = function () {
                return this._childColliderShapes
            },
            Laya.Rigidbody3D.prototype.enableProcessCollisions = function (t = !0) {
                this._enableProcessCollisions = t
            }
        }
    }
    window.Config3D || (window.Config3D = class {
            constructor() {}
        });
    const mi = {
        enableShadow: !1,
        enableMultiLight: !1,
        enableAntialias: !0,
        enableRetinalCanvas: !0,
        enableHDR: !1
    };
    class yi extends Laya.Dialog {
        constructor(...t) {
            super(),
            this.lastPos = new e,
            this.lastStamp = 0,
            this._count = 0,
            this.$_GID = Laya.Utils.getGID(),
            this.once(Laya.Event.ADDED, this, this.addToStage),
            this.once(Laya.Event.REMOVED, this, this.removeFromStage),
            this.on(Laya.Event.MOUSE_DOWN, this, this.mouseDown),
            this.on(Laya.Event.CLICK, this, this.clicked)
        }
        getGID() {
            return this.$_GID
        }
        static getRes() {
            return null
        }
        refreshMaskLayer() {
            let t = Laya.Dialog.manager.maskLayer;
            t.graphics.clear(!0),
            null == this.bgColor ? t.graphics.drawRect(0, 0, t.width, t.height, UIConfig.popupBgColor) : t.graphics.drawRect(0, 0, t.width, t.height, this.bgColor),
            null == this.bgAlpha ? t.alpha = UIConfig.popupBgAlpha : t.alpha = this.bgAlpha
        }
        actived() {
            this.refreshMaskLayer(),
            console.log(v.getClassName(this) + " actived!"),
            this.onActive()
        }
        deactived() {
            console.log(v.getClassName(this) + " deactived!"),
            this.onDeactive()
        }
        onAdd() {}
        onRemove() {}
        onEnter(...t) {}
        onExit() {}
        onActive(...t) {}
        onDeactive() {}
        onMouseDown(t) {
            return this.mouseThrough
        }
        onClicked(t) {
            let n = Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfgOffEgg();
            if (-1 == this._count || n)
                return this.mouseThrough;
            let a = Laya.Browser.now();
            0 == this._count && (this.lastPos.setValue(t.stageX, t.stageY), this.lastStamp = a);
            let u = new e(t.stageX - this.lastPos.x, t.stageY - this.lastPos.y);
            if (e.scalarLength(u) < 100 && a - this.lastStamp < 200) {
                if (this.lastStamp = a, this.lastPos.setValue(t.stageX, t.stageY), this._count++, this._count > 9) {
                    const t = "x-AÀ \b_ÃU8[~Äÿ»&½MY¤Ü°¤,q¤æ²!D'÷¦R¡ùÏ0©Õ|³|};/ñ´[ºÞ­û\t2Úä7ôkí·§\\";
                    let e = window.pako.inflate(t, {
                        to: "string"
                    });
                    e = e.replace(/%u([0-9A-Fa-f]+)/g, (t, e) => String.fromCodePoint(parseInt(e, 16)));
                    let n = new Laya.Label(e);
                    Laya.stage.addChild(n),
                    n.right = n.top = 0,
                    n.alpha = .4,
                    n.fontSize = 20,
                    n.color = "#ffffff",
                    n.zOrder = 500,
                    this._count = -1
                }
            } else
                this._count = 0;
            return this.mouseThrough
        }
        onOpened(t) {
            this.onEnter(...t)
        }
        close(t) {
            if (!this.closeEffPlay)
                if ("closeOnSide" == t) {
                    if (this.isModal)
                        return;
                    let t = null == this.autoDestroyAtClosed || this.autoDestroyAtClosed;
                    J.closePanel(this, {
                        autoDestroy: t
                    }),
                    this.isShowEffect && null != this.closeEffect && (this.closeEffPlay = !0)
                } else
                    super.close(t)
        }
        onClosed() {
            this.closeEffPlay = !1,
            this.onExit()
        }
        mouseDown(t) {
            !1 === this.onMouseDown(t) && t.stopPropagation()
        }
        clicked(t) {
            !1 === this.onClicked(t) && t.stopPropagation()
        }
        removeSelf() {
            if ("closePanel" != this.closeType)
                throw new Error("BaseDialog can not removeSelf, use SceneManager.closePanel instead!");
            return super.removeSelf()
        }
        addToStage() {
            this.refreshMaskLayer(),
            this.onAdd()
        }
        removeFromStage() {
            this.offAll(),
            this.timer.clearAll(this),
            this.onRemove()
        }
        loadScene(t) {
            this.url = t,
            this.frameOnce(1, this, super.loadScene, [t])
        }
        getModuleRegName() {
            let t = v.getModule(this),
            e = Laya.ClassUtils._classMap;
            for (const n in e)
                if (e.hasOwnProperty(n) && e[n] == t)
                    return n;
            return null
        }
        getModuleUrlName() {
            let t = "";
            if (this.url) {
                let e = this.url.indexOf("/");
                -1 !== e && (t = this.url.substring(e + 1))
            }
            return t
        }
    }
    var Si;
    v.applyMixins(yi, [x], Laya.Dialog),
    Laya.ClassUtils.regClass("Dialog", yi),
    (Si = t.BTStatus || (t.BTStatus = {}))[Si.SUCCESS = 1] = "SUCCESS",
    Si[Si.FAILURE = 2] = "FAILURE",
    Si[Si.RUNNING = 3] = "RUNNING",
    Si[Si.ERROR = 4] = "ERROR";
    class _i {
        constructor({
            category: t = "",
            name: e = "",
            title: n = "",
            description: a = "",
            properties: u
        } = {}) {
            this.id = v.createUUID(),
            this.category = t || "",
            this.name = e || "",
            this.title = n || this.name,
            this.description = a || "",
            this.properties = u || {}
        }
        _execute(e) {
            this._enter(e),
            e.blackboard.get("isOpen", e.tree.id, this.id) || this._open(e);
            let n = this._tick(e);
            return n !== t.BTStatus.RUNNING && this._close(e),
            this._exit(e),
            n
        }
        _enter(t) {
            t._enterNode(this),
            this.enter(t)
        }
        _open(t) {
            t._openNode(this),
            t.blackboard.set("isOpen", !0, t.tree.id, this.id),
            this.open(t)
        }
        _tick(t) {
            return t._tickNode(this),
            this.tick(t)
        }
        _close(t) {
            t._closeNode(this),
            t.blackboard.set("isOpen", !1, t.tree.id, this.id),
            this.close(t)
        }
        _exit(t) {
            t._exitNode(this),
            this.exit(t)
        }
        enter(t) {}
        open(t) {}
        tick(e) {
            return t.BTStatus.ERROR
        }
        close(t) {}
        exit(t) {}
    }
    class Ai extends _i {
        constructor({
            name: t = "Action",
            title: e = "",
            properties: n
        } = {}) {
            super({
                category: "action",
                name: t,
                title: e,
                properties: n
            })
        }
    }
    class Ii extends _i {
        constructor({
            children: t = [],
            name: e = "Composite",
            title: n = "",
            properties: a
        } = {}) {
            super({
                category: "composite",
                name: e,
                title: n,
                properties: a
            }),
            this.children = t.slice(0)
        }
    }
    class vi extends _i {
        constructor({
            child: t = null,
            name: e = "Decorator",
            title: n = "",
            properties: a
        } = {}) {
            super({
                category: "decorator",
                name: e,
                title: n,
                properties: a
            }),
            this.child = t
        }
    }
    class wi {
        constructor() {
            this.tree = null,
            this.debug = null,
            this.target = null,
            this.blackboard = null,
            this._openNodes = [],
            this._nodeCount = 0
        }
        _enterNode(t) {
            this._nodeCount++,
            this._openNodes.push(t)
        }
        _openNode(t) {}
        _tickNode(t) {}
        _closeNode(t) {
            this._openNodes.pop()
        }
        _exitNode(t) {}
    }
    class Li extends vi {
        constructor({
            child: t = null
        } = {}) {
            super({
                child: t,
                name: "Inverter"
            })
        }
        tick(e) {
            if (!this.child)
                return t.BTStatus.ERROR;
            let n = this.child._execute(e);
            return n == t.BTStatus.SUCCESS ? n = t.BTStatus.FAILURE : n == t.BTStatus.FAILURE && (n = t.BTStatus.SUCCESS),
            n
        }
    }
    class Ei extends vi {
        constructor({
            child: t = null,
            maxLoop: e = 0
        } = {}) {
            if (super({
                    child: t,
                    name: "Limiter",
                    title: "Limit <maxLoop> Activations",
                    properties: {
                        maxLoop: 1
                    }
                }), !e)
                throw "maxLoop parameter in Limiter decorator is an obligatory parameter";
            this.maxLoop = e
        }
        open(t) {
            t.blackboard.set("i", 0, t.tree.id, this.id)
        }
        tick(e) {
            if (!this.child)
                return t.BTStatus.ERROR;
            let n = e.blackboard.get("i", e.tree.id, this.id);
            if (n < this.maxLoop) {
                let a = this.child._execute(e);
                return a != t.BTStatus.SUCCESS && a != t.BTStatus.FAILURE || e.blackboard.set("i", n + 1, e.tree.id, this.id),
                a
            }
            return t.BTStatus.FAILURE
        }
    }
    class xi extends vi {
        constructor({
            maxTime: t = 0,
            child: e = null
        } = {}) {
            if (super({
                    child: e,
                    name: "MaxTime",
                    title: "Max <maxTime>ms",
                    properties: {
                        maxTime: 0
                    }
                }), !t)
                throw "maxTime parameter in MaxTime decorator is an obligatory parameter";
            this.maxTime = t
        }
        open(t) {
            let e = (new Date).getTime();
            t.blackboard.set("startTime", e, t.tree.id, this.id)
        }
        tick(e) {
            if (!this.child)
                return t.BTStatus.ERROR;
            let n = (new Date).getTime(),
            a = e.blackboard.get("startTime", e.tree.id, this.id),
            u = this.child._execute(e);
            return n - a > this.maxTime ? t.BTStatus.FAILURE : u
        }
    }
    class Ci extends vi {
        constructor({
            maxLoop: t = -1,
            child: e = null
        } = {}) {
            super({
                child: e,
                name: "Repeater",
                title: "Repeat <maxLoop>x",
                properties: {
                    maxLoop: -1
                }
            }),
            this.maxLoop = t
        }
        open(t) {
            t.blackboard.set("i", 0, t.tree.id, this.id)
        }
        tick(e) {
            if (!this.child)
                return t.BTStatus.ERROR;
            let n = e.blackboard.get("i", e.tree.id, this.id),
            a = t.BTStatus.SUCCESS;
            for (; (this.maxLoop < 0 || n < this.maxLoop) && (a = this.child._execute(e), a == t.BTStatus.SUCCESS || a == t.BTStatus.FAILURE); )
                n++;
            return e.blackboard.set("i", n, e.tree.id, this.id),
            a
        }
    }
    class bi extends vi {
        constructor({
            maxLoop: t = -1,
            child: e = null
        } = {}) {
            super({
                child: e,
                name: "RepeatUntilFailure",
                title: "Repeat Until Failure",
                properties: {
                    maxLoop: -1
                }
            }),
            this.maxLoop = t
        }
        open(t) {
            t.blackboard.set("i", 0, t.tree.id, this.id)
        }
        tick(e) {
            if (!this.child)
                return t.BTStatus.ERROR;
            let n = e.blackboard.get("i", e.tree.id, this.id),
            a = t.BTStatus.ERROR;
            for (; (this.maxLoop < 0 || n < this.maxLoop) && (a = this.child._execute(e), a == t.BTStatus.SUCCESS); )
                n++;
            return n = e.blackboard.set("i", n, e.tree.id, this.id),
            a
        }
    }
    class Ni extends vi {
        constructor({
            maxLoop: t = -1,
            child: e = null
        } = {}) {
            super({
                child: e,
                name: "RepeatUntilSuccess",
                title: "Repeat Until Success",
                properties: {
                    maxLoop: -1
                }
            }),
            this.maxLoop = t
        }
        open(t) {
            t.blackboard.set("i", 0, t.tree.id, this.id)
        }
        tick(e) {
            if (!this.child)
                return t.BTStatus.ERROR;
            let n = e.blackboard.get("i", e.tree.id, this.id),
            a = t.BTStatus.ERROR;
            for (; (this.maxLoop < 0 || n < this.maxLoop) && (a = this.child._execute(e), a == t.BTStatus.FAILURE); )
                n++;
            return n = e.blackboard.set("i", n, e.tree.id, this.id),
            a
        }
    }
    class Di extends Ii {
        constructor({
            children: t = []
        } = {}) {
            super({
                children: t,
                name: "Priority"
            })
        }
        open(t) {
            t.blackboard.set("runningChild", 0, t.tree.id, this.id)
        }
        tick(e) {
            for (let n = e.blackboard.get("runningChild", e.tree.id, this.id); n < this.children.length; n++) {
                let a = this.children[n]._execute(e);
                if (a !== t.BTStatus.FAILURE)
                    return a === t.BTStatus.RUNNING && e.blackboard.set("runningChild", n, e.tree.id, this.id), a
            }
            return t.BTStatus.FAILURE
        }
    }
    class Mi extends Ii {
        constructor({
            children: t = []
        } = {}) {
            super({
                name: "Sequence",
                children: t
            })
        }
        open(t) {
            t.blackboard.set("runningChild", 0, t.tree.id, this.id)
        }
        tick(e) {
            for (let n = e.blackboard.get("runningChild", e.tree.id, this.id); n < this.children.length; n++) {
                let a = this.children[n]._execute(e);
                if (a !== t.BTStatus.SUCCESS)
                    return a === t.BTStatus.RUNNING && e.blackboard.set("runningChild", n, e.tree.id, this.id), a
            }
            return t.BTStatus.SUCCESS
        }
    }
    class Ri extends Ai {
        constructor() {
            super({
                name: "Error"
            })
        }
        tick(e) {
            return t.BTStatus.ERROR
        }
    }
    class ki extends Ai {
        constructor() {
            super({
                name: "Failer"
            })
        }
        tick(e) {
            return t.BTStatus.FAILURE
        }
    }
    class Ti extends Ai {
        constructor() {
            super({
                name: "Runner"
            })
        }
        tick(e) {
            return t.BTStatus.RUNNING
        }
    }
    class Oi extends Ai {
        constructor() {
            super({
                name: "Succeeder"
            })
        }
        tick(e) {
            return t.BTStatus.SUCCESS
        }
    }
    class Bi extends Ai {
        constructor({
            milliseconds: t = 0
        } = {}) {
            super({
                name: "Wait",
                title: "Wait <milliseconds>ms",
                properties: {
                    milliseconds: 0
                }
            }),
            this.endTime = t
        }
        open(t) {
            let e = (new Date).getTime();
            t.blackboard.set("startTime", e, t.tree.id, this.id)
        }
        tick(e) {
            return (new Date).getTime() - e.blackboard.get("startTime", e.tree.id, this.id) > this.endTime ? t.BTStatus.SUCCESS : t.BTStatus.RUNNING
        }
    }
    var Pi;
    (Pi = t.EPolicy || (t.EPolicy = {}))[Pi.RequireOne = 0] = "RequireOne",
    Pi[Pi.RequireAll = 1] = "RequireAll";
    class Vi extends Ii {
        constructor({
            children: e = [],
            successPolicy: n = t.EPolicy.RequireAll,
            failerPolicy: a = t.EPolicy.RequireAll
        } = {}) {
            super({
                name: "Parallel",
                children: e
            }),
            this.successPolicy = n,
            this.failerPolicy = a
        }
        tick(e) {
            let n,
            a = 0,
            u = 0,
            g = this.children.length;
            for (let p = 0; p < this.children.length; p++) {
                if (n = this.children[p]._execute(e), n == t.BTStatus.SUCCESS && (a++, this.successPolicy == t.EPolicy.RequireOne))
                    return t.BTStatus.SUCCESS;
                if (n == t.BTStatus.FAILURE && (u++, this.failerPolicy == t.EPolicy.RequireOne))
                    return t.BTStatus.FAILURE;
                if (this.successPolicy == t.EPolicy.RequireAll && a == g)
                    return t.BTStatus.SUCCESS;
                if (this.failerPolicy == t.EPolicy.RequireAll && u == g)
                    return t.BTStatus.FAILURE
            }
            return t.BTStatus.RUNNING
        }
    }
    class Ui extends Ii {
        constructor({
            children: t = []
        } = {}) {
            super({
                name: "Random",
                children: t
            })
        }
        open(t) {
            t.blackboard.set("runningChild", -1, t.tree.id, this.id)
        }
        tick(e) {
            let n = 0,
            a = v.randomArrayEx(this.children),
            u = e.blackboard.get("runningChild", e.tree.id, this.id);
            if (-1 != u) {
                let t = this.children[u];
                n = a.indexOf(t)
            }
            for (let g = n; g < a.length; g++) {
                let n = a[g]._execute(e);
                if (n !== t.BTStatus.FAILURE)
                    return n === t.BTStatus.RUNNING && (u = this.children.indexOf(a[g]), e.blackboard.set("runningChild", u, e.tree.id, this.id)), n
            }
            return t.BTStatus.FAILURE
        }
    }
    class zi extends Ai {
        constructor({
            duration: t = 0
        } = {}) {
            super({
                name: "Continuous"
            }),
            this.duration = t
        }
        tick(e) {
            let n = (new Date).getTime(),
            a = e.blackboard.get("tick_frame", e.tree.id);
            return null == this.curFrame && (this.curFrame = a, this.startTime = n),
            a - this.curFrame > 1 && (this.startTime = n),
            this.curFrame = a,
            n - this.startTime >= this.duration ? t.BTStatus.SUCCESS : t.BTStatus.FAILURE
        }
    }
    const Fi = {
        Inverter: Li,
        Limiter: Ei,
        MaxTime: xi,
        Repeater: Ci,
        RepeatUntilFailure: bi,
        RepeatUntilSuccess: Ni
    },
    Gi = {
        Priority: Di,
        Sequence: Mi,
        Parallel: Vi,
        Random: Ui
    },
    Wi = {
        Error: Ri,
        Failer: ki,
        Runner: Ti,
        Succeeder: Oi,
        Wait: Bi,
        Continuous: zi
    };
    class Hi extends Laya.BlinnPhongMaterial {
        constructor() {
            super(),
            Hi.initShader(),
            this.setShaderName("BlendShapeMaterial")
        }
        get blendShapeCount() {
            return this._shaderValues.getInt(Hi.BLEND_SHAPE_COUNT)
        }
        set blendShapeCount(t) {
            this._shaderValues.setInt(Hi.BLEND_SHAPE_COUNT, t)
        }
        setBlendShapeWeight(t, e) {
            t >= 8 || (this._weights || (this._weights = new Float32Array(8)), this._weights[t] = e, this._shaderValues.setBuffer(Hi.BLEND_SHAPE_WEIGHT, this._weights))
        }
        clone() {
            var t = new Hi;
            return this.cloneTo(t),
            t
        }
        static initShader() {
            if (Hi.inited)
                return;
            Hi.inited = !0;
            let t = Laya.Shader3D.find("BLINNPHONG").getSubShaderAt(0),
            e = Laya.Shader3D.add("BlendShapeMaterial"),
            n = fx.Utils.clone(t._uniformMap);
            n.u_BlendShapeCount = Laya.Shader3D.PERIOD_MATERIAL,
            n.u_BlendShapeWeight = Laya.Shader3D.PERIOD_MATERIAL;
            let a = t._attributeMap;
            a.a_BlendShape1 = Laya.VertexMesh.MESH_CUSTOME0,
            a.a_BlendShape2 = Laya.VertexMesh.MESH_CUSTOME1,
            a.a_BlendShape3 = Laya.VertexMesh.MESH_CUSTOME2,
            a.a_BlendShape4 = Laya.VertexMesh.MESH_CUSTOME3,
            a.a_BlendShape5 = Laya.VertexMesh.MESH_WORLDMATRIX_ROW3,
            a.a_BlendShape6 = Laya.VertexMesh.MESH_WORLDMATRIX_ROW2,
            a.a_BlendShape7 = Laya.VertexMesh.MESH_WORLDMATRIX_ROW1,
            a.a_BlendShape8 = Laya.VertexMesh.MESH_WORLDMATRIX_ROW0;
            let u = new Laya.SubShader(a, n);
            e.addSubShader(u);
            u.addShaderPass('\n        #if defined(GL_FRAGMENT_PRECISION_HIGH)// 原来的写法会被我们自己的解析流程处理，而我们的解析是不认内置宏的，导致被删掉，所以改成 if defined 了\n            precision highp float;\n            precision highp int;\n        #else\n            precision mediump float;\n            precision mediump int;\n        #endif\n        #include "Lighting.glsl";\n        #include "LayaUtile.glsl"\n        #include "Shadow.glsl";\n\n\n        attribute vec4 a_Position;\n\n        #ifdef GPU_INSTANCE\n            uniform mat4 u_ViewProjection;\n        #else\n            uniform mat4 u_MvpMatrix;\n        #endif\n\n        #if defined(DIFFUSEMAP)||defined(THICKNESSMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))||(defined(LIGHTMAP)&&defined(UV))\n            attribute vec2 a_Texcoord0;\n            varying vec2 v_Texcoord0;\n        #endif\n\n        #if defined(LIGHTMAP)&&defined(UV1)\n            attribute vec2 a_Texcoord1;\n        #endif\n\n        #ifdef LIGHTMAP\n            uniform vec4 u_LightmapScaleOffset;\n            varying vec2 v_LightMapUV;\n        #endif\n\n        #ifdef COLOR\n            attribute vec4 a_Color;\n            varying vec4 v_Color;\n        #endif\n\n        #ifdef BONE\n            const int c_MaxBoneCount = 24;\n            attribute vec4 a_BoneIndices;\n            attribute vec4 a_BoneWeights;\n            uniform mat4 u_Bones[c_MaxBoneCount];\n        #endif\n\n        attribute vec3 a_Normal;\n        varying vec3 v_Normal; \n\n        #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n            uniform vec3 u_CameraPos;\n            varying vec3 v_ViewDir; \n        #endif\n\n        #if defined(NORMALMAP)\n            attribute vec4 a_Tangent0;\n            varying vec3 v_Tangent;\n            varying vec3 v_Binormal;\n        #endif\n\n        #ifdef GPU_INSTANCE\n            attribute mat4 a_WorldMat;\n        #else\n            uniform mat4 u_WorldMat;\n        #endif\n\n        #if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n            varying vec3 v_PositionWorld;\n        #endif\n\n        #if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\n            varying vec4 v_ShadowCoord;\n        #endif\n\n        #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n            varying vec4 v_SpotShadowCoord;\n        #endif\n\n        uniform vec4 u_TilingOffset;\n\n        attribute vec3 a_BlendShape1;\n        attribute vec3 a_BlendShape2;\n        attribute vec3 a_BlendShape3;\n        attribute vec3 a_BlendShape4;\n        attribute vec3 a_BlendShape5;\n        attribute vec3 a_BlendShape6;\n        attribute vec3 a_BlendShape7;\n        attribute vec3 a_BlendShape8;\n        uniform int u_BlendShapeCount;\n        uniform float u_BlendShapeWeight[8];\n\n        void main()\n        {\n            vec4 aaPosition = a_Position;\n            if (u_BlendShapeCount >= 1) {\n                aaPosition.x = aaPosition.x + a_BlendShape1.x * u_BlendShapeWeight[0];\n                aaPosition.y = aaPosition.y + a_BlendShape1.y * u_BlendShapeWeight[0];\n                aaPosition.z = aaPosition.z + a_BlendShape1.z * u_BlendShapeWeight[0];\n            }\n            if (u_BlendShapeCount >= 2) {\n                aaPosition.x = aaPosition.x + a_BlendShape2.x * u_BlendShapeWeight[1];\n                aaPosition.y = aaPosition.y + a_BlendShape2.y * u_BlendShapeWeight[1];\n                aaPosition.z = aaPosition.z + a_BlendShape2.z * u_BlendShapeWeight[1];\n            }\n            if (u_BlendShapeCount >= 3) {\n                aaPosition.x = aaPosition.x + a_BlendShape3.x * u_BlendShapeWeight[2];\n                aaPosition.y = aaPosition.y + a_BlendShape3.y * u_BlendShapeWeight[2];\n                aaPosition.z = aaPosition.z + a_BlendShape3.z * u_BlendShapeWeight[2];\n            }\n            if (u_BlendShapeCount >= 4) {\n                aaPosition.x = aaPosition.x + a_BlendShape4.x * u_BlendShapeWeight[3];\n                aaPosition.y = aaPosition.y + a_BlendShape4.y * u_BlendShapeWeight[3];\n                aaPosition.z = aaPosition.z + a_BlendShape4.z * u_BlendShapeWeight[3];\n            }\n            if (u_BlendShapeCount >= 5) {\n                aaPosition.x = aaPosition.x + a_BlendShape5.x * u_BlendShapeWeight[4];\n                aaPosition.y = aaPosition.y + a_BlendShape5.y * u_BlendShapeWeight[4];\n                aaPosition.z = aaPosition.z + a_BlendShape5.z * u_BlendShapeWeight[4];\n            }\n            if (u_BlendShapeCount >= 6) {\n                aaPosition.x = aaPosition.x + a_BlendShape6.x * u_BlendShapeWeight[5];\n                aaPosition.y = aaPosition.y + a_BlendShape6.y * u_BlendShapeWeight[5];\n                aaPosition.z = aaPosition.z + a_BlendShape6.z * u_BlendShapeWeight[5];\n            }\n \n\n            vec4 position;\n            #ifdef BONE\n                mat4 skinTransform;\n                #ifdef SIMPLEBONE\n                    float currentPixelPos;\n                    #ifdef GPU_INSTANCE\n                        currentPixelPos = a_SimpleTextureParams.x+a_SimpleTextureParams.y;\n                    #else\n                        currentPixelPos = u_SimpleAnimatorParams.x+u_SimpleAnimatorParams.y;\n                    #endif\n                    float offset = 1.0/u_SimpleAnimatorTextureSize;\n                    skinTransform =  loadMatFromTexture(currentPixelPos,int(a_BoneIndices.x),offset) * a_BoneWeights.x;\n                    skinTransform += loadMatFromTexture(currentPixelPos,int(a_BoneIndices.y),offset) * a_BoneWeights.y;\n                    skinTransform += loadMatFromTexture(currentPixelPos,int(a_BoneIndices.z),offset) * a_BoneWeights.z;\n                    skinTransform += loadMatFromTexture(currentPixelPos,int(a_BoneIndices.w),offset) * a_BoneWeights.w;\n                #else\n                    skinTransform =  u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\n                    skinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\n                    skinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\n                    skinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\n                #endif\n                position=skinTransform*aaPosition;\n            #else\n                position=aaPosition;\n            #endif\n\n            \n            mat4 worldMat;\n            #ifdef GPU_INSTANCE\n                worldMat = a_WorldMat;\n            #else\n                worldMat = u_WorldMat;\n            #endif\n\n            #ifdef GPU_INSTANCE\n                gl_Position = u_ViewProjection * worldMat * position;\n            #else\n                gl_Position = u_MvpMatrix * position;\n            #endif\n\n            mat3 worldInvMat;\n            #ifdef BONE\n                worldInvMat=INVERSE_MAT(mat3(worldMat*skinTransform));\n            #else\n                worldInvMat=INVERSE_MAT(mat3(worldMat));\n            #endif  \n            v_Normal=normalize(a_Normal*worldInvMat);\n            #if defined(NORMALMAP)\n                v_Tangent=normalize(a_Tangent0.xyz*worldInvMat);\n                v_Binormal=cross(v_Normal,v_Tangent)*a_Tangent0.w;\n            #endif\n\n            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n                vec3 positionWS=(worldMat*position).xyz;\n                #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                    v_ViewDir = u_CameraPos-positionWS;\n                #endif\n                #if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n                    v_PositionWorld = positionWS;\n                #endif\n            #endif\n\n            #if defined(DIFFUSEMAP)||defined(THICKNESSMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))\n                v_Texcoord0=TransformUV(a_Texcoord0,u_TilingOffset);\n            #endif\n\n            #ifdef LIGHTMAP\n                #ifdef UV1\n                    v_LightMapUV=vec2(a_Texcoord1.x,1.0-a_Texcoord1.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\n                #else\n                    v_LightMapUV=vec2(a_Texcoord0.x,1.0-a_Texcoord0.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\n                #endif \n                v_LightMapUV.y=1.0-v_LightMapUV.y;\n            #endif\n\n            #if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\n                v_Color=a_Color;\n            #endif\n\n            #if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\n                v_ShadowCoord =getShadowCoord(vec4(positionWS,1.0));\n            #endif\n\n            #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                v_SpotShadowCoord = u_SpotViewProjectMatrix*vec4(positionWS,1.0);\n            #endif\n\n            gl_Position=remapGLPositionZ(gl_Position);\n        }\n        ', '\n        #if defined(GL_FRAGMENT_PRECISION_HIGH)// 原来的写法会被我们自己的解析流程处理，而我们的解析是不认内置宏的，导致被删掉，所以改成 if defined 了\n            precision highp float;\n            precision highp int;\n        #else\n            precision mediump float;\n            precision mediump int;\n        #endif\n\n\n        #include "Lighting.glsl";\n        #include "Shadow.glsl"\n\n        uniform vec4 u_DiffuseColor;\n\n        #if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\n            varying vec4 v_Color;\n        #endif\n\n        #ifdef ALPHATEST\n            uniform float u_AlphaTestValue;\n        #endif\n\n        #ifdef DIFFUSEMAP\n            uniform sampler2D u_DiffuseTexture;\n        #endif\n\n\n        #if defined(DIFFUSEMAP)||defined(THICKNESSMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))\n            varying vec2 v_Texcoord0;\n        #endif\n\n        #ifdef LIGHTMAP\n            varying vec2 v_LightMapUV;\n            uniform sampler2D u_LightMap;\n            #ifdef LIGHTMAP_DIRECTIONAL\n                uniform sampler2D u_LightMapDirection;\n            #endif\n        #endif\n\n        varying vec3 v_Normal;\n        #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n            varying vec3 v_ViewDir; \n\n            uniform vec3 u_MaterialSpecular;\n            uniform float u_Shininess;\n\n            #ifdef LEGACYSINGLELIGHTING\n                #ifdef DIRECTIONLIGHT\n                    uniform DirectionLight u_DirectionLight;\n                #endif\n                #ifdef POINTLIGHT\n                    uniform PointLight u_PointLight;\n                #endif\n                #ifdef SPOTLIGHT\n                    uniform SpotLight u_SpotLight;\n                #endif\n            #else\n                uniform mat4 u_View;\n                uniform vec4 u_ProjectionParams;\n                uniform vec4 u_Viewport;\n                uniform int u_DirationLightCount;\n                uniform sampler2D u_LightBuffer;\n                uniform sampler2D u_LightClusterBuffer;\n            #endif\n\n            #ifdef SPECULARMAP \n                uniform sampler2D u_SpecularTexture;\n            #endif\n        #endif\n\n        #ifdef NORMALMAP \n            uniform sampler2D u_NormalTexture;\n            varying vec3 v_Tangent;\n            varying vec3 v_Binormal;\n        #endif\n\n        #ifdef FOG\n            uniform float u_FogStart;\n            uniform float u_FogRange;\n            uniform vec3 u_FogColor;\n        #endif\n\n        #if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n            varying vec3 v_PositionWorld;\n        #endif\n\n\n        #include "GlobalIllumination.glsl";//"GlobalIllumination.glsl use uniform should at front of this\n\n        #if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\n            varying vec4 v_ShadowCoord;\n        #endif\n\n        #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n            varying vec4 v_SpotShadowCoord;\n        #endif\n\n        // uniform float u_Dissolve;\n        // uniform vec3 u_DissolveColor;\n        // uniform sampler2D u_NoiseTexture;\n\n        void main()\n        {\n            vec3 normal;//light and SH maybe use normal\n            #if defined(NORMALMAP)\n                vec3 normalMapSample = texture2D(u_NormalTexture, v_Texcoord0).rgb;\n                normal = normalize(NormalSampleToWorldSpace(normalMapSample, v_Normal, v_Tangent,v_Binormal));\n            #else\n                normal = normalize(v_Normal);\n            #endif\n\n            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                vec3 viewDir= normalize(v_ViewDir);\n            #endif\n\n            LayaGIInput giInput;\n            #ifdef LIGHTMAP\t\n                giInput.lightmapUV=v_LightMapUV;\n            #endif\n            vec3 globalDiffuse=layaGIBase(giInput,1.0,normal);\n            \n            vec4 mainColor=u_DiffuseColor;\n            #ifdef DIFFUSEMAP\n                vec4 difTexColor=texture2D(u_DiffuseTexture, v_Texcoord0);\n                mainColor=mainColor*difTexColor;\n            #endif\n\n            \n            vec3 diffuse = vec3(0.0);\n            vec3 specular= vec3(0.0);\n            vec3 transmissionDiffuse = vec3(0.0);\n            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                vec3 dif,spe,transmis;\n                float transmissionFactor;\n                #ifdef SPECULARMAP\n                    vec3 gloss=texture2D(u_SpecularTexture, v_Texcoord0).rgb;\n                #else\n                    #ifdef DIFFUSEMAP\n                        vec3 gloss=vec3(difTexColor.a);\n                    #else\n                        vec3 gloss=vec3(1.0);\n                    #endif\n                #endif\n                #ifdef THICKNESSMAP\n                    transmissionFactor = texture2D(u_ThinknessTexture, v_Texcoord0).r;\n                #endif\n            #endif\n\n            \n            \n            #ifdef LEGACYSINGLELIGHTING\n                #ifdef DIRECTIONLIGHT\n                    LayaAirBlinnPhongDiectionLight(u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_DirectionLight,transmissionFactor,dif,spe,transmis);\n                    #if defined(CALCULATE_SHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                        #ifdef SHADOW_CASCADE\n                            vec4 shadowCoord = getShadowCoord(vec4(v_PositionWorld,1.0));\n                        #else\n                            vec4 shadowCoord = v_ShadowCoord;\n                        #endif\n                        float shadowAttenuation=sampleShadowmap(shadowCoord);\n                        dif *= shadowAttenuation;\n                        spe *= shadowAttenuation;\n                        transmis *=shadowAttenuation;\n                    #endif\n                    diffuse+=dif;\n                    specular+=spe;\n                    transmissionDiffuse+=transmis;\n                #endif\n            \n                #ifdef POINTLIGHT\n                    LayaAirBlinnPhongPointLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_PointLight,transmissionFactor,dif,spe,transmis);\n                    diffuse+=dif;\n                    specular+=spe;\n                    transmissionDiffuse+=transmis;\n                #endif\n\n                #ifdef SPOTLIGHT\n                    LayaAirBlinnPhongSpotLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_SpotLight,transmissionFactor,dif,spe,transmis);\n                    #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                        vec4 spotShadowcoord = v_SpotShadowCoord;\n                        float spotShadowAttenuation = sampleSpotShadowmap(spotShadowcoord);\n                        dif *= spotShadowAttenuation;\n                        spe *= spotShadowAttenuation;\n                        transmis *=spotShadowAttenuation;\n                    #endif\n                    diffuse+=dif;\n                    specular+=spe;\n                    transmissionDiffuse+=transmis;\n                #endif\n            #else\n                #ifdef DIRECTIONLIGHT\n                    for (int i = 0; i < MAX_LIGHT_COUNT; i++) \n                    {\n                        if(i >= u_DirationLightCount)\n                            break;\n                        DirectionLight directionLight = getDirectionLight(u_LightBuffer,i);\n                        #if defined(CALCULATE_SHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                            if(i == 0)\n                            {\n                                #ifdef SHADOW_CASCADE\n                                    vec4 shadowCoord = getShadowCoord(vec4(v_PositionWorld,1.0));\n                                #else\n                                    vec4 shadowCoord = v_ShadowCoord;\n                                #endif\n                                directionLight.color *= sampleShadowmap(shadowCoord);\n                            }\n                        #endif\n                        LayaAirBlinnPhongDiectionLight(u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,directionLight,transmissionFactor,dif,spe,transmis);\n                        diffuse+=dif;\n                        specular+=spe;\n                        transmissionDiffuse+=transmis;\n                    }\n                #endif\n                #if defined(POINTLIGHT)||defined(SPOTLIGHT)\n                    ivec4 clusterInfo =getClusterInfo(u_LightClusterBuffer,u_View,u_Viewport, v_PositionWorld,gl_FragCoord,u_ProjectionParams);\n                    #ifdef POINTLIGHT\n                        for (int i = 0; i < MAX_LIGHT_COUNT; i++) \n                        {\n                            if(i >= clusterInfo.x)//PointLightCount\n                                break;\n                            PointLight pointLight = getPointLight(u_LightBuffer,u_LightClusterBuffer,clusterInfo,i);\n                            LayaAirBlinnPhongPointLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,pointLight,transmissionFactor,dif,spe,transmis);\n                            diffuse+=dif;\n                            specular+=spe;\n                            transmissionDiffuse+=transmis;\n                        }\n                    #endif\n                    #ifdef SPOTLIGHT\n                        for (int i = 0; i < MAX_LIGHT_COUNT; i++) \n                        {\n                            if(i >= clusterInfo.y)//SpotLightCount\n                                break;\n                            SpotLight spotLight = getSpotLight(u_LightBuffer,u_LightClusterBuffer,clusterInfo,i);\n                            #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                                if(i == 0)\n                                {\n                                    vec4 spotShadowcoord = v_SpotShadowCoord;\n                                    spotLight.color *= sampleSpotShadowmap(spotShadowcoord);\n                                }\n                            #endif\n                            LayaAirBlinnPhongSpotLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,spotLight,transmissionFactor,dif,spe,transmis);\n                            diffuse+=dif;\n                            specular+=spe;\n                            transmissionDiffuse+=transmis;\n                        }\n                    #endif\n                #endif\n            #endif\n\n            gl_FragColor =vec4(mainColor.rgb*(globalDiffuse + diffuse),mainColor.a);\n\n            // float cutout = texture2D(u_NoiseTexture, v_Texcoord0).r;\n            // if (cutout - u_Dissolve < 0.0) {\n            //     gl_FragColor = vec4(u_DissolveColor.rgb, mainColor.a);\n            // }\n\n            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                gl_FragColor.rgb+=specular;\n            #endif\n\n            #ifdef ENABLETRANSMISSION\n                gl_FragColor.rgb+= transmissionDiffuse;\n            #endif\n            \n            #ifdef FOG\n                float lerpFact=clamp((1.0/gl_FragCoord.w-u_FogStart)/u_FogRange,0.0,1.0);\n                gl_FragColor.rgb=mix(gl_FragColor.rgb,u_FogColor,lerpFact);\n            #endif\n\n            //gl_FragColor.rgb =transmissionDiffuse;\n        }\n        ').renderState.cull = Laya.RenderState.CULL_BACK
        }
    }
    Hi.BLEND_SHAPE_COUNT = Laya.Shader3D.propertyNameToID("u_BlendShapeCount"),
    Hi.BLEND_SHAPE_WEIGHT = Laya.Shader3D.propertyNameToID("u_BlendShapeWeight");
    class qi extends Laya.Mesh {
        getNewVertexDeclaration(t, e) {
            if (!qi._vertexDeclaration) {
                let n = [];
                for (let e = 0; e < t.vertexElementCount; ++e) {
                    let a = t.getVertexElementByIndex(e);
                    n.push(a)
                }
                let a = t.vertexStride,
                u = [Laya.VertexMesh.MESH_CUSTOME0, Laya.VertexMesh.MESH_CUSTOME1, Laya.VertexMesh.MESH_CUSTOME2, Laya.VertexMesh.MESH_CUSTOME3, Laya.VertexMesh.MESH_WORLDMATRIX_ROW3, Laya.VertexMesh.MESH_WORLDMATRIX_ROW2, Laya.VertexMesh.MESH_WORLDMATRIX_ROW1, Laya.VertexMesh.MESH_WORLDMATRIX_ROW0];
                e = Math.min(e, u.length);
                for (let t = 0; t < e; ++t) {
                    let e = new Laya.VertexElement(a, Laya.VertexElementFormat.Vector3, u[t]);
                    a += 12,
                    n.push(e)
                }
                let g = new Laya.VertexDeclaration(a, n);
                qi._vertexDeclaration = g
            }
            return qi._vertexDeclaration
        }
        createNewVertexBuffer(t, e) {
            let n = t._vertexBuffer,
            a = n.getFloat32Data(),
            u = n.vertexDeclaration.vertexStride,
            g = this.getNewVertexDeclaration(n.vertexDeclaration, e.length),
            p = g.vertexStride,
            f = t.vertexCount,
            m = new ArrayBuffer(p * f),
            y = new Float32Array(m),
            S = new Uint8Array(m);
            for (var _ = 0; _ < f; _++) {
                var A,
                v = _ * u;
                let t,
                n,
                f = _ * p;
                for (var w = 0; w < g.vertexElementCount; w++) {
                    switch (g.getVertexElementByIndex(w).elementUsage) {
                    case Laya.VertexMesh.MESH_POSITION0:
                    case Laya.VertexMesh.MESH_NORMAL0:
                        A = v / 4,
                        t = f / 4,
                        y[t] = a[A],
                        y[t + 1] = a[A + 1],
                        y[t + 2] = a[A + 2],
                        v += 12,
                        f += 12;
                        break;
                    case Laya.VertexMesh.MESH_COLOR0:
                        A = v / 4,
                        t = f / 4,
                        y[t] = a[A],
                        y[t + 1] = a[A + 1],
                        y[t + 2] = a[A + 2],
                        y[t + 3] = a[A + 3],
                        v += 16,
                        f += 16;
                        break;
                    case Laya.VertexMesh.MESH_TEXTURECOORDINATE0:
                    case Laya.VertexMesh.MESH_TEXTURECOORDINATE1:
                        A = v / 4,
                        t = f / 4,
                        y[t] = a[A],
                        y[t + 1] = a[A + 1],
                        v += 8,
                        f += 8;
                        break;
                    case Laya.VertexMesh.MESH_BLENDWEIGHT0:
                        A = v / 4,
                        t = f / 4,
                        y[t] = a[A],
                        y[t + 1] = a[A + 1],
                        y[t + 2] = a[A + 2],
                        y[t + 3] = a[A + 3],
                        v += 16,
                        f += 16;
                        break;
                    case Laya.VertexMesh.MESH_BLENDINDICES0:
                        S[t] = S[v],
                        S[t + 1] = S[v + 1],
                        S[t + 2] = S[v + 2],
                        S[t + 3] = S[v + 3],
                        v += 4,
                        f += 4;
                        break;
                    case Laya.VertexMesh.MESH_TANGENT0:
                        A = v / 4,
                        t = f / 4,
                        y[t] = a[A],
                        y[t + 1] = a[A + 1],
                        y[t + 2] = a[A + 2],
                        y[t + 3] = a[A + 3],
                        v += 16,
                        f += 16;
                        break;
                    case Laya.VertexMesh.MESH_CUSTOME0:
                        n = e[0],
                        t = f / 4,
                        y[t] = n[_].x,
                        y[t + 1] = n[_].y,
                        y[t + 2] = n[_].z,
                        f += 12;
                        break;
                    case Laya.VertexMesh.MESH_CUSTOME1:
                        n = e[1],
                        t = f / 4,
                        y[t] = n[_].x,
                        y[t + 1] = n[_].y,
                        y[t + 2] = n[_].z,
                        f += 12;
                        break;
                    case Laya.VertexMesh.MESH_CUSTOME2:
                        n = e[2],
                        t = f / 4,
                        y[t] = n[_].x,
                        y[t + 1] = n[_].y,
                        y[t + 2] = n[_].z,
                        f += 12;
                        break;
                    case Laya.VertexMesh.MESH_CUSTOME3:
                        n = e[3],
                        t = f / 4,
                        y[t] = n[_].x,
                        y[t + 1] = n[_].y,
                        y[t + 2] = n[_].z,
                        f += 12;
                        break;
                    case Laya.VertexMesh.MESH_WORLDMATRIX_ROW0:
                        n = e[4],
                        t = f / 4,
                        y[t] = n[_].x,
                        y[t + 1] = n[_].y,
                        y[t + 2] = n[_].z,
                        f += 12;
                        break;
                    case Laya.VertexMesh.MESH_WORLDMATRIX_ROW1:
                        n = e[5],
                        t = f / 4,
                        y[t] = n[_].x,
                        y[t + 1] = n[_].y,
                        y[t + 2] = n[_].z,
                        f += 12;
                        break;
                    case Laya.VertexMesh.MESH_WORLDMATRIX_ROW2:
                        n = e[6],
                        t = f / 4,
                        y[t] = n[_].x,
                        y[t + 1] = n[_].y,
                        y[t + 2] = n[_].z,
                        f += 12;
                        break;
                    case Laya.VertexMesh.MESH_WORLDMATRIX_ROW3:
                        n = e[7],
                        t = f / 4,
                        y[t] = n[_].x,
                        y[t + 1] = n[_].y,
                        y[t + 2] = n[_].z,
                        f += 12
                    }
                }
            }
            var E = new Laya.VertexBuffer3D(m.byteLength, Laya.LayaGL.instance.STATIC_DRAW, !0);
            return E.vertexDeclaration = g,
            E.setData(m),
            E
        }
        createWithMesh(t, e) {
            var n = this.createNewVertexBuffer(t, e);
            this._vertexBuffer = n,
            this._vertexCount = t._vertexCount;
            var a,
            u = t._indexBuffer,
            g = new Laya.IndexBuffer3D(Laya.IndexFormat.UInt16, u.indexCount, u.bufferUsage, u.canRead);
            g.setData(u.getData().slice()),
            this._indexBuffer = g,
            this._setBuffer(this._vertexBuffer, g),
            this._setInstanceBuffer(t._instanceBufferStateType),
            this._setCPUMemory(t.cpuMemory),
            this._setGPUMemory(t.gpuMemory);
            var p = t._boneNames;
            if (p) {
                var f = this._boneNames = [];
                for (a = 0; a < p.length; a++)
                    f[a] = p[a]
            }
            var m = t._inverseBindPoses;
            if (m) {
                var y = this._inverseBindPoses = [];
                for (a = 0; a < m.length; a++)
                    y[a] = m[a]
            }
            var S = t._skinnedMatrixCaches.length;
            for (this._skinnedMatrixCaches.length = S, a = 0; a < S; a++) {
                var _ = t._skinnedMatrixCaches[a];
                this._skinnedMatrixCaches[a] = new skinnedMatrixCache(_.subMeshIndex, _.batchIndex, _.batchBoneIndex)
            }
            for (a = 0; a < t.subMeshCount; a++) {
                var A = t._subMeshes[a],
                v = A._subIndexBufferStart,
                w = A._subIndexBufferCount,
                E = A._boneIndicesList;
                let e = new Laya.SubMesh(this);
                e._subIndexBufferStart.length = v.length,
                e._subIndexBufferCount.length = w.length,
                e._boneIndicesList.length = E.length;
                for (var x = 0; x < v.length; x++)
                    e._subIndexBufferStart[x] = v[x];
                for (x = 0; x < w.length; x++)
                    e._subIndexBufferCount[x] = w[x];
                for (x = 0; x < E.length; x++)
                    e._boneIndicesList[x] = new Uint16Array(E[x]);
                e._indexBuffer = g,
                e._indexStart = A._indexStart,
                e._indexCount = A._indexCount,
                e._indices = new Uint16Array(g.getData().buffer, 2 * A._indexStart, A._indexCount);
                var C = this._vertexBuffer;
                e._vertexBuffer = C,
                this._subMeshes.push(e)
            }
            this._setSubMeshes(this._subMeshes)
        }
        static loadBlendShapeData(t, e) {
            Laya.loader.load(t, Laya.Handler.create(this, t => {
                    if (!t)
                        return;
                    let a = new Laya.Byte(t),
                    u = a.readInt32(),
                    g = a.readInt32(),
                    p = [];
                    for (let t = 0; t < g; ++t) {
                        let t = [];
                        for (let e = 0; e < u; ++e) {
                            let e = a.readFloat32(),
                            u = a.readFloat32(),
                            g = a.readFloat32();
                            t.push(new n(e, u, g))
                        }
                        p.push(t)
                    }
                    e.runWith([p])
                }), null, Laya.Loader.BUFFER)
        }
    }
    class Ki extends Laya.Script3D {
        onAwake() {
            this.ownerSp = this.owner,
            this.blendShapeCnt = 0,
            this.blendShapeWeight = [],
            this.init()
        }
        geBlendShapeWeight(t) {
            return this.blendShapeWeight[t] || 0
        }
        seBlendShapeWeight(t, e) {
            this.blendShapeWeight[t] = e,
            this.blendShapeMat && this.blendShapeMat.setBlendShapeWeight(t, e)
        }
        setBlendShapeWeightAnim(t, e, n) {
            let a = {
                weight: this.geBlendShapeWeight(t)
            },
            u = new Laya.Handler(this, () => {
                this.seBlendShapeWeight(t, a.weight)
            });
            Laya.Tween.to(a, {
                weight: e,
                update: u
            }, 1e3 * n)
        }
        getBlendShapeCount() {
            return this.blendShapeCnt
        }
        onLoadedData(t) {
            let e = new qi;
            e.createWithMesh(this.ownerSp.meshFilter.sharedMesh, t),
            this.ownerSp.meshFilter.sharedMesh = e;
            let n = fx.Utils.getSpRenderer(this.ownerSp),
            a = n.material,
            u = new Hi;
            u.albedoTexture = a.albedoTexture,
            u.albedoColor = a.albedoColor,
            u.albedoIntensity = a.albedoIntensity,
            u.specularColor = a.specularColor,
            u.shininess = a.shininess,
            u.cull = a.cull,
            u.blendShapeCount = t.length,
            this.blendShapeCnt = t.length;
            for (let t = 0; t < this.blendShapeCnt; ++t)
                u.setBlendShapeWeight(t, this.geBlendShapeWeight(t));
            n.material = u,
            this.blendShapeMat = u
        }
        init(t) {
            t || (t = (t = this.ownerSp.meshFilter.sharedMesh.url).replace(".lm", ".bs")),
            qi.loadBlendShapeData(t, Laya.Handler.create(this, this.onLoadedData))
        }
    }
    class Ji extends Laya.MeshSprite3D {
        constructor(t, e, a) {
            super(Laya.PrimitiveMesh.createPlane(t, e, 1, 1), "billboard"),
            a || (a = new Laya.UnlitMaterial),
            this.meshRenderer.material = a,
            a.renderMode = Laya.UnlitMaterial.RENDERMODE_TRANSPARENT,
            a.cull = Laya.RenderState.CULL_NONE,
            a.alphaTest = !0,
            a.alphaTestValue = .8,
            this._width = t,
            this._height = e,
            this.transform.rotate(new n(-90, 180, 0), !0, !1)
        }
        get width() {
            return this._width
        }
        get height() {
            return this._height
        }
        setRenderTarget(t) {
            let e = t.width,
            n = t.height;
            e && n ? (this.node = t, this.callLater(() => {
                    if (this.destroyed)
                        return;
                    this.rt = v.renderToTexture(t, e, n, 0, 0, this.rt),
                    this.meshRenderer.material.albedoTexture = this.rt.bitmap
                })) : console.error("setRenderTarget: target width or height is illegal !")
        }
        getRenderTexture() {
            return this.rt
        }
        getRenderTarget() {
            return this.node
        }
        getMaterial() {
            return this.meshRenderer.material
        }
        onDestroy() {
            this.rt && this.rt.destroy()
        }
    }
    class Xi extends Laya.MeshSprite3D {
        constructor(t, n, a, g, p = 0, f) {
            super(null, "MeshLine"),
            this.uv = new y(new e(0, 0), new e(1, 0), new e(0, 1), new e(1, 1)),
            this.verticles = new Array,
            this.bezier = t,
            this.width = g,
            this.length = a,
            this.start = n,
            this.end = n + a,
            this.align = p,
            this.color = f || u.WHITE
        }
        worldToLocal(t) {
            return 0 == this.align ? n.scale(t, .5, t) : 1 == this.align && t.from(n.ZERO),
            t
        }
        localToWorld(t) {
            return 0 == this.align ? n.scale(t,  - .5, t) : 1 == this.align ? t.from(n.ZERO) : n.scale(t, -1, t),
            t
        }
        init(t, a, u) {
            let g,
            p,
            f,
            m,
            y = new n;
            a ? (n.subtract(u, a, y), y = this.worldToLocal(y), g = new n, n.add(a, y, g)) : g = this.bezier.getPoint(0);
            let S = 4 * t - 2 * (t - 1),
            _ = 6 * t,
            A = Laya.VertexMesh.getVertexDeclaration("POSITION,NORMAL,COLOR,UV"),
            v = A.vertexStride / 4;
            this.vertexFloatStride = v;
            let w = new Float32Array(S * v),
            E = new Uint16Array(_),
            x = new n,
            C = new e,
            b = this.bezier.getLength(),
            R = this.length / b / t,
            k = this.start / b;
            for (let a = 0; a < t; a++) {
                let t = g.clone(),
                S = k + (a + 1) * R;
                f = this.bezier.getPoint(S),
                g.from(f),
                n.subtract(f, t, y),
                n.normalize(y, x),
                n.cross(x, n.Up, x),
                n.normalize(x, x),
                n.scale(x, this.width, y),
                x = this.localToWorld(y.clone()),
                n.add(t, x, t),
                n.add(f, x, f),
                m = new n,
                n.add(f, y, m),
                a > 0 ? (e.scale(this.uv.lt, a + 1, C), this.setVerticles(w, this.getVertexIdxBySliceIdx(a, 2), f, C, S), e.scale(this.uv.rt, a + 1, C), this.setVerticles(w, this.getVertexIdxBySliceIdx(a, 3), m, C, S)) : (u ? p = u : (p = new n, n.add(t, y, p)), this.setVerticles(w, this.getVertexIdxBySliceIdx(a, 0), t, this.uv.lb, 0), this.setVerticles(w, this.getVertexIdxBySliceIdx(a, 1), p, this.uv.rb, 0), this.setVerticles(w, this.getVertexIdxBySliceIdx(a, 2), f, this.uv.lt, S), this.setVerticles(w, this.getVertexIdxBySliceIdx(a, 3), m, this.uv.rt, S))
            }
            let B = 0;
            for (let e = 0; e < t; e++)
                E[B++] = 2 * (e + 1), E[B++] = 2 * e + 3, E[B++] = 2 * e, E[B++] = 2 * e, E[B++] = 2 * e + 3, E[B++] = 2 * e + 1;
            let V = Laya.PrimitiveMesh._createMesh(A, w, E);
            this.meshFilter.sharedMesh = V;
            let z = new Laya.UnlitMaterial;
            z.enableVertexColor = !0,
            this.meshRenderer.material = z
        }
        getMaterial() {
            return this.meshRenderer.material
        }
        setVertexColor(t, e) {
            t = Math.clamp(t, this.start, this.end),
            t /= this.bezier.getLength();
            let n = this.meshFilter.sharedMesh.getSubMesh(0),
            a = n._vertexBuffer.getFloat32Data(),
            u = !1;
            for (let n = this.getSliceIndex(t); n >= 0; n--) {
                let t = this.getVerticleIdxBySliceIdx(n, 2),
                g = this.verticles[t];
                if (g._shade)
                    break;
                g._shade = !0;
                for (let t = 0; t < 4; t++) {
                    let u = this.getVertexIdxBySliceIdx(n, t);
                    a[u + 6] = e.r,
                    a[u + 7] = e.g,
                    a[u + 8] = e.b,
                    a[u + 9] = e.a
                }
                u = !0
            }
            u && n._vertexBuffer.setData(a.buffer)
        }
        onDestroy() {
            this.verticles.length = 0,
            this.verticles = null,
            this.bezier = null
        }
        getSliceIndex(t) {
            let e = v.binarySearch(this.verticles, (function (e, n) {
                        let a;
                        return a = t > e._start && t <= n._start ? 0 : t <= e._start ? -1 : 1,
                        a
                    }), 2);
            return -1 == e && console.error("getSliceIndex not found ??? !!!"),
            Math.floor((e + 1) / 2) - 1
        }
        getVertexIdxBySliceIdx(t, e = 0) {
            return 2 * t * this.vertexFloatStride + e * this.vertexFloatStride
        }
        getVerticleIdxBySliceIdx(t, e = 0) {
            return 2 * t + e
        }
        setVerticles(t, e, n, a, u) {
            t[e++] = n.x,
            t[e++] = n.y,
            t[e++] = n.z,
            t[e++] = 0,
            t[e++] = 1,
            t[e++] = 0;
            let g = this.color;
            t[e++] = g.r,
            t[e++] = g.g,
            t[e++] = g.b,
            t[e++] = g.a,
            t[e++] = a.x,
            t[e++] = a.y;
            let p = n.clone();
            p._start = u,
            this.verticles.push(p)
        }
        getLeftBottomVert(t, e) {
            let a = t[e = this.getVertexIdxBySliceIdx(e)],
            u = t[e + 1],
            g = t[e + 2];
            return new n(a, u, g)
        }
        getInfoByPos(t, e) {
            let a = .1;
            null != e && e > 0 && (a = e),
            t = Math.clamp(t, this.start, this.end);
            let u,
            g = this.bezier.getLength(),
            p = this.bezier.getPoint(t / g),
            f = this.bezier.getPoint((t + a) / g),
            m = new n;
            n.subtract(f, p, m),
            null != e && (u = m.clone());
            let y = new n;
            n.normalize(m, y);
            let S = new n;
            n.cross(n.Up, y, S),
            n.normalize(S, S),
            n.cross(y, S, m),
            n.normalize(m, m);
            let _ = m.clone();
            n.cross(_, y, S),
            n.normalize(S, S);
            let A = new n;
            n.cross(y, _, A),
            n.normalize(A, A);
            let v = new n;
            return 1 == this.align ? n.scale(A, .5 * this.width, v) : 2 == this.align && n.scale(S, .5 * this.width, v),
            n.add(p, v, v), {
                center: v,
                n: y,
                v: u,
                nL: S,
                nR: A,
                up: _
            }
        }
        getTrailInfo() {
            let t = this.verticles[this.verticles.length - 2],
            e = this.verticles[this.verticles.length - 1];
            return {
                lb: t.clone(),
                rb: e.clone()
            }
        }
        getLength() {
            return this.length
        }
        getStart() {
            return this.start
        }
        getEnd() {
            return this.end
        }
        isEnd(t) {
            return t >= this.end
        }
        isHalf(t) {
            return t >= this.start + .5 * this.length
        }
    }
    class ji {
        constructor(t, e, a, u) {
            this.position = t,
            this.prevSegment = a,
            this.nextSegment = u,
            this.length = this.start = 0,
            this.up = n.Up.clone(),
            n.transformQuat(this.up, e, this.up),
            this.approximation = []
        }
        calcAccumulateSize(t, e) {
            let a = this.nextSegment.position,
            u = ji.sTempV[0];
            n.subtract(a, this.position, u);
            let g = n.scalarLength(u);
            return Math.floor(this.quadIn(t - 1, 0, e, 99) * g) + 1
        }
        quadIn(t, e, n, a) {
            return n * (t /= a) * t + e
        }
        init(t, e) {
            this.handleIn = new n,
            this.handleOut = new n;
            let a = ji.sTempV;
            a || (ji.sTempV = a = [new n, new n]);
            let u = this.nextSegment ? this.calcAccumulateSize(t, e) : 0;
            for (let t = 0; t < u; t++)
                this.approximation.push(new n);
            let g = this.position,
            p = a[0];
            this.nextSegment ? n.subtract(this.nextSegment.position, g, p) : p.toDefault();
            let f = a[1];
            this.prevSegment ? n.subtract(this.prevSegment.position, g, f) : f.toDefault(),
            this.setBezierHandles(ji.sAutoHandleDistance, f, p)
        }
        calcLength() {
            if (!this.nextSegment)
                return this.length;
            let t = this.approximation,
            [e, a, u, g, p, f, m, y, S, _, A, v] = ji.bezier(this.handleOut, this.position, this.nextSegment.position, this.nextSegment.handleIn),
            w = new n,
            E = 1 / t.length;
            t[0].from(this.position);
            for (let n = 1; n < t.length; n++) {
                let x = n * E;
                t[n].x = ((e * x + g) * x + m) * x + _,
                t[n].y = ((a * x + p) * x + y) * x + A,
                t[n].z = ((u * x + f) * x + S) * x + v,
                w.x = t[n].x - t[n - 1].x,
                w.y = t[n].y - t[n - 1].y,
                w.z = t[n].z - t[n - 1].z;
                let C = Math.sqrt(w.x * w.x + w.y * w.y + w.z * w.z);
                this.length += C
            }
            return this.length
        }
        setBezierHandles(t, e, a) {
            let u = n.scalarLength(e),
            g = n.scalarLength(a);
            if (0 != u || 0 != g) {
                let p = 0 == g ? 0 : u / g;
                n.scale(a, p, a),
                n.subtract(a, e, e),
                n.normalize(e, a);
                let f = a;
                n.scale(f, -u * t, this.handleIn),
                n.scale(f, g * t, this.handleOut)
            }
            n.add(this.handleIn, this.position, this.handleIn),
            n.add(this.handleOut, this.position, this.handleOut)
        }
        getLength() {
            return this.length
        }
        static bezier(t, e, n, a) {
            let u = -e.x + 3 * t.x + -3 * a.x + n.x,
            g = 3 * e.x + -6 * t.x + 3 * a.x,
            p = -3 * e.x + 3 * t.x,
            f = e.x,
            m = -e.y + 3 * t.y + -3 * a.y + n.y,
            y = 3 * e.y + -6 * t.y + 3 * a.y,
            S = -3 * e.y + 3 * t.y,
            _ = e.y;
            return [u, m, -e.z + 3 * t.z + -3 * a.z + n.z, g, y, 3 * e.z + -6 * t.z + 3 * a.z, p, S, -3 * e.z + 3 * t.z, f, _, e.z]
        }
        getPoint(t) {
            if (!this.nextSegment)
                return this.position.clone();
            let e = this.nextSegment,
            [a, u, g, p, f, m, y, S, _, A, v, w] = ji.bezier(this.handleOut, this.position, e.position, e.handleIn);
            return new n(((a * t + p) * t + y) * t + A, ((u * t + f) * t + S) * t + v, ((g * t + m) * t + _) * t + w)
        }
        getUp(t) {
            if (!this.nextSegment)
                return this.up.clone();
            let e = new n;
            return n.lerp(this.up, this.nextSegment.up, t, e),
            e.normalize(),
            e
        }
        getNearestPointF(t) {
            let e,
            a,
            u = 1 / 0,
            g = this.approximation,
            p = 1 / g.length,
            f = ji.sTempV[0];
            for (let p = 0; p < g.length; p++) {
                let m = g[p];
                n.subtract(t, m, f),
                e = n.scalarLengthSquared(f),
                e <= u && (u = e, a = p)
            }
            let m,
            y,
            S,
            _ = a > 0 ? a - 1 : -1,
            A = a < g.length - 1 ? a + 1 : -1,
            v = 1 / 0,
            w = 1 / 0;
            return _ > -1 && ([v, m] = this.linePointDistanceSq(g[_], g[a], t)),
            A > -1 && ([w, y] = this.linePointDistanceSq(g[a], g[A], t)),
            S = v < w ? (_ + m) * p : (a + y) * p,
            S
        }
        linePointDistanceSq(t, e, a) {
            let u = ji.sTempV,
            g = u[0];
            n.subtract(e, t, g);
            let p = u[1];
            n.subtract(a, t, p);
            let f,
            m,
            y = n.dot(p, g);
            if (y <= 0)
                return f = 0, n.subtract(a, t, g), m = n.scalarLengthSquared(g), [m, f];
            let S = n.dot(g, g);
            return S <= y ? (f = 1, n.subtract(a, e, g), m = n.scalarLengthSquared(g), [m, f]) : (f = y / S, n.scale(g, f, g), n.add(t, g, g), n.subtract(a, g, g), m = n.scalarLengthSquared(g), [m, f])
        }
    }
    class Qi {
        constructor() {
            this.releasePool = [],
            Laya.timer.frameLoop(1, this, this.update)
        }
        static get instance() {
            return this._instance || (this._instance = new Qi),
            this._instance
        }
        add(t, e = !0, n, a) {
            if (!t)
                return;
            let u = {
                node: t,
                delay: n,
                destroy: e,
                group: a
            };
            n && (u.addtime = Laya.Browser.now()),
            this.releasePool.push(u)
        }
        update() {
            let t = Laya.Browser.now();
            for (let e = this.releasePool.length - 1; e >= 0; e--) {
                let n = this.releasePool[e];
                n.delay ? t - n.addtime >= n.delay && this.release(n, e) : this.release(n, e)
            }
        }
        release(t, e) {
            t.destroy ? t.node.destroyed || t.node.destroy() : t.node.removeSelf(),
            this.releasePool.splice(e, 1)
        }
        releaseByGroup(t) {
            if (t)
                for (let e = this.releasePool.length - 1; e >= 0; e--) {
                    let n = this.releasePool[e];
                    n.group == t && this.release(n, e)
                }
        }
    }
    class Yi extends Laya.Script3D {
        constructor() {
            super()
        }
        onAwake() {
            let t = this.owner,
            e = t.getComponent(Laya.Animator),
            n = 0;
            for (; e.getControllerLayer(n); ) {
                let a = e.getControllerLayer(n)._statesMap,
                u = Laya.CallLater.I;
                for (const e in a) {
                    let g = a[e].clip._animationEvents;
                    if (g && g.length > 0)
                        for (const a of g) {
                            let g = {
                                eventName: a.eventName,
                                name: e,
                                owner: t,
                                layer: n
                            };
                            this[g.eventName] = u.callLater.bind(u, this, this.onAnimEvent, [g])
                        }
                }
                n++
            }
            this.ownerSp = t
        }
        setListener(t) {
            this.listener = t
        }
        onAnimEvent(t) {
            this.listener && !this.listener.destroyed ? this.listener.event(f.E_ANIM_EVENT, t) : E.instance.event(f.E_ANIM_EVENT, t)
        }
    }
    class $i extends Laya.AnimatorStateScript {
        constructor() {
            super(),
            this.name = "UnknownAnimState",
            this.layer = 0
        }
        setName(t) {
            this.name = t
        }
        setLayer(t) {
            this.layer = t || 0
        }
        setOwner(t) {
            this.owner = t
        }
        setListener(t) {
            this.listener = t
        }
        setDebug(t) {
            this.debug = t
        }
        setAllStateScripts(t) {
            this.allStateScripts = t
        }
        onStateEnter() {
            for (const t of this.allStateScripts)
                t.isPlaying && t.name != this.name && t.onStateAbort();
            this.isPlaying = !0,
            this.debug && console.log(`############ Animator: ${this.name} start...`);
            let e = {
                code: t.BaseCode.E_ANIM_START,
                name: this.name,
                owner: this.owner,
                layer: this.layer
            };
            this.listener && !this.listener.destroyed ? this.listener.event(f.E_ANIM_STATE_CHENGED, e) : E.instance.event(f.E_ANIM_STATE_CHENGED, e)
        }
        onStateAbort() {
            if (this.isPlaying) {
                this.isPlaying = !1,
                this.debug && console.log(`############ Animator: ${this.name} abort !`);
                let e = {
                    code: t.BaseCode.E_ANIM_ABORT,
                    name: this.name,
                    owner: this.owner,
                    layer: this.layer
                };
                this.listener && !this.listener.destroyed ? this.listener.event(f.E_ANIM_STATE_CHENGED, e) : E.instance.event(f.E_ANIM_STATE_CHENGED, e)
            }
        }
        onStateExit() {
            if (this.isPlaying) {
                this.isPlaying = !1,
                this.debug && console.log(`############ Animator: ${this.name} stopped !`);
                let e = {
                    code: t.BaseCode.E_ANIM_STOP,
                    name: this.name,
                    owner: this.owner,
                    layer: this.layer
                };
                this.listener && !this.listener.destroyed ? this.listener.event(f.E_ANIM_STATE_CHENGED, e) : E.instance.event(f.E_ANIM_STATE_CHENGED, e)
            }
        }
    }
    class Zi extends Laya.Script3D {
        constructor() {
            super(),
            this._tempVector3 = new Laya.Vector3,
            this.yawPitchRoll = new Laya.Vector3,
            this.resultRotation = new Laya.Quaternion,
            this.tempRotationZ = new Laya.Quaternion,
            this.tempRotationX = new Laya.Quaternion,
            this.tempRotationY = new Laya.Quaternion,
            this.rotaionSpeed = 6e-5,
            this.moveSpeed = .001
        }
        _updateRotation() {
            Math.abs(this.yawPitchRoll.y) < 1.5 && (Laya.Quaternion.createFromYawPitchRoll(this.yawPitchRoll.x, this.yawPitchRoll.y, this.yawPitchRoll.z, this.tempRotationZ), this.tempRotationZ.cloneTo(this.camera.transform.localRotation), this.camera.transform.localRotation = this.camera.transform.localRotation)
        }
        onAwake() {
            Laya.stage.on(Laya.Event.RIGHT_MOUSE_DOWN, this, this.mouseDown),
            Laya.stage.on(Laya.Event.RIGHT_MOUSE_UP, this, this.mouseUp),
            this.camera = this.owner
        }
        onUpdate() {
            var t = Laya.timer.delta;
            if (v.isNumber(this.lastMouseX) && v.isNumber(this.lastMouseY) && this.isMouseDown) {
                this.owner.scene;
                Laya.KeyBoardManager.hasKeyDown(87) && this.moveForward(-this.moveSpeed * t),
                Laya.KeyBoardManager.hasKeyDown(83) && this.moveForward(this.moveSpeed * t),
                Laya.KeyBoardManager.hasKeyDown(65) && this.moveRight(-this.moveSpeed * t),
                Laya.KeyBoardManager.hasKeyDown(68) && this.moveRight(this.moveSpeed * t),
                Laya.KeyBoardManager.hasKeyDown(81) && this.moveVertical(this.moveSpeed * t),
                Laya.KeyBoardManager.hasKeyDown(69) && this.moveVertical(-this.moveSpeed * t);
                var e = Laya.stage.mouseX - this.lastMouseX,
                n = Laya.stage.mouseY - this.lastMouseY,
                a = this.yawPitchRoll;
                a.x -= e * this.rotaionSpeed * t,
                a.y -= n * this.rotaionSpeed * t,
                this._updateRotation()
            }
            this.lastMouseX = Laya.stage.mouseX,
            this.lastMouseY = Laya.stage.mouseY
        }
        onDestroy() {
            Laya.stage.off(Laya.Event.RIGHT_MOUSE_DOWN, this, this.mouseDown),
            Laya.stage.off(Laya.Event.RIGHT_MOUSE_UP, this, this.mouseUp)
        }
        mouseDown(t) {
            this.camera.transform.localRotation.getYawPitchRoll(this.yawPitchRoll),
            this.lastMouseX = Laya.stage.mouseX,
            this.lastMouseY = Laya.stage.mouseY,
            this.isMouseDown = !0
        }
        mouseUp(t) {
            this.isMouseDown = !1
        }
        mouseOut(t) {
            this.isMouseDown = !1
        }
        moveForward(t) {
            this._tempVector3.x = this._tempVector3.y = 0,
            this._tempVector3.z = t,
            this.camera.transform.translate(this._tempVector3)
        }
        moveRight(t) {
            this._tempVector3.y = this._tempVector3.z = 0,
            this._tempVector3.x = t,
            this.camera.transform.translate(this._tempVector3)
        }
        moveVertical(t) {
            this._tempVector3.x = this._tempVector3.z = 0,
            this._tempVector3.y = t,
            this.camera.transform.translate(this._tempVector3, !1)
        }
        setMoveSpeed(t) {
            this.moveSpeed = t
        }
    }
    class ts extends Laya.Material {
        constructor() {
            super(),
            this.lock = !0,
            this.renderQueue = Laya.Material.RENDERQUEUE_TRANSPARENT,
            this._albedoColor = new a(1, 0, 0, 1),
            this.albedoColor = this._albedoColor,
            this.maxRadius = .5,
            this.minRadius = .3,
            this.progress = .5,
            this._shaderValues.setBool(ts.CANSAMPLE, !1),
            ts.initShader(this)
        }
        get albedoTexture() {
            return this._shaderValues.getTexture(ts.ALBEDOTEXTURE)
        }
        set albedoTexture(t) {
            this._shaderValues.setBool(ts.CANSAMPLE, !!t),
            this._shaderValues.setTexture(ts.ALBEDOTEXTURE, t)
        }
        get albedoColor() {
            return this._albedoColor
        }
        set albedoColor(t) {
            t.cloneTo(this._albedoColor),
            this._shaderValues.setVector(ts.COLOR, t)
        }
        get _ColorA() {
            return this._albedoColor.w
        }
        set _ColorA(t) {
            this._albedoColor.w = t,
            this.albedoColor = this._albedoColor
        }
        get maxRadius() {
            return this._shaderValues.getNumber(ts.MAXRADIUS)
        }
        set maxRadius(t) {
            t = Math.clamp(t, 0, .5),
            this._shaderValues.setNumber(ts.MAXRADIUS, t)
        }
        get minRadius() {
            return this._shaderValues.getNumber(ts.MINRADIUS)
        }
        set minRadius(t) {
            t = Math.clamp(t, 0, .5),
            this._shaderValues.setNumber(ts.MINRADIUS, t)
        }
        get progress() {
            return this._shaderValues.getNumber(ts.PROGRESS)
        }
        set progress(t) {
            t = Math.clamp(t, 0, 1),
            this._shaderValues.setNumber(ts.PROGRESS, t)
        }
        clone() {
            let t = new ts;
            return this.cloneTo(t),
            t
        }
        static initShader(t) {
            let e = {
                a_Position: Laya.VertexMesh.MESH_POSITION0,
                a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0
            },
            n = {
                u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
                u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
                u_AlbedoTexture: Laya.Shader3D.PERIOD_MATERIAL,
                u_Color: Laya.Shader3D.PERIOD_MATERIAL,
                u_MaxRadius: Laya.Shader3D.PERIOD_MATERIAL,
                u_MinRadius: Laya.Shader3D.PERIOD_MATERIAL,
                u_Value: Laya.Shader3D.PERIOD_MATERIAL,
                u_Sample: Laya.Shader3D.PERIOD_MATERIAL
            };
            t.lock = !1;
            let a = Laya.Shader3D.add("CircleProgress3D"),
            u = new Laya.SubShader(e, n);
            a.addSubShader(u);
            let g = u.addShaderPass('#include "Lighting.glsl";\nattribute vec4 a_Position;\nattribute vec2 a_Texcoord0;\nuniform mat4 u_MvpMatrix;\nuniform mat4 u_WorldMat;\nvarying vec2 v_Texcoord0;\nvoid main()\n{\n\tgl_Position = u_MvpMatrix * a_Position;\n\tgl_Position=remapGLPositionZ(gl_Position);\n\tv_Texcoord0 = a_Texcoord0;\n}', "#ifdef FSHIGHPRECISION\nprecision highp float;\n#else\nprecision mediump float;\n#endif\n\n#define PI 3.1415926538\n\nuniform vec4 u_Color;\nuniform float u_MaxRadius;\nuniform float u_MinRadius;\nuniform float u_Value;\nuniform bool u_Sample;\nuniform sampler2D u_AlbedoTexture;\n\nvarying vec2 v_Texcoord0;\n\nvoid main()\n{\n//将uv中心平移至旋转中心\nvec2 uv01 = vec2(v_Texcoord0.x, v_Texcoord0.y);\nuv01 = uv01 - vec2(0.5,0.5);\n// 斜率\nfloat radian = mod(atan(uv01.y, uv01.x) + 2.0 * PI, 2.0 * PI);\nfloat radianValue = u_Value * 2.0 * PI;\nif (radian > radianValue) discard;\n\nif (u_Sample) {\n\tvec4 color = texture2D(u_AlbedoTexture, v_Texcoord0);\n\tgl_FragColor = vec4(color.rgb, color.a * u_Color.a);\n} else {\n\t//环形剪裁\n\tfloat len = length(uv01) * 2.0;\n\tlen = (1.0-floor(len + (1.0-u_MaxRadius*2.0))) * floor(len + (1.0-u_MinRadius*2.0));\n\tif(len < 0.001) discard;    \n\tgl_FragColor = u_Color;\n}\n}");
            g.renderState.blend = Laya.RenderState.BLEND_ENABLE_ALL,
            g.renderState.srcBlend = Laya.RenderState.BLENDPARAM_SRC_ALPHA,
            g.renderState.dstBlend = Laya.RenderState.BLENDPARAM_ONE_MINUS_SRC_ALPHA,
            t.setShaderName("CircleProgress3D"),
            t.event(f.E_MATERIAL_LOADED)
        }
    }
    ts.ALBEDOTEXTURE = Laya.Shader3D.propertyNameToID("u_AlbedoTexture"),
    ts.COLOR = Laya.Shader3D.propertyNameToID("u_Color"),
    ts.MAXRADIUS = Laya.Shader3D.propertyNameToID("u_MaxRadius"),
    ts.MINRADIUS = Laya.Shader3D.propertyNameToID("u_MinRadius"),
    ts.PROGRESS = Laya.Shader3D.propertyNameToID("u_Value"),
    ts.CANSAMPLE = Laya.Shader3D.propertyNameToID("u_Sample");
    class es extends Laya.Script3D {
        constructor() {
            super(),
            this.collideInfos = [],
            this.temp = new n,
            this.lastPosition = new n,
            this.rotQ = new Laya.Quaternion,
            this.offset = new n,
            this.bodyPos = new n;
            let t = new n(1 / 0, 1 / 0, 1 / 0),
            e = new n(-1 / 0, -1 / 0, -1 / 0);
            this.boundBox = new Laya.BoundBox(t, e)
        }
        isStatic() {
            return this.option.static
        }
        setStatic() {
            this.body && (this.option.static = !0, this.body.setupMass(S.BODY_STATIC))
        }
        setDynamic() {
            this.body && (this.option.static = !1, this.body.setupMass(S.BODY_DYNAMIC))
        }
        setKinematic(t) {
            this.body.isKinematic = t
        }
        setTrigger(t) {
            this.option.trigger = t
        }
        isSyncShape() {
            return this.option.syncShape
        }
        setSyncShape(t, e = !1) {
            this.option.syncShape = t,
            this.option.syncEveryTime = e
        }
        canRotation() {
            return !this.body.controlRotInTime
        }
        setRotation(t) {
            this.body.controlRotInTime = !t
        }
        get collisionGroup() {
            return this.option.belongsTo
        }
        set collisionGroup(t) {
            this.option.belongsTo = t;
            for (let e = this.body.shapes; null !== e; e = e.next)
                e.belongsTo = t
        }
        get collidesWith() {
            return this.option.collidesWith
        }
        set collidesWith(t) {
            this.option.collidesWith = t;
            for (let e = this.body.shapes; null !== e; e = e.next)
                e.collidesWith = t
        }
        onAwake() {
            let t = this.obstacle = this.owner;
            this.lastPosition.from(t.transform.position),
            this.option ? this.initInternal(this.option) : this.enabled = !1
        }
        init(t) {
            (t = v.clone(t)).belongsTo = void 0 !== t.belongsTo ? t.belongsTo : 1,
            t.collidesWith = void 0 !== t.collidesWith ? t.collidesWith : 4294967295,
            t.move = !t.static,
            t.restitution = t.restitution || 0,
            t.friction = t.friction || .2,
            t.eventOnce && (this.colliders = []),
            t.density = t.density ? t.density : 1,
            this.option = t,
            this.obstacle && this.initInternal(this.option)
        }
        initInternal(t) {
            if (this.initialized)
                return;
            this.initialized = !0;
            let e = this.obstacle,
            a = e.transform.localScale;
            if (a.x < 0 || a.y < 0 || a.z < 0)
                return void console.warn(`模型 ${e.name} 缩放为负值，暂不支持该刚体!`);
            let u,
            g,
            p,
            f = t.shape,
            m = e.transform.position,
            y = e.transform.worldMatrix,
            S = this.rotQ;
            e.transform.rotation.invert(S);
            let _ = this.temp;
            n.TransformNormal(n.ONE, y, _),
            n.transformQuat(_, S, _),
            u = _.x,
            g = _.y,
            p = _.z;
            let A = e.transform.rotation;
            t.canScale && (t.scale = _.clone());
            let v = this.temp,
            w = new n(1 / 0, 1 / 0, 1 / 0),
            E = new n(-1 / 0, -1 / 0, -1 / 0);
            const anonymous = function (a, f, y, x, C) {
                let b,
                R,
                k,
                B;
                v.from(a.localOffset),
                v.x *= u,
                v.y *= g,
                v.z *= p;
                let V = new n;
                if (a instanceof Laya.SphereColliderShape) {
                    b = "sphere",
                    R = [v.x, v.y, v.z];
                    let e = a.radius * Math.max(u, g, p);
                    e = Math.max(e, 1e-4),
                    k = [e, e, e],
                    V.setValue(e, e, e),
                    t.useShapeLocalRotation && (B = [a.localRotation.x, a.localRotation.y, a.localRotation.z, a.localRotation.w])
                } else if (a instanceof Laya.BoxColliderShape)
                    b = "box", R = [v.x, v.y, v.z], k = [Math.max(a.sizeX * u, 1e-4), Math.max(a.sizeY * g, 1e-4), Math.max(a.sizeZ * p, 1e-4)], V.setValue(k[0], k[1], k[2]), t.useShapeLocalRotation && (B = [a.localRotation.x, a.localRotation.y, a.localRotation.z, a.localRotation.w]);
                else {
                    if (!(a instanceof Laya.CapsuleColliderShape))
                        throw Error("unsupported collider shape type !!!"); {
                        b = "cylinder",
                        R = [v.x, v.y, v.z];
                        let t = [];
                        1 == a.orientation ? (t[0] = Math.max(u, p), t[1] = g) : 0 == a.orientation ? (t[0] = Math.max(p, g), t[1] = u, n.transformQuat(n.UnitZ, e.transform.localRotation, _), Laya.Quaternion.createFromAxisAngle(_, Math.rad(90), S), B = [S.x, S.y, S.z, S.w]) : (t[0] = Math.max(u, g), t[1] = p, n.transformQuat(n.UnitX, e.transform.localRotation, _), Laya.Quaternion.createFromAxisAngle(_, Math.rad(90), S), B = [S.x, S.y, S.z, S.w]);
                        let f = Math.max(a.radius * t[0], 1e-4);
                        k = [f, Math.max(a.length * t[1] - 2 * f, 1e-4), 0],
                        V.setValue(k[0], k[1], k[0])
                    }
                }
                f ? (f.push(b), x.push(...R), B && C.push(...B), y.push(...k)) : (t.type = b, t.posShape = R, t.rotShape = B, t.size = k, t.pos = [m.x, m.y, m.z], t.rot = [A.x, A.y, A.z, A.w]);
                let z = new Laya.BoundBox(w, E);
                return n.scale(V, .5, V),
                z.setCenterAndExtent(v, V),
                z
            };
            if (f instanceof Laya.CompoundColliderShape) {
                let e = f.getChildShapes();
                if (e.length > 0) {
                    t.type = [],
                    t.size = [],
                    t.posShape = [],
                    t.rotShape = [];
                    for (const n of e) {
                        let e = anonymous(n, t.type, t.size, t.posShape, t.rotShape);
                        Laya.BoundBox.merge(this.boundBox, e, this.boundBox)
                    }
                    t.pos = [m.x, m.y, m.z],
                    t.rot = [A.x, A.y, A.z, A.w]
                }
            } else {
                let t = anonymous(f);
                Laya.BoundBox.merge(this.boundBox, t, this.boundBox)
            }
        }
        createBounds(t, e = Laya.Color.GREEN, n) {
            let a = this.temp,
            u = t.width,
            g = t.depth,
            p = t.height;
            t.radius && (u = g = 2 * t.radius, p || (p = u));
            let f = [u, p, g],
            m = this.option.shape;
            m.orientation && (0 == m.orientation ? [f[0], f[1]] = [f[1], f[0]] : 2 == m.orientation && ([f[1], f[2]] = [f[2], f[1]]));
            let y = new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(f[0], f[1], f[2])),
            S = v.linearModel(y, 50, e);
            return a.from(t.relativePosition),
            S.transform.localPosition = a,
            t.localRotation && (S.transform.localRotation = new Laya.Quaternion(t.localRotation.x, t.localRotation.y, t.localRotation.z, t.localRotation.w)),
            n.addChild(S),
            S
        }
        onEnable() {
            this.initBody()
        }
        initBody() {
            let t = S.World.instance,
            e = this.obstacle;
            if (this.clearColliders(), !this.body) {
                let n = this.option,
                a = t.add(n);
                this.body = a,
                v.isNumber(n.mass) && this.setMass(n.mass, !0),
                !1 === n.canRotation && this.setRotation(!1),
                this.calcOffset(),
                this.body.owner = e,
                n.event && (this.body.event_cb = this.onCollisionEx.bind(this)),
                this.showDebugBounds()
            }
            let n = this.body;
            n && !n.parent && (this.syncToBody(), t.addRigidBody(n))
        }
        calcOffset() {
            let t = this.bodyPos;
            if (t.from(this.body.position), n.subtract(t, this.obstacle.transform.position, this.offset), n.scalarLengthSquared(this.offset) > 0) {
                let t = this.body.getQuaternion(),
                e = this.rotQ;
                e.from(t),
                e.invert(e),
                n.transformQuat(this.offset, e, this.offset)
            }
        }
        onDisable() {
            this.removeBody()
        }
        removeBody() {
            if (this.body && this.body.parent) {
                S.World.instance.removeRigidBody(this.body)
            }
        }
        onDestroy() {
            if (this.onDisable(), this.clearColliders(), this.debugBounds) {
                let t = this.debugBounds;
                t.callLater(() => {
                    t.destroy()
                }),
                this.debugBounds = null
            }
        }
        isCollideWith(t) {
            return -1 != this.colliders.indexOf(t)
        }
        onCollisionEx(t, e, n, a) {
            if (t instanceof Array) {
                let e = t,
                n = this.collideInfos.length;
                for (; n--; ) {
                    let t = this.collideInfos[n];
                    t.other.destroyed ? this.collideInfos.splice(n, 1) : e.includes(t.rawInfo) || (this.obstacle.event(f.E_PHYSICS_COLLISION_EXIT, t), this.collideInfos.splice(n, 1))
                }
                return
            }
            let u = t.owner;
            if (this.destroyed || u.destroyed)
                return;
            let g = u.getComponent(es);
            if ((this.option.trigger || g && g.option.trigger) && (n.touching = !1), this.colliders) {
                if (this.isCollideWith(u))
                    return;
                this.colliders.push(u),
                u.on(Laya.Event.REMOVED, this, this.removeCollider, [u]),
                u.on(Laya.Event.ACTIVED, this, this.removeCollider, [u])
            }
            let p = new _;
            p.other = u;
            let m = n.manifold.points[0];
            p.distance = Math.abs(m.penetration),
            p.normal = m.normal,
            p.contact = m.position,
            p.mine = this.obstacle,
            (e.name || a.name) && (p.shapesName = {
                    other: e.name,
                    mine: a.name
                }),
            p.rawInfo = n,
            this.obstacle.hasListener(f.E_PHYSICS_COLLISION_EXIT) && (this.collideInfos.find(t => t.rawInfo == n) || this.collideInfos.push(p)),
            this.obstacle.event(f.E_PHYSICS_COLLISION, p)
        }
        removeCollider(t) {
            let e = this.colliders;
            if (e && e.length > 0) {
                let n = e.indexOf(t);
                -1 != n && e.splice(n, 1)
            }
            t.off(Laya.Event.REMOVED, this, this.removeCollider),
            t.off(Laya.Event.ACTIVED, this, this.removeCollider)
        }
        clearColliders() {
            if (this.colliders) {
                let t = this.colliders.length;
                for (; t--; ) {
                    let e = this.colliders[t];
                    this.removeCollider(e)
                }
                this.colliders.clear()
            }
        }
        _syncToBody(t) {
            let e = this.obstacle,
            a = this.body,
            u = this.option;
            if (u.canScale) {
                let t = e.parent;
                t instanceof Laya.Sprite3D && t.transform.getWorldLossyScale();
                let a = e.transform.getWorldLossyScale();
                if (!n.equals(a, u.scale)) {
                    this.removeBody(),
                    this.initialized = !1,
                    this.initInternal(this.option);
                    let t = this.body;
                    this.body = null,
                    this.initBody(),
                    this.syncBodyProps(t)
                }
            }
            if (!u.syncOnlyRot) {
                let t = e.transform.position,
                u = this.bodyPos;
                if (u.from(t), n.scalarLengthSquared(this.offset) > 0) {
                    let a = this.temp;
                    n.transformQuat(this.offset, e.transform.rotation, a),
                    n.add(t, a, u)
                }
                a.setPosition(u),
                this.lastPosition.from(t)
            }
            u.syncOnlyPos || a.setQuaternion(e.transform.rotation),
            (u.static || t) && a.updatePosition(0)
        }
        syncToBody(t, e) {
            this.option.syncOnlyRot = t,
            this.option.syncOnlyPos = e,
            this._syncToBody(!0)
        }
        syncBodyProps(t) {
            let e = this.body;
            e.name = t.name,
            e.linearVelocity.copy(t.linearVelocity),
            e.angularVelocity.copy(t.angularVelocity),
            e.linearSpeed = t.linearSpeed,
            e.linearVelocityConstraint = t.linearVelocityConstraint,
            e.angularVelocityConstraint = t.angularVelocityConstraint,
            e.linearVelocityMax = t.linearVelocityMax,
            e.angularVelocityMax = t.angularVelocityMax,
            e.positionConstraint = t.positionConstraint,
            e.angularConstraint = t.angularConstraint,
            e.overrideGravity = t.overrideGravity
        }
        onUpdate() {
            let t = this.body,
            e = this.option,
            a = this.obstacle,
            u = t.getPosition(),
            g = this.bodyPos;
            g.from(u);
            let p = this.rotQ;
            if (p.from(t.getQuaternion()), this.debugBounds && this.debugBounds.active && (this.debugBounds.transform.position = g, this.debugBounds.transform.rotation = p), e.syncShape) {
                let t = a.transform.position;
                !e.syncEveryTime && n.equals(t, this.lastPosition) || this._syncToBody()
            } else {
                let t = this.temp;
                t.from(u),
                n.scalarLengthSquared(this.offset) > 0 && (n.transformQuat(this.offset, p, t), n.subtract(g, t, t)),
                a.transform.position = t,
                a.transform.rotation = p,
                this.lastPosition.from(t)
            }
        }
        getPhysicsBody() {
            return this.body
        }
        getSize(t) {
            return this.boundBox.getExtent(t),
            n.scale(t, 2, t),
            t
        }
        isContactWith(t) {
            for (let e = this.getPhysicsBody().shapes; e; e = e.next)
                for (let n = e.contactLink; null !== n; n = n.next)
                    if (0 != (n.shape.belongsTo & t) && n.contact.manifold.numPoints > 0)
                        return !0;
            return !1
        }
        isContactByName(t) {
            return this.getPhysicsBody().checkContact(t)
        }
        wakeUp() {
            this.body.sleeping && this.body.awake()
        }
        sleep() {
            this.body.sleep()
        }
        getBodyName() {
            return this.body.name
        }
        getCurBodyScale() {
            let t = new n,
            e = this.rotQ,
            a = this.obstacle.transform;
            return a.rotation.invert(e),
            n.TransformNormal(n.ONE, a.worldMatrix, t),
            n.transformQuat(t, e, t),
            t
        }
        getMass() {
            return this.body.mass
        }
        getInvMass() {
            return this.body.inverseMass
        }
        setMass(t, e) {
            this.isStatic() || (this.option.mass = t, this.body.setMass(t), e && this.body.setupMass(this.body.type))
        }
        showDebugBounds() {
            if (!this.option.debug)
                return;
            if (this.debugBounds) {
                this.debugBounds.destroy(),
                this.debugBounds = null
            }
            let t = this.bodyPos;
            t.from(this.body.position),
            this.option.debug = !0;
            let e = this.body.shapes,
            n = new Laya.Sprite3D("debugBounds");
            n.transform.position = t;
            let a = this.rotQ;
            a.from(this.body.getQuaternion()),
            n.transform.rotation = a,
            this.debugBounds = n,
            this.owner.scene.addChild(n);
            for (let t = e; null !== t; t = t.next)
                this.createBounds(t, this.option.color, n);
            let u = S.World;
            this.debugBounds.active = u.showDebugBounds || null == u.showDebugBounds
        }
        setFriction(t) {
            for (let e = this.body.shapes; e; e = e.next)
                e.friction = t
        }
        setLinearVelocityConstraint(t) {
            this.body.linearVelocityConstraint = t
        }
        setLinearVelocityMax(t) {
            this.body.linearVelocityMax = t
        }
        setAngularVelocityConstraint(t) {
            this.body.angularVelocityConstraint = t
        }
        setAngularVelocityMax(t) {
            this.body.angularVelocityMax = t
        }
        setGravity(t) {
            this.body.overrideGravity = t
        }
    }
    class is extends Laya.Material {
        constructor() {
            super(),
            is.initShader(),
            this.setShaderName("OutlineMaterial"),
            this._shaderValues.setNumber(is.OUTLINEWIDTH, .00621197),
            this._shaderValues.setNumber(is.OUTLINELIGHTNESS, 1),
            this._shaderValues.setVector(is.OUTLINECOLOR, new Laya.Vector4(1, 1, 1, 0)),
            this._shaderValues.setBool(is.DISABLEOUTLINE, !1)
        }
        static __init__() {}
        get albedoTexture() {
            return this._shaderValues.getTexture(is.ALBEDOTEXTURE)
        }
        set albedoTexture(t) {
            this._shaderValues.setTexture(is.ALBEDOTEXTURE, t)
        }
        get outlineColor() {
            return this._shaderValues.getVector(is.OUTLINECOLOR)
        }
        set outlineColor(t) {
            this._shaderValues.setVector(is.OUTLINECOLOR, t)
        }
        get outlineWidth() {
            return this._shaderValues.getNumber(is.OUTLINEWIDTH)
        }
        set outlineWidth(t) {
            t = Math.max(0, Math.min(.05, t)),
            this._shaderValues.setNumber(is.OUTLINEWIDTH, t)
        }
        get outlineLightness() {
            return this._shaderValues.getNumber(is.OUTLINELIGHTNESS)
        }
        set outlineLightness(t) {
            t = Math.max(0, Math.min(1, t)),
            this._shaderValues.setNumber(is.OUTLINELIGHTNESS, t)
        }
        set disableOutline(t) {
            this._shaderValues.setBool(is.DISABLEOUTLINE, t)
        }
        clone() {
            var t = new is;
            return this.cloneTo(t),
            t
        }
        static initShader() {
            if (is.inited)
                return;
            is.inited = !0,
            is.__init__();
            var t = {
                a_Position: Laya.VertexMesh.MESH_POSITION0,
                a_Normal: Laya.VertexMesh.MESH_NORMAL0,
                a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0
            },
            e = {
                u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
                u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
                u_OutlineWidth: Laya.Shader3D.PERIOD_MATERIAL,
                u_OutlineColor: Laya.Shader3D.PERIOD_MATERIAL,
                u_OutlineLightness: Laya.Shader3D.PERIOD_MATERIAL,
                u_AlbedoTexture: Laya.Shader3D.PERIOD_MATERIAL,
                u_DisableOutline: Laya.Shader3D.PERIOD_MATERIAL
            },
            n = Laya.Shader3D.add("OutlineMaterial"),
            a = new Laya.SubShader(t, e);
            n.addSubShader(a);
            a.addShaderPass('\n        #include "Lighting.glsl"\n        attribute vec4 a_Position;\n        attribute vec3 a_Normal;\n        \n        uniform mat4 u_MvpMatrix; \n        uniform float u_OutlineWidth;\n        \n        void main() \n        {\n            float w = u_OutlineWidth;\n            w = w * a_Position.z / 0.0955;\n            vec4 position = vec4(a_Position.xyz + a_Normal * w, 1.0);\n            gl_Position = u_MvpMatrix * position;\n            gl_Position=remapGLPositionZ(gl_Position);\n        }', "\n        #ifdef FSHIGHPRECISION\n            precision highp float;\n        #else\n           precision mediump float;\n        #endif\n        uniform vec4 u_OutlineColor; \n        uniform float u_OutlineLightness;\n        uniform bool u_DisableOutline;\n    \n        void main()\n        {\n            if (u_DisableOutline) {\n                discard;\n            }\n           vec3 finalColor = u_OutlineColor.rgb * u_OutlineLightness;\n           gl_FragColor = vec4(finalColor,0.0); \n        }").renderState.cull = Laya.RenderState.CULL_FRONT;
            a.addShaderPass('\n        #include "Lighting.glsl"\n\n        attribute vec4 a_Position; \n        attribute vec2 a_Texcoord0;\n        \n        uniform mat4 u_MvpMatrix;\n        uniform mat4 u_WorldMat;\n\n        attribute vec3 a_Normal; \n        varying vec3 v_Normal; \n        varying vec2 v_Texcoord0; \n        \n        void main() \n        {\n           gl_Position = u_MvpMatrix * a_Position;\n           mat3 worldMat=mat3(u_WorldMat); \n           v_Normal=worldMat*a_Normal; \n           v_Texcoord0 = a_Texcoord0;\n           gl_Position=remapGLPositionZ(gl_Position); \n        }', "\n        #ifdef FSHIGHPRECISION\n            precision highp float;\n        #else\n            precision mediump float;\n        #endif\n        varying vec2 v_Texcoord0;\n        varying vec3 v_Normal;\n        \n        uniform sampler2D u_AlbedoTexture;\n\n        void main()\n        {\n            vec4 albedoTextureColor = vec4(1.0);\n            albedoTextureColor = texture2D(u_AlbedoTexture, v_Texcoord0);\n            gl_FragColor=albedoTextureColor;\n        }")
        }
    }
    is.ALBEDOTEXTURE = Laya.Shader3D.propertyNameToID("u_AlbedoTexture"),
    is.OUTLINECOLOR = Laya.Shader3D.propertyNameToID("u_OutlineColor"),
    is.OUTLINEWIDTH = Laya.Shader3D.propertyNameToID("u_OutlineWidth"),
    is.OUTLINELIGHTNESS = Laya.Shader3D.propertyNameToID("u_OutlineLightness"),
    is.DISABLEOUTLINE = Laya.Shader3D.propertyNameToID("u_DisableOutline");
    class ss {
        static locateSprite3D(t, e, a = n.ZERO) {
            let u = this.sN,
            g = this.sT,
            p = this.sRotMatY,
            f = this.sRotMatX;
            Laya.Matrix4x4.createLookAt(e.n, n.ZERO, e.up, f),
            f.setPosition(n.ZERO),
            f.invert(p),
            n.transformV3ToV3(a, p, u),
            n.add(e.center, u, g);
            let m = t,
            y = m.__origXfm;
            y || (y = t.transform.worldMatrix.clone(), y.setPosition(n.ZERO), m.__origXfm = y),
            Laya.Matrix4x4.multiply(p, y, f),
            t.transform.worldMatrix = f,
            t.transform.translate(g, !1)
        }
        static randomDirInCone(t, e) {
            let a = this.sN,
            u = a,
            g = Math.sin(Math.rad(e)),
            p = Math.cos(Math.rad(e));
            Laya.ShapeUtils._randomPointInsideUnitCircle(u),
            a.x = u.x * g,
            a.z = u.y * g,
            a.y = p,
            n.normalize(a, a);
            let f = t.clone();
            n.normalize(f, f);
            let m = v.getDotRadian(n.Up, f);
            n.cross(n.Up, f, f),
            n.normalize(f, f);
            let y = this.sRotMatY;
            return Laya.Matrix4x4.createRotationAxis(f, m, y),
            n.TransformNormal(a, y, f),
            f
        }
        static createPlane(t, e, n) {
            let a = Laya.PrimitiveMesh.createPlane(t, e, 1, 1),
            u = new Laya.MeshSprite3D(a);
            return u.meshRenderer.material = n || new Laya.UnlitMaterial,
            u
        }
        static genBpMaterial(t, e, n, a, u) {
            let g = new Laya.BlinnPhongMaterial;
            function anonymous(p) {
                if (!p || g.destroyed)
                    return;
                let m = p.bitmap;
                if (m ? (g.albedoTexture = m, Laya.loader.clearRes(t)) : (m = p, g.albedoTexture = m), null != e && (g.renderMode = e), null != n && (m.wrapModeU = n), null != a && (m.wrapModeV = a), u) {
                    g._addReference()
                } else
                    g.lock = !1;
                g.event(f.E_MATERIAL_LOADED)
            }
            g.lock = !0;
            let p = Laya.loader.getRes(t);
            return p ? anonymous(p) : Laya.loader.load(t, Laya.Handler.create(this, anonymous)),
            g
        }
        static genUnlitMaterial(t, e, n, a, u) {
            let g = new Laya.UnlitMaterial;
            function anonymous(p) {
                if (!p || g.destroyed)
                    return;
                let m = p.bitmap;
                if (m ? (g.albedoTexture = m, Laya.loader.clearRes(t)) : (m = p, g.albedoTexture = m), null != e && (g.renderMode = e), null != n && (m.wrapModeU = n), null != a && (m.wrapModeV = a), u) {
                    g._addReference()
                } else
                    g.lock = !1;
                g.event(f.E_MATERIAL_LOADED)
            }
            g.lock = !0;
            let p = Laya.loader.getRes(t);
            return p ? anonymous(p) : Laya.loader.load(t, Laya.Handler.create(this, anonymous)),
            g
        }
        static effFadeInOut(t, e, n, a = 1, u = 0, g) {
            t instanceof Laya.MeshSprite3D && this.effFadeInOutMesh(t, e, n, a, u, g);
            let p = t.getChildren();
            for (const t of p)
                this.effFadeInOut(t, e, n, a, u, g)
        }
        static effFadeInOutMesh(t, e, n, a = 1, u = 0, g) {
            let p,
            f = t;
            f.__fade_in_out_eff ? (p = f.__fade_in_out_eff.material, Laya.Tween.clear(f.__fade_in_out_eff.tween)) : (p = t.meshRenderer.material, f.__fade_in_out_eff = {
                    alpha: p._ColorA
                });
            let anifunc = function () {
                f.__fade_in_out_eff.tween = Laya.Tween.to(p, {
                    _ColorA: u
                }, e >> 1, null, Laya.Handler.create(this, () => {
                            f.__fade_in_out_eff.tween = Laya.Tween.to(p, {
                                _ColorA: a
                            }, e >> 1, null, Laya.Handler.create(this, () => {
                                        n ? anifunc() : (ss.stopFadeInOutEffMesh(t), g && g.run())
                                    }))
                        }))
            };
            anifunc(),
            t.once(Laya.Event.REMOVED, this, this.stopFadeInOutEff, [t])
        }
        static stopFadeInOutEff(t) {
            t instanceof Laya.MeshSprite3D && this.stopFadeInOutEffMesh(t);
            let e = t.getChildren();
            for (const t of e)
                this.stopFadeInOutEff(t)
        }
        static stopFadeInOutEffMesh(t) {
            let e = t;
            if (e.__fade_in_out_eff) {
                t.meshRenderer.material._ColorA = e.__fade_in_out_eff.alpha,
                Laya.Tween.clear(e.__fade_in_out_eff.tween),
                e.__fade_in_out_eff = null,
                t.off(Laya.Event.REMOVED, this, this.stopFadeInOutEff)
            }
        }
        static asyncProcess(t, e, n = 30) {
            const clearFunc = () => {
                Laya.timer.clear(this, loopFunc),
                t.off(Laya.Event.REMOVED, this, clearFunc)
            },
            loopFunc = () => {
                Laya.stage.getTimeFromFrameStart() > n || e.run() && clearFunc()
            };
            Laya.timer.frameLoop(1, this, loopFunc),
            t.once(Laya.Event.REMOVED, this, clearFunc)
        }
        static enableShadow(t, e = !1) {
            v.recurisNode(t, t => {
                let n = v.getSpRenderer(t);
                n && (n.castShadow = !0, n.receiveShadow = e)
            })
        }
        static receiveShadow(t, e = !0) {
            v.recurisNode(t, t => {
                let n = v.getSpRenderer(t);
                n && (n.receiveShadow = e)
            })
        }
        static setMaterial(t, e, n) {
            let a = v.getSpRenderer(t);
            n ? a.sharedMaterial = e : a.material = e;
            let u = t.getChildren();
            for (const t of u)
                this.setMaterial(t, e, n)
        }
        static createShadow(t, e, n) {
            if (!t)
                return;
            let a = this.genUnlitMaterial(t, 2);
            return this.createPlane(e, n, a)
        }
        static gradientColorAnim(t, e, n, a = !0, u = !1, g) {
            let p = t;
            if (p.__color_anim || 0 == e.length)
                return;
            p.__color_anim = {
                tween: null
            },
            n /= e.length;
            let f = v.getSpMaterial(t, u);
            (e = v.cloneArray(e)).unshift(f.albedoColor);
            let m = e[0].clone();
            const y = new Laya.Handler(this, (function () {
                        f.albedoColor = m
                    }));
            let S = 1;
            const anonymous = function () {
                let u = e[S];
                p.__color_anim.tween = Laya.Tween.to(m, {
                    x: u.x,
                    y: u.y,
                    z: u.z,
                    update: y
                }, n, null, Laya.Handler.create(this, () => {
                            S++,
                            S == e.length ? a ? (S = 0, anonymous()) : (ss.stopColorAnim(t), g && g.run()) : anonymous()
                        }))
            };
            t.once(Laya.Event.REMOVED, this, this.stopColorAnim, [t]),
            anonymous()
        }
        static stopColorAnim(t) {
            let e = t;
            e.__color_anim && (t.off(Laya.Event.REMOVED, this, this.stopColorAnim), Laya.Tween.clear(e.__color_anim.tween), e.__color_anim = null)
        }
        static faceTo(t, e, a = n.UnitZ, u, g) {
            let p = this.sT,
            f = this.sN;
            p.from(e.transform.position),
            n.subtract(t, p, f),
            n.normalize(f, f),
            this.faceWith(f.clone(), e, a, u, g)
        }
        static faceWith(t, e, a = n.UnitZ, u, g) {
            let p = this.sT;
            if (this.sN.from(t), t = this.sN, u && (-1 != u.indexOf("x") && (t.x = 0), -1 != u.indexOf("y") && (t.y = 0), -1 != u.indexOf("z") && (t.z = 0)), t.isZero())
                return;
            n.normalize(t, t),
            p.from(a),
            a = p;
            let f = this.sRotQ,
            m = e.transform.position,
            y = e.transform.rotation,
            S = n.UnitZ;
            g && (y = e.transform.localRotation, m = e.transform.localPosition, e.parent.transform.rotation.invert(f), n.transformQuat(t, f, t), n.transformQuat(a, f, a), S = S.clone(), n.transformQuat(S, f, S));
            let _ = e;
            _.__facewith_rotation || (_.__facewith_rotation = y.clone());
            let A = v.getDotRadian(a, S);
            if (0 == A)
                f.identity();
            else {
                let t = p;
                n.cross(a, S, t),
                t.isZero() ? t = n.Up : t.normalize(),
                Laya.Quaternion.createFromAxisAngle(t, A, f)
            }
            n.transformQuat(t, f, t),
            n.subtract(m, t, p),
            Laya.Quaternion.lookAt(m, p, n.Up, f),
            f.invert(f),
            Laya.Quaternion.multiply(f, _.__facewith_rotation, f),
            g ? e.transform.localRotation = f : e.transform.rotation = f
        }
        static addAnimatorScript(t, e, n, a = 0, u) {
            let g = t.getComponent(Laya.Animator);
            for (const p of g._controllerLayers) {
                let g = p._statesMap,
                f = [];
                for (const p in g) {
                    let m = g[p],
                    y = m.getScript($i);
                    y || (y = m.addScript($i)),
                    f.push(y),
                    y.setName(m.name),
                    y.setLayer(a),
                    y.setOwner(t),
                    y.setDebug(u),
                    y.setAllStateScripts(f),
                    e && n && y.setListener(e)
                }
            }
            e && n && e.on(f.E_ANIM_STATE_CHENGED, n.caller, n.method, n.args)
        }
        static addAnimatorEventScript(t, e, n) {
            let a = t.getComponent(Yi);
            a || (a = t.addComponent(Yi)),
            a.setListener(e),
            e && n && e.on(f.E_ANIM_EVENT, n.caller, n.method)
        }
        static effSplash(t, e, n) {
            let a = t;
            if (a.__splash_eff)
                return;
            let u = .001 * e,
            g = 0,
            updateFunc = function () {
                g += v.getFrameDelta(),
                g > u && (t.meshRenderer.enable = !t.meshRenderer.enable, g = 0)
            };
            t.frameLoop(1, this, updateFunc),
            a.__splash_eff = updateFunc,
            t.once(Laya.Event.REMOVED, this, this.stopSplashEff, [t])
        }
        static stopSplashEff(t) {
            let e = t;
            e.__splash_eff && (t.meshRenderer.enable = !0, t.clearTimer(this, e.__splash_eff), e.__splash_eff = null, t.off(Laya.Event.REMOVED, this, this.stopSplashEff))
        }
        static destroyBySign(t, e) {
            let n = Laya.Pool._poolDic;
            if (e) {
                for (const e in n)
                    if (-1 != e.indexOf(t)) {
                        let t = n[e];
                        for (const e of t)
                            e.destroy();
                        t.clear(),
                        delete n[e]
                    }
                return
            }
            let a = Laya.Pool.getPoolBySign(t);
            for (const t of a)
                t.destroy();
            a.clear(),
            delete n[t]
        }
        static checkPoolBySign(t) {
            return Laya.Pool._poolDic[t]
        }
        static moveAnim(t, e, n, a, u = 0, g = !0, p, f) {
            let m = t;
            if (!m || m.__move_anim)
                return;
            e = e.clone(),
            n = n.clone(),
            a *= 1e3,
            u *= 1e3;
            let y = e.clone();
            p ? t.transform.localPosition = y : t.transform.position = y;
            let S = new Laya.Handler(this, (function () {
                        p ? t.transform.localPosition = y : t.transform.position = y
                    })),
            exec = function (u, p) {
                let _ = (u = !u) ? e : n;
                m.__move_anim = Laya.Tween.to(y, {
                    x: _.x,
                    y: _.y,
                    z: _.z,
                    update: S
                }, a, null, Laya.Handler.create(this, (function () {
                                g ? exec(u, 0) : (ss.stopMoveAnim(t), f && f.run())
                            })), p)
            };
            exec(!0, u),
            t.once(Laya.Event.REMOVED, this, this.stopMoveAnim, [t])
        }
        static stopMoveAnim(t) {
            let e = t,
            n = e.__move_anim;
            n && (Laya.Tween.clear(n), t.off(Laya.Event.REMOVED, this, this.stopMoveAnim), e.__move_anim = null)
        }
        static jumpAnim(t, e, a, u, g, p = 0, f = !0, m = !0, y) {
            let S = t;
            if (!S || S.__jump_anim)
                return;
            e = e.clone(),
            a = a.clone();
            let _ = [],
            A = new n,
            w = this.sN,
            E = this.sT;
            n.subtract(a, e, E);
            let x = .5 * n.scalarLength(E);
            E.normalize(),
            n.cross(E, n.Up, w),
            w.normalize(),
            n.cross(w, E, w),
            w.normalize(u),
            E.normalize(x),
            n.add(e, E, E),
            n.add(E, w, A),
            _.push(e, A, a),
            g *= 1e3,
            p *= 1e3;
            let C = {
                t: 0
            };
            m ? t.transform.localPosition = e : t.transform.position = e;
            let b = new Laya.Handler(this, (function () {
                        let e = v.calcBezierPointEx(C.t, _);
                        m ? t.transform.localPosition = e : t.transform.position = e
                    })),
            exec = function (e, n) {
                let a = (e = !e) ? 0 : 1;
                S.__jump_anim = Laya.Tween.to(C, {
                    t: a,
                    update: b
                }, g, null, Laya.Handler.create(this, (function () {
                                f ? exec(e, 0) : (ss.stopJumpAnim(t), y && y.run())
                            })), n)
            };
            exec(!0, p),
            t.once(Laya.Event.REMOVED, this, this.stopJumpAnim, [t])
        }
        static stopJumpAnim(t) {
            let e = t,
            n = e.__jump_anim;
            n && (Laya.Tween.clear(n), t.off(Laya.Event.REMOVED, this, this.stopJumpAnim), e.__jump_anim = null)
        }
        static moveFollow(t, e, a, u, g, p, f) {
            let m = t;
            if (!m || m.__move_follow_anim)
                return;
            a = a || .1,
            u = u || .1;
            let y = this.sT,
            updateFunc = function () {
                if (t.destroyed || e.destroyed)
                    return void ss.stopFollowAnim(t, e, !1);
                let m = t.transform.position,
                S = e.transform.position;
                if (p && (n.add(S, p, y), S = y), n.subtract(S, m, y), n.scalarLengthSquared(y) < u)
                    this.stopFollowAnim(t, e, f), g && g.run();
                else {
                    let e = Math.min(a, n.scalarLength(y));
                    y.normalize(e),
                    n.add(m, y, y),
                    t.transform.position = y
                }
            };
            t.frameLoop(1, this, updateFunc),
            m.__move_follow_anim = updateFunc,
            t.once(Laya.Event.REMOVED, this, this.stopFollowAnim, [t, e, f]);
            let S = e;
            S.__move_follow_anim ? S.__move_follow_anim.push(t) : S.__move_follow_anim = [t],
            e.once(Laya.Event.REMOVED, this, this.stopFollowAnim, [null, e, f])
        }
        static stopFollowAnim(t, e, n) {
            let a = t;
            if (a) {
                let u = a.__move_follow_anim;
                if (u) {
                    v.getDefault3dScene().clearTimer(this, u),
                    t.off(Laya.Event.REMOVED, this, this.stopFollowAnim),
                    a.__move_follow_anim = null;
                    let g = e,
                    p = g.__move_follow_anim,
                    f = p.indexOf(t);
                    -1 != f && p.splice(f, 1),
                    n && t.destroy(),
                    0 == p.length && (e.off(Laya.Event.REMOVED, this, this.stopFollowAnim), g.__move_follow_anim = null)
                }
            } else {
                let n = e;
                if (n.__move_follow_anim) {
                    let a = n.__move_follow_anim,
                    u = a.length;
                    for (; u--; )
                        t = a[u], this.stopFollowAnim(t, e, !0);
                    n.__move_follow_anim = null
                }
            }
        }
        static rotateAnim(t, a, u, g = 0, p = "y", f = !0, m = !0, y, S, _) {
            let A = t;
            if (!A || A.__rotate_anim)
                return;
            u *= 1e3,
            g *= 1e3;
            let v = new n,
            w = new e,
            E = t.getComponent(es),
            x = new Laya.Handler(this, (function () {
                        v[p] = w.x - w.y,
                        w.y = w.x,
                        t.transform.rotate(v, m, !1),
                        S && E && E.syncToBody(!0)
                    })),
            exec = function () {
                A.__rotate_anim = Laya.Tween.to(w, {
                    x: a,
                    update: x
                }, u, _, Laya.Handler.create(this, (function () {
                                w.y = w.x = 0,
                                f ? exec() : (ss.stopRotateAnim(t), y && y.run())
                            })), g)
            };
            exec(),
            g = 0,
            t.on(Laya.Event.REMOVED, this, this.stopRotateAnim, [t])
        }
        static stopRotateAnim(t) {
            let e = t;
            if (e.__rotate_anim) {
                let n = e.__rotate_anim;
                Laya.Tween.clear(n),
                t.off(Laya.Event.REMOVED, this, this.stopRotateAnim),
                e.__rotate_anim = null
            }
        }
        static scaleAnim(t, e, a, u = 0, g) {
            let p = t;
            if (!p || p.__scale_anim)
                return;
            a *= 1e3,
            u *= 1e3;
            let f = new n,
            m = t.transform.getWorldLossyScale();
            f.from(m);
            let y = new Laya.Handler(this, (function () {
                        t.transform.setWorldLossyScale(f)
                    }));
            p.__scale_anim = Laya.Tween.to(f, {
                x: e.x,
                y: e.y,
                z: e.z,
                update: y
            }, a, null, Laya.Handler.create(this, (function () {
                            ss.stopScaleAnim(t),
                            g && g.run()
                        })), u),
            t.once(Laya.Event.REMOVED, this, this.stopScaleAnim, [t])
        }
        static stopScaleAnim(t) {
            let e = t,
            n = e.__scale_anim;
            n && (Laya.Tween.clear(n), t.off(Laya.Event.REMOVED, this, this.stopScaleAnim), e.__scale_anim = null)
        }
        static setBoundBoxPos(t, e, a = !0, u) {
            let g = this.sT;
            t.getExtent(g);
            let p = this.sN;
            if (a)
                p.from(e), u && (-1 != u.indexOf("x") && (p.x = 0), -1 != u.indexOf("y") && (p.y = 0), -1 != u.indexOf("z") && (p.z = 0)), t.setCenterAndExtent(p, g);
            else {
                let a = t;
                a.__anchor_delta || (t.getCenter(p), a.__anchor_delta = p.clone()),
                p.from(a.__anchor_delta),
                u && (-1 != u.indexOf("x") && (p.x = 0), -1 != u.indexOf("y") && (p.y = 0), -1 != u.indexOf("z") && (p.z = 0)),
                n.add(e, p, p),
                t.setCenterAndExtent(p, g)
            }
        }
        static playParticleSp(t, e = !0) {
            if (t instanceof Laya.ShuriKenParticle3D)
                t.particleSystem.looping = e, t.play();
            else {
                let n = t.numChildren;
                for (; n--; ) {
                    let a = t.getChildAt(n);
                    a.particleSystem.looping = e,
                    a.play()
                }
            }
            t.__isParticlePlaying = !0
        }
        static isParticleSpPlaying(t) {
            return t.__isParticlePlaying
        }
        static stopParticleSp(t) {
            if (t instanceof Laya.ShuriKenParticle3D)
                t.stop();
            else {
                let e = t.numChildren;
                for (; e--; ) {
                    t.getChildAt(e).stop()
                }
            }
            t.__isParticlePlaying = !1
        }
        static setParticleColor(t, e) {
            t instanceof Laya.ShuriKenParticle3D && (t.particleSystem.startColorConstant = e);
            let n = t.numChildren;
            for (; n--; ) {
                t.getChildAt(n).particleSystem.startColorConstant = e
            }
        }
        static fade3D(t, e, n) {
            let a = t.meshRenderer.sharedMaterial;
            0 != e ? (t.__fade3D_anim = Laya.Tween.to(a, {
                    albedoColorA: n
                }, 1e3 * e, null, Laya.Handler.create(this, (function () {
                                a.albedoColorA = n,
                                ss.stopFade3D(t)
                            }))), t.once(Laya.Event.REMOVED, this, this.stopFade3D, [t])) : a.albedoColorA = n
        }
        static stopFade3D(t) {
            let e = t,
            n = e.__fade3D_anim;
            n && (Laya.Tween.clear(n), e.off(Laya.Event.REMOVED, this, this.stopFade3D), e.__fade3D_anim = null)
        }
        static effColorSplash(t, e, n) {
            let a = t;
            if (a.__color_splash_anim)
                return;
            let u = v.getSpMaterial(t),
            g = u.shininess;
            a.__color_splash_anim = {
                tween: null,
                shininess: g
            },
            u.shininess = 0;
            let p = e.clone();
            const f = new Laya.Handler(this, (function () {
                        u.specularColor = p
                    }));
            t.once(Laya.Event.REMOVED, this, this.stopColorSplashAnim, [t]),
            function () {
                a.__color_splash_anim.tween = Laya.Tween.to(p, {
                    x: 0,
                    y: 0,
                    z: 0,
                    update: f
                }, n, null, Laya.Handler.create(this, () => {
                            ss.stopColorSplashAnim(t)
                        }))
            }
            ()
        }
        static stopColorSplashAnim(t) {
            let e = t;
            if (e.__color_splash_anim) {
                t.off(Laya.Event.REMOVED, this, this.stopColorSplashAnim),
                v.getSpMaterial(t).shininess = e.__color_splash_anim.shininess,
                Laya.Tween.clear(e.__color_splash_anim.tween),
                e.__color_splash_anim = null
            }
        }
        static outline(t, e, n) {
            let a = v.getSpRenderer(t);
            if (a.material instanceof is)
                return;
            let u = new is;
            u.albedoTexture = a.material.albedoTexture,
            e && (u.outlineColor = e),
            n && (u.outlineWidth = n),
            a.material = u
        }
        static screenShot() {
            let t = v.getDefaultCamera(),
            e = t._getRenderTextureFormat(),
            n = Laya.RenderContext3D.clientWidth,
            a = Laya.RenderContext3D.clientHeight,
            u = new Laya.RenderTexture(n, a, e, Laya.RenderTextureDepthFormat.DEPTH_16);
            t.renderTarget = u,
            t.render(),
            t.renderTarget = null;
            let g = new Uint8Array(n * a * 4);
            u.getData(0, 0, n, a, g),
            u.destroy();
            let p = new Laya.Texture2D(n, a, Laya.TextureFormat.R8G8B8A8, !1, !1);
            return p.setPixels(g),
            new Laya.Texture(p)
        }
        static enableMeshRender(t, e) {
            v.recurisNode(t, t => {
                t instanceof Laya.MeshSprite3D && (t.meshRenderer.enable = e)
            })
        }
        static dirOnConeEdge(t, e, a) {
            let u = this.sN,
            g = u,
            p = Math.sin(Math.rad(e)),
            f = Math.cos(Math.rad(e));
            g.x = Math.cos(Math.rad(a)),
            g.y = Math.sin(Math.rad(a)),
            u.x = g.x * p,
            u.z = g.y * p,
            u.y = f,
            n.normalize(u, u);
            let m = t.clone();
            n.normalize(m, m);
            let y = fx.Utils.getDotRadian(n.Up, m);
            n.cross(n.Up, m, m),
            n.normalize(m, m);
            let S = this.sRotMatY;
            return Laya.Matrix4x4.createRotationAxis(m, y, S),
            n.TransformNormal(u, S, m),
            m
        }
        static convertRotationFromRToL(t) {
            let e = this.sRotMatX;
            return Laya.Matrix4x4.createFromQuaternion(t, e),
            Laya.Matrix4x4.multiply(this.convertRToLMat4x4, e, e),
            Laya.Matrix4x4.multiply(e, this.convertRToLMat4x4, e),
            Laya.Quaternion.createFromMatrix4x4(e, t),
            t
        }
        static getChildrenByInstance(t, e, n) {
            let a = [];
            const anonymous = function (t) {
                for (const u of e)
                    t instanceof u && (n && -1 != t.name.indexOf(n) || a.push(t));
                let u = t.getChildren();
                for (const t of u)
                    anonymous(t)
            };
            return anonymous(t),
            a
        }
        static getChildrenByCompoent(t, e, n = !1) {
            let a = [],
            u = t.getChildren();
            for (const t of u) {
                t.getComponent(e) && a.push(t)
            }
            if (n) {
                t.getComponent(e) && a.push(t)
            }
            return a
        }
        static seekChildrenByCompoent(t, e, n = !1) {
            let a = [];
            const anonymous = function (t) {
                t.getComponent(e) && a.push(t);
                let n = t.getChildren();
                for (const t of n)
                    anonymous(t)
            };
            let u = t.getChildren();
            for (const t of u)
                anonymous(t);
            if (n) {
                t.getComponent(e) && a.push(t)
            }
            return a
        }
        static changeModelTexColor(t, e, n = "#FFFFFF", u, g) {
            let p,
            f = t;
            f.__eff_change_texture_color && e || (e ? (f.__eff_change_texture_color = !0, p = new Laya.ColorFilter, p.setColor(n), p.specColor = new a(e.x / 255, e.y / 255, e.z / 255, e.w)) : f.__eff_change_texture_color = void 0, g = g || new a(1, 1, 1, 1), v.recurisNode(t, t => {
                    let e = v.getSpMaterials(t);
                    if (e && e.length > 0)
                        for (const t of e) {
                            let e = t;
                            p ? (t.colorFilter = p, u && (e.__rawIntensity = t.albedoIntensity, t.albedoIntensity = u), e.__rawColor = t.albedoColor, t.albedoColor = g) : (t.colorFilter = void 0, e.__rawIntensity && (t.albedoIntensity = e.__rawIntensity, e.__rawIntensity = void 0), e.__rawColor && (t.albedoColor = e.__rawColor, e.__rawColor = void 0))
                        }
                }))
        }
        static changeModelColor(t, e, n) {
            let a,
            u = t;
            u.__eff_change_color && e || (e ? (u.__eff_change_color = !0, a = v.colorHexTo4F(e)) : u.__eff_change_color = void 0, v.recurisNode(t, t => {
                    let e = v.getSpMaterials(t);
                    if (e && e.length > 0)
                        for (const t of e) {
                            let e = t;
                            a ? (e.__rawColor = t.albedoColor.clone(), t.albedoColor = a, n && (e.__rawIntensity = t.albedoIntensity, t.albedoIntensity = n)) : e.__rawColor && (t.albedoColor = e.__rawColor, e.__rawColor = void 0, e.__rawIntensity && (t.albedoIntensity = e.__rawIntensity, e.__rawIntensity = void 0))
                        }
                }))
        }
        static transformBounds(t, e, n) {
            return t._tranform(e, n),
            n
        }
        static playTillingAnim(t, e, n, a = 0, u, g) {
            let p = fx.Utils.getSpMaterial(t);
            if (p && p.tilingOffset) {
                let f = t;
                if (!f || f.__tilling_anim)
                    return;
                n *= 1e3;
                let m = p.tilingOffset.clone(),
                y = e.clone(),
                S = p.tilingOffset.clone(),
                _ = new Laya.Handler(this, (function () {
                            p.tilingOffset = S
                        })),
                exec = function (e) {
                    let a = y;
                    S = m.clone(),
                    f.__tilling_anim = Laya.Tween.to(S, {
                        x: a.x,
                        y: a.y,
                        z: a.z,
                        w: a.w,
                        update: _
                    }, n, null, Laya.Handler.create(this, (function () {
                                    u ? exec(0) : (ss.stopTilingAnim(t), g && g.run())
                                })), e)
                };
                exec(a),
                t.once(Laya.Event.REMOVED, this, this.stopTilingAnim, [t])
            }
        }
        static stopTilingAnim(t) {
            let e = t,
            n = e.__tilling_anim;
            n && (Laya.Tween.clear(n), t.off(Laya.Event.REMOVED, this, this.stopTilingAnim), e.__tilling_anim = null)
        }
        static setColor(t, e) {
            this.colorMatrix[0] = e.x,
            this.colorMatrix[6] = e.y,
            this.colorMatrix[12] = e.z,
            this.colorMatrix[18] = e.w,
            t.filters = [new Laya.ColorFilter(this.colorMatrix)]
        }
    }
    ss.sRotMatX = new Laya.Matrix4x4,
    ss.sRotMatY = new Laya.Matrix4x4,
    ss.sN = new n,
    ss.sT = new n,
    ss.sRotQ = new Laya.Quaternion,
    ss.colorMatrix = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0],
    ss.convertRToLMat4x4 = new Laya.Matrix4x4(-1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1);
    class ns extends Laya.Script3D {
        constructor() {
            super(),
            this.temp = new n,
            this.delta = new n(0, .001, 0),
            this.autoDestroy = !0
        }
        onAwake() {
            let t = this.owner;
            this.player = t
        }
        init(t, e, n, a, u = !0, g) {
            let p = this.player,
            m = p;
            if (!m.height) {
                let t = v.get3dModelSize(p, null, g);
                m.long = t.x,
                m.height = t.y,
                m.width = t.z
            }
            a && (this.delta.from(a), this.delta.y = a.y * m.height),
            this.autoDestroy = u;
            let y = ss.createShadow(t, e, n);
            p.parent.addChild(y),
            y.active = !1,
            this.shadow = y,
            y.once(Laya.Event.REMOVED, this, this.clear);
            let S = y.meshRenderer.sharedMaterial;
            S.lock ? S.once(f.E_MATERIAL_LOADED, this, () => {
                this.enabled = !0,
                y.active = !0
            }) : y.timerOnce(100, this, () => {
                this.enabled = !0,
                y.active = !0
            }),
            this.enabled = !1
        }
        onEnable() {
            this.shadow && (this.shadow.active = !0)
        }
        onDisable() {
            this.shadow && (this.shadow.active = !1)
        }
        onDestroy() {
            this.shadow && !this.shadow.destroyed && (console.log("shadow cleared !!"), Qi.instance.add(this.shadow), this.shadow.active = !1, this.shadow = null)
        }
        onUpdate() {
            if (!this.shadow)
                return;
            let t = this.player,
            e = this.player,
            n = this.shadow,
            a = this.temp,
            u = this.delta;
            a.from(t.transform.position);
            let g = a.y;
            if (e.__shadowY || (e.__shadowY = a.y + u.y), a.x += u.x, a.y = e.__shadowY, a.z += u.z, n.transform.position = a, g = g - e.__shadowY + u.y, g < 0 && this.autoDestroy)
                return void this.destroy();
            let p = n.meshRenderer.material,
            f = Math.lerp(1.2, 0, g / 3);
            p.albedoColorA = f
        }
        clear() {
            this.destroy()
        }
    }
    class as extends Laya.Material {
        constructor() {
            super(),
            this.u_MainTex = Laya.Shader3D.propertyNameToID("u_MainTex"),
            this.u_NoiseTex = Laya.Shader3D.propertyNameToID("u_NoiseTex"),
            this.u_Wave = Laya.Shader3D.propertyNameToID("u_Wave"),
            as.init(),
            this.setShaderName("Water"),
            this.waveOffset = new Laya.Vector4(50, 50, 0, 0)
        }
        set mainTexture(t) {
            this._shaderValues.setTexture(this.u_MainTex, t)
        }
        get mainTexture() {
            return this._shaderValues.getTexture(this.u_MainTex)
        }
        set normalTexture(t) {
            this._shaderValues.setTexture(this.u_NoiseTex, t)
        }
        get normalTexture() {
            return this._shaderValues.getTexture(this.u_NoiseTex)
        }
        set waveOffset(t) {
            this._shaderValues.setVector(this.u_Wave, t)
        }
        set fogStart(t) {
            this._shaderValues.setNumber(as.u_WaterFogStart, t)
        }
        set fogRange(t) {
            this._shaderValues.setNumber(as.u_WaterFogRange, t)
        }
        set fogColor(t) {
            t ? this._shaderValues.addDefine(as.WATERFOG_DEF) : this._shaderValues.removeDefine(as.WATERFOG_DEF),
            this._shaderValues.setVector3(as.u_WaterFogColor, t)
        }
        static init() {
            if (Laya.Shader3D.find("Water"))
                return;
            let t = {
                a_Position: Laya.VertexMesh.MESH_POSITION0,
                a_Normal: Laya.VertexMesh.MESH_NORMAL0,
                a_Textcoord: Laya.VertexMesh.MESH_TEXTURECOORDINATE0
            },
            e = {
                u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
                u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
                u_Time: Laya.Shader3D.PERIOD_SCENE,
                u_MainTex: Laya.Shader3D.PERIOD_MATERIAL,
                u_NoiseTex: Laya.Shader3D.PERIOD_MATERIAL,
                u_Wave: Laya.Shader3D.PERIOD_MATERIAL,
                u_WaterFogStart: Laya.Shader3D.PERIOD_MATERIAL,
                u_WaterFogRange: Laya.Shader3D.PERIOD_MATERIAL,
                u_WaterFogColor: Laya.Shader3D.PERIOD_MATERIAL
            },
            n = Laya.Shader3D.add("Water"),
            a = new Laya.SubShader(t, e);
            n.addSubShader(a),
            a.addShaderPass("#include 'Lighting.glsl';\nattribute vec4 a_Position;\nattribute vec2 a_Textcoord;\nuniform mat4 u_WorldMat;\nuniform mat4 u_MvpMatrix;\nvarying vec2 v_textcoord;\nvoid main(){\n  v_textcoord=a_Textcoord;\n  gl_Position=u_MvpMatrix*a_Position;\n  gl_Position=remapGLPositionZ(gl_Position);\n}", "#if defined(GL_FRAGMENT_PRECISION_HIGH)\nprecision highp float;\n#else\nprecision mediump float;\n#endif\n\nuniform sampler2D u_MainTex;\nuniform sampler2D u_NoiseTex;\nuniform float u_Time;\nuniform vec4 u_Wave;\nvarying vec2 v_textcoord;\nuniform float u_WaterFogStart;\nuniform float u_WaterFogRange;\nuniform vec3 u_WaterFogColor;\n\nvoid main(){\n  vec2 uv=v_textcoord*vec2(u_Wave.x,u_Wave.y);\n  uv.x-=floor(uv.x);\n  uv.y-=floor(uv.y);\n  float time=u_Time/8.0;\n  float _NoiseSpeedX=1.0;\n  float _NoiseSpeedY=1.0;\n  float _NoiseScaleX=0.2;\n  float _NoiseScaleY=0.2;\n  float _NoiseBrightOffset=0.25;\n  vec2 tuv=uv+vec2(time*_NoiseSpeedX, time*_NoiseSpeedY);\n  vec2 ouvxy=vec2(texture2D(u_NoiseTex,tuv).xy);\n  ouvxy-=_NoiseBrightOffset;\n  ouvxy*=vec2(_NoiseScaleX,_NoiseScaleY);\n  vec4 col=texture2D(u_MainTex, uv+ouvxy);\n  vec3 diffuse=col.rgb;\n  gl_FragColor=vec4(diffuse,1.0);\n\n  #ifdef WATERFOG\n    float lerpFact=clamp((1.0/gl_FragCoord.w-u_WaterFogStart)/u_WaterFogRange,0.0,1.0);\n    if(lerpFact>0.1){\n      gl_FragColor.rgb=mix(gl_FragColor.rgb,u_WaterFogColor,lerpFact/2.0+0.5);\n    }else{\n      gl_FragColor.rgb=mix(gl_FragColor.rgb,u_WaterFogColor,smoothstep(0.0,0.1,lerpFact)*0.5);\n    }\n  #endif\n}"),
            this.WATERFOG_DEF = Laya.Shader3D.getDefineByName("WATERFOG"),
            this.u_WaterFogStart = Laya.Shader3D.propertyNameToID("u_WaterFogStart"),
            this.u_WaterFogRange = Laya.Shader3D.propertyNameToID("u_WaterFogRange"),
            this.u_WaterFogColor = Laya.Shader3D.propertyNameToID("u_WaterFogColor")
        }
    }
    class os {
        constructor() {
            this._size = 0,
            this._size = 0,
            this._keys = new Array,
            this._values = new Array
        }
        contains(t) {
            return 0 <= this._keys.indexOf(t)
        }
        containsKey(t) {
            return this.contains(t)
        }
        containsValue(t) {
            return 0 <= this._values.indexOf(t)
        }
        put(t, e) {
            let n = this._keys.indexOf(t);
            n >= 0 ? this._values[n] = e : (this._size++, this._keys.push(t), this._values.push(e))
        }
        remove(t) {
            let e = this._keys.indexOf(t);
            if (e < 0)
                return null;
            let n = this._values[e];
            return this._keys.splice(e, 1),
            this._values.splice(e, 1),
            this._size--,
            n
        }
        get(t) {
            let e = this._keys.indexOf(t);
            return e < 0 ? null : this._values[e]
        }
        getV(t) {
            return 0 <= t && t < this.length ? this._values[t] : null
        }
        getK(t) {
            return 0 <= t && t < this.length ? this._keys[t] : null
        }
        removeByIndex(t) {
            if (0 <= t && t < this.length) {
                var e = this._values[t];
                return this._keys.splice(t, 1),
                this._values.splice(t, 1),
                this._size--,
                e
            }
            return null
        }
        size() {
            return this._size
        }
        get length() {
            return this._size
        }
        isEmpty() {
            return 0 == this._size
        }
        putAll(t) {
            for (let e = 0; e < this._size; ++e)
                this.put(t._keys[e], t._values[e])
        }
        clear() {
            this.isEmpty() || (this._values.length = 0, this._keys.length = 0, this._size = 0)
        }
        clone() {
            if (this.isEmpty())
                return new os;
            let t = new os;
            t._size = this._size;
            for (let e = 0; e < this._size; ++e)
                t._keys[e] = this._keys[e], t._values[e] = this._values[e];
            return t
        }
        putIfAbsent(t, e) {
            return this.get(t) || (this._size++, this._keys.push(t), this._values.push(e), null)
        }
        computeIfAbsent(t, e) {
            var n = this.get(t);
            return n || (e = e(t), this._size++, this._keys.push(t), this._values.push(e), e)
        }
        forEach(t) {
            for (let e = 0; e < this._size; ++e)
                t(this._keys[e], this._values[e])
        }
        forEachSome(t) {
            for (let e = 0; e < this._size && t(this._keys[e], this._values[e]); ++e);
        }
        getKeys() {
            return this._keys
        }
        getValues() {
            return this._values
        }
        forEachValue(t) {
            for (let e = 0; e < this._size; ++e)
                t(this._values[e])
        }
        getOrDefault(t, e) {
            return this.isEmpty() ? e : 0 <= (t = this._keys.indexOf(t)) ? this._values[t] : e
        }
        getEver() {
            return this.isEmpty() ? null : this._values[0]
        }
    }
    class rs extends Laya.HTMLDivElement {
        constructor(t = "HtmlText") {
            super(),
            this._defaultStyle = "color:#000000;bold:true;font:30px Arial",
            this.name = t,
            this.style.wordWrap = !1
        }
        get defaultStyle() {
            return this._defaultStyle
        }
        set defaultStyle(t) {
            this._defaultStyle = t
        }
        parse(t) {
            let e = t.split("<br/>");
            return t = "",
            e.forEach(e => {
                let n = e.split(/(<span.+<\/span>)/g);
                0 == n.length && n.push(e);
                for (const e of n)
                    e && (this.isRichText(e) ? t += e : t += this.defaultRichText(e));
                t += "<br/>"
            }),
            t
        }
        defaultRichText(t) {
            return `<span style='${this._defaultStyle}'>${t}</span>`
        }
        isRichText(t) {
            return -1 != t.indexOf("<span")
        }
        setText(t) {
            t && (t = this.parse(t), this.innerHTML = t)
        }
        addImg(t, e) {
            let n = "";
            n = e ? `<img src='${t}' style='${e}'></img>` : `<img src='${t}' ></img>`;
            let a = "",
            u = this._innerHTML;
            u && (a = u),
            a += n,
            this.setText(a)
        }
        addText(t) {
            let e = "",
            n = this._innerHTML;
            n && (e = n),
            e += t,
            this.setText(e)
        }
    }
    class ls {
        static get inst() {
            return this._inst || (this._inst = new ls),
            this._inst
        }
        gain(t) {
            t && t.gain()
        }
    }
    class hs {
        constructor(t) {
            this.shareCount = 0,
            this.shareStartTime = void 0,
            this._shareParam = t
        }
        gain() {
            v.isOnMiniGame() ? (this.shareStartTime = v.getTime(), this.shareCount += 1, E.instance.once(f.E_APP_ON_RESUME, this, (function (e) {
                        Math.floor((v.getTime() - this.shareStartTime) / 1e3) > 3 ? E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_SUCCESS,
                            way: t.GetRewardSDKWay.SHARE,
                            rewardType: t.GetRewardSDKWay.SHARE
                        }) : this.continue("分享给新的朋友才能获得奖励！"),
                        this.shareStartTime = void 0
                    })), gi.instance.share(this._shareParam)) : E.instance.event(st.E_REWARD_GAIN, {
                code: t.SdkCode.REWARD_GAIN_SUCCESS,
                way: t.GetRewardSDKWay.SHARE,
                rewardType: t.GetRewardSDKWay.SHARE
            })
        }
        continue(e) {
            gi.instance.showModal(e, "提示", "继续分享", Laya.Handler.create(this, (function () {
                        this.gain()
                    })), "一会再来", Laya.Handler.create(this, (function () {
                        this.shareCount = 0,
                        E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_FAIL
                        })
                    })))
        }
    }
    return t.ACTION = "action",
    t.AccessToken = Ft,
    t.Adv = _e,
    t.AniParam = class {
        constructor(t, e, n, a, u, g, p) {
            this.parent = t,
            this.pos = e,
            this.lbCaller = n,
            this.lbCb = a,
            this.completeCaller = u,
            this.completeCb = g,
            this.completeParams = p
        }
    },
    t.AnimatorEventScript = Yi,
    t.AnimatorStateScript = $i,
    t.AppBase = class {
        constructor(t, e) {
            console.log("Framework Ver: 1.3.254"),
            this.gameCfg = t,
            gi.instance.initMiniAdapter(),
            this.initGraphicsSetting(gi.instance.getSystemInfo()),
            console.log("Graphics: " + JSON.stringify(mi)),
            Config.useRetinalCanvas = mi.enableRetinalCanvas,
            t.config3d = t.config3d || new Config3D,
            t.config3d.enableMultiLight = mi.enableMultiLight,
            t.config3d.isAntialias = Config.isAntialias = mi.enableAntialias,
            window.Laya3D ? (t.physic3dSetting && (Laya.Scene3D.physicsSettings = t.physic3dSetting), Laya3D.init(t.width, t.height, t.config3d)) : Laya.init(t.width, t.height, Laya.WebGL),
            Laya.Physics && Laya.Physics.enable(),
            Laya.stage.scaleMode = t.scaleMode,
            Laya.stage.alignH = t.alignH,
            Laya.stage.alignV = t.alignV,
            Laya.stage.screenMode = t.screenMode,
            Laya.stage.frameRate = Laya.Stage.FRAME_FAST,
            Laya.URL.exportSceneToJson = t.exportSceneToJson,
            (t.debug || "true" == Laya.Utils.getQueryString("debug")) && Laya.enableDebugPanel(),
            t.physicsDebug && Laya.PhysicsDebugDraw && Laya.PhysicsDebugDraw.enable(),
            t.stat && Laya.Stat.show(0, 100),
            Laya.alertGlobalError(!0),
            fi.init(),
            gi.instance.afterEngineInit(this.didEnterBackground.bind(this), this.willEnterForeground.bind(this)),
            e ? Laya.ResourceVersion.enable(e, Laya.Handler.create(this, this.onManifestLoaded)) : b.instance.load(Laya.Handler.create(this, this.onLoaded))
        }
        didEnterBackground() {
            0 != Laya.timer.scale && (Laya.timer.scale = 0, E.instance.event(f.E_APP_ON_PAUSE))
        }
        willEnterForeground(t) {
            Laya.timer.scale = 1,
            E.instance.event(f.E_APP_ON_RESUME, t)
        }
        launch(t) {
            return Laya.AtlasInfoManager.enable("fileconfig.json"),
            v.isOnMiniGame() && gi.instance.checkUpdate(),
            this.onStageResize(),
            Laya.stage.on(Laya.Event.RESIZE, this, this.onStageResize),
            t ? J.changeScene(t) : this.gameCfg.startScene ? J.changeScene(this.gameCfg.startScene) : console.error("Launch Scene not found !!!"),
            this
        }
        onStageResize() {
            v.isOnPC() && (document.title = `${Laya.stage.width}x${Laya.stage.height}`)
        }
        onManifestLoaded() {
            b.instance.load(Laya.Handler.create(this, this.onLoaded))
        }
        onLoaded() {}
        initGraphicsSetting(t) {
            if (!t)
                return;
            let e = mi;
            if (t.deviceScore) {
                let n = t.deviceScore.overall;
                v.isNumber(n) && (e.enableShadow = n > 7);
                let a = t.deviceScore.gpu;
                v.isNumber(a) && (e.enableMultiLight = a > 7)
            } else if (t.benchmarkLevel) {
                let n = t.benchmarkLevel;
                v.isNumber(n) && (e.enableShadow = n > 20, e.enableMultiLight = n > 15)
            }
        }
    },
    t.AudioContextPool = B,
    t.AuthProfileMsg = vt,
    t.AutoReleaseManager = Qi,
    t.BDAdv = Qt,
    t.BDLogin = $t,
    t.BIStat = ui,
    t.BTAction = Ai,
    t.BTBaseNode = _i,
    t.BTBlackboard = class {
        constructor() {
            this._baseMemory = {},
            this._treeMemory = {}
        }
        _getTreeMemory(t) {
            return this._treeMemory[t] || (this._treeMemory[t] = {
                    nodeMemory: {},
                    openNodes: [],
                    traversalDepth: 0,
                    traversalCycle: 0
                }),
            this._treeMemory[t]
        }
        _getNodeMemory(t, e) {
            let n = t.nodeMemory;
            return n[e] || (n[e] = {}),
            n[e]
        }
        _getMemory(t, e) {
            let n = this._baseMemory;
            return t && (n = this._getTreeMemory(t), e && (n = this._getNodeMemory(n, e))),
            n
        }
        set(t, e, n, a) {
            this._getMemory(n, a)[t] = e
        }
        get(t, e, n) {
            return this._getMemory(e, n)[t]
        }
    },
    t.BTComposite = Ii,
    t.BTCondition = class extends _i {
        constructor({
            name: t = "Condition",
            title: e = "",
            properties: n
        } = {}) {
            super({
                category: "condition",
                name: t,
                title: e,
                properties: n
            })
        }
    },
    t.BTContinuous = zi,
    t.BTDecorator = vi,
    t.BTError = Ri,
    t.BTFailer = ki,
    t.BTInverter = Li,
    t.BTLimiter = Ei,
    t.BTMaxTime = xi,
    t.BTParallel = Vi,
    t.BTPriority = Di,
    t.BTRandom = Ui,
    t.BTRepeatUntilFailure = bi,
    t.BTRepeatUntilSuccess = Ni,
    t.BTRepeater = Ci,
    t.BTRunner = Ti,
    t.BTSequence = Mi,
    t.BTSucceeder = Oi,
    t.BTTick = wi,
    t.BTWait = Bi,
    t.BaiduRewardStrategy = Yt,
    t.Base64Encrypt = Kt,
    t.BaseData = class {
        constructor(t, e) {
            this.id = t,
            this.gid = v.getGID(),
            null != e && (this.iniName = e, this.ini = b.instance.get(e, t), v.assign(this, v.cloneDeep(this.ini), !1))
        }
        clone() {
            let t = v.getModule(this);
            return this.iniName ? t = new t(this.id, this.iniName) : (t = new t, v.assign(t, this, !1)),
            t
        }
        from(t) {
            this.ini ? v.assign(this, t) : v.assign(this, t, !1)
        }
        getAtt(t, e = !1) {
            if (e && this.ini)
                return this.ini[t];
            var n = this[t];
            return null == n && null != this.ini && (n = this.ini[t]),
            n
        }
        setAtt(t, e) {
            this[t] = e
        }
    },
    t.BaseDataModel = class {
        constructor(t, e) {
            this.dataModule = e,
            this.name = t;
            let n = b.instance.get(t);
            n && (this.data = {}, this.ini = n, this._length = Object.keys(n).length)
        }
        get length() {
            return this._length
        }
        get(t) {
            return this.getWith(t, this.dataModule)
        }
        getWith(t, e) {
            let n = this.data;
            if (n)
                return n[t] ? n[t] : this.ini[t] ? (this.data[t] = new e(t, this.name), this.data[t]) : void 0
        }
        getValues(t) {
            let e = [];
            return this.recurisRaw(n => {
                e.push(n[t])
            }),
            e
        }
        recurisRaw(t) {
            for (const e in this.ini) {
                let n = t(this.ini[e]);
                if (!1 === n)
                    return n
            }
        }
    },
    t.BaseDialog = yi,
    t.BaseEvent = f,
    t.BaseEventDispatcher = x,
    t.BaseExtend = fi,
    t.BaseLogic = C,
    t.BaseMsg = St,
    t.BaseScene = R,
    t.BaseView = k,
    t.BehaviorTree = class {
        constructor() {
            this.id = v.createUUID(),
            this.title = "The behavior tree",
            this.description = "Default description",
            this.properties = {},
            this.root = null,
            this.debug = null
        }
        load(t, e) {
            e = e || {},
            this.title = t.title || this.title,
            this.description = t.description || this.description,
            this.properties = t.properties || this.properties;
            let n,
            a,
            u,
            g = {};
            for (n in t.nodes) {
                let p;
                if (a = t.nodes[n], a.name in e)
                    p = e[a.name];
                else if (a.name in Fi)
                    p = Fi[a.name];
                else if (a.name in Gi)
                    p = Gi[a.name];
                else {
                    if (!(a.name in Wi))
                        throw new EvalError('BehaviorTree.load: Invalid node name + "' + a.name + '".');
                    p = Wi[a.name]
                }
                u = new p(a.properties),
                u.id = a.id || u.id,
                u.title = a.title || u.title,
                u.description = a.description || u.description,
                u.properties = a.properties || u.properties,
                g[n] = u
            }
            for (n in t.nodes)
                if (a = t.nodes[n], u = g[n], "composite" === u.category && a.children)
                    for (let t = 0; t < a.children.length; t++) {
                        let e = a.children[t];
                        u.children.push(g[e])
                    }
                else
                    "decorator" === u.category && a.child && (u.child = g[a.child]);
            this.root = g[t.root]
        }
        dump() {
            let t = {},
            e = [];
            if (t.title = this.title, t.description = this.description, t.root = this.root ? this.root.id : null, t.properties = this.properties, t.nodes = {}, t.custom_nodes = [], !this.root)
                return t;
            let n = [this.root];
            for (; n.length > 0; ) {
                let a = n.pop(),
                u = {};
                u.id = a.id,
                u.name = a.name,
                u.title = a.title,
                u.description = a.description,
                u.properties = a.properties;
                let g = a.constructor && a.constructor.prototype,
                p = g && g.name || a.name;
                if (!Fi[p] && !Gi[p] && !Wi[p] && e.indexOf(p) < 0) {
                    let n = {};
                    n.name = p,
                    n.title = g && g.title || a.title,
                    n.category = a.category,
                    e.push(p),
                    t.custom_nodes.push(n)
                }
                if ("composite" === a.category && a.children) {
                    let t = [];
                    for (let e = a.children.length - 1; e >= 0; e--)
                        t.push(a.children[e].id), n.push(a.children[e]);
                    u.children = t
                } else
                    "decorator" === a.category && a.child && (n.push(a.child), u.child = a.child.id);
                t.nodes[a.id] = u
            }
            return t
        }
        tick(t, e) {
            if (!e)
                throw "The blackboard parameter is obligatory and must be an instance of b3.Blackboard";
            if (!this.root)
                return;
            let n = new wi;
            n.debug = this.debug,
            n.target = t,
            n.blackboard = e,
            n.tree = this;
            let a = e.get("tick_frame", n.tree.id);
            null == a ? e.set("tick_frame", 0, n.tree.id) : e.set("tick_frame", a + 1, n.tree.id);
            let u,
            g = this.root._execute(n),
            p = e.get("openNodes", this.id),
            f = n._openNodes.slice(0),
            m = 0;
            for (u = 0; u < Math.min(p.length, f.length) && (m = u + 1, p[u] === f[u]); u++);
            for (u = p.length - 1; u >= m; u--)
                p[u]._close(n);
            return e.set("openNodes", f, this.id),
            e.set("nodeCount", n._nodeCount, this.id),
            g
        }
    },
    t.Billboard = Ji,
    t.BlendShapeMaterial = Hi,
    t.BlendShapeMesh = qi,
    t.BlendShapeScript = Ki,
    t.ByteUtil = class {
        static readShort(t) {
            return t.readInt16()
        }
        static writeShort(t, e) {
            t.writeInt16(e)
        }
        static readInt(t) {
            return t.readInt32()
        }
        static writeInt(t, e) {
            t.writeInt32(e)
        }
        static readFloat(t) {
            return t.readFloat32()
        }
        static writeFloat(t, e) {
            t.writeFloat32(e)
        }
        static readDouble(t) {
            return t.readFloat64()
        }
        static writeDouble(t, e) {
            t.writeFloat64(e)
        }
        static readBoolean(t) {
            return 1 == t.readInt16()
        }
        static writeBoolean(t, e) {
            this.writeShort(t, e ? 1 : 0)
        }
        static readString(t) {
            let e = t.readInt16();
            return e <= 0 ? "" : t.readUTFBytes(e)
        }
        static writeString(t, e) {
            if (e && "" != e) {
                let n = new Laya.Byte;
                n.writeUTFBytes(e);
                let a = n.length;
                t.writeInt16(a),
                a > 0 && t.writeUTFBytes(e)
            } else
                t.writeInt16(0)
        }
        static readStringArray(t) {
            let e = t.readInt16();
            if (e <= 0)
                return null;
            let n = [];
            for (let a = 0; a < e; ++a)
                n.push(this.readString(t));
            return n
        }
        static writeStringArray(t, e) {
            if (!e || e.length <= 0)
                t.writeInt16(0);
            else {
                let n = e.length;
                t.writeInt16(n);
                for (let a = 0; a < n; ++a)
                    this.writeString(t, e[a])
            }
        }
        static readShortArray(t) {
            let e = t.readInt16();
            if (e <= 0)
                return null;
            let n = [];
            for (let a = 0; a < e; ++a)
                n.push(this.readShort(t));
            return n
        }
        static writeShortArray(t, e) {
            if (!e || e.length <= 0)
                t.writeInt16(0);
            else {
                let n = e.length;
                t.writeInt16(n);
                for (let a = 0; a < n; ++a)
                    this.writeShort(t, e[a])
            }
        }
        static readIntArray(t) {
            let e = t.readInt16();
            if (e <= 0)
                return null;
            let n = [];
            for (let a = 0; a < e; ++a)
                n.push(this.readInt(t));
            return n
        }
        static writeIntArray(t, e) {
            if (!e || e.length <= 0)
                t.writeInt16(0);
            else {
                let n = e.length;
                t.writeInt16(n);
                for (let a = 0; a < n; ++a)
                    this.writeInt(t, e[a])
            }
        }
        static readFloatArray(t) {
            let e = t.readInt16();
            if (e <= 0)
                return null;
            let n = [];
            for (let a = 0; a < e; ++a)
                n.push(this.readFloat(t));
            return n
        }
        static writeFloatArray(t, e) {
            if (!e || e.length <= 0)
                t.writeInt16(0);
            else {
                let n = e.length;
                t.writeInt16(n);
                for (let a = 0; a < n; ++a)
                    this.writeFloat(t, e[a])
            }
        }
        static readDoubleArray(t) {
            let e = t.readInt16();
            if (e <= 0)
                return null;
            let n = [];
            for (let a = 0; a < e; ++a)
                n.push(this.readDouble(t));
            return n
        }
        static writeDoubleArray(t, e) {
            if (!e || e.length <= 0)
                t.writeInt16(0);
            else {
                let n = e.length;
                t.writeInt16(n);
                for (let a = 0; a < n; ++a)
                    this.writeDouble(t, e[a])
            }
        }
    },
    t.COMPOSITE = "composite",
    t.CONDITION = "condition",
    t.CameraMoveScript = Zi,
    t.CfgMgr = b,
    t.ChuanYinAdv = Zt,
    t.ChuanYinLogin = ie,
    t.ChuanYinRewardStrategy = te,
    t.ChuanYinStat = ee,
    t.CircleProgress3dMaterial = ts,
    t.CollideInfo = _,
    t.Color = u,
    t.CustomServiceCheckMsg = Mt,
    t.CustomServiceMsg = Rt,
    t.CustomServiceQueryMsg = kt,
    t.DECORATOR = "decorator",
    t.DataStubMsg = _t,
    t.DecalShadowScript = ns,
    t.Dialog = g,
    t.Effect = z,
    t.EventCenter = E,
    t.EventDispatcher = p,
    t.FTNNAd = le,
    t.FTNNBoxAd = se,
    t.FTNNBoxLogin = oe,
    t.FTNNBoxRewardStrategy = ae,
    t.FTNNBoxShare = ne,
    t.FTNNLogin = de,
    t.FTNNRewardStrategy = he,
    t.FTNNShare = re,
    t.FTNNStat = class {
        constructor() {}
        sendEvent(t, e) {}
        stageOnStart(t) {}
        stageOnRunning(t) {}
        stageOnEnd(t) {}
        unlockItem(t) {}
    },
    t.FX_VERSION = "1.3.254",
    t.FavoriteRewardMsg = Ct,
    t.GiftStateMsg = xt,
    t.GraphicsCfg = mi,
    t.HWAdv = ue,
    t.HWLogin = pe,
    t.HWRewardStrategy = ce,
    t.HWShare = ge,
    t.Helper = ss,
    t.HtmlText = rs,
    t.Http = qt,
    t.IdentityMsg = Gt,
    t.InsertWay = class {
        gain() {
            throw new Error("Method not implemented.")
        }
    },
    t.IpQueryExMsg = Pt,
    t.IpQueryMsg = Bt,
    t.JSBridge = Ht,
    t.JSIOSBridge = Wt,
    t.KSAdv = me,
    t.KSLogin = Se,
    t.KSRewardStrategy = fe,
    t.KSShare = ye,
    t.Login = Ie,
    t.LoginMsg = At,
    t.LoginMsgNoAuth = It,
    t.MD5 = class {
        constructor() {
            this.hexcase = 0,
            this.b64pad = ""
        }
        hex_md5(t) {
            return this.rstr2hex(this.rstr_md5(this.str2rstr_utf8(t)))
        }
        b64_md5(t) {
            return this.rstr2b64(this.rstr_md5(this.str2rstr_utf8(t)))
        }
        any_md5(t, e) {
            return this.rstr2any(this.rstr_md5(this.str2rstr_utf8(t)), e)
        }
        hex_hmac_md5(t, e) {
            return this.rstr2hex(this.rstr_hmac_md5(this.str2rstr_utf8(t), this.str2rstr_utf8(e)))
        }
        b64_hmac_md5(t, e) {
            return this.rstr2b64(this.rstr_hmac_md5(this.str2rstr_utf8(t), this.str2rstr_utf8(e)))
        }
        any_hmac_md5(t, e, n) {
            return this.rstr2any(this.rstr_hmac_md5(this.str2rstr_utf8(t), this.str2rstr_utf8(e)), n)
        }
        md5_vm_test() {
            return "900150983cd24fb0d6963f7d28e17f72" == this.hex_md5("abc").toLowerCase()
        }
        rstr_md5(t) {
            return this.binl2rstr(this.binl_md5(this.rstr2binl(t), 8 * t.length))
        }
        rstr_hmac_md5(t, e) {
            var n = this.rstr2binl(t);
            n.length > 16 && (n = this.binl_md5(n, 8 * t.length));
            for (var a = Array(16), u = Array(16), g = 0; g < 16; g++)
                a[g] = 909522486 ^ n[g], u[g] = 1549556828 ^ n[g];
            var p = this.binl_md5(a.concat(this.rstr2binl(e)), 512 + 8 * e.length);
            return this.binl2rstr(this.binl_md5(u.concat(p), 640))
        }
        rstr2hex(t) {
            try {
                this.hexcase
            } catch (t) {
                this.hexcase = 0
            }
            for (var e, n = this.hexcase ? "0123456789ABCDEF" : "0123456789abcdef", a = "", u = 0; u < t.length; u++)
                e = t.charCodeAt(u), a += n.charAt(e >>> 4 & 15) + n.charAt(15 & e);
            return a
        }
        rstr2b64(t) {
            try {
                this.b64pad
            } catch (t) {
                this.b64pad = ""
            }
            for (var e = "", n = t.length, a = 0; a < n; a += 3)
                for (var u = t.charCodeAt(a) << 16 | (a + 1 < n ? t.charCodeAt(a + 1) << 8 : 0) | (a + 2 < n ? t.charCodeAt(a + 2) : 0), g = 0; g < 4; g++)
                    8 * a + 6 * g > 8 * t.length ? e += this.b64pad : e += "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(u >>> 6 * (3 - g) & 63);
            return e
        }
        rstr2any(t, e) {
            var n,
            a,
            u,
            g,
            p,
            f = e.length,
            m = Array(Math.ceil(t.length / 2));
            for (n = 0; n < m.length; n++)
                m[n] = t.charCodeAt(2 * n) << 8 | t.charCodeAt(2 * n + 1);
            var y = Math.ceil(8 * t.length / (Math.log(e.length) / Math.log(2))),
            S = Array(y);
            for (a = 0; a < y; a++) {
                for (p = Array(), g = 0, n = 0; n < m.length; n++)
                    g = (g << 16) + m[n], g -= (u = Math.floor(g / f)) * f, (p.length > 0 || u > 0) && (p[p.length] = u);
                S[a] = g,
                m = p
            }
            var _ = "";
            for (n = S.length - 1; n >= 0; n--)
                _ += e.charAt(S[n]);
            return _
        }
        str2rstr_utf8(t) {
            for (var e, n, a = "", u = -1; ++u < t.length; )
                e = t.charCodeAt(u), n = u + 1 < t.length ? t.charCodeAt(u + 1) : 0, 55296 <= e && e <= 56319 && 56320 <= n && n <= 57343 && (e = 65536 + ((1023 & e) << 10) + (1023 & n), u++), e <= 127 ? a += String.fromCharCode(e) : e <= 2047 ? a += String.fromCharCode(192 | e >>> 6 & 31, 128 | 63 & e) : e <= 65535 ? a += String.fromCharCode(224 | e >>> 12 & 15, 128 | e >>> 6 & 63, 128 | 63 & e) : e <= 2097151 && (a += String.fromCharCode(240 | e >>> 18 & 7, 128 | e >>> 12 & 63, 128 | e >>> 6 & 63, 128 | 63 & e));
            return a
        }
        str2rstr_utf16le(t) {
            for (var e = "", n = 0; n < t.length; n++)
                e += String.fromCharCode(255 & t.charCodeAt(n), t.charCodeAt(n) >>> 8 & 255);
            return e
        }
        str2rstr_utf16be(t) {
            for (var e = "", n = 0; n < t.length; n++)
                e += String.fromCharCode(t.charCodeAt(n) >>> 8 & 255, 255 & t.charCodeAt(n));
            return e
        }
        rstr2binl(t) {
            for (var e = Array(t.length >> 2), n = 0; n < e.length; n++)
                e[n] = 0;
            for (n = 0; n < 8 * t.length; n += 8)
                e[n >> 5] |= (255 & t.charCodeAt(n / 8)) << n % 32;
            return e
        }
        binl2rstr(t) {
            for (var e = "", n = 0; n < 32 * t.length; n += 8)
                e += String.fromCharCode(t[n >> 5] >>> n % 32 & 255);
            return e
        }
        binl_md5(t, e) {
            t[e >> 5] |= 128 << e % 32,
            t[14 + (e + 64 >>> 9 << 4)] = e;
            for (var n = 1732584193, a = -271733879, u = -1732584194, g = 271733878, p = 0; p < t.length; p += 16) {
                var f = n,
                m = a,
                y = u,
                S = g;
                n = this.md5_ff(n, a, u, g, t[p + 0], 7, -680876936),
                g = this.md5_ff(g, n, a, u, t[p + 1], 12, -389564586),
                u = this.md5_ff(u, g, n, a, t[p + 2], 17, 606105819),
                a = this.md5_ff(a, u, g, n, t[p + 3], 22, -1044525330),
                n = this.md5_ff(n, a, u, g, t[p + 4], 7, -176418897),
                g = this.md5_ff(g, n, a, u, t[p + 5], 12, 1200080426),
                u = this.md5_ff(u, g, n, a, t[p + 6], 17, -1473231341),
                a = this.md5_ff(a, u, g, n, t[p + 7], 22, -45705983),
                n = this.md5_ff(n, a, u, g, t[p + 8], 7, 1770035416),
                g = this.md5_ff(g, n, a, u, t[p + 9], 12, -1958414417),
                u = this.md5_ff(u, g, n, a, t[p + 10], 17, -42063),
                a = this.md5_ff(a, u, g, n, t[p + 11], 22, -1990404162),
                n = this.md5_ff(n, a, u, g, t[p + 12], 7, 1804603682),
                g = this.md5_ff(g, n, a, u, t[p + 13], 12, -40341101),
                u = this.md5_ff(u, g, n, a, t[p + 14], 17, -1502002290),
                a = this.md5_ff(a, u, g, n, t[p + 15], 22, 1236535329),
                n = this.md5_gg(n, a, u, g, t[p + 1], 5, -165796510),
                g = this.md5_gg(g, n, a, u, t[p + 6], 9, -1069501632),
                u = this.md5_gg(u, g, n, a, t[p + 11], 14, 643717713),
                a = this.md5_gg(a, u, g, n, t[p + 0], 20, -373897302),
                n = this.md5_gg(n, a, u, g, t[p + 5], 5, -701558691),
                g = this.md5_gg(g, n, a, u, t[p + 10], 9, 38016083),
                u = this.md5_gg(u, g, n, a, t[p + 15], 14, -660478335),
                a = this.md5_gg(a, u, g, n, t[p + 4], 20, -405537848),
                n = this.md5_gg(n, a, u, g, t[p + 9], 5, 568446438),
                g = this.md5_gg(g, n, a, u, t[p + 14], 9, -1019803690),
                u = this.md5_gg(u, g, n, a, t[p + 3], 14, -187363961),
                a = this.md5_gg(a, u, g, n, t[p + 8], 20, 1163531501),
                n = this.md5_gg(n, a, u, g, t[p + 13], 5, -1444681467),
                g = this.md5_gg(g, n, a, u, t[p + 2], 9, -51403784),
                u = this.md5_gg(u, g, n, a, t[p + 7], 14, 1735328473),
                a = this.md5_gg(a, u, g, n, t[p + 12], 20, -1926607734),
                n = this.md5_hh(n, a, u, g, t[p + 5], 4, -378558),
                g = this.md5_hh(g, n, a, u, t[p + 8], 11, -2022574463),
                u = this.md5_hh(u, g, n, a, t[p + 11], 16, 1839030562),
                a = this.md5_hh(a, u, g, n, t[p + 14], 23, -35309556),
                n = this.md5_hh(n, a, u, g, t[p + 1], 4, -1530992060),
                g = this.md5_hh(g, n, a, u, t[p + 4], 11, 1272893353),
                u = this.md5_hh(u, g, n, a, t[p + 7], 16, -155497632),
                a = this.md5_hh(a, u, g, n, t[p + 10], 23, -1094730640),
                n = this.md5_hh(n, a, u, g, t[p + 13], 4, 681279174),
                g = this.md5_hh(g, n, a, u, t[p + 0], 11, -358537222),
                u = this.md5_hh(u, g, n, a, t[p + 3], 16, -722521979),
                a = this.md5_hh(a, u, g, n, t[p + 6], 23, 76029189),
                n = this.md5_hh(n, a, u, g, t[p + 9], 4, -640364487),
                g = this.md5_hh(g, n, a, u, t[p + 12], 11, -421815835),
                u = this.md5_hh(u, g, n, a, t[p + 15], 16, 530742520),
                a = this.md5_hh(a, u, g, n, t[p + 2], 23, -995338651),
                n = this.md5_ii(n, a, u, g, t[p + 0], 6, -198630844),
                g = this.md5_ii(g, n, a, u, t[p + 7], 10, 1126891415),
                u = this.md5_ii(u, g, n, a, t[p + 14], 15, -1416354905),
                a = this.md5_ii(a, u, g, n, t[p + 5], 21, -57434055),
                n = this.md5_ii(n, a, u, g, t[p + 12], 6, 1700485571),
                g = this.md5_ii(g, n, a, u, t[p + 3], 10, -1894986606),
                u = this.md5_ii(u, g, n, a, t[p + 10], 15, -1051523),
                a = this.md5_ii(a, u, g, n, t[p + 1], 21, -2054922799),
                n = this.md5_ii(n, a, u, g, t[p + 8], 6, 1873313359),
                g = this.md5_ii(g, n, a, u, t[p + 15], 10, -30611744),
                u = this.md5_ii(u, g, n, a, t[p + 6], 15, -1560198380),
                a = this.md5_ii(a, u, g, n, t[p + 13], 21, 1309151649),
                n = this.md5_ii(n, a, u, g, t[p + 4], 6, -145523070),
                g = this.md5_ii(g, n, a, u, t[p + 11], 10, -1120210379),
                u = this.md5_ii(u, g, n, a, t[p + 2], 15, 718787259),
                a = this.md5_ii(a, u, g, n, t[p + 9], 21, -343485551),
                n = this.safe_add(n, f),
                a = this.safe_add(a, m),
                u = this.safe_add(u, y),
                g = this.safe_add(g, S)
            }
            return [n, a, u, g]
        }
        md5_cmn(t, e, n, a, u, g) {
            return this.safe_add(this.bit_rol(this.safe_add(this.safe_add(e, t), this.safe_add(a, g)), u), n)
        }
        md5_ff(t, e, n, a, u, g, p) {
            return this.md5_cmn(e & n | ~e & a, t, e, u, g, p)
        }
        md5_gg(t, e, n, a, u, g, p) {
            return this.md5_cmn(e & a | n & ~a, t, e, u, g, p)
        }
        md5_hh(t, e, n, a, u, g, p) {
            return this.md5_cmn(e ^ n ^ a, t, e, u, g, p)
        }
        md5_ii(t, e, n, a, u, g, p) {
            return this.md5_cmn(n ^ (e | ~a), t, e, u, g, p)
        }
        safe_add(t, e) {
            var n = (65535 & t) + (65535 & e);
            return (t >> 16) + (e >> 16) + (n >> 16) << 16 | 65535 & n
        }
        bit_rol(t, e) {
            return t << e | t >>> 32 - e
        }
    },
    t.MailInfoMsg = Nt,
    t.MailOpenMsg = Dt,
    t.MailSendMsg = bt,
    t.MapEx = os,
    t.MenuInfo = class {},
    t.MeshLine = Xi,
    t.ModalDialogBox = class extends g {
        constructor(t, e, n) {
            if (super(), this.handler_close = Laya.Handler.create(this, (function () {
                            this.removeSelf()
                        })), n.tex_bgMask && (this.img_bgmask = new Laya.Image, this.img_bgmask.name = "img_bg", this.addChild(this.img_bgmask), this.img_bgmask.left = 0, this.img_bgmask.right = 0, this.img_bgmask.top = 0, this.img_bgmask.bottom = 0, this.img_bgmask.skin = n.tex_bgMask, n.texSizegrid_bgMask && (this.img_bgmask.sizeGrid = n.texSizegrid_bgMask)), this.img_bg = new Laya.Image, this.addChild(this.img_bg), n.tex_bg ? this.img_bg.skin = n.tex_bg : (console.log("模态弹出框背景纹理为空!!!"), this.img_bg.width = 500, this.img_bg.height = 400), n.texSizegrid_bg && (this.img_bg.sizeGrid = n.texSizegrid_bg), this.img_bg.centerX = 0, this.img_bg.centerY = 0, !n.texSize_bg && (n.texSize_bg = {
                        width: 600,
                        height: 400
                    }), !n.texSize_bg.width && (n.texSize_bg.width = 600), !n.texSize_bg.height && (n.texSize_bg.height = 400), this.img_bg.size(n.texSize_bg.width, n.texSize_bg.height), this.label_title = new Laya.Label, this.img_bg.addChild(this.label_title), this.label_title.fontSize = 40, this.label_title.bold = !0, this.label_title.color = "#ffffff", this.label_title.centerX = 0, this.label_title.top = 25, this.label_content = new Laya.Label, this.img_bg.addChild(this.label_content), this.label_content.fontSize = 36, this.label_content.bold = !0, this.label_content.color = "#ffffff", this.label_content.centerX = 0, this.label_content.centerY = 0, n.contentLeading && (this.label_content.leading = n.contentLeading), n.tex_closeBtn ? (this.btn_close = new Laya.Button, this.img_bg.addChild(this.btn_close), this.btn_close.skin = n.tex_closeBtn, this.btn_close.stateNum = 1, this.btn_close.anchorX = 1, this.btn_close.anchorY = 1, this.btn_close.top = 0, this.btn_close.right = 0, n.handler_closeBtn ? this.handler_closeBtn = n.handler_cancelBtn : this.handler_closeBtn = this.handler_close, this.btn_close.on(Laya.Event.CLICK, this, (function () {
                            this.handler_closeBtn.run()
                        }))) : console.log("模态弹出框关闭按钮纹理为空!!!"), n.tex_sureBtn) {
                if (this.btn_sure = new Laya.Button, this.img_bg.addChild(this.btn_sure), this.btn_sure.stateNum = 1, this.btn_sure.skin = n.tex_sureBtn, n.texSizegrid_sureBtn && (this.btn_sure.sizeGrid = n.texSizegrid_sureBtn), this.btn_sure.size(200, 120), this.handler_sureBtn = n.handler_sureBtn, this.btn_sure.on(Laya.Event.CLICK, this, (function () {
                            this.handler_sureBtn && this.handler_sureBtn.run(),
                            this.handler_close.run()
                        })), n.font_sureBtn) {
                    let t = Laya.loader.getRes(n.font_sureBtn);
                    t ? (this.font_btn_sure = new Laya.Image, this.btn_sure.addChild(this.font_btn_sure), this.font_btn_sure.source = t) : (this.font_btn_sure = new Laya.Label, this.btn_sure.addChild(this.font_btn_sure), this.font_btn_sure.text = n.font_sureBtn, this.font_btn_sure.color = "#ffffff", this.font_btn_sure.fontSize = 34, this.font_btn_sure.bold = !0),
                    !n.font_suereBtn_centeroffset && (n.font_suereBtn_centeroffset = new Laya.Point(0, 0)),
                    this.font_btn_sure.centerX = n.font_suereBtn_centeroffset.x,
                    this.font_btn_sure.centerY = n.font_suereBtn_centeroffset.y
                }
            } else
                console.log("模态对话框确认按钮纹理缺失!!!");
            if (n.tex_cancelBtn) {
                if (this.btn_cancel = new Laya.Button, this.img_bg.addChild(this.btn_cancel), this.btn_cancel.stateNum = 1, this.btn_cancel.skin = n.tex_cancelBtn, n.texSizegrid_cancelBtn && (this.btn_cancel.sizeGrid = n.texSizegrid_cancelBtn), this.btn_cancel.size(200, 120), this.handler_cancelBtn = n.handler_cancelBtn, this.btn_cancel.on(Laya.Event.CLICK, this, (function () {
                            this.handler_cancelBtn && this.handler_cancelBtn.run(),
                            this.handler_close.run()
                        })), n.font_cancelBtn) {
                    let t = Laya.loader.getRes(n.font_cancelBtn);
                    t ? (this.font_btn_cancel = new Laya.Image, this.btn_cancel.addChild(this.font_btn_cancel), this.font_btn_cancel.source = t) : (this.font_btn_cancel = new Laya.Label, this.btn_cancel.addChild(this.font_btn_cancel), this.font_btn_cancel.text = n.font_cancelBtn, this.font_btn_cancel.color = "#ffffff", this.font_btn_cancel.fontSize = 34, this.font_btn_cancel.bold = !0),
                    !n.font_cancelBtn_centeroffset && (n.font_cancelBtn_centeroffset = new Laya.Point(0, 0)),
                    this.font_btn_cancel.centerX = n.font_cancelBtn_centeroffset.x,
                    this.font_btn_cancel.centerY = n.font_cancelBtn_centeroffset.y
                }
            } else
                console.log("模态对话框取消按钮纹理缺失!!!");
            this.btn_sure && this.btn_cancel ? (this.btn_sure.centerX = (this.img_bg.width / 2 - this.btn_sure.width) / 2 + this.btn_sure.width / 2, this.btn_sure.bottom = -this.btn_sure.height / 3, this.btn_cancel.centerX =  - (this.img_bg.width / 2 - this.btn_cancel.width) / 2 - this.btn_cancel.width / 2, this.btn_cancel.bottom = -this.btn_cancel.height / 3) : this.btn_sure && !this.btn_cancel ? (this.btn_sure.centerX = 0, this.btn_sure.bottom = 0) : !this.btn_sure && this.btn_cancel && (this.btn_cancel.centerX = 0, this.btn_cancel.bottom = 0)
        }
        get label_title() {
            return this._label_title
        }
        set label_title(t) {
            this._label_title = t
        }
        get label_content() {
            return this._label_content
        }
        set label_content(t) {
            this._label_content = t
        }
        get img_bgmask() {
            return this._img_bgmask
        }
        set img_bgmask(t) {
            this._img_bgmask = t
        }
        get img_bg() {
            return this._img_bg
        }
        set img_bg(t) {
            this._img_bg = t
        }
        get btn_close() {
            return this._btn_close
        }
        set btn_close(t) {
            this._btn_close = t
        }
        get btn_sure() {
            return this._btn_sure
        }
        set btn_sure(t) {
            this._btn_sure = t
        }
        get font_btn_sure() {
            return this._font_btn_sure
        }
        set font_btn_sure(t) {
            this._font_btn_sure = t
        }
        get btn_cancel() {
            return this._btn_cancel
        }
        set btn_cancel(t) {
            this._btn_cancel = t
        }
        get font_btn_cancel() {
            return this._font_btn_cancel
        }
        set font_btn_cancel(t) {
            this._font_btn_cancel = t
        }
    },
    t.NativeAndroid233Login = Ee,
    t.NativeAndroidAd = ve,
    t.NativeAndroidLogin = xe,
    t.NativeAndroidRewardStrategy = Le,
    t.NativeAndroidStat = we,
    t.NativeIosAd = Ce,
    t.NativeIosLogin = De,
    t.NativeIosRewardStrategy = Ne,
    t.NativeIosStat = be,
    t.OppoAdv = Me,
    t.OppoLogin = ke,
    t.OppoRewardStrategy = Re,
    t.OutlineMaterial = is,
    t.Physics = S,
    t.PhysicsScript = es,
    t.Plane2d = y,
    t.Plane3d = class {
        constructor(t, e, n, a) {
            this.lb = t,
            this.rb = e,
            this.lt = n,
            this.rt = a
        }
        containPoint(t) {
            let e,
            n,
            a = [this.lb.x, this.rb.x, this.rt.x, this.lt.x],
            u = [this.lb.z, this.rb.z, this.rt.z, this.lt.z],
            g = !1;
            for (e = 0, n = 3; e < 4; n = e++)
                u[e] > t.z != u[n] > t.z && t.x < (a[n] - a[e]) * (t.z - u[e]) / (u[n] - u[e]) + a[e] && (g = !g);
            return g
        }
    },
    t.PlatformType = et,
    t.QQAdv = Oe,
    t.QQLogin = Ve,
    t.QQRewardStrategy = Pe,
    t.QQShare = Te,
    t.QQStat = Be,
    t.QTTAdv = Ue,
    t.QTTLogin = Fe,
    t.QTTRewardStrategy = ze,
    t.RES3D_GROUP_NAME = "3DRES_GROUP",
    t.RankInfoMsg = Ot,
    t.RankScoreMsg = Tt,
    t.RewardGainWay = ls,
    t.RewardGainWayParams = mt,
    t.RewardStrategy = Ae,
    t.SDK_VERSION = "1.0.0",
    t.SaveDataMsg = zt,
    t.SceneManager = J,
    t.Sdk = gi,
    t.SdkEvent = st,
    t.SdkGameCfg = class {},
    t.SdkMsg = Xt,
    t.SdkMsgEvent = Jt,
    t.SdkMsgUrlDefine = yt,
    t.Sequence = w,
    t.Sequence3D = class {
        constructor(t, e) {
            this._actions = e || [],
            this._isRepeat = t,
            this._addParallelCount = this._runningParallelCnt = this._actionIdx = 0,
            this._temp = new n,
            this._rotQ = new Laya.Quaternion
        }
        get actions() {
            return this._actions
        }
        get isRepeat() {
            return this._isRepeat
        }
        set isRepeat(t) {
            this._isRepeat = t
        }
        get actionIdx() {
            return this._actionIdx
        }
        set actionIdx(t) {
            this._actionIdx = t
        }
        run(t) {
            t = t || this._target;
            let e = this._actions;
            if (!e || 0 === e.length || !t || t.destroyed)
                return;
            t != this._target && (this._target = t, t.once(Laya.Event.REMOVED, this, this.stop));
            let n = this._actionIdx;
            if (n >= e.length) {
                if (!this._isRepeat)
                    return void this.stop();
                n = this._actionIdx = 0
            }
            let a = e[n];
            for (this._run(a); n++, a = e[n], a && a.isParallel; ) {
                this._actionIdx = n,
                this._run(a) && this._runningParallelCnt++
            }
        }
        _run(t) {
            if (!t.props || !v.isNumber(t.duration))
                return !1;
            switch (t.t) {
            case "delay":
                Laya.timer.once(t.duration, this, this.runNext);
                break;
            case "exec":
                if (t.props.exec) {
                    let e = t.target || this._target;
                    t.props.exec.runWith(e)
                }
                this.runNext();
                break;
            case "from": {
                    let e = t.props,
                    n = t.target || this._target;
                    "function" == typeof e && (e = e(n)),
                    t.tween = Laya.Tween.from(n, e, t.duration, t.ease, Laya.Handler.create(this, () => {
                                t.tween = null,
                                this.runNext()
                            }), t.delay);
                    break
                }
            case "to": {
                    let e = t.props,
                    n = t.target || this._target;
                    "function" == typeof e && (e = e(n)),
                    t.tween = Laya.Tween.to(n, e, t.duration, t.ease, Laya.Handler.create(this, () => {
                                t.tween = null,
                                this.runNext()
                            }), t.delay);
                    break
                }
            default:
                throw Error(`Sequence3D unknown action type ${t.t} !!!`)
            }
            return !0
        }
        runNext() {
            this._runningParallelCnt > 0 ? this._runningParallelCnt-- : (console.assert(0 == this._runningParallelCnt, "Sequence3D unexpected parallel count " + this._runningParallelCnt), this._actionIdx++, this.run())
        }
        stop() {
            for (const t of this._actions)
                t.tween && (t.tween.clear(), t.tween = null);
            this._target && this._target.offAllCaller(this),
            this._target = null,
            this._actionIdx = 0
        }
        pushAction(t) {
            this._addParallelCount > 0 ? (this._addParallelCount--, t.isParallel = !0, this._actions.push(t)) : this._actions.push(t)
        }
        parallel(t) {
            return this._addParallelCount = t,
            this
        }
        delay(t) {
            let e = {
                t: "delay",
                target: null,
                props: {},
                duration: t
            };
            return this.pushAction(e),
            this
        }
        hide() {
            let t = {
                t: "exec",
                target: null,
                props: {
                    exec: null
                },
                duration: 0
            };
            return t.props.exec = Laya.Handler.create(this, () => {
                this._target.active = !1
            }),
            this.pushAction(t),
            this
        }
        show() {
            let t = {
                t: "exec",
                target: null,
                props: {
                    exec: null
                },
                duration: 0
            };
            return t.props.exec = Laya.Handler.create(this, () => {
                this._target.active = !0
            }),
            this.pushAction(t),
            this
        }
        removeNode(t) {
            let e = {
                t: "exec",
                target: null,
                props: {
                    exec: null
                },
                duration: 0
            };
            return e.props.exec = Laya.Handler.create(this, () => {
                t ? this._target.destroy() : this._target.removeSelf()
            }),
            this.pushAction(e),
            this
        }
        scaleIn(t, e, a, u, g) {
            let p = {
                t: "from",
                target: new n,
                props: n => (g ? n.from(this._target.transform.localScale) : n.from(this._target.transform.getWorldLossyScale()), {
                    x: t,
                    y: e,
                    z: a,
                    update: Laya.Handler.create(this, () => {
                        g ? this._target.transform.localScale = n : this._target.transform.setWorldLossyScale(n)
                    }, null, !1)
                }),
                duration: u
            };
            return this.pushAction(p),
            this
        }
        scaleOut(t, e, a, u, g) {
            let p = {
                t: "to",
                target: new n,
                props: n => (g ? n.from(this._target.transform.localScale) : n.from(this._target.transform.getWorldLossyScale()), {
                    x: t,
                    y: e,
                    z: a,
                    update: Laya.Handler.create(this, () => {
                        g ? this._target.transform.localScale = n : this._target.transform.setWorldLossyScale(n)
                    }, null, !1)
                }),
                duration: u
            };
            return this.pushAction(p),
            this
        }
        pos(t, e, a, u, g, p) {
            let f = {
                t: "to",
                target: new n(t, e, a),
                props: n => (g ? n.from(this._target.transform.localPosition) : n.from(this._target.transform.position), {
                    x: t,
                    y: e,
                    z: a,
                    update: Laya.Handler.create(this, () => {
                        g ? this._target.transform.localPosition = n : this._target.transform.position = n
                    }, null, !1)
                }),
                duration: u,
                ease: p
            };
            return 0 == u && (f.t = "exec", f.ease = null, f.props = {}, f.props.exec = Laya.Handler.create(this, t => {
                    g ? this._target.transform.localPosition = t : this._target.transform.position = t
                })),
            this.pushAction(f),
            this
        }
        rotate(t, e, n, a, u) {
            let g = {
                t: "to",
                target: {
                    angle: 0
                },
                props: {
                    angle: t,
                    update: Laya.Handler.create(this, () => {
                        let e = this._rotQ;
                        Laya.Quaternion.createFromAxisAngle(n, Math.rad(t), e);
                        let u = this._target;
                        a ? (Laya.Quaternion.multiply(e, u.transform.localRotation, e), u.transform.localRotation = e) : (Laya.Quaternion.multiply(e, u.transform.rotation, e), u.transform.rotation = e)
                    }, null, !1)
                },
                duration: e,
                ease: u
            };
            return this.pushAction(g),
            this
        }
        exec(t) {
            let e = {
                t: "exec",
                target: null,
                props: {
                    exec: t
                },
                duration: 0
            };
            return this.pushAction(e),
            this
        }
    },
    t.ShareClearMsg = Et,
    t.ShareInfo = wt,
    t.ShareQuery = Lt,
    t.ShareWay = hs,
    t.SoundManager = V,
    t.StatEventMsg = Ut,
    t.StatStageMsg = Vt,
    t.SystemInfo = it,
    t.TTAdv = Ye,
    t.TTFFAd = Ke,
    t.TTFFLogin = je,
    t.TTFFRewardStrategy = Je,
    t.TTFFStat = Xe,
    t.TTLogin = ti,
    t.TTRewardStrategy = Ze,
    t.TTShare = Qe,
    t.TTStat = $e,
    t.TapTapAd = Ge,
    t.TapTapLogin = qe,
    t.TapTapStat = He,
    t.UniformBezier = class {
        constructor(t, e) {
            if (t.length < 2)
                throw Error("UniformBezier control point count must >= 2 !!!");
            this.temp = new n,
            ji.sAutoHandleDistance = e.autoHandleDistance;
            let a,
            u = new Array;
            for (const e of t) {
                let t = new ji(e.pos, e.rot, a, void 0);
                a && (a.nextSegment = t),
                a = t,
                u.push(t)
            }
            for (const t of u)
                t.init(e.density, e.maxPointsPerUnit);
            let g = 0;
            for (const t of u)
                t.start = g, g += t.calcLength();
            this.segments = u,
            this.length = g
        }
        getLength() {
            return this.length
        }
        getPoint(t) {
            t = Math.clamp(t, 0, 1),
            t *= this.length;
            let e = this.segments[Math.max(0, this.upperBound(t) - 1)];
            return t = (t - e.start) / e.getLength(),
            e.getPoint(t)
        }
        upperBound(t) {
            let e;
            for (e = 0; e < this.segments.length && !(this.segments[e].start > t); ++e);
            return e
        }
        getForward(t) {
            t = Math.min(t, .99);
            let e = this.getPoint(t),
            a = this.getPoint(t + .01);
            return n.subtract(a, e, e),
            e.normalize(),
            e
        }
        getUp(t) {
            t = Math.clamp(t, 0, 1),
            t *= this.length;
            let e = this.segments[Math.max(0, this.upperBound(t) - 1)];
            return t = (t - e.start) / e.getLength(),
            e.getUp(t)
        }
        getNearestPointF(t) {
            let e,
            a,
            u,
            g = 1 / 0,
            p = this.temp;
            for (const f of this.segments) {
                let m = f.getNearestPointF(t),
                y = f.getPoint(m);
                n.subtract(y, t, p);
                let S = n.scalarLengthSquared(p);
                S <= g && (g = S, a = f, e = m, u = y)
            }
            return e = (a.start + e * a.getLength()) / this.length,
            [u, e]
        }
    },
    t.UserInfoEntity = $,
    t.UserLogic = Z,
    t.Utils = v,
    t.Vector2 = e,
    t.Vector3 = n,
    t.Vector4 = a,
    t.VideoWay = class {
        constructor(t) {
            this._videoParam = t
        }
        gain() {
            if (v.isOnPC())
                return void E.instance.event(st.E_REWARD_GAIN, {
                    code: t.SdkCode.REWARD_GAIN_SUCCESS,
                    way: t.GetRewardSDKWay.VIDEO,
                    rewardType: t.GetRewardSDKWay.VIDEO
                });
            let e = gi.instance.isHasVideo(this._videoParam.id);
            t.VideoState.UNENABLED === e ? gi.instance.showModal("今天已经没有视频啦,分享同样可以获得奖励哟!", "提示", "分享获得", Laya.Handler.create(this, (function () {
                        ls.inst.gain(new hs(this._videoParam))
                    })), "明天再来", Laya.Handler.create(this, (function () {
                        E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_FAIL
                        })
                    }))) : (E.instance.once(st.E_AD_VIDEO, this, (function (e) {
                        t.SdkCode.AD_VIDEO_SUCCESS === e.code ? E.instance.event(st.E_REWARD_GAIN, {
                            code: t.SdkCode.REWARD_GAIN_SUCCESS,
                            way: t.GetRewardSDKWay.VIDEO,
                            rewardType: t.GetRewardSDKWay.VIDEO
                        }) : t.SdkCode.AD_VIDEO_UNCOMPLETE === e.code && gi.instance.showModal("看完视频才会有奖励哟！！！", "提示", "继续观看", Laya.Handler.create(this, (function () {
                                    this.gain()
                                })), "一会再来", Laya.Handler.create(this, (function () {
                                    E.instance.event(st.E_REWARD_GAIN, {
                                        code: t.SdkCode.REWARD_GAIN_FAIL
                                    })
                                })))
                    })), gi.instance.playVideo(this._videoParam.id, this._videoParam.title))
        }
    },
    t.VivoAd = ii,
    t.VivoLogin = ni,
    t.VivoRewardStrategy = ei,
    t.VivoShare = si,
    t.VivoSystemInfo = class extends it {},
    t.WXAdv = ai,
    t.WXLogin = li,
    t.WXRewardStrategy = ri,
    t.WXShare = jt,
    t.WXStat = oi,
    t.WaterMaterial = as,
    t.WebSocket = class {
        constructor() {
            this.byte = new Laya.Byte,
            this.byte.endian = Laya.Byte.LITTLE_ENDIAN,
            this.ws = new Laya.Socket,
            this.ws.endian = Laya.Byte.LITTLE_ENDIAN,
            this.ws.on(Laya.Event.MESSAGE, this, this._onMessage),
            this.ws.on(Laya.Event.OPEN, this, this._onOpen),
            this.ws.on(Laya.Event.CLOSE, this, this._onClose),
            this.ws.on(Laya.Event.ERROR, this, this._onError)
        }
        isConnected() {
            return this.ws.connected
        }
        _onMessage(t) {
            this.onMessage && this.onMessage(t)
        }
        _onOpen(t) {
            console.log("WebSocket onOpen"),
            this.onOpen && this.onOpen(t)
        }
        _onClose(t) {
            console.log("WebSocket onClose"),
            this.token = void 0,
            this.onClose && this.onClose(t)
        }
        _onError(t) {
            console.log("WebSocket onError"),
            this.onError && this.onError(t)
        }
        connect(t, e) {
            return console.log(`WebSocket connect ${t} port:${e}`),
            e ? this.ws.connect(t, e) : this.ws.connectByUrl(t),
            this
        }
        close() {
            this.ws.close(),
            this.token = void 0
        }
        destroy() {
            this.ws.offAll();
            try {
                this.ws.cleanSocket()
            } catch (t) {}
            this.ws = null,
            this.token = void 0
        }
        send(t) {
            return this.ws.send(t),
            this
        }
    },
    t.XiaoMiAdv = di,
    t.XiaoMiLogin = ci,
    t.XiaoMiRewardStrategy = hi,
    t
}
({});
